
function formUpdate (id, type, value) {

    if (_updating == '1') { return }
    _updating = '1';

    if (type == 'widget date') {
        dateWidgetCheckInvalid(id);
    }
    
    if (type == 'widget time') {
        timeWidgetCheckInvalid(id);
    }

    this._timeout = setTimeout(function(){  formDoUpdate(id, value) }, 300);       
}


function formDoUpdate (id, value) {

    require(['dojo/dom','dojo/dom-class','dojo/on','dojo/_base/xhr'], function(dom, domClass, on, xhr) {

        if (typeof _is_demo != 'undefined' && _is_demo == '1' && dom.byId('wizardSubmitStep1')) {
            
            var iWs = new Array();
	        iterFunction = function(widget) {
                try { var invalid = widget.isValid(); if (invalid == false) { iWs.push(widget); } }
                catch(err) { }
            }
	        
	        dojo.forEach(dijit.byId('Form').getChildren(), iterFunction);

            if (iWs.length == '0') {

		        domClass.remove('step1Substep1', 'selected');
	    	    domClass.add('step1Substep1', 'completed');

                on(dom.byId('wizardSubmitStep1'), 'click', function() {
	                wizardSubmitStep1();
		        });

            } else {
                if (domClass.contains('step1Substep1', 'completed')) {
            	    domClass.remove('step1Substep1', 'completed');
	                domClass.add('step1Substep1', 'selected');
                }
            }
        }

        clearTimeout(this._timeout); 
        var f = dom.byId('Form');
        if (f.elements.length) {
            if (this._deferred) { this._deferred.cancel(); }
            xhr.post({
		        url: _base_path + '/' + _page + '/form_data/update/?',
		        handleAs: 'json',
		        form: dom.byId('Form'),
		        load: function(jsonData) { 
		            fieldUpdate(id, jsonData, _base_path);
		        }         
		    });
		}
    });
}


function formDialogUpdate (id, value) {

    if (_updating == '1') { return }
    _updating = '1';

    this._timeout = setTimeout(function(){  formDialogDoUpdate(id, value); }, 300);       
}


function formDialogDoUpdate (id, value) {

    require(['dojo/dom','dojo/_base/xhr'], function(dom, xhr) {
    
        clearTimeout(this._timeout); 

        var f = dom.byId('Form_Dialog');
        if (f && f.elements.length) {
	        if (this._deferred) { this._deferred.cancel(); }
            xhr.post({
		        url: _base_path + '/' + _page + '/form_data/update/dialog/?',
		        handleAs: 'json',
		        form: dom.byId('Form_Dialog'),
		        load: function(jsonData) { 
		            fieldUpdate(id, jsonData);
		        }         
	        });
	    }
    });
}


function formDialogChartUpdate (id, value) {
    this._timeout = setTimeout(function(){  formDialogChartDoUpdate(id, value); }, 100);       
}


function formDialogChartDoUpdate (id, value) {

    require(['dojo/dom','dojo/dom-construct','dojo/dom-class','dojo/query'], function(dom, domConstruct, domClass, query) {
    
        clearTimeout(this._timeout); 

        var chart_selection = dijit.byId('d_chart_selection').get('value');
        var chart_selection = chart_selection.replace(/ /g, "___");
        var chartTableNode = 'd_' + chart_selection;
        var chartNode = 'chart_d_' + chart_selection;
        var chartPL = chartNode + '_PL';
        
        hideChartWarning();

        query('td.activeChart').forEach(function(node, index, arr) {	
            var activeChartId = node.getAttribute('id');
            var activeChartNode = dom.byId(activeChartId);     
            domClass.replace(activeChartNode, 'inactiveChart', 'activeChart');
        });

        query('div.activeChart').forEach(function(node, index, arr) {	
            var activeChartId = node.getAttribute('id');
            var activeChartNode = dom.byId(activeChartId);          
            domClass.replace(activeChartNode, 'inactiveChart', 'activeChart');
            domConstruct.empty(activeChartId);
            var activeChartLegendId = activeChartId + '_Legend';
            if (dom.byId(activeChartLegendId)) {
                var activeChartLegendNode = dom.byId(activeChartLegendId);
                var newChartLegendNode = "<div id=" + activeChartLegendId + " class='chartLegend inactiveChart'>";
                domConstruct.place(newChartLegendNode, activeChartLegendNode, 'replace');
            }
        });

        domClass.replace(chartTableNode, 'activeChart', 'inactiveChart');  
        domClass.replace(chartNode, 'activeChart', 'inactiveChart');

        domClass.add(chartPL, 'contentChartPreloader'); 

        query('#' + chartNode).forEach(function(node, index, arr) {
            renderDoChart(node, dialog); 
        });
    });
}


function formSelectUpdate (id, value) {
 
    require(['dojo/dom'], function(dom) {
        value = value.join();
        var mSelectData = 'mSelectData_' + id;
        dom.byId(mSelectData).innerHTML = value;
        if ( value == '' ) { 
            dom.byId('mSelect_status_' + id).value = 'clear'; 
        } else {
            dom.byId('mSelect_status_' + id).value = value; 
        }
    });
    
    setTimeout(function(){ formUpdate(id, value); }, 800); 
}


function formFileUpdate (id, value) {

    _updating = '1';
    _attempts = '0'; 
    
    formDoFileUpdate(id, value);
}


function formDoFileUpdate (id, value) {

    require(['dojo/dom','dojo/dom-style','dojo/_base/xhr','dojo/io/iframe'], function(dom, domStyle, xhr, ioIframe) {

        var signature_required = dijit.byId(id).get('signature_required');

        if (signature_required == '1') {
        
            _attempts = parseInt(_attempts) + parseInt('1');
            if (_attempts > '1') { 
                _updating = '0';
                var contents = 'fileSignatureContents_' + id;
                var check = 'fileSignatureCheck_' + id;
                var PL = 'fileSignaturePL_' + id;
                dom.byId(contents).innerHTML = 'Error when checking signature';
                dom.byId(check).setAttribute('src','');
                domStyle.set(PL, 'display', 'none');
                domStyle.set(contents, 'color', 'red');
                domStyle.set(contents, 'cursor', 'default');
                domStyle.set(check, 'display', 'none');
                return 
            };
        
            var preloader = 'fileSignaturePL_' + id;
            var text = 'fileSignatureContents_' + id;
            var check = 'fileSignatureCheck_' + id;
            
            domStyle.set(preloader, 'verticalAlign', 'top');
            domStyle.set(preloader, 'padding', '2pt 5pt 0 0');
            domStyle.set(preloader, 'display', 'inline');
            domStyle.set(text, 'fontSize', '8pt');
            domStyle.set(text, 'fontStyle', 'italic');
            domStyle.set(text, 'color', '#045FB4');
            
            dom.byId(text).innerHTML = 'Checking signature...';
            dom.byId(check).setAttribute('src','');
            
            domStyle.set(check, 'display', 'none');

            if (this._deferred) { this._deferred.cancel(); }

            this._deferred = ioIframe.send({
                 url: _base_path + '/' + _page + '/form_data/update/file_signature/?',
                 handleAs: 'json',
                 form: dom.byId('Form'),
                 load: function(jsonData) {
                    fieldUpdate(id, jsonData, _base_path);
                    if (this._deferred) { this._deferred.cancel(); }
                    this._deferred = ioIframe.send({
                        url: _base_path + '/' + _page + '/form_data/update/?',
		                handleAs: 'json',
		                form: dom.byId('Form'),
		                load: function(jsonData) { 
		                    fieldUpdate(id, jsonData, _base_path);
		                }              
		            });
                 },
                 error: function(response, ioArgs){
                    formDoFileUpdate (id, value); 
                 }
            });

        } else {

            xhr.post({
                 url: _base_path + '/' + _page + '/form_data/update/?',
		         handleAs: 'json',
		         form: dom.byId('Form'),
		         load: function(jsonData) { 
		            fieldUpdate(id, jsonData, _base_path);
		         }              
		    });
		}
    });
}


function fieldUpdate (active_node, jsonData, _base_path) {

    require(['dojo/dom','dojo/dom-construct','dojo/dom-class','dojo/dom-style','dojo/dom-attr','dojo/query'], 

    function(dom, domConstruct, domClass, domStyle, domAttr, query) {
    
        dojo.forEach(jsonData.items,function(items) {

            if (items.type == 'file') {

                var file = 'fileWidget_' + items.name;
                var type = dom.byId(file).getAttribute('class');

                var fileButton = 'fileButton_' + items.name;
                var widgetB = dijit.byId(fileButton);

	            var B_c = 'fileButtonClear_' + items.name;
	        
	            var contents = 'fileSignatureContents_' + items.name;
                var check = 'fileSignatureCheck_' + items.name;

                var dialog = 'fileSignatureDialog_' + items.name;
                var dialogContents = 'fileSignatureDialogContents_' + items.name;
                var tooltip = 'fileSignatureTooltip_' + items.name;
                var tooltipContents = 'fileSignatureTooltipContents_' + items.name;
                var PL = 'fileSignaturePL_' + items.name;

                if (items.name != active_node && (!type.match(/fileWidgetReception/))) {
                
                    var widget = dijit.byId(items.name);

                    var c_value = widget.get('value');
         
                    if (items.value != '--') {

                        if (items.value != '') {
                            widget.set('value',items.value);
                            dom.byId('file_status_' + items.name).value = items.value;
                            dijit.byId(B_c).set('disabled',false);
                            
                        } else {
                            widget.set('value',null);
                            dijit.byId(B_c).set('disabled','disabled');
                        }
                    }    

                    if (items.condition != '--') {
                    
                        query('div.EdC #' + items.name).forEach(function(node, index, arr){  

                            if (items.condition == 'true') {

		                        widget.fileInput.removeAttribute('disabled');
                                widget.fileInput.setAttribute('condition','true');
                                widgetB.set('disabled',false);
		                
                                domStyle.set(widget.fileInput, 'cursor', 'pointer');
                                domStyle.set(widget.inputNode, 'backgroundColor', '#FFF');
		                        domStyle.set(widget.inputNode, 'color', '#000');
            
                                domStyle.set(file, 'border', '1px solid #B5BCC7');


                                if ( dom.byId(contents) && dom.byId(check) ) {
                                    domStyle.set(contents, 'opacity', '1');
			                        domStyle.set(contents, 'filter', 'alpha(opacity=100)');
                                    domStyle.set(check, 'opacity', '1');
                                    domStyle.set(check, 'filter', 'alpha(opacity=100)');
                                }

                            } else {

                                widget.fileInput.setAttribute('disabled', 'disabled');
			                    widget.fileInput.setAttribute('condition','false');
			                    widgetB.set('disabled','disabled');

			                    domStyle.set(widget.fileInput, 'cursor', 'default');
		                        domStyle.set(widget.inputNode, 'backgroundColor', '#EFEFEF');
		                        domStyle.set(widget.inputNode, 'color', '#878787');
		                
		                        domStyle.set(file, 'border', '1px solid #D3D3D3');

                                if ( dom.byId(contents) && dom.byId(check) ) {
                                    dom.byId(contents).innerHTML = 'Signed PDF file required';
                                    dom.byId(check).setAttribute('src','');
                                    domStyle.set(contents, 'opacity', '0.3');
			                        domStyle.set(contents, 'filter', 'alpha(opacity=30)');
                                    domStyle.set(check, 'opacity', '0.3');
                                    domStyle.set(check, 'filter', 'alpha(opacity=30)');
                                }
                            }
                        });
                    }

                } else {

                    if (type.match(/fileWidgetReception/)) { 
                        var fileButton = 'fileButton_' + items.name;
                        dijit.byId(fileButton).set('disabled',false);
                    }

                    var node = dom.byId(contents);
                    
	                var newnode = dojo.create('span', {id: contents, 'class':'fileSignatureContents'}); 
                    if (node != null || node != undefined) {
                        node.parentNode.replaceChild(newnode, node);
                    }

                    if (items.print.match(/!ERROR*/)) {
                        var txt = items.print.replace(/!ERROR/, '');
                        if (dom.byId(contents) != null) {
                            dom.byId(dialogContents).innerHTML = '';
                            dom.byId(contents).innerHTML = txt;
                            dom.byId(check).setAttribute('src','');
                            domStyle.set(PL, 'display', 'none');
                            domStyle.set(contents, 'color', 'red');
                            domStyle.set(contents, 'cursor', 'default');
                            domStyle.set(check, 'display', 'none');
                        }

                    } else if (items.print != ''){
                        var lprint = items.print.split('--');

	                    var val = lprint[0];
                        var exp = lprint[1]
                        var txt = lprint[2];
                        var txt2 = txt;
                        var txt_dialog = lprint[3];

                        var lexp = exp.split(';');
                        if ( lexp[0].match(/^expired/) ) {
                            var txt2 = 'Expired certificate';
                        }

                        if (val.match(/^no_verification/)) {
			                var src = '';
			            } else if (val.match(/^none/)) {
                            var val = 'Signature not validated';
                            var src = _base_path + '/int/js/custom/images/question.png';
                            domClass.add(contents, 'UMS');
                        } else if (val.match(/^new/)) {
                            var val = 'Signature not validated';
                            var src = _base_path + '/int/js/custom/images/question.png';
                            domClass.add(contents, 'UMS');
                        } else if (val.match(/^active/)) {
                            var val = 'Signature validated';
                            var src = _base_path + '/int/js/custom/images/true.png';
                            domClass.add(contents, 'UMS');
                        } else {
                            var val = 'Signature revoked';
                            var src = _base_path + '/int/js/custom/images/false.png';
                            domClass.add(contents, 'UMS');
                        }
                        
                        if (node != null) {

                            domStyle.set(PL, 'display', 'none');

			                if (val.match(/^no_verification/)) {
			                    var dialog_check = "";
			                } else if (val.match(/^Signature not validated/)) {
			                    var dialog_check = "<img width='20' height='20' style='padding:0 0 0 15pt;' src='" + src + "'</img>";
			                } else {
				                var dialog_check = "<img width='12' height='12' style='padding:0 0 0 15pt;' src='" + src + "'</img>";			
			                }
                            
                            if ( lexp[0].match(/^no_expired/) ) {
                                domStyle.set(contents, 'cursor', 'pointer');
				                if (!val.match(/^no_verification/) && !val.match(/^none/) && !val.match(/^new/)) {
				                    dom.byId(check).setAttribute('src', src);
                                    domStyle.set(check, 'padding', '2pt 0 0 8pt');
                                    domStyle.set(check, 'verticalAlign', 'top');
                                    domStyle.set(check, 'display', 'inline');
				                }
                                
                            } else {
                                domStyle.set(contents, 'cursor', 'pointer');
                                domStyle.set(check, 'display', 'none');
                            }
                            
                            var _onclick = "sigsDialogShow('" + dialog + "')";  
                            dom.byId(contents).innerHTML = "<a onclick=" + _onclick + ">" + txt + "</a>";

                            var tooltip_label1_ = "<div style='width:250px;margin:5pt'><p>Signed by " + txt + "</p>";

			                if (val.match(/^no_verification/)) {
				                var tooltip_label1 = tooltip_label1_ + "</div>";
			                } else {
                                var tooltip_label1 = tooltip_label1_ + "<p class='fileSignatureTooltipVal'>" + val + dialog_check + "</p></div>";
			                }
                            
                            var tooltip_label2_ = "<div style='width:250px;margin:5pt'><p>Signed by " + txt + "</p>";
                            var tooltip_label2_ = tooltip_label2_ + "<p class='fileSignatureTooltipExp'>" + txt2 + "</p>";

		                    if (val.match(/^no_verification/)) {
				                var tooltip_label2 = tooltip_label2_ + "</div>";
			                } else {
                                var tooltip_label2 = tooltip_label2_ + "<p class='fileSignatureTooltipVal'>" + val + dialog_check + "</p></div>";
			                }

                            if (lexp[0].match(/^no_expired/)) {
                                var tooltip = new dijit.Tooltip({
                                    connectId: contents,
    			                    label: tooltip_label1,
                                    position:['below']
                                });
                                tooltip.startup();

                            } else {
                                var tooltip = new dijit.Tooltip({
                                    connectId: contents,
    			                    label: tooltip_label2,
                                    position:['below']
                                });
                                tooltip.startup();
                            }

                            dom.byId(dialogContents).innerHTML = txt_dialog;
                            
			                if (!val.match(/^no_verification/)) {
                                var certD_val = 'certD' + items.name + '_val';
                                dom.byId(certD_val).innerHTML = "<p style='font-size:11pt;font-weight:bold;color:#4D8B99'>" + val + dialog_check + "</p>";
			                }
                            
                            if (lexp[0].match(/^expired/)) {
                                var exp_cert_id = lexp[1];
                                var exp_date = lexp[2];
                                var exp_cert_node = 'certD' + items.name + '_id_' + lexp[1];
                                var exp_cert_name = dojo.byId(exp_cert_node).innerHTML;
			                    var exp_text1 = "<span><p style='font-size:10pt'>Certificate <b>" + exp_cert_name + "</b>";
                                var exp_text2 = 'expired on ' + exp_date + '</p></span>';
                                
				                var certD_exp = 'certD' + items.name + '_exp';
                                dom.byId(certD_exp).innerHTML = exp_text1 + ' ' + exp_text2;
                            }
                        }

 	                } else {

                        if (node != null) {
                            dom.byId(dialogContents).innerHTML = '';
                            dom.byId(contents).innerHTML = 'Signed PDF file required';
                            dom.byId(check).setAttribute('src','');
                            domStyle.set(PL, 'display', 'none');
                            domStyle.set(contents, 'color', '#555555');
                            domStyle.set(contents, 'cursor', 'default');
                            domStyle.set(check, 'display', 'none');
                        }
	                }
	            }

	        } else if (items.type == 'date') {
	        
                var widget = dijit.byId(items.name);
                if (widget) {
                    var date = 'dateWidget_' + items.name;
                    if (items.value != '--') {
                        widget.set('value',items.value); 
                    } 
                    if (items.condition != '--') {      
                        var dateTable = 'dateWidget_' + items.name;
                        var dateButton = 'dateButton_' + items.name;
                        var widgetB = dijit.byId(dateButton);
                        
                        if (items.condition == 'true') {   
		                    widget.set('disabled',false);
                            widgetB.set('disabled',false);
                            domStyle.set(dateTable, 'border', '1px solid #B5BCC7');
                            
                        } else {
                            widget.set('value',null);
                            widget.set('disabled','disabled');
                            widgetB.set('disabled','disabled');
                            domStyle.set(dateTable, 'border', '1px solid #D3D3D3');
                        }        
                    }
                 }

            } else if (items.type == 'time') {

                var widget = dijit.byId(items.name);
                if (widget) {
                    if (items.value != '--') {
                        widget.set('value',items.value); 
                    } 
                    if (items.condition != '--') {     
                        var timeTable = 'timeWidget_' + items.name;
                        var timeButton = 'timeButton_' + items.name;
                        var widgetB = dijit.byId(timeButton);
                        
                        if (items.condition == 'true') {
		                    widget.set('disabled',false);
                            widgetB.set('disabled',false);
		                    domStyle.set(timeTable, 'border', '1px solid #B5BCC7');
		                    
		                } else {
                            widget.set('value',null);
		                    widget.set('disabled','disabled');
                            widgetB.set('disabled','disabled');
		                    domStyle.set(timeTable, 'border', '1px solid #D3D3D3');
		                }        
                    }
		        }

	        } else if (items.type == 'condition') {

                if (items.value != '--'){
                    if (items.print != ''){
		                var text = '<i>' + items.print + '</i>';
	                    var id = 'condition_' + items.name;
		                dom.byId(id).innerHTML = text;
	                }
	                var src = _base_path + '/int/js/custom/images/' + items.value + '.png';
	                var id = 'img_' + items.name;
	                var c_src = dom.byId(id).getAttribute('src');
	                if (src != c_src) { dom.byId(id).setAttribute('src',src); }
                }

	        } else if (items.type == 'expression') {
    
                var e_node = 'e_' + items.name;
		        if (items.value != '--') {  
                    dom.byId(items.name).value = items.value;
                    if (dom.byId(e_node) != null ) { dom.byId(e_node).innerHTML = items.value; }
                }
                if (items.condition != '--') {
                    if (items.condition == 'true') {   
                        if (dom.byId(e_node) != null ) { domStyle.set(e_node, 'visibility', 'visible'); }
                    } else {
		                if (dom.byId(e_node) != null ) { domStyle.set(e_node, 'visibility', 'hidden'); }
		            }
                }


	        } else if (items.type == 'text expression') {

	            var widget = dijit.byId(items.name);
                if (widget) {
                    if (items.value != '--') { widget.set('value',items.value); } 
                    if (items.condition != '--') {
                        if (items.condition == 'true') {   
                            widget.set('disabled',false);
                        } else {
		                    widget.set('disabled','disabled');
		                }
                    }
    
                } else {
                    var node = dom.byId(items.name);
                    if (node && items.value != '--') { node.innerHTML = items.value; }
                }

            } else if (items.type == 'formatted expression') {

                var type = 'default';
                var node = dom.byId(items.name);
                if (node) {
                    var node_class = node.getAttribute('class');
                    if (domClass.contains(node, 'chart')) { var type = 'chart'; }
                }
                
                var e_name = 'e_' + items.name;
                var e_widget = dijit.byId(e_name);

                if (e_widget) {
                
                    if (items.value != '--') { 
                        if(node) { node.innerHTML = items.value; }
                        e_widget.set('value', items.value); 
                    }
                    if (items.condition != '--') {
                        query('div.EdC #' + e_name).forEach(function(node, index, arr){ 
                            if (items.condition == 'true') {
		                        domStyle.set(e_widget, 'backgroundColor', 'white');
                            } else {
                                domStyle.set(e_widget, 'backgroundColor', 'grey');
                            }
                        });
		            }
		            
                } else  {
                
                    if (node && items.value != '--') { 
                       if (type == 'chart') { 
                            var value = items.value.toString();
                            var chartNode = domConstruct.toDom(items.value); 

                            updateChart(items.name, chartNode);

                       } else {
                            node.innerHTML = items.value;
                       }
                    }
                }

            } else if (items.type == 'radio_buttons') {

                var radio1 = items.name + '_1';
                var label1 = 'label_' + radio1;
                var radio2 = items.name + '_2';
                var label2 = 'label_' + radio2;
                var node1 = dijit.byId(radio1);
                var node2 = dijit.byId(radio2);
                
                if ( node1 != null && node2 != null && items.value != '--') {
                
                    if ( (node1.get('value') != items.value) && (node2.get('value') != items.value) ) {
                        if ( node1.get('value') == false ) {
                            node1.set('checked',true);
                            node2.set('checked',false);
                        } else {
                            node1.set('checked',false);
                            node2.set('checked',true);
                        }
                    }
                    
                    if (items.condition != '--') {
                        if (items.condition == 'true') {
                            node1.set('disabled',cond);
                            domStyle.set(label1, 'color', 'black');
                            node2.set('disabled',cond);
                            domStyle.set(label2, 'color', 'black');
                        } else {
                            node1.set('disabled','disabled');
                            domStyle.set(label1, 'color', 'grey');
                            node2.set('disabled','disabled');
                            domStyle.set(label2, 'color', 'grey');   
                        }
                    }
                }

            } else if (items.type == 'button') {
            
                var widget = dijit.byId(items.name);
                
                if ( widget && items.condition != '--') {
                    if (items.condition == 'true') {
		                widget.set('disabled',false);
                    } else {
		                widget.set('disabled','disabled');
                    }
                }
  
            } else if (items.type == 'table') {

            } else if (items.type == 'check_buttons') {

            } else  {

                var widget = dijit.byId(items.name);
                if (widget) {
                    if (items.value != '--') { widget.set('value',items.value); }
		            if (items.condition != '--') {
                        if (items.condition == 'true') {   
                            widget.set('disabled',false);
                        } else {
		                    widget.set('disabled','disabled');
		                }
                    }  
                } 
            } 
        });

        if (!_db_display) { domAttr.remove('Form', 'target'); }

        setTimeout(function(){  _updating = '0'; }, 500);  
    });	                         
}

function updateChart(id, chartNode) {
    require(['dojo/ready','dojo/dom','dojo/query','dojo/dom-construct','dojo/dom-class','dojo/dom-style','dojo/dom-attr',
             'dojo/_base/fx','dojox/html/entities'], function(ready, dom, query, domConstruct, domClass, domStyle, domAttr, fx) {

        var numC = domAttr.get(chartNode, 'chart_num');

        if (numC) {

	        var toUpdate = '0';

	        if (_chartWidgetStorage[numC][0] != domAttr.get(chartNode, 'type')) {
                _chartWidgetStorage[numC][0] = domAttr.get(chartNode, 'type');
		        var toUpdate = '1';
            }
	        if (_chartWidgetStorage[numC][1] != domAttr.get(chartNode, 'pn')) {
                _chartWidgetStorage[numC][1] = domAttr.get(chartNode, 'pn');
		        var toUpdate = '1';
	        }
	        if (_chartWidgetStorage[numC][2] != domAttr.get(chartNode, 'xaxisname')) {
                _chartWidgetStorage[numC][2] = domAttr.get(chartNode, 'xaxisname');
		        var toUpdate = '1';
	        }
	        if (_chartWidgetStorage[numC][3] != domAttr.get(chartNode, 'yaxisname')) {
		        _chartWidgetStorage[numC][3] = domAttr.get(chartNode, 'yaxisname');
		        var toUpdate = '1'; 
            }
	        if (_chartWidgetStorage[numC][4] != domAttr.get(chartNode, 'radius')) {
                _chartWidgetStorage[numC][4] = domAttr.get(chartNode, 'radius');
		        var toUpdate = '1';
	        }
	        if (_chartWidgetStorage[numC][5] != domAttr.get(chartNode, 'labels')) {
                _chartWidgetStorage[numC][5] = domAttr.get(chartNode, 'labels');
		        var toUpdate = '1';
            }
	        if (_chartWidgetStorage[numC][6] != domAttr.get(chartNode, 'colours')) {
                _chartWidgetStorage[numC][6] = domAttr.get(chartNode, 'colours');
		        var toUpdate = '1';
	        }
	        if (_chartWidgetStorage[numC][7] != domAttr.get(chartNode, 'legend')) {
                _chartWidgetStorage[numC][7] = domAttr.get(chartNode, 'legend');
		        var toUpdate = '1';
            }
	        if (_chartWidgetStorage[numC][8] != domAttr.get(chartNode, 'dataX')) {
                _chartWidgetStorage[numC][8] = domAttr.get(chartNode, 'dataX');
		        var toUpdate = '1';
            }
	        if (_chartWidgetStorage[numC][9] != domAttr.get(chartNode, 'data')) {
	            _chartWidgetStorage[numC][9] = domAttr.get(chartNode, 'data');
		        var toUpdate = '1';
            }

	        if (toUpdate == '0') { return }
    
            query('div.chartWarning').forEach(function(node, index, arr) {	
                var chartWarningNode = node.getAttribute('id');
                node.innerHTML = '';
                domClass.replace(chartWarningNode, 'inactiveChartWarning', 'activeChartWarning');
	        domStyle.set(chartWarningNode, 'opacity', '0');
            });
      
            var chartId = 'chart_' + id;
            domAttr.set(chartNode, 'id', chartId);

            domStyle.set(chartId, 'opacity', '0');

            var chartType = domAttr.get(chartNode, 'type');
	        if (chartType == 'Calendar') { domStyle.set(chartId, 'visibility', 'hidden'); }
            
            var height = domStyle.get(chartId, 'height');
            domStyle.set(chartId, 'height', height + 'px');
            
            var chartPL = chartId + '_PL';
            if (dom.byId(chartPL)) { domClass.add(chartPL, 'contentChartPreloader'); }
	        if (chartType == 'Calendar') { domClass.add(chartPL, 'calendar'); }
            
            domConstruct.empty(chartId);

            var chartLegendId = chartId + '_Legend';
            if (dom.byId(chartLegendId)) {
                var chartLegendNode = dom.byId(chartLegendId);
                var newChartLegendNode = "<div id=" + chartLegendId + " class='chartLegend inactiveChart'>";
                domConstruct.place(newChartLegendNode, chartLegendNode, 'replace');
            }

            renderDoChart(chartNode, 'page');   
            
            
        } else {
	        raiseChartWarning(id); 
        }
    });
}
