

define(['dojo/_base/declare', 'dijit/_WidgetBase', 'dijit/_TemplatedMixin', 'dojo/text!./templates/FileInput.html'], function(declare, WidgetBase, TemplatedMixin,  template){
      
   return declare('custom.FileInput', [WidgetBase, TemplatedMixin], {

   templateString: template,
   
   startup: function(){

      this._listener = this.connect(this.fileInput,'onchange','_matchValue');
      this._keyListener = this.connect(this.fileInput,'onkeyup','_matchValue');
      this._mouseOutListener = this.connect(this.fileInput,'onmouseleave','_UnHovered');
      this._mouseInListener = this.connect(this.fileInput,'onmouseenter','_Hovered');
      this.defaultvalueNode.value = this.inputNode.value;

      if (this.defaultValueNode == undefined || this.defaultValueNode == null || this.defaultValueNode == '') {
            var widgetB_c = 'fileButtonClear_' + this.id;
            if (dijit.byId(widgetB_c)) { dijit.byId(widgetB_c).set('disabled','disabled'); }
      }
      
      var accept = this.inputNode.getAttribute('accept');;
      if (accept != null || accept != undefined) {
          this.fileInput.setAttribute('accept','application/pdf');
      }
      
      var fileWidgetId = 'fileWidget_' + this.id;
      var fileInputId = 'fileInput_' + this.id;

      this.fileInput.setAttribute('id', fileInputId);
      this.fileInput.setAttribute('size', '3');
      
      var condition = this.fileInput.getAttribute('condition');
      
      var contents = 'fileSignatureContents_' + this.id;
      var check = 'fileSignatureCheck_' + this.id;
      var infoIcon = 'fileSignatureInfoIcon_' + this.id;

      if (condition == 'disabled') {
          var inputNode = this.inputNode;
          this.fileInput.setAttribute('disabled','disabled');

          require(['dojo/dom','dojo/dom-style'], function(dom, domStyle){
              domStyle.set(inputNode, 'backgroundColor', '#EFEFEF');
              domStyle.set(inputNode, 'color', '#878787');

              if ( dom.byId(contents) != null && dom.byId(check) != null && dom.byId(infoIcon) != null ) {
                  domStyle.set(contents, 'opacity', '0.3');
		          domStyle.set(contents, 'filter', 'alpha(opacity=30)');
                  domStyle.set(check, 'opacity', '0.3');
                  domStyle.set(check, 'filter', 'alpha(opacity=30)');
                  domStyle.set(infoIcon, 'display', 'none');
              }
          });
      }
      
      require(['dojo/dom','dojo/dom-class','dojo/query'], function(dom, domClass, query){
          if ( dojo.isIE ) {
                query('.dijitFileInputVisible').forEach(function(node, index, arr){
                    domClass.add(node, 'IE');
                });
            
          } else if ( dojo.isChrome ) {
                query('.dijitFileInputVisible').forEach(function(node, index, arr){
                    domClass.add(node, 'Chrome');
                });
            
          } else {
                query('.dijitFileInputVisible').forEach(function(node, index, arr){
                    domClass.add(node, 'FF');
                });
          }
      });
   },

    postCreate: function(){},

    _matchValue: function(){
        var str = this.fileInput.value;
        var array = str.split(/\\/); 
        this.inputNode.value = array[array.length-1];
        dijit.byId(this.id).set('value',this.inputNode.value);
      
        var B_c = 'fileButtonClear_' + this.id;
        dijit.byId(B_c).set('disabled',false);

        fileUpdate(this.id, this.inputNode.value);
    },

    _Hovered: function(){

        var fileInput = this.inputNode;
        var fileWidget = 'fileWidget_' + this.id;
        
        require(['dojo/dom-class','dojo/query'], function(domClass, query){
            domClass.add(fileWidget, 'widgetHovered');
            domClass.add(fileInput, 'widgetHovered');
        }); 
    },

    _UnHovered: function(){

        var fileInput = this.inputNode; 
        var fileWidget = 'fileWidget_' + this.id;
        
        require(['dojo/dom-class','dojo/query'], function(domClass, query){
            domClass.remove(fileWidget, 'widgetHovered');
            domClass.remove(fileInput, 'widgetHovered');
        });
    },

   reset: function(e){
   
      this.disconnect(this._listener);
      this.disconnect(this._keyListener);
      this.disconnect(this._mouseInListener);
      this.disconnect(this._mouseOutListener);

      if(this.fileInput){ this.domNode.removeChild(this.fileInput); }
      this.fileInput = document.createElement('input');
      
      var fileWidgetId = 'fileWidget_' + this.id;
      var fileInputId = 'fileInput_' + this.id;
      
      this.fileInput.setAttribute('type', 'file');
      this.fileInput.setAttribute('id', fileInputId);
      this.fileInput.setAttribute('name',this.name);
      this.fileInput.setAttribute('size','3');
      this.fileInput.setAttribute('condition',this.condition);
      
      var accept = this.inputNode.getAttribute('accept');;
      if (accept != null || accept != undefined) {
          this.fileInput.setAttribute('accept', 'application/pdf');
      }

      dojo.addClass(this.fileInput,'dijitFileInputReal');
      this.domNode.insertBefore(this.fileInput,this.domNode.firstChild);
      
      this._mouseOutListener = this.connect(this.fileInput,'onmouseleave','_UnHovered');
      this._mouseInListener = this.connect(this.fileInput,'onmouseenter','_Hovered');
      this._keyListener = this.connect(this.fileInput,'onkeyup','_matchValue');
      this._listener = this.connect(this.fileInput,'onchange','_matchValue');
   }

  });

});






