

function fileWidgetUpdate() {

    require(['dojo/dom','dojo/dom-style','dojo/on','dojo/query'], function(dom, domStyle, on, query){

        query('table.formContainer.formSameLineParamContainer input.dijitFileInputReal' ).forEach(function(node, index, arr){ 
            node.setAttribute('size','3'); 
        }); 

        query('.fileButtonDownload').forEach(function(node, index, arr){
	        var id = node.getAttribute('id');
	        var file_id = id.replace(/fileButtonDownload_/, '');
	        var file_value = dijit.byId(file_id).get('value');
	        if ( file_value && file_value != '') {
	            dijit.byId(id).set('disabled',false);
	            var clearButton = 'fileButtonClear_' + file_id;
	            var clearButtonWidget = dijit.byId(clearButton);
	            if (clearButtonWidget) { clearButtonWidget.set('disabled',false); }
	            var downloadButton = 'fileButtonDownload_' + file_id;
	            var downloadButtonWidget = dijit.byId(downloadButton);
	            if (downloadButtonWidget) { downloadButtonWidget.set('disabled',false); }
	            
	            var edit_choose_name = dom.byId('post_key_2').getAttribute('value');
                var edit_choose_value = dom.byId('post_key_3').getAttribute('value');
		        var edit_choose_id = dom.byId('post_key_4').getAttribute('value');
	            
	            var table = dijit.byId(file_id).get('table');

	            on(node, 'click', function(){
	                window.location.href = _base_path + '/form_data/file/' + table + '/' + edit_choose_name + '/' + edit_choose_value + '/' + edit_choose_id + '/' + file_id;
	            });

	            formFileUpdate (file_id, file_value, edit_choose_name);
	        } 
        });
    });
}


function fileWidgetClear (id, signature_required) {

     require(['dojo/dom','dojo/dom-style'], function(dom, domStyle){
     
        dom.byId('file_status_' + id).value = 'clear';
        dijit.byId(id).reset();
        dijit.byId(id).set('value','');
        dijit.byId('fileButtonClear_' + id).set('disabled','disabled');

        var download_id = 'fileButtonDownload_' + id;
        dijit.byId(download_id).destroy();

	    var newnode = dojo.create('div', {id: download_id, innerHTML: 'Download'});
	    var refnode = dijit.byId('fileMenu_' + id);
	    var widget = new dijit.MenuItem({
		    'class': 'fileButtonDownload',
		    iconClass: 'dijitIconEditTask',
		    disabled: 'disabled'
	    },newnode ).placeAt(refnode);
	    
        if ( signature_required == '1' ) {
            var contents = 'fileSignatureContents_' + id;
            var check = 'fileSignatureCheck_' + id;
            var tooltip = 'fileSignatureTooltip_' + id;
            var tooltipContents = 'fileSignatureTooltipContents_' + id;
            var node = dom.byId(contents);
            var newnode = dojo.create('span', {id: contents, style:'font-size:8pt;font-style:italic;color:#555555;cursor:default'});
            if ( node ) { node.parentNode.replaceChild(newnode, node); }
            dom.byId(contents).innerHTML = 'Signed PDF file required';
            dom.byId(check).setAttribute('src','');
            domStyle.set(check, 'display', 'none');
         }
     });
}


function fileWidgetSelection(id) {
    var fileInput = 'fileInput_' + id;
    require(['dojo/dom'], function(dom){
        dom.byId(fileInput).click();
    });
}


function sigsDialogShow(id) {

    require(['dojo/dom','dojo/query'], function(dom, query){

        query('#' + id + ' .dijitDialogTitleBar .dijitDialogTitle').forEach(function(node, index, arr){  
            var titleBar = "<span class='dijitIcon certsProfileIcon'></span><span class='dijitTitleName'>Signature data</span>";
            node.innerHTML = titleBar;
        });
        
        dijit.byId(id).show();
    });
}


function sigInfo(n, id, depth) {
     for (i = 0; i < depth; i++) {
         var certD_det = 'certD' + n + '_det_' + i;
         var certD_id = 'certD' + n + '_id_' + i;
         require(['dojo/dom-style'], function(domStyle){
             if (i == id) {
                 domStyle.set(certD_det, 'display', 'block');
                 domStyle.set(certD_id, 'fontWeight', 'bold');
             } else {
                 domStyle.set(certD_det, 'display', 'none');
                 domStyle.set(certD_id, 'fontWeight', 'normal');
             }
         });
     }
}


function Hovered_File_Button() {
    var node = dijit.byId(this.id);
    var id = this.id.replace(/fileButton_/, '');
    if (node.get('disabled')){ var dis = true; } else { var dis = false; }
    if ( dis == false ) {
        var fileWidget = 'fileWidget_' + id;
        var fileInput = 'widget_' + id;
        require(['dojo/dom-class'], function(domClass){
            domClass.add(fileWidget, 'widgetHovered');
            domClass.add(fileInput, 'widgetHovered');
        }); 
    }
}


function UnHovered_File_Button(){
    var node = dijit.byId(this.id);
    var id = this.id.replace(/fileButton_/, '');
    if (node.get('disabled')){ var dis = true; } else { var dis = false; }
    if ( dis == false ) {
        var fileWidget = 'fileWidget_' + id;  
        var fileInput = 'widget_' + id;
        require(['dojo/dom-class'], function(domClass){
            domClass.remove(fileWidget, 'widgetHovered');
            domClass.remove(fileInput, 'widgetHovered');
        }); 
    }
}


function Hovered_Date() {
    var node = dijit.byId(this.id);
    var id = this.id;
    if (node.get('disabled')){ var dis = true; } else { var dis = false; }
    if ( dis == false ) {
	    var dateWidget = 'dateWidget_' + id;
	    require(['dojo/dom-class'], function(domClass){
            domClass.add(dateWidget, 'widgetHovered');
        });
    }
}

function Focused_Date() {
    dijit.byId(this.id).openDropDown();
}

function Focused_Selection() {
    dijit.byId(this.id).loadAndOpenDropDown();
}


function dateWidgetSelection(id) {
    dijit.byId(id).openDropDown();
    require(['dojo/dom','dijit/focus'], function(dom,focusUtil){
        focusUtil.focus(dom.byId(id));
    });
}


function dateWidgetCheckInvalid(id) {
    require(['dojo/dom-class','dojo/on'], function(domClass, on){ 
        var dateWidget = dijit.byId(id);
        var invalid = dateWidget.isValid();
        if (invalid == false) { 
            domClass.add('dateWidget_' + id, 'invalid');
        } else {
            domClass.remove('dateWidget_' + id, 'invalid');
        }
    });
}


function Hovered_Date_Button() {
    var node = dijit.byId(this.id);
    var id = this.id.replace(/dateButton_/, '');
    if (node.get('disabled')){ var dis = true; } else { var dis = false; }
    if ( dis == false ) {
        var dateInput = 'widget_' + id;
        var dateWidget = 'dateWidget_' + id;
        require(['dojo/dom-class'], function(domClass){
            domClass.add(dateWidget, 'widgetHovered');
            domClass.add(dateInput, 'dijitTextBoxHover dijitComboBoxHover dijitDateTextBoxHover dijitValidationTextBoxHover dijitHover');
        });
    }
}


function UnHovered_Date() {
    var node = dijit.byId(this.id);
    var triggerId = this.id;
    if (node.get('disabled')){ var dis = true; } else { var dis = false; }
    if ( dis == false ) {
	    var dateWidget = 'dateWidget_' + this.id;
	    require(['dojo/dom-class','dijit/focus'], function(domClass, focusUtil){
	        var focusedWidget = focusUtil.curNode;
	        if (focusedWidget == null) {
	            domClass.remove(dateWidget, 'widgetHovered');          
            } else {
                var id = focusedWidget.getAttribute('id');
		        if ( id != triggerId ) { 
                    domClass.remove(dateWidget, 'widgetHovered');
                }
            }
        });
    }
}


function UnFocused_Date() {
    var node = dijit.byId(this.id);
    if (node.get('disabled')){ var dis = true; } else { var dis = false; }
    if ( dis == false ) {
	    var dateWidget = 'dateWidget_' + this.id;
	    require(['dojo/dom-class'], function(domClass){
	        domClass.remove(dateWidget, 'widgetHovered');    
        });
    }
    dateWidgetCheckInvalid(this.id);
}


function UnHovered_Date_Button() {
    var node = dijit.byId(this.id);
    var id = this.id.replace(/dateButton_/, '');
    if (node.get('disabled')){ var dis = true; } else { var dis = false; }
    if ( dis == false ) {
        var dateWidget = 'dateWidget_' + id;
        var dateInput = 'widget_' + id;
        require(['dojo/dom-class'], function(domClass){
            domClass.remove(dateWidget, 'widgetHovered');
            domClass.remove(dateInput, 'dijitTextBoxHover dijitComboBoxHover dijitDateTextBoxHover dijitValidationTextBoxHover dijitHover');
        });
    }
}


function Hovered_Time() {
    var node = dijit.byId(this.id);
    var id = this.id;
    if (node.get('disabled')){ var dis = true; } else { var dis = false; }
    if ( dis == false ) {
	    var timeWidget = 'timeWidget_' + id;
	    require(['dojo/dom-class'], function(domClass){
            domClass.add(timeWidget, 'widgetHovered');
        });
    }
}


function Focused_Time() {
    dijit.byId(this.id).openDropDown();
}


function timeWidgetSelection(id) {
    dijit.byId(id).openDropDown();
    require(['dojo/dom','dijit/focus'], function(dom,focusUtil){
        focusUtil.focus(dom.byId(id));
    });
}


function timeWidgetCheckInvalid(id) {
    require(['dojo/dom-class'], function(domClass){ 
        var timeWidget = dijit.byId(id);
        var invalid = timeWidget.isValid();
        if (invalid == false) { 
            domClass.add('timeWidget_' + id, 'invalid');
        } else {
            domClass.remove('timeWidget_' + id, 'invalid');
        }
    });
}


function Hovered_Time_Button() {
    var node = dijit.byId(this.id);
    var id = this.id.replace(/timeButton_/, '');
    if (node.get('disabled')){ var dis = true; } else { var dis = false; }
    if ( dis == false ) {
        var timeInput = 'widget_' + id;
        var timeWidget = 'timeWidget_' + id;
        require(['dojo/dom-class'], function(domClass){
            domClass.add(timeWidget, 'widgetHovered');
            domClass.add(timeInput, 'dijitTextBoxHover dijitComboBoxHover dijitDateTextBoxHover dijitValidationTextBoxHover dijitHover');
        });
    }
}


function UnHovered_Time() {
    var node = dijit.byId(this.id);
    var triggerId = this.id;
    if (node.get('disabled')){ var dis = true; } else { var dis = false; }
    if ( dis == false ) {
	    var timeWidget = 'timeWidget_' + this.id;
	    require(['dojo/dom-class','dijit/focus'], function(domClass, focusUtil){
	        var focusedWidget = focusUtil.curNode;
	        if (focusedWidget == null) {
	            domClass.remove(timeWidget, 'widgetHovered');          
            } else {
                var id = focusedWidget.getAttribute('id');
		        if ( id != triggerId ) { 
                    domClass.remove(timeWidget, 'widgetHovered');
                }
            }
        });
    }
}


function UnFocused_Time() {
    var node = dijit.byId(this.id);
    if (node.get('disabled')){ var dis = true; } else { var dis = false; }
    if ( dis == false ) {
	    var timeWidget = 'timeWidget_' + this.id;
	    require(['dojo/dom-class'], function(domClass){
	        domClass.remove(timeWidget, 'widgetHovered');    
        });
    }
    timeWidgetCheckInvalid(this.id)
}


function UnHovered_Time_Button() {
    var node = dijit.byId(this.id);
    var id = this.id.replace(/timeButton_/, '');
    if (node.get('disabled')){ var dis = true; } else { var dis = false; }
    if ( dis == false ) {
        var timeWidget = 'timeWidget_' + id;
        var timeInput = 'widget_' + id;
        require(['dojo/dom-class'], function(domClass){
            domClass.remove(timeWidget, 'widgetHovered');
            domClass.remove(timeInput, 'dijitTextBoxHover dijitComboBoxHover dijitDateTextBoxHover dijitValidationTextBoxHover dijitHover');
        });
    }
}


function Hovered_mSelect(id) {
    var node = dijit.byId(id);
    if (node.get('disabled')){ var dis = true; } else { var dis = false; }
    if ( dis == false ) {
        var mSelectionWidget = 'mSelectWidget_' + id;
        require(['dojo/dom-class'], function(domClass){
            domClass.add(mSelectionWidget, 'widgetHovered');
        });
    }
}


function UnHovered_mSelect(id) {
    var node = dijit.byId(id);
    if (node.get('disabled')){ var dis = true; } else { var dis = false; }
    if ( dis == false ) {
        var mSelectionWidget = 'mSelectWidget_' + id;
        require(['dojo/dom-class'], function(domClass){
            domClass.remove(mSelectionWidget, 'widgetHovered');
        });
    }
}


function Hovered_mSelect_Button() {
    var node = dijit.byId(this.id);
    var id = this.id.replace(/mSelectButton_/, '');
    if (node.get('disabled')){ var dis = true; } else { var dis = false; }
    if ( dis == false ) {
        var mSelectionWidget = 'mSelectWidget_' + id;
        var mSelectionWidgetButton = 'mSelectButton_' + id;
        require(['dojo/dom-class'], function(domClass) { 
            domClass.add(mSelectionWidget, 'widgetHovered');
            domClass.add(mSelectionWidgetButton, 'buttonHovered');
        });
    }
}


function UnHovered_mSelect_Button() {
    var node = dijit.byId(this.id);
    var id = this.id.replace(/mSelectButton_/, '');
    if (node.get('disabled')){ var dis = true; } else { var dis = false; }
    if ( dis == false ) {
        var mSelectionWidget = 'mSelectWidget_' + id;
        var mSelectionWidgetButton = 'mSelectButton_' + id;
        var mSelectionInput = 'widget_' + id;
        require(['dojo/dom-class','dojo/dom-style'], function(domClass, domStyle) {
            domClass.remove(mSelectionWidgetButton, 'buttonHovered');
            if (domStyle.get(mSelectionInput, 'display') == 'none') {
                domClass.remove(mSelectionWidget, 'widgetHovered');
            }
        });
    }
}


function Open_mSelectBox(id) {
    var mSelectionWidget = 'mSelectWidget_' + id;
    var mSelectionData = 'mSelectData_' + id;
    var mSelectionBox = 'widget_' + id;
    require(['dojo/dom','dojo/dom-style','dojo/dom-class','dijit/focus'], function(dom, domStyle, domClass, focusUtil) {
        domClass.add(mSelectionWidget, 'widgetHovered widgetBoxOpen');
        domStyle.set(mSelectionBox, 'display', 'block');
        var handle = focusUtil.watch('curNode', function(name, node, newNode){
            if (newNode != node) { Close_mSelectBox(id); }
        });  
    });
}

function Close_mSelectBox(id) {
    var mSelectionWidget = 'mSelectWidget_' + id;
    var mSelectionData = 'mSelectData_' + id;
    var mSelectionBox = 'widget_' + id;
    require(['dojo/dom','dojo/dom-style','dojo/dom-class'], function(dom, domStyle, domClass) {
        domClass.remove(mSelectionWidget, 'widgetHovered widgetBoxOpen');
        domStyle.set(mSelectionBox, 'display', 'none');
    });
}


function renderWidgets(mode) {
    require(['dojo/ready','dojo/dom'], function(ready, dom) {
        ready(function() { 
            renderOptionsTree(mode);       
            renderTable(mode);
            renderChart(mode);
            fileWidgetUpdate();
         });
     });
}


function renderOptionsTree(mode) {

    require(['dojo/ready','dojo/on','dojo/dom','dojo/store/Memory','dijit/form/FilteringSelect'], 
    
    function(ready, on, dom, Memory, FilteringSelect){

            for (var i = 0; i < _optionsTreeWidgetStorage.length; i++) {
        
                var type = _optionsTreeWidgetStorage[i][0];
                var id = _optionsTreeWidgetStorage[i][1];
                var value = _optionsTreeWidgetStorage[i][2];
                var condition = _optionsTreeWidgetStorage[i][3];
		        var required = _optionsTreeWidgetStorage[i][4];
                var data = _optionsTreeWidgetStorage[i][5];
                var edit_choose_name = _optionsTreeWidgetStorage[i][6];

                if (mode == 'edit' && edit_choose_name == id) { continue }

                if (mode == 'dialog' && dijit.byId(id)) { continue }

                var treeStore = new Memory({data: data });

                if (type == 'options non-editable') {
        
                    if (condition == 'disabled' || condition == 'readonly') {
                    
                        var fs = new FilteringSelect({
                            id: id,
                            name: 'p_' + id,
                            value: value,
                            store: treeStore,
                            disabled: 'disabled',
                            searchAttr: 'name',
                            labelAttr: 'label',
                            labelType: 'html',
                            'class': 'widget readonly',
                            readonly: 'readonly',
			                onChange: function(evt){ formUpdate(id, 'widget readonly', value); }
                        }, id);

                    } else {
                    
                        var fs = new FilteringSelect({
                            id: id,
                            name: 'p_' + id,
                            value: value,
                            store: treeStore,
                            condition: condition,
                            searchAttr: 'name',
                            labelAttr: 'label',
                            labelType: 'html',
                            'class': 'widget readonly',
                            readonly: 'readonly',
			                required: required,
			                onClick: optionsTreeSelectionClicked,
                            onChange: function(evt){ formUpdate(id, 'widget readonly', value); }
                        }, id);

                        on(dom.byId(id), 'focus', function() {
                           optionsTreeSelectionHovered(id);
                        });
                    }
                     
                 } else {
                    
                    if (condition == 'disabled' || condition == 'readonly') {
                    
                        var fs = new FilteringSelect({
                            id: id,
                            name: 'p_' + id,
                            value: value,
                            store: treeStore,
                            disabled: 'disabled',
                            condition: condition,
                            searchAttr: 'name',
                            labelAttr: 'label',
                            labelType: 'html',
                            'class': 'widget',
                            onChange: function(evt){ formUpdate(id, 'widget', value); }
                        }, id);
                    
                    } else {
                    
                        var fs = new FilteringSelect({
                            id: id,
                            name: 'p_' + id,
                            value: value,
                            store: treeStore,
                            condition: condition,
                            searchAttr: 'name',
                            labelAttr: 'label',
                            labelType: 'html',
                            'class': 'widget',
			                required: required,
                            onChange: function(evt){ formUpdate(id, 'widget', value); }
                        }, id);
                    }
                 }
                 
                 fs.startup();
            }
    });
}


function optionsTreeSelectionClicked() {
     var id = this.id;
     require(['dijit/focus','dojo/dom'], function(focusUtil, dom) {
        focusUtil.curNode && focusUtil.curNode.blur();
        dijit.byId(id).loadDropDown();
        setTimeout(function() { dijit.byId(id).openDropDown(); }, 500);
     });
}

function optionsTreeSelectionHovered(id) {
     require(['dijit/focus','dojo/dom'], function(focusUtil, dom) {
        focusUtil.curNode && focusUtil.curNode.blur();
     });      
}



function renderTable(mode) {

    require(['dojo/dom','dojo/query','dojo/store/Memory','dojo/data/ObjectStore','dojo/data/ItemFileWriteStore',
             'dojox/grid/DataGrid'], function(dom, query, Memory, ObjectStore, ItemFileWriteStore, DataGrid) {

        if (mode != 'dialog') { var to_query = '.tableGridParam' } else { var to_query = '.dialog .tableGridParam' }
  
        query(to_query).forEach(function(node, index, arr) {

            var tableId = node.getAttribute('id');
            var id = tableId.replace(/tableGrid_/, '');

	        var fTableN = 'fT_n_' + id;
	        var numT = dom.byId(fTableN).getAttribute('value');
	        
	        var gridLayout = _tableWidgetStorage[numT][0];
	        var width = _tableWidgetStorage[numT][1];
	        var height = _tableWidgetStorage[numT][2];
	        var values = _tableWidgetStorage[numT][3];
		    var types = _tableWidgetStorage[numT][4];
	        var condition = _tableWidgetStorage[numT][5];
		
		    var selectedRow = _tableWidgetStorage[numT][6];

            if (mode == 'dialog' && dijit.byId(id)) { return }

	        var valuesList = values.split('-.-/-.-');

	        var dataO = [];
	        var data = '';
            var data_list = '';

            for (j = 0,k = 1; valuesList != '' && j < valuesList.length; j++,k++) {
	            if (k == '1') { var data = data + '{ '; var data_list = data_list + '{'; }
	            var data = data + "column_" + k + ": '" + valuesList[j] + "'";
	            if (k < width) { 
	                var data = data + ', ';
                        var valuesArray = valuesList[j].split(/ /);
                        if ( valuesList[j] != '' && valuesArray.length == 1) {
                           var data_list = data_list + ' ' + valuesList[j];
                        } else {
                           var data_list = data_list + ' {' + valuesList[j] + '}';
                        }                       

	            } else {
	                var data = data + '}'; 
                        var obj = eval('(' + data + ')');
                        dataO.push(obj);
                        var data = '';
	                var k = '0';
                        var valuesArray = valuesList[j].split(/ /);
                        if ( valuesList[j] != '' && valuesArray.length == 1) {
                           var data_list = data_list + ' ' + valuesList[j];
                        } else {
                           var data_list = data_list + ' {' + valuesList[j] + '}';
                        }
                        var data_list = data_list + ' } ';
	            }
	        }

		    if (valuesList == '') { var data_list = '{ {} }' }
                    
	        var objectStore = new Memory({ data: dataO });
	        
	        if (condition == 'disabled') { 
	            var condition_class = 'tableGridParam disabled'; 
	        } else { 
	            var condition_class = 'tableGridParam';
	        }

            var tGrid = new DataGrid({
                store: ObjectStore({objectStore: objectStore}),
                structure: gridLayout,
                'class': condition_class
            }, tableId);

            tGrid.on('RowClick', function(evt){
		        var pSelection = _tableWidgetStorage[numT][6];
		        var idx = evt.rowIndex.toString();
		
		        if (idx == pSelection) { 
		            tGrid.selection.clear();
		            _tableWidgetStorage[numT][6] = ''; 
                } else {
		            _tableWidgetStorage[numT][6] = idx;
		        }

                var editTBWidget = dijit.byId('editTableRowButton_' + id);
                var removeTBWidget = dijit.byId('removeTableRowButton_' + id);
                  
                var items = this.selection.getSelected();
		        if (items.length) {
		            editTBWidget.set('disabled',false);
		            removeTBWidget.set('disabled',false);
                } else {
		            editTBWidget.set('disabled','disabled');
		            removeTBWidget.set('disabled','disabled');
                }
            });

            tGrid.canSort = function(){return false}; 

            initTable(tableId, data_list);

            tGrid.startup();
            tGrid.render(); 
            tGrid.resize();           
        });   
   });
}


function resizeTable(tableId) {
    require(['dojo/dom', 'dojo/dom-style', 'dojo/query'], function(dom, domStyle, query){
	    var tGrid = dijit.byId(tableId);
    	var height = domStyle.get(tableId, 'height');
	    if (height < '200') {
            domStyle.set(tableId, 'height', '300px');
        } else {
	        domStyle.set(tableId, 'height', '125px');
        }
    	tGrid.resize();
    	tGrid.update();
        if(_db_display == '1') { dbReadjust(); }
    });
}





function initTable (tableId, data_list) {
    require(['dojo/dom'], function(dom){
        var id = tableId.replace(/tableGrid_/, '');
        dom.byId(id).value = data_list;
    });
}


function updateTable (tableId) {

    require(['dojo/ready','dojo/dom'], function(ready, dom){

        var tGrid = dijit.byId(tableId);
        var id = tableId.replace(/tableGrid_/, '');
        
        var fTableN = 'fT_n_' + id;
	    var numT = dom.byId(fTableN).getAttribute('value');
	    var width = _tableWidgetStorage[numT][1];
	    
        var gotItems = function(items, request){
            numRows = items.length;
        };

        tGrid.store.fetch({onComplete: gotItems});
        var data_list = '';
        
        for (i = 0; i < numRows; i++) {
            data_row = tGrid.getItem(i);
            var data_list = data_list + '{';
            for (j = 0; j < width; j++) {
                var cell = tGrid.getCell(j);
                var cellValue = tGrid.store.getValue(data_row, cell.field);
                if ( cellValue != '' ) {
                   var cellValue_array = cellValue.split(/ /);
                   if ( cellValue_array.length == 1 ) {
                        var data_list = data_list + ' ' + cellValue;
                   } else {
                        var data_list = data_list + ' {' + cellValue + '}';
                   }

                } else {
                   var data_list = data_list + ' {' + cellValue + '}';
                }
            }
            var data_list = data_list + ' } ';
        }
        var id = tableId.replace(/tableGrid_/, '');
        dom.byId(id).value = data_list;
        var edit_choose_name = dom.byId('post_key_2').getAttribute('value');
        formUpdate (tableId, data_list, edit_choose_name);
    });
}


function readjustTable() {
    require(['dojo/dom','dojo/query'], function(dom, query){
        query('.tableGridParam').forEach(function(node, index, arr){
            var tableId = node.getAttribute('id');
            var tGrid = dijit.byId(tableId);
            if (typeof tGrid != 'undefined') {
                tGrid.resize();
            } 
        });
    });
}


function addTableRow (tableId) {

    require(['dojo/dom','dojo/on','dojo/_base/xhr','dojo/query','dijit/Dialog',
             'dojo/_base/fx'], function(dom, on, xhr, query, dialog, fx) {

	    query('.tableDialog').forEach(function(node, index, arr){
	        var id = node.getAttribute('id');
            var widget = dijit.byId(id);
            if (widget) { widget.destroyRecursive(); }
	    });

        var id = tableId.replace(/tableGrid_/, '');
        
        var mode = 'fT_mode_' + id;
        dom.byId(mode).setAttribute('value','add');

        var title = 'Add Row';

        xhr.post({
            url: _base_path + '/' + _page + '/form_data/table/' + id,
            form: dom.byId('Form'),
            handleAs: 'text',    
            load: function(data) {

                var ldata = data.split('-*/*-');

		        var dType = ldata[0];
		        var contents = ldata[1];

		        if (dType == 'doc') {

                    var dlg = new dialog({ 
	                    id: 'tableDialog',
		                className: 'tableDialog',
		                executeScripts: true,
		                refreshOnShow: true, 
		                content: contents
	                });

	                dlg.startup(); 

                    query('#tableDialog .dijitDialogTitleBar .dijitDialogTitle').forEach(function(node, index, arr){    
                        var titleBar = "<span class='dijitIconTable'></span><span class='dijitTitleName'>" + title + "</span>";
                        node.innerHTML = titleBar;
                    });

		            on(dom.byId('aB_Table'), 'click', function(){
		                if (dijit.byId('Form_Table').validate()) {
                            addDoTableRow(dlg, tableId);
                        }
	                });

                    on(dom.byId('cB_Table'), 'click', function(){
	                    dlg.hide();
                        dlg.destroyRecursive();
	                });

                    cu_dlgShow(dlg);

                } else if (dType == 'error') {
	                var dlg = dijit.byId('formErrorDialog');
	                dom.byId('errorDialogStatus').innerHTML = contents;

                    query('#formErrorDialog .dijitDialogTitleBar .dijitDialogTitle').forEach(function(node, index, arr){    
                        var titleBar = "<span class='dijitIconTable'></span><span class='dijitTitleName'>" + title + "</span>";
                        node.innerHTML = titleBar;
                    });

		            fx.fadeIn({
                        node: 'formErrorDialog',
                        duration: 200,
                        onEnd: function(){ cu_dlgShow(dlg); }
                    }).play(); 
                }

		        dom.byId(mode).setAttribute('value','');
            }
        });    
    });
}


function addDoTableRow (dlg, tableId) {

    require(['dojo/dom'], function(dom){

        var id = tableId.replace(/tableGrid_/, '');

        var fTableN = 'fT_n_' + id;
	    var numT = dom.byId(fTableN).getAttribute('value');

        var types = _tableWidgetStorage[numT][4].split(',');
    
        var f = dom.byId('Form_Table');
        var s = '';          
        var j = 1;
        for (var i = 0; i < f.elements.length; i++) {
            var elem = f.elements[i];
            if (!elem.name.match(/^p_/)) { continue; }
            if (elem.name == 'button') { continue; }
            if (elem.type == 'radio' && !elem.checked) { continue; }
	        var value = elem.value;
            if (types[j-1] == 'time') {
                var value = value.replace(/^T/, '');
                var valueList = value.split(':');
                valueList.pop();
                var value = valueList.join(':');
            }

            if ( s == '') {
                s += 'column_' + j + '-/:/-' + value;
            } else {
                s += ',' + 'column_' + j + '-/:/-' + value;
            }
            j++;
        }

        var properties = s.split(',');
        var obj = {};
        properties.forEach(function(property) {
            var tup = property.split('-/:/-');
            obj[tup[0]] = tup[1];
        });

        var tGrid = dijit.byId(tableId); 
        var item = tGrid.store.newItem(obj);

        tGrid.store.save();
        updateTable(tableId);

        dlg.hide();
        dijit.byId('tableDialog').destroyRecursive();
        var lastRow = tGrid.rowCount;
        setTimeout(function(){ 
            tGrid.scrollToRow(lastRow);
        }, 300);
    });
}

function editTableRow (tableId) {

    require(['dojo/dom','dojo/on','dojo/_base/xhr','dojo/query','dijit/Dialog',
             'dojo/_base/fx'], function(dom, on, xhr, query, dialog, fx) {

	    query('.tableDialog').forEach(function(node, index, arr){
	        var id = node.getAttribute('id');
            var widget = dijit.byId(id);
            if (widget) { widget.destroyRecursive(); }
	    });

        var id = tableId.replace(/tableGrid_/, '');

        var mode = 'fT_mode_' + id;
        dom.byId(mode).setAttribute('value','edit');

        var title = 'Edit Row';
        
        var tGrid = dijit.byId(tableId);
        var items = tGrid.selection.getSelected();
        
        if (items.length) {
        
            var idxItem = tGrid.selection.selectedIndex;
            var item = tGrid.getItem(idxItem);
            
            var fTableN = 'fT_n_' + id;
	        var numT = dom.byId(fTableN).getAttribute('value');
	        var width = _tableWidgetStorage[numT][1];

            var types = _tableWidgetStorage[numT][4].split(',');

            var data_list = '';
            for (j = 0; j < width; j++) {
                var cell = tGrid.getCell(j);
                var cellValue = tGrid.store.getValue(item, cell.field);
                var cellValue_array = cellValue.split(/ /);
                if ( cellValue_array.length == 1 && cellValue != '') {
                    var data_list = data_list + ' ' + cellValue;
                } else {
                    var data_list = data_list + ' {' + cellValue + '}';
                }
            }

	        var rowValues = 'fT_rowValues_' + id;
            dom.byId(rowValues).setAttribute('value', data_list);

            xhr.post({
                url: _base_path + '/' + _page + '/form_data/table/' + id,
		        form: dom.byId('Form'),
                handleAs: 'text',    
                load: function(data) {

		            var ldata = data.split('-*/*-');

		            var dType = ldata[0];
		            var contents = ldata[1];

		            if (dType == 'doc') {

                        var dlg = new dialog({ 
	                        id: 'tableDialog',
		                    className: 'tableDialog',
		                    executeScripts: true, 
		                    refreshOnShow: true,
		                    content: contents
	                    });
	                    
	                    dlg.startup(); 
	                
	                    query('#tableDialog .dijitDialogTitleBar .dijitDialogTitle').forEach(function(node, index, arr){    
                            var titleBar = "<span class='dijitIconTable'></span><span class='dijitTitleName'>" + title + "</span>";
                            node.innerHTML = titleBar;
                        });

		                on(dom.byId('aB_Table'), 'click', function(){
		                    if (dijit.byId('Form_Table').validate()) {
                                editDoTableRow(dlg, tableId, idxItem);
                            }
	                    });

                        on(dom.byId('cB_Table'), 'click', function(){
	                        dlg.hide();
                            dlg.destroyRecursive();
	                    });

                        cu_dlgShow(dlg);
		
		            } else if (dType == 'error') {
	                    var dlg = dijit.byId('formErrorDialog');
	                    dom.byId('errorDialogStatus').innerHTML = contents;

                        query('#formErrorDialog .dijitDialogTitleBar .dijitDialogTitle').forEach(function(node, index, arr){    
                            var titleBar = "<span class='dijitIconTable'></span><span class='dijitTitleName'>" + title + "</span>";
                            node.innerHTML = titleBar;
                        });

		                fx.fadeIn({
                            node: 'formErrorDialog',
                            duration: 200,
                            onEnd: function(){ cu_dlgShow(dlg); }
                        }).play(); 
                    }
                }
            });  
     
        } else {
            var dlg = dijit.byId('formErrorDialog');
            dom.byId('errorDialogStatus').innerHTML = 'Select row to edit';
		    fx.fadeIn({
                node: 'formErrorDialog',
                duration: 200,
                onEnd: function(){ cu_dlgShow(dlg); }
            }).play();
        }

        dom.byId(mode).setAttribute('value','');
	    dom.byId(rowValues).setAttribute('value','');
    });
}


function editDoTableRow (dlg, tableId, idxItem) {

    require(['dojo/dom'], function(dom){

        var id = tableId.replace(/tableGrid_/, '');

        var fTableN = 'fT_n_' + id;
	    var numT = dom.byId(fTableN).getAttribute('value');

        var types = _tableWidgetStorage[numT][4].split(',');

        var tGrid = dijit.byId(tableId); 
        var item = tGrid.getItem(idxItem);
        var f = dom.byId('Form_Table');     
        var j = 1;
        for (var i = 0; i < f.elements.length; i++) {
            var elem = f.elements[i];
            if (!elem.name.match(/^p_/)) { continue; }
            if (elem.name == 'button') { continue; }
            if (elem.type == 'radio' && !elem.checked) { continue; }
            var value = elem.value;
            if (types[j-1] == 'time') {
                var value = value.replace(/^T/, '');
                var valueList = value.split(':');
                valueList.pop();
                var value = valueList.join(':');
            }
            tGrid.store.setValue(item, 'column_' + j, value);
            j++;
        }

        
        updateTable(tableId);

        dlg.hide();
        dijit.byId('tableDialog').destroyRecursive();
    });
}


function removeTableRow (tableId) {
    require(['dojo/dom','dojo/_base/fx'], function(dom, fx){
        var tGrid = dijit.byId(tableId);
        var items = tGrid.selection.getSelected();
        
        if (items.length) {
            dojo.forEach(items, function(selectedItem){
                if(selectedItem !== null){ tGrid.store.deleteItem(selectedItem); }
            });

            tGrid.store.save();
            updateTable(tableId);
                
        } else {
            var dlg = dijit.byId('formErrorDialog');
            dom.byId('errorDialogStatus').innerHTML = 'Select row to delete';
		    fx.fadeIn({
                node: 'formErrorDialog',
                duration: 200,
                onEnd: function(){ cu_dlgShow(dlg); }
            }).play();
        }
        
        var id = tableId.replace(/tableGrid_/, '');

	    var fTableN = 'fT_n_' + id;
	    var numT = dom.byId(fTableN).getAttribute('value');
	    
        _tableWidgetStorage[numT][6] = '';
        
        var editTBWidget = dijit.byId('editTableRowButton_' + id);
        var removeTBWidget = dijit.byId('removeTableRowButton_' + id);
        editTBWidget.set('disabled','disabled');
		removeTBWidget.set('disabled','disabled');
    });
}


function buttonRespond(id, dDBId) {

    require(['dojo/dom','dojo/dom-style','dojo/io/iframe','dojo/query',
             'dojo/NodeList-traverse'], function(dom, domStyle, ioIframe, query) {

        if (typeof dDBId == 'undefined') {
            dijit.byId(id).set('disabled','disabled');
            var buttonPL = 'buttonPL_' + id;
        } else {
            var buttonPL = 'buttonPL_' + dDBId;
        }
        
        domStyle.set(buttonPL, 'visibility', 'visible');
        
        query('.dialog').forEach(function(node, index, arr){
	        var id = node.getAttribute('id');
            var widget = dijit.byId(id);
            if (widget) { widget.destroyRecursive(); }
	    });

        ioIframe.send({
            url: _base_path + '/' + _page + '/form_data/button/' + id,
            handleAs: 'html',
            preventCache: true,
            form: dom.byId('Form'),
            load: function(data) {

                var ldata = data.body.innerHTML;

                processResponse(ldata);
              
	            if (typeof dDBId == 'undefined') { dijit.byId(id).set('disabled',false); }
	            setTimeout(function(){ domStyle.set(buttonPL, 'visibility', 'hidden'); }, 100);
	        }
        });
    });
}


function dialogRespond(dlg) {

    require(['dojo/dom','dojo/dom-style','dojo/on','dojo/_base/xhr','dojo/query','dijit/Dialog',
             'dojo/_base/fx'], function(dom, domStyle, on, xhr, query, dialog, fx) {

        xhr.post({
            url: _base_path + '/' + _page + '/form_data/dialog/accept',
            handleAs: 'text',
            form: 'Form_Dialog',
            load: function(data) {
                dlg.hide();
                dlg.destroyRecursive();
                processResponse(data);
		    }
        });
    });
}


function processResponse(data) {

    require(['dojo/dom','dojo/ready','dojo/dom-construct','dojo/dom-class','dojo/on','dojo/_base/xhr','dojo/query',
             'dojox/widget/DialogSimple','dojo/_base/fx','dojo/domReady!'], 
             
    function(dom, ready, domConstruct, domClass, on, xhr, query, dialog, fx) {

        var ldata = data.split('-*/*-');

	    var dType = ldata[0];
        var dResponse = ldata[1];
        var dTitle = ldata[2];
        var dClass = ldata[3];

	    if (dType == 'nothing') {
	        if (_db_display) { dbFastUpdate('nCS'); dbReadjust(); }
	                
	    } else if (dType == 'url') {
            window.location.href = _base_path + '/' + dResponse;
            
        } else if (dType == 'file') {
            window.location.href = _base_path + "/form_data/temp_file/" + dResponse;
                    
        } else if (dType == 'doc') {

            if (dClass.match(/^charts/)) {
                var dClass = 'dialogChart';
	            var dIClass = 'dijitIconChart';
	        } else if (dClass.match(/^text/)) {
	            var dClass = 'dialog dialogText';
	            var dIClass = 'dijitIconEditProperty';
	        } else {
	            var dClass = 'dialog';
	            var dIClass = 'dijitIconEditProperty';
	        }

            var dlg = new dialog({ 
	            id: 'dialog',
	            className: dClass,
		        executeScripts: true, 
		        refreshOnShow: true,
		        content: dResponse
	        });

	        dlg.startup();

	        if (!dTitle) { var dTitle = ''; } 

            query('#dialog .dijitDialogTitleBar .dijitDialogTitle').forEach(function(node, index, arr){    
                var titleBar = "<span class='dijitIcon " + dIClass + "'></span><span class='dijitTitleName'>" + dTitle + "</span>";
                node.innerHTML = titleBar;
            });

            ready(function(){  

                dlg.show();

                renderWidgets('dialog');

                var aBWidget = dom.byId('aB_Dialog');
                if (aBWidget) {
	                on(dom.byId('aB_Dialog'), 'click', function(){
		                if (dijit.byId('Form_Dialog').validate()) {
                            dialogRespond(dlg);
                        }
	                });
                }

                var cBWidget = dom.byId('cB_Dialog');
                if (cBWidget) {
                    on(dom.byId('cB_Dialog'), 'click', function() {
                        query('.ganttRowHighlight').forEach(function(node, index, arr) {
                            domConstruct.destroy(node);
                        });
	                    dlg.hide();
                        dlg.destroyRecursive();
	                });
                }
                var handle = dojo.connect(dlg, 'onCancel', function(e) {
                    query('.ganttRowHighlight').forEach(function(node, index, arr) {
                        domConstruct.destroy(node);
                    }); 
                });
	            cu_dlgShow(dlg);
            });
	                
	    } else if (dType == 'error') {
	         var dlg = dijit.byId('formErrorDialog');
	         dom.byId('errorDialogStatus').innerHTML = dResponse;
		     fx.fadeIn({
                node: 'formErrorDialog',
                duration: 200,
                onEnd: function(){ cu_dlgShow(dlg); }
             }).play(); 
                    
	    } else {
             var dResponse = '<div>' + dResponse + '</div>';
	         var dlg = new dialog({ 
	            id: 'dialog',
	            className: 'dialog',
		        executeScripts: true, 
		        refreshOnShow: true,
		        content: dResponse
	         });
               
	         dlg.startup(); 
	         cu_dlgShow(dlg);
	     }    
    });         
}


function renderChart(mode) {

    require(['dojo/dom','dojo/dom-class','dojo/on','dojo/query'], function(dom, domClass, on, query) {

        if (mode != 'dialog') { var to_query = '.chartNode' } else { var to_query = '.dialog .chartNode' }

        query(to_query).forEach(function(node, index, arr) {

            if(!domClass.contains(node, 'inactiveChart')) { 
                tabContainer = dijit.byId('tabContainerForm');
                if (tabContainer) {
                    renderChartTabSelection('dijit_layout_ContentPane_0');
                } else { 
                    renderDoChart(node, mode); 
                }
            }   
        });
    });
}     


function renderChartTabSelection(tabId) {
    require(['dojo/dom','dojo/dom-style','dojo/query','dojo/dom-construct',
             'dojo/dom-class'], function(dom, domStyle, query, domConstruct, domClass) {

        query('#' + tabId + ' .chartNode').forEach(function(node, index, arr) {
            if(!domClass.contains(node, 'renderedChart')) { 
                var chartId = node.getAttribute('id');
                domConstruct.empty(chartId); 
                var chartPL = chartId + '_PL';
                domClass.add(chartPL, 'contentChartPreloader');
                renderDoChart(node, 'page'); 
                domClass.add(node, 'renderedChart');
            }
        });
    });
}                 
                 

function renderDoChart(node, mode) {

    require(['dojo/dom','dojo/dom-style','dojo/query','dojo/dom-construct',
             'dojo/dom-class'], function(dom, domStyle, query, domConstruct, domClass) {

        var chartNode = node;
        var chartId = chartNode.getAttribute('id');

        var chartLegendId = chartId + '_Legend';
        var widgetLegend = dijit.byId(chartLegendId);
        if (widgetLegend) { widgetLegend.destroyRecursive(); }

        var id = chartId.replace(/chart_/, '');
	    var fChartN = 'fC_n_' + id;
	    
	    var chartPL = chartId + '_PL';

	    var numC = dom.byId(fChartN).getAttribute('value');

	    var chartType = _chartWidgetStorage[numC][0];
	    var chartTitle = _chartWidgetStorage[numC][1];
	    var chartXAxisTitle = _chartWidgetStorage[numC][2];
	    var chartYAxisTitle = _chartWidgetStorage[numC][3];
	    var chartRadius = _chartWidgetStorage[numC][4];
	    var chartLabels = _chartWidgetStorage[numC][5];
	    var chartColours = _chartWidgetStorage[numC][6];
        var chartLegend = _chartWidgetStorage[numC][7];
	    var chartDataX = _chartWidgetStorage[numC][8];
	    var chartData = _chartWidgetStorage[numC][9];

        if (chartType != 'Calendar' && !chartData) { 
            raiseChartWarning(id);
	        return  
        }

        hideChartWarning();

        if (chartType == 'Pie') {
        
            domClass.add(chartId, 'Pie');

            domClass.add(chartPL, 'contentChartPreloader');

            var array = [];
            var data = '';
            var chartData = chartData.split('-*/d/*-').reverse();

            var chartColours = chartColours.split(';').reverse(); 
            var chartLabels = chartLabels.split(';').reverse(); 
            
            for (i = 0; i < chartData.length; i++) {
                var data = data + '{ x:1, y:' + chartData[i];
                if  (chartColours != '') {
                    var data = data + ', color:' + '"' + chartColours[i] + '"'; 
                }
                if  (chartLabels != '') {
                    var data = data + ', text:' + '"' + chartLabels[i] + '"';
                    var data = data + ', tooltip:' + '"' + chartData[i] + '"'; 
                }
                var data = data + ' }';
                if (i < chartData.length - 1) {
                    var data = data + '; ';
                }
            }

            var dataArray = new Array();
            var data_ = data.split(';'); 
	        for (var i=0; i<data_.length; i=i+1){
		        var obj = eval('(' + data_[i] + ')');
                dataArray.push(obj);
	        }
		    
	        if (!chartRadius) { _chartRadius = parseInt('120'); } else { _chartRadius = parseInt(chartRadius); }

            require(['dojox/charting/Chart2D','dojox/charting/themes/MiamiNice','dojox/charting/plot2d/Pie',
                     'dojox/charting/action2d/Tooltip','dojox/charting/action2d/Highlight','dojox/charting/action2d/MoveSlice',
                     'dojo/domReady!'], function(Chart, theme, Pie, Tooltip, Highlight, MoveSlice) {

                var pieChart = new Chart(chartId);
                
                theme.chart.fill= 'transparent';
                theme.plotarea.fill = 'transparent';

                pieChart.setTheme(theme);

                pieChart.addPlot('default', {
                    type: 'Pie',
                    font: 'normal normal 12pt Tahoma',
                    radius: _chartRadius,
                    fontColor: '#000',
                    labelOffset: 40
                });

                pieChart.addSeries('chart', dataArray);

                new MoveSlice(pieChart, 'default');
                new Tooltip(pieChart, 'default');

                setTimeout(function() {
                    if (mode == 'dialog') { pieChart.resize('100%', 300) } else { pieChart.resize('100%', 340); }
                    pieChart.render(); 
		            domClass.remove(chartPL, 'contentChartPreloader'); 
                    cu_fadeIn(chartId);
                }, 300);

            });

        } else if (chartType == 'Gantt') {

            var chartData = chartData.split('-*/d/*-'); 

            domClass.add(chartPL, 'contentChartPreloader');

            setTimeout(function(){

                require(['dojo','dojox/gantt/GanttChart', 'dojox/gantt/GanttProjectItem', 
                         'dojox/gantt/GanttTaskItem'], function(dojo, GanttChart, GanttProjectItem, GanttTaskItem){
  
                    var ganttChart = new GanttChart({
                        readOnly: false,          // optional: determine if gantt chart is editable
                        dataFilePath: 'gantt_default.json',    // optional: json data file path for load and save, default is 'gantt_default.json'
                        height: 320,             // optional: chart height in pixel, default is 400px
                        withResource: false      // optional: display the resource chart or not
                    }, chartId);                
                    
		            _chartData = new Array();

                    var j = 1;
                    for (i = 1; i < chartData.length; i = i + 2) {
		                _chartData[j] = chartData[i];
			            var j = j + 1;
                    }

                    for (i = 1; i < _chartData.length; i = i + 1) {
                        var re = /description\s(.*)\sstart_date/;
                        var _description = _chartData[i].match(re);

                        var description = _description[1];
                        if (description.match(/^{/)) { var description = description.replace(/^{/, ''); }
                        if (description.match(/}$/)) { var description = description.replace(/}$/, ''); }
                    
                        var re = /start_date\s(.*)\send_date/;
                        var _start_date = _chartData[i].match(re);
                        var start_date = _start_date[1];
                
                        var s = start_date.split('-');
                        var s_y = s[0];
                        var s_m = s[1];
                        var s_d = s[2];
                    
                        var re = /end_date\s(.*)\splanned_time/;
                        var _end_date = _chartData[i].match(re);
                        var end_date = _end_date[1];
                    
                        var re = /planned_time\s(.*)\sduration_time/;
                        var _planned_time = _chartData[i].match(re);
                        var planned_time = _planned_time[1];
                    
                        var re = /duration_time\s(.*)$/;
                        var _duration_time = _chartData[i].match(re);
                        var duration_time = _duration_time[1]; 

                        var taskvariable = 'task_' + i; 
                        var taskname = 'Task ' + i;
               
                        if ( i == 1 ) {
                
                            var project = new GanttProjectItem({
                                id: 1,
                                name: 'Development Project',
                                startDate: new Date(s[0], s[1], s[2])
                            });
                    
                            var taskvariable = new GanttTaskItem({
                                id: 1,
                                name: description,
                                startTime: new Date(s[0], s[1], s[2]),
                                duration: planned_time,
                                percentage: duration_time,
                                taskOwner: taskname
                            });
                    
                        } else {

                            var taskvariable = new GanttTaskItem({
                                id: i ,
                                name: description,
                                startTime: new Date(s[0], s[1], s[2]),
                                duration: planned_time,
                                percentage: duration_time,
                                previousTaskId: i-1,
                                taskOwner: taskname
                            });
                        }

                        project.addTask(taskvariable);
                    }

                    ganttChart.addProject(project);

                    domClass.remove(chartPL, 'contentChartPreloader'); 

                    ganttChart.init();

                    cu_fadeIn(chartId);

                    require(['dojox/gfx','dojox/gfx/utils'], function(gfx, gfxUtils) {

                        gfxUtils.toSvg(ganttChart.surface).then(
                            function(svg){
                                //alert(svg);
                                //console.info("svg",svg);
                            },
                            function(error){
                                //alert("Error occurred: " + error);
                            }
                        );
                        
                     });
                    
               }, 300);

            }, 0);

        } else if (chartType == 'Calendar') {

            var dataArray = new Array();
            if (chartData != '') {
                var chartData_ = chartData.split(';'); 
		        for (var i=0; i<chartData_.length; i=i+1){
		            if (chartData_[i] != '') { dataArray.push(chartData_[i]); }
		        }
	        }

            require(['dojo/dom','dijit/Calendar','dojo/date','dojo/date/locale','dojo/domReady!'], function(dom, Calendar, date, locale) {

                var chartWidget = dijit.byId(chartId);

                if (chartWidget) { 
                    domConstruct.place(chartNode, chartId, 'replace');
		            chartWidget.destroyRecursive(); 
                    var dataWidget = dijit.byId('chart_calendar_mddb');
                    if (dataWidget) { dataWidget.destroyRecursive() };
                }

                var calendar = new Calendar({
                    value: new Date(),
                    className: 'calendar',
                    isDisabledDate: function(d) {
                        var d = new Date(d); 
                        d.setHours(0, 0, 0, 0);        
                        //if (locale.isWeekend(d)) { return true }
                        for (var i = 0; i < dataArray.length; i = i+1) { 
                            var ddata = locale.parse(dataArray[i], {datePattern: 'yyyy-MM-dd', selector: 'date'});            
                            ddata.setHours(0, 0, 0, 0);
                            if (Math.abs(date.compare(d, ddata, 'date')) == 0) {
                                return true
                            } else if ( i == dataArray.length - 1 ) {
                                return false
                            }
                        }
                    }
                }, chartId);

		        domClass.remove(chartPL, 'contentChartPreloader'); 
			cu_fadeIn(chartId);
            });    

        } else { 
        
            domClass.add(chartPL, 'contentChartPreloader');

	        var chartDataX = chartDataX.split('-*/d/*-'); 
	        var chartData = chartData.split('-*/d/*-'); 

            var _chartData = new Array();

            for (var i = 0; i < chartData.length; i = i + 1) {   
		        var dataX = chartDataX[i].split(';'); 
		        var dataY = chartData[i].split(';');

                _chartData[i] = new Array(); 

                for (j = 0; j < dataX.length; j = j + 1) {
                    dataX[j] = parseFloat(dataX[j]); 
		            dataY[j] = parseFloat(dataY[j]); 

		            _chartData[i][j] = { x: dataX[j], y: dataY[j] };
                }	
            }

            var chartLabels = chartLabels.split(';');
	        var chartLegend = chartLegend.split(';');
	        var chartColours = chartColours.split(';'); 

            if (chartType == 'Lines') {
                var chartPlot = 'Lines';
            } else if (chartType == 'Areas') {
                var chartPlot = 'Areas';
            } else if (chartType == 'Columns') {
                var chartPlot = 'Columns';
            } else if (chartType == 'Markers') {
                var chartPlot = 'MarkersOnly';
            } else {
                var chartPlot = 'Default'; 
            }

            require(['dojox/charting/Chart','dojox/charting/themes/MiamiNice','dojox/charting/plot2d/Lines','dojox/charting/plot2d/Areas',
                     'dojox/charting/plot2d/Columns','dojox/charting/widget/Legend','dojox/charting/action2d/Tooltip',
                     'dojox/charting/action2d/Magnify','dojox/charting/action2d/Highlight','dojox/charting/plot2d/Markers',
                     'dojox/charting/plot2d/MarkersOnly','dojox/charting/axis2d/Default','dojo/domReady!'], 

            function(Chart, theme, Lines, Areas, Columns, Legend, Tooltip, Magnify, Highlight, Markers, MarkersOnly, Default) {
 
                var chart = new Chart(chartId, {title: chartTitle});

                theme.chart.fill= 'transparent';
                theme.plotarea.fill = 'transparent';
 
                chart.setTheme(theme);

                if (chartPlot == 'Columns') {
                    chart.addPlot('default', {
                        type: Columns,
                        markers: true,
                        gap: 5
                    });

                } else {
                    chart.addPlot('default', {
                        type: chartPlot,
                        markers: true
                    });
                }
                
                var labelsFunc = function(text, value, precision){
                        return chartLabels[text];
                    };

                chart.addAxis('x', { 
                    title: chartXAxisTitle, 
                    titleOrientation: 'away',
                    titleFontColor: '#585A4D',
                    minorLabels: false,
                    labelFunc: labelsFunc
                });
 
                chart.addAxis('y', { 
                    title: chartYAxisTitle, 
                    titleOrientation: 'axis', 
                    titleGap: 20, 
                    titleFontColor: '#585A4D', 
                    vertical: true,
                    fixLower: 'major', 
                    fixUpper: 'major' 
                });

                for (var i = 0; i < _chartData.length; i++) {  

		            if (_chartData.length == '1') {

			            if (chartColours[i] && chartColours != '') {
		                    chart.addSeries(chartTitle, _chartData[i], {stroke: chartColours[i], fill: chartColours[i]});
                        } else {
		    	            chart.addSeries(chartTitle, _chartData[i]);
                        }

		            } else {

		    	        if (chartColours[i] && chartColours != '') {
		                    chart.addSeries(chartLegend[i], _chartData[i], {stroke: chartColours[i], fill: chartColours[i]});
                        } else {
		    	            chart.addSeries(chartLegend[i], _chartData[i]);
                        }
		            }
                }

    	        new Tooltip(chart, 'default');
                if (chartPlot == 'Columns') {
                    new Highlight(chart,'default');
                } else {
                    new Magnify(chart, 'default');
                }

                setTimeout(function() {
                    domClass.replace(chartNode, 'activeChart', 'inactiveChart');
		            if (mode == 'dialog') { chart.resize('100%', 300) } else { chart.resize('100%', 340); }
                    chart.render(); 
                    if (_chartData.length > '1') { var legend = new Legend({ chart: chart }, chartLegendId); }
		    domClass.remove(chartPL, 'contentChartPreloader'); 
                    cu_fadeIn(chartId);
                }, 300);
            });
        }  
    });
}


function raiseChartWarning(id) {

    require(['dojo/dom','dojo/query','dojo/dom-construct','dojo/dom-class'], function(dom, query, domConstruct, domClass) {
    
        var activeChartId = 'chart_' + id;
        var activeChartNode = dom.byId(activeChartId);          
        domClass.replace(activeChartNode, 'inactiveChart', 'activeChart');
            
        var activeChartLegendId = activeChartId + '_Legend';
        if (dom.byId(activeChartLegendId)) {
            var activeChartLegendNode = dom.byId(activeChartLegendId);
            var newChartLegendNode = "<div id=" + activeChartLegendId + " class='chartLegend inactiveChart'>";
            domConstruct.place(newChartLegendNode, activeChartLegendNode, 'replace');
        }   
        
        var chartWarningId = 'chart_' + id + '_Warning';
        var chartWarningNode = dom.byId(chartWarningId);
        chartWarningNode.innerHTML = '<div>No data available to render</div>';
        domClass.replace(chartWarningNode, 'activeChartWarning', 'inactiveChartWarning');

	var chartPL = 'chart_' + id + '_PL';
	domClass.remove(chartPL, 'contentChartPreloader'); 

        cu_fadeIn(chartWarningNode);

	_chartWidgetStorage[numC][9] = '';
    });
}


function hideChartWarning() {

    require(['dojo/dom','dojo/query','dojo/dom-class'], function(dom, query, domClass) {

        query('div.inactiveChart').forEach(function(node, index, arr) {	
            var activeChartId = node.getAttribute('id');
            var activeChartNode = dom.byId(activeChartId);          
            domClass.replace(activeChartNode, 'activeChart', 'inactiveChart');
            
            var activeChartLegendId = activeChartId + '_Legend';
            if (dom.byId(activeChartLegendId)) {
                var activeChartLegendNode = dom.byId(activeChartLegendId);
                domClass.replace(activeChartLegendNode, 'activeChart', 'inactiveChart');
            }
        });

        query('div.chartWarning.activeChartWarning').forEach(function(node, index, arr) {	
            var chartWarningNode = node.getAttribute('id');
            domClass.replace(chartWarningNode, 'inactiveChartWarning', 'activeChartWarning');
        });
    });
}




