
function sdbLoad(readAccess, editionAccess, creationAccess, deletionAccess, isAdmin, numRows, titleFields) {

    require(['dojo/ready','dojo/dom','dojo/dom-class','dojo/dom-style','dojo/on','dojox/grid/DataGrid','dojox/data/QueryReadStore',
             'dojo/_base/xhr','dojo/_base/fx','dojo/query','dojo/keys','dojox/grid/cells/dijit','dojox/grid/_CheckBoxSelector'], 
	    
	function(ready, dom, domClass, domStyle, on, DataGrid, QueryReadStore, xhr, fx, query, keys) {

        _toSearch = '';

        var edit_choose_name = dom.byId('post_key_2').getAttribute('value');
        var edit_choose_id = dom.byId('post_key_4').getAttribute('value');

        _read_access = readAccess;
	    _edition_access = editionAccess;
	    _creation_access = creationAccess;
	    _deletion_access = deletionAccess;

        if (_read_access == '0') {

            domStyle.set('formContents', 'opacity', '0');
            dom.byId('formContents').innerHTML = fM_deniedAccessMsg();
            var fadeArgs = {
                node: dom.byId('formContents'),
                duration: 2500
            };
            fx.fadeIn(fadeArgs).play();
            fM_hidePL(); 
                
        } else {

		    var w = dijit.byId('submitButton');
		    if (_edition_access == '0') {
		        if (w) { w.set('disabled','disabled'); }
		        query('div.formContainer').forEach(function(node, index, arr) {  
			        domClass.add(node, 'nEdC');    
                }); 
            } 

		    var w = dijit.byId('dbFormNewButton');
		    if (_creation_access == '0') {
            	if (w) { w.set('disabled','disabled'); }
		    } else {
		        if (w) { w.set('disabled',false); } 
		    }

		    var w = dijit.byId('dbFormDeleteButton');
		    if (_deletion_access == '0') {
            	if (w) { w.set('disabled','disabled'); }
		    } 
		        
		    if (isAdmin == '0') {
		        domStyle.set('sdbAdminLoad', 'display', 'none');
		        domStyle.set('sdbUserLoad', 'display', 'none');
		    } else {
			    dom.byId('sdbLoadControl').innerHTML = '1';
            }
            
            var array_titles = titleFields.split('-*/*-');
                
            _db_columns = array_titles.length;

            if (array_titles.length == 1) {
                var grid_cells = [{name: array_titles[0], editable: 'false', field:'name', width: '100%', formatter: formatData }];
                    
            } else {
		        var grid_cells = [{name: array_titles[0], editable: 'false', field: 'name', width: '200px', formatter: formatData }];       
			    var total_width = '0';
                var j = 2;
                for (var i = 1; i < array_titles.length; i = i + 1){   
                    var name_id = 'name' + j;
                    if (array_titles[i].match(/^--STATUS--/)) {
                        var name = ' ';
                        var width = '30px';
			        } else if (array_titles[i] == 'Date') {
			            var name = "<span class='date'>Date</span>";
                        var width = '100px';
                    } else {
                        var name = array_titles[i];
                        var width = '160px';
                    }
                        
			        var total_width = parseInt(total_width) + parseInt(width);
                    if (i == array_titles.length - 1 && total_width < '600') { var width = '100%'; } 

                    if (i == 1) {
			            grid_cells.push({name: name, editable: 'false', field: name_id, width: width, formatter: formatSRData });
                    } else {
	                    grid_cells.push({name: name, editable: 'false', field: name_id, width: width, formatter: formatData });
                    }
                    var j = j + 1;  
                } 
	        }

		    dataStore = new QueryReadStore({
	            url: _base_path + '/' + _page + '/form_data/database/' + edit_choose_name + '/?',
	            requestMethod: 'post',
	   	        preventCache: true
	        });
		        
           	grid = new DataGrid({
	       	    store: dataStore,
	            query: { query: '*' },
	            rowsPerPage: 100,
	            queryOptions: {ignoreCase: true},
                'class': 'dataStore',
                loadingMessage: "<span class='dojoxGridLoading'>Loading...</span>",
                noDataMessage: "<span class='dojoxGridNoData'>No items in database</span>",
                escapeHTMLInData: false,
                structure: [{type: 'dojox.grid._CheckBoxSelector', width: '3em', left: '0', scroll: true},
                            {cells: grid_cells }]
                        
	   	    }, 'dbLeftGrid');

            grid.on('RowClick', function(evt) {
                evt.stopPropagation();
	       	    var idy = evt.cell.field;
	            var idx = evt.rowIndex;
	            c_item = this.getItem(idx);
	            store = this.store;
	            var v = store.getValue(c_item,'name');
	            if (v.match(/^--BOLD--/)) { var v = v.replace(/--BOLD--/, ''); } 
		        dom.byId('selected_value').setAttribute('value',v);
	            dom.byId('selected_id').setAttribute('value',store.getValue(c_item,'id'));
	            dbSelect();  
	   	    }, true);    

	   	    grid.on('SelectionChanged', function() {
	       	    var c_items = this.selection.getSelected();

	       	    var height = domStyle.get(dojo.byId('dbLeftGrid'), 'height');
	       	    var display_rows = parseInt (parseInt(height) / 24);

                var deleteBWidget = dijit.byId('dbFormDeleteButton');
                var delete2BWidget = dijit.byId('dbFormDeleteButton2');
                var globalBWidget = dijit.byId('dbFormGlobalButton');
                var exportBWidget = dijit.byId('dbFormExportButton');

	            store = this.store;
		   	    var nameSelected = new Array();
		   	    var idSelected = new Array();
		   	        
		   	    if ( !c_items.length ) {
		     	    if (_deletion_access == '1') { 
		     	        deleteBWidget.set('disabled','disabled'); 
		     	        if (delete2BWidget) { delete2BWidget.set('disabled','disabled'); }
		     	    }
                   	exportBWidget.set('disabled','disabled');
		   	        dom.byId('selected_value').setAttribute('value',null);
		   	        dom.byId('selected_id').setAttribute('value',null); 
		   	    }
		   	        
	            dojo.forEach(c_items, function(item) {
		      	    var v = store.getValue(item,'name');
		      	    var id = store.getValue(item,'id');
		      	    
		      	    if (v.match(/split/)) {
		      	        if (deletionAccess == '1') { 
		      	            deleteBWidget.set('disabled','disabled'); 
		      	            if (delete2BWidget) { delete2BWidget.set('disabled','disabled'); }
		      	        }
		      	        exportBWidget.set('disabled','disabled');
                   	    grid.selection.setSelected(grid.selection.selectedIndex, false);
                   	    
                   	} else if (c_items.length > display_rows) {
                   	    grid.selection.setSelected(grid.selection.selectedIndex, false);
                   	    
		      	    } else {
		   	            if (_deletion_access == '1') { 
		   	                deleteBWidget.set('disabled',false); 
		   	                if (delete2BWidget) { delete2BWidget.set('disabled',false); }
		   	            }
                        if (c_items.length < 6) {
                            exportBWidget.set('disabled',false);
                        } else {
                            exportBWidget.set('disabled','disabled');
                        }   
                        nameSelected.push(v);
		                idSelected.push(id);
	       	        }
	       	    });
	       	         
	       	    dom.byId('selected_value').setAttribute('value',nameSelected.toString());
		   	    dom.byId('selected_id').setAttribute('value',idSelected.toString());
		   	    
	   	    }, true);
	   	        
            grid.startup();
            grid.canSort=function() { return false }; 

            if (numRows == '0') {
	            query('#dbLeftGrid .dojoxGridHeader').forEach(function(node, index, arr) {      
                    domStyle.set(node, 'opacity', '0'); 
                });
	        }

            if (edit_choose_id) { 
                _db_view = 'left';
                dbInitSelection(edit_choose_id);
            } else if (creationAccess == '1') {  
                _db_view = 'left';
                dbInit();
            } else {
                _db_view = 'all';
                dbInit();
            }

            ready(function() { 
                on(dijit.byId('database_search'), 'keydown', function(e) {
                    if (e.keyCode == keys.ENTER) {
                        e.preventDefault();
                    }
                });
            });
        }      
    });
}


function dbInit() {

    require(['dojo/dom','dojo/dom-class','dojo/dom-style','dojo/on','dojo/query'], function(dom, domClass, domStyle, on, query) {  

        var grid = dijit.byId('dbLeftGrid');

        domClass.add('dbLeftFormLayer', 'left');

        _widthLayer = domStyle.get('dbLeftFormLayer', 'width');
        _widthDbLayer = domStyle.get('dbLayer', 'width');
	    _widthFormLayer = domStyle.get('dbFormLayer', 'width');
        
        if (_db_view == 'left') {
            if (dom.byId('sdbViewLayer')) {
                domStyle.set('sdbViewLayer', 'display', 'none');
            }
            
        } else if (_db_view == 'none') {
            domClass.replace('dbLeftFormLayer', 'none', 'left');
            
        } else {
            domClass.add('dbExtend', 'hidden');
	        domClass.add('dbHide', 'hidden');
            domClass.replace('dbLeftFormLayer', 'all', 'left');
        }

	    dbReadjust();
        fM_hidePL();

        if (_is_demo == '1') { 
	        if (_is_demo_active == '1' && _demo_form == _page) {
		        showDemoFormDialog('start'); 

	        } else if (_demo_form == _page) {
		        domClass.remove('wizardDisplay', 'hidden');
                on(dom.byId('wizardDisplay'), 'click', function() {
                    showDemoFormDialog('selection');
                });
            }
	    }
	    
	    setTimeout(function() { fM_hidePL(); }, 5000);
    });
}


function dbInitSelection(id_form) {

    require(['dojo/dom','dojo/dom-class','dojo/dom-style','dojo/on'], function(dom, domClass, domStyle, on) {
    
        domClass.add('dbLeftFormLayer', 'left');
        
        _widthLayer = domStyle.get('dbLeftFormLayer', 'width');
        _widthDbLayer = domStyle.get('dbLayer', 'width');
	    _widthFormLayer = domStyle.get('dbFormLayer', 'width');
	    
	    if (dom.byId('sdbViewLayer')) {
            domStyle.set('sdbViewLayer', 'display', 'none');
        }
    
        grid = dijit.byId('dbLeftGrid');
        
        var handle = dojo.connect(grid, '_onFetchComplete', function(e) {
            grid.store.fetchItemByIdentity({
                identity: id_form,
                onItem : function(item, request) {
                    grid.selection.addToSelection(grid.getItemIndex(item));
		            var id = grid.store.getValue(item,'id');
		            var v = grid.store.getValue(item,'name');
		            
		            dom.byId('post_key_1').setAttribute('name', 'edit');
		            
	                dom.byId('selected_id').setAttribute('value', id);
	                dom.byId('selected_value').setAttribute('value', v);
                    
                    dbReadjust();
                    fM_hidePL();

		            if (_is_demo == '1') { 

			            if (_is_demo_active == '1' && _demo_form == _page) {
	        	        
	        	            showDemoFormDialog('start');

					        if (_demo_step == 'step4') {
		    			        wizardStep2FrameSettings();
	            			    wizardStep3FrameSettings();
			                    wizardStep4FrameSettings();
			                    
				            } else {
					            if (_creation_access == '1' && dom.byId('post_key_1').getAttribute('name') == 'edit') {
	        				        dbDoNew('selection');
					            }
					        }

			            } else if (_demo_form == _page) {
				            domClass.remove('wizardDisplay', 'hidden');
                   		    on(dom.byId('wizardDisplay'), 'click', function() {
                       	        showDemoFormDialog('selection');
                   		    });
                        }
	    	        }
	    	        
	    	        var deleteBWidget = dijit.byId('dbFormDeleteButton');
                    var delete2BWidget = dijit.byId('dbFormDeleteButton2');
                    var exportBWidget = dijit.byId('dbFormExportButton');
	    	        
	    	        if (_deletion_access == '1') { 
		   	            deleteBWidget.set('disabled',false); 
		   	            if (delete2BWidget) { delete2BWidget.set('disabled',false); }
		   	        }

                    exportBWidget.set('disabled',false);
                }
            });
            
            dojo.disconnect(handle);
        });
        
        setTimeout(function() { fM_hidePL(); }, 5000);
    });
}


function showDemoFormDialog(mode) {

    require(['dojo/ready','dojo/dom','dojo/dom-class','dojo/dom-style','dojo/on','dojo/_base/xhr','dojo/fx','dojo/fx/easing'], 
    
    function(ready, dom, domClass, domStyle, on, xhr) {

        if (dom.byId('democontents') == null) { return }
        if (_demo_form != _page) { return }
        
        function combineShowIt() {

      	    var moveAnim = dojo.fx.chain([
                dojo.animateProperty({node: 'democontents',
          	    properties: {
            		height: {start: 0, end: 200, unit: 'px'}
          	    },
          	    duration: 1200
                })           
      	    ]);

      	    var combinedAnim = dojo.fx.combine([moveAnim]);

            dojo.connect(combinedAnim, 'onEnd', function() {
		domStyle.set('democontents', 'height', '100%');
                cu_fadeIn('democontents');
                if (dom.byId('wizardClose')) {
                    on(dom.byId('wizardClose'), 'click', function() {
                        hideDemoFormDialog();
	                });
	            }

                if (dom.byId('wizardStartStep1')) {
                    var whandlerS1a = on.pausable(dom.byId('wizardStartStep1'), 'click', function() {
                        whandlerS1a.pause();
	                    wizardStartStep1(whandlerS1a);
	                });
	            }
	            
	            if (dom.byId('wizardAutofillStep1')) {
                    var whandlerS1b = on.pausable(dom.byId('wizardAutofillStep1'), 'click', function() {
			            whandlerS1b.pause();
	                    wizardAutofillStep1(whandlerS1b);
	                });
	            }
            });

      	    combinedAnim.play();
        }

        if (mode == 'start') {
            setTimeout(function() { combineShowIt(); }, 2500);     

        } else {
	        combineShowIt();
            domClass.add('wizardDisplay', 'hidden');
            
            _is_demo_active = '1';

            xhr.post({
		        url: _base_path + '/' + _page + '/demo/enable/?',
		        handleAs: 'text',
		        postData: { 'dummy': 'dummy' },
		        load: function(data) { }         
	        });
        }
    });
}


function hideDemoFormDialog() {

    require(['dojo/ready','dojo/dom','dojo/dom-class','dojo/on','dojo/_base/xhr','dojo/fx','dojo/fx/easing'], 
    
    function(ready, dom, domClass, on, xhr) {

	if (dom.byId('democontents') == null) { return }
        if (_demo_form != _page) { return }

        function combineHideIt() {

            var moveHideAnim = dojo.fx.chain([
                dojo.animateProperty({node: 'democontents',
          	        properties: {
            		    height: {start: 170, end: 0, unit: 'px'}
          	        },
          	        duration: 1500
                })           
      	    ]);

	        var combinedHideAnim = dojo.fx.combine([moveHideAnim]);

	        dojo.connect(combinedHideAnim, 'onBegin', function() {
                cu_fadeQuickOut('democontents');
            });

	        dojo.connect(combinedHideAnim, 'onEnd', function() {
                domClass.remove('wizardDisplay', 'hidden');
                on(dom.byId('wizardDisplay'), 'click', function() {
                    showDemoFormDialog('selection');
                });
            });

            combinedHideAnim.play();
        }

        combineHideIt();
        
        _is_demo_active = '0';
        
        xhr.post({
		    url: _base_path + '/' + _page + '/demo/disable/?',
		    handleAs: 'text',
		    postData: { 'dummy': 'dummy' },
		    load: function(data) { }         
	    });
    });
}


function wizardAutofillStep1(whandlerS1b) {

    require(['dojo/dom','dojo/dom-class'], function(dom, domClass) {

	domClass.remove('demoWizardTStep2', 'selected');
        domClass.remove('demoWizardTStep3', 'selected');
        domClass.remove('demoWizardTStep4', 'selected');

	updateEditMenu();

        if (_creation_access == '1' && dom.byId('post_key_1').getAttribute('name') == 'edit') {
	        dbDoNew('wizardStart', whandlerS1b);
        } else {
            wizardDoAutofillStep1(whandlerS1b);
        }
    });       	    
} 


function wizardDoAutofillStep1(whandlerS1b) {

    require(['dojo/dom','dojo/dom-class','dojo/dom-style','dojo/on','dojo/_base/xhr','dijit/Tooltip'], function(dom, domClass, domStyle, on, xhr, Tooltip) {
        _updating = '1';
        dijit.byId('Form').reset();

        if (dom.byId('managerStatus_image') && dom.byId('managerStatus_text')) {
	    domStyle.set('managerStatus_image', 'display', 'none');
	    domStyle.set('managerStatus_text', 'display', 'none');
	}

        if (domClass.contains('step1Substep1', 'completed')) {
            domClass.remove('step1Substep1', 'completed');
	        domClass.add('step1Substep1', 'selected');
        }
        
        domClass.add('step1Substep1', 'loading');
        domClass.add('demoWizardTStep4', 'denied');

        var wA = new Array();
	    iterFunction = function(widget) {
            wA.push(widget); 
            return;
        }
	        
	    dojo.forEach(dijit.byId('Form').getChildren(), iterFunction);

        var w = wA[0];
        var wId = w.id;

        Tooltip.hide(dom.byId(wId));

        var f = dom.byId('Form');
        if (f.elements.length) {
            xhr.post({
		        url: _base_path + '/' + _page + '/demo/autofill/?',
		        handleAs: 'json',
		        form: dom.byId('Form'),
		        load: function(jsonData) { 

			    _updating = '0';
		            fieldUpdate('', jsonData, _base_path);
                    	    domClass.remove('step1Substep1', 'selected');
	    	            domClass.add('step1Substep1', 'completed');
                            if (dom.byId('wizardSubmitStep1')) {
                                on(dom.byId('wizardSubmitStep1'), 'click', function() {
	                            wizardSubmitStep1();
		                });
	                    } 
	                    domClass.remove('step1Substep1', 'loading');
                            whandlerS1b.resume();
		        }         
	        });
	        
	    } else {
	        whandlerS1b.resume();
        }
    });
}


function wizardStartStep1(whandlerS1a) {

    require(['dojo/dom','dojo/dom-class'], function(dom, domClass) {
    
        domClass.remove('demoWizardTStep2', 'selected');
        domClass.remove('demoWizardTStep3', 'selected');
        domClass.remove('demoWizardTStep4', 'selected');

	updateEditMenu();

        if (_creation_access == '1' && dom.byId('post_key_1').getAttribute('name') == 'edit') {
	        dbDoNew('wizardStart', whandlerS1a);
        } else {
            wizardDoStartStep1(whandlerS1a);
        }
    });       	    
}    


function wizardDoStartStep1(whandlerS1a) {

    require(['dojo/dom','dojo/dom-class','dojo/dom-style','dojo/on','dijit/Tooltip','dojox/fx/scroll','dojo/fx','dojo/fx/easing'], 

    function(dom, domClass, domStyle, on, Tooltip) {

        dijit.byId('Form').reset();

        if (dom.byId('managerStatus_image') && dom.byId('managerStatus_text')) {
	    domStyle.set('managerStatus_image', 'display', 'none');
	    domStyle.set('managerStatus_text', 'display', 'none');
	}

        if (domClass.contains('step1Substep1', 'completed')) {
            domClass.remove('step1Substep1', 'completed');
	        domClass.add('step1Substep1', 'selected');
        }
        
        domClass.add('demoWizardTStep4', 'denied');
    
        var wA = new Array();
	    iterFunction = function(widget) {
            wA.push(widget); 
            return;
        }
	        
	    dojo.forEach(dijit.byId('Form').getChildren(), iterFunction);

	    var w = wA[0];
        var wId = w.id;

        dojox.fx.smoothScroll({
            node: 'contents',
            win: window,
            duration: 800
        }).play();

        if (_creation_access == '1') {
            var label = 'Start filling in the form !';
            setTimeout(function() { Tooltip.show(label,dom.byId(wId),['before']); }, 1000);
        }

        on(dom.byId(wId), 'click', function() {
	        Tooltip.hide(dom.byId(wId));
	    });

        on(dom.byId(wId), 'keyup', function() {
	        Tooltip.hide(dom.byId(wId));
	    });

        on(dom.byId(wId), 'blur', function() {
	        Tooltip.hide(dom.byId(wId));
	    });

        w.focus();

        whandlerS1a.resume();
    });       	    
}

function wizardSubmitStep1() {

    require(['dojo/dom','dojo/on','dijit/Tooltip','dojox/fx/scroll','dojo/fx','dojo/fx/easing'], function(dom, on, Tooltip) {

        dojox.fx.smoothScroll({
            node: 'submitButton',
            win: window,
            duration: 1000
        }).play();

        var label = 'Submit the form !';
        setTimeout(function() { Tooltip.show(label,dom.byId('submitButtonLayer'),['after']); }, 1000);

        on(dom.byId('submitButton'), 'click', function() {
	        Tooltip.hide(dom.byId('submitButtonLayer'));
	    });
    });
}


function wizardGoStep2() {

    require(['dojo/dom','dojo/dom-class','dojo/on','dijit/Tooltip','dojox/fx/scroll','dojo/fx','dojo/fx/easing'], 

    function(dom, domClass, on, Tooltip) {
    
        _demo_step = 'step2';

        domClass.replace('demoWizardTStep1', 'done', 'selected');
	    domClass.replace('demoWizardTStep2', 'selected', 'disabled');

        domClass.add('demoWizardContentsStep1', 'hidden');
	    domClass.remove('demoWizardContentsStep2', 'hidden');

        setTimeout(function() { 
            dojox.fx.smoothScroll({
               node: 'editmenu',
               win: window,
               duration: 1500,
               onEnd: function() { cu_fadeIn('demoWizardContentsStep2'); }
            }).play();
        }, 1000);

        wizardStep2FrameSettings();
    });
}


function wizardGoStep4b() {
    require(['dojo/dom','dojo/dom-class','dojo/on','dijit/Tooltip','dojox/fx/scroll','dojo/fx','dojo/fx/easing'], 

    function(dom, domClass, on, Tooltip) {
    
        domClass.add('demoWizardContentsStep4Substep1', 'hidden');
	    domClass.remove('demoWizardContentsStep4Substep2', 'hidden');

        setTimeout(function() { 
            dojox.fx.smoothScroll({
                node: 'editmenu',
                win: window,
                duration: 1500,
                onEnd: function() { 
                    cu_fadeIn('demoWizardContentsStep4Substep2'); 
                }
            }).play();
        }, 1000);
    });
}


function wizardAutosubmitStep2() {

    require(['dojo/dom','dojo/dom-class','dojo/dom-style','dojo/_base/xhr'], function(dom, domClass, domStyle, xhr) {

        var edit_choose_id = dom.byId('post_key_4').getAttribute('value');

        domClass.add('wizardAutosubmitStep2', 'disabled');

        xhr.post({
            url: _base_path + '/' + _page + '/demo/autosubmit/?',
	        handleAs: 'text',
	        preventCache: true,
	        postData: { 'edit_choose_id': edit_choose_id },
	        load: function(data) {
                if (data == 'ERROR') {
                    domClass.remove('wizardAutosubmitStep2', 'disabled');
		            var msgError = 'An error occurred when autosubmitting the form';
                    ShowDialogError(msgError);
                } else {
		            domStyle.set('wizardNotifStep3a', 'opacity', '0');
		            wizardGoStep3();
                }
            }
        });
    });
}


function wizardGoStep3() {

    require(['dojo/dom','dojo/dom-class','dojo/on','dijit/Tooltip','dojox/fx/scroll','dojo/fx','dojo/fx/easing'], function(dom, domClass, on, Tooltip) {
    
        _demo_step = 'step3';

        domClass.replace('demoWizardTStep2', 'done', 'selected');
	    domClass.replace('demoWizardTStep3', 'selected', 'disabled');

        domClass.add('demoWizardContentsStep2', 'hidden');
	    domClass.remove('demoWizardContentsStep3', 'hidden');

        cu_fadeIn('demoWizardContentsStep3');
        
        wizardStep3FrameSettings();

	    domClass.remove('wizardAutosubmitStep2', 'disabled');

        updateEditMenu();  
        
		setTimeout(function() { 
		    dojox.fx.smoothScroll({
                node: 'editmenu',
                win: window,
                duration: 1000,
                onEnd: function() { 
			        cu_fadeIn('wizardNotifStep3a');
				    domClass.add('notifications_menu_num', 'blink');
                    var label = 'Click here !';
		    	    Tooltip.show(label, dom.byId('notifications-nav'),['before']);
                }
            }).play();    
	    }, 1000);     
    });
}


function wizardStep2FrameSettings() {

    require(['dojo/dom','dojo/dom-class','dojo/on','dojo/_base/xhr'], function(dom, domClass, on, xhr) {
    
         on(dom.byId('demoWizardTStep1'), 'click', function() {
	        domClass.replace('demoWizardTStep1', 'selected', 'done');
	        domClass.replace('demoWizardTStep2', 'disabled selected', 'selected');

            domClass.remove('demoWizardContentsStep1', 'hidden');
	        domClass.add('demoWizardContentsStep2', 'hidden');

	        cu_fadeQuickOut('demoWizardContentsStep2');
            cu_fadeIn('demoWizardContentsStep1');
            
            _demo_step = 'step1';

            xhr.post({
		        url: _base_path + '/' + _page + '/demo/update/?',
		        handleAs: 'text',
		        postData: { 'step': 'step1' },
		        load: function(data) { }         
	        });
        });

        on(dom.byId('demoWizardTStep2'), 'click', function() {
	        domClass.replace('demoWizardTStep1', 'done', 'selected');
            domClass.replace('demoWizardTStep2', 'selected', 'disabled selected');

            domClass.add('demoWizardContentsStep1', 'hidden');
	        domClass.remove('demoWizardContentsStep2', 'hidden');

	        cu_fadeQuickOut('demoWizardContentsStep1');
            cu_fadeIn('demoWizardContentsStep2');
            
            _demo_step = 'step2';
            
            xhr.post({
		        url: _base_path + '/' + _page + '/demo/update/?',
		        handleAs: 'text',
		        postData: { 'step': 'step2' },
		        load: function(data) { }         
	        });
        });

	    if (dom.byId('wizardAutosubmitStep2')) {
            on(dom.byId('wizardAutosubmitStep2'), 'click', function() {
	            wizardAutosubmitStep2();
            });
        }
    });
}


function wizardStep3FrameSettings() {

    require(['dojo/dom','dojo/dom-class','dojo/on','dojo/_base/xhr'], function(dom, domClass, on, xhr) {

        on(dom.byId('demoWizardTStep1'), 'click', function() {
	        domClass.replace('demoWizardTStep2', 'disabled selected', 'done');
	        domClass.replace('demoWizardTStep3', 'disabled selected', 'selected');

	        domClass.add('demoWizardContentsStep3', 'hidden');

            cu_fadeQuickOut('demoWizardContentsStep3');
        });

        on(dom.byId('demoWizardTStep2'), 'click', function() {
	        domClass.replace('demoWizardTStep2', 'selected', 'done');
	        domClass.replace('demoWizardTStep3', 'disabled selected', 'selected');
	        
	        domClass.add('demoWizardContentsStep3', 'hidden');

            cu_fadeQuickOut('demoWizardContentsStep3');
        });

        on(dom.byId('demoWizardTStep3'), 'click', function() {
	        domClass.replace('demoWizardTStep1', 'done', 'selected');
	        domClass.replace('demoWizardTStep2', 'done', 'selected');
	        domClass.replace('demoWizardTStep2', 'done', 'disabled selected');
	        domClass.replace('demoWizardTStep3', 'selected', 'disabled selected');

            domClass.add('demoWizardContentsStep1', 'hidden');
	        domClass.add('demoWizardContentsStep2', 'hidden');
            domClass.remove('demoWizardContentsStep3', 'hidden');
            
            cu_fadeQuickOut('demoWizardContentsStep1');
            cu_fadeQuickOut('demoWizardContentsStep2');
            cu_fadeIn('demoWizardContentsStep3');
            
            _demo_step = 'step3';
            
            xhr.post({
		        url: _base_path + '/' + _page + '/demo/update/?',
		        handleAs: 'text',
		        postData: { 'step': 'step3' },
		        load: function(data) { }         
	        });
        });
    });
}


function wizardStep4FrameSettings() {

    require(['dojo/dom','dojo/dom-class','dojo/on','dojo/_base/xhr'], function(dom, domClass, on, xhr) {

	    on(dom.byId('demoWizardTStep1'), 'click', function() {
	        domClass.replace('demoWizardTStep3', 'disabled', 'done');
	        domClass.replace('demoWizardTStep4', 'disabled selected', 'selected');
	        
		domClass.remove('demoWizardTStep2', 'selected');
	        domClass.remove('demoWizardTStep3', 'selected');

	        domClass.add('demoWizardTStep2', 'denied');
	        domClass.add('demoWizardTStep3', 'denied');

	        domClass.add('demoWizardContentsStep4', 'hidden');

            cu_fadeQuickOut('demoWizardContentsStep4');
        });

        on(dom.byId('demoWizardTStep4'), 'click', function() {
            domClass.replace('demoWizardTStep1', 'done', 'selected');
            domClass.replace('demoWizardTStep2', 'disabled done', 'disabled selected');
            domClass.replace('demoWizardTStep3', 'disabled done', 'disabled selected');  
            domClass.replace('demoWizardTStep4', 'selected', 'disabled selected');
            
            domClass.remove('demoWizardTStep2', 'denied');
	        domClass.remove('demoWizardTStep3', 'denied');
            
            domClass.add('demoWizardContentsStep1', 'hidden');
	        domClass.add('demoWizardContentsStep2', 'hidden');
            domClass.add('demoWizardContentsStep3', 'hidden');
            domClass.remove('demoWizardContentsStep4', 'hidden');
            
	        cu_fadeQuickOut('demoWizardContentsStep1');
            cu_fadeQuickOut('demoWizardContentsStep2');
            cu_fadeQuickOut('demoWizardContentsStep3');
            cu_fadeIn('demoWizardContentsStep4');
            
            _demo_step = 'step4';
            
            xhr.post({
		        url: _base_path + '/' + _page + '/demo/update/?',
		        handleAs: 'text',
		        postData: { 'step': 'step4' },
		        load: function(data) { }         
	        });
        });
        
        if (dom.byId('wizardSubmitStep4')) {
            on(dom.byId('wizardSubmitStep4'), 'click', function() {
	            wizardSubmitStep4();
            });
        }
    });
}

function wizardSubmitStep4() {

    require(['dojo/dom','dojo/dom-class','dojo/on','dijit/Tooltip','dojox/fx/scroll','dojo/fx','dojo/fx/easing'], 

    function(dom, domClass, on, Tooltip) {
    
        var w = dijit.byId('status_complete');
        var wId = w.id;
        
        dojox.fx.smoothScroll({
            node: 'status_complete',
            win: window,
            duration: 800
        }).play();
        
        var label = 'Close the form !';
        
        if (w.type == 'checkbox') {               
            var checked = w.get('checked');
            if (!checked) {
	            setTimeout(function() { Tooltip.show(label,dom.byId(wId),['below']); }, 1000);
	            
	        } else {
	            dojox.fx.smoothScroll({
                    node: 'submitButton',
                    win: window,
                    duration: 800
                }).play();

                var label = 'Submit the form !';
                setTimeout(function() { Tooltip.show(label,dom.byId('submitButtonLayer'),['after']); }, 1000);

                on(dom.byId('submitButton'), 'click', function() {
	                Tooltip.hide(dom.byId('submitButtonLayer'));
	            });
	        } 
		}

        on(dom.byId(wId), 'click', function() {
	        Tooltip.hide(dom.byId(wId));
	        
	        dojox.fx.smoothScroll({
                node: 'submitButton',
                win: window,
                duration: 800
            }).play();

            var label = 'Submit the form !';
            setTimeout(function() { Tooltip.show(label,dom.byId('submitButtonLayer'),['after']); }, 1000);

            on(dom.byId('submitButton'), 'click', function() {
	            Tooltip.hide(dom.byId('submitButtonLayer'));
	        });
	    });   
    });
}


function sdbAdminControlLoad(mode) {

    require(['dojo/dom','dojo/dom-style','dojo/query','dijit/Tooltip'], function(dom, domStyle, query, Tooltip) {

        var grid = dijit.byId('dbLeftGrid');

        if (mode == '1') {
            dom.byId('sdbLoadControl').innerHTML = '1';
            domStyle.set('sdbAdminLoad', 'display', 'none');
            domStyle.set('sdbUserLoad', 'display', '');
        } else {
            dom.byId('sdbLoadControl').innerHTML = '0';
            domStyle.set('sdbUserLoad', 'display', 'none');
            domStyle.set('sdbAdminLoad', 'display', '');
        }

        dijit.byId('database_search').reset();

        var edit_choose_name = dom.byId('post_key_2').getAttribute('value');

        query('#dbLeftGrid .dojoxGridHeader').forEach(function(node, index, arr) {      
            domStyle.set(node, 'opacity', '0'); 
        });

        query('#dbLeftGrid .dojoxGridScrollbox').forEach(function(node, index, arr) {      
            domStyle.set(node, 'display', 'none'); 
        });

        loadingMessage = "<span class='dojoxGridLoading'>Loading...</span>";
        grid.showMessage(loadingMessage);
    
        sdbDoAdminControlLoad(edit_choose_name, mode); 
    }); 
}


function sdbDoAdminControlLoad(edit_choose_name, mode) {

    require(['dojo/dom','dojo/dom-style','dojox/grid/DataGrid','dojox/data/QueryReadStore','dojo/_base/xhr',
             'dojo/query','dojox/grid/cells/dijit','dojox/grid/_CheckBoxSelector'],

    function(dom, domStyle, DataGrid, QueryReadStore, xhr, query) {

        var grid = dijit.byId('dbLeftGrid');

        grid.setQuery({ consider_admin: mode });
        dataStore = new QueryReadStore({
            url: _base_path + '/' + _page + '/form_data/database/' + edit_choose_name + '/?',
	        requestMethod: 'post'  
        });

        var handle = dojo.connect(grid, '_onFetchBegin', function(total) {
            var numRows = total;
            if (numRows != '0') {   
                query('#dbLeftGrid .dojoxGridHeader').forEach(function(node, index, arr) {      
                    domStyle.set(node, 'opacity', '1'); 
                });

            } else {
                var noDataMessage = "<span class='dojoxGridNoData'>No items in database</span>";
                grid.showMessage(noDataMessage);
            }

            query('.dojoxGridScrollbox').forEach(function(node, index, arr) {      
                domStyle.set(node, 'display', ''); 
            }); 

            dojo.disconnect(handle);
        });
    });
}


function formatData(name) {
     if (name && name.match(/^--BOLD--/)) {
         var name = name.replace(/--BOLD--/, '');
         var name = "<b class='" + name + "'>" + name + "</b>";
         
     } else if (name && name.match(/^--STATUS--/)) {
         var name = name.replace(/--STATUS--/, '');
         if (name == 'new') { var name = "<img width='20' src='" + _base_path + "/int/js/custom/images/status/p0.png'/>" }
         if (name == 'pending') { var name = "<img width='20' src='" + _base_path + "/int/js/custom/images/status/p2.png'/>" }
         if (name == 'validated') { var name = "<img width='20' src='" + _base_path + "/int/js/custom/images/status/p8.png'/>" }
         if (name == 'rejected') { var name = "<img width='20' src='" + _base_path + "/int/js/custom/images/status/p9.png'/>" }
         if (name == 'completed') { var name = "<img width='21' src='" + _base_path + "/int/js/custom/images/status/p10_b.png'/>" }
         
     } else if (name && name.match(/^--DATE--/)) {
         var name = name.replace(/--DATE--/, '');
         var name = "<span class='date'>" + name + "</span>";
     }

     return "<span class='data'>" + name + "</span>";
}


function formatSRData(name) {
     if (name && name.match(/^--BOLD--/)) {
         var name = name.replace(/--BOLD--/, '');
         var name = "<b class='" + name + "'>" + name + "</b>";
         
     } else if (name && name.match(/^--STATUS--/)) {
         var name = name.replace(/--STATUS--/, '');
         if (name == 'new') { var name = "<img width='20' src='" + _base_path + "/int/js/custom/images/status/p0.png'/>" }
         if (name == 'pending') { var name = "<img width='20' src='" + _base_path + "/int/js/custom/images/status/p2.png'/>" }
         if (name == 'validated') { var name = "<img width='20' src='" + _base_path + "/int/js/custom/images/status/p8.png'/>" }
         if (name == 'rejected') { var name = "<img width='20' src='" + _base_path + "/int/js/custom/images/status/p9.png'/>" }
         if (name == 'completed') { var name = "<img width='21' src='" + _base_path + "/int/js/custom/images/status/p10_b.png'/>" }
         
     } else if (name && name.match(/^--DATE--/)) {
         var name = name.replace(/--DATE--/, '');
         var name = "<span class='date'>" + name + "</span>";
     }
     
     return "<span class='data' style='padding-left: 35px'>" + name + "</span>";
}


function dbUpdate() {

    require(['dojo/dom','dojo/dom-style','dojo/query'], function(dom, domStyle, query) {
        _toSearch = '_update';
	    var edit_choose_name = dom.byId('post_key_2').getAttribute('value');
            dbDoSearch (edit_choose_name);
    });
}


function dbFastUpdate(mode) {

    require(['dojo/dom','dojo/dom-style','dojox/grid/DataGrid','dojox/data/QueryReadStore','dojo/_base/xhr',
             'dojo/query','dojox/grid/cells/dijit','dojox/grid/_CheckBoxSelector'],

    function(dom, domStyle, DataGrid, QueryReadStore, xhr, query) {

        clearTimeout(this._timeout); 
        
        var grid = dijit.byId('dbLeftGrid');
        
        if (mode == 'nCS') {
            var id = grid.selection.selectedIndex;
            var idx = parseInt(id);
        }
        
        var edit_choose_name = dom.byId('post_key_2').getAttribute('value');

        dijit.byId('database_search').set('value', '');
        
        grid.setQuery({query: '*'});
        dataStore = new QueryReadStore({
            url: _base_path + '/' + _page + '/form_data/database/' + edit_choose_name + '/?',
	        requestMethod: 'post'  
        });
                
        if (mode == 'nCS') { 
            var handle = dojo.connect(grid, '_onFetchComplete', function() {
                grid.selection.clear();
                grid.selection.addToSelection(idx);
            });
        }

        query('#dbLeftGrid .dojoxGridHeader').forEach(function(node, index, arr) {      
            domStyle.set(node, 'opacity', '1'); 
        });

        query('.dojoxGridScrollbox').forEach(function(node, index, arr) {      
            domStyle.set(node, 'display', ''); 
        });
    });
}


function gridShowMessage() {

    require(['dojo/dom','dojo/query','dojo/dom-style'], function(dom, query, domStyle) {

	    var grid = dijit.byId('dbLeftGrid');

        var loadingMessage = "<span class='dojoxGridLoading'>Loading...</span>";
        grid.showMessage(loadingMessage);

        query('#dbLeftGrid .dojoxGridMasterMessages').forEach(function(node, index, arr) { 
            domStyle.set(node, 'display', ''); 
        });
    });
}


function gridHideMessage() {

    require(['dojo/dom','dojo/query','dojo/dom-style'], function(dom, query, domStyle) {

        query('#dbLeftGrid .dojoxGridMasterMessages').forEach(function(node, index, arr) { 
            domStyle.set(node, 'display', 'none'); 
        });
    });
}


function dbExtendAction() {

    require(['dojo/ready','dojo/dom','dojo/dom-class','dojo/dom-style','dojo/fx','dojo/fx/easing'], function(ready, dom, domClass, domStyle) {
    
        ready(function() {

            _db_view = 'all';

	        var grid = dijit.byId('dbLeftGrid');     

	        function combineIt() {

      		    var displayAnim = dojo.fx.chain([
        	        dojo.fadeOut({node: 'dbFormLayer', duration: 10})
      		    ]);

      		    var moveAnim = dojo.fx.chain([
                    dojo.animateProperty({node: 'dbFormLayer',
          		        properties: {
            		        width: {start: _widthFormLayer, end: 0, unit: 'px'}
          		        },
          		        duration: 100
        	        }), 
        	        dojo.animateProperty({node: 'dbLayer',
          		        properties: {
            		        width: {start: _widthDbLayer, end: _widthLayer, unit: 'px'}
          		        },
          		        duration: 1000
        	        })               
      		    ]);

      		    var combinedAnim = dojo.fx.combine([moveAnim, displayAnim]);

                var handle = dojo.connect(combinedAnim, 'onBegin', function() {
		            dom.byId('dbExtend').setAttribute('onClick', 'dbShrinkAction()');
            	    dom.byId('actiondbExtendIcon').setAttribute('src', _base_path + '/int/js/custom/images/back_b.png'); 

                    if (grid.rowCount > 0) { gridShowMessage(); }
                });
 
                var handle = dojo.connect(combinedAnim, 'onEnd', function() {
                    grid.resize();  
                    
            	    if (grid.rowCount > 0) { gridHideMessage(); }

                    if (dom.byId('sdbViewLayer')) {
                	    domStyle.set('sdbViewLayer', 'display', '');
            	    }

		            domClass.remove('dbLeftFormLayer', 'left');
            	    domClass.add('dbLeftFormLayer', 'all');
            	});

      		    combinedAnim.play();
            }

	        combineIt();

	        if (dom.byId('dbFormGlobalButton')) {
                domStyle.set('dbFormDeleteButton', 'display', '');
                domStyle.set('dbFormDeleteButton2', 'visibility', 'hidden');
	        }
        });
    });
}


function dbShrinkAction() {

    require(['dojo/ready','dojo/dom','dojo/dom-class','dojo/dom-style','dojo/query','dojo/fx','dojo/fx/easing'], 
    
    function(ready, dom, domClass, domStyle, query) {
    
        ready(function() {

            _db_view = 'left';

            if (dom.byId('sdbViewLayer')) {
                domStyle.set('sdbViewLayer', 'display', 'none');
            }

	        var grid = dijit.byId('dbLeftGrid');    

	        function combineIt() {

      		    var moveAnim = dojo.fx.chain([
        	        dojo.animateProperty({node: 'dbLayer',
          		        properties: {
            		        width: {start: _widthLayer, end: _widthDbLayer, unit: 'px'}
          		        },
          		        duration: 700
        	        }),
		            dojo.animateProperty({node: 'dbFormLayer',
          	    	    properties: {
               		        width: {start: 0, end: _widthFormLayer, unit: 'px'}
          		        },
          		        duration: 10
        	        })
      		    ]);

      		    var combinedAnim = dojo.fx.combine([moveAnim]);

                var handle = dojo.connect(combinedAnim, 'onBegin', function() {
                    
                    if (dom.byId('sdbViewLayer')) {
                	    domStyle.set('sdbViewLayer', 'display', 'none');
            	    }
                    dom.byId('dbExtend').setAttribute('onClick', 'dbExtendAction()');
            	    dom.byId('actiondbExtendIcon').setAttribute('src', _base_path + '/int/js/custom/images/next_b.png');

            	    domStyle.set('actiondbExtendIcon', 'display', 'block');
            	    domStyle.set('actiondbHideIcon', 'display', '');
                });

		        var handle = dojo.connect(combinedAnim, 'onEnd', function() {
		            grid.resize();  

		            cu_fadeIn('dbFormLayer');  

		            domClass.remove('dbLeftFormLayer', 'all');
            	    domClass.add('dbLeftFormLayer', 'left');

                    query('table.sLpC input.dijitFileInputReal').forEach(function(node, index, arr) { 
                        node.setAttribute('size','1'); 
                    });

                    readjustTable();   
            	});

      		    combinedAnim.play();
            }

	        combineIt();
	        
	        domClass.remove('dbExtend', 'hidden');

            if (dom.byId('dbFormGlobalButton')) {
            	domStyle.set('dbFormDeleteButton', 'display', 'none');
            	domStyle.set('dbFormDeleteButton2', 'visibility', 'visible');
	        }
        });
    });
} 


function dbHideAction() {

    require(['dojo/ready','dojo/dom','dojo/dom-class','dojo/dom-style','dojo/query','dijit/Tooltip','dojox/fx/scroll','dojo/fx','dojo/fx/easing'], 
    
    function(ready, dom, domClass, domStyle, query, Tooltip) {
    
        ready(function() {
        
            _db_view = 'none';

	        var grid = dijit.byId('dbLeftGrid');  

            _width_p_DbLayer = domStyle.get('dbLayer', 'width');
	        _width_p_FormLayer = domStyle.get('dbFormLayer', 'width');

	        function combineIt() {

	            if (_width_p_FormLayer == '0') {
                    var displayAnim = dojo.fx.chain([
        	    	    dojo.fadeOut({node: 'dbLayer', duration: 1200})
      		        ]);
                } else {
		            var displayAnim = dojo.fx.chain([
        	    	    dojo.fadeOut({node: 'dbLayer', duration: 500})
      		        ]);
                }

      		    var moveAnim = dojo.fx.chain([
        	        dojo.animateProperty({node: 'dbLayer',
          		        properties: {
            		        width: {start: _width_p_DbLayer, end: 0, unit: 'px'}
          		        },
          		        duration: 800
        	        }),
		            dojo.animateProperty({node: 'dbFormLayer',
          	    	    properties: {
               		        width: {start: _width_p_FormLayer, end: _widthLayer, unit: 'px'}
          		        },
          		        duration: 800
        	        })
      		    ]);

      		    var combinedAnim = dojo.fx.combine([moveAnim, displayAnim]);

                var handle = dojo.connect(combinedAnim, 'onBegin', function() {
                    if (dom.byId('sdbViewLayer')) {
                	    domStyle.set('sdbViewLayer', 'display', 'none');
            	    }
                });

		        var handle = dojo.connect(combinedAnim, 'onEnd', function() {
		            if (_width_p_FormLayer == '0') {
		                cu_fadeIn('dbFormLayer');
		                domClass.remove('dbLeftFormLayer', 'all');
                    } else {
			            domClass.remove('dbLeftFormLayer', 'left');
                    }
            	    domClass.add('dbLeftFormLayer', 'none');

                    domStyle.set('dbShow', 'visibility', 'visible');

            	    var dbtooltip = dijit.byId('udbShow');
            	    if (dbtooltip) { 
                	    var label = 'Display database';
                	    dojox.fx.smoothScroll({
                    	    node: 'dbShow',
                    	    win: window,
                    	    duration: 800
                	    }).play(); 
                
                	    setTimeout(function() { Tooltip.show(label,'dbShow_img',['below']); }, 500);
                	    setTimeout(function() { Tooltip.hide('dbShow_img'); }, 5000); 
            	    }
            	});

                var handle = dojo.connect(combinedAnim, 'onPlay', function() {
                    setTimeout(function() { 
                        query('table.formContainer.sLpC' ).forEach(function(node, index, arr) { 
            	            domClass.replace(node, 'sLpCe', 'sLpC');
                        });
                        query('table.sLpC input.dijitFileInputReal' ).forEach(function(node, index, arr) { 
                            node.setAttribute('size','9'); 
                        });
                        
                    }, 1000); 
                });

                var handle = dojo.connect(combinedAnim, 'onEnd', function() {
                    readjustTable();
                });

      		    combinedAnim.play();
            }

	        combineIt();
        });
    });
}      


function dbShowAction() {

    require(['dojo/ready','dojo/dom','dojo/dom-class','dojo/dom-style','dojo/query','dijit/Tooltip','dojox/fx/scroll','dojo/fx','dojo/fx/easing'], 
    
    function(ready, dom, domClass, domStyle, query, Tooltip) {
    
        ready(function() {
        
	        if ( _width_p_FormLayer > 0 ) {
                _db_view = 'left';
            } else {
		        _db_view = 'all';
            }
        
            var grid = dijit.byId('dbLeftGrid');  

	        function combineIt() {

		        var displayAnim = dojo.fx.chain([
        	        dojo.fadeOut({node: 'dbFormLayer', duration: 800})
      		    ]);

      		    var moveAnim = dojo.fx.chain([
        	        dojo.animateProperty({node: 'dbLayer',
          		        properties: {
            		        width: {start: 0, end: _width_p_DbLayer, unit: 'px'}
          		        },
          		        duration: 800
        	        }),
		            dojo.animateProperty({node: 'dbFormLayer',
          	    	    properties: {
               		        width: {start: _widthLayer, end: _width_p_FormLayer, unit: 'px'}
          		        },
          		        duration: 800
        	        })
      		    ]);

		        if (_db_view == 'left') {
		            var combinedAnim = dojo.fx.combine([moveAnim]);
                } else {
      		        var combinedAnim = dojo.fx.combine([displayAnim, moveAnim]);
		        }
      		
		        var handle = dojo.connect(combinedAnim, 'onEnd', function() {
		            cu_fadeIn('dbLayer');

		            domClass.remove('dbLeftFormLayer', 'none');  
                    if (_width_p_FormLayer == '0') {
		                domClass.add('dbLeftFormLayer', 'all');
                    } else {
			            domClass.add('dbLeftFormLayer', 'left');
                    }

                    domStyle.set('dbShow', 'visibility', 'hidden');
            	    var dbtooltip = dijit.byId('udbShow');
            	    if (dbtooltip) { Tooltip.hide('dbShow_img'); } 

                    if (_db_view == 'all' && dom.byId('sdbViewLayer')) {
                	    domStyle.set('sdbViewLayer', 'display', '');
            	    }

                });

                var handle = dojo.connect(combinedAnim, 'onPlay', function() {
                    setTimeout(function() { 
                        query('table.formContainer.sLpCe' ).forEach(function(node, index, arr) { 
                            domClass.replace(node, 'sLpC', 'sLpCe');
                        });
                        query('table.formContainer.sLpC input.dijitFileInputReal' ).forEach(function(node, index, arr) { 
                            node.setAttribute('size','1'); 
                        });
                    }, 1000); 
                });

      		    combinedAnim.play();
            }

	        combineIt();

            readjustTable();

            //dbReadjust();
        });
    });
}    


function dbNew() {
    if (this._timeout) { 
        clearTimeout(this._timeout); 
    }
    
    require(['dojo/dom','dojo/dom-style','dojo/query'], function(dom, domStyle, query) {
        // create a new delay before sending the request (i.e. reset the 500ms timer each time a key is pressed) 
        this._timeout = setTimeout(function() { dbDoNew('selection'); }, 500);
    });
}


function dbDoNew(mode, whandlerS1a) {

    require(['dojo/ready','dojo/parser','dojo/dom','dojo/dom-style','dojo/dom-class','dojo/dom-construct','dojo/_base/xhr',
             'dojo/query'], function(ready, parser, dom, domStyle, domClass, domConstruct, xhr, query) {

         clearTimeout(this._timeout); 

         var grid = dijit.byId('dbLeftGrid');
         
         if (_db_view != 'left') { dbShrinkAction(); }
         
         domStyle.set('Form', 'visibility', 'hidden');
         domClass.add('FormTablePreloader', 'contentPreloader');         
         
         query('.sigsDialog').forEach(function(node, index, arr) {
	        var id = node.getAttribute('id');
	        var dialogWidget = dijit.byId(id);
	        if (dialogWidget) { dialogWidget.destroyRecursive(); }
         }); 

         var description_widget = dijit.byId('formDescriptionDialog');
         if (description_widget) { description_widget.destroyRecursive(); } 

         dom.byId('selected_id').setAttribute('value','');
	     dom.byId('selected_value').setAttribute('value','');

         xhr.post({
            url: _base_path + '/' + _page + '/form_data/new/?',
            handleAs: 'text',
            preventCache: true,
            form: dom.byId('SelectForm'),
            load: function(data) {

		        dijit.byId('Form').destroyRecursive();
		        
		        dojox.html.set('FormTableContainer', data, {
                    executeScripts: true,
                    scriptHasHooks: true,
                    renderStyles: false
                });
		        
		        domStyle.set('FormTable', 'opacity', '0');
		        parser.parse('FormTable');
		        
                renderWidgets('new');

		        ready(function() {

                    domClass.remove('FormTablePreloader', 'contentPreloader');
	
		            setTimeout(function() { cu_fadeIn('FormTable'); }, 500);
		            
	                grid.selection.clear();

				domClass.remove('dbExtend', 'hidden');
	                        domClass.remove('dbHide', 'hidden');
			        dbReadjust();

                    if (mode == 'wizardStart') {
		                wizardDoStartStep1(whandlerS1a);
                    }
	            }); 
            }
        });
   }); 
}


function dbReadjust() {

    require(['dojo/ready','dojo/dom','dojo/dom-style'], function(ready, dom, domStyle) {
    
	ready(function() {

            var grid = dijit.byId('dbLeftGrid');

            if (_db_view != 'none') {
            
	            if (dom.byId('formControlButtonContainer')) {
                    var controlDisplay = domStyle.get('formControlButtonContainer', 'display');
                } else { var controlDisplay = 'none'; }

                if (_db_view == 'left') {
                
                    var height = domStyle.get('formContainer', 'height');
                
                    if (controlDisplay == 'none') {
                        if ( dojo.isChrome ) {
	                        var height_ = parseInt(height) - parseInt('205');
	                    } else {
	                        var height_ = parseInt(height) - parseInt('150');
	                    }

                    } else {
	                    if ( dojo.isChrome ) {
	                        var height_ = parseInt(height) - parseInt('205');
	                    } else {
	                        var height_ = parseInt(height) - parseInt('205');
	                    }
                    }
                
                    domStyle.set('dbLeftGridContainer', 'height', height_ + 'px');
                    domStyle.set('dbLeftGrid', 'minHeight', '100%');
          
                } else {
                    domStyle.set('dbLeftGrid', 'minHeight', '700px');
                }

                grid.resize(); 
            }
        });
    }); 
}


function dbSelect() {
    if (this._timeout) { 
        clearTimeout(this._timeout); 
    }
    
    grid = dijit.byId('dbLeftGrid');
    grid.resize();
    
    require(['dojo/dom','dojo/dom-style','dojo/query'], function(dom, domStyle, query) {
        // create a new delay before sending the request (i.e. reset the 500ms timer each time a key is pressed)
        this._timeout = setTimeout(function() { dbDoSelect(); }, 500);
    });
}


function dbDoSelect() {

   require(['dojo/ready','dojo/parser','dojo/dom','dojo/dom-style','dojo/dom-class','dojo/dom-construct','dojo/_base/xhr',
            'dojo/query'], function(ready, parser, dom, domStyle, domClass, domConstruct, xhr, query) {
        
        clearTimeout(this._timeout); 

        if (_db_view != 'left') { dbShrinkAction(); }
	    
        domStyle.set('Form', 'visibility', 'hidden'); 
        domClass.add('FormTablePreloader', 'contentPreloader'); 
        
        query('.sigsDialog').forEach(function(node, index, arr) {
	        var id = node.getAttribute('id');
	        var dialogWidget = dijit.byId(id);
	        if (dialogWidget) { dialogWidget.destroyRecursive(); }
        }); 

        var description_widget = dijit.byId('formDescriptionDialog');
        if (description_widget) { description_widget.destroyRecursive(); }

        xhr.post({
            url: _base_path + '/' + _page + '/form_data/select/?',
            handleAs: 'text',
            preventCache: true,
            form: dom.byId('SelectForm'),
            load: function(data) {

                var ldata = data.split('-*/*-');

	            var edit_choose_value = ldata[0];
                var edit_choose_id = ldata[1];
                var contents = ldata[2];

		        dijit.byId('Form').destroyRecursive();
		        
                dojox.html.set('FormTableContainer', contents, {
                    executeScripts: true,
                    scriptHasHooks: true,
                    renderStyles: false
                });

			    domStyle.set('FormTable', 'opacity', '0');
		        parser.parse('FormTable');

                query('#status_resume i.status').forEach(function(node, index, arr) {
                    var status = node.innerHTML;
                    if (status.replace(/[^A-Z]/gi, "") == 'Completed') { domStyle.set('formControlButtonContainer', 'display', 'none'); }
                }); 
                
                renderWidgets('edit');

                ready(function() {
        
		            domClass.remove('FormTablePreloader', 'contentPreloader'); 

		            setTimeout(function() { cu_fadeIn('FormTable'); }, 500);

                            domClass.remove('dbExtend', 'hidden');
	                    domClass.remove('dbHide', 'hidden');
		            dbReadjust();
                });
            }
        });
    }); 
}


function dbDelete() {

    require(['dojo/dom','dojo/on','dojo/_base/xhr','dojo/query','dojo/_base/fx'], function(dom, on, xhr, query, fx) {
    
        hideDeleteDialog();

        grid = dijit.byId('dbLeftGrid');

	    var formDataId = new Array();

        var c_items = grid.selection.getSelected(); 
        if (c_items.length) {
            dojo.forEach(c_items, function(item) {
                var id = grid.store.getValue(item, 'id');
		        formDataId.push(id);
	        });

	        formDataId.join();   
	        var formDataId = formDataId.toString(); 

            xhr.post({
	            url: _base_path + '/' + _page + '/form_data/delete/?',
	            handleAs: 'text',
	            preventCache: true,
	            postData: { 'edit_choose_id': formDataId },
	            load: function(data) {
	            
	                var opResult = data;

	                if (opResult.match(/^OK/)) {

                        dbFastUpdate('nCS');

                        var handle = dojo.connect(grid, '_onFetchComplete', function() {
                            var description_widget = dijit.byId('formDescriptionDialog');
                            if (description_widget) { description_widget.destroyRecursive(); }
                            dbSelect();
                        });
                        dijit.byId('dbFormDeleteButton').set('disabled','disabled');
                        
	                } else {
                        var msgError = data;
                    	ShowDialogError(msgError);
	                }
	            }
            });
        }
    });
}


function showDeleteDialog() {
    require(['dojo/dom','dojo/query'], function(dom, query) {
        query('#formDeleteDialog .dijitDialogTitleBar .dijitDialogTitle').forEach(function(node, index, arr) {    
            var titleBar = "<span class='dijitIconEditProperty'></span><span class='dijitTitleName'>Delete</span>";
            node.innerHTML = titleBar;
        });
    });

    cu_dlgShow(dijit.byId('formDeleteDialog'));
}


function hideDeleteDialog() { 
    dijit.byId('formDeleteDialog').hide(); 
}


function dbButton(id) {
    require(['dojo/dom','dojo/dom-style','dojo/_base/xhr', 'dojo/query'], function(dom, domStyle, xhr, query) {

        domStyle.set('globalBPL', 'visibility', 'visible');    
        query('.dialog').forEach(function(node, index, arr) {
	    var id = node.getAttribute('id');
            var widget = dijit.byId(id);
            if (widget) { widget.destroyRecursive(); }
	    });

        xhr.post({
            url: _base_path + '/' + _page + '/form_data/database_button/',
            handleAs: 'text',
            preventCache: true,
            postData: { 'button_id': id },
            load: function(data) {

                processResponse(data);

	            setTimeout(function() { domStyle.set('globalBPL', 'visibility', 'hidden'); }, 500);
	        }
        });
    });
}


function dbExport() {

    require(['dojo/dom','dojo/dom-style','dojo/_base/xhr','dojo/_base/Deferred'], function(dom, domStyle, xhr, Deferred) {

        if (dom.byId('dbFormGlobalButton')) {
            domStyle.set('exportPL2', 'display', 'inline');
        } else {
            domStyle.set('globalBPL', 'visibility', 'visible');
        }

        var edit_choose_name = dom.byId('edit_choose_name').getAttribute('value');
        var arrayDef = new Array();
        var c_items = grid.selection.getSelected(); 
        
        if (c_items.length) {
            dojo.forEach(c_items, function(item) {
                var selected_value = grid.store.getValue(item, 'name');
                var selected_id = grid.store.getValue(item, 'id');
                var def = new Deferred();
                def.then(function() {
                    xhr.post({
                        url: _base_path + '/' + _page + '/form_data/export/?',
	                    handleAs: 'text',
	                    preventCache: true,
	                    postData: { 'edit_choose_name': edit_choose_name, 'selected_value': selected_value, 'selected_id': selected_id },
	                    load: function(data) {

	                        if (data.match(/^!ERROR/)) {
                                var msgError = 'An error occurred when exporting item';
                    		ShowDialogError(msgError);
                
	                        } else {
		                        window.location.href = _base_path + '/form_data/temp_file/' + data;
                                setTimeout(function() { 
                                    arrayDef.shift();
                                    if(arrayDef.length) { arrayDef[0].resolve(); } 
                                }, 1000);             
	                        }
	                        
	                        if (dom.byId('dbFormGlobalButton')) {
                                   domStyle.set('exportPL2', 'display', 'none');
                               } else {
                                   domStyle.set('globalBPL', 'visibility', 'hidden');
                               }
	                    }
                   });           

                }, function(err) {
		            var msgError = 'An error occurred when exporting item';
                    ShowDialogError(msgError);
                }); 

                arrayDef.push(def);                 
           });

           arrayDef[0].resolve(); 
        }
   });
}


function containerAction(id) {

    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {
        var num = id.replace(/containerAction_/, '');
        var display = domStyle.get(dojo.byId("containerContents_" + num), 'display');
        if ( display == 'none' ) {
            domStyle.set(dojo.byId("containerContents_" + num), 'display', '');
            dom.byId("actionIcon_" + num).setAttribute('src', _base_path + '/int/js/custom/images/flat.png');
            dom.byId("actionText_" + num).innerHTML = 'Hide data';
        } else {
            domStyle.set(dojo.byId("containerContents_" + num), 'display', 'none');
            dom.byId("actionIcon_" + num).setAttribute('src', _base_path + '/int/js/custom/images/pop.png');
            dom.byId("actionText_" + num).innerHTML = 'Show data';
        }
        
        dbReadjust();
    });   
}


function dbSearch() {

    if (this._timeout) { 
        clearTimeout(this._timeout); 
    }
    
    require(['dojo/dom','dojo/dom-style','dojo/query'], function(dom, domStyle, query) {

        var grid = dijit.byId('dbLeftGrid');

        var toSearch = dijit.byId('database_search').get('value');
        if (toSearch == _toSearch) { return }

        var edit_choose_name = dom.byId('post_key_2').getAttribute('value');

        query('#dbLeftGrid .dojoxGridHeader').forEach(function(node, index, arr) {      
            domStyle.set(node, 'opacity', '0'); 
        });

        query('#dbLeftGrid .dojoxGridScrollbox').forEach(function(node, index, arr) {      
            domStyle.set(node, 'display', 'none'); 
        });

        loadingMessage = "<span class='dojoxGridLoading'>Loading...</span>";
        grid.showMessage(loadingMessage);
    
        // create a new delay before sending the request (i.e. reset the 300ms timer each time a key is pressed) 
        this._timeout = setTimeout(function() { dbDoSearch(edit_choose_name); }, 300);
        
    }); 
}


function dbDoSearch(edit_choose_name) {

    require(['dojo/dom','dojo/dom-style','dojox/grid/DataGrid','dojox/data/QueryReadStore','dojo/_base/xhr',
             'dojo/query','dojox/grid/cells/dijit','dojox/grid/_CheckBoxSelector'],

    function(dom, domStyle, DataGrid, QueryReadStore, xhr, query) {
        
        clearTimeout(this._timeout); 

        var grid = dijit.byId('dbLeftGrid');

        var toSearch = dijit.byId('database_search').get('value');
        _toSearch = toSearch;
        
        var consider_admin = dom.byId('sdbLoadControl').innerHTML;

        grid.setQuery({ query: toSearch + '*', consider_admin: consider_admin });
        dataStore = new QueryReadStore({
            url: _base_path + '/' + _page + '/form_data/database/' + edit_choose_name + '/?',
	        requestMethod: 'post'  
        });

        var handle = dojo.connect(grid, '_onFetchBegin', function(total) {
            var numRows = total;
            if (numRows != '0') {   
                query('#dbLeftGrid .dojoxGridHeader').forEach(function(node, index, arr) {      
                    domStyle.set(node, 'opacity', '1'); 
                });

            } else {
                if (toSearch == '') {
                    var noDataMessage = "<span class='dojoxGridNoData'>No items in database</span>";
                } else {
                    var noDataMessage = "<span class='dojoxGridNoData'>No matched results</span>";
                }
                grid.showMessage(noDataMessage);
            }

            query('.dojoxGridScrollbox').forEach(function(node, index, arr) {      
                domStyle.set(node, 'display', ''); 
            }); 

            dojo.disconnect(handle);
        });
    });
}


function dbSubmit(mode) {

    require(['dojo/dom','dojo/dom-style','dojo/dom-class','dojo/dom-construct','dojo/on','dojo/io/iframe','dojo/query'],
             
    function(dom, domStyle, domClass, domConstruct, on, ioIframe, query) {
        
        clearFormStatus();
        showDbFormPL();

        if ( mode != 'reject') { 
            dijit.byId('submitButton').set('disabled','disabled'); 
        }
        
        var grid = dijit.byId('dbLeftGrid');

        var src = _base_path + '/int/js/custom/images/true.png';
        var icon = "<img width='13' height='13' src='" + src + "'></img>";
     
        ioIframe.send({
	        url: _base_path + '/' + _page + '/form_data/submit/' + mode,
	        handleAs: 'html',     
	        form: dom.byId('Form'),
	        load: function(data) {

                var ldata = data.body.innerHTML.split('-*/*-');

	            var opResult = ldata[0];

	            var status_values = ldata[1];
                var status_resume = ldata[2];
                var status_complete = ldata[3];

                var object = ldata[4];

	            if (opResult == 'OK_new') {

                    var edit_choose_name = dom.byId('post_key_2').getAttribute('value');

                    query('div.formControlContainer table.formContainer').forEach(function(node, index, arr){
                        domClass.add(node, 'nEdP');
                    });
                 
                    domClass.add('widget_' + edit_choose_name, 'dijitTextBoxDisabled dijitValidationTextBoxDisabled dijitDisabled');

                    if (status_resume && status_resume != '') { domConstruct.place(status_resume, 'status_resume', 'only'); }
                    if (status_complete && status_complete == '1') { dbDoSelect(); } 

                    dbFastUpdate('submit');

                    hideDbFormPL();
                    showFormStatus(icon, 'Successfully created'); 
   
                    dom.byId('post_key_1').setAttribute('name','edit');           

                    var handle = dojo.connect(grid, '_onFetchComplete', function() {
                        grid.selection.clear();
                        grid.selection.addToSelection(0);
                        var c_items = grid.selection.getSelected();
                        
                        dojo.forEach(c_items, function(item, i){
		      	            var id = grid.store.getValue(item,'id');
		      	            var v = grid.store.getValue(item,'name');
                            if (v.match(/^--BOLD--/)) { var v = v.replace(/--BOLD--/, ''); } 
	                        dom.byId('selected_id').setAttribute('value',id);
	                        dom.byId('selected_value').setAttribute('value',v);
                            dom.byId('post_key_3').setAttribute('value',v);
	                        dom.byId('post_key_4').setAttribute('value',id);
		      	        });
                        
                        dijit.byId('submitButton').set('disabled',false);
                        if (object) {
                            query('#_object').forEach(function(node, index, arr){  
                                node.innerHTML = object;
                            });
                        }
                        
                        dbReadjust();
                        dojo.disconnect(handle);
                    });

		            if (_is_demo == '1' && _is_demo_active == '1' && _demo_form == _page) {
		                if (_demo_step == 'step1') {
		                    wizardGoStep2(); 
		                } else if (_demo_step == 'step4') {
		                    wizardGoStep4b();
		                }
		            }

	            } else if (opResult == 'OK_edit') {

                    var id = grid.selection.selectedIndex;
                    var idx = parseInt(id) + parseInt('1');
	            
                    if (status_resume && status_resume != '') { domConstruct.place(status_resume, 'status_resume', 'only'); }
		            if (status_values && status_values != '') { dbUpdateEntriesSelection(idx, status_values); }

                    var style = document.createElement('style');
                    style.type = 'text/css';
                    style.innerHTML = "#dbLeftGrid .dojoxGridRow:nth-child(" + idx + ") b { font-weight: normal; }";
                    document.getElementsByTagName('head')[0].appendChild(style); 

                    if (status_complete && status_complete == '1') { dbDoSelect(); }

                    hideDbFormPL();
                    showFormStatus(icon, 'Successfully updated'); 
                    dijit.byId('submitButton').set('disabled',false);
                    if (object) {
                        query('#_object').forEach(function(node, index, arr){  
                            node.innerHTML = object;
                        });
                    }

                    if (_is_demo == '1' && _is_demo_active == '1' && _demo_form == _page) {
		                if (_demo_step == 'step1') {
		                    wizardGoStep2(); 
		                } else if (_demo_step == 'step4') {
		                    wizardGoStep4b();
		                }
		            }

                } else {
		            var msgError = opResult;
                    ShowDialogError(msgError);
                    hideDbFormPL();
                    dijit.byId('submitButton').set('disabled',false);
                } 
            }
        });
    });
}


function ShowDialogError(msgError) {

    require(['dojo/dom','dojo/query','dijit/Dialog','dojo/_base/fx'], function(dom, query, dialog, fx) {

        var errorDialog = dijit.byId('formErrorDialog');

        if (msgError != '') {
            dom.byId('errorDialogStatus').innerHTML = msgError;
        } else {
            dom.byId('errorDialogStatus').innerHTML = 'There has been an unexpected error';
        }

	    query('#formErrorDialog .dijitDialogTitleBar .dijitDialogTitle').forEach(function(node, index, arr) {    
            var titleBar = "<span class='dijitIconError'></span><span class='dijitTitleName'>Error</span>";
            node.innerHTML = titleBar;
        });

	    fx.fadeIn({
            node: 'formErrorDialog',
            duration: 300,
            onEnd: function() { cu_dlgShow(errorDialog); }
        }).play(); 
    });
}


function dbUpdateEntriesSelection(idx, status_values) {

    var ldata = status_values.split('*-*');

    for (var i = 0; i < ldata.length; i = i + 1) {
 
        var lldata = ldata[i].split('--');

        var pos = lldata[0];
        var status = lldata[1];

        if (status == 'new') { var src = _base_path + "/int/js/custom/images/status/p0.png" }
        if (status == 'pending') { var src = _base_path + "/int/js/custom/images/status/p2.png" }
        if (status == 'validated') { var src = _base_path + "/int/js/custom/images/status/p8.png" }
        if (status == 'rejected') { var src = _base_path + "/int/js/custom/images/status/p9.png" }
        if (status == 'completed') { var src = _base_path + "/int/js/custom/images/status/p10_b.png" }

        var style = document.createElement('style');
        style.type = 'text/css';
        var s = "background: url(" + src + ") no-repeat; display: block; height: 100%; padding-left: 22px; box-sizing: border-box; -moz-box-sizing: border-box;";
        style.innerHTML = "#dbLeftGrid .dojoxGridRow:nth-child(" + idx + ") .dojoxGridCell:nth-child(" + pos + ") img {" + s +  "}";
        document.getElementsByTagName('head')[0].appendChild(style); 
    }
}


function dbInvalidForm() {

    var src = _base_path + '/int/js/custom/images/false.png';
    var icon = "<img width='13' height='13' src='" + src + "'></img>";

    showFormStatus(icon, 'Please check this form before submitting', 'warning'); 
    setTimeout(function() { clearFormStatus(); }, 5000);
    
    require(['dojo/dom','dojo/on','dojo/dom-class','dojo/dom-style','dojox/fx/scroll','dojo/fx','dojo/fx/easing'], 

    function(dom, on, domClass, domStyle) {
    
        var iWs = new Array();
	iterFunction = function(widget) {
            try { var invalid = widget.isValid(); if (invalid == false) { iWs.push(widget); } }
            catch(err) { }
        }
	        
	    dojo.forEach(dijit.byId('Form').getChildren(), iterFunction);

            dojox.fx.smoothScroll({
                node: 'contents',
                win: window,
                duration: 200
            }).play();

	    for (var i=0; i<iWs.length; i++) {
	        var iW = iWs[i];
	        var iWId = iW.id;
	        var iWClass = iW.class;
            if (iWClass == 'widget date') {
                domClass.add('dateWidget_' + iWId, 'invalid');
            }
            if (iWClass == 'widget time') {
                domClass.add('timeWidget_' + iWId, 'invalid');
            }

            on(dijit.byId('Form'), 'reset', function() {
		 for (var i=0; i<iWs.length; i++) {
	             var iW = iWs[i];
	             var iWId = iW.id;
	             var iWClass = iW.class;
            	     if (iWClass == 'widget date') {
                	 domClass.remove('dateWidget_' + iWId, 'invalid');
            	     }
            	     if (iWClass == 'widget time') {
                	 domClass.remove('timeWidget_' + iWId, 'invalid');
            	     }
                 }
            });
        }
    }); 
}


function dbRejectDialog() {

    require(['dojo/dom','dojo/_base/xhr','dojo/query','dijit/Dialog'], function(dom, xhr, query, dialog) {

        var formIncidenceDialog = dijit.byId('formIncidenceDialog');
        if (formIncidenceDialog) { formIncidenceDialog.destroyRecursive(); }

        clearFormStatus();
        showDbFormPL();

        xhr.post({
            url: _base_path + '/' + _page + '/form_data/reject/?',
	        preventCache: true,
            handleAs: 'text',
            load: function(data) {

                var ldata = data.split('-*/*-');

	            var contents = ldata[0];
                var title = ldata[1];

		        var dlg = new dialog({ 
		            id: 'formIncidenceDialog',
		            'class': 'formIncidenceDialog',
		            executeScripts: true,
		            scriptHasHooks: true,
		            content: contents
		        });

                query('#formIncidenceDialog .dijitDialogTitleBar .dijitDialogTitle').forEach(function(node, index, arr) {    
                    var titleBar = "<span class='dijitIconError'></span><span class='dijitTitleName'>" + title + "</span>";
                    node.innerHTML = titleBar;
                });
		        
		        dlg.startup();
		        cu_dlgShow(dlg); 

       			hideDbFormPL();
	        }
        });
    });
}


function dbShowDescriptionIcon() {

    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {
        domStyle.set('dbDescription', 'display', '');
    });
}


function dbShowDescriptionDialog() {

    require(['dojo/dom','dojo/_base/xhr','dojo/query'], function(dom, xhr, query) {

        query('#formDescriptionDialog .dijitDialogTitleBar .dijitDialogTitle').forEach(function(node, index, arr) {    
            var titleBar = "<span class='dijitLeaf'></span><span class='dijitTitleName'>Description</span>";
            node.innerHTML = titleBar;
        });

        dijit.byId('formDescriptionDialog').show();
    });
}


function dbReject() {
    require(['dojo/dom','dojo/_base/xhr','dojo/query','dijit/Dialog'], function(dom, xhr, query, dialog) {
        var incidence = dijit.byId('_incidence').get('value');
        if (incidence != '') {
            dijit.byId('Form').reset();
            var incidenceField = dom.byId('incidence_field').getAttribute('value')
            dom.byId(incidenceField).setAttribute('value', incidence);
            dijit.byId('formIncidenceDialog').hide();
            dbSubmit('reject');
            
        } else {
            return false;
        }
    });
}

function searchFormClear() { 
    dijit.byId('database_search').reset(); 
    require(['dojo/dom'], function(dom) {
        var edit_choose_name = dom.byId('post_key_2').getAttribute('value');
        dbDoSearch(edit_choose_name);
    });
}


function searchFormHovered() {
    require(['dojo/dom','dojo/dom-style','dijit/focus'], function(dom, domStyle, focusUtil) {
        domStyle.set('formSearchInput', 'border', '1px solid #769DC0');
    });
}


function searchFormUnHovered() {
    require(['dojo/dom','dojo/dom-style','dijit/focus'], function(dom, domStyle, focusUtil) {
        domStyle.set('formSearchInput', 'border', '1px solid #B5BCC7');
    });
}


function showDbFormPL() {
    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {
        domStyle.set('managerPL', 'display', '');
    });
}


function hideDbFormPL() {
    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {
        domStyle.set('managerPL', 'display', 'none');
    });
}


function showFormStatus(icon, text, mode) {
    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {
         dom.byId('managerStatus_image').innerHTML = icon;
         dom.byId('managerStatus_text').innerHTML = text;
         domStyle.set('managerStatus_image', 'display', 'block');
         domStyle.set('managerStatus_text', 'display', 'block');
         if (mode == 'warning') { domStyle.set('managerStatus_text', 'color', 'red'); }    
    });
}


function clearFormStatus() {
    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {
        domStyle.set('managerStatus_image', 'display', 'none');
        domStyle.set('managerStatus_text', 'display', 'none'); 
        domStyle.set('managerStatus_text', 'color', '#000'); 
    });       
}

function hideFormDialog() {
    dijit.byId('dialog_form').hide();
}

                        




























