
function uM_c_GridInit() {
    
     require(['dojo/ready','dojo/dom','dojo/dom-style','dojo/dom-class','dojo/on','dojox/grid/DataGrid','dijit/Tooltip',
              'dojo/store/Memory','dojo/data/ObjectStore','dojox/data/QueryReadStore','dijit/form/ComboBox',
              'dojo/_base/xhr','dojo/query','dijit/form/Form','dojox/grid/cells/dijit','dojox/grid/_CheckBoxSelector'],

        function(ready, dom, domStyle, domClass, on, DataGrid, Tooltip, Memory, ObjectStore, QueryReadStore, Select, xhr, query){
        
        _uM_grid_loading = '1';
        
        ready(function(){ 

            _selection = 'certificates';

            xhr.post({
                url: './certificates/loadDatabase/check',
		        handleAs: 'json',
		        preventCache: true

            }).then(function(jsonData){
        
                var numRows = jsonData.numRows.toString();
                var uM_C_h1 = jsonData.uM_C_h1.toString();
                var uM_C_h2 = jsonData.uM_C_h2.toString();
                var uM_C_h3 = jsonData.uM_C_h3.toString();
                var uM_C_h4 = jsonData.uM_C_h4.toString();
                var uM_C_h5 = jsonData.uM_C_h5.toString();
                var uM_C_h6 = jsonData.uM_C_h6.toString();
                var uM_C_h7 = jsonData.uM_C_h7.toString();

                var gridCertLayout = [
                    {type: 'dojox.grid._CheckBoxSelector', width:'3em', scroll:true},
                    {cells: [
                        { name: uM_C_h1, field: 'id', width: '40px', headerClasses: 'certHeaderGrid', cellClasses: 'dojoxGridStyle', formatter: uM_c_viewFormat },
                        { name: uM_C_h2, field: 'user', width: '180px', headerClasses: 'certHeaderGrid', cellClasses: 'dojoxGridStyle', styles:'padding-left:8pt;text-align:left;', formatter: uM_inputTextUsernameFormat },
                        { name: uM_C_h3, field: 'status', width: '45px', headerClasses: 'certHeaderGrid', cellClasses: 'dojoxGridStyle', formatter: uM_statusIconFormat },
                        { name: uM_C_h4, field: 'subject_name', width: '300px', headerClasses: 'certHeaderGrid', cellClasses: 'dojoxGridStyle', styles:'padding-left:5pt;text-align:left;', formatter: uM_c_signerNameFormat },
                        { name: uM_C_h5, field: 'issuer_name', width: '220px', headerClasses: 'certHeaderGrid', cellClasses: 'dojoxGridStyle', styles:'padding-left:5pt;text-align:left;', formatter: uM_c_issuerNameFormat },
                        { name: uM_C_h6, field: 'edate', width: '100px', headerClasses: 'certHeaderGrid', cellClasses: 'dojoxGridStyle', formatter: uM_c_expirationDateFormat },
                        { name: uM_C_h7, field: 'cdate', width: '100px', headerClasses: 'certHeaderGrid', cellClasses: 'dojoxGridStyle' }
                    ]}
                ];
                
                var certStore = new QueryReadStore({
	   	            url: './certificates/loadDatabase/',
	   	            requestMethod: 'post'
	            });

	            cGrid = new DataGrid({
		            store: certStore,
		            structure: gridCertLayout,
                    rowsPerPage: 20,
		            query: {query: '*'},
	                queryOptions: { ignoreCase: true },
	                noDataMessage: "<span class='dojoxGridNoData'>No certificates in database</span>",
	                onRowClick: function(e) {
	                    this.edit.rowClick(e);
	                }
		        }, 'certsGrid');
		        
		        cGrid.on('RowClick', function(event){
	                query('#certsGrid td.dojoxGridCellFocus').forEach(function(node, index, arr){
	                    domClass.remove(node,'dojoxGridCellFocus');
                    });
	                var idx = event.rowIndex,
                    item = this.getItem(idx);
                    var id = this.store.getValue(item, 'id');
                    var inputWidget = dijit.byId('c_' + id); 
                    if (inputWidget) { inputWidget.focus(); }
                    var tooltip = dijit.byId('t_c_' + id);
                    if (tooltip) { 
                        var label = tooltip.get('label');
                        if (label != '') { Tooltip.show(label,'widget_c_' + id); } 
                    }
                }, true);

	            cGrid.on('SelectionChanged', function(){
	            
	                var c_items = this.selection.getSelected();
	                store = this.store;
	            
                    dom.byId('managerStatus_image').innerHTML = '';
                    dom.byId('managerStatus_text').innerHTML = '';

			        if (c_items.length == '0') {
				        dijit.byId('cManagerB_a').set('disabled','disabled');
				        dijit.byId('cManagerB_r').set('disabled','disabled');
				        dijit.byId('cManagerB_d').set('disabled','disabled');
				        
				        dom.byId('selCert').setAttribute('value','');
				        
			        } else {
			        
			            dijit.byId('cManagerB_d').set('disabled',false);

                        e_st = 1;
			            dojo.forEach(c_items, function(item, i){
		      	            var id = store.getValue(item,'id');
		      	            var username = store.getValue(item,'user');
                            var inputWidget = dijit.byId('c_' + id);
                            if (inputWidget && inputWidget.get('value') == '') {
                                inputWidget.focus();
			                    inputWidget.set('value',username);
                            }
                            var status = store.getValue(item,'status');
                            if (i == '0') { 
                                st = status; 
                            } else {
                                if ( status != st ) { e_st = 0; }
                            }
                            var i = i+1;
			            });
			                
			            if (e_st) {
			                if (st == 'active') { 
			                    dijit.byId('cManagerB_a').set('disabled','disabled');
			                    dijit.byId('cManagerB_r').set('disabled',false);
			                } else if (st == 'revoked') {
			                    dijit.byId('cManagerB_a').set('disabled',false);
			                    dijit.byId('cManagerB_r').set('disabled','disabled');
			                } else {
			                    dijit.byId('cManagerB_a').set('disabled',false);
			                    dijit.byId('cManagerB_r').set('disabled',false);
			                }  
			            } else {
			                dijit.byId('cManagerB_a').set('disabled',false);
			                dijit.byId('cManagerB_r').set('disabled',false);
			            }
				    }
			    }, true);

			    cGrid.startup();
	            cGrid.canSort = function() { return false };
	            cGrid.resize();
	            
	            var handle = dojo.connect(cGrid, '_onFetchComplete', function(e) {
                    _uM_grid_loading = '0';   
                    dojo.disconnect(handle);
                });

                if (numRows == '0') {
	                query('#certsGrid .dojoxGridHeader').forEach(function(node, index, arr){      
                        domStyle.set(node, 'opacity', '0'); 
                    });
	            }

                dijit.byId('filter_by').removeOption(dijit.byId('filter_by').getOptions());
                dijit.byId('filter_by').addOption({label:'Status',value:'status',selected:true});
            });
        });
	}); 
}


function uM_c_action() {

    require(['dojo/dom'], function(dom) {
    
        var cGrid = dijit.byId('certsGrid');
        var c_items = cGrid.selection.getSelected();
	    var certsData = new Array();

        if (c_items.length) {
            dojo.forEach(c_items, function(item){
		        var id = cGrid.store.getValue(item, 'id');
		        var id_user = cGrid.store.getValue(item, 'id_user');
		        var username = cGrid.store.getValue(item, 'user');
		        var inputWidget = dijit.byId('c_' + id);
		        if (inputWidget) {
		            var username = inputWidget.get('value');
		        } 
		        if (username == '') { var username = 'null'; }
 		        var perm = cGrid.store.getValue(item, 'gen_perm');
		        certsData.push(id);
		        certsData.push(id_user);
		        certsData.push(username);
		        certsData.push(perm);
	        });
	        certsData.join();
	        dom.byId('selCert').setAttribute('value', certsData.toString());
	        uM_c_doAction();
         }
    });
}


function uM_c_doAction() {

    if (this._timeout) { 
        clearTimeout(this._timeout); 
    }
    
    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {
    
        uM_clearStatus();
        uM_showPL();

        // create a new delay before sending the request (i.e. reset the 300ms timer each time a key is pressed) 
        this._timeout = setTimeout(function(){ uM_c__doAction(); }, 300);  
    }); 
}


function uM_c__doAction() {

    require(['dojo/ready','dojo/dom','dojo/dom-style','dojox/grid/DataGrid','dojox/data/QueryReadStore','dojo/_base/xhr',
             'dojo/query','dojo/_base/fx','dijit/Dialog','dojox/grid/cells/dijit','dojox/grid/_CheckBoxSelector'],

        function(ready, dom, domStyle, DataGrid, QueryReadStore, xhr, query, fx, dialog){
        
        ready(function(){ 

            query('.formLoginDialog').forEach(function(node, index, arr){
			    var id = node.getAttribute('id');
			    dijit.byId(id).destroyRecursive();
		    });

		    action = dom.byId('certAction').getAttribute('value');
		    var activeUser = dom.byId('activeUser').getAttribute('value');
		    
		    cGrid = dijit.byId('certsGrid');

            dom.byId('certsGrid').focus();

            var selCert = dom.byId('selCert').getAttribute('value'); 
		    var selCert_ = selCert.split(',');  

		    if (action == 'activate') {      

		        var block = 0;
		        var msgErrData = new Array();
		        for (var i = 2; i < selCert_.length; i = i+4){
		            if (selCert_[i] == 'null') { 
		                var block = 1;
		                var msgErr = 'All users must have a username';
                        msgErrData.push(selCert_[i-2]);
                        msgErrData.push(selCert_[i]);
                        msgErrData.push(msgErr); 
		            }
		        }
		        
		        if (!block) { 
		     	    uM_c_activate(); 
		     	} else {
		     	    uM_XHRwarning(msgErrData.join()) 
		     	}

		    } else if (action == 'revoke') {       

		        var block = 0;
		        for (var i = 3; i < selCert_.length; i = i+4){
		            if (selCert_[i] == 'Administrator' && selCert_[i-1] != activeUser) { 
		                var block = 1;
		                var user = selCert_[i-1]; 
		                var msgErr = '<b>' + user + '</b> is an administrator user';
		                break
		            }
		        }
		        
		        if (!block) { 
		            uM_c_revoke();
		        } else {
		            uM_XHRerror(msgErr);
		        }
		    
		    } else {      

		        var block = 0;
		        for (var i = 3; i < selCert_.length; i = i+4){
		            if (selCert_[i] == 'Administrator' && selCert_[i-1] != activeUser) { 
		                var block = 1;
		                var user = selCert_[i-1]; 
		                var msgErr = '<b>' + user + '</b> is an administrator user';
		                break 
		            }
		        }
		        
		        if (!block) { 
		            uM_c_remove();
		        
		        } else {
		            uM_XHRerror(msgErr); 
		        }
		    }
        });
    });
}


function uM_c_activate() {

    require(['dojo/dom','dojo/_base/xhr'], function(dom, xhr){

        var selCert = dom.byId('selCert').getAttribute('value');
	    var selCert_ = selCert.split(',');   

        var certsData = new Array();
	    for (var i=0; i<selCert_.length; i=i+4){
		    certsData.push(selCert_[i]);
		    certsData.push(selCert_[i+1]);
		    certsData.push(selCert_[i+2]);
		}
	    certsData.join();
	    var certsData = certsData.toString();
	    
	    _Grid = dijit.byId('certsGrid');
	
        xhr.post({
            url: './../login/activate',
            handleAs: 'json',
            postData: { 'what': 'certificates', 'data': certsData, 'action': action },
            load: function(jsonData) {
                 uM_XHRrespond('activate',jsonData);
            }
        });
    });
}


function uM_c_revoke() {

    require(['dojo/dom','dojo/_base/xhr'], function(dom, xhr){
    
        var selCert = dom.byId('selCert').getAttribute('value');
	    var selCert_ = selCert.split(',');   

        var certsData = new Array();
	    for (var i=0; i<selCert_.length; i=i+4){
		    certsData.push(selCert_[i]);
		    certsData.push(selCert_[i+1]);
		    certsData.push(selCert_[i+2]);
		}
	    certsData.join();
	    var certsData = certsData.toString();
	
        xhr.post({
            url: './../login/inactivate',
            handleAs: 'json',
            postData: { 'what': 'certificates', 'data': certsData, 'action': action },
            load: function(jsonData) {
                uM_XHRrespond('inactivate', jsonData);
		    }
        });
    });
}


function uM_c_remove() {

    require(['dojo/dom','dojo/_base/xhr'], function(dom, xhr){
    
        var selCert = dom.byId('selCert').getAttribute('value');
	    var selCert_ = selCert.split(',');   

        var certsData = new Array();
	    for (var i=0; i<selCert_.length; i=i+4){
	        certsData.push(selCert_[i]);
	        certsData.push(selCert_[i+1]);
	    }
	    certsData.join();
	    var certsData = certsData.toString();
	
        xhr.post({
            url: './../login/delete',
            handleAs: 'json',
            postData: { 'what': 'certificates', 'data': certsData, 'action': action },
            load: function(jsonData) {
                uM_XHRrespond('delete', jsonData);
		    }
        });
    });
}


function uM_c_viewFormat(id) {
     var icon = "<img width='17' height='17' onclick='uM_certDialog(event," + id + ")' src='./../int/js/custom/images/info.png'></img>";
     var data = "<span class='userCertificateInfo'>" + icon + "</span>";
     return data;
}


function uM_c_signerNameFormat(subject_name) {
     if (subject_name == '') {
        return "<i style='font-size:7.5pt'>Not specified</i>";
     } else {
        return subject_name;
     }
}


function uM_c_issuerNameFormat(issuer_name) {
     if (issuer_name == '') {
        return "<i style='font-size:7.5pt'>Not specified</i>";
     } else {
        return issuer_name;
     }
}  


function uM_c_expirationDateFormat(edate) {
     if (edate) {
        _edate = edate.split('-').join(', ');
        _edate = new Date(_edate);
        date = new Date();
        if (date.getTime() > _edate.getTime()) {
            var edate = "<span style='color:red;font-weight:bold'>" + edate + "</span>";
        }
        return edate;
    }
}


function uM_c_GridUpdate() {

    require(['dojo/dom','dojo/dom-style','dojo/dom-class','dojox/grid/DataGrid','dojox/data/QueryReadStore',
             'dojo/_base/xhr','dojo/query','dojox/grid/cells/dijit','dojox/grid/_CheckBoxSelector'],

    function(dom, domStyle, domClass, DataGrid, QueryReadStore, xhr, query) {
    
        var _Grid = dijit.byId('certsGrid');
    
        _Grid.setQuery({query: '*', filter_by: 'status', filter_what: ''});

        certStore = new QueryReadStore({
            url: './users/loadDatabase/',
	        requestMethod: 'post'  
        });
    });
}