
function uM_s_GridInit() {
    
     require(['dojo/ready','dojo/dom','dojo/dom-style','dojo/dom-class','dojo/on','dojox/grid/DataGrid',
              'dojo/store/Memory','dojo/data/ObjectStore','dojox/data/QueryReadStore','dijit/form/ComboBox',
              'dojo/_base/xhr','dojo/query','dijit/form/Form','dojox/grid/cells/dijit','dojox/grid/_CheckBoxSelector'],

        function(ready, dom, domStyle, domClass, on, DataGrid, Memory, ObjectStore, QueryReadStore, Select, xhr, query){
        
        _uM_grid_loading = '1';
        
        ready(function(){ 

            _selection = 'signatures';

            xhr.post({
                url: './signatures/loadDatabase/check',
		        handleAs: 'json',
		        preventCache: true

            }).then(function(jsonData){
        
                var numRows = jsonData.numRows.toString();
                var uM_S_h1 = jsonData.uM_S_h1.toString();
                var uM_S_h2 = jsonData.uM_S_h2.toString();
                var uM_S_h3 = jsonData.uM_S_h3.toString();
                var uM_S_h4 = jsonData.uM_S_h4.toString();
                var uM_S_h5 = jsonData.uM_S_h5.toString();
                var uM_S_h6 = jsonData.uM_S_h6.toString();
                var uM_S_h7 = jsonData.uM_S_h7.toString();
                
                var gridSigLayout = [
                    {type: 'dojox.grid._CheckBoxSelector', width:'3em', scroll:true},
                    {cells: [
                        { name: uM_S_h1, field: 'id', width: '40px', headerClasses: 'certHeaderGrid', cellClasses: 'dojoxGridStyle', formatter: uM_c_viewFormat },
                        { name: uM_S_h2, field: 'user', width: '180px', headerClasses: 'certHeaderGrid', cellClasses: 'dojoxGridStyle', styles:'padding-left:8pt;text-align:left;' },
                        { name: uM_S_h3, field: 'status', width: '45px', headerClasses: 'certHeaderGrid', cellClasses: 'dojoxGridStyle', formatter: uM_statusIconFormat },
                        { name: uM_S_h4, field: 'subject_name', width: '300px', headerClasses: 'certHeaderGrid', cellClasses: 'dojoxGridStyle', styles:'padding-left:5pt;text-align:left;', formatter: uM_c_signerNameFormat },
                        { name: uM_S_h5, field: 'issuer_name', width: '220px', headerClasses: 'certHeaderGrid', cellClasses: 'dojoxGridStyle', styles:'padding-left:5pt;text-align:left;', formatter: uM_c_issuerNameFormat },
                        { name: uM_S_h6, field: 'edate', width: '100px', headerClasses: 'certHeaderGrid', cellClasses: 'dojoxGridStyle', formatter: uM_c_expirationDateFormat },
                        { name: uM_S_h7, field: 'cdate', width: '100px', headerClasses: 'certHeaderGrid', cellClasses: 'dojoxGridStyle' }
                    ]}
                ];
                
                var sigStore = new QueryReadStore({
	   	            url: './signatures/loadDatabase/',
	   	            requestMethod: 'post'
	            });

	            sGrid = new DataGrid({
		            store: sigStore,
		            structure: gridSigLayout,
                    rowsPerPage: 20,
		            query: {query: '*'},
	                queryOptions: { ignoreCase: true },
	                noDataMessage: "<span class='dojoxGridNoData'>No signatures in database</span>",
	                onRowClick: function(e) {
	                    this.edit.rowClick(e);
	                }
		        }, 'sigsGrid');
		  

                sGrid.on('RowClick', function(event){
	                query('#sigsGrid td.dojoxGridCellFocus').forEach(function(node, index, arr){
	                    domClass.remove(node,'dojoxGridCellFocus');
                    });
                }, true);

	            sGrid.on('SelectionChanged', function(){
	            
	                var c_items = this.selection.getSelected();
	                store = this.store;
	            
                    dom.byId('managerStatus_image').innerHTML = '';
                    dom.byId('managerStatus_text').innerHTML = '';

			        if (c_items.length == '0') {
				        dijit.byId('sManagerB_a').set('disabled','disabled');
				        dijit.byId('sManagerB_r').set('disabled','disabled');
				        dijit.byId('sManagerB_d').set('disabled','disabled');
				        
				        dom.byId('selSig').setAttribute('value','');
				        
			        } else {
			        
			            dijit.byId('sManagerB_d').set('disabled',false);

                        e_st = 1;
			            dojo.forEach(c_items, function(item, i){
		      	           
                            var status = store.getValue(item,'status');
                            if (i == '0') { 
                                st = status; 
                            } else {
                                if ( status != st ) { e_st = 0; }
                            }
                            var i = i+1;
			            });
			                
			            if (e_st) {
			                if (st == 'active') { 
			                    dijit.byId('sManagerB_a').set('disabled','disabled');
			                    dijit.byId('sManagerB_r').set('disabled',false);
			                } else if (st == 'revoked') {
			                    dijit.byId('sManagerB_a').set('disabled',false);
			                    dijit.byId('sManagerB_r').set('disabled','disabled');
			                } else {
			                    dijit.byId('sManagerB_a').set('disabled',false);
			                    dijit.byId('sManagerB_r').set('disabled',false);
			                }  
			            } else {
			                dijit.byId('sManagerB_a').set('disabled',false);
			                dijit.byId('sManagerB_r').set('disabled',false);
			            }
				    }
			    }, true);
			    
			    sGrid.startup();
	            sGrid.canSort = function() { return false };
	            sGrid.resize();
	            
	            var handle = dojo.connect(sGrid, '_onFetchComplete', function(e) {
                    _uM_grid_loading = '0';   
                    dojo.disconnect(handle);
                });
	            
	            if (numRows == '0') {
	                query('#sigsGrid .dojoxGridHeader').forEach(function(node, index, arr){      
                        domStyle.set(node, 'opacity', '0'); 
                    });
	            }
                
                dijit.byId('filter_by').removeOption(dijit.byId('filter_by').getOptions());
                dijit.byId('filter_by').addOption({label:'Status',value:'status',selected:true});
            });
        });
	}); 
}


function uM_s_action() {

    require(['dojo/dom'], function(dom) {
    
        var sGrid = dijit.byId('sigsGrid');
        var c_items = sGrid.selection.getSelected();
	    var sigsData = new Array();

        if (c_items.length) {
            dojo.forEach(c_items, function(item){

                var id = sGrid.store.getValue(item, 'id');
		        var id_user = sGrid.store.getValue(item, 'id_user');
		        var username = sGrid.store.getValue(item, 'user');
		        var inputWidget = dijit.byId('s_' + id);
		        if (inputWidget) {
		            var username = inputWidget.get('value');
		        } 
		        if (username == '') { var username = 'null'; }
 		        var perm = sGrid.store.getValue(item, 'gen_perm');
		        sigsData.push(id);
		        sigsData.push(id_user);
		        sigsData.push(username);
		        sigsData.push(perm);

	        });
	        sigsData.join();
	        dom.byId('selSig').setAttribute('value', sigsData.toString());
	        uM_s_doAction();
         }
    });
}



function uM_s_doAction() {

    if (this._timeout) { 
        clearTimeout(this._timeout); 
    }
    
    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {

	    uM_clearStatus()
        uM_showPL();

        // create a new delay before sending the request (i.e. reset the 300ms timer each time a key is pressed) 
        this._timeout = setTimeout(function(){ uM_s__doAction(); }, 300);  
    }); 
}


function uM_s__doAction(){

    require(['dojo/ready','dojo/dom','dojo/dom-style','dojox/grid/DataGrid','dojox/data/QueryReadStore','dojo/_base/xhr',
             'dojo/query','dojo/_base/fx','dijit/Dialog','dojox/grid/cells/dijit','dojox/grid/_CheckBoxSelector'],

        function(ready, dom, domStyle, DataGrid, QueryReadStore, xhr, query, fx, dialog){
        
        ready(function(){ 

            query('.formLoginDialog').forEach(function(node, index, arr){
			    var id = node.getAttribute('id');
			    dijit.byId(id).destroyRecursive();
		    });

		    action = dom.byId('sigAction').getAttribute('value');
		    var activeUser = dom.byId('activeUser').getAttribute('value');
		    
		    sGrid = dijit.byId('sigsGrid');

		    dom.byId('sigsGrid').focus();

            var selSig = dom.byId('selSig').getAttribute('value'); 
		    var selSig_ = selSig.split(',');

		    if (action == 'activate') {

		     	uM_s_activate(); 

		    } else if (action == 'revoke') {        

		        var block = 0;
		        for (var i = 3; i < selSig_.length; i = i + 4){
		            if (selSig_[i] == 'Administrator' && selSig_[i-1] != activeUser) { 
		                var block = 1;
		                var user = selSig_[i-1]; 
		                var msgErr = '<b>' + user + '</b> is an administrator user';
		                break
		            }
		        }
		        
		        if (!block) { 
		            uM_s_revoke();
		        } else {
		            uM_XHRerror(msgErr);
		        }
		    
		    } else {   

		        var block = 0;
		        for (var i = 3; i < selSig_.length; i = i + 4){
		            if (selSig_[i] == 'Administrator' && selSig_[i-1] != activeUser) { 
		                var block = 1;
		                var user = selSig_[i-1]; 
		                var msgErr = '<b>' + user + '</b> is an administrator user';
		                break
		            }
		        }  
		        if (!block) { 
		            uM_s_remove();
		        } else {
		            uM_XHRerror(msgErr);
		        }
		    }
        });
    });
}


function uM_s_activate() {

    require(['dojo/dom','dojo/_base/xhr'], function(dom, xhr){

        var selSig = dom.byId('selSig').getAttribute('value');
	    var selSig_ = selSig.split(',');   

        var sigsData = new Array();
	    for (var i=0; i<selSig_.length; i=i+4){
		    sigsData.push(selSig_[i]);
            sigsData.push(selSig_[i+1]);
		}
	    sigsData.join();
	    var sigsData = sigsData.toString();
	
        xhr.post({
            url: './../login/activate',
            handleAs: 'json',
            postData: { 'what': 'signatures', 'data': sigsData, 'action': action },
            load: function(jsonData) {
                uM_s_XHRrespond(jsonData);
	        }
        });
    });
}


function uM_s_revoke() {

    require(['dojo/dom','dojo/_base/xhr'], function(dom, xhr){
    
        var selSig = dom.byId('selSig').getAttribute('value');
	    var selSig_ = selSig.split(',');   

        var sigsData = new Array();
	    for (var i=0; i<selSig_.length; i=i+4){
		    sigsData.push(selSig_[i]);
            sigsData.push(selSig_[i+1]);
		}
	    sigsData.join();
	    var sigsData = sigsData.toString();
	
        xhr.post({
            url: './../login/inactivate',
            handleAs: 'json',
            postData: { 'what': 'signatures', 'data': sigsData, 'action': action },
            load: function(jsonData) {
                uM_s_XHRrespond(jsonData);
		    }
        });
    });
}


function uM_s_remove() {

    require(['dojo/dom','dojo/_base/xhr'], function(dom, xhr){  
        
        var selSig = dom.byId('selSig').getAttribute('value');
	    var selSig_ = selSig.split(',');   

         var sigsData = new Array();
	    for (var i=0; i<selSig_.length; i=i+4){
	        sigsData.push(selSig_[i]);
            sigsData.push(selSig_[i+1]);
	    }
	    sigsData.join();
	    var sigsData = sigsData.toString();
	
        xhr.post({
            url: './../login/delete',
            handleAs: 'json',
            postData: { 'what': 'signatures', 'data': sigsData, 'action': action },
            load: function(jsonData) {
                uM_s_XHRrespond(jsonData);
		    }
        });
    });
}


function uM_s_XHRrespond(jsonData) {

    require(['dojo/dom','dojo/dom-style'], function(dom, domStyle) {

        var opResult = jsonData.opResult.toString();

	    if (opResult.match(/^ERROR/)) {
            var msgError = jsonData.error.toString();
            sigsXHRerror(msgError); 
                                
	    } else {
	        var msg = jsonData.msg.toString();
            var msgError = jsonData.msgErr.toString();
	        if (msg != '') {
		        uM_doSearch();
                var tick = 'true';
            }
            if (msgError != '') {
                if (msg == '') { 
                    var lmsgError = msgError.split(',');
                    var msg = msgError[msgError.length-1]; 
                }
		        var tick = 'false';
            }
            uM_showStatus(tick, msg);
         }
    });
}


function sig_info(j, depth) {

    for (i = 0; i < depth; i++) {
	    var certD_det = 'certD_det_' + i;
        var certD_id = 'certD_id_' + i;

        require(['dojo/dom-style'], function(domStyle){
            if (i == j) {
                domStyle.set(certD_det, 'display', 'block');
                domStyle.set(certD_id, 'fontWeight', 'bold');
            } else {
                domStyle.set(certD_det, 'display', 'none');
                domStyle.set(certD_id, 'fontWeight', 'normal');
            }
        });
    }
}

