
proc ::mysql::auto_encoding { handle } {
    
    set server_version [lindex [mysql::sel $handle "select @@version" -flatlist] 0]
    if { [regexp {^4[.][1-9]} $server_version] || [regexp {^[5-9]} $server_version] } {
	set csd [lindex [mysql::sel $handle "select @@character_set_database" -flatlist] 0]
	# we do not like latin1 databases. It can happen that the database has still not
	# used "mysqluse" and by defaults returns "latin1"
	if { $csd eq "latin1" } {
	    set csd "utf8"
	}
    }
    if { [::info exists csd] && $csd == "utf8" } {
	mysql::encoding $handle utf-8
	mysql::exec $handle "set names 'utf8'"
	return utf-8
    } else {
	mysql::encoding $handle binary
	return binary
    }
}
package provide mysqltcl 3.052
