#!/bin/bash -f

#    OutputFile: $2/$1.flavia.inf
#    ErrorFile: $2/$1.flavia.err
#    WarningFile: $2/$1.flavia.war

# set -e is commented out because we wnat to write the error in case of segfault
# set -e
if [ ! -e "$3/exec/tdyn" ]
then
echo "error: This distribution does not contain the UNIX executable" >> "$2/$1.err"
fi

prbgidDir="$3" # path to compassfem.gid that contains the current bat file
dir=$prbgidDir/../../problemtypes
rm -f "$2/$1.txt"
if test -d $dir; then
    libDir=$dir/../lib
    exeDir=$prbgidDir/exec
    export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$exeDir:$libDir
    echo "LD_LIBRARY_PATH = $LD_LIBRARY_PATH" >> "$2/$1.txt"
else
    exeDir=$prbgidDir/exec
    export LD_LIBRARY_PATH=$exeDir:~/gidproject/lib
    echo "LD_LIBRARY_PATH = $LD_LIBRARY_PATH" >> "$2/$1.txt"
fi

rm -f "$2/$1.flavia.err" "$2/$1.flavia.res" "$2/$1.flavia" "$2/$1.post"
mv "$2/$1.dat" "$2/$1.flavia"

# export HDF5_DISABLE_VERSION_CHECK=1

"$3/exec/tdyn" -name "$2/$1.flavia" > "$2/$1.flavia.out"

if [ ! -e "$2/$1.flavia.res" -o ! -s "$2/$1.flavia.res" ]
then
    echo "Result files do not exist. Program failed." >> "$2/$1.err"
fi
 
