#!/bin/bash -f

#    OutputFile: $2/$1.info
#    ErrorFile: $2/$1.err
#    WarningFile: $2/$1.war

# set -e is commented out because we wnat to write the error in case of segfault
# set -e
if [ ! -e "$3/exec/tdyn" ]
then
echo "error: This distribution does not contain the UNIX executable" >> "$2/$1.err"
fi

prbgidDir="$3" # path to compassfem.gid that contains the current bat file
dir=$prbgidDir/../../problemtypes
rm -f "$2/$1.txt"
if test -d $dir; then
    libDir=$dir/../lib
    exeDir=$prbgidDir/exec
    export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$exeDir:$libDir
    echo "LD_LIBRARY_PATH = $LD_LIBRARY_PATH" >> "$2/$1.txt"
else
    exeDir=$prbgidDir/exec
    export LD_LIBRARY_PATH=$exeDir:~/gidproject/lib
    echo "LD_LIBRARY_PATH = $LD_LIBRARY_PATH" >> "$2/$1.txt"
fi

rm -f "$2/$1.flavia.msh" "$2/$1.flavia.res" "$2/$1.info" "$2/$1_steel.html"
"$3/exec/ramseries" -i "$2/$1.info" -e "$2/$1.err" -w "$2/$1.war" "$2/$1.dat" &> "$2/$1.err"
if [ ! -e "$2/$1.flavia.res" -o ! -s "$2/$1.flavia.res" ]
then
  echo "Result files do not exist. Program failed." >> "$2/$1.err"
fi
 
