#!/bin/bash -f

# OutputFile: $2/$1.flavia.inf
# WarningFile: $2/$1.flavia.war
# ErrorFile: $2/$1.flavia.err
# OutFile: $2/$1.flavia.out

if [ ! -e "$3/exec/seabem" ]
then
echo "error: This distribution does not contain the UNIX executable" >> "$2/$1.err"
fi

rm -f "$2/$1.flavia.res"
rm -f "$2/$1.flavia.err"
rm -f "$2/$1.flavia.war"

rm -f "$2/damping_matrix.dat"
rm -f "$2/DiffractionForce.tec"
rm -f "$2/ExcitationForce.tec"
rm -f "$2/Fe.dat"
rm -f "$2.IRF.dat"
rm -f "$2/hydrodynamic_restoration_matrix.dat"
rm -f "$2/added_mass_matrix.dat"
rm -f "$2/$1.Raos.res"
rm -f "$2/$1.Raos_phase.res" 
rm -fr "$2/Nemoh_output"
rm -fr "$2/mesh"
rm -fr "$2/results"
rm -fr "$2/Kochin"

mkdir "$2/mesh"
mkdir "$2/results"
mkdir "$2/Kochin"

prbgidDir="$3" # path to compassfem.gid that contains the current bat file
dir=$prbgidDir/../../problemtypes
rm -f "$2/$1.txt"
if test -d $dir; then
    libDir=$dir/../lib
    exeDir=$prbgidDir/exec
    export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$exeDir:$libDir
    echo "LD_LIBRARY_PATH = $LD_LIBRARY_PATH" >> "$2/$1.txt"
else
    exeDir=$prbgidDir/exec
    export LD_LIBRARY_PATH=$exeDir:~/gidproject/lib
    echo "LD_LIBRARY_PATH = $LD_LIBRARY_PATH" >> "$2/$1.txt"
fi

echo $prbgidDir >> "$2/$1.txt"
echo $3/exec/seabem >> "$2/$1.txt"
echo $2 >> "$2/$1.txt"
echo $1 >> "$2/$1.txt"

cd $2
"$3/exec/seabem" -r $2 $1 >> "$2/$1.flavia.out"

if [ ! -e "$2/$1.flavia.res" -o ! -s "$2/Nemoh_output" ]
then
  echo "Result files do not exist. Program failed." >> "$2/$1.err"
fi

if [ ! -e "$2/Nemoh_output" ]
then
    mkdir "$2/Nemoh_output"
fi

# mv -f "$2/mesh" "$2/Nemoh_output/mesh"
# mv -f "$2/Normalvelocities.dat" "$2/Nemoh_output"
# mv -f "$2/results" "$2/Nemoh_output"
# mv -f "$2/$1.cal" "$2/Nemoh_output/Nemoh.cal"

