#!/bin/bash -f

# OutputFile: $2/$1.flavia.inf
# WarningFile: $2/$1.flavia.war
# ErrorFile: $2/$1.flavia.err

# set -e is commented out because we want to write the error in case of segfault
# set -e
if [ ! -e "$3/exec/tdyn" ]
then
echo "error: This distribution does not contain the UNIX executable" >> "$2/$1.err"
fi

rm -f "$2/$1.flavia"
rm -f "$2/$1.flavia.err"
rm -f "$2/$1.flavia.ram.msh"
rm -f "$2/$1.post"
rm -f "$2/$1.flavia.res"
rm -f "$2/$1.BodyVelocities.res"
rm -f "$2/$1.BodyPressureLoads.res"
rm -f "$2/$1.BodyMovements.res"
rm -f "$2/$1.BodyLoads.res"
rm -f "$2/$1.BodyAccelerations.res"
rm -f "$2/$1.Seal_Loads.res"
rm -f "$2/$1.Outputs.res"
rm -f "$2/$1.BodyMovements_animations.res"
rm -f "$2/$1.Raos.res"
rm -f "$2/$1.MooringResults.msh"
rm -f "%2/%1.MooringResults.res"
rm -f "%2/%1.MooringLoads.res"

mv "$2/$1.dat" "$2/$1.flavia"

prbgidDir="$3" # path to compassfem.gid that contains the current bat file
dir=$prbgidDir/../../problemtypes
rm -f "$2/$1.txt"
if test -d $dir; then
    libDir=$dir/../lib
    exeDir=$prbgidDir/exec
    export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$exeDir:$libDir
    echo "LD_LIBRARY_PATH = $LD_LIBRARY_PATH" >> "$2/$1.txt"
else
    exeDir=$prbgidDir/exec
    export LD_LIBRARY_PATH=$exeDir:~/gidproject/lib
    echo "LD_LIBRARY_PATH = $LD_LIBRARY_PATH" >> "$2/$1.txt"
fi

"$3/exec/tdyn" -name "$2/$1.flavia" -SeaWaves > "$2/$1.flavia.out"

if [ ! -e "$2/$1.flavia.res" -o ! -s "$2/$1.flavia.res" ]
then
  echo "Result files do not exist. Program failed." >> "$2/$1.err"
fi

# Renaming results files
FILES="
Outputs.res
Raos.res
BodyKinematics.res
BodyMovements_animations.res
BodyPressureLoads.res
BodyJointReactions.res
BodyLoads.res
MooringData.res
MooringResults.msh
MooringResults.res
MooringLoads.res
Seal_Loads"

for file in $FILES
do
    if [ -e "$2/$file" ]
    then
	mv "$2/$file" "$2/$1.$file"
    fi
done
