# ConfigureProgram -*- TCL -*-
#----------------------Configuration section-----------------------------

# name of the game
set GidPriv(ProgName,Default) "Tdyn"
set GidPriv(Organization,Default) "Compass Engineering <info@compassis.com>"

# web page of the program
set GidPriv(ProgWeb,Default) "http://www.compassis.com"
# web page to obtain a password to register the program
set GidPriv(PassWeb,Default) "http://www.compassis.com/compass/en/Passwords"
set ::GidPriv(WebDownload,Default) "www.gidhome.com/download"
set ::GidPriv(WebLinkColour,Default) \#0000ff
# contact mail
set ::GidPriv(ContactMail,Default) "gid@cimne.upc.edu"

#similar but related to the problemtype
set ::GidPriv(ProblemtypeWeb,Default) $::GidPriv(ProgWeb,Default)
set ::GidPriv(ProblemtypeWebPassword,Default) $::GidPriv(PassWeb,Default)
set ::GidPriv(ProblemtypeWebDownload,Default) $::GidPriv(WebDownload,Default)
set ::GidPriv(ProblemtypeContactMail,Default) $::GidPriv(ContactMail,Default)


#to change in the help->About, the showed internal GiD version number
#for another alternative text version of a particular developer
#(e.g set ::GidPriv(TextOfVersion) "MyProgram 4.0" )
set GidPriv(TextOfVersion,Default) "13.7.3.0"


#images to be customized:

set ::GidPriv(SplashWindow) GiDsplash.png ;#used in the splash window        
set GidPriv(AboutWindow) [file join $GIDDEFAULT bitmaps about-compass.gif]
set GidPriv(InfoGiDBitmapName) "info_compass.gif"
#are expected three more images for the status {a p t} info_gid_{status}.png  ,for evaluation (academic), professional or temporal
set GidPriv(InfoGiDProc) "CreateCompassInfo_win" ;source [file join $GIDDEFAULTTCL compass_info_win.tcl]
set ::GidPriv(FolderGiDBitmapName) GiDdirectory.png ;#used in the file browser and register problem type window
set ::GidPriv(FolderHiddenGiDBitmapName) GiDdirectory_h.png ;#the same but for folders with hidden attribute

set ::GidPriv(LogosGiDBitmapName) GiDlogo.png ;#used in the printed images
set ::GidPriv(LogosGiDBitmapName32) GiDlogo32.png ;#used in the printed images

#now for printed images it is used: resources/textures/GiDlogo.png ( hi-res logo) and GiDlogo32.png ( 32pix height)
#for window decoration:
#are expected eight more images with different size: 16 24 32 48 64 128 256 512 named GiDlogo${size}.png
#placed at: \themes\GiD_classic\images\GiDlogo${size}.png
# gid.ico (for Windows it is the icon compiled in the exe and the installer put it in the desktop)



#to customize the default extension of the calculation file, for example ".nas" for Nastran
set ::GidPriv(CalculationFileExtension,Default) ".dat"

#::GidPriv(MenuType) defined on gid_themes::SetOptions

#variable to hide volume level menus and tools
set ::GidPriv(HideVolumeLevel,Default) 0
 
#variable to hide quadratic options: Normal (linear), Quadratic, Quadratic9
#integer value representing a binary array of 3 bits from left to right, 1 to hide 0 to show
#e.g. values: 0=000 not hide nothing
#             1=001 to hide linear
#             6=110 to hide quadratic and quadratic9
set ::GidPriv(HideQuadraticTypeLevel,Default) 0

#unset -nocomplain ::GID_INTERNAL_GROUPS ;#unset to disable show groups window
set ::GidPriv(ShowGroupsTab,Default) 1 ;#0 to not show a tab for groups inside the layers frame ('GiD_Groups window open' an external window)

#if a procedure 'configure_program_proc' exists, it will be executed as the last step
#can be implemented to do some special initialization. Its prototype is:

    proc configure_program_proc {} {
	catch {
	    lappend ::auto_path $::GIDDEFAULT/problemtypes/common_lib
	    package require gid_groups_conds
	    check_gid_help
	}
	GiD_Set MaintainProblemTypeInNew 1
	GiD_Set SplashWindow 0
	GiD_Set BackColorType 1
	GiD_Set BackColorTop #929ae7
	GiD_Set BackColorBottom #ffffff
	GiD_Set BackColorSense ul 
	GiD_Set ShowCheckNewVersion 0        
    }


# 3D or 2D (to restrict integrals and stream lines to be like 2d discarding z)
set ::GidPriv(PostSpaceDimension) 3D

set ::GidPriv(Configuration) release ;#relase or debug
set ::GidPriv(ShowPackages) 0 ;#show packages information loading GiD
set ::GidPriv(ChangeButtonMeaning) 1 ;# use of mouse button changes:0 old_bindings , 1 new_bindings
#To customize some widget colors see gid_themes
set ::GidPriv(ThemeSelection) 1

#----------------------End configuration section-------------------------


#---------------------- Info section -------------------------
# tcl functions related to internal GiD version number
# format: n1.n2[.n3][char] (e.g: 10.1.1b or 10.2 are valid)
# This version number is used to compare is a version is more recent to another

# proc GidUtils::VersionCmp { Version }
# return -1 if Internal GiD Version < Version
# return  0 if Internal GiD Version == Version
# return  1 if Internal GiD Version > Version
# Internal GiD Version must be asked with [GiD_Info GiDVersion]

# proc GidUtils::VersionNumber { VersionString } convert the string to an integer
# (e.g. "9.1.2b" return 901020)

# proc GidUtils::VersionSubchar { VersionString } return the char if exist
# (e.g. "9.1.2b" return b)

#----------------------End Info section -------------------------



#to debug whitout open a window
if { $::GidPriv(Configuration) == "debug" } {
    if {$tcl_platform(platform) == "unix"} {
	set tmpdir /tmp
    } else {
	set tmpdir $env(tmp)
    }
    set ::GidPriv(SetDebugFileName) [file join $tmpdir DebugGiDTcl.log]
}
set ::GidPriv(DebugInitialized) 0

proc ConfigureProgramSetVariablesDefault { } {   
    foreach item {ProgName Organization ProgWeb PassWeb WebDownload WebLinkColour ContactMail TextOfVersion \
		      CalculationFileExtension HideVolumeLevel HideQuadraticTypeLevel ShowGroupsTab \
		      ProblemtypeWeb ProblemtypeWebPassword ProblemtypeWebDownload ProblemtypeContactMail} {
	#temporary remove raise trace events, like GidPriv(HideVolumeLevel) that raise UpdateMenusAndToolbars
	set infotrace [trace info variable ::GidPriv($item)]
	if { $infotrace != "" } {	   
	    foreach data $infotrace {
		trace remove variable ::GidPriv($item) {*}$data
	    }
	}
	set ::GidPriv($item) $::GidPriv($item,Default)
	if { $infotrace != "" } {
	    foreach data $infotrace {
		trace add variable ::GidPriv($item) {*}$data
	    }
	}
    }
}

ConfigureProgramSetVariablesDefault
