
namespace eval Groups {
    variable allow_select_lower_entities 0 ;#better not show to allow select lowerentities for groups
    variable also_lower_entities 0 ;#by default not select also lowerentities, it is dangerous to select unwanted entities
    variable _fullnames
    variable _T
}

proc Groups::Test { args } {
    WarnWinText "Groups::Test $args"
}

proc Groups::OpenOutside {  { w .gid.central.wgroup } } {
    if { [winfo exists $w] } {
        destroy $w
    }
    InitWindow $w [_ "Groups"] GroupsWindowGeom Groups::OpenOutside
    if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0   
    Groups::Win $w
    #add lower buttons
    ttk::frame $w.buts -style BottomFrame.TFrame
    ttk::button $w.buts.close -text [_ "Close"] -command [list destroy $w] -style BottomFrame.TButton
    grid $w.buts.close -sticky ew -padx 5 -pady 6
    grid $w.buts -sticky ews -pady {2 0}
    grid anchor $w.buts center
    bind $w <Alt-c> "destroy $w"
    bind $w <Escape> "destroy $w"
}

#-button1handler of fulltktree works bad, not allow multiple selection and other bugs...
proc Groups::Button1_trick { T x y } {       
    set sel [$T selection get]
    set identify [$T identify $x $y]
    if { $sel == "" } { 
        #I don't know why when clicking the element rect of the color the selection is cleared!!
        if { [lindex $identify 0] == "item" } {
            set id [lindex $identify 1]
            $T selection add $id
            set sel [$T selection get]
            set sel $id
        }            
    }    
    return [Groups::Button1 $T $sel $identify $x $y]
}

proc Groups::CreateListWin { w } {  
    package require fulltktree
        
    #trick: set the color column as 'text' but this is falsem after set its style to 's_color_text' 
    #the name and style must have the word 'text' to avoid an error selecting the range to be ordered!!
    set columns [list \
            [list 10 [_ "Name"] left text 1 1] \
            [list 5 [_ "C#C#Color"] center text 1 0] \
            [list 5 [_ "I/O#C#On/Off"] center image 1 0] \
            [list 5 [_ "Tr#C#transparent"] center image 1 0] \
            ]
    #set sort_columns {dictionary dictionary integer {command Groups::ImageCmp}}
    set sort_columns {dictionary integer integer integer}
    
    set T [fulltktree $w.t \
            -returnhandler Groups::CreateNewAux \
            -contextualhandler Groups::ContextualMenu \
            -editbeginhandler Groups::RenameStart \
            -editaccepthandler Groups::RenameEnd \
            -deletehandler Groups::Delete \
            -draghandler Groups::DragAndDrop \
            -columns $columns -expand 1 -compass_background 0 \
            -selectmode extended -showheader 1 \
            -showroot 0 -showbutton 0 -showrootbutton 0 \
            -width 240 -height 240 -borderwidth 0 \
            -sort_type_cols $sort_columns \
            -item_image "" -folder_image "" -arrow_image_expand 0 \
            -showlines 1 -indent 15]
    #-button1handler Groups::Button1
    #-selecthandler2 {Groups::Test press2}        
    #-font SystemFont
    
    set t1 [$T givetreectrl]
    gid_themes::ConfigureHeaders $t1
    gid_themes::ApplyHeadersConfig $t1
    
    #-button1handler of fulltktree works bad, not allow multiple selection and other bugs...
    #and also works bad <ButtonRelease-1> because the selection is lost in the special 's_color_text' column
    #bind $T <ButtonRelease-1> "Groups::Button1_trick %W %x %y"    
    bind $T <ButtonPress-1> "Groups::Button1_trick %W %x %y"
    
    $T element create e_col_rect rect -fill "" -outline black -width 17 -height 17 -outlinewidth 1        
    #trick: set the color column as 'text' but this is falsem after set its style to 's_color_text' 
    #the name and style must have the word 'text' to avoid an error selecting the range to be ordered!!
    set S [$T style create s_color_text]
    $T style elements $S [list e_hidden e_rect e_col_rect e_text_sel e_selmarker_up e_selmarker_down]
    
    #$T style layout $S e_hidden -padx 0 -squeeze x -expand nswe
    $T style layout $S e_hidden -visible 0
    $T style layout $S e_col_rect -expand nsew
    #$T style layout $S e_text_sel -squeeze x -sticky w
    $T style layout $S e_rect -union [list e_text_sel] -iexpand nswe
    
    $T style layout $S e_selmarker_up -detach 1
    $T style layout $S e_selmarker_up -height 2 -sticky nwe -iexpand x
    $T style layout $S e_selmarker_down -detach 1 -expand n
    $T style layout $S e_selmarker_down -height 2 -sticky swe -iexpand x
    
    #modify also the layout of fulltktree 'image' style to hide the element 'e_hidden'
    #because I am using this 'e_hidden' field as a trick to store a text to sort the column
    $T style layout image e_hidden -visible 0            
    return $T
}

proc Groups::Win { w } {            
    variable _T
    
    if { ![winfo exists $w.middle] } {
        ttk::frame $w.middle
        set T [Groups::CreateListWin $w.middle]
        set _T $T
        
        grid $T -sticky nsew -padx 1 -pady 1
        grid configure $T -pady "2 0"
        
        ttk::frame $w.top -style ForcedFrame          
        ttk::button $w.top.new -image [gid_themes::GetImage group_new.png small_icons] -command [list Groups::CreateNew $T] -style IconButton
        GidHelp $w.top.new [_ "Create a new group at root level."]
        ttk::button $w.top.newfolder -image [gid_themes::GetImage group_newfolder.png small_icons] -command [list Groups::CreateNewFolder $T] -style IconButton
        GidHelp $w.top.newfolder [_ "Create a new child group with the selected parent."]
        ttk::button $w.top.delete -image [gid_themes::GetImage erase-cross.png small_icons] -command [list Groups::Delete $T] -style IconButton
        GidHelp $w.top.delete [_ "Delete a group."]
        ttk::menubutton $w.top.assign -image [gid_themes::GetImage group_assign.png small_icons] -menu $w.top.assign.m -takefocus 1 -style IconButton
        GidHelp $w.top.assign [_ "Assign the selected entities to a group."]
        Groups::CreateMenuAssign $w.top.assign.m $T
        ttk::menubutton $w.top.unassign -image [gid_themes::GetImage group_unassign.png small_icons] -menu $w.top.unassign.m -takefocus 1 -style IconButton
        GidHelp $w.top.unassign [_ "Unassign the selected entities from a group."]
        Groups::CreateMenuUnassign $w.top.unassign.m $T    
        ttk::button $w.top.draw -image [gid_themes::GetImage group_draw.png small_icons] -command [list Groups::Draw $T] -style IconButton
        GidHelp $w.top.draw [_ "Draw groups by color"]
        ttk::button $w.top.list_entities -image [gid_themes::GetImage list.png small_icons] -command [list Groups::ListEntities $T] -style IconButton
        GidHelp $w.top.list [_ "List group entities"]
        if { [llength [GiD_Info conditions ovgroup]] } {
            ttk::button $w.top.list_conditions -image [gid_themes::GetImage condition.png small_icons] -command [list Groups::ListConditions $T] -style IconButton
            GidHelp $w.top.list_conditions [_ "List group conditions"]      
            grid $w.top.new $w.top.newfolder $w.top.delete $w.top.assign $w.top.unassign \
                $w.top.draw $w.top.list_entities $w.top.list_conditions -sticky w 
        } else {            
            grid $w.top.new $w.top.newfolder $w.top.delete $w.top.assign $w.top.unassign \
                $w.top.draw $w.top.list_entities -sticky w
        }
        
        grid $w.top -sticky ew
        grid $w.middle -sticky nsew
           
        grid columnconfigure $w.middle 0 -weight 1
        grid rowconfigure $w.middle 0 -weight 1
        
        grid columnconfigure $w 0 -weight 1
        grid rowconfigure $w 1 -weight 1
    } else {
         Groups::ClearTree $T
    }        
    Groups::FillInfoTree $T "" 0
    focus $T
}

proc Groups::CreateMenuAssign { m T } {
    variable allow_select_lower_entities
    variable also_lower_entities
    menu $m -postcommand [list Groups::CreateMenuAssign2 $m $T]
    if { $allow_select_lower_entities } {
        $m add check -label [_ "Also lower entities"] -variable ::Groups::also_lower_entities
    }
    $m configure -activeborderwidth 1
}

proc Groups::CreateMenuAssign2 { m T } {  
    set geometry_labels [GetGeometryLabels 1]                                                                   
    set geometry_commands [GetGeometryCommands 1]
    lset geometry_commands end All_Geom_Types ;#replace All by All_Geom_Types
    set allow_select_all_mesh_types 1 ;#set 0 until GiD is able to simultaneously select element faces and elements/nodes
    if { $allow_select_all_mesh_types } {
        set mesh_labels [GetMeshLabels 1]
        set mesh_commands [GetMeshCommands 1]
        lset mesh_commands end All_Mesh_Types ;#replace All by All_Mesh_Types        
    } else {        
        set mesh_labels [GetMeshLabels 0]
        set mesh_commands [GetMeshCommands 0]
    }
    set mesh_labels [linsert $mesh_labels 2 [_ "Faces"]]
    set mesh_commands [linsert $mesh_commands 2 Faces]
    AddEntitiesToMenu $m [list Groups::Assign $T] $geometry_labels $geometry_commands $mesh_labels $mesh_commands    
}

proc Groups::Assign { T over } {
    variable _fullnames
    variable also_lower_entities   
    set sel [$T selection get]
    if { [llength $sel] !=1 } {
        WarnWin [_ "before applying 'Entities' it is necessary to select 1 group"]
        return
    }
    set tree_id [lindex $sel 0]
    set fullname $_fullnames($tree_id)
    if { $also_lower_entities } {
        GiD_Process escape escape escape Utilities EntitiesGroups Assign $fullname LowerEntities $over
    } else {
        GiD_Process escape escape escape Utilities EntitiesGroups Assign $fullname $over
    }
    #set parent [winfo parent [winfo parent $T]]
    #FinishButton $parent $parent.top [_ "Press 'Finish' to end selection"] "" disableall [GiD_Set SmallWinSelecting]
    # $w is same parent as $::wChangeLayButtonFrame
    set w [ winfo parent $::wChangeLayFrame]
    FinishButton $w $::wChangeLayButtonFrame [_ "Press 'Finish' to end selection"] "" disableall [GiD_Set SmallWinSelecting]
}

proc Groups::CreateMenuUnassign { m T } {
    variable allow_select_lower_entities
    variable also_lower_entities
    menu $m -postcommand [list Groups::CreateMenuUnassign2 $m $T]
    if { $allow_select_lower_entities } {
        $m add check -label [_ "Also lower entities"] -variable ::Groups::also_lower_entities
    }
    $m configure -activeborderwidth 1
}

proc Groups::CreateMenuUnassign2 { m T } {     
    set geometry_labels [GetGeometryLabels 1]                                                                   
    set geometry_commands [GetGeometryCommands 1]
    lset geometry_commands end All_Geom_Types ;#replace All by All_Geom_Types
    set allow_select_all_mesh_types 1 ;#set 0 until GiD is able to simultaneously select element faces and elements/nodes
    if { $allow_select_all_mesh_types } {
        set mesh_labels [GetMeshLabels 1]
        set mesh_commands [GetMeshCommands 1]
        lset mesh_commands end All_Mesh_Types ;#replace All by All_Mesh_Types        
    } else {
        set mesh_labels [GetMeshLabels 0]
        set mesh_commands [GetMeshCommands 0]
    }
    set mesh_labels [linsert $mesh_labels 2 [_ "Faces"]]
    set mesh_commands [linsert $mesh_commands 2 Faces]
    AddEntitiesToMenu $m [list Groups::Unassign $T] $geometry_labels $geometry_commands $mesh_labels $mesh_commands
}

proc Groups::Unassign { T over } {
    variable _fullnames
    variable also_lower_entities   
    set sel [$T selection get]
    if { [llength $sel] !=1 } {
        WarnWin [_ "before applying 'Entities' it is necessary to select 1 group"]
        return
    }
    set tree_id [lindex $sel 0]
    set fullname $_fullnames($tree_id)
    if { $also_lower_entities } {
        GiD_Process escape escape escape Utilities EntitiesGroups Unassign $fullname LowerEntities $over
    } else {
        GiD_Process escape escape escape Utilities EntitiesGroups Unassign $fullname $over
    }
    #set parent [winfo parent [winfo parent $T]]
    #FinishButton $parent $parent.top [_ "Press 'Finish' to end selection"] "" disableall [GiD_Set SmallWinSelecting]
    set w [ winfo parent $::wChangeLayFrame]
    FinishButton $w $::wChangeLayButtonFrame [_ "Press 'Finish' to end selection"] "" disableall [GiD_Set SmallWinSelecting]
}

proc Groups::NameJoin { parent name } {
    if { $parent == "" } {
        set fullname $name
    } else {
        set fullname $parent//$name
    }                
    return $fullname
}

proc Groups::FillInfo { } {
    variable _T
#     variable _filling
#     if { [info exists _filling]} {
#         return
#     }
#     set _filling 1
    if { [GidUtils::IsTkDisabled] } {  
        #e.g. batch mode without windows
        return
    }
    if { [info exists _T] && [winfo exists $_T] } {
        Groups::ClearTree $_T
        Groups::FillInfoTree $_T
    }

    #update also the external window
    set nb .gid.central.wgroup.middle.t
    if { [winfo exists $nb] } {
        Groups::ClearTree $nb
        Groups::FillInfoTree $nb
    }    
#     unset _filling   
 
    DWSetCurrentGroupsToAssign
}

#forbidden_types is a list of not allowed types: points lines surfaces volumes elements faces
#warning: not add nodes to forbidden_types list, because now when meshing the nodes are always 
#         added to the group of the source entity!!
proc Groups::ListGroups { {state normal} {forbidden_types ""} } {
    set groups {}
    foreach group [GiD_Groups list] {
        if { [GiD_Groups get state $group] == $state } {
            set valid 1
            foreach over $forbidden_types {
                if { [GiD_EntitiesGroups get $group $over -count] } {
                    set valid 0
                    break
                }
            }
            if { $valid } {
                lappend groups $group                
            }
        }
    }
    return [lsort -unique -dictionary $groups]
}

proc Groups::ListChildGroups { parent {state normal} } {
    set groups {}
    foreach group [GiD_Groups list $parent] {
        set fullname [Groups::NameJoin $parent $group]
        if { [GiD_Groups get state $fullname] == $state } {
            lappend groups $group
        }
    }
    return [lsort -unique -dictionary $groups]
}


proc GiD_AfterCreateGroup { name } {
    DWSetCurrentGroupsToAssign
}

proc GiD_AfterRenameGroup { oldname newname } {
    DWSetCurrentGroupsToAssign
}

proc GiD_AfterDeleteGroup { name } {
    DWSetCurrentGroupsToAssign
}

proc Groups::ClearTree { T } {
    variable _fullnames
    unset -nocomplain _fullnames
    $T item delete all
}

proc Groups::FillInfoTree { T {parent ""} {tree_id_parent 0}} {
    variable _fullnames    
    set groups [Groups::ListChildGroups $parent]
    foreach group $groups {
        set fullname [Groups::NameJoin $parent $group]
        set tree_id [Groups::Create $T $fullname $tree_id_parent]        
        Groups::FillInfoTree $T $fullname $tree_id
    }
}

proc Groups::GetAutomaticName { {prefix ""} } {
    set names [GiD_Groups list] ;#warning, not use [Groups::ListEntities] to have also hidden groups
    for {set i 0} {$i<10000} {incr i} {
        set fullname [Groups::NameJoin $prefix Group${i}]
        if { [lsearch -exact $names $fullname] == -1 } { 
            break 
        }
    }
    return $fullname
}

proc Groups::CreateNewAux { T args } {
    #parent is a Fulltktree, T is TreeCtrl
    return [Groups::CreateNew [winfo parent $T] ""]
}

proc Groups::CreateNew { T {name ""}} {
    variable _fullnames

    set tree_id_parent 0
    set prefix ""
    if { $name == "" } {
        set name [Groups::GetAutomaticName $prefix]
    } else {
        #validate name
    }

    set fullname $name    
    #GiD_Groups create $fullname
    GiD_Process 'Groups Create $fullname escape
    
    set tree_id [Groups::Create $T $fullname $tree_id_parent]    
    
    Groups::StartRename $T $tree_id
        
    return $fullname
}

proc Groups::CreateNewFolder { T {name ""}} {
    variable _fullnames
    
    set prefix ""
    if { [$T selection count] == 1 } {
        set tree_id_parent [$T selection get 0]
        set prefix $_fullnames($tree_id_parent)
    } else {
        WarnWin [_ "A parent group must be selected before"]
        return ""
    }

    if { $name == "" } {
        set name [Groups::GetAutomaticName $prefix]
    } else {
        #validate name
    }

    set fullname $name
    #GiD_Groups create $fullname
    GiD_Process 'Groups Create $fullname escape
    
    set tree_id [Groups::Create $T $fullname $tree_id_parent]
    
    Groups::StartRename $T $tree_id
        
    return $fullname
}

proc Groups::IsOpaque { intensity } {
    if { $intensity == "ff"} {
        set res 1
    } else {
        set res 0
    }
    return $res
}

proc Groups::Create { T fullname tree_id_parent } {
    variable _fullnames
    set tailname [file tail $fullname];#GiD_Groups get name $fullname
    set rgba [GiD_Groups get color $fullname]
    set intensity [string range $rgba end-1 end]
    set color [string range $rgba 0 end-2]
    set visible [GiD_Groups get visible $fullname]
    if { $visible } {
        set img_visible [gid_themes::GetImage layer_on.png small_icons]
    } else {
        set img_visible [gid_themes::GetImage layer_off.png small_icons]
    }        
    if { [Groups::IsOpaque $intensity] } {
        set img_intensity [gid_themes::GetImage transparent_off.png small_icons]
    } else {
        set img_intensity [gid_themes::GetImage transparent_on.png small_icons]
    }    
    
    set tree_id [$T insert end [list $tailname "" $img_visible $img_intensity] $tree_id_parent]
    if { $tree_id_parent != 0 } {
        $T configure -indent 15 -showbutton 1 -showlines 1
    }        
    $T item style set $tree_id 1 s_color_text
    $T item element configure $tree_id 1 e_col_rect -fill $color + e_hidden -text 0x[string range $color 1 end]
    $T item element configure $tree_id 2 e_hidden -text $visible
    $T item element configure $tree_id 3 e_hidden -text 0x$intensity
    
    set _fullnames($tree_id) $fullname
    return $tree_id
}

#return true if itself or some child has entities assigned
proc Groups::NumEntitiesRecursive { parent } {
    set count 0
    if { $parent != "" } {
        set  count [GiD_Groups get num_entities $parent]
    }
    foreach child [GiD_Groups list $parent] {
        incr count [Groups::NumEntitiesRecursive [Groups::NameJoin $parent $child]]        
    }
    return $count
}

#return true if itself or some child has conditions assigned
proc Groups::NumConditionsRecursive { parent } {
    set count 0
    if { $parent != "" } {
        set  count [GiD_Groups get num_conditions $parent]
    }
    foreach child [GiD_Groups list $parent] {
        incr count [Groups::NumConditionsRecursive [Groups::NameJoin $parent $child]]        
    }
    return $count
}

proc Groups::Delete { T {sel ""} } {
    variable _fullnames
    if { $sel == "" } {
        set sel [$T selection get]
    }
    set delete_only_empty_groups 1
    set ask 1
    foreach tree_id $sel {
        #set fullname [$T item tag names $tree_id]
        set fullname $_fullnames($tree_id)
        if { ![GiD_Groups exists $fullname] } {
            #e.g. if its parent was also in the list, deleting them childs are deleted 
            continue
        }
        if { $ask } {
            set num_entities [Groups::NumEntitiesRecursive $fullname]
            set num_conditions [Groups::NumConditionsRecursive $fullname]
            if { $num_entities || $num_conditions } {
                if { $num_entities && $num_conditions } {
                    set message [_ "Group '%s' has '%s' entities. Delete it? (entities won't be deleted but applied conditions will be deleted also)" $fullname $num_entities]
                } elseif { $num_entities } {
                    set message [_ "Group '%s' has '%s' entities. Delete it? (entities won't be deleted)" $fullname $num_entities]
                } else {
                    set message [_ "Group '%s' has '%s' conditions. Delete it? (applied conditions will be deleted also)" $fullname $num_conditions]
                }
                set ret [tk_dialogRAM  .gid.modal [_ "Groups"] $message \
                             question 0 [_ "Cancel"] [_ "Yes"] [_ "No"] [_ "Yes to all"] [_ "No to all"]]
                if { $ret == 0 } {
                    #cancel
                    break
                } elseif { $ret == 1 } {
                    #yes: do it asking each time
                } elseif { $ret == 2 } {
                    #no: not to do but continue with the rest
                    continue
                } elseif { $ret == 3 } {
                    #yes to all: yes and not ask more
                    set ask 0
                    set delete_only_empty_groups 0
                } elseif { $ret == 4 } {
                    #no to all: no and not ask more (delete only empty groups)
                    set ask 0
                    set delete_only_empty_groups 1
                    continue
                } else {
                    break
                }
            }
        } else {
            if { $delete_only_empty_groups } {
                set num_entities [Groups::NumEntitiesRecursive $fullname]
                if { $num_entities} {
                    #delete only empty groups
                    continue
                }
            }
        }
        
        unset _fullnames($tree_id)
        $T item delete $tree_id 
        #GiD_Groups delete $fullname
        GiD_Process 'Groups Delete $fullname escape
    }    
}

proc Groups::Draw { T {sel ""} } {
    variable _fullnames
    if { $sel == "" } {
        set sel [$T selection get]
        if { $sel == "" } {
            #clicking the button wihout select nothing draw all
            $T selection add all
            set sel [$T selection get]
        }
    }
    set fullnames ""
    foreach tree_id $sel {        
        lappend fullnames $_fullnames($tree_id)
    }
    if { [llength $fullnames] } {        
        #GiD_Groups draw $fullnames
        GiD_Process 'Groups Draw {*}$fullnames escape
        set parent [winfo parent [winfo parent $T]]
        ##FinishButton $parent $parent.top [_ "Press 'Finish' to end selection"] {GiD_Groups end_draw} disableall [GiD_Set SmallWinSelecting]
        #FinishButton $parent $parent.top [_ "Press 'Finish' to end selection"] "" disableall [GiD_Set SmallWinSelecting]
        # $w is same parent as $::wChangeLayButtonFrame
        set w [ winfo parent $::wChangeLayFrame]
        FinishButton $w $::wChangeLayButtonFrame [_ "Press 'Finish' to end selection"] "" disableall [GiD_Set SmallWinSelecting]
    }
}

proc Groups::ListEntities { T {sel ""} } {
    variable _fullnames
    if { $sel == "" } {
        set sel [$T selection get]
        if { $sel == "" } {
            #clicking the button wihout select nothing list all
            $T selection add all
            set sel [$T selection get]
        }
    }
    set view_mode [GiD_Info Project ViewMode]
    if { $view_mode == "GEOMETRYUSE"}  {
        set over all_geometry
        set types [list [_ "Points"] [_ "Lines"] [_ "Surfaces"] [_ "volumes"]]
    } elseif { $view_mode == "MESHUSE"}  {
        set over all_mesh
        set types [list [_ "Nodes"] [_ "Elements"] [_ "Faces"]]
    } else {
        WarnWinText "Unexpected mode $view_mode"
        return 1
    }
    WarnWinText "" [_ "Groups"]   
    foreach tree_id $sel {
        set fullname $_fullnames($tree_id)
        set data [GiD_EntitiesGroups get $fullname $over]
        set has_entities 0
        foreach type $types type_data $data {        
            if { [llength $type_data] > 0 } {
                if { $type != [_ "Faces"] || [llength [lindex $type_data 0]] > 0} {                
                    set has_entities 1
                    break
                }
            }
        }
        if { $has_entities } {
            WarnWinText "$fullname:"
            foreach type $types type_data $data {
                if { [llength $type_data] > 0 } {
                    if { $type != [_ "Faces"] || [llength [lindex $type_data 0]] > 0} {
                        set txt ""
                        foreach element [lindex $type_data 0] face [lindex $type_data 1] {
                            lappend txt $element:$face
                        }
                        if { $type == [_ "Faces"] } {
                            WarnWinText "$type: $txt"
                        } else {
                            WarnWinText "$type: $type_data"
                        }
                    }
                }
            }
            WarnWinText ""
        }        
    }   
}

#return a list with items containing the condition name and its  values
proc Groups::GetConditionValues { fullname } {
    set values [list]
    foreach condition_name [GiD_Info conditions ovgroup] {
        set condition_values [list]
        foreach data [GiD_Info conditions $condition_name geometry] {
            if { [lindex $data 1] == $fullname } {
                lappend condition_values [lrange $data 3 end]
            }
        } 
        if { [llength $condition_values] } {
            lappend values [list $condition_name $condition_values]
        }
    } 
    return $values
}

proc Groups::ListConditions { T {sel ""} } {
    variable _fullnames
    if { $sel == "" } {
        set sel [$T selection get]
        if { $sel == "" } {
            #clicking the button wihout select nothing list all
            $T selection add all
            set sel [$T selection get]
        }
    }
    WarnWinText "" [_ "Conditions"]
    set fullnames [list]
    foreach tree_id $sel {
        lappend fullnames $_fullnames($tree_id)
    }
    foreach fullname [lsort -dictionary $fullnames] {
        set group_data [Groups::GetConditionValues $fullname]
        if { [llength $group_data]} {
            WarnWinText "Group: $fullname"
            foreach item $group_data {
                lassign $item condition_name condition_values
                WarnWinText "[llength $condition_values] $condition_name"            
                foreach data $condition_values {
                    WarnWinText $data
                }             
                WarnWinText ""
            }
        }
    }   
}

proc Groups::RenameStart { T item col } {
    if { $col == 0 } {
        #return [list combo 1 $values ""]
        return [list entry]
    }
}

proc Groups::RenameEnd { T tree_id col newname } {
    variable _fullnames
    if { $col == 0 } {
        set fullname $_fullnames($tree_id)  
        set fullparentname [GiD_Groups get parent $fullname]
        set newfullname [Groups::NameJoin $fullparentname $newname]
        if { $fullname != $newfullname } {
            #GiD_Groups edit rename $fullname $newfullname
            GiD_Process 'Groups Edit Rename $fullname $newfullname escape
            $T item element configure $tree_id 0 e_text_sel -text $newname
            set _fullnames($tree_id) $newfullname  
            #must update also childs if any
            set prefix $fullname//
            set len [string length $prefix]
            foreach i [array names _fullnames] {
                if { [string range $_fullnames($i) 0 $len-1] == $prefix } {
                    set _fullnames($i) $newfullname//[string range $_fullnames($i) $len end]
                }                
            }            
        }
    }
}

proc Groups::StartRename { T {tree_id ""} } {
    #to start rename
    if { $tree_id == "" } {
        set sel [$T selection get]
        if { [llength $sel] == 1 } {
            set tree_id [lindex $sel 0]
        }
    }
    if { $tree_id == "" } {
        return
    }

    $T selection clear all
    $T selection add $tree_id    
    $T activate $tree_id
    $T see $tree_id
    focus [$T givetreectrl]
    update
    event generate [$T givetreectrl] <F2>    
}

proc Groups::Button1 { T sel identify x y } {      
    if { [llength $sel] == 1 } {
        #trick: when click on/off, etc of a row different of currently selected 
        #user want to set the clicked row, not the previously selected one
        set item [lindex $identify 1]
        set sel $item
    }
    set column [lindex $identify 3]
    if { $column == 1 } {
        #color                
        Groups::ChangeColor $T $sel
    } elseif { $column == 2 } {
        #on/off
        Groups::ChangeVisible $T $sel        
    } elseif { $column == 3 } {
        #intensity
        Groups::ChangeTransparency $T $sel 
    } else {
    }
}

proc Groups::ChangeColor { T {sel ""} {rgba ""} } {    
    variable _fullnames
    if { $sel == "" } {
        set sel [$T selection get]    
    }    
    set tree_id [lindex $sel 0]
    if { $tree_id == "" } {
        return
    }   
    if { $rgba == "" } {
        set fullname $_fullnames($tree_id)
        set rgba [GiD_Groups get color $fullname]    
        set rgba [GIDChooseColor .gid.selectcolor -title [_ "Select color"] -color $rgba]    
        if { $rgba == "" } {
            return
        }
    }
    set intensity [string range $rgba end-1 end]
    set color [string range $rgba 0 end-2]
    foreach tree_id $sel {
        set fullname $_fullnames($tree_id)
        #GiD_Groups edit color $fullname $rgba
        GiD_Process 'Groups Edit Color $fullname $rgba escape
        
        $T item element configure $tree_id 1 e_col_rect -fill $color + e_hidden -text 0x[string range $color 1 end]
    }
    GiD_Redraw
}

proc Groups::ChangeVisible { T {sel ""} {visible ""}} {    
    variable _fullnames
    if { $sel == "" } {
        set sel [$T selection get]    
    }    
    set tree_id [lindex $sel 0]
    if { $tree_id == "" } {
        return
    } 
          
    if { $visible == "" } {
        set fullname $_fullnames($tree_id)
        set visible [GiD_Groups get visible $fullname]   
        if { $visible } {
            set visible 0
        } else {
            set visible 1
        }    
    }
    if { $visible } {
        set img_visible [gid_themes::GetImage layer_on.png small_icons]
    } else {
        set img_visible [gid_themes::GetImage layer_off.png small_icons]
    }    
    foreach tree_id $sel {
        set fullname $_fullnames($tree_id)
        #GiD_Groups edit visible $fullname $visible
        GiD_Process 'Groups Edit Visible $fullname $visible escape
        $T item element configure $tree_id 2 e_image -image $img_visible + e_hidden -text $visible
    }
    GiD_Redraw
}

proc Groups::ChangeTransparency { T {sel ""} {intensity ""} } {    
    variable _fullnames
    
    if { $sel == "" } {
        set sel [$T selection get]    
    }    
    set tree_id [lindex $sel 0]
    if { $tree_id == "" } {
        return
    } 

    set fullname $_fullnames($tree_id)      
    set rgba [GiD_Groups get color $fullname]
    set color [string range $rgba 0 end-2]
    if { $intensity == "" } {
        set intensity [string range $rgba end-1 end]
        if { [Groups::IsOpaque $intensity] } {
            set intensity 7f ;#if set to intensity=00 will be invisible
        } else {
            set intensity ff
        }
    }
    if { [Groups::IsOpaque $intensity] } {
        set img_intensity [gid_themes::GetImage transparent_off.png small_icons]
    } else {
        set img_intensity [gid_themes::GetImage transparent_on.png small_icons]
    }    
    foreach tree_id $sel {
        set fullname $_fullnames($tree_id)
        set rgba [GiD_Groups get color $fullname]
        set color [string range $rgba 0 end-2]
        set rgba ${color}${intensity}        
        #GiD_Groups edit color $fullname $rgba
        GiD_Process 'Groups Edit Color $fullname $rgba escape
        $T item element configure $tree_id 3 e_image -image $img_intensity + e_hidden -text 0x$intensity
    }
    GiD_Redraw
}

proc Groups::DragAndDrop { T tree_id_new_parent sel place } {    
    variable _fullnames
    set change_parent 0
    if { $place == "center" } {
        set change_parent 1
        set fullparentname $_fullnames($tree_id_new_parent)                
    } elseif { $place == "prev" } {
        set change_parent 1
        set tree_id_new_parent 0
        set fullparentname ""         
    } elseif { $place == "next" } {
        set change_parent 1
        set tree_id_new_parent 0
        set fullparentname ""         
    }
    
    if { $change_parent } {
        foreach tree_id $sel {
            set tree_id_old_parent [$T item parent $tree_id]
            set fullname $_fullnames($tree_id)          
            #GiD_Groups edit parent $fullname $fullparentname  
            GiD_Process 'Groups Edit Parent $fullname $fullparentname escape
            set tailname [file tail $fullname] ;#GiD_Groups get name $fullname
            set newfullname [Groups::NameJoin $fullparentname $tailname]
            set _fullnames($tree_id) $newfullname
            $T item lastchild $tree_id_new_parent $tree_id
            if { $tree_id_new_parent != 0 } {
                #$T convert_to_folder $tree_id_parent
                $T item style map $tree_id_new_parent 0 folder [list e_text_sel e_text_sel]
                $T item configure $tree_id_new_parent -button 1
            } 
            
            if { ![$T item numchildren $tree_id_old_parent] } {
                #now old parent doesn't has any child
                $T item style map $tree_id_old_parent 0 text [list e_text_sel e_text_sel]
                $T item configure $tree_id_old_parent -button 0            
            }
        }
    }
}

proc Groups::ContextualMenu { T tree_id x y } {
    variable _fullnames
    
    set w $T.menucontextual
    if { [winfo exists $w] } {
        destroy $w
    }
    menu $w
    
    set n_selected [$T selection count]

    $w add command -label [_ "New group#C#group"] -command [list Groups::CreateNew $T] \
        -image [gid_themes::GetImage group_new.png small_icons] -compound left
    $w add command -label [_ "New child group#C#group"] -command [list Groups::CreateNewFolder $T] \
        -image [gid_themes::GetImage group_newfolder.png small_icons] -compound left        

    
    if { $n_selected == 1 } {
        $w add command -label [_ "Rename"] -command [list Groups::StartRename $T] -state normal \
            -image [gid_themes::GetImage rename.png small_icons] -compound left
    } else {
        $w add command -label [_ "Rename"] -state disabled \
            -image [gid_themes::GetImage rename.png small_icons] -compound left
    }
    if { $n_selected > 0 } {
        $w add command -label [_ "Delete"] -command [list Groups::Delete $T] -state normal \
            -image [gid_themes::GetImage erase-cross.png small_icons] -compound left
    } else {
        $w add command -label [_ "Delete"] -state disabled \
            -image [gid_themes::GetImage erase-cross.png small_icons] -compound left
    }
   
    $w add separator

    if { $n_selected > 0 } {
        set state normal
    } else {
        set state disabled
    }
    $w add command -label [_ "Color"]... -command [list Groups::ChangeColor $T] -state $state \
        -image [gid_themes::GetImage color.png small_icons] -compound left
    if { $n_selected == 1 } {
        set sel [$T selection get]
        set tree_id [lindex $sel 0]
        set fullname $_fullnames($tree_id)      
        set visible [GiD_Groups get visible $fullname]           
        set rgba [GiD_Groups get color $fullname]
        set color [string range $rgba 0 end-2]
        set intensity [string range $rgba end-1 end]                      
        if { $visible } {
            $w add command -label [_ "Off#C#verb"] -command [list Groups::ChangeVisible $T "" 0] -state $state \
                -image [gid_themes::GetImage layer_off.png small_icons] -compound left
        } else {
            $w add command -label [_ "On#C#verb"] -command [list Groups::ChangeVisible $T "" 1] -state $state \
                -image [gid_themes::GetImage layer_on.png small_icons] -compound left
        }
        if { [Groups::IsOpaque $intensity] } {
            $w add command -label [_ "Transparent#C#verb"] -command [list Groups::ChangeTransparency $T "" 7f] -state $state \
                -image [gid_themes::GetImage transparent_on.png small_icons] -compound left
        } else {
            $w add command -label [_ "Opaque#C#verb"] -command [list Groups::ChangeTransparency $T "" ff] -state $state \
                -image [gid_themes::GetImage transparent_off.png small_icons] -compound left
        }
    } else {
        $w add command -label [_ "On#C#verb"] -command [list Groups::ChangeVisible $T "" 1] -state $state \
            -image [gid_themes::GetImage layer_on.png small_icons] -compound left
        $w add command -label [_ "Off#C#verb"] -command [list Groups::ChangeVisible $T "" 0] -state $state \
            -image [gid_themes::GetImage layer_off.png small_icons] -compound left
        $w add command -label [_ "Opaque#C#verb"] -command [list Groups::ChangeTransparency $T "" ff] -state $state \
            -image [gid_themes::GetImage transparent_off.png small_icons] -compound left
        $w add command -label [_ "Transparent#C#verb"] -command [list Groups::ChangeTransparency $T "" 7f] -state $state \
            -image [gid_themes::GetImage transparent_on.png small_icons] -compound left
    }
    $w add separator
    $w add command -label [_ "Select all"] -command [list $T selection add all]
    $w add separator
    if { $n_selected == 1 } {
        $w add cascade -label [_ "Assign"] -menu $w.assign -state normal \
            -image [gid_themes::GetImage group_assign.png small_icons] -compound left
    } else {
        $w add cascade -label [_ "Assign"] -menu $w.assign -state disabled \
            -image [gid_themes::GetImage group_assign.png small_icons] -compound left
    }
    Groups::CreateMenuAssign $w.assign $T
    
    if { $n_selected == 1 } {
        $w add cascade -label [_ "Unassign"] -menu $w.unassign -state normal \
            -image [gid_themes::GetImage group_unassign.png small_icons] -compound left
    } else {
        $w add cascade -label [_ "Unassign"] -menu $w.unassign -state disabled \
            -image [gid_themes::GetImage group_unassign.png small_icons] -compound left
    }
    Groups::CreateMenuUnassign $w.unassign $T
        
    $w add command -label [_ "Draw groups by color"] -command [list Groups::Draw $T] -state $state \
        -image [gid_themes::GetImage group_draw.png small_icons] -compound left        
    $w add command -label [_ "List group entities"] -command [list Groups::ListEntities $T] -state $state \
        -image [gid_themes::GetImage list.png small_icons] -compound left
    if { [llength [GiD_Info conditions ovgroup]] } {
        $w add command -label [_ "List group conditions"] -command [list Groups::ListConditions $T] -state $state \
            -image [gid_themes::GetImage condition.png small_icons] -compound left
    }
    
    
#     $w add separator
#     $w add command -label [_ "Filter"] -command [list SelectLayersByRegexp $T] \
#         -image [gid_themes::GetImage filter.png small_icons] -compound left

    #set x [expr [winfo rootx $T]+$x+2]
    #set y [expr [winfo rooty $T]+$y]
    GiD_PopupMenu $w $x $y
}

#test of sorting with a tcl procedure
proc Groups::ImageCmp { T column tree_id1 tree_id2 } {
    set img_1 [$T item element cget $tree_id1 $column e_image -image]
    set img_2 [$T item element cget $tree_id2 $column e_image -image]
    return [string compare $img_1 $img_2]
}
