
set ::_Debug_PostAnim 0

proc DebugPostAnim { txt} {
    if { $::_Debug_PostAnim} {
	#WarnWinText "$txt"
	set fo [ open "/temp/bb.bb" a+]
	puts $fo $txt\n
	close $fo
    }
}

namespace eval AnimacionEstatica {
    variable _wid
    variable _tipo
    variable _pasos   
}

proc AnimacionEstatica::Cerrar { } {
    variable _wid

    if { ![info exists _wid] || ![ winfo exists $_wid] } { return}
    destroy $_wid
}

proc AnimacionEstatica::CambiaTipo { que} {
    variable _tipo

    set _tipo $que
}

proc AnimacionEstatica::Aceptar { } {
    variable _wid
    variable _tipo
    variable _pasos
    global AnimacionEstatica

    set res [ scan $_pasos %d pp]
    if { ( $res != 1) || ( $_pasos <= 1)} {
	WarnWin [_ "Number of steps for the animation should be > 1, and not '%s'" $_pasos] $_wid
    } else {
	set AnimacionEstatica(tipo) $_tipo
	set AnimacionEstatica(pasos) $_pasos
	AnimacionEstatica::Cerrar
    }
}

proc AnimacionEstatica::Crear { parent_w} {
    variable _wid
    variable _tipo
    variable _pasos 
    global AnimacionEstatica GIDDEFAULT
    set _tipo $AnimacionEstatica(tipo)
    set _pasos $AnimacionEstatica(pasos)

    if { $parent_w == "."} {
	set _wid .__w_Animacion_estatica
    } else {
	set _wid $parent_w.__w_Animacion_estatica
    }

    toplevel $_wid
    set w $_wid
    if { $::tcl_platform(platform) == "windows" } {        
	wm attributes $w -toolwindow 1
    }

    wm title $_wid [_ "Creating animation of static analysis"]


    #set def_back [ $parent_w cget -background]
    #set realzado [ CCColorActivo $def_back]

    ttk::frame $_wid.f

    foreach ti "Lineal Cosine Triangular Sinusoidal" {
	if { ![ info exists _imagenes($ti)]} {
	    set _imagenes($ti) [gid_themes::GetImage StaticAnim$ti.png]
	}
    }
    ttk::radiobutton $_wid.f.rd1 -image $_imagenes(Lineal) -value Lineal -variable AnimacionEstatica::_tipo
    ttk::radiobutton $_wid.f.rd2 -image $_imagenes(Cosine) -value Cosine -variable AnimacionEstatica::_tipo
    ttk::radiobutton $_wid.f.rd3 -image $_imagenes(Triangular) -value Triangular -variable AnimacionEstatica::_tipo
    ttk::radiobutton $_wid.f.rd4 -image $_imagenes(Sinusoidal) -value Sinusoidal -variable AnimacionEstatica::_tipo

    ttk::label $_wid.f.l -text [_ "Steps"]:
    ttk::entry $_wid.f.e -width 5 -textvariable AnimacionEstatica::_pasos
    # -borderwidth 1 -relief sunken


    grid $_wid.f.rd1 $_wid.f.rd2 -sticky w -pady 3 -padx 4
    grid $_wid.f.rd3 $_wid.f.rd4 -sticky w -pady 3 -padx 4
    grid $_wid.f.l $_wid.f.e -sticky e -pady 3 -padx 4
    grid configure $_wid.f.e -sticky w

    # marco de los botones
    ttk::frame $_wid.but -style BottomFrame.TFrame
    # -background $realzado

    ttk::button $_wid.but.apply -text [_ "Apply"] -command "AnimacionEstatica::Aceptar" -style BottomFrame.TButton -takefocus 0
    # -borderwidth 1 -padx 8 -pady 3
    ttk::button $_wid.but.close -text [_ "Close"] -command AnimacionEstatica::Cerrar -style BottomFrame.TButton -takefocus 0
    # -borderwidth 1 -padx 8 -pady 3
    #SetWidgetsWidthFromText $_wid.but.apply $_wid.but.close

    grid $_wid.but.apply -sticky ews -padx 4 -pady 10
    grid $_wid.but.close -sticky ews -padx 4 -pady 10 -row 0 -column 1

    #enpaquetamos marcos
    grid $_wid.f -sticky news -padx 0 -pady 0
    grid $_wid.but -sticky wes
    if { $::tcl_version >= 8.5 } { grid anchor $_wid.but center }

    grid columnconfigure $_wid 0 -weight 1
    grid rowconfigure $_wid 0 -weight 1

    AjustaPosicion $_wid $parent_w

    focus $_wid.but.apply
    bind $_wid <Escape> "$_wid.but.close invoke"
    return $_wid
}


proc PostAnimateDisableGUIUpdates { } {
    # GiD_Set PostUpdateWindows no
    GiD_Process escape escape escape escape Utilities Variables PostUpdateWindows no escape escape escape escape
    # GidUtils::Disable windows
    #GidUtils::Disable graphinput
    #GidUtils::Disable graphics
    # GidUtils::Disable  warnline
    .central.s disable windows 1
    .central.s disable warnline 1
}

proc PostAnimateEnableGUIUpdates { } {
    # GidUtils::Enable windows
    #GidUtils::Enable graphinput
    #GidUtils::Enable graphics
    #GidUtils::Enable warnline
    .central.s disable windows 0
    .central.s disable warnline 0
    # GiD_Set PostUpdateWindows yes
    GiD_Process escape escape escape escape Utilities Variables PostUpdateWindows yes escape escape escape escape
    # update menus and windows ....
    set cur_analysis [GiD_Info postprocess get cur_analysis]
    ::GiDPostprocessUpdate LoadSelectionEvent $cur_analysis [ GiD_Info postprocess get cur_step $cur_analysis] 
}

proc PostAnimateVerificaPermisos { w archivo} {
    # verificamos si ha existe
    if { ![ catch {
	set fi [ open $archivo]
	close $fi}]} {
	set resp [ tk_messageBox -parent $w -default no -title [_ "Confirm"] -type yesno \
		       -icon warning \
		       -message [_ "The file %s already exists.\nOverwrite it?" $archivo]]
	if { $resp == "no"} {
	    return 0
	}
    }

    # verificamos que el archivo se pueda escribir
    if { [ catch {
	set fo [ open $archivo w]
	puts $fo "hola"
	close $fo
    } err_msg ]} {
	WarnWin "$err_msg\nPlease check permisions, quotas and \nthat no application is using the file." $w
	return 0
    }
    return 1
}


proc PostAnimateInitValues {} {
    global GidPriv AnimacionEstatica

    set GidPriv(PostAnimateControlsDelay) 0

    set GidPriv(PostAnimateDoing) Nothing
    set GidPriv(PostAnimateDeform) 0
    set GidPriv(PostAnimateIsoSurfaces) ""
    set GidPriv(PostAnimateRsultView) ""
    set GidPriv(PostAnimateCurrentButton) ""
    # set GidPriv(PostAnimateDurationType) TotalTime
    set GidPriv(PostAnimateDefaultDurationType) Delay
    set GidPriv(PostAnimateDurationType) $::GidPriv(PostAnimateDefaultDurationType)
    # in miliseconds
    set GidPriv(PostAnimateMinimumDelayTime) 5
    set GidPriv(PostAnimateDefaultDelayTime) 200
    # in seconds
    set GidPriv(PostAnimateDefaultDurationTime) 5
    set GidPriv(PostAnimateDelayTime) $::GidPriv(PostAnimateDefaultDelayTime)
    set GidPriv(PostAnimateDelay) 1
    set GidPriv(PostAnimateDurationTime) $::GidPriv(PostAnimateDefaultDurationTime)
    set GidPriv(PostAnimateDurationTimeDelay) $::GidPriv(PostAnimateDefaultDurationTime)
    set GidPriv(PostAnimateDuration) 0
    set GidPriv(PostAnimateDurationWStep) 0
    set GidPriv(PostAnimateDurationOld) 0
    set GidPriv(PostAnimateStepvalues) 0
    set GidPriv(PostAnimateStepvaluesDelay) $::GidPriv(PostAnimateDefaultDelayTime)
    set GidPriv(PostAnimateIstepold) 0
    set GidPriv(PostAnimateDefaultRangeFrameFrom) 1
    set GidPriv(PostAnimateDefaultRangeFrameTo) 999999999
    set GidPriv(PostAnimateRangeFrameFrom) $::GidPriv(PostAnimateDefaultRangeFrameFrom)
    set GidPriv(PostAnimateRangeFrameTo) $::GidPriv(PostAnimateDefaultRangeFrameTo)
    set GidPriv(PostAnimateRangeFrames) 0
    set GidPriv(PostAnimateOldAutoRedraw) 1
    set GidPriv(PostAnimateSaveFrame) 0
    set GidPriv(PostAnimateSaveAnimation) 0
    set GidPriv(PostAnimateSavingAnimation) 0
    set GidPriv(PostAnimateSavingRepes) 1
    set GidPriv(PostAnimateSlideDelay) 10
    set GidPriv(PostAnimateSliding) 0
    set GidPriv(PostAnimateAnalysisLimitsCb) 0
    set GidPriv(PostAnimateSaveAnimationFormat) [GiD_Info postprocess get animationformat]
    set GidPriv(PostAnimateSaveFrameFormat) "PNG"
    set GidPriv(PostAnimateSaveAnimationFormat) "AVIMSVC"
    set info2 [.central.s configure]
    set height_list [ lindex $info2 0]
    set width_list [ lindex $info2 1]
    set current [format "%dx%d" [ lindex $width_list 4] [ lindex $height_list 4]]
    set GidPriv(PostAnimateResizeDefault) $current
    set GidPriv(PostAnimateResize) Default
    set GidPriv(PostAnimateTime) 0

    # para animaciones de un solo paso de analisis
    set AnimacionEstatica(tipo) Lineal
    set AnimacionEstatica(pasos) 10
    set AnimacionEstatica(hay) 0

    set ::GidPriv(PostDoStereoAnimation) [ GiD_Set PostDoStereoAnimation]
}

proc PostAnimateThereAreResultsInModel { { complain "no_complain"}} {
    set ret 0
    # at least, if there are some results in the model, 
    # an analysis has been selected
    if { [ info exists ::GidPriv(PostAnimate_cur_anal)] && \
	     ( $::GidPriv(PostAnimate_cur_anal) != "")} {
	set ret 1
    }
    if { !$ret && ( $complain != "no_complain")} {
	set w .gid
	if { [ winfo exists $::GidPriv(PostAnimateWindow)]} {
	    set w $::GidPriv(PostAnimateWindow)
	}
	ErrorWin [_ "No results could be found in model."] $w
    }
    return $ret
}

proc AnimacionEstaticaCreaFactores { factor_base} {
    global AnimacionEstatica

    switch $AnimacionEstatica(tipo) {
	"Lineal" {
	    set f [ expr 1.0 / double( $AnimacionEstatica(pasos))]
	    set AnimacionEstatica(factores) ""
	    for { set i 1} { $i < $AnimacionEstatica(pasos)} { incr i} {
		lappend AnimacionEstatica(factores) [ expr $factor_base * $i * $f]
	    }
	    # para asegurarnos que este
	    lappend AnimacionEstatica(factores) $factor_base
	}
	"Cosine" {
	    set f [ expr 2.0 * acos( 0.0) / double( $AnimacionEstatica(pasos))]
	    set AnimacionEstatica(factores) ""
	    for { set i 1} { $i < $AnimacionEstatica(pasos)} { incr i} {
		lappend AnimacionEstatica(factores) [ expr $factor_base * 0.5 * ( 1.0 - cos( $f * $i))]
	    }
	    # para asegurarnos que este
	    lappend AnimacionEstatica(factores) $factor_base
	}
	"Triangular" {
	    if { $AnimacionEstatica(pasos) == 2} {
		set AnimacionEstatica(factores) ""
		lappend AnimacionEstatica(factores) $factor_base
		lappend AnimacionEstatica(factores) $factor_base
	    } else {
		set p2 [ expr ( $AnimacionEstatica(pasos)) / 2]
		set f [ expr 1.0 / double( $p2)]
		set AnimacionEstatica(factores) ""
		for { set i 1} { $i < $p2} { incr i} {
		    lappend AnimacionEstatica(factores) [ expr $factor_base * $i * $f]
		}
		# para asegurarnos que este
		lappend AnimacionEstatica(factores) $factor_base
		# si es impar repetimos $factor_base, p.ej.
		# 3 pasos -> 1.0 1.0 0.0
		# 4 pasos -> 0.5 1.0 0.5 0.0
		# 5 pasos -> 0.5 1.0 1.0 0.5 0.0
		if { [ expr $AnimacionEstatica(pasos) % 2]} {
		    lappend AnimacionEstatica(factores) $factor_base
		}
		for { set i 1} { $i <= $p2} { incr i} {
		    lappend AnimacionEstatica(factores) [ expr $factor_base * ( $p2 - $i) * $f]
		}
	    }
	}
	"Sinusoidal" {
	    if { $AnimacionEstatica(pasos) == 2} {
		set AnimacionEstatica(factores) ""
		lappend AnimacionEstatica(factores) $factor_base
		lappend AnimacionEstatica(factores) $factor_base
	    } else {
		set p2 [ expr ( $AnimacionEstatica(pasos)) / 2]
		set f [ expr 2.0 * acos( 0.0) / double( $p2)]
		set AnimacionEstatica(factores) ""
		for { set i 1} { $i < $p2} { incr i} {
		    lappend AnimacionEstatica(factores) [ expr $factor_base * 0.5 * ( 1.0 - cos( $f * $i))]
		}
		# para asegurarnos que este
		lappend AnimacionEstatica(factores) $factor_base
		# si es impar repetimos $factor_base, p.ej.
		# 3 pasos -> 1.0 1.0 0.0
		# 4 pasos -> 0.5 1.0 0.5 0.0
		# 5 pasos -> 0.5 1.0 1.0 0.5 0.0
		if { [ expr $AnimacionEstatica(pasos) % 2]} {
		    lappend AnimacionEstatica(factores) $factor_base
		}
		for { set i 1} { $i <= $p2} { incr i} {
		    lappend AnimacionEstatica(factores) [ expr $factor_base * 0.5 * ( 1.0 - cos( $f * ( $p2 - $i)))]
		}
	    }
	}
    }
}

proc CambioPostAnimateDeform { name1 name2 op} {
    global GidPriv AnimacionEstatica

    if { ![ info exists GidPriv(PostAnimateWindow)] || ![ winfo exists $::GidPriv(PostAnimateWindow)] } {
	return
    }

    # if { $::GidPriv(PostAnimateDeform)}
    set mainst [GiD_Info postprocess get main_geom_state]
    if { $mainst == "Deformed" } {
	if { [ llength $::GidPriv(PostAnimate_all_step)] != 1} {
	    $AnimacionEstatica(boton) configure -state disable
	    # -foreground grey60
	    set AnimacionEstatica(hay) 0
	} else {
	    $AnimacionEstatica(boton) configure -state normal
	    # -foreground black
	    set AnimacionEstatica(hay) 1
	}
	AnimacionEstaticaCreaFactores $::GidPriv(PostAnimate_cur_d_factor)
    } else {
	$AnimacionEstatica(boton) configure -state disable
	# -foreground grey60
	set AnimacionEstatica(hay) 0
    }
}

proc UpdateStepValEntry { val} {
    $::GidPriv(PostAnimateStepValueEntry) configure -state normal
    $::GidPriv(PostAnimateStepValueEntry) delete 0 end
    if { $val != ""} {
	$::GidPriv(PostAnimateStepValueEntry) insert 0 $val
    }
    $::GidPriv(PostAnimateStepValueEntry) configure -state readonly
}

proc UpdateStepNumEntry { val} {
    $::GidPriv(PostAnimateStepNumberEntry) configure -state normal
    $::GidPriv(PostAnimateStepNumberEntry) delete 0 end
    if { $val != ""} {
	$::GidPriv(PostAnimateStepNumberEntry) insert 0 $val
    }
    $::GidPriv(PostAnimateStepNumberEntry) configure -state readonly
}

proc PostAnimateGetNumberOfSteps {} {
    # somewhat dirty....
    if { ![ winfo exists $::GidPriv(PostAnimateSlide)] } { return 0}

    set from [ $::GidPriv(PostAnimateSlide) cget -from]
    set to [ $::GidPriv(PostAnimateSlide) cget -to]
    if { $::GidPriv(PostAnimateRangeFrames)} {
	PostAnimateCheckRangeFrame
	set from $::GidPriv(PostAnimateRangeFramesFrom)
	set to $::GidPriv(PostAnimateRangeFramesTo)
    }
    return [ expr $to - $from + 1]
}

proc PostAnimateConfigureSlide {} {
    global GidPriv AnimacionEstatica

    if { ![ winfo exists $::GidPriv(PostAnimateSlide)] } { return}

    if { $::GidPriv(PostAnimateDeform) } {
	if { $AnimacionEstatica(hay)} {
	    $::GidPriv(PostAnimateSlide) configure -from 0 -to [ expr [ llength $AnimacionEstatica(factores)]]
	    # -resolution 1
	} else {
	    $::GidPriv(PostAnimateSlide) configure -from 0 -to [ expr [ llength $::GidPriv(PostAnimate_all_step)]]
	    # -resolution 1
	}

	#set GidPriv(PostAnimateCurrentFrame) -1
	#$::GidPriv(PostAnimateSlide) set [ expr $::GidPriv(PostAnimateCurrentFrame)+1]
	#$::GidPriv(PostAnimateStepValueEntry) configure -state normal
	#$::GidPriv(PostAnimateStepValueEntry) delete 0 end
	#$::GidPriv(PostAnimateStepValueEntry) insert 0 "Orig"
	#$::GidPriv(PostAnimateStepValueEntry) configure -state disabled
	#$::GidPriv(PostAnimateStepNumberEntry) configure -state normal
	#$::GidPriv(PostAnimateStepNumberEntry) delete 0 end
	#$::GidPriv(PostAnimateStepNumberEntry) insert 0 "Orig"
	#$::GidPriv(PostAnimateStepNumberEntry) configure -state disabled

	if { $AnimacionEstatica(hay)} {
	    set res [ lsearch $AnimacionEstatica(factores) $::GidPriv(PostAnimate_cur_d_factor)]
	} else {
	    set res [ lsearch $::GidPriv(PostAnimate_all_step) $::GidPriv(PostAnimate_cur_d_step)]
	}
	set frame $res

	if { $AnimacionEstatica(hay)} {
	    set istep [ lindex $AnimacionEstatica(factores) $frame]
	} else {
	    set istep [ lindex $::GidPriv(PostAnimate_all_step) $frame]
	}
	if { $istep == ""} {
	    set frame -1
	    UpdateStepValEntry "Orig"
	} else {
	    UpdateStepValEntry $istep
	}
	$::GidPriv(PostAnimateSlide) set [ expr $frame+1]
	UpdateStepNumEntry [ expr $frame+1]

	set frame [ expr $res+1]
	if { $AnimacionEstatica(hay)} {
	    set istep [ lindex $AnimacionEstatica(factores) $frame]
	} else {
	    set istep [ lindex $::GidPriv(PostAnimate_all_step) $frame]
	}
	if { $istep == ""} {
	    set frame -1
	} else {
	    set frame $res
	}

	set GidPriv(PostAnimateCurrentFrame) $frame

    } else {
	set nsteps [ llength $::GidPriv(PostAnimate_all_step)]
	if { $nsteps != 0} {
	    $::GidPriv(PostAnimateSlide) configure -from 1 -to $nsteps
	    # -resolution 1

	    #set GidPriv(PostAnimateCurrentFrame) 0
	    #$::GidPriv(PostAnimateSlide) set [ expr $::GidPriv(PostAnimateCurrentFrame)+1]

	    set res [ lsearch $::GidPriv(PostAnimate_all_step) $::GidPriv(PostAnimate_cur_step)]
	    set frame $res
	
	    set istep [ lindex $::GidPriv(PostAnimate_all_step) $frame]
	    # $::GidPriv(PostAnimateStepValueEntry) configure -state normal
	    # $::GidPriv(PostAnimateStepValueEntry) delete 0 end
	    # $::GidPriv(PostAnimateStepValueEntry) insert 0 $istep
	    # $::GidPriv(PostAnimateStepValueEntry) configure -state disabled
	    UpdateStepValEntry $istep
	    $::GidPriv(PostAnimateSlide) set [ expr $frame+1]
	    UpdateStepNumEntry [ expr $frame+1]
	
	    set frame [ expr $res+1]
	    set istep [ lindex $::GidPriv(PostAnimate_all_step) $frame]
	    if { $istep == ""} {
		set frame 0
	    } else {
		set frame $res
	    }
	
	    set GidPriv(PostAnimateCurrentFrame) $frame
	
	    #$::GidPriv(PostAnimateSlide) set [ expr $::GidPriv(PostAnimateCurrentFrame)+1]
	    #
	    #set istep [ lindex $::GidPriv(PostAnimate_all_step) $::GidPriv(PostAnimateCurrentFrame)]
	    #$::GidPriv(PostAnimateStepValueEntry) configure -state normal
	    #$::GidPriv(PostAnimateStepValueEntry) delete 0 end
	    #$::GidPriv(PostAnimateStepValueEntry) insert 0 $istep
	    #$::GidPriv(PostAnimateStepValueEntry) configure -state disabled
	} else {
	    $::GidPriv(PostAnimateSlide) configure -from 0 -to 0
	    # -resolution 1
	    # $::GidPriv(PostAnimateStepValueEntry) configure -state normal
	    # $::GidPriv(PostAnimateStepValueEntry) delete 0 end
	    # $::GidPriv(PostAnimateStepValueEntry) configure -state disabled

	    UpdateStepValEntry ""
	    UpdateStepNumEntry ""
	
	    set GidPriv(PostAnimateCurrentFrame) 0
	}
    }
    set GidPriv(PostAnimateSlideDelay) 10
    set GidPriv(PostAnimateSliding) 0
    update
}

#checkea si el analysis y el paso de la deformada y C.fill son los mismos
proc PostAnimateCheckVisualizationCoherency { } {
    global GidPriv AnimacionEstatica

    if { [ info exists GidPriv(PostAnimateWindow)] && [ winfo exists $::GidPriv(PostAnimateWindow)] } {
	if { ( $::GidPriv(PostAnimateResultView) != "") && $::GidPriv(PostAnimateDeform) } {
	    if { $::GidPriv(PostAnimate_cur_d_anal) != $::GidPriv(PostAnimate_cur_anal) } {

		# verificamos que en ambos analisis hay igual numero de pasos y con igual valor
		set GidPriv(PostAnimate_all_d_step) [GiD_Info postprocess get all_steps $::GidPriv(PostAnimate_cur_d_anal)]
		set iguales 1
		if { $::GidPriv(PostAnimateRangeFrames) } {
		    set from [ expr $::GidPriv(PostAnimateRangeFrameFrom) - 1]
		    set to [ expr $::GidPriv(PostAnimateRangeFrameTo) - 1]
		    set res_view_steps [ lrange $::GidPriv(PostAnimate_all_step) $from $to]
		    set res_def_steps [ lrange $::GidPriv(PostAnimate_all_d_step) $from $to]
		} else {
		    set res_view_steps $::GidPriv(PostAnimate_all_step)
		    set res_def_steps $::GidPriv(PostAnimate_all_d_step)
		}
		if { ( [ llength $res_view_steps] <= 0) || ( [ llength $res_def_steps] <= 0)} {
		        set iguales 0
		        WarnWin [_ "Empty step list in one of the analysis"]
		} elseif { ( [ llength $res_view_steps] != [ llength $res_def_steps]) } {
		    set iguales 0
		} else {
		    set l [ llength $::GidPriv(PostAnimate_all_step)]
		    for { set idx 0} { $idx < $l} { incr idx} {
		        if { "[ lindex $res_view_steps $idx]" != "[ lindex $res_def_steps $idx]"} {
		            set iguales 0
		            break
		        }
		    }
		}

		if { $iguales} {
		    # verificamos que el paso es el mismo para el resultado como para la deformada
		    if { $::GidPriv(PostAnimate_cur_step) != $::GidPriv(PostAnimate_cur_d_step)} {
		        WarnWin "Current Deformation step differs from the current Result View's step. The animation will display the view and deformation on of the same step." $::GidPriv(PostAnimateWindow)
		    }
		} else {
		    set resp [ tk_dialog  $::GidPriv(PostAnimateWindow).___pa_ww [_ "Warning"] \
		            [_ "Current Deformation analysis differs from current Result View's analysis. \
		            Choose which one should be valid for the animation"] \
		            info 2 [_ "ResultView"] [_ "Deformation"] [_ "Cancel"]]
		    switch $resp {
		        0 {
		            set GidPriv(PostAnimateDeform) 0
		        }
		        1 {
		            set GidPriv(PostAnimateResultView) ""
		        }
		        2 {
		            set GidPriv(PostAnimateResultView) ""
		            set GidPriv(PostAnimateDeform) 0
		        }
		    }
		}
	    }
	}
    }
}

proc PostAnimateInitVariables { } {
    global GidPriv AnimacionEstatica

    if { [ info exists GidPriv(PostAnimateInitializing)] && $::GidPriv(PostAnimateInitializing)} { return}

    if { ![ info exists GidPriv(PostAnimateDoing)] } { set GidPriv(PostAnimateDoing) "Nothing"}

    if { $::GidPriv(PostAnimateDoing) != "Nothing"} { return}

    set GidPriv(PostAnimateInitializing) 1

    set GidPriv(PostAnimate_cur_anal) [GiD_Info postprocess get cur_analysis]
    set cur_anal $::GidPriv(PostAnimate_cur_anal)
    set GidPriv(PostAnimate_cur_step) [GiD_Info postprocess get cur_step $cur_anal]
    set GidPriv(PostAnimate_all_step) [GiD_Info postprocess get all_steps $cur_anal]
    #set GidPriv(PostAnimate_all_step,anal) [GiD_Info postprocess get all_steps $cur_anal]
    set GidPriv(PostAnimate_cur_resv) [GiD_Info postprocess get cur_results_view]
    set GidPriv(PostAnimate_cur_res)  [ join [GiD_Info postprocess get cur_result]]
    set GidPriv(PostAnimate_cur_comp) [ join [GiD_Info postprocess get cur_component]]

    set GidPriv(PostAnimateVariosResultados) [ string tolower [ GiD_Set postresoverres]]
    set GidPriv(PostAnimateListaResultados) [ GiD_Info postprocess get results_view_list]

    set GidPriv(PostAnimate_cur_d_defor) [ GiD_Info postprocess get main_geom_cur_deform]

    set GidPriv(PostAnimate_cur_d_anal) [ GiD_Info postprocess get main_geom_cur_anal]
    set GidPriv(PostAnimate_cur_d_step) [ GiD_Info postprocess get main_geom_cur_step]
    set GidPriv(PostAnimate_cur_d_factor) [GiD_Info postprocess get main_geom_cur_factor]

    set GidPriv(PostAnimate_cur_defor_type) [ GiD_Info postprocess get main_geom_deformation_type]

#    set GidPriv(PostAnimate_cur_d_factor) [GiD_Info postprocess get main_geom_factor $::GidPriv(PostAnimate_cur_d_defor) $::GidPriv(PostAnimate_cur_d_anal) $::GidPriv(PostAnimate_cur_d_step)]

#     set GidPriv(PostAnimateDoing) Nothing
#     set GidPriv(PostAnimateCurrentButton) ""
#     set GidPriv(PostAnimateDefaultDelayTime) 200
#     set GidPriv(PostAnimateDelayTime) $::GidPriv(PostAnimateDefaultDelayTime)
#     set GidPriv(PostAnimateDelay) 0
#     set GidPriv(PostAnimateOldAutoRedraw) 1

    # do not change user set values, only if they are not valid
    set max_num_steps [ llength $::GidPriv(PostAnimate_all_step)]
    if { ![ info exist ::GidPriv(PostAnimateDefaultRangeFrameFrom)] || \
	     ( $::GidPriv(PostAnimateDefaultRangeFrameFrom) > $max_num_steps)} {
	set ::GidPriv(PostAnimateDefaultRangeFrameFrom) 1
    }
    if { ![ info exists ::GidPriv(PostAnimateDefaultRangeFrameTo)] || \
	     ( $::GidPriv(PostAnimateDefaultRangeFrameTo) > $max_num_steps)} {
	set ::GidPriv(PostAnimateDefaultRangeFrameTo) $max_num_steps
    }
    # correct user set limits if we have to
    if { ![ info exist ::GidPriv(PostAnimateRangeFrameFrom)] || \
	     ( $::GidPriv(PostAnimateRangeFrameFrom) > $max_num_steps)} {
	set ::GidPriv(PostAnimateRangeFrameFrom) 1
    }
    if { ![ info exists ::GidPriv(PostAnimateRangeFrameTo)] || \
	     ( $::GidPriv(PostAnimateRangeFrameTo) > $max_num_steps)} {
	set ::GidPriv(PostAnimateRangeFrameTo) $max_num_steps
    }

    regsub -all {_} $::GidPriv(PostAnimate_cur_resv) {} pepe

    set GidPriv(PostAnimate_cur_resv) $pepe

    set GidPriv(PostAnimateResultViewCb) 1
    switch $::GidPriv(PostAnimate_cur_resv) {
	"ShMinMax" { set GidPriv(PostAnimateResultView) $::GidPriv(PostAnimate_cur_resv)}
	"ContourFill"        { set GidPriv(PostAnimateResultView) $::GidPriv(PostAnimate_cur_resv)}
	"SmoothContourFill"  { set GidPriv(PostAnimateResultView) $::GidPriv(PostAnimate_cur_resv)}
	"ContourLines"       { set GidPriv(PostAnimateResultView) $::GidPriv(PostAnimate_cur_resv)}
	"SmoothContourLines" { set GidPriv(PostAnimateResultView) $::GidPriv(PostAnimate_cur_resv)}
	"IsoSurfaces" {
	    set GidPriv(PostAnimateResultView) $::GidPriv(PostAnimate_cur_resv)
	    # esto de abajo lo hacemos siempre, pues puede ser que hagan
	    # isosuperficies con color del contour fill y hagan despues el contour fill
	    #set GidPriv(PostAnimateIsoSurfaces) [ lindex [GiD_Info postprocess get iso_cur_result_values] 0]
	}
	"DisplayVectors" {
	    set GidPriv(PostAnimateResultView) $::GidPriv(PostAnimate_cur_resv)
	    set GidPriv(PostAnimateDisplayVectors) [GiD_Info postprocess get cur_vector_factor \
		    Display_Vectors $::GidPriv(PostAnimate_cur_res) $::GidPriv(PostAnimate_cur_anal) \
		    $::GidPriv(PostAnimate_cur_step)]
	}
	"ContourRanges" { set GidPriv(PostAnimateResultView) $::GidPriv(PostAnimate_cur_resv)}
	"ScalarLineDiagram" {
	    set GidPriv(PostAnimateResultView) $::GidPriv(PostAnimate_cur_resv)
	    set GidPriv(PostAnimateScalarDiagram) [GiD_Info postprocess get cur_diagram_factor\
		    $::GidPriv(PostAnimate_cur_res) $::GidPriv(PostAnimate_cur_comp) $::GidPriv(PostAnimate_cur_anal) \
		    $::GidPriv(PostAnimate_cur_step)]
	}
	"VectorLineDiagram" {
	    set GidPriv(PostAnimateResultView) $::GidPriv(PostAnimate_cur_resv)
	    set GidPriv(PostAnimateVectorDiagram) [GiD_Info postprocess get cur_diagram_factor\
		    $::GidPriv(PostAnimate_cur_res) $::GidPriv(PostAnimate_cur_anal) \
		    $::GidPriv(PostAnimate_cur_step)]
	}
	"ResultSurface" {
	    set GidPriv(PostAnimateResultView) $::GidPriv(PostAnimate_cur_resv)
	    set GidPriv(PostAnimateResultSurface) [GiD_Info postprocess get cur_result_surface_factor \
		    Result_Surface $::GidPriv(PostAnimate_cur_res) $::GidPriv(PostAnimate_cur_comp) $::GidPriv(PostAnimate_cur_anal) \
		    $::GidPriv(PostAnimate_cur_step)]
	}
	"SmoothResultSurface" {
	    set GidPriv(PostAnimateResultView) $::GidPriv(PostAnimate_cur_resv)
	    set GidPriv(PostAnimateResultSurface) [GiD_Info postprocess get cur_result_surface_factor \
		    Result_Surface $::GidPriv(PostAnimate_cur_res) $::GidPriv(PostAnimate_cur_comp) $::GidPriv(PostAnimate_cur_anal) \
		    $::GidPriv(PostAnimate_cur_step)]
	}
	"LineThickness" {
	    set GidPriv(PostAnimateResultView) $::GidPriv(PostAnimate_cur_resv)
	    set GidPriv(PostAnimateResultSurface) [GiD_Info postprocess get cur_result_surface_factor \
		    Line_Thickness $::GidPriv(PostAnimate_cur_res) $::GidPriv(PostAnimate_cur_comp) $::GidPriv(PostAnimate_cur_anal) \
		    $::GidPriv(PostAnimate_cur_step)]
	}
	"SmoothLineThickness" {
	    set GidPriv(PostAnimateResultView) $::GidPriv(PostAnimate_cur_resv)
	    set GidPriv(PostAnimateResultSurface) [GiD_Info postprocess get cur_result_surface_factor \
		    Line_Thickness $::GidPriv(PostAnimate_cur_res) $::GidPriv(PostAnimate_cur_comp) $::GidPriv(PostAnimate_cur_anal) \
		    $::GidPriv(PostAnimate_cur_step)]
	}
	default {
	    set GidPriv(PostAnimateResultView) ""
	    set GidPriv(PostAnimateResultViewCb) 0
	}
    }
    set GidPriv(PostAnimateIsoSurfaces) [ lindex [GiD_Info postprocess get iso_cur_result_values] 0]
    # WarnWinText "linex iso_cur_result_values] 0] -$::GidPriv(PostAnimateIsoSurfaces)-"

    if { [ info exists GidPriv(PostAnimateResButtons)] && [ winfo exists $::GidPriv(PostAnimateResButtons).b1] } {
	if { $::GidPriv(PostAnimateResultViewCb) } {
	    #$::GidPriv(PostAnimateResButtons).l configure -foreground black
	    $::GidPriv(PostAnimateResButtons).b1 configure -state normal
	    #$::GidPriv(PostAnimateResButtons).b2 configure -state normal
	} else {
	    #$::GidPriv(PostAnimateResButtons).l configure -foreground grey60
	    $::GidPriv(PostAnimateResButtons).b1 configure -state disabled
	    #$::GidPriv(PostAnimateResButtons).b2 configure -state disabled
	}
    }

    #if { [ info exists GidPriv(PostAnimateAnalysisLimitsCb)] && \
    #             $::GidPriv(PostAnimateAnalysisLimitsCb) } {
    #         PostAnimateGetAnalysisLimits "" "" ""
    #}


    set mainst [GiD_Info postprocess get main_geom_state]
    if { $mainst == "Deformed" } {
	set GidPriv(PostAnimateDeform) 1
    } else {
	set GidPriv(PostAnimateDeform) 0
    }

    if { [ info exists GidPriv(PostAnimateSlide)] } {
	PostAnimateConfigureSlide
    }

    set GidPriv(PostAnimateInitializing) 0

    if { [ info exists GidPriv(PostAnimateAnalysisLimitsCb)] && \
	    $::GidPriv(PostAnimateAnalysisLimitsCb) } {
	PostAnimateGetAnalysisLimits "" "" ""
    }

    set ::GidPriv(PostDoStereoAnimation) [ GiD_Set PostDoStereoAnimation]

    set ::GidPriv(PostAnimateContourUsedLimits) [PostAnimateGetUsedLimits]
}

proc PostAnimateGetValidFrame { frame} {
    global GidPriv AnimacionEstatica

    # no hace falta: if { !$::GidPriv(PostAnimateRangeFrames)} { return $frame}
    # corrige el maximo por si acaso
    PostAnimateCheckRangeFrame 0
    set from_f [ expr $::GidPriv(PostAnimateRangeFrameFrom) - 1]
    if { $frame < $from_f} {
	set frame $from_f
    } else {
	# set to_f [ expr $::GidPriv(PostAnimateRangeFrameTo) - 1]
	# if { ( $frame > $to_f) && $::GidPriv(PostAnimateEndless)} {
	#     set frame $from_f
	# }
    }
    return $frame
}

proc PostAnimateGetValidDelayTime {} {
    set delay $::GidPriv(PostAnimateDelayTime)
    set color black
    if { ( $delay == "") || [ catch { set pp [ expr $delay + 1]}] || ( $delay <= 0)} {
	set delay $::GidPriv(PostAnimateMinimumDelayTime)
	set color red
    }
    if { $delay != [ expr int( $delay)]} {
	# Delay time is an integer, representing miliseconds for the after xxx xxx command
	set delay [ expr int( $delay)]
	set color red
    }
    if { [ info exists ::GidPriv(PostAnimateDelayTimeEntry)] && [ winfo exists $::GidPriv(PostAnimateDelayTimeEntry)]} {
	$::GidPriv(PostAnimateDelayTimeEntry) configure -foreground $color
    }
    return [ expr int( $delay)]
}

proc PostAnimateFrame { frame} {
    global GidPriv AnimacionEstatica
    # WarnWinText "PostAnimateFrame $frame"
    #WarnWinText "PostAnimateFrame: GidPriv(PostAnimateDoing) = $::GidPriv(PostAnimateDoing)   frame = $frame"
    if { $::GidPriv(PostAnimateRangeFrames) && $::GidPriv(PostAnimateDoing) == "Animate"} {
	#WarnWinText "Skipping first frames doing $::GidPriv(PostAnimateDoing)"
	set frame [ PostAnimateGetValidFrame $frame]
    }
    # WarnWinText "                 $frame --> $::GidPriv(PostAnimateDoing)"
    switch $::GidPriv(PostAnimateDoing) {
	"Nothing" { return}
	"Stop" {
	    PostAnimateEnableGUIUpdates
	    if { $::GidPriv(PostAnimateSavingAnimation) } {
		GiD_Process 'AnimationFile End
		set GidPriv(PostAnimateSavingAnimation) 0
	    }

	    if { $::GidPriv(PostAnimateDeform)} {
		# reactivate redraw
		#DebugPostAnim "SET_stop AutomaticRedraw $::GidPriv(PostAnimateOldAutoRedraw)"
		GiD_Set AutomaticRedraw $::GidPriv(PostAnimateOldAutoRedraw)
		# .central.s render
		GiDActualizaVentanasTogl
	    }
	    #set GidPriv(PostAnimateCurrentFrame) [ expr $frame-1]
	    set GidPriv(PostAnimateCurrentFrame) $frame
	    #WarnWin "Frame:Stop: $::GidPriv(PostAnimateCurrentFrame)"
	
	    #catch {
		#if { $::GidPriv(PostAnimateCurrentButton) != ""} {
		#    TryRoundRelief $::GidPriv(PostAnimateCurrentButton) raised
		#    # $::GidPriv(PostAnimateCurrentButton) configure -relief raise
		#}
	    #}
	    update
	    set GidPriv(PostAnimateDoing) Nothing

	    return
	}
	"Rewind" {
	    if { $::GidPriv(PostAnimateDeform)} {
		set GidPriv(PostAnimateCurrentFrame) -1
	    } else {
		set GidPriv(PostAnimateCurrentFrame) 0
		set ::GidPriv(PostAnimateCurrentFrame) [ PostAnimateGetValidFrame \
		                                           $::GidPriv(PostAnimateCurrentFrame)]
	    }
	
	    set frame $::GidPriv(PostAnimateCurrentFrame)
	    # WarnWin "Frame:Rewind: $::GidPriv(PostAnimateCurrentFrame)"
	
	    if { $frame == -1} {
		UpdateStepValEntry "Orig"
	    } else {
		set all_step $::GidPriv(PostAnimate_all_step)
		set istep [ lindex $all_step $frame]
		UpdateStepValEntry $istep
	    }
	    $::GidPriv(PostAnimateSlide) set [ expr $frame+1]
	    UpdateStepNumEntry [ expr $frame+1]
	}
    }

	#actualizamos la slide
#         set frame $::GidPriv(PostAnimateCurrentFrame)
#         $::GidPriv(PostAnimateStepValueEntry) configure -state normal
#         $::GidPriv(PostAnimateStepValueEntry) delete 0 end
#         if { $frame == -1} {
#             $::GidPriv(PostAnimateStepValueEntry) insert 0 "Orig"
#         } else {
#             set all_step   $::GidPriv(PostAnimate_all_step)
#             set istep [ lindex $all_step $frame]
#             $::GidPriv(PostAnimateStepValueEntry) insert 0 $istep
#         }
#         $::GidPriv(PostAnimateStepValueEntry) configure -state disabled
#         $::GidPriv(PostAnimateSlide) set [ expr $frame+1]

    set cur_anal   $::GidPriv(PostAnimate_cur_anal)
    #set cur_step   $::GidPriv(PostAnimate_cur_step)
    set cur_d_anal   $::GidPriv(PostAnimate_cur_d_anal)
    #set cur_d_step   $::GidPriv(PostAnimate_cur_d_step)
    set all_step   $::GidPriv(PostAnimate_all_step)
    set cur_resv   $::GidPriv(PostAnimate_cur_resv)
    set cur_res    $::GidPriv(PostAnimate_cur_res)
    set cur_comp   $::GidPriv(PostAnimate_cur_comp)
    set cur_defor  $::GidPriv(PostAnimate_cur_d_defor)
    set cur_factor $::GidPriv(PostAnimate_cur_d_factor)
    set cur_defor_type $::GidPriv(PostAnimate_cur_defor_type)


    if { $::GidPriv(PostAnimateSaveFrame)} {
	if { $::GidPriv(PostAnimateSaveFrameFormat) == "PNG"} {
	    set GidPriv(PostAnimateSaveFilename) [ format %s-%02d.png \
		    $::GidPriv(PostAnimateSavePrefix) [ expr $frame+1]]
	} elseif { $::GidPriv(PostAnimateSaveFrameFormat) == "GIF"} {
	    set GidPriv(PostAnimateSaveFilename) [ format %s-%02d.gif \
		    $::GidPriv(PostAnimateSavePrefix) [ expr $frame+1]]
	} elseif { $::GidPriv(PostAnimateSaveFrameFormat) == "TIFF"} {
	    set GidPriv(PostAnimateSaveFilename) [ format %s-%02d.tif \
		    $::GidPriv(PostAnimateSavePrefix) [ expr $frame+1]]
	} elseif { $::GidPriv(PostAnimateSaveFrameFormat) == "JPEG"} {
	    set GidPriv(PostAnimateSaveFilename) [ format %s-%02d.jpg \
		    $::GidPriv(PostAnimateSavePrefix) [ expr $frame+1]]
	} else {
	    set GidPriv(PostAnimateSaveFilename) [ format %s-%02d.png \
		    $::GidPriv(PostAnimateSavePrefix) [ expr $frame+1]]
	}
    } else {
	set GidPriv(PostAnimateSaveFilename) ""
    }

    if { $::GidPriv(PostAnimateDeform) && $frame == -1} {

	# deactivate redraw
	set GidPriv(PostAnimateOldAutoRedraw) [GiD_Set AutomaticRedraw]
	#DebugPostAnim "GET-1 AutomaticRedraw $::GidPriv(PostAnimateOldAutoRedraw)"
	#DebugPostAnim "SET-1 AutomaticRedraw -1"
	GiD_Set AutomaticRedraw -1

	# to ensure that it's the first step when loading multiple files
	set all_step $::GidPriv(PostAnimate_all_step)
	set istep [ lindex $all_step 0]
	GiD_Process Mescape Results AnalysisSel $cur_d_anal $istep

	# la original
	GiD_Process Mescape Results Geometry Original
	#DebugPostAnim "SET-1 AutomaticRedraw $::GidPriv(PostAnimateOldAutoRedraw)"
	GiD_Set AutomaticRedraw $::GidPriv(PostAnimateOldAutoRedraw)
	#.central.s render
	GiDActualizaVentanasTogl
	if { $::GidPriv(PostAnimateSavingAnimation) } {
	    # for { set irepe 0} { $irepe < $::GidPriv(PostAnimateSavingRepes)} { incr irepe} {
	    #           GiD_Process 'AnimationFile AddFrame
	    # }
	    GiD_Process 'AnimationFile AddStep
	}
	if { $::GidPriv(PostAnimateSaveFrame)} {
	    #WarnWin $::GidPriv(PostAnimateSaveFilename)
	    GiD_Process 'Hardcopy $::GidPriv(PostAnimateSaveFrameFormat) $::GidPriv(PostAnimateSaveFilename)
	}        
	
	#DebugPostAnim "SET-1 AutomaticRedraw -1"
	GiD_Set AutomaticRedraw -1

	#actualizamos la slide
	$::GidPriv(PostAnimateSlide) set [ expr $frame+1]
	UpdateStepNumEntry [ expr $frame+1]
	# $::GidPriv(PostAnimateStepValueEntry) configure -state normal
	# $::GidPriv(PostAnimateStepValueEntry) delete 0 end
	# $::GidPriv(PostAnimateStepValueEntry) insert 0 "Orig"
	# $::GidPriv(PostAnimateStepValueEntry) configure -state disabled
	UpdateStepValEntry "Orig"

	if { $::GidPriv(PostAnimateDoing) == "Rewind"} {
	    set GidPriv(PostAnimateDoing) Stop
	    PostAnimateFrame $frame
	    return
	}

	update idletasks
	if { $::GidPriv(PostAnimateDelay) } {
	    #WarnWin "1 after $::GidPriv(PostAnimateDelayTime) PostAnimateFrame 0 - $::GidPriv(PostAnimateDoing)"
	    set delay [ PostAnimateGetValidDelayTime]
	    after $delay "PostAnimateFrame 0"
	} else {
	    #WarnWin "1b after $::GidPriv(PostAnimateDefaultDelayTime) PostAnimateFrame 0 - $::GidPriv(PostAnimateDoing)"
	    # may be here we should check $::GidPriv(PostAnimateDuration) and $::GidPriv(PostAnimateStepvalues) ?
	    # or not, as it's the starting frame !
	    set delay [ PostAnimateGetValidDelayTime]
	    after $delay "PostAnimateFrame 0"
	}
	return
	
    }

    if { !$::GidPriv(PostAnimateDeform) || !$AnimacionEstatica(hay)} {
	set istep [ lindex $all_step $frame]
    } else {
	set istep [ lindex $AnimacionEstatica(factores) $frame]
    }

    if { $::GidPriv(PostAnimateRangeFrames)} {
	set to_f $::GidPriv(PostAnimateRangeFrameTo)
	if { ( $frame >= $to_f)} {
	    set istep ""
	}
    }

    if { $istep == ""} {
	if { $::GidPriv(PostAnimateDeform)} {
	    set frame -1
	} else {
	    set frame 0
	}
	if { $::GidPriv(PostAnimateEndless)} {
	    #set istep [ lindex $all_step 0]
	    PostAnimateFrame $frame
	    return
	} else {
	    set GidPriv(PostAnimateDoing) Stop
	    PostAnimateFrame $frame
	    return
	}
    }

	
    #actualizamos la slide
    if { [winfo exists $::GidPriv(PostAnimateSlide)] } {
	$::GidPriv(PostAnimateSlide) set [ expr $frame+1]    
	UpdateStepNumEntry [ expr $frame+1]   
	UpdateStepValEntry $istep
    }

    #actualizamos la representacion delete resultado
    #DebugPostAnim "SET AutomaticRedraw -1"
    GiD_Set AutomaticRedraw -1

    # no parece que haga falta... lo comentamos para evitar un redraw
    if { $::GidPriv(PostAnimateVariosResultados) == "yes"} {
	GiD_Process Mescape Results Geometry NoResults escape escape escape escape
    }

    set already_set 0
    if { $::GidPriv(PostAnimateDeform)} {
	# puede que cur_anal != cur_d_anal
	GiD_Process Mescape Results AnalysisSel $cur_d_anal $istep
	if { $cur_d_anal == $cur_anal} {
	    set already_set 1
	}
	GiD_Process Mescape Results Options DeformationType $cur_defor_type
	if { $AnimacionEstatica(hay)} {
	    GiD_Process Mescape Results Geometry Original Geometry Deformation $cur_defor $istep escape
	} else {
	    GiD_Process Mescape Results Geometry Original Geometry Deformation $cur_defor $cur_factor escape
	}
	if { $cur_defor_type != "relative"} {
	    GiD_Process Mescape Results Options DeformationType Relative
	}
    }
    if { !$already_set} {
	GiD_Process Mescape Results AnalysisSel $cur_anal $istep Mescape
    }

    if { $::GidPriv(PostAnimateResultViewCb) && $::GidPriv(PostAnimateAnalysisLimitsCb)} {
	PostAnimatePushLimits
	PostAnimateSetAnalysisLimits
    }

    # si hay isosuperficie, la actualizamos
    set draw_isosurface 0
    if { ( $::GidPriv(PostAnimate_cur_resv) == "IsoSurfaces") && ( [ llength $::GidPriv(PostAnimateIsoSurfaces)] != 0)} {
	set draw_isosurface 1
    }
    if { ( $::GidPriv(PostAnimateVariosResultados) == "no") &&  ( [ llength $::GidPriv(PostAnimateIsoSurfaces)] != 0)} {
	# pues puede ser que hagan
	# isosuperficies con color del contour fill y hagan despues el contour fill
	set draw_isosurface 1
    }
    if { $draw_isosurface} {
	set iso_res [ lindex $::GidPriv(PostAnimateIsoSurfaces) 2]
	set iso_anal [ lindex $iso_res 2]
	# set iso_paso [ lindex $iso_res 3]
	if { $cur_anal != $iso_anal} {
	    GiD_Process Mescape Results AnalysisSel $iso_anal $istep Mescape
	}
	set lst_valores [ lindex $::GidPriv(PostAnimateIsoSurfaces) 1]
	GiD_Process Mescape Results IsoSurfaces Exact [ lindex $iso_res 0] [ lindex $iso_res 1] \
	    [ lindex $::GidPriv(PostAnimateIsoSurfaces) 0] {*}$lst_valores
	# WarnWinText "1- $::GidPriv(PostAnimateIsoSurfaces)"
	# WarnWinText "1- GiD_Process Mescape Results IsoSurfaces Exact [ lindex $iso_res 0] [ lindex $iso_res 1] \
	#     [ lindex $::GidPriv(PostAnimateIsoSurfaces) 0] {*}$lst_valores"
	# foreach val $lst_valores {
	#     GiD_Process $val
	# }
	if { $cur_anal != $iso_anal} {
	    GiD_Process Mescape Results AnalysisSel $cur_anal $istep Mescape
	}
    }

    if { $::GidPriv(PostAnimateResultViewCb) && $::GidPriv(PostAnimateResultView) != ""} {
	if { $::GidPriv(PostAnimateVariosResultados) == "no"} {
	    switch $::GidPriv(PostAnimate_cur_resv) {
		"ShMinMax" {
		    GiD_Process Mescape Results $cur_resv $cur_res $cur_comp
		}
		"ContourFill" {
		    # set used c.fill limits if automatic limits is not enabled
		    if { !$::GidPriv(PostAnimateAnalysisLimitsCb)} {
		        if { [info exists ::GidPriv(PostAnimateContourUsedLimits)] } {
		            PostAnimateSetUsedLimits $::GidPriv(PostAnimateContourUsedLimits)
		        }
		    }
		    GiD_Process Mescape Results $cur_resv $cur_res $cur_comp
		}
		"SmoothContourFill" {
		    # set used c.fill limits if automatic limits is not enabled
		    if { !$::GidPriv(PostAnimateAnalysisLimitsCb)} {
		        if { [info exists ::GidPriv(PostAnimateContourUsedLimits)] } {
		            PostAnimateSetUsedLimits $::GidPriv(PostAnimateContourUsedLimits)
		        }
		    }
		    GiD_Process Mescape Results $cur_resv $cur_res $cur_comp
		}
		"ContourLines" {
		    # set used c.fill limits if automatic limits is not enabled
		    if { !$::GidPriv(PostAnimateAnalysisLimitsCb)} {
		        if { [info exists ::GidPriv(PostAnimateContourUsedLimits)] } {
		            PostAnimateSetUsedLimits $::GidPriv(PostAnimateContourUsedLimits)
		        }
		    }
		    GiD_Process Mescape Results $cur_resv $cur_res $cur_comp
		}
		"SmoothContourLines" {
		    # set used c.fill limits if automatic limits is not enabled
		    if { !$::GidPriv(PostAnimateAnalysisLimitsCb)} {
		        if { [info exists ::GidPriv(PostAnimateContourUsedLimits)] } {
		            PostAnimateSetUsedLimits $::GidPriv(PostAnimateContourUsedLimits)
		        }
		    }
		    GiD_Process Mescape Results $cur_resv $cur_res $cur_comp
		}
		"IsoSurfaces" {
		    ### set lst_valores [ lindex $::GidPriv(PostAnimateIsoSurfaces) 1]
		    ### GiD_Process Mescape Results $cur_resv Exact $cur_res $cur_comp \
		    ###     [ lindex $::GidPriv(PostAnimateIsoSurfaces) 0] {*}$lst_valores
		    # WarnWinText "2- $::GidPriv(PostAnimateIsoSurfaces)"
		    # WarnWinText "2 - GiD_Process Mescape Results $cur_resv Exact $cur_res $cur_comp \
		    #     [ lindex $::GidPriv(PostAnimateIsoSurfaces) 0] {*}$lst_valores"
		    # foreach val $lst_valores {
		    #         GiD_Process $val
		    # }
		}
		"DisplayVectors" {
		    GiD_Process Mescape Results $cur_resv $cur_res $cur_comp \
		        $::GidPriv(PostAnimateDisplayVectors)
		}
		"ContourRanges" {
		    GiD_Process Mescape Results $cur_resv $cur_res $cur_comp
		}
		"ScalarLineDiagram" {
		    GiD_Process Mescape Results LineDiagram ScalarDiagram $cur_res $cur_comp \
		        $::GidPriv(PostAnimateScalarDiagram)
		}
		"VectorLineDiagram" {
		    GiD_Process Mescape Results LineDiagram VectorDiagram $cur_res \
		        $::GidPriv(PostAnimateVectorDiagram)
		}
		"ResultSurface" {
		    GiD_Process Mescape Results $cur_resv $cur_res $cur_comp \
		        $::GidPriv(PostAnimateResultSurface)
		}
		"SmoothResultSurface" {
		    GiD_Process Mescape Results $cur_resv $cur_res $cur_comp \
		        $::GidPriv(PostAnimateResultSurface)
		}
		"LineThickness" {
		    GiD_Process Mescape Results $cur_resv $cur_res $cur_comp \
		        $::GidPriv(PostAnimateResultSurface)
		}
		"SmoothLineThickness" {
		    GiD_Process Mescape Results $cur_resv $cur_res $cur_comp \
		        $::GidPriv(PostAnimateResultSurface)
		}
		default {
		    #nothing
		}
	    }
	} else {
	    # varios resultados
	
	    set lst_limits_resv [ list contourfill smoothcontourfill contourlines smoothcontourlines]
	    # GiD_Process Mescape Results Geometry NoResults Mescape
	    foreach estado_res $::GidPriv(PostAnimateListaResultados) {
		set resv [ string tolower [ lindex $estado_res 1]]
		set res_name [ lindex $estado_res 4]
		set res_comp [ lindex $estado_res 5]
		set res_factor [ lindex $estado_res 6]
		regsub -all { } $resv {} resv

		if { ( [ lsearch $lst_limits_resv $resv] != -1) && !$::GidPriv(PostAnimateAnalysisLimitsCb)} {
		    # set used c.fill limits if automatic limits is not enabled
		    if { [info exists ::GidPriv(PostAnimateContourUsedLimits)] } {
		        PostAnimateSetUsedLimits $::GidPriv(PostAnimateContourUsedLimits)
		    }
		}

		if { $resv == "displayvectors"} {
		    GiD_Process Mescape Results $resv $res_name $res_comp $res_factor
		} elseif { $resv == "scalarlinediagram"} {
		    GiD_Process Mescape Results LineDiagram ScalarDiagram $res_name $res_comp $res_factor
		} elseif { $resv == "vectorlinediagram"} {
		    GiD_Process Mescape Results LineDiagram VectorDiagram $res_name $res_factor
		} elseif { $resv == "isosurfaces"} {
		    set lst_valores [ lindex $res_factor 1]
		    GiD_Process Mescape Results $resv Exact $res_name $res_comp \
		        [ lindex $res_factor 0] {*}$lst_valores
		    # WarnWinText "3- $res_factor ( $::GidPriv(PostAnimateIsoSurfaces))"
		    # WarnWinText "3- GiD_Process Mescape Results $resv Exact $res_name $res_comp \
		    #     [ lindex $res_factor 0] {*}$lst_valores"
		    # foreach val $lst_valores {
		    #         GiD_Process $val
		    # }
		} else {
		    GiD_Process Mescape Results $resv $res_name $res_comp
		}
	    }
	}
    }

    #WarnWin "istep = $istep - frame = $frame"

    #if { $::GidPriv(PostAnimateDeform)} {
    #DebugPostAnim "GET AutomaticRedraw $::GidPriv(PostAnimateOldAutoRedraw)"
    GiD_Set AutomaticRedraw $::GidPriv(PostAnimateOldAutoRedraw)
    #.central.s render
    GiDActualizaVentanasTogl
    #}

    if { $::GidPriv(PostAnimateSavingAnimation) } {
	# for { set irepe 0} { $irepe < $::GidPriv(PostAnimateSavingRepes)} { incr irepe} {
	#     GiD_Process 'AnimationFile AddFrame
	# }
	GiD_Process 'AnimationFile AddStep
	#PostAnimateShowFileSize
    } else {
	PostAnimateShowTime
    }
    if { $::GidPriv(PostAnimateSaveFrame)} {
	#WarnWin $::GidPriv(PostAnimateSaveFilename)
	GiD_Process 'Hardcopy $::GidPriv(PostAnimateSaveFrameFormat) $::GidPriv(PostAnimateSaveFilename)
    }

    if { $::GidPriv(PostAnimateResultViewCb) && $::GidPriv(PostAnimateAnalysisLimitsCb)} {
	PostAnimatePopLimits
    }

    if { $::GidPriv(PostAnimateDoing) == "Rewind"} {
	set GidPriv(PostAnimateDoing) Stop
	PostAnimateFrame $frame
	return
    }

    update idletasks
   if { $::GidPriv(PostAnimateDelay) } {
       set delay [ PostAnimateGetValidDelayTime]
       after $delay "PostAnimateFrame [expr $frame + 1]"   
    } else {
	if { $::GidPriv(PostAnimateDuration)} {
	    if { $::GidPriv(PostAnimateDurationWStep)} {
		set GidPriv(PostAnimateStepvalues) 1
	    } else {
		set GidPriv(PostAnimateStepvalues) 0
	    }
	}
	if { $::GidPriv(PostAnimateStepvalues)} {
	    if {$::GidPriv(PostAnimateDuration)} {
		set npas [ expr $::GidPriv(PostAnimateRangeFrameTo)  - 1]
		set pas_final [lindex $::GidPriv(PostAnimate_all_step) $npas]
		set dur [ expr double($::GidPriv(PostAnimateDurationTime))/$pas_final]
	    } else {
		set dur 1
	    }
	    set frame1 [expr $istep-$::GidPriv(PostAnimateIstepold)]
	    set GidPriv(PostAnimateIstepold) $istep
		set val [expr int([expr $frame1*1000*$dur])]
		if { $val <= 0} {
		    set val 5
		}
		set GidPriv(PostAnimateStepvaluesDelay) $val
	    after [expr $::GidPriv(PostAnimateStepvaluesDelay)] "PostAnimateFrame [expr $frame + 1]"
	} else {
	    if {$::GidPriv(PostAnimateDuration)} {
		set GidPriv(PostAnimateDurationTimeDelay) [expr {$::GidPriv(PostAnimateDurationTime)*1000/$::GidPriv(PostAnimateRangeFrameTo)}]
		if { $::GidPriv(PostAnimateDurationTimeDelay) <= 0} {
		    set GidPriv(PostAnimateDurationTimeDelay) 5
		}
		set delay $::GidPriv(PostAnimateDurationTimeDelay)
	    } else {
		set delay [ PostAnimateGetValidDelayTime]
	    }
	    after $delay "PostAnimateFrame [expr $frame + 1]"
	}
    }
    return

}

proc PostAnimateProcessGIFOption { format} {
    set ret $format
    if { [ regexp {^GIF/(.+)$} $format dum opt] != 0} {
	set ret GIF
	GiD_Process 'Hardcopy Options GIFDithering $opt
    }
    return $ret
}

proc PostAnimateWriteGIFOption { fo format} {
    set ret $format
    # handles [_ "GIF/no dithering"] [_ "GIF/dithering595"] [_ "GIF/dithering666"]
    if { [ regexp {^GIF/(.+)$} $format dum opt] != 0} {
	set ret GIF
	puts $fo "'Hardcopy Options GIFDithering $opt"
    }
    return $ret
}

proc PostAnimatePlay { w { un_paso 0}} {
    global GidPriv
    # WarnWinText "PostAnimatePlay"
    if { $::GidPriv(PostAnimateDoing) != "Nothing"} { return}

    # if { ( $::GidPriv(PostAnimateResultView) == "" ) && !$::GidPriv(PostAnimateDeform)} {
    #           WarnWin [_ "Please check ResultView or Deformation"] $::GidPriv(PostAnimateWindow)
    #           return
    # }
    #WarnWinText "PostAnimatePlay: rangeframes = $::GidPriv(PostAnimateRangeFrames) from $::GidPriv(PostAnimateRangeFrameFrom) to $::GidPriv(PostAnimateRangeFrameTo). Check = [ PostAnimateCheckRangeFrame]"
    if { $::GidPriv(PostAnimateRangeFrames) && ![ PostAnimateCheckRangeFrame]} { return}

    if { ![ PostAnimateCheckWhichAnimation]} { return}

    PostAnimateCheckVisualizationCoherency

    if { $::GidPriv(PostAnimateDelay)} {
	if { [ catch { set pp [ expr $::GidPriv(PostAnimateDelayTime)]}] } {
	    WarnWin [_ "Delay '%s' not correct." $::GidPriv(PostAnimateDelayTime)] $::GidPriv(PostAnimateWindow)
	    return
	}
	if { $::GidPriv(PostAnimateDelayTime) < 0} {
	    WarnWin [_ "Delay '%s' not correct." $::GidPriv(PostAnimateDelayTime)] $::GidPriv(PostAnimateWindow)
	    return
	}
	if { $::GidPriv(PostAnimateDelayTime) > 15000} {
	    set resp [ tk_messageBox -parent $::GidPriv(PostAnimateWindow) -default no -title [_ "Confirm"] -type yesno \
		-message [_ "Are you sure you want to use %s ms as delay?" $::GidPriv(PostAnimateDelayTime)]]
	    if { $resp == "no"} {
		return
	    }
	}
    }

    if { $::GidPriv(PostAnimateDuration)} {
	if { [ catch { set pp [ expr $::GidPriv(PostAnimateDurationTime)]}] } {
	    WarnWin [_ "Duration '%s' not correct." $::GidPriv(PostAnimateDurationTime)] $::GidPriv(PostAnimateWindow)
	    return
	}
	if { $::GidPriv(PostAnimateDurationTime) < 0} {
	    WarnWin [_ "Duration '%s' not correct." $::GidPriv(PostAnimateDurationTime)] $::GidPriv(PostAnimateWindow)
	    return
	}
	if { $::GidPriv(PostAnimateDurationTime) > 200} {
	    set resp [ tk_messageBox -parent $::GidPriv(PostAnimateWindow) -default no -title [_ "Confirm"] -type yesno \
		    -message [_ "Are you sure you want to use %s s as duration?" $::GidPriv(PostAnimateDurationTime)]]
	    if { $resp == "no"} {
		return
	    }
	}
    }

    if { $::GidPriv(PostAnimateEndless) && ( $::GidPriv(PostAnimateSaveAnimation) || $::GidPriv(PostAnimateSaveFrame))} {
	set what ""
	if { $::GidPriv(PostAnimateSaveFrame)} {
	    set what "save $::GidPriv(PostAnimateSaveFrameFormat)'s"
	}
	if { $::GidPriv(PostAnimateSaveAnimation)} {
	    if { $what == ""} {
		set what "save the $::GidPriv(PostAnimateSaveAnimationFormat)"
	    } else {
		set what "$what & save the $::GidPriv(PostAnimateSaveAnimationFormat)"
	    }
	}
	set resp [ tk_dialog $::GidPriv(PostAnimateWindow).___pa_ww2 [_ "Warning"] \
		       [_ "Are you sure to do an ENDLESS animation AND %s, so that the disk will be filled?" $what]\
		       error 1 [_ "Yes, I know"] [_ "No, I wouldn't"]]
	switch $resp {
	    0 {
		WarnWin [_ "Remember to push the STOP button to STOP the animation and so, not to fill the disk !!!"] $::GidPriv(PostAnimateWindow)
	    }
	    1 {
		return
	    }
	}
    }

    #if { $::GidPriv(PostAnimateSaveAnimation) && !$::GidPriv(PostAnimateDelay) } {
	 # set resp [ tk_messageBox -parent $::GidPriv(PostAnimateWindow) -icon warning -type yesno \
	#           -default no -message \
	#           "Saving a MPEG animation file without delay between Steps can cause some strange efects in Microsoft Windows 95/98/NT.\n Are you sure you want continue?" ]
	# if { $resp == "no"} {
	#     return
	# }
     #   WarnWin [_ "There is no delay selected, using default of 200 ms. \n If you want no delay, please check the delay time entry."] $::GidPriv(PostAnimateWindow)
    #}
#     set cur_anal   $::GidPriv(PostAnimate_cur_anal)
#     set cur_step   $::GidPriv(PostAnimate_cur_step)
#     set all_step   $::GidPriv(PostAnimate_all_step)
#     set cur_resv   $::GidPriv(PostAnimate_cur_resv)
#     set cur_res    $::GidPriv(PostAnimate_cur_res)
#     set cur_comp   $::GidPriv(PostAnimate_cur_comp)
#     set cur_defor  $::GidPriv(PostAnimate_cur_defor)
#     set cur_factor $::GidPriv(PostAnimate_cur_factor)

#     if { $::GidPriv(PostAnimateCurrentFrame) == ""} {
#         if { $::GidPriv(PostAnimateDeform)} {
#             set GidPriv(PostAnimateCurrentFrame) -1
#         } else {
#             set GidPriv(PostAnimateCurrentFrame) 0
#         }
#     }

    # configuramos la slide
#     if { $::GidPriv(PostAnimateDeform)} {
#         $::GidPriv(PostAnimateSlide) configure -from 0 -to [ expr [ llength $all_step]] -resolution 1
#     } else {
#         $::GidPriv(PostAnimateSlide) configure -from 1 -to [ expr [ llength $all_step]] -resolution 1
#     }
#WarnWin $::GidPriv(PostAnimateCurrentFrame)

    if { $::GidPriv(PostAnimateSaveAnimation) } {
	if { ![ PostAnimateVerificaPermisos $w $::GidPriv(PostAnimateSaveAnimationFile)]} {
	    return
	}
	# para que no nos actualize el estado de resultados:
	#puede que estemos haciendo una animacion de deformada y estemos en el estado original
	set GidPriv(PostAnimateInitializing) 1
	GiD_Process 'AnimationFile Format [ PostAnimateProcessGIFOption $::GidPriv(PostAnimateSaveAnimationFormat)]
	set GidPriv(PostAnimateInitializing) 0

	if { $::GidPriv(PostAnimateSaveAnimationFormat) == "AVIMJPG" || \
		 $::GidPriv(PostAnimateSaveAnimationFormat) == "AVIMSVC" || \
		 $::GidPriv(PostAnimateSaveAnimationFormat) == "AVI" || \
		 $::GidPriv(PostAnimateSaveAnimationFormat) == "AVI15" || \
		 $::GidPriv(PostAnimateSaveAnimationFormat) == "AVI16" || \
		 $::GidPriv(PostAnimateSaveAnimationFormat) == "FLV"} {
	    set info2 [.central.s configure]
	    set height_list [ lindex $info2 0]
	    set width_list [ lindex $info2 1]
	    set width [ lindex $width_list 4]
	    set height [ lindex $height_list 4]

	    set avisize [ expr $width * $height * ( [ llength $::GidPriv(PostAnimate_all_step)] + $::GidPriv(PostAnimateDeform))]
	    if { $::GidPriv(PostAnimateSaveAnimationFormat) == "AVIMJPG" } {
		# estimacion aproximada
		set avisize [ expr $avisize * 3 * 0.1]
	    } elseif { $::GidPriv(PostAnimateSaveAnimationFormat) == "AVIMSVC" } {
		# estimacion aproximada
		set avisize [ expr $avisize * 3 * 0.15]
	    } elseif { $::GidPriv(PostAnimateSaveAnimationFormat) == "AVI" } {
		set avisize [ expr $avisize * 3]
	    } elseif { $::GidPriv(PostAnimateSaveAnimationFormat) == "FLV" } {
		# estimacion aproximada
		set avisize [ expr $avisize * 3 * 0.1]
	    } else {
		set avisize [ expr $avisize * 2]
	    }
	    set avisize [ expr ( $avisize / 1024.0) / 1024.0]

	    if { $avisize > 95.00 } {
		set resp [ tk_messageBox -parent $::GidPriv(PostAnimateWindow) -icon warning -type yesno \
		        -default no -message \
		        "Warning: the AVI/FLV file will be [ format %.3g $avisize] MB big !!!\n Are you sure you want continue?" ]
		if { $resp == "no"} {
		    return
		}
	    }
	    #WarnWin "The AVI file will be [ format %.3g $avisize] MB big !!!"
	}

	# Frame rate = 25 FPS == 40 ms.
	set repe 1
	if { $::GidPriv(PostAnimateDelay) } {
	    if { $::GidPriv(PostAnimateDelayTime) != ""} {
		if { $::GidPriv(PostAnimateDelayTime) == 0 && $::GidPriv(PostAnimateSaveAnimationFormat) == "MPEG" } {
		    set resp [ tk_messageBox -parent $::GidPriv(PostAnimateWindow) -icon warning -type yesno \
				   -default no -message \
				   "Saving a MPEG animation file without delay between Steps can cause some strange efects in Microsoft Windows 95/98/NT.\n Are you sure you want continue?" ]
		    if { $resp == "no"} {
			return
		    }
		}
	    }
#            set repe [ expr int(0.5 + $::GidPriv(PostAnimateDefaultDelayTime)/40.0)]
	    set repe 1
	    catch {
		set repe [ expr int(0.5 + $::GidPriv(PostAnimateDelayTime)/40.0)]
	    }
	    if { $repe == 0} { set repe 1}
	} else {
	    # por defecto 200 ms. # medio segundo
	    set repe [ expr int(0.5 + 200.0/40.0)]
	    if { $repe == 0} { set repe 1}
	}

	set GidPriv(PostAnimateSavingRepes) $repe
	GiD_Process 'AnimationFile FramesPerStep $::GidPriv(PostAnimateSavingRepes) escape escape escape escape
	GiD_Process 'AnimationFile Start $::GidPriv(PostAnimateSaveAnimationFile) Yes escape escape escape escape

	set GidPriv(PostAnimateSavingAnimation) 1

	update
    }

    # para mostrar al usuario el tamanyo delete archivo
    if { $::GidPriv(PostAnimateStepvalues) } {
	set temps [lindex $::GidPriv(PostAnimate_all_step) 0]
	set GidPriv(PostAnimateTime) [expr int([expr $temps*1000])]
    } else {
	set GidPriv(PostAnimateTime) 0
    }

    set GidPriv(PostAnimateDoing) Animate
    if { !$un_paso} {
	PostAnimateDisableGUIUpdates
    }

    #if { $w != ""} {
	#TryRoundRelief $w sunken
	#$w configure -relief sunken
    #}
    set GidPriv(PostAnimateCurrentButton) $w

    set ::GidPriv(PostAnimateContourUsedLimits) [PostAnimateGetUsedLimits]
    #WarnWinText "PostAnimatePlay: 5 $::GidPriv(PostAnimateCurrentFrame)"
    #WarnWinText "PostAnimatePlay: un_paso = $un_paso   CurrentFrame = $::GidPriv(PostAnimateCurrentFrame)"
    PostAnimateFrame $::GidPriv(PostAnimateCurrentFrame)
}

proc PostAnimateStop { w} {
    global GidPriv
    #WarnWinText "PostAnimateStop"
    if { $::GidPriv(PostAnimateDoing) == "Nothing"} { return}
    #if { $::GidPriv(PostAnimateCurrentButton) != ""} {
	#TryRoundRelief $::GidPriv(PostAnimateCurrentButton) raised
	#$::GidPriv(PostAnimateCurrentButton) configure -relief raised
    #}
    set GidPriv(PostAnimateDoing) Stop
    #if { $w != ""} {
	#TryRoundRelief $w sunken
	#$w configure -relief sunken
    #}
    set GidPriv(PostAnimateCurrentButton) $w
}

proc PostAnimateRewind { w} {
    global GidPriv

    #if { $::GidPriv(PostAnimateCurrentButton) != ""} {
	#TryRoundRelief $::GidPriv(PostAnimateCurrentButton) raised
	#$::GidPriv(PostAnimateCurrentButton) configure -relief raised
    #}
    #if { $w != ""} {
	#TryRoundRelief $w sunken
	#$w configure -relief sunken
    #}
    if { $::GidPriv(PostAnimateStepvalues) } { set GidPriv(PostAnimateTime) 0}
    set GidPriv(PostAnimateCurrentButton) $w
    #WarnWin "Rewind: $::GidPriv(PostAnimateDoing)"
    if { $::GidPriv(PostAnimateDoing) != "Animate"} {
	set GidPriv(PostAnimateDoing) Rewind
	set oldstepvalues $::GidPriv(PostAnimateStepvalues)
	set oldskipframes $::GidPriv(PostAnimateRangeFrames)
	set oldsave $::GidPriv(PostAnimateSaveFrame)
	set oldsaveanim $::GidPriv(PostAnimateSaveAnimation)
	set GidPriv(PostAnimateStepvalues) 0
	set GidPriv(PostAnimateRangeFrames) 0
	set GidPriv(PostAnimateSaveFrame) 0
	set GidPriv(PostAnimateSaveAnimation) 0
	PostAnimateFrame $::GidPriv(PostAnimateCurrentFrame)
	set GidPriv(PostAnimateSaveFrame) $oldsave
	set GidPriv(PostAnimateSaveAnimation) $oldsaveanim
	set GidPriv(PostAnimateRangeFrames) $oldskipframes
	set GidPriv(PostAnimateStepvalues) $oldstepvalues
    } else {
	set GidPriv(PostAnimateDoing) Rewind
    }
}

proc PostAnimateStep { w} {
    global GidPriv

    #WarnWinText "PostAnimateStep"
    set oldskipframes $::GidPriv(PostAnimateRangeFrames)
    set old $::GidPriv(PostAnimateDefaultDelayTime)
    set oldduration $::GidPriv(PostAnimateDuration)
    set olddurationtime $::GidPriv(PostAnimateDefaultDurationTime)
    set oldstepvalues $::GidPriv(PostAnimateStepvalues)
    set oldsave $::GidPriv(PostAnimateSaveFrame)
    set oldsaveanim $::GidPriv(PostAnimateSaveAnimation)
    set GidPriv(PostAnimateRangeFrames) 0
    set GidPriv(PostAnimateDefaultDelayTime) 5
    set GidPriv(PostAnimateDuration) 0
    set GidPriv(PostAnimateDefaultDurationTime) 0
    set GidPriv(PostAnimateStepvalues) 0
    set GidPriv(PostAnimateSaveFrame) 0
    set GidPriv(PostAnimateSaveAnimation) 0
    # para que tambien actualize las ventanas
    PostAnimatePlay $w 1
    PostAnimateStop $w
    set GidPriv(PostAnimateSaveAnimation) $oldsaveanim
    set GidPriv(PostAnimateSaveFrame) $oldsave
    set GidPriv(PostAnimateDefaultDelayTime) $old
    set GidPriv(PostAnimateDuration) $oldduration
    set GidPriv(PostAnimateDefaultDurationTime) $olddurationtime
    set GidPriv(PostAnimateStepvalues) $oldstepvalues
    set GidPriv(PostAnimateRangeFrames) $oldskipframes
}

proc PostAnimateMPEGLeds { estado} {
    global GidPriv

    set w $::GidPriv(PostAnimateWindow)
    set led_libre $::GidPriv(PostAnimateMPEG_led_libre)
    #set led_ocupado $::GidPriv(PostAnimateMPEG_led_ocupado)

    switch $estado {
	DISABLED {
	    $w.f_anim.f.cv itemconfigure $led_libre -fill grey60
	    #$w.f_anim.f.cv itemconfigure $led_ocupado -fill grey60
	}
	FREE {
	    $w.f_anim.f.cv itemconfigure $led_libre -fill green
	    #$w.f_anim.f.cv itemconfigure $led_ocupado -fill grey60
	}
	BUSY {
	    $w.f_anim.f.cv itemconfigure $led_libre -fill red
	    #$w.f_anim.f.cv itemconfigure $led_ocupado -fill red
	}
	default {
	    WarnWin [_ "Unknown led state: %s" $estado] $::GidPriv(PostAnimateWindow)
	    $w.f_anim.f.cv itemconfigure $led_libre -fill grey60
	    #$w.f_anim.f.cv itemconfigure $led_ocupado -fill grey60
	}
    }

}

proc PostAnimateTogleDelayEntry { name1 name2 op} {
    global GidPriv

    set w $::GidPriv(PostAnimateWindow)
    if { $::GidPriv(PostAnimateDelay) } {
	$w.f_dur.f_del.e configure -state normal
	# -foreground black
	focus $w.f_dur.f_del.e
    } else {
	$w.f_dur.f_del.e configure -state disabled
	# -foreground grey60
    }
}

proc PostAnimateTogleDurationEntry { name1 name2 op} {
    global GidPriv

    set w $::GidPriv(PostAnimateWindow)
    if { $::GidPriv(PostAnimateDuration) } {
	$w.f_dur.dur.e configure -state normal
	# -foreground black
	focus $w.f_dur.dur.e
	#$w.f_dur.f_del.cb configure -state disabled -foreground grey60
	#$w.f_dur.f_del.e configure -state disabled -foreground grey60
	$w.f_dur.f_sca.cb configure -state normal
	# -foreground black
	#set GidPriv(PostAnimateDelayTime) [expr {$::GidPriv(PostAnimateDurationTime)*1000/$::GidPriv(PostAnimateRangeFrameTo)}]
	
    } else {
	$w.f_dur.dur.e configure -state disabled
	# -foreground grey60
	$w.f_dur.f_sca.cb configure -state disabled
	# -foreground grey60
	#$w.f_dur.f_del.cb configure -state normal -foreground black
	#$w.f_dur.f_del.e configure -state normal -foreground black
    }
}

proc PostAnimateGetDurationType { name1 name2 op} {

    global GidPriv

    if { $::GidPriv(PostAnimateDurationType) == "TotalTime" } {
	set GidPriv(PostAnimateDuration) 1
	set GidPriv(PostAnimateDelay) 0
	if { $::GidPriv(PostAnimateDurationWStep) } {
	    if { [ PostAnimateThereAreResultsInModel complain]} {
		set GidPriv(PostAnimateStepvalues) 1
	    } else {
		set ::GidPriv(PostAnimateDurationWStep) 0
	    }
	} else {
	    set GidPriv(PostAnimateStepvalues) 0
	}
    }

    if { $::GidPriv(PostAnimateDurationType) == "Delay" } {
	set GidPriv(PostAnimateDuration) 0
	set GidPriv(PostAnimateDelay) 1
	set GidPriv(PostAnimateStepvalues) 0
    }

    if { $::GidPriv(PostAnimateDurationType) == "StepValue" } {
	if { [ PostAnimateThereAreResultsInModel complain]} {
	    set GidPriv(PostAnimateDuration) 0
	    set GidPriv(PostAnimateDelay) 0
	    set GidPriv(PostAnimateStepvalues) 1
	} else {
	    set ::GidPriv(PostAnimateDurationType) $::GidPriv(PostAnimateDefaultDurationType)
	}
    }
}

proc CheckPostAnimateDurationWStep { } {
    if { $::GidPriv(PostAnimateDurationWStep) &&
	 ![ PostAnimateThereAreResultsInModel complain]} {
	set ::GidPriv(PostAnimateDurationWStep) 0
    }
}

proc PostAnimateTogleRangeFramesEntry { name1 name2 op} {
    global GidPriv

    set w $::GidPriv(PostAnimateWindow)
    if { $::GidPriv(PostAnimateRangeFrames) } {
	if { ![ PostAnimateThereAreResultsInModel complain]} {
	    set ::GidPriv(PostAnimateRangeFrames) 0
	    return
	}
       # if { $::GidPriv(PostAnimateDuration) } {
	#    set GidPriv(PostAnimateDurationOld) 1
	    #set GidPriv(PostAnimateDuration) 0
	    #$w.f_opt.f_dur.e configure -state disabled -foreground grey60
	#} else {
	 #   set GidPriv(PostAnimateDurationOld) 0
	#}
	$w.f_opt.f_rangefr.ef configure -state normal
	# -foreground black
	focus $w.f_opt.f_rangefr.ef
	$w.f_opt.f_rangefr.et configure -state normal
	# -foreground black
	if { $::GidPriv(PostAnimateRangeFrameFrom) == $::GidPriv(PostAnimateRangeFrameTo)} {

	    set GidPriv(PostAnimateRangeFrameTo) [ llength $::GidPriv(PostAnimate_all_step)]
	}
    } else {
	# set GidPriv(PostAnimateRangeFrameTo) [ llength $::GidPriv(PostAnimate_all_step)]
	$w.f_opt.f_rangefr.ef configure -state disabled
	# -foreground grey60
	$w.f_opt.f_rangefr.et configure -state disabled
	# -foreground grey60
       # $w.f_opt.f_dur.cb configure -state normal -foreground black
	#$w.f_opt.f_dur.e configure -state normal -foreground black
	#set GidPriv(PostAnimateDuration) $::GidPriv(PostAnimateDurationOld)
       # if { $::GidPriv(PostAnimateStepvalues) } {
	#    set GidPriv(PostAnimateStepvalues) 0
	 #   set GidPriv(PostAnimateStepvalues) 1
	#}
    }
}

proc PostAnimateTogleSaveEntry { name1 name2 op} {
    global GidPriv

    set w $::GidPriv(PostAnimateWindow)
    if { $::GidPriv(PostAnimateSaveFrame) } {
	#$w.f_save.f.f.cb configure -foreground black
	$w.f_save.f.f.mb configure -state normal
	#$w.f_save.f.f.l configure -foreground black
	$w.f_save.f.b configure -state normal
	$w.f_save.e configure -state normal
	# -foreground black
	focus $w.f_save.e
    } else {
	#$w.f_save.f.f.cb configure -foreground grey60
	$w.f_save.f.f.mb configure -state disabled
	#$w.f_save.f.f.l configure -foreground grey60
	$w.f_save.f.b configure -state disabled
	$w.f_save.e configure -state disabled
	# -foreground grey60
    }
}

proc PostAnimateTogleMPEGLeds { name1 name2 op} {
    global GidPriv

    if { $::GidPriv(PostAnimateSavingAnimation) == 0} {
	PostAnimateMPEGLeds FREE
    }

    if { $::GidPriv(PostAnimateSavingAnimation) == 1} {
	PostAnimateMPEGLeds BUSY
    }
}

proc PostAnimateChangeExtension { new_format} {
    global GidPriv

    if { $::GidPriv(PostAnimateSaveAnimationFile) == "" } { return}
    set w $::GidPriv(PostAnimateWindow)

    set raiz [ file root $::GidPriv(PostAnimateSaveAnimationFile)]
    set ext [ string tolower [ file extension $::GidPriv(PostAnimateSaveAnimationFile)]]
    switch $new_format {
	"MPEG" {# $w.f_anim.e
	    if { ( $ext != ".mpeg") && ( $ext != ".mpg") } {
		set GidPriv(PostAnimateSaveAnimationFile) ${raiz}.mpg
	    }
	}
	"AVIMJPG" {
	    if { $ext != ".avi"} {
		set GidPriv(PostAnimateSaveAnimationFile) ${raiz}.avi
	    }
	}
	"AVIMSVC" {
	    if { $ext != ".avi"} {
		set GidPriv(PostAnimateSaveAnimationFile) ${raiz}.avi
	    }
	}
	"AVI" {
	    if { $ext != ".avi"} {
		set GidPriv(PostAnimateSaveAnimationFile) ${raiz}.avi
	    }
	}
	"AVI15" {
	    if { $ext != ".avi"} {
		set GidPriv(PostAnimateSaveAnimationFile) ${raiz}.avi
	    }
	}
	"AVI16" {
	    if { $ext != ".avi"} {
		set GidPriv(PostAnimateSaveAnimationFile) ${raiz}.avi
	    }
	}
	"GIF" {
	    if { $ext != ".gif"} {
		set GidPriv(PostAnimateSaveAnimationFile) ${raiz}.gif
	    }
	}
	"FLV" {
	    if { $ext != ".flv"} {
		set GidPriv(PostAnimateSaveAnimationFile) ${raiz}.flv
	    }
	}
    }
}

proc if_stereo_disable_force_cb { w} {
    array set stereo [ GiD_Info stereo]
    if { $stereo(Stereo) || ( [ info exists ::GID_Stereo(Stereo)] && $::GID_Stereo(Stereo))} {
	$w configure -state disabled
	#-foreground grey60
    } else {
	$w configure -state normal
	#-foreground black 
    }
}

proc PostAnimateTogleAnimEntry { name1 name2 op} {
    global GidPriv

    set w $::GidPriv(PostAnimateWindow)
    if { $::GidPriv(PostAnimateSaveAnimation) } {
	if {  [ info exists GidPriv(PostAnimateControlsSavingAnimation) ] && \
		$::GidPriv(PostAnimateControlsSavingAnimation) } {
	    WarnWin "Sorry, but couldn't save the animation while another one is active (Animation Controls Window)"
	    set GidPriv(PostAnimateSaveAnimation) 0
	    return
	}
	#$w.f_anim.f.f.cb configure -foreground black
	# $w.f_anim.f.f.cb_stereo configure -foreground black -state normal
	if_stereo_disable_force_cb $w.f_anim.f.f.cb_stereo
	$w.f_anim.f.f.mb configure -state normal
	#$w.f_anim.f.f.l configure -foreground black
	$w.f_anim.f.b configure -state normal
	$w.f_anim.e configure -state normal
	# -foreground black
	focus $w.f_anim.e
	PostAnimateMPEGLeds FREE
	trace add variable GidPriv(PostAnimateSavingAnimation) write PostAnimateTogleMPEGLeds
    } else {
	#$w.f_anim.f.f.cb configure -foreground grey60
	$w.f_anim.f.f.cb_stereo configure -state disabled
	# -foreground grey60
	$w.f_anim.f.f.mb configure -state disabled
	#$w.f_anim.f.f.l configure -foreground grey60
	$w.f_anim.f.b configure -state disabled
	$w.f_anim.e configure -state disabled
	# -foreground grey60
	PostAnimateMPEGLeds DISABLED
	trace remove variable GidPriv(PostAnimateSavingAnimation) write PostAnimateTogleMPEGLeds
    }
}

proc PostAnimateCheckDelayTime { name1 name2 op} {
    global GidPriv
    set w $::GidPriv(PostAnimateWindow)
    if { $::GidPriv(PostAnimateDelayTime) == ""} {
	return
    }
    set len [string length $::GidPriv(PostAnimateDelayTime)]
    set cur_digit [ string index $::GidPriv(PostAnimateDelayTime) [ expr $len - 1]]
    if { ( $cur_digit >= 0) && ( $cur_digit <= 9)} { return}
    if { ( $cur_digit == "e") || ( $cur_digit == "E") ||
	 ( $cur_digit == "+") || ( $cur_digit == "-") || ( $cur_digit == ".")} {
	return
    }
    set val [ string range $::GidPriv(PostAnimateDelayTime) 0 [ expr $len-2]]
    # if { $val <= 0} {
    # 	set val 5
    # } # avoid filling the entry with garbage while the user is writting in it
    set GidPriv(PostAnimateDelayTime) $val
}

proc PostAnimateCheckDurationTime { name1 name2 op} {
    global GidPriv
    set w $::GidPriv(PostAnimateWindow)
    set len [string length $::GidPriv(PostAnimateDurationTime)]
    set cur_digit [ string index $::GidPriv(PostAnimateDurationTime) [ expr $len - 1]]
    if { ( $cur_digit >= 0) && ( $cur_digit <= 9)} { return}
    if { ( $cur_digit == "e") || ( $cur_digit == "E") ||
	 ( $cur_digit == "+") || ( $cur_digit == "-") || ( $cur_digit == ".")} {
	return
    }
    set GidPriv(PostAnimateDurationTime) [ string range $::GidPriv(PostAnimateDurationTime) 0 [ expr $len-2]]
}

proc PostAnimateCheckRangeFrame { { msg 1}} {
    global GidPriv

    set ok 0
    if { !$::GidPriv(PostAnimateRangeFrames)} { return $ok}
    set w $::GidPriv(PostAnimateWindow)
    set end_step [ llength $::GidPriv(PostAnimate_all_step)]
    set ini_step 1
    if { $::GidPriv(PostAnimateDeform)} {
	set ini_step 0
    }

    # el from
    if { [ string is integer $::GidPriv(PostAnimateRangeFrameFrom)]} {
	if { ( $::GidPriv(PostAnimateRangeFrameFrom) >= $ini_step) && \
		 ( $::GidPriv(PostAnimateRangeFrameFrom) <= $end_step)} {
	    set ok 1
	}
    }
    if { !$ok} {
	set val_ant $::GidPriv(PostAnimateRangeFrameFrom)
	set GidPriv(PostAnimateRangeFrameFrom) $ini_step
	if { $msg} {
	    WarnWin [ format [_ "Wrong initial step: '%s', should be between %d and %d."] \
		          $val_ant $ini_step $end_step]
	}
    }

    # el to
    if { $ok} {
	set ok 0
	if { [ string is integer $::GidPriv(PostAnimateRangeFrameTo)]} {
	    if { ( $::GidPriv(PostAnimateRangeFrameTo) >= 0) && ( $::GidPriv(PostAnimateRangeFrameTo) <= $end_step)} {
		set ok 1
	    }
	}
	if { !$ok} {
	    set val_ant $::GidPriv(PostAnimateRangeFrameTo)
	    set GidPriv(PostAnimateRangeFrameTo) $end_step
	    if { $msg} {
		WarnWin [ format [_ "Wrong final step: '%s', should be between %d and %d."] \
		              $val_ant $ini_step $end_step]
	    }
	}
    }

    # si from <= to
    if { $ok} {
	if { $::GidPriv(PostAnimateRangeFrameFrom) > $::GidPriv(PostAnimateRangeFrameTo)} {
	    set ok 0
	    set val_ant $::GidPriv(PostAnimateRangeFrameFrom)
	    set GidPriv(PostAnimateRangeFrameFrom) $ini_step
	    if { $msg} {
		WarnWin [ format [_ "Crosing steps %d > %d."] \
		              $::GidPriv(PostAnimateRangeFrameFrom) $::GidPriv(PostAnimateRangeFrameTo)]
	    }
	}
    }
    #WarnWinText "  Check: $ini_step <= $::GidPriv(PostAnimateRangeFrameFrom), $::GidPriv(PostAnimateRangeFrameTo) <= $end_step = $ok"
    update idletasks
    return $ok
}

proc PostAnimateDoingSlide { } {
    global GidPriv

    if { $::GidPriv(PostAnimateSlideDelay)} {
	set GidPriv(PostAnimateSlideDelay) [ expr $::GidPriv(PostAnimateSlideDelay)-1]
	after 100 PostAnimateDoingSlide
    } else {
	set GidPriv(PostAnimateSlideDelay) 10
	if { $::GidPriv(PostAnimateDoing) == "Nothing"} {
	    set oldskipframes $::GidPriv(PostAnimateRangeFrames)
	    set old $::GidPriv(PostAnimateDefaultDelayTime)
	    set old $::GidPriv(PostAnimateDefaultDurationTime)
	    set oldsave $::GidPriv(PostAnimateSaveFrame)
	    set oldsaveanim $::GidPriv(PostAnimateSaveAnimation)
	    set GidPriv(PostAnimateRangeFrames) 0
	    set GidPriv(PostAnimateDefaultDelayTime) 5
	    set GidPriv(PostAnimateDefaultDurationTime) 0
	    set GidPriv(PostAnimateSaveFrame) 0
	    set GidPriv(PostAnimateSaveAnimation) 0
	    # para que tambien actualize las ventanas
	    PostAnimatePlay "" 1
	    PostAnimateStop ""
	    set GidPriv(PostAnimateRangeFrames) $oldskipframes
	    set GidPriv(PostAnimateSaveAnimation) $oldsaveanim
	    set GidPriv(PostAnimateSaveFrame) $oldsave
	    set GidPriv(PostAnimateDefaultDelayTime) $old
	    set GidPriv(PostAnimateDefaultDurationTime) $old
	}
	set GidPriv(PostAnimateSliding) 0
    }
}

proc PostAnimateChangeScale { frame} {
    global GidPriv

    if { $::GidPriv(PostAnimateInitializing)} { return}
    if { $::GidPriv(PostAnimateDoing) == "Nothing"} {
	set GidPriv(PostAnimateCurrentFrame) [ expr $frame-1]
	set GidPriv(PostAnimateSlideDelay) 10
	if { !$::GidPriv(PostAnimateSliding) } {
	    after 100 PostAnimateDoingSlide
	    set GidPriv(PostAnimateSliding) 1
	}
    }
}

proc PostAnimateCheckedDeform {} {
    global GidPriv

    if { $::GidPriv(PostAnimateDeform) } {
	set mainst [GiD_Info postprocess get main_geom_state]
	if { $mainst != "Deformed" } {
	    #WarnWin "Animation currently not supported for Main Geometry state $mainst"
	    WarnWin [_ "Please choose a Main Deformation Visualization first."] $::GidPriv(PostAnimateWindow)
	    set GidPriv(PostAnimateDeform) 0
	    return
	}
    }

    PostAnimateConfigureSlide
}


proc PostAnimateCheckedContour {} {
    global GidPriv

    regsub -all {_} $::GidPriv(PostAnimate_cur_resv) {} pepe
    set GidPriv(PostAnimate_cur_resv) $pepe
    if { $::GidPriv(PostAnimateResultView) == "" } {
	#WarnWin "Animation currently not suported for Results View $cur_resv"
	WarnWin [_ "Please choose a Results Visualization first."] $::GidPriv(PostAnimateWindow)
	set GidPriv(PostAnimateResultViewCb) 0
	return
    }

    if { $::GidPriv(PostAnimateResultViewCb) } {
	#$::GidPriv(PostAnimateResButtons).l configure -foreground black
	$::GidPriv(PostAnimateResButtons).b1 configure -state normal
	#$::GidPriv(PostAnimateResButtons).b2 configure -state normal
    } else {
	#$::GidPriv(PostAnimateResButtons).l configure -foreground grey60
	$::GidPriv(PostAnimateResButtons).b1 configure -state disabled
	#$::GidPriv(PostAnimateResButtons).b2 configure -state disabled
    }
    #set GidPriv(PostAnimateAnalysisLimitsCb) 1

    PostAnimateConfigureSlide
}

proc PostAnimateCheckWhichAnimation {} {
    global GidPriv

    regsub -all {_} $::GidPriv(PostAnimate_cur_resv) {} pepe
    set GidPriv(PostAnimate_cur_resv) $pepe
    if { $::GidPriv(PostAnimateResultViewCb) && ( $::GidPriv(PostAnimateResultView) == "") } {
	#WarnWin "Animation currently not suported for Results View $cur_resv"
	WarnWin [_ "Please choose a Results Visualization first. Or check 'Results' out."] $::GidPriv(PostAnimateWindow)
	return 0
    }

    if { $::GidPriv(PostAnimateDeform)  && ( $::GidPriv(PostAnimate_cur_d_defor) == "")} {
	#set mainst [GiD_Info postprocess get main_geom_state]
	#if { $mainst != "Deformed" } {
	    #WarnWin "Animation currently not supported for Main Geometry state $mainst"
	WarnWin [_ "Please choose a Main Deformation Visualization first. Or check 'Deformation' out."] $::GidPriv(PostAnimateWindow)
	    set GidPriv(PostAnimateDeform) 0
	    return 0
	#}
    }
    return 1
}

proc PostAnimateChooseSavePrefix {} {
    global GidPriv

    set GidPriv(PostAnimateSaveFrame) 1
    if { $::GidPriv(PostAnimateSaveFrame) } {
	set w $::GidPriv(PostAnimateWindow)
	if { $::GidPriv(PostAnimateSaveFrameFormat) == "PNG"} {
	    set GidPriv(PostAnimateSavePrefix) [Browser-ramR imagefile write .gid [_ "Prefix for '*.png' files"]...]
	    if { [ regexp -nocase {(.*).png$} $::GidPriv(PostAnimateSavePrefix) dum prefix]} {
		set GidPriv(PostAnimateSavePrefix) $prefix
	    }
	} elseif { $::GidPriv(PostAnimateSaveFrameFormat) == "GIF"} {
	    set GidPriv(PostAnimateSavePrefix) [Browser-ramR imagefile write .gid [_ "Prefix for '*.gif' files"]...]
	    if { [ regexp -nocase {(.*).gif$} $::GidPriv(PostAnimateSavePrefix) dum prefix]} {
		set GidPriv(PostAnimateSavePrefix) $prefix
	    }
	} elseif { $::GidPriv(PostAnimateSaveFrameFormat) == "TIFF"} {
	    set GidPriv(PostAnimateSavePrefix) [Browser-ramR imagefile write .gid [_ "Prefix for '*.tif' files"]...]
	    if { [ regexp -nocase {(.*).tif$} $::GidPriv(PostAnimateSavePrefix) dum prefix]} {
		set GidPriv(PostAnimateSavePrefix) $prefix
	    }
	    if { [ regexp -nocase {(.*).tiff$} $::GidPriv(PostAnimateSavePrefix) dum prefix]} {
		set GidPriv(PostAnimateSavePrefix) $prefix
	    }
	} elseif { $::GidPriv(PostAnimateSaveFrameFormat) == "JPEG"} {
	    set GidPriv(PostAnimateSavePrefix) [Browser-ramR imagefile write .gid [_ "Prefix for '*.jpg' files"]...]
	    if { [ regexp -nocase {(.*).jpg$} $::GidPriv(PostAnimateSavePrefix) dum prefix]} {
		set GidPriv(PostAnimateSavePrefix) $prefix
	    }
	    if { [ regexp -nocase {(.*).jpeg$} $::GidPriv(PostAnimateSavePrefix) dum prefix]} {
		set GidPriv(PostAnimateSavePrefix) $prefix
	    }
	} else {
	    set GidPriv(PostAnimateSavePrefix) [Browser-ramR imagefile write .gid [_ "Prefix for '*.png' files"]...]
	    if { [ regexp -nocase {(.*).png$} $::GidPriv(PostAnimateSavePrefix) dum prefix]} {
		set GidPriv(PostAnimateSavePrefix) $prefix
	    }
	}
	#$w.f_save.e delete 0 end
	#$w.f_save.e insert 0 $::GidPriv(PostAnimateSavePrefix)
    }
}

proc PostAnimateChooseAnimationFile {} {
    global GidPriv

    set GidPriv(PostAnimateSaveAnimation) 1
    if { $::GidPriv(PostAnimateSaveAnimation) } {
	set w $::GidPriv(PostAnimateWindow)
	switch [ PostAnimateProcessGIFOption $::GidPriv(PostAnimateSaveAnimationFormat)] {
	    "MPEG" {
		set GidPriv(PostAnimateSaveAnimationFile) \
		    [ Browser-ramR imagefile write .gid [_ "Save MPEG on"]... \
		          {} {{{Mpeg animation} {.mpg .mpeg}} {{All files} {.*}}} ".mpg" ]
	    }
	    "AVIMJPG" {
		set GidPriv(PostAnimateSaveAnimationFile) \
		    [ Browser-ramR imagefile write .gid [_ "Save AVI on"]... \
		          {} {{{AVI animation} {.avi}} {{All files} {.*}}} ".avi" \
		          0 [ list {AVI/mjpg options} CreateExportJPEGOpts ProcessExportJPEGOpts]]
	    }
	    "AVIMSVC" {
		set GidPriv(PostAnimateSaveAnimationFile) \
		    [ Browser-ramR imagefile write .gid [_ "Save AVI on"]... \
		          {} {{{AVI animation} {.avi}} {{All files} {.*}}} ".avi" \
		          0 [ list {AVI/msvc options} CreateExportAviMSVCOpts ProcessExportAviMSVCOpts]]
	    }
	    "AVI" {
		set GidPriv(PostAnimateSaveAnimationFile) \
		    [ Browser-ramR imagefile write .gid [_ "Save AVI on"]... \
		          {} {{{AVI animation} {.avi}} {{All files} {.*}}} ".avi" ]
	    }
	    "AVI15" {
		set GidPriv(PostAnimateSaveAnimationFile) \
		    [ Browser-ramR imagefile write .gid [_ "Save AVI on"]... \
		          {} {{{AVI animation} {.avi}} {{All files} {.*}}} ".avi" ]
	    }
	    "AVI16" {
		set GidPriv(PostAnimateSaveAnimationFile) \
		    [ Browser-ramR imagefile write .gid [_ "Save AVI on"]... \
		          {} {{{AVI animation} {.avi}} {{All files} {.*}}} ".avi" ]
	    }
	    "GIF" {
		set GidPriv(PostAnimateSaveAnimationFile) \
		    [ Browser-ramR imagefile write .gid [_ "Save GIF on"]... \
		          {} {{{GIF animation} {.gif}} {{All files} {.*}}} ".gif" \
		          0 [ list {GIF options} CreateExportGIFOpts ProcessExportGIFOpts] ]
	    }
	    "FLV" {
		set GidPriv(PostAnimateSaveAnimationFile) \
		    [ Browser-ramR imagefile write .gid [_ "Save Macromedia Flash Video on"]... \
		          {} {{{Macromedia Flash Video} {.flv}} {{All files} {.*}}} ".flv" \
		          0 [ list {Flash Video options} CreateExportFLVOpts ProcessExportFLVOpts]]
	    }
	}

	#$w.f_anim.e delete 0 end
	#$w.f_anim.e insert 0 $::GidPriv(PostAnimateSaveAnimationFile)
    }
}

proc PostAnimateGetUsedLimits {} {
    return [ lindex [ GiD_Info postprocess get contour_limits] 0]
}

proc PostAnimateSetUsedLimits { limits } {
    if { [ lindex $limits 0] == "STD"} {
	GiD_Process Mescape Results ContOptions SetMinOptions ResetValue
    } else {
	GiD_Process Mescape Results ContOptions SetMinOptions SetValue [ lindex $limits 1]
    }

    if { [ lindex $limits 2] == "STD"} {
	GiD_Process Mescape Results ContOptions SetMaxOptions ResetValue
    } else {
	GiD_Process Mescape Results ContOptions SetMaxOptions SetValue [ lindex $limits 3]
    }
}

proc PostAnimatePushLimits {} {
    global GidPriv
    set GidPriv(PostAnimateSavedLimits) [ lindex [ GiD_Info postprocess get contour_limits] 0]
}

proc PostAnimatePopLimits {} {
    global GidPriv

    if { [ lindex $::GidPriv(PostAnimateSavedLimits) 0] == "STD"} {
	GiD_Process Mescape Results ContOptions SetMinOptions ResetValue
    } else {
	GiD_Process Mescape Results ContOptions SetMinOptions SetValue [ lindex $::GidPriv(PostAnimateSavedLimits) 1]
    }

    if { [ lindex $::GidPriv(PostAnimateSavedLimits) 2] == "STD"} {
	GiD_Process Mescape Results ContOptions SetMaxOptions ResetValue
    } else {
	GiD_Process Mescape Results ContOptions SetMaxOptions SetValue [ lindex $::GidPriv(PostAnimateSavedLimits) 3]
    }

}

proc PostAnimateGetAnalysisLimits { name1 name2 op} {
    global GidPriv

    if { $::GidPriv(PostAnimateInitializing)} { return}
    if { $::GidPriv(PostAnimateResultViewCb) && $::GidPriv(PostAnimateAnalysisLimitsCb) } {
	PostAnimatePushLimits
	set GidPriv(PostAnimateInitializing) 1
#WarnWinText "hola($::GidPriv(PostAnimateAnalysisLimitsCb)) -> $name1 $name2"
	# si hay varios resultados, buscamos los limites del c.fill/lines/rango
	if { $::GidPriv(PostAnimateVariosResultados)} {
	    set GidPriv(PostAnimateOldAutoRedraw) [GiD_Set AutomaticRedraw]
#WarnWinText "old = $::GidPriv(PostAnimateOldAutoRedraw)"
	    #DebugPostAnim "GET_lim AutomaticRedraw $::GidPriv(PostAnimateOldAutoRedraw)"
	    #DebugPostAnim "SET_lim AutomaticRedraw -1"
	    GiD_Set AutomaticRedraw -1

	    GiD_Process Mescape Results Geometry NoResults Mescape
	    # pintamos solo el c.fill para conseguir los limites
	    foreach estado_res $::GidPriv(PostAnimateListaResultados) {
		set resv [ string tolower [ lindex $estado_res 1]]
		set res_name [ lindex $estado_res 4]
		set res_comp [ lindex $estado_res 5]
		set res_factor [ lindex $estado_res 6]
		regsub -all { } $resv {} resv
		if { $resv == "contourfill" || $resv == "smoothcontourfill" || \
		         $resv == "contourlines" || $resv == "smoothcontourlines" || \
		         $resv == "contourranges" } {
		    GiD_Process Mescape $resv $res_name $res_comp
		}
	    }
	}
	GiD_Process Mescape Results ContOptions FixAnalysisLim
	set GidPriv(PostAnimateAnalysisLimits) [ lindex [ GiD_Info postprocess get contour_limits] 0]
#WarnWinText "analysis limits = $::GidPriv(PostAnimateAnalysisLimits)"

	#devolvemos lo que estaba
	if { $::GidPriv(PostAnimateVariosResultados)} {
	    GiD_Process Mescape Results Geometry NoResults Mescape
	    if { $::GidPriv(PostAnimateResultViewCb) && $::GidPriv(PostAnimateResultView) != ""} {
		foreach estado_res $::GidPriv(PostAnimateListaResultados) {
		    set resv [ string tolower [ lindex $estado_res 1]]
		    set res_name [ lindex $estado_res 4]
		    set res_comp [ lindex $estado_res 5]
		    set res_factor [ lindex $estado_res 6]
		    regsub -all { } $resv {} resv
		    if { $resv == "displayvectors"} {
		        GiD_Process Mescape Results $resv $res_name $res_comp $res_factor
		    } elseif { $resv == "scalarlinediagram"} {
		        GiD_Process Mescape Results LineDiagram ScalarDiagram $res_name $res_comp $res_factor
		    } elseif { $resv == "vectorlinediagram"} {
		        GiD_Process Mescape Results LineDiagram VectorDiagram $res_name $res_factor
		    } else {
		        GiD_Process Mescape Results $resv $res_name $res_comp
		    }
		}
	    }
	    #DebugPostAnim "GET_lim AutomaticRedraw $::GidPriv(PostAnimateOldAutoRedraw)"
	    GiD_Set AutomaticRedraw $::GidPriv(PostAnimateOldAutoRedraw)
	    #WarnWinText "dejando como antes =  $::GidPriv(PostAnimateOldAutoRedraw)"
	}
	PostAnimatePopLimits
	set GidPriv(PostAnimateInitializing) 0
    }
}

proc PostAnimateSetAnalysisLimits {} {
    global GidPriv

    GiD_Process Mescape Results ContOptions SetMinOptions SetValue [ lindex $::GidPriv(PostAnimateAnalysisLimits) 1]
    GiD_Process Mescape Results ContOptions SetMaxOptions SetValue [ lindex $::GidPriv(PostAnimateAnalysisLimits) 3]
}

# this func is necessary to aviod the warning when going from pre to post
proc PostAnimateM { { w .gid.wPostAnimate } } {

    set mm [ GiD_Info postprocess get all_volumes]
    set ss [ GiD_Info postprocess get all_surfaces]
    if { ( $mm == "") && ( $ss == "") } {
	set w .gid
	if { [ info exists GidPriv(PostAnimateWindow)] && [ winfo exists $::GidPriv(PostAnimateWindow)]} {
	    set w $::GidPriv(PostAnimateWindow)
	}
	WarnWin [_ "Please load a model first."] $w
	return
    }
    PostAnimate $w
}

proc PostAnimateResize { } {
    global GidPriv

    set info [ wm geometry .gid]
    set info2 [.central.s configure]
    set height_list [ lindex $info2 0]
    set width_list [ lindex $info2 1]
    if { ![ regexp {([0-9]*)x([0-9]*)} $info trozo top_width top_height] } { return }
    set width_offset [ expr $top_width - [ lindex $width_list 4]]
    set height_offset [ expr $top_height - [ lindex $height_list 4]]

    if { $::GidPriv(PostAnimateResize) == "Default"} {
	set GidPriv(PostAnimateResize) $::GidPriv(PostAnimateResizeDefault)
    }
    if { ![ regexp {([0-9]*)x([0-9]*)} $::GidPriv(PostAnimateResize) trozo new_width new_height] } { return }

    #WarnWinText ".gid = $info = $top_width x $top_height"
    #WarnWinText "togl = [ lindex $width_list 4]x[ lindex $height_list 4]"
    #WarnWinText "offset = $width_offset x $height_offset"
    ## 768x576 640x480 512x384 320x240
    wm geometry .gid [ expr $width_offset + $new_width]x[ expr $height_offset + $new_height]
}

proc PostAnimateCrearAnimacion { w} {
    global GidPriv AnimacionEstatica
    set win [ AnimacionEstatica::Crear $w]
    tkwait window $win

    if { $::GidPriv(PostAnimateDeform)} {
	AnimacionEstaticaCreaFactores $::GidPriv(PostAnimate_cur_d_factor)
	#WarnWin $AnimacionEstatica(factores)
	PostAnimateConfigureSlide
    }
    #WarnWin "Animacion $AnimacionEstatica(tipo) con $AnimacionEstatica(pasos) pasos"

}

proc PostAnimateDoStep {} {
    # check if window is open
    if { [ winfo exists $::GidPriv(PostAnimateButtonFrame).step]} {
	PostAnimateStep $::GidPriv(PostAnimateButtonFrame).step
    }
}

proc CheckCreateStereoscopicAnimation {} {
    global GidPriv GIDDEFAULT AnimacionEstatica
    if { $::GidPriv(PostAnimateDoing) != "Animate" } {
	GiD_Set PostDoStereoAnimation $::GidPriv(PostDoStereoAnimation)
    }
}

proc PostAnimateFillComboWithCorrectWindowSizes { w} {

    set labels_all [ list [_ "Default"] \
			 "1920x1200" "1920x1080 HD" "1680x1050" "1680x945" \
			 "1440x900" "1440x810" "1366x768" \
			 "1280x1024" "1280x800" "1280x768" "1280x720 HD" \
			 "1024x768" "1024x640" "1024x600" "1024x576" \
			 "800x600" "720x576" "640x480" "512x384" "352x288" "320x240"]
    set values_all [ list Default \
			 1920x1200 1920x1080 1680x1050 1680x945 \
			 1440x900 1440x810 1366x768 \
			 1280x1024 1280x800 1280x768 1280x720 \
			 1024x768 1024x640 1024x600 1024x576 \
			 800x600 720x576 640x480 512x384 352x288 320x240]
    # experimental settings....
    set gui_margin_width 210
    set gui_margin_height 220
    set max_width [ expr [ winfo vrootwidth .] - $gui_margin_width]
    set max_height [ expr [ winfo vrootheight .] - $gui_margin_height]
    set combo_labels {}
    set combo_values {}
    foreach txt $labels_all resol $values_all {
	if { [ regexp {^([0-9]+)x([0-9]+)$} $resol dum width height] == 1} {
	    # check if resolution fits in screen
	    if { ( $width > $max_width) || ( $height > $max_height)} {
		# do not append resolution to list
		continue
	    }
	}
	# append resolution
	lappend combo_labels $txt
	lappend combo_values $resol
    }
    $w configure -labels $combo_labels -values $combo_values
}

proc PostAnimate { { w .gid.wPostAnimate } } {
    global GidPriv GIDDEFAULT AnimacionEstatica

    if { [ winfo exists $w]} {
	raise $w
	return
    }

    QuitaTraces
    set mm [ GiD_Info postprocess get all_volumes]
    set ss [ GiD_Info postprocess get all_surfaces]
    if { ( $mm == "") && ( $ss == "") } {
	return
    }

    set GidPriv(PostAnimateInitializing) 1
    PostAnimateInitValues

    InitWindow $w [_ "Animate"] PostAnimateWindowGeom PostAnimate
    if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0
	
    # Las opciones
    #ttk::frame $w.f_opt -relief ridge -borderwidth 2
    ttk::labelframe $w.f_opt -text [_ "Options"]



    #label $w.f_opt.l -text [_ "Check"]:
    ttk::frame $w.f_opt.res -borderwidth 0
    if { ![info exists GidPriv(PostAnimateResultViewCb)] } { set GidPriv(PostAnimateResultViewCb) 0 }
    ttk::checkbutton $w.f_opt.res.cb1 -text [_ "Results View"] -variable GidPriv(PostAnimateResultViewCb) \
    -command PostAnimateCheckedContour

    ttk::frame $w.f_opt.res.opt -borderwidth 0
    if { ![info exists GidPriv(PostAnimateAnalysisLimitsCb)] } { set GidPriv(PostAnimateAnalysisLimitsCb) 0 }
    ttk::checkbutton $w.f_opt.res.opt.b1 -text [_ "Automatic Limits"] \
	    -variable GidPriv(PostAnimateAnalysisLimitsCb)
    grid $w.f_opt.res.opt.b1 -padx 22 -sticky we

    GidHelp $w.f_opt.res.cb1 [_ "The result view evolution is shown. \n\
	    NOTE: the results view should be selected previously."]
    GidHelp $w.f_opt.res.opt.b1 [_ "The limits of the results view will be the same for the whole animation."]

    set GidPriv(PostAnimateResButtons) $w.f_opt.res.opt
    #$::GidPriv(PostAnimateResButtons).l configure -foreground grey60
    $::GidPriv(PostAnimateResButtons).b1 configure -state disabled
    #$::GidPriv(PostAnimateResButtons).b2 configure -state disabled

    grid $w.f_opt.res.cb1 -sticky w
    grid $w.f_opt.res.opt -sticky we
    grid rowconf $w.f_opt.res 1 -weight 1
    grid columnconf $w.f_opt.res 0 -weight 1

	if { ![info exists GidPriv(PostAnimateDeform)] } { set GidPriv(PostAnimateDeform) 0 }
    ttk::checkbutton $w.f_opt.cb2 -text [_ "Deformation"] -variable GidPriv(PostAnimateDeform) \
	    -command PostAnimateCheckedDeform
	if { ![info exists GidPriv(PostAnimateEndless)] } { set GidPriv(PostAnimateEndless) 0 }
    ttk::checkbutton $w.f_opt.cb3 -text [_ "Endless"] -variable GidPriv(PostAnimateEndless)

    GidHelp $w.f_opt.cb2 [_ "The evolution of the deformation is shown. \n\
	    NOTE: to use this option, the model should be deformed previously."]
    GidHelp $w.f_opt.cb3 [_ "After pressing the 'Play' button, the \
	    animation will not stop. \nNOTE: if the animation is saved, the entire disk may be filled."]


    ttk::frame $w.f_opt.f_rangefr
    if { ![info exists GidPriv(PostAnimateRangeFrames)] } { set GidPriv(PostAnimateRangeFrames) 0 }
    ttk::checkbutton $w.f_opt.f_rangefr.cb -text [_ "From step"] -variable GidPriv(PostAnimateRangeFrames)
    ttk::entry $w.f_opt.f_rangefr.ef -width 5 -textvariable GidPriv(PostAnimateRangeFrameFrom) \
	-validate focus -validatecommand PostAnimateCheckRangeFrame
	# -relief sunken
    ttk::label $w.f_opt.f_rangefr.lt -text [_ "to step"]
    ttk::entry $w.f_opt.f_rangefr.et -width 5 -textvariable GidPriv(PostAnimateRangeFrameTo) \
	-validate focus -validatecommand PostAnimateCheckRangeFrame
	# -relief sunken
    $w.f_opt.f_rangefr.ef configure -state disabled
    # -foreground grey60
    $w.f_opt.f_rangefr.et configure -state disabled
    # -foreground grey60
    #label $w.f_opt.f_rangefr.l -text [_ "step(s)."]
    grid $w.f_opt.f_rangefr.cb $w.f_opt.f_rangefr.ef $w.f_opt.f_rangefr.lt $w.f_opt.f_rangefr.et -sticky w

    GidHelp $w.f_opt.f_rangefr [_ "With this option the first N steps will be skiped."]

    ttk::button $w.f_opt.static -text [_ "Static analysis animation profile"]  \
	    -command "PostAnimateCrearAnimacion $w" 
	    #-wraplength 65 -borderwidth 1 -padx 8 -pady 3
    GidHelp $w.f_opt.static [_ "Configures the behaviour of the pseudo-animation\n \
	    of the deformation for analysis with only one step."]
    set AnimacionEstatica(boton) $w.f_opt.static

    #grid $w.f_opt.l
    grid $w.f_opt.res -sticky we
    grid $w.f_opt.cb2 -sticky w
    grid $w.f_opt.cb3 -sticky w
    grid $w.f_opt.f_rangefr -sticky w -columnspan 3
    #grid $w.f_opt.dt -sticky w
    #grid $w.f_opt.f_dur -sticky w
    #grid $w.f_opt.f_sca -sticky w
    #grid $w.f_opt.f_del -sticky w
    #grid $w.f_opt.cb4 -sticky w
    grid $w.f_opt.static -row 0 -column 1 -rowspan 3 -sticky e
    grid rowconf $w.f_opt 0 -weight 1
    grid columnconf $w.f_opt 0 -weight 1
    grid rowconf $w.f_opt 4 -weight 1
    grid rowconf $w.f_opt 5 -weight 1
    grid columnconf $w.f_opt 0 -weight 1

    #ttk::frame $w.f_dur -relief ridge -borderwidth 2
    ttk::labelframe $w.f_dur -text [_ "Duration"]

    ttk::label $w.f_dur.dt -text [_ "Set duration by"]:

    ttk::frame $w.f_dur.dur
    ttk::radiobutton $w.f_dur.dur.cb -text [_ "Total Time"]:  -value TotalTime -variable GidPriv(PostAnimateDurationType)
    ttk::entry $w.f_dur.dur.e -width 5 -textvariable GidPriv(PostAnimateDurationTime)
    # $w.f_dur.dur.e configure -state normal
    $w.f_dur.dur.e configure -state disabled
    # -foreground black -relief sunken
    ttk::label $w.f_dur.dur.l -text [_ "s."]
    grid $w.f_dur.dur.cb $w.f_dur.dur.e $w.f_dur.dur.l -sticky w

    GidHelp $w.f_dur.dur [_ "With this option the duration of the animation /
	    will be set with the entered seconds."]

    ttk::frame $w.f_dur.f_sca
    if { ![info exists GidPriv(PostAnimateDurationWStep)] } { set GidPriv(PostAnimateDurationWStep) 0 }
    ttk::checkbutton $w.f_dur.f_sca.cb -text [_ "use step values as scaled delays"] \
	-variable GidPriv(PostAnimateDurationWStep) \
	-command CheckPostAnimateDurationWStep
    grid $w.f_dur.f_sca.cb -padx 44 -sticky we

    GidHelp $w.f_dur.f_sca [_ "With this option the duration of the animation /
	    will be scaled with the step values."]

    ttk::frame $w.f_dur.f_del
    ttk::radiobutton $w.f_dur.f_del.cb -text [_ "Delay between steps"]:  -value Delay -variable GidPriv(PostAnimateDurationType)
    ttk::entry $w.f_dur.f_del.e -width 5 -textvariable GidPriv(PostAnimateDelayTime)
    set ::GidPriv(PostAnimateDelayTimeEntry) $w.f_dur.f_del.e
    # $w.f_dur.f_del.e configure -state disabled
    # -foreground grey60 -relief sunken
    ttk::label $w.f_dur.f_del.l -text [_ "ms."]
    #grid $w.f_opt.f_del.cb -sticky w
    #grid $w.f_opt.f_del.e -row 0 -column 1 -sticky w
    #grid $w.f_opt.f_del.l -row 0 -column 2 -sticky w
    grid $w.f_dur.f_del.cb $w.f_dur.f_del.e $w.f_dur.f_del.l -sticky w
    #grid rowconf $w.f_opt.f_del 0 -weight 1
    #grid columnconf $w.f_opt.f_del 1 -weight 1

    GidHelp $w.f_dur.f_del [_ "With this option a DelayTime of the entered milliseconds \
	    will be used between frames."]

    ttk::radiobutton $w.f_dur.cb4 -text [_ "Use step values as seconds"]  -value StepValue -variable GidPriv(PostAnimateDurationType)

    grid $w.f_dur.dt -sticky w
    grid $w.f_dur.dur -padx 22 -sticky w
    grid $w.f_dur.f_sca -padx 22 -sticky w
    grid $w.f_dur.f_del -padx 22 -sticky w
    grid $w.f_dur.cb4 -padx 22 -sticky w
    grid columnconf $w.f_dur 0 -weight 1
    grid rowconf $w.f_dur 0 -weight 1
    grid rowconf $w.f_dur 1 -weight 1
    grid rowconf $w.f_dur 2 -weight 1
    grid rowconf $w.f_dur 3 -weight 1
    grid rowconf $w.f_dur 4 -weight 1

    # los controles
    #ttk::frame $w.f_ctr -relief ridge -borderwidth 2
    ttk::labelframe $w.f_ctr -text [_ "Play"]

    # el chivato
    ttk::frame $w.f_ctr.f1
    ttk::label $w.f_ctr.f1.l -text [_ "Step number"]:
    ttk::entry $w.f_ctr.f1.e -width 6 -state disabled
    ttk::label $w.f_ctr.f1.lv -text [_ "Step value"]:
    ttk::entry $w.f_ctr.f1.ev -width 10 -state disabled
    ttk::label $w.f_ctr.f1.l2 -textvariable GidPriv(PostAnimateFileSize)
    # -foreground black -font SmallFont
    set GidPriv(PostAnimateFileSizeLabel) $w.f_ctr.f1.l2
    grid $w.f_ctr.f1.l -sticky e
    grid $w.f_ctr.f1.e -row 0 -column 1 -sticky w
    grid $w.f_ctr.f1.lv -row 0 -column 2 -sticky e
    grid $w.f_ctr.f1.ev -row 0 -column 3 -sticky w
    grid $w.f_ctr.f1.l2 -row 0 -column 4 -sticky ew
    grid rowconf $w.f_ctr.f1 0 -weight 1
    grid columnconf $w.f_ctr.f1 1 -weight 1
    grid columnconf $w.f_ctr.f1 3 -weight 1
    grid columnconf $w.f_ctr.f1 4 -weight 1

    gidscale $w.f_ctr.b -orient h -from 1 -to 2 \
	-showbuttons 1 -symbolbuttons "< >" \
	-command PostAnimateChangeScale
	#-sliderlength 16
	
   

    set GidPriv(PostAnimateSlide) $w.f_ctr.b
    set GidPriv(PostAnimateStepNumberEntry) $w.f_ctr.f1.e
    set GidPriv(PostAnimateStepValueEntry) $w.f_ctr.f1.ev
    set GidPriv(PostAnimateButtonFrame) $w.f_ctr.f2

    ttk::frame $w.f_ctr.f2
    #use gif instead png because some problem on $::tcl_platform(os) == "Darwin" (maybe this problem has been solved)
    ttk::button $w.f_ctr.f2.play -image [gid_themes::GetImage play.png large_icons] -command "PostAnimatePlay $w.f_ctr.f2.play"
    ttk::button $w.f_ctr.f2.stop -image [gid_themes::GetImage stop.png large_icons] -command "PostAnimateStop $w.f_ctr.f2.stop"
    ttk::button $w.f_ctr.f2.rewind -image [gid_themes::GetImage rewind.png large_icons] -command "PostAnimateRewind $w.f_ctr.f2.rewind"
    ttk::button $w.f_ctr.f2.step -image [gid_themes::GetImage skipforward.png large_icons] -command PostAnimateDoStep

    #set leave_bg [$w.f_ctr.f2.play cget -background]
    #set enter_bg [CCColorActivo $leave_bg]
    #foreach item [list $w.f_ctr.f2.play $w.f_ctr.f2.stop $w.f_ctr.f2.rewind $w.f_ctr.f2.step] {
	#bind $item <ButtonPress-1> "$item configure -background $leave_bg"
	#bind $item <Enter> "$item configure -background $enter_bg "
	#bind $item <Leave> "$item configure -background $leave_bg"
	#$item configure -relief flat ;#hay que corregir muchas funciones que lo cambian
	#TryRoundRelief $item raised 1
	#$item configure -relief raised
    #}

    grid $w.f_ctr.f2.rewind $w.f_ctr.f2.stop $w.f_ctr.f2.play $w.f_ctr.f2.step -padx 2 -pady 2 -sticky we

    grid $w.f_ctr.f1 -sticky we
    grid $w.f_ctr.b -sticky we
    grid $w.f_ctr.f2 -sticky we
    grid columnconf $w.f_ctr 0 -weight 1
    grid rowconf $w.f_ctr 0 -weight 1
    grid rowconf $w.f_ctr 1 -weight 1
    grid rowconf $w.f_ctr 2 -weight 1

    #ttk::frame $w.f_save
    ttk::labelframe $w.f_save -text [_ "Save image"]
    ttk::frame $w.f_save.f
    ttk::frame $w.f_save.f.f -borderwidth 0
    if { ![info exists GidPriv(PostAnimateSaveFrame)] } { set GidPriv(PostAnimateSaveFrame) 0 }
    ttk::checkbutton $w.f_save.f.f.cb -text [_ "Save"] -variable GidPriv(PostAnimateSaveFrame)

    #ComboBoxRAM $w.f_save.f.f.mb GidPriv(PostAnimateSaveFrameFormat) \
    #            [list "TIFF" "JPEG" GIF"] \
    #            {TIFF JPEG GIF}
    TTKComboBox $w.f_save.f.f.mb -textvariable ::GidPriv(PostAnimateSaveFrameFormat) \
	-labels [list "PNG" "TIFF" "JPEG" "GIF"] -values {PNG TIFF JPEG GIF} \
	-width 10 -state readonly

    ttk::label $w.f_save.f.f.l -text [_ "on"]
    grid $w.f_save.f.f.cb $w.f_save.f.f.mb $w.f_save.f.f.l \
	    -padx 0 -ipadx 0 -pady 0 -ipady 0 -sticky nsew
    ttk::button $w.f_save.f.b  -image [gid_themes::GetImage "folder.png" small_icons] -command PostAnimateChooseSavePrefix 
     #-borderwidth 1 -padx 8 -pady 3
    grid $w.f_save.f.f -sticky w
    grid $w.f_save.f.b -row 0 -column 1 -sticky e

    ttk::entry $w.f_save.e -width 5 -state disabled -textvariable GidPriv(PostAnimateSavePrefix)
    # -relief sunken 
		grid $w.f_save.f -sticky w
    grid $w.f_save.e -sticky we

    grid columnconf $w.f_save 0 -weight 1
    grid rowconf $w.f_save 0 -weight 1
    grid rowconf $w.f_save 1 -weight 1

    GidHelp $w.f_save.f.f.cb [_ "Check here to create an image sequence"]
    GidHelp $w.f_save.e [_ "To create a image sequence, the prefix of the images names must be entered here.\nImage names will be of the form Prefix-XX.ext"]
    GidHelp $w.f_save.f.f.mb [_ "Choose the file format of the image sequence."]
    GidHelp $w.f_save.f.b [_ "A file browser will be openned, so a file can be selected."]

    #ttk::frame $w.f_anim
    ttk::labelframe $w.f_anim -text [_ "Save animation"]
    ttk::frame $w.f_anim.f    
    ttk::frame $w.f_anim.f.f -borderwidth 0

	if { ![info exists ::GidPriv(PostDoStereoAnimation)] } { set ::GidPriv(PostDoStereoAnimation) 0 }
    ttk::checkbutton $w.f_anim.f.f.cb_stereo -text [_ "Create a stereoscopic animation"] \
	-variable ::GidPriv(PostDoStereoAnimation) \
	-command CheckCreateStereoscopicAnimation

    if { ![info exists GidPriv(PostAnimateSaveAnimation)] } { set GidPriv(PostAnimateSaveAnimation) 0 }
    ttk::checkbutton $w.f_anim.f.f.cb -text [_ "Save"] -variable GidPriv(PostAnimateSaveAnimation)

    # ComboBoxRAM $w.f_anim.f.f.mb GidPriv(PostAnimateSaveAnimationFormat) \
    #         [list [_ "MPEG"] [_ "AVI/mjpeg"] [_ "AVI/MS Video 1"] [_ "AVI/raw True Color"] \
    #              [_ "AVI/raw 15 bpp (VD)"] [_ "AVI/raw 16 bpp (MS)"] [_ "GIF"]] \
    #             {MPEG AVIMJPG AVIMSVC AVI AVI15 AVI16 GIF}
    TTKComboBox $w.f_anim.f.f.mb -textvariable ::GidPriv(PostAnimateSaveAnimationFormat) \
	-labels [ list [_ "MPEG"] [_ "AVI/mjpeg"] [_ "AVI/MS Video 1"] [_ "AVI/raw True Color"] \
		      [_ "AVI/raw 15 bpp (VD)"] [_ "AVI/raw 16 bpp (MS)"] \
		      [_ "GIF/no dithering"] [_ "GIF/dithering595"] [_ "GIF/dithering666"] \
		      [_ "Macromedia Flash Video (flv)"]] \
	-values {MPEG AVIMJPG AVIMSVC AVI AVI15 AVI16 GIF/None GIF/Dither595 GIF/Dither666 FLV} \
	-width 26 -state readonly

    ttk::label $w.f_anim.f.f.l -text [_ "on"]
    grid $w.f_anim.f.f.cb $w.f_anim.f.f.mb $w.f_anim.f.f.l \
	    -padx 0 -ipadx 0 -pady 0 -ipady 0 -sticky nsew
    grid $w.f_anim.f.f.cb_stereo -columnspan 3 -stick w -pady 0 -ipady 0

    if_stereo_disable_force_cb $w.f_anim.f.f.cb_stereo

    # to actualize the checkbutton
    set ::GidPriv(PostDoStereoAnimation) $::GidPriv(PostDoStereoAnimation)

    ttk::button $w.f_anim.f.b -image [gid_themes::GetImage "folder.png" small_icons] -command PostAnimateChooseAnimationFile
    #-borderwidth 1 -padx 8 -pady 3
    canvas $w.f_anim.f.cv -width 18 -height 18
    
    set led_libre [ $w.f_anim.f.cv create oval 2 2 17 17 -fill grey60]   
    set GidPriv(PostAnimateMPEG_led_libre) $led_libre
    #set GidPriv(PostAnimateMPEG_led_ocupado) $led_ocupado
    PostAnimateMPEGLeds DISABLED

    GidHelp $w.f_anim.f.cv [_ "Animation status leds:\n\
	    Green: no animation is being done, \n\
		   the animation file is closed.\n\
	    Red:   The program is storing frames ( added \n\
		   by the user, or storing redraws)\n\
		   in an opened animation file."]

    ttk::button $w.f_anim.f.bch -image [ gid_themes::GetImage "create_batch.png" large_icons] \
	-command [ list CreateAnimationBatch $w]
	#-borderwidth 1 
    setTooltip $w.f_anim.f.bch -text [_ "Herewith a batch file can be saved \n\
		                      to create the animation int batch mode, \n\
		                      using %s in offscreen mode." $::GidPriv(ProgName,Default)]

    grid $w.f_anim.f.f -sticky w
    grid $w.f_anim.f.b -row 0 -column 1 -sticky e
    grid $w.f_anim.f.cv -row 0 -column 2 -sticky e -padx 2
    grid $w.f_anim.f.bch -row 0 -column 3 -sticky w -padx 2

    if { ![info exists ::GidPriv(PostAnimateSaveAnimationFile)] } {
	set ::GidPriv(PostAnimateSaveAnimationFile) ""
    }
    ttk::entry $w.f_anim.e -width 5 -state disabled -textvariable GidPriv(PostAnimateSaveAnimationFile)
    # -relief sunken
    grid $w.f_anim.f -sticky w
    grid $w.f_anim.e -sticky we

    grid columnconf $w.f_anim 0 -weight 1
    grid rowconf $w.f_anim 0 -weight 1
    grid rowconf $w.f_anim 1 -weight 1

    setTooltip $w.f_anim.f.f.cb -text [_ "Check here to create an animation file"]
    setTooltip $w.f_anim.e [_ "Here the name of the animation file must be entered."]
    setTooltip $w.f_anim.f.f.mb [_ "Choose the file format of the animation file."]
    setTooltip $w.f_anim.f.b [_ "A file browser will be openned, so a file can be selected."]

    # close
    ttk::frame $w.f_but -style BottomFrame.TFrame
    ttk::frame $w.f_but.siz -relief sunken -borderwidth 1

    # ComboBoxRAM $w.f_but.siz.mb GidPriv(PostAnimateResize) \
    #             [list [_ "Default"] "800x600" "720x576" "640x480" "512x384" "352x288" "320x240"] \
    #             {Default 800x600 720x576 640x480 512x384 352x288 320x240}
    # TTKComboBox $w.f_but.siz.mb -textvariable ::GidPriv(PostAnimateResize) \
    # 	-labels [ list [_ "Default"] \
    # 		      "1920x1200" "1920x1080 HD" "1680x1050" "1680x945" \
    # 		      "1440x900" "1440x810" "1366x768" \
    # 		      "1280x1024" "1280x800" "1280x768" "1280x720 HD" \
    # 		      "1024x768" "1024x640" "1024x600" "1024x576" \
    # 		      "800x600" "720x576" "640x480" "512x384" "352x288" "320x240"] \
    # 	-values {Default \
    # 		     1920x1200 1920x1080 1680x1050 1680x945 \
    # 		     1440x900 1440x810 1366x768 \
    # 		     1280x1024 1280x800 1280x768 1280x720 \
    # 		     1024x768 1024x640 1024x600 1024x576 \
    # 		     800x600 720x576 640x480 512x384 352x288 320x240} \
    # 	-width 14 -state readonly
    TTKComboBox $w.f_but.siz.mb -textvariable ::GidPriv(PostAnimateResize) \
	-width 14 -state readonly
    PostAnimateFillComboWithCorrectWindowSizes $w.f_but.siz.mb
    #other sizes "352x288 (VCD-PAL)" "352x240 (VCD-NTSC)

    ttk::button $w.f_but.siz.resize -text [_ "Resize"] \
	-command "PostAnimateResize; update; after 200; PostAnimateResize" 
	#-borderwidth 1 -padx 8 -pady 3

    grid $w.f_but.siz.mb $w.f_but.siz.resize

    ttk::button $w.f_but.close -text [_ "Close"] -command "destroy $w" -style BottomFrame.TButton
    #-padx 8 -pady 3
    #SetWidgetsWidthFromText $w.f_but.siz.resize $w.f_but.close

    grid $w.f_but.siz -sticky w -ipady 1 -pady 1 -ipadx 1 -padx 1
    grid $w.f_but.close -column 1 -row 0 -sticky e -padx 2 -pady 3

    grid rowconf $w.f_but 0 -weight 1
    grid rowconf $w.f_but 1 -weight 1
    grid columnconf $w.f_but 0 -weight 1
    GidHelp $w.f_but.siz [_ "For MPEG files on windows its recommended \n\
	    to choose a windows-standard frame size:\n \
	    320x240 / 352x288 / 512x384 / 640x480 / 720x576 or 800x600"]
    GidHelp $w.f_but.siz.mb [_ "For MPEG files on windows its recommended \n\
	    to choose a windows-standard frame size:\n \
	    320x240 / 352x288 / 512x384 / 640x480 / 720x576 or 800x600"]
    GidHelp $w.f_but.siz.resize [_ "For MPEG files on windows its recommended \n\
	    to choose a windows-standard frame size:\n \
	    320x240 / 352x288 / 512x384 / 640x480 / 720x576 or 800x600"]

    grid $w.f_opt -sticky news
    grid $w.f_dur -sticky news
    grid $w.f_ctr -sticky news
    grid $w.f_save -sticky ew
    grid $w.f_anim -sticky ew
    grid $w.f_but -sticky sew
    if { $::tcl_version >= 8.5 } { grid anchor $w.f_but center }

    grid rowconf $w 1 -weight 1
    grid rowconf $w 2 -weight 1
    grid rowconf $w 3 -weight 1
    grid rowconf $w 0 -weight 1
    grid rowconf $w 4 -weight 1
    grid columnconf $w 0 -weight 1

    set GidPriv(PostAnimateInitializing) 0
    trace add variable GidPriv(PostAnimateDeform) write CambioPostAnimateDeform
    PostAnimateInitVariables
    update

    bind $w <Destroy> [list +DestroyPostAnimate %W $w]

    trace add variable GidPriv(PostAnimateDurationType) write PostAnimateGetDurationType

    trace add variable GidPriv(PostAnimateDelay) write PostAnimateTogleDelayEntry
    trace add variable GidPriv(PostAnimateDelayTime) write PostAnimateCheckDelayTime
    trace add variable GidPriv(PostAnimateDuration) write PostAnimateTogleDurationEntry
    trace add variable GidPriv(PostAnimateDurationTime) write PostAnimateCheckDurationTime
    trace add variable GidPriv(PostAnimateRangeFrames) write PostAnimateTogleRangeFramesEntry
    #trace add variable GidPriv(PostAnimateRangeFrameFrom) write PostAnimateCheckRangeFrame
    trace add variable GidPriv(PostAnimateSaveFrame) write PostAnimateTogleSaveEntry
    trace add variable GidPriv(PostAnimateSaveAnimation) write PostAnimateTogleAnimEntry
    trace add variable GidPriv(PostAnimateAnalysisLimitsCb) write PostAnimateGetAnalysisLimits

    #set GidPriv(PostAnimateDelay) 1

    if { !$::GidPriv(PostAnimateSaveFrame) } {
	#$w.f_save.f.f.cb configure -foreground grey60
	$w.f_save.f.f.mb configure -state disabled
	#$w.f_save.f.f.l configure -foreground grey60
	$w.f_save.f.b configure -state disabled
	$w.f_save.e configure -state disabled
	# -foreground grey60
    }
    if { !$::GidPriv(PostAnimateSaveAnimation) } {
	#$w.f_anim.f.f.cb configure -foreground grey60
	$w.f_anim.f.f.cb_stereo configure -state disabled
	# -foreground grey60 
	$w.f_anim.f.f.mb configure -state disabled
	#$w.f_anim.f.f.l configure -foreground grey60
	$w.f_anim.f.b configure -state disabled
	$w.f_anim.e configure -state disabled
	# -foreground grey60
    }


    #focus $w.f_but.close
    bind $w <Escape> "$w.f_but.close invoke"

    # set GidPriv(PostAnimateAnalysisLimitsCb) 1
    set GidPriv(PostAnimateAnalysisLimitsCb) 0
}

proc QuitaTraces {} {
    global GidPriv
    trace remove variable GidPriv(PostAnimateDelay) write PostAnimateTogleDelayEntry
    trace remove variable GidPriv(PostAnimateDelayTime) write PostAnimateCheckDelayTime
    trace remove variable GidPriv(PostAnimateDuration) write PostAnimateTogleDurationEntry
    trace remove variable GidPriv(PostAnimateDurationTime) write PostAnimateCheckDurationTime
    trace remove variable GidPriv(PostAnimateRangeFrames) write PostAnimateTogleRangeFramesEntry
    #trace remove variable GidPriv(PostAnimateRangeFrameFrom) write PostAnimateCheckRangeFrame
    trace remove variable GidPriv(PostAnimateSaveFrame) write PostAnimateTogleSaveEntry
    trace remove variable GidPriv(PostAnimateSaveAnimation) write PostAnimateTogleAnimEntry
    trace remove variable GidPriv(PostAnimateAnalysisLimitsCb) write PostAnimateGetAnalysisLimits
    trace remove variable GidPriv(PostAnimateSavingAnimation) write PostAnimateTogleMPEGLeds
    trace remove variable GidPriv(PostAnimateDeform) write CambioPostAnimateDeform
}

proc DestroyPostAnimate { W  w } {
    if { $W != $w } return
    global GidPriv
    set GidPriv(PostAnimateDoing) Stop
    AnimacionEstatica::Cerrar
    QuitaTraces
}

proc PostAnimateShowFileSize { } {
    global GidPriv

    if { ( [info exists GidPriv(PrePostAnimateWindow)] && [ winfo exists $::GidPriv(PrePostAnimateWindow)]) || \
	( [info exists GidPriv(PostAnimateWindow)] && [ winfo exists $::GidPriv(PostAnimateWindow)])} {
	file stat $::GidPriv(PostAnimateSaveAnimationFile) pp
# GidPriv(PostAnimateCurrentFrame) GidPriv(PostAnimateDefaultDelayTime)
	# set GidPriv(PostAnimateFileSize) "[format \"%.3g MB\" [ expr $pp(size)/(1024.0*1024.0)]]"
	# may be some values are being edited...
	catch {
	    if { $::GidPriv(PostAnimateDelay)} {
		set delay [ PostAnimateGetValidDelayTime]
		set GidPriv(PostAnimateTime) [ expr $::GidPriv(PostAnimateTime) + $delay]
	    }
	    if { $::GidPriv(PostAnimateDuration)} {
		set GidPriv(PostAnimateTime) [ expr $::GidPriv(PostAnimateTime) + $::GidPriv(PostAnimateDurationTimeDelay)]
		
	    }
	    if { $::GidPriv(PostAnimateStepvalues)} {
		set GidPriv(PostAnimateTime) [ expr $::GidPriv(PostAnimateTime) + $::GidPriv(PostAnimateStepvaluesDelay)]
	    }
	}
	set time [ expr $::GidPriv(PostAnimateTime) / 1000]
	# may be $time is floating point
	set minutes [ expr int( $time / 60)]
	set seconds [ expr int( $time - 60 * $minutes)]
	set GidPriv(PostAnimateFileSize) [ format "%02d:%02d - %.3gMB" $minutes $seconds [ expr $pp(size)/(1024.0*1024.0)]]
    }
}

proc PostAnimateShowTime { } {
    global GidPriv

    if { ( [info exists GidPriv(PrePostAnimateWindow)] && [ winfo exists $::GidPriv(PrePostAnimateWindow)]) || \
	( [info exists GidPriv(PostAnimateWindow)] && [ winfo exists $::GidPriv(PostAnimateWindow)])} {
	
	# may be some values are being edited...
	catch {
	    if { $::GidPriv(PostAnimateDelay)} {
		set delay [ PostAnimateGetValidDelayTime]
		set GidPriv(PostAnimateTime) [ expr $::GidPriv(PostAnimateTime) + $delay]
	    }
	    if { $::GidPriv(PostAnimateDuration)} {
		set GidPriv(PostAnimateTime) [ expr $::GidPriv(PostAnimateTime) + $::GidPriv(PostAnimateDurationTimeDelay)]
	    }
	    if { $::GidPriv(PostAnimateStepvalues)} {
		set GidPriv(PostAnimateTime) [ expr $::GidPriv(PostAnimateTime) + $::GidPriv(PostAnimateStepvaluesDelay)]
	    }
	}
	set time [ expr $::GidPriv(PostAnimateTime) / 1000]
	# may be $time is floating point
	set minutes [ expr int( $time / 60)]
	set seconds [ expr int( $time - 60 * $minutes)]
	set GidPriv(PostAnimateFileSize) [ format "%02d:%02d" $minutes $seconds]
    }
}

######################################################################
##### Animation Controls Window #####
######################################################################

proc PostAnimateControlsResize { } {
    global GidPriv

    set info [ wm geometry .gid]
    set info2 [.central.s configure]
    set height_list [ lindex $info2 0]
    set width_list [ lindex $info2 1]
    if { ![ regexp {([0-9]*)x([0-9]*)} $info trozo top_width top_height] } { return }
    set width_offset [ expr $top_width - [ lindex $width_list 4]]
    set height_offset [ expr $top_height - [ lindex $height_list 4]]

    if { $::GidPriv(PostAnimateControlsResize) == "Default"} {
	set GidPriv(PostAnimateControlsResize) $::GidPriv(PostAnimateControlsResizeDefault)
    }
    if { ![ regexp {([0-9]*)x([0-9]*)} $::GidPriv(PostAnimateControlsResize) trozo new_width new_height] } { return }

    #WarnWinText ".gid = $info = $top_width x $top_height"
    #WarnWinText "togl = [ lindex $width_list 4]x[ lindex $height_list 4]"
    #WarnWinText "offset = $width_offset x $height_offset"
    ## 768x576 640x480 512x384 320x240
    wm geometry .gid [ expr $width_offset + $new_width]x[ expr $height_offset + $new_height]
}

proc PostAnimateControlsInitValues {} {
    global GidPriv

    set GidPriv(PostAnimateControlsDoing) Nothing
    set GidPriv(PostAnimateControlsDefaultDelayTime) 200
    if { ![ info exists GidPriv(PostAnimateControlsDelayTime)]} {
	set GidPriv(PostAnimateControlsDelayTime) $::GidPriv(PostAnimateControlsDefaultDelayTime)
    }

    set GidPriv(PostAnimateControlsDefaultDurationTime) 200
    if { ![ info exists GidPriv(PostAnimateControlsDurationTime)]} {
	set GidPriv(PostAnimateControlsDurationTime) $::GidPriv(PostAnimateControlsDefaultDurationTime)
    }

    set GidPriv(PostAnimateControlsDelay) 0
    set GidPriv(PostAnimateControlsDuration) 0
    set GidPriv(PostAnimateControlsSaveAnimation) 0
    set GidPriv(PostAnimateControlsSavingAnimation) 0
    set GidPriv(PostAnimateControlsSavingRepes) 1
    set GidPriv(PostAnimateControlsSaveAnimationFormat) [GiD_Info postprocess get animationformat]
    set GidPriv(PostAnimateControlsSaveFrameFormat) "PNG"
    # set GidPriv(PostAnimateControlsSaveAnimationFormat) AVIMJPG
    set GidPriv(PostAnimateControlsSaveAnimationFormat) AVIMSVC
    set info2 [.central.s configure]
    set height_list [ lindex $info2 0]
    set width_list [ lindex $info2 1]
    set current [format "%dx%d" [ lindex $width_list 4] [ lindex $height_list 4]]
    set GidPriv(PostAnimateControlsResizeDefault) $current
    set GidPriv(PostAnimateControlsResize) Default

    set GidPriv(PostAnimateControlsLastFile) ""
    if { ![ info exists GidPriv(PostAnimateControlsSaveRedraws)]} {
	set GidPriv(PostAnimateControlsSaveRedraws) 0
    }
    set GidPriv(PostAnimateControlsDisableList) ""
    set GidPriv(PostAnimateControlsFileSize) ""
    set GidPriv(PostAnimateControlsTime) 0


    set ::GidPriv(PostDoStereoAnimation) [ GiD_Set PostDoStereoAnimation]
}

proc PostAnimateControlsMPEGLeds { estado } {
    global GidPriv

    set w $::GidPriv(PostAnimateControlsMPEGCanvas)
    if { ![winfo exists $w] } {
	return
    }
    set led_libre $::GidPriv(PostAnimateControlsMPEG_led_libre)

    switch $estado {
	DISABLED {
	    $w itemconfigure $led_libre -fill grey60
	}
	FREE {
	    $w itemconfigure $led_libre -fill green
	}
	BUSY {
	    $w itemconfigure $led_libre -fill red
	}
	default {
	    WarnWin [_ "Unknown led state: %s" $estado] $::GidPriv(PostAnimateControlsWindow)
	    $w itemconfigure $led_libre -fill grey60
	}
    }

}

proc PostAnimateControlsTogleDelayEntry { name1 name2 op} {
    global GidPriv

    set w $::GidPriv(PrePostAnimateControlsWindow)
    if { $::GidPriv(PostAnimateControlsDelay) } {
	$w.conf.f_del.e configure -state normal
	focus $w.conf.f_del.e
    } else {
	$w.conf.f_del.e configure -state disabled
    }
}

proc PostAnimateControlsTogleDurationEntry { name1 name2 op} {
    global GidPriv

    set w $::GidPriv(PrePostAnimateControlsWindow)
    if { $::GidPriv(PostAnimateControlsDuration) } {
	$w.conf.f_dur.e configure -state normal
	focus $w.conf.f_dur.e
    } else {
	$w.conf.f_dur.e configure -state disabled
    }
}


proc PostAnimateControlsTogleMPEGLeds { name1 name2 op} {
    global GidPriv

    if { $::GidPriv(PostAnimateControlsSavingAnimation) == 0} {
	PostAnimateControlsMPEGLeds FREE
	foreach i $::GidPriv(PostAnimateControlsDisableList) {
	    $i state !disabled
	}
    }

    if { $::GidPriv(PostAnimateControlsSavingAnimation) == 1} {
	PostAnimateControlsMPEGLeds BUSY
	foreach i $::GidPriv(PostAnimateControlsDisableList) {
	    $i state disabled
	}
    }
}

proc PostAnimateControlsTogleAnimEntry { name1 name2 op} {
    global GidPriv

    set w $::GidPriv(PrePostAnimateControlsWindow)
    if { $::GidPriv(PostAnimateControlsSaveAnimation) } {
	$w.file.name.filename configure -state normal
	focus $w.file.name.filename
	PostAnimateControlsMPEGLeds FREE
	trace add variable GidPriv(PostAnimateControlsSavingAnimation) write PostAnimateControlsTogleMPEGLeds
    } else {
	$w.file.name.filename configure -state disabled
	PostAnimateControlsMPEGLeds DISABLED
	trace remove variable GidPriv(PostAnimateControlsSavingAnimation) write PostAnimateControlsTogleMPEGLeds
    }
}

proc PostAnimateControlsCheckDelayTime { name1 name2 op} {
    global GidPriv

    set w $::GidPriv(PrePostAnimateControlsWindow)
    set len [string length $::GidPriv(PostAnimateControlsTime)]
    set cur_digit [ string index $::GidPriv(PostAnimateControlsDelayTime) [ expr $len - 1]]
    if { ( $cur_digit >= 0) && ( $cur_digit <= 9)} { return}
    if { ( $cur_digit == "e") || ( $cur_digit == "E") ||
    ( $cur_digit == "+") || ( $cur_digit == "-") || ( $cur_digit == ".")} {
	return
    }
    set val [ string range $::GidPriv(PostAnimateControlsDelayTime) 0 [ expr $len-2]]
    if { $val <= 0} {
	set val 5
    }
    set GidPriv(PostAnimateControlsDelayTime) $val
}

proc PostAnimateControlsAddStep { w} {
    global GidPriv

    #if { $w != ""} {
	#TryRoundRelief $w sunken
	#$w configure -relief sunken
    #}

    if { ( [ info exists GidPriv(PostAnimateSaveAnimation) ] && \
	    $::GidPriv(PostAnimateSaveAnimation)) || \
	    ( [ info exists GidPriv(PostAnimateSavingAnimation) ] && \
	    $::GidPriv(PostAnimateSavingAnimation)) } {
	WarnWin "Sorry, but couldn't save the animation while another one is active (Post Animate Window)"
	#if { $w != ""} {
	#    TryRoundRelief $w raised
	#    #$w configure -relief raised
	#}
	return
    }

    if { !$::GidPriv(PostAnimateControlsSavingAnimation)} {
	if { $::GidPriv(PostAnimateControlsSaveAnimationFile) == ""} {
	    WarnWin [_ "Sorry but a file name is needed to save the animation."] $w
	    #if { $w != ""} {
		#TryRoundRelief $w raised
		#$w configure -relief raised
	    #}
	    return
	} else {
	    #alredy cheched when call GiD_Process 'AnimationFile Start ...
	    #if { $::GidPriv(PostAnimateControlsLastFile) == $::GidPriv(PostAnimateControlsSaveAnimationFile) } {
	    #        set resp [ tk_messageBox -parent $::GidPriv(PrePostAnimateControlsWindow) -icon warning -type yesno \
	    #                -default no -message \
	    #                       [_ "Warning: Do you want to overwrite the file '%s'?" $::GidPriv(PostAnimateControlsSaveAnimationFile)] ]
	    #        if { $resp == "no"} {
		    #if { $w != ""} {
		    #    TryRoundRelief $w raised
		    #    #$w configure -relief raised
		    #}
	    #            return
	    #        }
	    #}

	    if { !$::GidPriv(PostAnimateControlsDelay) } {
		WarnWin [_ "There is no delay selected, using default of 200 ms. \n If you want no delay, please check the delay time entry."] $w
	    }

	    if { ![ PostAnimateVerificaPermisos $w $::GidPriv(PostAnimateControlsSaveAnimationFile)]} {
		#if { $w != ""} {
		#    TryRoundRelief $w raised
		#    #$w configure -relief raised
		#}
		return
	    }

	    GiD_Process 'AnimationFile Format [ PostAnimateProcessGIFOption $::GidPriv(PostAnimateControlsSaveAnimationFormat)]

	    if { $::GidPriv(PostAnimateControlsSaveRedraws) } {
		GiD_Process 'AnimationFile SaveRedraws Yes
	    }
	
	    if { $::GidPriv(PostAnimateControlsSaveAnimationFormat) == "AVIMJPG" || \
		     $::GidPriv(PostAnimateControlsSaveAnimationFormat) == "AVIMSVC" || \
		     $::GidPriv(PostAnimateControlsSaveAnimationFormat) == "AVI" || \
		     $::GidPriv(PostAnimateControlsSaveAnimationFormat) == "AVI15" || \
		     $::GidPriv(PostAnimateControlsSaveAnimationFormat) == "AVI16" || \
		     $::GidPriv(PostAnimateControlsSaveAnimationFormat) == "FLV"} {
		set info2 [.central.s configure]
		set height_list [ lindex $info2 0]
		set width_list [ lindex $info2 1]
		set width [ lindex $width_list 4]
		set height [ lindex $height_list 4]
		
		set avisize [ expr $width * $height * 1]
		if { $::GidPriv(PostAnimateControlsSaveAnimationFormat) == "AVIMJPG" } {
		    # estimacion aproximada
		    set avisize [ expr $avisize * 3 * 0.1]
		} elseif { $::GidPriv(PostAnimateControlsSaveAnimationFormat) == "AVIMSVC" } {
		    # estimacion aproximada
		    set avisize [ expr $avisize * 3 * 0.15]
		} elseif { $::GidPriv(PostAnimateControlsSaveAnimationFormat) == "AVI" } {
		    set avisize [ expr $avisize * 3]
		} elseif { $::GidPriv(PostAnimateControlsSaveAnimationFormat) == "FLV" } {
		    set avisize [ expr $avisize * 3 * 0.1]
		} else {
		    set avisize [ expr $avisize * 2]
		}
		set avisize [ expr ( $avisize / 1024.0) / 1024.0]
		
		if { $avisize > 95.00 } {
		    set resp [ tk_messageBox -parent $::GidPriv(PrePostAnimateControlsWindow) -icon warning -type yesno \
		            -default no -message \
		            "Warning: the AVI/FLV file will be [ format %.3g $avisize] MB big !!!\n Are you sure you want continue?" ]
		    if { $resp == "no"} {
		        #if { $w != ""} {
		        #    TryRoundRelief $w raised
		        #    #$w configure -relief raised
		        #}
		        return
		    }
		}
		#WarnWin "The AVI file will be [ format %.3g $avisize] MB big !!!"
	    }
	
	    # Frame rate = 25 FPS == 40 ms.
	    set repe 1
	    if { $::GidPriv(PostAnimateControlsDelay) } {
		if { $::GidPriv(PostAnimateControlsDelayTime) == 0 && $::GidPriv(PostAnimateControlsSaveAnimationFormat) == "MPEG" } {
		    set resp [ tk_messageBox -parent $::GidPriv(PrePostAnimateControlsWindow) -icon warning -type yesno \
		            -default no -message \
		            "Saving a MPEG animation file without delay between Steps can cause some strange efects in Microsoft Windows 95/98/NT.\n Are you sure you want continue?" ]
		    if { $resp == "no"} {
		        #if { $w != ""} {
		        #    TryRoundRelief $w raised
		        #    #$w configure -relief raised
		        #}
		        return
		    }
		}
		#            set repe [ expr int(0.5 + $::GidPriv(PostAnimateControlsDefaultDelayTime)/40.0)]
		set repe [ expr int(0.5 + $::GidPriv(PostAnimateControlsDelayTime)/40.0)]
		if { $repe == 0} { set repe 1}
	    } else {
		# por defecto 200 ms # medio segundo
		set repe [ expr int(0.5 + 200.0/40.0)]
		if { $repe == 0} { set repe 1}
	    }

	    set GidPriv(PostAnimateControlsSavingRepes) $repe
	    GiD_Process 'AnimationFile FramesPerStep \
		    $::GidPriv(PostAnimateControlsSavingRepes) escape escape escape escape
	    GiD_Process 'AnimationFile Start \
		    $::GidPriv(PostAnimateControlsSaveAnimationFile) Yes escape escape escape escape
	    set GidPriv(PostAnimateControlsSavingAnimation) 1
	    update

	    # para mostrar al usuario el tamanyo del archivo
	    #$::GidPriv(PostAnimateControlsFileSizeLabel) configure -foreground black
	    set GidPriv(PostAnimateControlsTime) 0
	}
    }

    if { $::GidPriv(PostAnimateControlsSavingAnimation)} {
	if { $::GidPriv(PostAnimateControlsSavingAnimation) } {
	    GiD_Process 'AnimationFile AddStep
	    #PostAnimateControlsShowFileSize
	}
    }

    #if { $w != ""} {
	#TryRoundRelief $w raised
	#$w configure -relief raised
    #}
}

proc PostAnimateControlsShowFileSize { } {
    global GidPriv

    if { ( [info exists GidPriv(PrePostAnimateControlsWindow)] && [ winfo exists $::GidPriv(PrePostAnimateControlsWindow)]) || \
	( [info exists GidPriv(PostAnimateControlsWindow)] && [ winfo exists $::GidPriv(PostAnimateControlsWindow)])} {
	file stat $::GidPriv(PostAnimateControlsSaveAnimationFile) pp
# GidPriv(PostAnimateControlsCurrentFrame) GidPriv(PostAnimateControlsDefaultDelayTime)
	# set GidPriv(PostAnimateControlsFileSize) "[format \"%.3g MB\" [ expr $pp(size)/(1024.0*1024.0)]]"
	set GidPriv(PostAnimateControlsTime) [ expr $::GidPriv(PostAnimateControlsTime) + $::GidPriv(PostAnimateControlsDelayTime)]
	set time [ expr $::GidPriv(PostAnimateControlsTime) / 1000]
	set GidPriv(PostAnimateControlsFileSize) [format "%02d:%02d - %.3gMB" [ expr int( $time / 60)] [ expr int( $time % 60)] [ expr $pp(size)/(1024.0*1024.0)]]
    }
}

proc PostAnimateControlsShowTime { } {
    global GidPriv

    if { ( [info exists GidPriv(PrePostAnimateControlsWindow)] && [ winfo exists $::GidPriv(PrePostAnimateControlsWindow)]) || \
	( [info exists GidPriv(PostAnimateControlsWindow)] && [ winfo exists $::GidPriv(PostAnimateControlsWindow)])} {
	set GidPriv(PostAnimateControlsTime) [ expr $::GidPriv(PostAnimateControlsTime) + $::GidPriv(PostAnimateControlsDelayTime)]
	set time [ expr $::GidPriv(PostAnimateControlsTime) / 1000]
	set GidPriv(PostAnimateControlsFileSize) [format "%02d:%02d" [ expr $time / 60] [ expr $time % 60]]
    }
}

proc PostAnimateControlsEndAnim { w} {
    global GidPriv

    #if { $w != ""} {
	#TryRoundRelief $w sunken
	#$w configure -relief sunken
    #}

    if { $::GidPriv(PostAnimateControlsSavingAnimation) } {
	GiD_Process 'AnimationFile End
	set GidPriv(PostAnimateControlsSavingAnimation) 0
	set GidPriv(PostAnimateControlsLastFile) $::GidPriv(PostAnimateControlsSaveAnimationFile)
	if { $::GidPriv(PostAnimateControlsSaveRedraws) } {
	    GiD_Process 'AnimationFile SaveRedraws No
	}
	#$::GidPriv(PostAnimateControlsFileSizeLabel) configure -foreground grey60
    }

    #if { $w != ""} {
	#TryRoundRelief $w raised
	#$w configure -relief raised
    #}
}

proc PostAnimateControlsChooseAnimationFile {} {
    global GidPriv

    if { $::GidPriv(PostAnimateControlsSaveAnimation) } {
	set w $::GidPriv(PrePostAnimateControlsWindow)
	switch [ PostAnimateProcessGIFOption $::GidPriv(PostAnimateControlsSaveAnimationFormat)] {
	    "MPEG" {
		set GidPriv(PostAnimateControlsSaveAnimationFile) [Browser-ramR imagefile write .gid [_ "Save MPEG on"]... \
		{} {{{Mpeg animation} {.mpg .mpeg}} {{All files} {.*}}} ".mpg" ]
	    }
	    "AVIMJPG" {
		set GidPriv(PostAnimateControlsSaveAnimationFile) [Browser-ramR imagefile write .gid [_ "Save AVI on"]... \
		{} {{{AVI animation} {.avi}} {{All files} {.*}}} ".avi" \
		          0 [ list {AVI/mjpg options} CreateExportJPEGOpts ProcessExportJPEGOpts]]
	    }
	    "AVIMSVC" {
		set GidPriv(PostAnimateControlsSaveAnimationFile) [Browser-ramR imagefile write .gid [_ "Save AVI on"]... \
		{} {{{AVI animation} {.avi}} {{All files} {.*}}} ".avi"  \
		          0 [ list {AVI/msvc options} CreateExportAviMSVCOpts ProcessExportAviMSVCOpts]]
	    }
	    "AVI" {
		set GidPriv(PostAnimateControlsSaveAnimationFile) [Browser-ramR imagefile write .gid [_ "Save AVI on"]... \
		{} {{{AVI animation} {.avi}} {{All files} {.*}}} ".avi" ]
	    }
	    "AVI15" {
		set GidPriv(PostAnimateControlsSaveAnimationFile) [Browser-ramR imagefile write .gid [_ "Save AVI on"]... \
		{} {{{AVI animation} {.avi}} {{All files} {.*}}} ".avi" ]
	    }
	    "AVI16" {
		set GidPriv(PostAnimateControlsSaveAnimationFile) [Browser-ramR imagefile write .gid [_ "Save AVI on"]... \
		{} {{{AVI animation} {.avi}} {{All files} {.*}}} ".avi" ]
	    }
	    "GIF" {
		set GidPriv(PostAnimateControlsSaveAnimationFile) [Browser-ramR imagefile write .gid [_ "Save GIF on"]... \
		{} {{{GIF animation} {.gif}} {{All files} {.*}}} ".gif" \
		          0 [ list {GIF options} CreateExportGIFOpts ProcessExportGIFOpts] ]
	    }
	    "FLV" {
		set GidPriv(PostAnimateControlsSaveAnimationFile) [Browser-ramR imagefile write .gid [_ "Save Macromedia Flash Video on"]... \
		{} {{{Macromedia Flash Video} {.flv}} {{All files} {.*}}} ".flv"  \
		          0 [ list {Flash Video options} CreateExportFLVOpts ProcessExportFLVOpts]]
	    }
	}
	#$w.f_anim.e delete 0 end
	#$w.f_anim.e insert 0 $::GidPriv(PostAnimateControlsSaveAnimationFile)
    }
}
proc HimAndAllSlaves { w } {
    set a $w
    set count 0
    while {$count != [llength $a] } {
	lappend a {*}[grid slaves [lindex $a $count]]
	incr count        
    } 
    return $a
}

proc PostAnimateControls { { w .gid.wPostAnimateControls } } {
    global GidPriv

    if { [ winfo exists $w] } {return}


    set GidPriv(PostAnimateControlsInitializing) 1
    PostAnimateControlsInitValues

    InitWindow $w [_ "Animation Controls"] PrePostAnimateControlsWindowGeom PostAnimateControls
    if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0

    # file
    ttk::labelframe $w.file -text [_ "File"]
    GidHelp $w.file [_ "Here the name of the animation file must be entered."]
    
    ttk::frame $w.file.name
    ttk::label $w.file.name.label -text [_ "Name"]:
    if { ![info exists GidPriv(PostAnimateControlsSaveAnimationFile)] } {
	set GidPriv(PostAnimateControlsSaveAnimationFile) ""
    }
    ttk::entry $w.file.name.filename -width 8 -state normal -textvariable GidPriv(PostAnimateControlsSaveAnimationFile)
    ttk::button $w.file.name.browse -image [gid_themes::GetImage "folder.png" small_icons] -command PostAnimateControlsChooseAnimationFile
    GidHelp $w.file.name.browse [_ "A file browser will be openned, so a file can be selected."]
    
    grid $w.file.name.label $w.file.name.filename $w.file.name.browse -sticky news
    grid columnconfigure $w.file.name 1 -weight 1
	
    ttk::frame $w.file.type
    ttk::label $w.file.type.label -text [_ "Type"]:
    TTKComboBox $w.file.type.cb -textvariable ::GidPriv(PostAnimateControlsSaveAnimationFormat) \
	-labels [ list [_ "MPEG"] [_ "AVI/mjpeg"] [_ "AVI/MS Video 1"] [_ "AVI/raw True Color"] \
		      [_ "AVI/raw 15 bpp (VD)"] [_ "AVI/raw 16 bpp (MS)"] \
		      [_ "GIF/no dithering"] [_ "GIF/dithering595"] [_ "GIF/dithering666"] \
		      [_ "Macromedia Flash Video (flv)"]] \
	-values {MPEG AVIMJPG AVIMSVC AVI AVI15 AVI16 GIF/None GIF/Dither595 GIF/Dither666 FLV} \
	-width 26 -state readonly
    GidHelp $w.file.type.cb [_ "Choose the file format of the animation file."]
     
    grid $w.file.type.label $w.file.type.cb -sticky nws
    #---
    grid $w.file.name -sticky news
    grid $w.file.type -sticky news
    grid columnconfigure $w.file 0 -weight 1
    
    
    # configuration
    ttk::labelframe $w.conf -text [_ "Configuration"]
    
    ttk::frame $w.conf.f_siz
    GidHelp $w.conf.f_siz [_ "For MPEG files on windows its recommended \n\
	    to choose a windows-standard frame size:\n \
	    320x240 / 352x288 / 512x384 / 640x480 / 720x576 or 800x600"]
    # TTKComboBox $w.conf.f_siz.cb -textvariable ::GidPriv(PostAnimateControlsResize) \
    # 	-labels [ list [_ "Default"] \
    # 		      "1920x1200" "1920x1080 HD" "1680x1050" "1680x945" \
    # 		      "1440x900" "1440x810" "1366x768" \
    # 		      "1280x1024" "1280x800" "1280x768" "1280x720 HD" \
    # 		      "1024x768" "1024x640" "1024x600" "1024x576" \
    # 		      "800x600" "720x576" "640x480" "512x384" "352x288" "320x240"] \
    # 	-values {Default \
    # 		     1920x1200 1920x1080 1680x1050 1680x945 \
    # 		     1440x900 1440x810 1366x768 \
    # 		     1280x1024 1280x800 1280x768 1280x720 \
    # 		     1024x768 1024x640 1024x600 1024x576 \
    # 		     800x600 720x576 640x480 512x384 352x288 320x240} \
    # 	-width 14 -state readonly
    TTKComboBox $w.conf.f_siz.cb -textvariable ::GidPriv(PostAnimateControlsResize) \
	-width 14 -state readonly
    PostAnimateFillComboWithCorrectWindowSizes $w.conf.f_siz.cb
    #other sizes "352x288 (VCD-PAL)" "352x240 (VCD-NTSC)
    ttk::button $w.conf.f_siz.resize -text [_ "Resize"] \
	-command "PostAnimateControlsResize; update; after 200 PostAnimateControlsResize"
    grid $w.conf.f_siz.cb $w.conf.f_siz.resize -sticky nw
    
    ttk::frame $w.conf.f_del   
    GidHelp $w.conf.f_del [_ "With this option a DelayTime of the entered milliseconds will be used between frames."]
    if { ![info exists GidPriv(PostAnimateControlsDelay)] } { set GidPriv(PostAnimateControlsDelay) 0 }
    ttk::checkbutton $w.conf.f_del.cb -text [_ "Delay"]: -variable GidPriv(PostAnimateControlsDelay)
    ttk::entry $w.conf.f_del.e -width 5 -textvariable GidPriv(PostAnimateControlsDelayTime)
    $w.conf.f_del.e configure -state disabled   
    ttk::label $w.conf.f_del.l -text [_ "ms."]
    
    grid $w.conf.f_del.cb $w.conf.f_del.e $w.conf.f_del.l -sticky new
    grid columnconfigure $w.conf.f_del 1 -weight 1
    
    ttk::frame $w.conf.f_dur
    if { ![info exists GidPriv(PostAnimateControlsDuration)] } { set GidPriv(PostAnimateControlsDuration) 0 }
    ttk::checkbutton $w.conf.f_dur.cb -text [_ "Duration"]: -variable GidPriv(PostAnimateControlsDuration)
    ttk::entry $w.conf.f_dur.e -width 5 -textvariable GidPriv(PostAnimateControlsDurationTime)
    $w.conf.f_dur.e configure -state disabled    
    ttk::label $w.conf.f_dur.l -text [_ "s."]
    grid $w.conf.f_dur.cb $w.conf.f_dur.e $w.conf.f_dur.l -sticky new
    grid columnconfigure $w.conf.f_dur 1 -weight 1
    
    if { ![info exists ::GidPriv(PostDoStereoAnimation)] } { set ::GidPriv(PostDoStereoAnimation) 0 }
    ttk::checkbutton $w.conf.cb_stereo -text [_ "Create a stereoscopic animation"] \
	-variable ::GidPriv(PostDoStereoAnimation) \
	-command {GiD_Set PostDoStereoAnimation $::GidPriv(PostDoStereoAnimation)}
    
    if_stereo_disable_force_cb $w.conf.cb_stereo    
    
    grid $w.conf.f_siz -column 0 -row 0 -sticky news
    grid $w.conf.f_del -column 0 -row 1 -sticky news
    grid $w.conf.f_dur -column 0 -row 2 -sticky news
    grid $w.conf.cb_stereo -column 0 -row 3 -sticky news
   
    grid columnconfigure $w.conf 0 -weight 1
   
   
    #controls
    ttk::labelframe $w.controls -text [_ "Controls"]
    
    if { ![info exists GidPriv(PostAnimateControlsSaveRedraws)] } { set GidPriv(PostAnimateControlsSaveRedraws) 0 }
    ttk::checkbutton $w.controls.cb_redraw -text [_ "Save redraws"] -variable GidPriv(PostAnimateControlsSaveRedraws)
    GidHelp $w.controls.cb_redraw [_ "Check this option if you want to save each redraw into the animation file.\n\
	    The program will start saving redraws into the file after clicking the AddSet button in this windows."]

    ttk::frame $w.controls.f_buttons
    ttk::button $w.controls.f_buttons.add -image [gid_themes::GetImage AddStep.png large_icons] \
	    -command "PostAnimateControlsAddStep $w.controls.f_buttons.add"
    GidHelp $w.controls.f_buttons.add \
	    [_ "AddSet button: Adds a frame \n\
	    into the animation file.\n\
	    If the 'Save redraws' checkbox \n\
	    is checked, pressing this button \n\
	    starts saving redraws into the file."]
    ttk::button $w.controls.f_buttons.end -image [gid_themes::GetImage EndAnim.png large_icons] \
	    -command "PostAnimateControlsEndAnim $w.controls.f_buttons.end" 
    GidHelp $w.controls.f_buttons.end \
	    [_ "EndAnimation button: Ends and \n\
	    closes the animation file.\n"]
    
    set GidPriv(PostAnimateControlsMPEGCanvas) $w.controls.f_buttons.indicator
    canvas $::GidPriv(PostAnimateControlsMPEGCanvas) -width 18 -height 18
    set led_libre [$::GidPriv(PostAnimateControlsMPEGCanvas) create oval 2 2 17 17 -fill grey60]
    set GidPriv(PostAnimateControlsMPEG_led_libre) $led_libre
    PostAnimateControlsMPEGLeds DISABLED
    
    grid $w.controls.f_buttons.add -column 0 -row 0 -sticky nw
    grid $w.controls.f_buttons.end -column 1 -row 0 -sticky nw
    grid $::GidPriv(PostAnimateControlsMPEGCanvas) -column 2 -row 0 -sticky ne
    grid columnconfigure $w.controls.f_buttons 2 -weight 1
    #----
    grid $w.controls.cb_redraw -sticky news
    grid $w.controls.f_buttons -sticky news
    grid columnconfigure $w.controls 0 -weight 1
    
    
    
    # close
    ttk::frame $w.f_but -style BottomFrame.TFrame
    
    ttk::button $w.f_but.close -text [_ "Close"] -command "destroy $w" -style BottomFrame.TButton
    lappend GidPriv(PostAnimateControlsDisableList) $w.f_but.close
    
    grid $w.f_but.close -sticky {} -pady 5
    grid columnconfigure $w.f_but 0 -weight 1
    grid rowconfigure $w.f_but 0 -weight 1
    
    #grid window (allways display bottom buttons)
    grid $w.file -column 0 -row 0 -sticky news
    grid $w.conf -column 0 -row 1 -sticky news
    grid $w.controls -column 0 -row 2 -sticky news
    grid $w.f_but -column 0 -row 3 -sticky news
    grid columnconfigure $w 0 -weight 1
    grid rowconfigure $w 0 -weight 0
    grid rowconfigure $w 1 -weight 0
    grid rowconfigure $w 2 -weight 1
    grid rowconfigure $w 3 -weight 0
    
    lappend GidPriv(PostAnimateControlsDisableList) {*}[HimAndAllSlaves $w.file]
    lappend GidPriv(PostAnimateControlsDisableList) {*}[HimAndAllSlaves $w.conf]
    lappend GidPriv(PostAnimateControlsDisableList) $w.controls.cb_redraw    
    lappend GidPriv(PostAnimateControlsDisableList) $w.f_but.close
    
    

    set GidPriv(PostAnimateControlsInitializing) 1
    update
    set GidPriv(PostAnimateControlsInitializing) 0

    bind $w <Escape> [list destroy $w]
    bind $w <Destroy> [list +DestroyPrePostAnimateControls %W $w]

    trace add variable GidPriv(PostAnimateControlsDelay) write PostAnimateControlsTogleDelayEntry
    trace add variable GidPriv(PostAnimateControlsDelayTime) write PostAnimateControlsCheckDelayTime
    trace add variable GidPriv(PostAnimateControlsSaveAnimation) write PostAnimateControlsTogleAnimEntry

    trace add variable GidPriv(PostAnimateControlsDuration) write PostAnimateControlsTogleDurationEntry

    # set GidPriv(PostAnimateControlsDuration) 1
    set GidPriv(PostAnimateControlsDelay) 1
    set GidPriv(PostAnimateControlsSaveRedraws) 1

    set ::GidPriv(PostDoStereoAnimation) $::GidPriv(PostDoStereoAnimation)

    # no hay checkbox
    set GidPriv(PostAnimateControlsSaveAnimation) 1
}

proc DestroyPrePostAnimateControls { W w } {
    if { $W != $w } return

    global GidPriv
    if { $::GidPriv(PostAnimateControlsSavingAnimation) } {
	GiD_Process 'AnimationFile End
	set GidPriv(PostAnimateControlsSavingAnimation) 0
    }
    trace remove variable GidPriv(PostAnimateControlsDelay) write PostAnimateControlsTogleDelayEntry
    trace remove variable GidPriv(PostAnimateControlsDelayTime) write PostAnimateControlsCheckDelayTime
    trace remove variable GidPriv(PostAnimateControlsSaveAnimation) write PostAnimateControlsTogleAnimEntry
    trace remove variable GidPriv(PostAnimateControlsSavingAnimation) write PostAnimateControlsTogleMPEGLeds
    trace remove variable GidPriv(PostAnimateControlsDuration) write PostAnimateControlsTogleDurationEntry
}

proc GetCurrentResultsViewCommands { istep } {
    set cur_anal   $::GidPriv(PostAnimate_cur_anal)
    set cur_resv   $::GidPriv(PostAnimate_cur_resv)
    set cur_res    $::GidPriv(PostAnimate_cur_res)
    set cur_comp   $::GidPriv(PostAnimate_cur_comp)
    set cur_defor  $::GidPriv(PostAnimate_cur_d_defor)
    set cur_factor $::GidPriv(PostAnimate_cur_d_factor)
    set cur_defor_type $::GidPriv(PostAnimate_cur_defor_type)
    set cur_d_anal $::GidPriv(PostAnimate_cur_d_anal)

    set ret_line {}

    set already_set 0
    if { $::GidPriv(PostAnimateDeform)} {
	# puede que cur_anal != cur_d_anal
	lappend ret_line [ list Mescape Results AnalysisSel $cur_d_anal $istep]
	if { $cur_d_anal == $cur_anal} {
	    set already_set 1
	}
	lappend ret_line [ list Mescape Results Options DeformationType $cur_defor_type]
	if { $::AnimacionEstatica(hay)} {
	    lappend ret_line [ list Mescape Results Geometry Original Geometry Deformation $cur_defor $istep escape]
	} else {
	    lappend ret_line [ list Mescape Results Geometry Original Geometry Deformation $cur_defor $cur_factor escape]
	}
	if { $cur_defor_type != "relative"} {
	    lappend ret_line [ list Mescape Results Options DeformationType relative]
	}
    }
    if { !$already_set} {
	lappend ret_line [ list Mescape Results AnalysisSel $cur_anal $istep Mescape]
    }

    # if { $::GidPriv(PostAnimateResultViewCb) && $::GidPriv(PostAnimateAnalysisLimitsCb)} {
    #         PostAnimatePushLimits
    #         PostAnimateSetAnalysisLimits
    # }

    if { ( $::GidPriv(PostAnimate_cur_resv) == "IsoSurfaces") && ( [ llength $::GidPriv(PostAnimateIsoSurfaces)] != 0)} {
	set iso_res [ lindex $::GidPriv(PostAnimateIsoSurfaces) 2]
	set iso_anal [ lindex $iso_res 2]
	# set iso_paso [ lindex $iso_res 3]
	if { $cur_anal != $iso_anal} {
	    lappend ret_line [ list Mescape results analysissel $iso_anal $istep Mescape]
	}
	set lst_valores [ lindex $::GidPriv(PostAnimateIsoSurfaces) 1]
	lappend ret_line [ list \
		               Mescape results IsoSurfaces Exact [ lindex $iso_res 0] [ lindex $iso_res 1] \
		               [ lindex $::GidPriv(PostAnimateIsoSurfaces) 0] {*}$lst_valores \
		           ]
	# WarnWinText "1- $::GidPriv(PostAnimateIsoSurfaces)"
	# WarnWinText "1- GiD_Process Mescape Results IsoSurfaces Exact [ lindex $iso_res 0] [ lindex $iso_res 1] \
	#     [ lindex $::GidPriv(PostAnimateIsoSurfaces) 0] {*}$lst_valores"
	# foreach val $lst_valores {
	#     GiD_Process $val
	# }
	if { $cur_anal != $iso_anal} {
	    lappend ret_line [ list Mescape results analysissel $cur_anal $istep Mescape]
	}
    }

    if { $::GidPriv(PostAnimateResultViewCb) && $::GidPriv(PostAnimateResultView) != ""} {
	if { $::GidPriv(PostAnimateVariosResultados) == "no"} {
	    switch $::GidPriv(PostAnimate_cur_resv) {
		"ShMinMax" {
		    lappend ret_line [ list Mescape Results $cur_resv $cur_res $cur_comp]
		}
		"ContourFill" {
		    lappend ret_line [ list Mescape Results $cur_resv $cur_res $cur_comp]
		}
		"SmoothContourFill" {
		    lappend ret_line [ list Mescape Results $cur_resv $cur_res $cur_comp]
		}
		"ContourLines" {
		    lappend ret_line [ list Mescape Results $cur_resv $cur_res $cur_comp]
		}
		"SmoothContourLines" {
		    lappend ret_line [ list Mescape Results $cur_resv $cur_res $cur_comp]
		}
		"IsoSurfaces" {
		    ### set lst_valores [ lindex $::GidPriv(PostAnimateIsoSurfaces) 1]
		    ### GiD_Process Mescape Results $cur_resv Exact $cur_res $cur_comp \
		    ###     [ lindex $::GidPriv(PostAnimateIsoSurfaces) 0] {*}$lst_valores
		    # WarnWinText "2- $::GidPriv(PostAnimateIsoSurfaces)"
		    # WarnWinText "2 - GiD_Process Mescape Results $cur_resv Exact $cur_res $cur_comp \
		    #     [ lindex $::GidPriv(PostAnimateIsoSurfaces) 0] {*}$lst_valores"
		    # foreach val $lst_valores {
		    #         GiD_Process $val
		    # }
		}
		"DisplayVectors" {
		    lappend ret_line [ list Mescape Results $cur_resv $cur_res $cur_comp \
		                           $::GidPriv(PostAnimateDisplayVectors) ]
		}
		"ContourRanges" {
		    lappend ret_line [ list Mescape Results $cur_resv $cur_res $cur_comp]
		}
		"ScalarLineDiagram" {
		    lappend ret_line [ list \
		                           Mescape Results LineDiagram ScalarDiagram $cur_res $cur_comp \
		                           $::GidPriv(PostAnimateScalarDiagram) ]
		}
		"VectorLineDiagram" {
		    lappend ret_line [ list \
		                           Mescape Results LineDiagram VectorDiagram $cur_res \
		                           $::GidPriv(PostAnimateVectorDiagram) ]
		}
		"ResultSurface" {
		    lappend ret_line [ list \
		                           Mescape Results $cur_resv $cur_res $cur_comp \
		                           $::GidPriv(PostAnimateResultSurface)]
		}
		"SmoothResultSurface" {
		    lappend ret_line [ list \
		                           Mescape Results $cur_resv $cur_res $cur_comp \
		                           $::GidPriv(PostAnimateResultSurface)]
		}
		"LineThickness" {
		    lappend ret_line [ list \
		                           Mescape Results $cur_resv $cur_res $cur_comp \
		                           $::GidPriv(PostAnimateResultSurface)]
		}
		"SmoothLineThickness" {
		    lappend ret_line [ list \
		                           Mescape Results $cur_resv $cur_res $cur_comp \
		                           $::GidPriv(PostAnimateResultSurface)]
		}
		default {
		    #nothing
		}
	    }
	}
    }
    return $ret_line
}

proc GetPostprocessFileLoadCommands {} {
    # set tmp_dir [ GiD_Info project TmpDirectory]
    
    set cur_batch_file [ .central.s flushBatchToWrite]

    set fi [ open $cur_batch_file r]
    fconfigure $fi -encoding utf-8
    # we'll read until we find postprocess
    # then we'll look for the 'file' command 
    # and save the commands until the 'escape'
    set ret_lines {}
    set post_found 0
    set files_found 0
    set read_found 0
    while { ![ eof $fi] } {
	set ln [ gets $fi]
	if { $::tcl_platform(platform) == "windows" } {        
	    # turn windows K:\BigExamples\Ejemplos\BarcelonaMedia\...
	    # to  K:/BigExamples/Ejemplos/BarcelonaMedia/
	    regsub -all {\\} $ln {/} line
	} else {
	    set line $ln
	}
	foreach word_in $line {
	    # if { [ llength $word_in] != 1} {
	    # 	WarnWinText "list in line = -$line-"
	    # 	WarnWinText "word is list = -$word_in-"
	    # }
	    if { [ llength $word_in] != 1} {
		set word [ list $word_in]
	    }
	    set word [ string tolower $word_in]

	    # check for transparent commands: do not add more to the file list
	    if { [ string index $word 0] == "'"} {
		set files_found 0
		set read_found 0
	    }
	    switch $word {
		preprocess {
		    set post_found 0
		}
		postprocess {
		    set post_found 1
		    set files_found 0
		    set ret_lines {}
		}
		files {
		    if { $post_found} {
		        set files_found 1
		    }
		}
		escape {
		    set files_found 0
		    set read_found 0
		}
		mescape {
		    set files_found 0
		    set read_found 0
		}
		read {
		    if { $files_found} {
		        set read_found 1
		        set ret_lines {}
		        lappend ret_lines files
		        lappend ret_lines $word_in
		    }
		}
		readmultiple {
		    if { $files_found} {
		        set read_found 1
		        set ret_lines {}
		        lappend ret_lines files
		        lappend ret_lines $word_in
		    }
		}
		add {
		    if { $files_found} {
		        set read_found 1
		        set ret_lines {}
		        lappend ret_lines files
		        lappend ret_lines $word_in
		    }
		}
		new {
		    # if { $files_found} {
		    #     set read_found 0
		    #     set ret_lines {}
		    # }
		}
		default {
		    if { $read_found} {
			# WarnWinText "[llength $word_in] = -$word_in-"
			lappend ret_lines $word_in
		    }
		}
	    }
	}
    }

    close $fi

    return $ret_lines
}

proc CreateAnimationBatch { w } {
    set batch_name [ Browser-ramR imagefile write .gid [_ "Save GiD batch file on"]... \
		         {} {{{GiD batch file} {.bch}} {{All files} {.*}}} ".bch" ]    
    if { $batch_name == ""} {
	return
    }

    # verify some variables
    if { $::GidPriv(PostAnimateSaveAnimationFile) == ""} {
	PostAnimateChooseAnimationFile
	if { $::GidPriv(PostAnimateSaveAnimationFile) == ""} {
	    return
	}
    }

    set root_name [ file root $batch_name]

    set fo [ open $batch_name w]
    
    # save current view:
    GiD_Process escape escape escape escape View SaveView ${root_name}.vv
    GiD_Process escape escape escape escape

    # create batch
    puts $fo postprocess
    foreach w [ GetPostprocessFileLoadCommands] {
	puts $fo $w
    }
    puts $fo "escape escape escape escape escape"

    # read saved view
    puts $fo "escape escape escape escape escape"
    puts $fo "View ReadView ${root_name}.vv"
    puts $fo "escape escape escape escape escape"

    # switch on / off meshes
    foreach t [ list volume surface cut] {
	foreach v [ GiD_Info postprocess get all_$t] {
	    foreach p [ list Massive Transparent EdgeWidth Visibility] {
		set cur_state [ GiD_Info postprocess get property $p $v]
		puts $fo "Utilities ChangeProperty ${t}Sets $v $p $cur_state"
		puts $fo "escape escape escape escape escape"
	    }
	    set p DisplayStyle
	    set cur_state [ GiD_Info postprocess get property $p $v]
	    regsub -all {_} $cur_state {} cur_state
	    puts $fo "Utilities ChangeProperty ${t}Sets $v $p $cur_state"
	    puts $fo "escape escape escape escape escape"
	}
    }
    
    # animation parameters
    puts $fo "'AnimationFile Format [ PostAnimateWriteGIFOption $fo $::GidPriv(PostAnimateSaveAnimationFormat)]"
    puts $fo "escape escape escape escape escape"
    set delay 0.1
    if { $::GidPriv(PostAnimateDelay) && ( $::GidPriv(PostAnimateDelayTime) != "")} {
	set delay [ expr $::GidPriv(PostAnimateDelayTime) * 0.001]
    }
    puts $fo "'AnimationFile StepDelay $delay escape escape escape escape escape"

    # disable windows
    puts $fo "utilities variables PostUpdateWindows no escape escape escape escape escape"

    # start animation
    puts $fo "'AnimationFile Start $::GidPriv(PostAnimateSaveAnimationFile) Yes"
    puts $fo "escape escape escape escape escape"

    set all_steps $::GidPriv(PostAnimate_all_step)
    for { set i [ expr $::GidPriv(PostAnimateRangeFrameFrom) - 1]} { $i < $::GidPriv(PostAnimateRangeFrameTo)} { incr i} {
	set cur_step [ lindex $all_steps $i]
	puts $fo "escape escape escape escape escape results analysissel $::GidPriv(PostAnimate_cur_anal) $cur_step"
	puts $fo "escape escape escape escape escape"

	# write result view
	foreach ln [ GetCurrentResultsViewCommands $cur_step] {
	    puts $fo $ln
	}
	puts $fo "escape escape escape escape escape"

	puts $fo "'AnimationFile AddStep"
    }

    # close animation
    puts $fo "'AnimationFile End"
    puts $fo "escape escape escape escape escape"

    # enable windows
    puts $fo "utilities variables PostUpdateWindows yes escape escape escape escape escape"

    # quit
    puts $fo "quit no"
    
    close $fo

    set height_list [ .central.s configure -height]
    set width_list [ .central.s configure -width]
    set gid_width [ lindex $width_list 4]
    set gid_height [ lindex $height_list 4]

    set gid_exec gid_offscreen
    if { [ info exists ::env(INI_ARG_0)]} {
	set gid_exec $::env(INI_ARG_0)
    } else {
	set gid_exec [ file rootname $::argv0]
    }

    if { [ string first off $gid_exec] == -1} {
	if { ![ regsub {.exe} $gid_exec {_offscreen.exe} gid_exec]} {
	    set gid_exec ${gid_exec}_offscreen
	}
    }

    WarnWin [_ "Animation batch file '%s' and view file '%s' written. Remember to launch the batch like this:\n%s" \
	$batch_name ${root_name}.vv "${gid_exec} -offscreen ${gid_width}x${gid_height} -b+g $batch_name"]
}

