
set PGDebug 0

namespace eval PostGeom {
    variable _w_id
    # pagina_malla_principal
    variable _p_mp
    # pagina__malla_copia
    variable _p_mc

    variable _MallaPrincipal
    variable _MallaCopia
    variable _DoingApply       0
}

proc FillPGInfo {} {
    global GidPriv

    if { ![info exists GidPriv(PostResultsDeformationWindow)] || \
	    ![winfo exists $GidPriv(PostResultsDeformationWindow)] } { return }

    PostGeom::ActualizaVariables
}

# Rutinas pagina PRINCIPAL

proc PostGeom::CambioAnalisisPrincipal { } {
    variable _MallaPrincipal
    
    if { $::PGDebug } {
	WarnWinText "PostGeom::CambioAnalisisPrincipal $_MallaPrincipal(analisis)"
    }

    # todos los pasos del analisis
    if { $_MallaPrincipal(analisis) != "" } {
	if { [ catch { set lst_pasos [ GiD_Info postprocess get all_steps $_MallaPrincipal(analisis)]}]} {
	    set lst_pasos {}
	}
	set step [ GiD_Info postprocess get cur_step $_MallaPrincipal(analisis)]
	if { $step == "" || [lsearch $lst_pasos $step] == -1 } {
	    set step [lindex $lst_pasos 0]
	}
    } else {
	set lst_pasos ""
	set step ""
    }
    if { [$_MallaPrincipal(paso,wid) cget -values] != $lst_pasos } {
	$_MallaPrincipal(paso,wid) configure -values $lst_pasos         
    }
    set _MallaPrincipal(paso) $step
    if { $::PGDebug} {
	WarnWinText "setting '$_MallaPrincipal(paso)' from '$lst_pasos'"
    }
    #PostGeom::CambioPasoPrincipal
}

proc PostGeom::CambioPasoPrincipal { } {
    variable _MallaPrincipal

    if { $::PGDebug} {
	WarnWinText "PostGeom::CambioPasoPrincipal $_MallaPrincipal(paso)"
    }

    if { $_MallaPrincipal(paso) == ""} {
	set _MallaPrincipal(resultado) ""
	PostGeom::CambioResultadoPrincipal
	return
    }

    set old_anal [ GiD_Info postprocess get cur_analysis]
    set old_step [ GiD_Info postprocess get cur_step $old_anal]
    set old_analisis $_MallaPrincipal(analisis)
    if { $::PGDebug} {
	WarnWinText "GiD_Process Mescape Results AnalysisSel $old_analisis $_MallaPrincipal(paso)"
    }
    GiD_Process Mescape Results AnalysisSel $old_analisis $_MallaPrincipal(paso)

    set all_values [ GiD_Info postprocess get main_geom_all_deform]
    set all_labels {}
    foreach j $all_values {
	lappend all_labels [TranslateResultName $j]
    }
    $_MallaPrincipal(resultado,wid) configure -labels $all_labels -values $all_values
    set _MallaPrincipal(resultado) [lindex $all_values 0]

    PostGeom::CambioResultadoPrincipal

    GiD_Process Mescape Results AnalysisSel $old_anal $old_step

}

proc PostGeom::CambioResultadoPrincipal { } {
    variable _MallaPrincipal

    if { $::PGDebug} {
	WarnWinText "PostGeom::CambioResultadoPrincipal $_MallaPrincipal(resultado)"
    }

    if { $_MallaPrincipal(resultado) == ""} {
	set _MallaPrincipal(factor) 1
	set _MallaPrincipal(FactorFijo) 0
	return
    }

    if { ( $_MallaPrincipal(analisis) != "") && \
	    ( $_MallaPrincipal(paso) != "") && \
	    ( $_MallaPrincipal(resultado) != "") } {
	set def_vec $_MallaPrincipal(resultado)
	set res_anal $_MallaPrincipal(analisis)
	GiD_Process Mescape results options deformationtype $_MallaPrincipal(TipoDeformacion)
	set _MallaPrincipal(factor) [ GiD_Info postprocess \
		get main_geom_factor $res_anal $_MallaPrincipal(paso) $def_vec]
	set tipo_factor [ GiD_Info postprocess get results_preference $def_vec deformation factortype]
	if { [ string equal -nocase $tipo_factor "Fixed"] } {
	    set _MallaPrincipal(FactorFijo) 1
	} else {
	    set _MallaPrincipal(FactorFijo) 0
	}
	GiD_Process Mescape results options deformationtype relative               
    } else {
	set _MallaPrincipal(factor) 1
	set _MallaPrincipal(FactorFijo) 0
    }
}

proc PostGeom::GetGiDResultsInfoPrincipal { estado} {
    variable _MallaPrincipal

    # todos los analisis
    set all_analysis_values [lsort -dictionary [ GiD_Info postprocess get all_analysis]]
    if { $::PGDebug} {
	WarnWinText "adding pseudo trace"
    }
    set all_analysis_labels {}
    foreach j $all_analysis_values {
	lappend all_analysis_labels [TranslateResultName $j]
    }  

    $_MallaPrincipal(analisis,wid) configure -values $all_analysis_values \
	-labels $all_analysis_labels

    # analisis actual
    set cur [ GiD_Info postprocess get cur_analysis]
    if { $cur == "" } {
	set cur [ lindex $all_analysis_values 0]
    }
    set _MallaPrincipal(analisis) $cur
    PostGeom::CambioAnalisisPrincipal
}


#rutina pagina COPIA

proc PostGeom::CambioAnalisisCopia { } {
    variable _MallaCopia    
    # todos los pasos del analisis
    if { $_MallaCopia(analisis) != "" } {
	if { [ catch { set lst_pasos [ GiD_Info postprocess get all_steps $_MallaCopia(analisis)]}]} {
	    set lst_pasos {}
	}
	set step [ GiD_Info postprocess get cur_step $_MallaCopia(analisis)]
    } else {
	set lst_pasos ""
	set step ""
    }
    if { [$_MallaCopia(paso,wid) cget -values] != $lst_pasos } {
	$_MallaCopia(paso,wid) configure -values $lst_pasos
	set _MallaCopia(paso) $step
    }
}

proc PostGeom::CambioPasoCopia { } {
    variable _MallaCopia

    if { ![ info exists _MallaCopia(paso)] || ( "$_MallaCopia(paso)" == "")} {
	set _MallaCopia(resultado) ""
	PostGeom::CambioResultadoCopia
	return
    }

    if { [ info exists _MallaCopia(analisis)] && ( $_MallaCopia(analisis) != "") } {
	set analisis $_MallaCopia(analisis)
	if { [ catch { set lst_pasos [ GiD_Info postprocess get all_steps $analisis]}]} {
	    set lst_pasos {}
	}
	if { [ lsearch $lst_pasos $_MallaCopia(paso)] == -1} {
	    set _MallaCopia(resultado) ""
	    PostGeom::CambioResultadoCopia
	    return
	}
    } else {
	set _MallaCopia(resultado) ""
	PostGeom::CambioResultadoCopia
	return
    }

    set str_analisis $_MallaCopia(analisis)    
    set all_values [ GiD_Info postprocess get show_geom_all_deform \
	    $str_analisis $_MallaCopia(paso)]
    set all_labels {}
    foreach j $all_values {
	lappend all_labels [TranslateResultName $j]        
    }
    $_MallaCopia(resultado,wid) configure -labels $all_labels -values $all_values
    set _MallaPrincipal(resultado) [lindex $all_values 0]
    

    PostGeom::CambioResultadoCopia
}

proc PostGeom::CambioResultadoCopia { } {
    variable _MallaCopia

    if { $_MallaCopia(resultado) == ""} {
	set _MallaCopia(factor) 1
	set _MallaCopia(FactorFijo) 0
	return
    }

    if { ( $_MallaCopia(analisis) != "") && \
	    ( $_MallaCopia(paso) != "") && \
	    ( $_MallaCopia(resultado) != "") } {
	set def_vec $_MallaCopia(resultado)
	set res_anal $_MallaCopia(analisis)
	GiD_Process Mescape results options deformationtype $_MallaCopia(TipoDeformacion)
	set _MallaCopia(factor) [ GiD_Info postprocess \
		get main_geom_factor $res_anal $_MallaCopia(paso) $def_vec]
	set tipo_factor [ GiD_Info postprocess get results_preference $def_vec deformation factortype]
	if { [ string equal -nocase $tipo_factor "Fixed"] } {
	    set _MallaCopia(FactorFijo) 1
	} else {
	    set _MallaCopia(FactorFijo) 0
	}
	GiD_Process Mescape results options deformationtype relative
    } else {
	set _MallaCopia(factor) 1
	set _MallaCopia(FactorFijo) 0
    }
}

proc PostGeom::GetGiDResultsInfoCopia { estado} {
    variable _MallaCopia
    # todos los analisis
    set all_analysis_values [lsort -dictionary [ GiD_Info postprocess get all_analysis]]
    set all_analysis_labels {}
    foreach j $all_analysis_values {
	lappend all_analysis_labels [TranslateResultName $j]
    }
    $_MallaCopia(analisis,wid) configure -values $all_analysis_values -labels $all_analysis_labels

    # analisis actual
    set cur [ GiD_Info postprocess get cur_analysis]
    if { $cur == "" } {
	set cur [lindex $all_analysis_values 0]
    }
    set _MallaCopia(analisis) $cur
    PostGeom::CambioAnalisisCopia   
}

proc PostGeom::ActualizaVariables { } {
    variable _w_id

    variable _MallaPrincipal
    variable _MallaCopia
    variable _DoingApply

    if { $_DoingApply} { 
	return
    }
    
    DeleteTraceVariables $_w_id $_w_id

    # averiguar estado malla principal

    set mainst [ GiD_Info postprocess get main_geom_state]
    set _MallaPrincipal(estado) $mainst
    set maindeftyp [ GiD_Info postprocess get main_geom_deformation_type]
    set _MallaPrincipal(TipoDeformacion) $maindeftyp


    GetGiDResultsInfoPrincipal $mainst

    if { "$mainst" == "Original"} {
	$_MallaPrincipal(wid_pagina).frd.rd1 invoke
	#DisableResultFactorWidget $_MallaPrincipal(wid_pagina).rs
    } else {
	$_MallaPrincipal(wid_pagina).frd.rd2 invoke
	#DisableResultFactorWidget $_MallaPrincipal(wid_pagina).rs
    }

#     if { "$maindeftyp" == "relative"} {
#         $_MallaPrincipal(wid_pagina).rs.fs.cb1 deselect
#     } else { # == "absolute"
#         $_MallaPrincipal(wid_pagina).rs.fs.cb1 select
#     }
    set ::[$_MallaPrincipal(wid_pagina).rs.fa.cb1 cget -variable] $maindeftyp

    foreach i "estado analisis paso resultado factor FactorFijo TipoDeformacion" {
	set _MallaPrincipal(antes,$i) $_MallaPrincipal($i)
    }

    # mejor hacerlo antes que buscar los valores de la malla de copia
    # pues igual me deshabilita el radio button y no puedo activarlos
    # el color de la copia
    set res [ GiD_Info postprocess get show_geom_color]

    set _MallaCopia(TipoColor) [ lindex $res 0]
    $_MallaCopia(Color,wid) configure -background [ lindex $res 1]
    set _MallaCopia(Color) [ lindex $res 1]
    if { $_MallaCopia(TipoColor) == "UserColor"} {
	#$_MallaCopia(wid_pagina).fcol.rd2 invoke
	set ::[$_MallaCopia(wid_pagina).rs.fa.cb1 cget -variable] "absolute"
	$_MallaCopia(Color,wid) configure -state normal
    } else {
	#$_MallaCopia(wid_pagina).fcol.rd1 invoke
	set ::[$_MallaCopia(wid_pagina).rs.fa.cb1 cget -variable] "relative"
	$_MallaCopia(Color,wid) configure -state disabled
    }

    foreach i "TipoColor Color" {
	set _MallaCopia(antes,$i) $_MallaCopia($i)
    }

    # ahora la copia
    set copiast [ GiD_Info postprocess get show_geom_state]
    set _MallaCopia(estado) $copiast
    set showdeftyp [ GiD_Info postprocess get show_geom_deformation_type]
    set _MallaCopia(TipoDeformacion) $showdeftyp

    GetGiDResultsInfoCopia $copiast
    if { $copiast == "Off"} {
	$_MallaCopia(wid_pagina).frd.rd1 invoke
    } elseif { $copiast == "Original"} {
	$_MallaCopia(wid_pagina).frd.rd2 invoke
    } else {
	$_MallaCopia(wid_pagina).frd.rd3 invoke
    }

#     if { "$showdeftyp" == "relative"} {
#         $_MallaCopia(wid_pagina).rs.fs.cb1 deselect
#     } else { # == "absolute"
#         $_MallaCopia(wid_pagina).rs.fs.cb1 select
#     }
    set ::[$_MallaCopia(wid_pagina).rs.fa.cb1 cget -variable] $showdeftyp

    foreach i "estado analisis paso resultado factor FactorFijo TipoDeformacion" {
	set _MallaCopia(antes,$i) $_MallaCopia($i)
    }

    SetTraceVariables
}

proc DisableResultFactorEntry { w } {
    $w.fa.e configure -foreground grey60
    $w.fa.e configure -state disabled
}

proc EnableResultFactorEntry { w } {
    $w.fa.e configure -foreground black
    $w.fa.e configure -state normal
}

proc DisableResultFactorWidget { w } {
    $w.fa.la configure -foreground grey60
    $w.fa.ma configure -state disabled
    $w.fa.ls configure -foreground grey60
    $w.fa.cb configure -state disabled
    $w.fa.cb1 configure -state disabled


    $w.fa.lr configure -foreground grey60
    $w.fa.lb configure -state disabled
    $w.fa.l configure -foreground grey60
    DisableResultFactorEntry $w
    $w.fa.c configure -state disabled
}

proc EnableResultFactorWidget { w } {
    $w.fa.la configure -foreground black
    $w.fa.ma configure -state normal

    $w.fa.ls configure -foreground black
    $w.fa.cb configure -state normal
    $w.fa.cb1 configure -state normal

    $w.fa.lr configure -foreground black
    $w.fa.lb configure -state normal
    $w.fa.l configure -foreground black
    EnableResultFactorEntry $w
    $w.fa.c configure -state normal
}

proc DisableColorCopiaWidgets { w} {
    $w.cb1 configure -state disabled
    $w.b configure -state disabled
}

proc EnableColorCopiaWidgets { w} {
    $w.cb1 configure -state normal
    $w.b configure -state normal
}

proc PostGeom::CambiaMalla { cual que w_id} {
    variable $cual

    set PostGeom::${cual}(estado) $que
    if { $que == "Deformed"} {
	EnableResultFactorWidget $w_id.rs
    } else {
	DisableResultFactorWidget $w_id.rs
    }

    if { $cual == "_MallaCopia"} {
	if { "$que" == "Off"} {
	    DisableColorCopiaWidgets $w_id.fcol
	} else {
	    EnableColorCopiaWidgets $w_id.fcol
	}
    }

    PostGeom::CambiaFactorFijo $cual $w_id.rs
}

proc PostGeom::CambiaFactorFijo { cual w_id} {
    variable $cual

    if { [ subst $[ subst PostGeom::${cual}(FactorFijo)]]} {
	DisableResultFactorEntry $w_id
    } else {
	EnableResultFactorEntry $w_id
    }
}

proc PostGeom::CambiaTipoColorCopia { tipo} {
    variable _MallaCopia

    set _MallaCopia(TipoColor) $tipo
    if { $_MallaCopia(TipoColor) == "UserColor"} {
	$_MallaCopia(Color,wid) configure -state normal
    } else {
	$_MallaCopia(Color,wid) configure -state disabled
    }
}

proc PostGeom::CambiaTipoColorCopia2 { } {
    global PG_MallaColorCopia

    CambiaTipoColorCopia $PG_MallaColorCopia
}



proc PostGeom::CambiaColorCopia { wb} {
    variable _MallaCopia

    # set nuevo [ GIDChooseColorMenu $wb.mc [ list below $wb] -title [_ "Select color"] -color [ $wb cget -background]]

    set nuevo [ GIDChooseColor [ winfo toplevel $wb].selcolor \
		    -color [ $wb cget -background] \
		    -title [_ "Select color"]]

    if { [ string length $nuevo]} {
	$wb configure -background $nuevo
	#GiD_Process Mescape results geometry ChangeShowCol DefineColor $nuevo
	set _MallaCopia(Color) $nuevo
    }
}

proc PostGeom::TipoDeformacion { cual} {
    variable $cual
    global PG_tipo_defor

    set PostGeom::${cual}(TipoDeformacion) $PG_tipo_defor($cual)
    if { $cual == "_MallaPrincipal"} {
	PostGeom::CambioResultadoPrincipal
    } else {
	PostGeom::CambioResultadoCopia
    }
}


proc PostGeom::CreateResultFactorSelectionWidget { w storevar} {
    global PG_tipo_defor

    ttk::frame $w -borderwidth 0

    ttk::frame $w.fa -borderwidth 0
    ttk::label $w.fa.la -text [_ "Analysis"]:
    #labels can be translated
    set values [lsort -dictionary [ GiD_Info postprocess get all_analysis]]
    set labels {}
    foreach i $values {
	lappend labels [TranslateResultName $i]
    }
    TTKComboBox $w.fa.ma -textvariable PostGeom::${storevar}(analisis) -state readonly
    if { $storevar == "_MallaPrincipal" } {
	$w.fa.ma configure -modifycmd PostGeom::CambioAnalisisPrincipal
    } elseif {$storevar == "_MallaCopia"} {
	$w.fa.ma configure -modifycmd PostGeom::CambioAnalisisCopia
    }
    
    grid $w.fa.la -column 0 -row 0 -sticky w
    grid $w.fa.ma -column 1 -row 0 -sticky w

    
    set PostGeom::${storevar}(analisis,wid) $w.fa.ma

    ttk::label $w.fa.ls -text [_ "Step"]:
    TTKComboBox $w.fa.cb -textvariable PostGeom::${storevar}(paso) -state readonly 

    if { ![info exists PG_tipo_defor($storevar)] } { set PG_tipo_defor($storevar) relative }
    ttk::checkbutton $w.fa.cb1 -text [_ "Position vector"] -variable PG_tipo_defor($storevar) -onvalue absolute -offvalue relative  -command [list PostGeom::TipoDeformacion $storevar]
	# -borderwidth 1
   
    grid $w.fa.ls -column 0 -row 1 -sticky w
    grid $w.fa.cb -column 1 -row 1 -sticky w
    grid $w.fa.cb1 -column 2 -row 1 -padx 5 -sticky w
    
    set PostGeom::${storevar}(paso,wid) $w.fa.cb

    ttk::label $w.fa.lr -text [_ "Result"]:
    TTKComboBox $w.fa.lb -textvariable PostGeom::${storevar}(resultado) -state readonly
    
    
    grid $w.fa.lr -column 0 -row 2 -sticky w
    grid $w.fa.lb -column 1 -row 2 -sticky w
    
    set PostGeom::${storevar}(resultado,wid) $w.fa.lb

    ttk::label $w.fa.l -text [_ "Factor"]:
    
    if { ![info exists PostGeom::${storevar}(factor)] } { set PostGeom::${storevar}(factor) "" }

    ttk::entry $w.fa.e -textvariable PostGeom::${storevar}(factor)
    # -borderwidth 1 -relief sunken
    if { ![info exists PostGeom::${storevar}(FactorFijo)] } { set PostGeom::${storevar}(FactorFijo) 0 }
    ttk::checkbutton $w.fa.c -variable PostGeom::${storevar}(FactorFijo) -text [_ "fixed deformation"] -command [list PostGeom::CambiaFactorFijo $storevar $w]    
    # -borderwidth 1

    grid $w.fa.l -column 0 -row 3 -sticky w
    grid $w.fa.e -column 1 -row 3 -sticky w
    grid $w.fa.c -column 2 -row 3 -padx 5 -sticky w
    
    set PostGeom::${storevar}(factor,wid) $w.fa.l

    grid $w.fa -sticky we -padx 2 -pady 0
    grid columnconfigure $w 0 -weight 1
    grid rowconfigure $w 0 -weight 1
    grid rowconfigure $w 1 -weight 1
    grid rowconfigure $w 2 -weight 1

}

proc PostGeom::Close { } {
    variable _w_id

    destroy $_w_id
}

proc PostGeom::Apply {  w_ntb } {
    variable _w_id
    variable _MallaPrincipal
    variable _MallaCopia
    variable _DoingApply

    if { "[ $w_ntb raise]" == "ViewResults"} {
	PRAccept
	return
    }

    # as VerificaReal has been changed, we need to do extra verifying !!!
    if { $_MallaPrincipal(estado) == "Deformed"} {
	if { ![ VerificaReal [_ "Main mesh deformation factor"]: $_MallaPrincipal(factor) $_w_id]} {
	    set def_vec $_MallaPrincipal(resultado)
	    set res_anal $_MallaPrincipal(analisis)
	    set _MallaPrincipal(factor) [ GiD_Info postprocess \
					      get main_geom_factor $res_anal $_MallaPrincipal(paso) $def_vec]
	    return            
	}
    }
    
    # as VerificaReal has been changed, we need to do extra verifying !!!
    if { $_MallaCopia(estado) == "Original"} {
	if { ![ VerificaReal [_ "Reference mesh deformation factor"]: $_MallaCopia(factor)  $_w_id]} {
	    set def_vec $_MallaCopia(resultado)
	    set res_anal $_MallaCopia(analisis)
	    set _MallaCopia(factor) [ GiD_Info postprocess \
					  get main_geom_factor $res_anal $_MallaCopia(paso) $def_vec]
	    return
	}
    }

    set _DoingApply 1

    set oldAutomaticRedraw [ GiD_Set AutomaticRedraw]
    GiD_Set AutomaticRedraw -1

    set redibujar 0

    # la malla PRINCIPAL
    set cambio 0
    foreach i "estado analisis paso resultado factor FactorFijo TipoDeformacion" {
	if { "$_MallaPrincipal(antes,$i)" != "$_MallaPrincipal($i)"} {
	    set cambio 1
	    break
	}
    }

    if { $cambio} {
	GiD_Process Mescape results geometry Original
	if { $_MallaPrincipal(estado) == "Deformed"} {
	    set result $_MallaPrincipal(resultado)
	    set res_anal $_MallaPrincipal(analisis)
	    set tipo_factor "Dynamic"
	    if { $_MallaPrincipal(FactorFijo)} {
		set tipo_factor "Fixed"
	    }
	    GiD_Process Mescape results resultspreferences $result Deformation FactorType $tipo_factor
	    GiD_Process Mescape results resultspreferences $result Deformation Factor $_MallaPrincipal(factor)
	    if { ( $result != "") && ( $res_anal != "") && ( $_MallaPrincipal(paso) != "")} {
		GiD_Process Mescape results options deformationtype $_MallaPrincipal(TipoDeformacion)
		GiD_Process Mescape results AnalysisSel $res_anal $_MallaPrincipal(paso) \
		    geometry deformation $result $_MallaPrincipal(factor)
		GiD_Process Mescape results options deformationtype relative
	    }
	}
	set redibujar 1
	
	# ahora el nuevo estado es este
	foreach i "estado analisis paso resultado factor FactorFijo TipoDeformacion" {
	    set _MallaPrincipal(antes,$i) $_MallaPrincipal($i)
	}
    }

    # el color de la COPIA
    set cambio 0
    foreach i "TipoColor Color" {
	if { "$_MallaCopia(antes,$i)" != "$_MallaCopia($i)"} {
	    set cambio 1
	    break
	}
    }

    if { $cambio} {
	if { "$_MallaCopia(TipoColor)" == "UserColor"} {
	    GiD_Process Mescape results geometry ChangeShowCol DefineColor $_MallaCopia(Color)
	} else {
	    GiD_Process Mescape results geometry ChangeShowCol MeshColor
	}
    }

    # la malla COPIA
    set cambio 0
    foreach i "estado analisis paso resultado factor FactorFijo TipoDeformacion" {
	if { "$_MallaCopia(antes,$i)" != "$_MallaCopia($i)"} {
	    set cambio 1
	    break
	}
    }

    if { $cambio} {
	GiD_Process Mescape results geometry hidetheshow
	if { $_MallaCopia(estado) == "Original"} {
	    GiD_Process Mescape results geometry showoriginal
	} elseif { $_MallaCopia(estado) == "Deformed"} {
	    set result $_MallaCopia(resultado)
	    set res_anal $_MallaCopia(analisis)
	    set tipo_factor "Dynamic"
	    if { $_MallaCopia(FactorFijo)} {
		set tipo_factor "Fixed"
	    }
	    GiD_Process Mescape results resultspreferences $result Deformation FactorType $tipo_factor
	    GiD_Process Mescape results resultspreferences $result Deformation Factor $_MallaCopia(factor)
	    if { ( $result != "") && ( $res_anal != "") && ( $_MallaCopia(paso) != "")} {
		GiD_Process Mescape results options deformationtype $_MallaCopia(TipoDeformacion)
		GiD_Process Mescape results Geometry ShowDeformed \
		        $res_anal $_MallaCopia(paso) $result $_MallaCopia(factor)
		GiD_Process Mescape results options deformationtype relative
	    }
	}
	set redibujar 1

	# ahora el nuevo estado es este
	foreach i "estado analisis paso resultado factor FactorFijo TipoDeformacion" {
	    set _MallaCopia(antes,$i) $_MallaCopia($i)
	}
    }


    # lo separamos por si lo de arriba da un error
    GiD_Set AutomaticRedraw $oldAutomaticRedraw

    if { $redibujar} {
	.central.s render
    }
    set _DoingApply 0
}

proc PostGeom::SetTraceVariables { } {
    variable _MallaPrincipal
    variable _MallaCopia
    trace variable _MallaPrincipal(paso) w "PostGeom::CambioPasoPrincipal;#"
    trace variable _MallaPrincipal(resultado) w "PostGeom::CambioResultadoPrincipal;#"
    trace variable _MallaCopia(paso) w "PostGeom::CambioPasoCopia;#"
    trace variable _MallaCopia(resultado) w "PostGeom::CambioResultadoCopia;#"
}

proc PostGeom::DeleteTraceVariables { w_evento w_padre} {
    variable _MallaPrincipal
    variable _MallaCopia
    if { $w_evento == $w_padre} {
	trace vdelete _MallaPrincipal(paso) w "PostGeom::CambioPasoPrincipal;#"
	trace vdelete _MallaPrincipal(resultado) w "PostGeom::CambioResultadoPrincipal;#"
	trace vdelete _MallaCopia(paso) w "PostGeom::CambioPasoCopia;#"
	trace vdelete _MallaCopia(resultado) w "PostGeom::CambioResultadoCopia;#"
    }
}

proc PostGeom::Create { { w .gid.wPostGeom } } {
    variable _w_id
    variable _p_mp
    variable _p_mc
    variable _MallaPrincipal
    variable _MallaCopia
    variable _DoingApply
    global PG_MallaColorCopia

    set _w_id $w
    set _DoingApply 0

    InitWindow $w [_ "View Results & Deformation"] PostResultsDeformationWindowGeom \
	PostGeom::Create
    if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0

    DeleteTraceVariables $w $w

    set def_back [ $w cget -background]
    set realzado [ CCColorActivo $def_back]

    # marco de las cosas:
    ttk::frame $w.f -borderwidth 0

    NoteBook $w.f.nb -internalborderwidth 0 -activebackground $realzado

    # pgina para visualizar resultados
    set _p_vr [ $w.f.nb insert end ViewResults -text [_ "View results"]]
    PostResults $_p_vr 1

    # pagina de la geometria principal
    set _p_mp [ $w.f.nb insert end MainMesh -text [_ "Main Mesh"]]

    text $_p_mp.t -borderwidth 4 -relief flat -width 20 -height 2 -wrap word -background $realzado
    $_p_mp.t insert end [_ "Results will be drawn on this deformed model."]
    $_p_mp.t configure -state disabled

    ttk::labelframe $_p_mp.f -text [_ "Deform main mesh"]

    ttk::frame $_p_mp.f.frd -borderwidth 0

    if { ![info exists _MallaPrincipal(estado)] } { set _MallaPrincipal(estado) [GiD_Info postprocess get main_geom_state] }
    ttk::radiobutton $_p_mp.f.frd.rd1 -text [_ "Original"] -value Original -variable _MallaPrincipal(estado) \
	    -command "PostGeom::CambiaMalla _MallaPrincipal Original $_p_mp.f"
    ttk::radiobutton $_p_mp.f.frd.rd2 -text [_ "Deformed"] -value Deformed -variable _MallaPrincipal(estado) \
	    -command "PostGeom::CambiaMalla _MallaPrincipal Deformed $_p_mp.f"
    grid $_p_mp.f.frd.rd1 $_p_mp.f.frd.rd2 -sticky ew -padx 4 -pady 2

    set _MallaPrincipal(wid_pagina) $_p_mp.f
    PostGeom::CreateResultFactorSelectionWidget $_p_mp.f.rs _MallaPrincipal

    grid $_p_mp.f.frd -sticky new -padx 4 -pady 0
    grid $_p_mp.f.rs -sticky enws -padx 4 -pady 3
    grid $_p_mp.f -sticky nwes -padx 4 -pady 8
    grid $_p_mp.t -sticky nwes -padx 4 -pady 8
    grid columnconfigure $_p_mp.f 0 -weight 1
    grid rowconfigure $_p_mp.f 2 -weight 1
    grid columnconfigure $_p_mp 0 -weight 1
    grid rowconfigure $_p_mp "0 1" -weight 1


    ##############################
    # pagina de la geometria de referencia ( copia del modelo)
    set _p_mc [ $w.f.nb insert end CopyMesh -text [_ "Reference mesh"]]

    text $_p_mc.t -borderwidth 4 -relief flat -width 20 -height 3 -wrap word -background $realzado
    $_p_mc.t insert end [_ "This is a snapshot of the model. Results will NOT be drawn over this representation."]
    $_p_mc.t configure -state disabled

    ttk::labelframe $_p_mc.f -text [_ "Deform reference mesh"]
    ttk::frame $_p_mc.f.frd -borderwidth 0
    if { ![info exists _MallaCopia(estado)] } { set _MallaCopia(estado) [GiD_Info postprocess get show_geom_state] }
    ttk::radiobutton $_p_mc.f.frd.rd1 -text [_ "Off"] -value Off -variable _MallaCopia(estado) \
	    -command "PostGeom::CambiaMalla _MallaCopia Off $_p_mc.f"
    ttk::radiobutton $_p_mc.f.frd.rd2 -text [_ "Original"] -value Original -variable _MallaCopia(estado) \
	    -command "PostGeom::CambiaMalla _MallaCopia Original $_p_mc.f"
    ttk::radiobutton $_p_mc.f.frd.rd3 -text [_ "Deformed"] -value Deformed -variable _MallaCopia(estado) \
	    -command "PostGeom::CambiaMalla _MallaCopia Deformed $_p_mc.f"
    grid $_p_mc.f.frd.rd1 $_p_mc.f.frd.rd2 $_p_mc.f.frd.rd3 -sticky wns -padx 4 -pady 2

    ttk::frame $_p_mc.f.fcol -borderwidth 0
    if { ![info exists PG_MallaColorCopia] } { set PG_MallaColorCopia MeshColor }
    ttk::checkbutton $_p_mc.f.fcol.cb1 -text [_ "Use this color: "] -variable PG_MallaColorCopia \
	    -offvalue MeshColor -onvalue UserColor -command "PostGeom::CambiaTipoColorCopia2"
    #button $_p_mc.f.fcol.b -width 3 -background $realzado -command "PostGeom::CambiaColorCopia $_p_mc.f.fcol.b"
    LabelButton $_p_mc.f.fcol.b -width 3 -background $realzado -command "PostGeom::CambiaColorCopia $_p_mc.f.fcol.b"
    set _MallaCopia(Color,wid) $_p_mc.f.fcol.b
    grid $_p_mc.f.fcol.cb1 $_p_mc.f.fcol.b -sticky wns -padx 0 -pady 0 -ipadx 0


    set _MallaCopia(wid_pagina) $_p_mc.f
    PostGeom::CreateResultFactorSelectionWidget $_p_mc.f.rs _MallaCopia

    grid $_p_mc.f.frd -sticky wns -padx 4 -pady 0
    grid $_p_mc.f.fcol -sticky wns -padx 4 -pady 0
    grid $_p_mc.f.rs -sticky enws -padx 4 -pady 3
    grid $_p_mc.f -sticky nwes -padx 4 -pady 8
    grid $_p_mc.t -sticky nwes -padx 4 -pady 8
    grid columnconfigure $_p_mc.f 0 -weight 1
    grid rowconfigure $_p_mc.f 3 -weight 1
    grid columnconfigure $_p_mc 0 -weight 1
    grid rowconfigure $_p_mc "0 1" -weight 1

    $w.f.nb compute_size
    $w.f.nb raise [ $w.f.nb page 0]
    grid $w.f.nb -sticky news -padx 4 -pady 2
    grid columnconfigure $w.f 0 -weight 1
    grid rowconfigure $w.f 0 -weight 1


    # marco de los botones
    ttk::frame $w.but -style BottomFrame.TFrame
    # -background $realzado

    ttk::button $w.but.apply -text [_ "Apply"] -command "PostGeom::Apply $w.f.nb" -takefocus 0 -style BottomFrame.TButton
    #-borderwidth 1 -padx 8 -pady 3
    ttk::button $w.but.close -text [_ "Close"] -command PostGeom::Close -takefocus 0 -style BottomFrame.TButton
    #-borderwidth 1 -padx 8 -pady 3

    #SetWidgetsWidthFromText $w.but.apply $w.but.close

    grid $w.but.apply -sticky ews -padx 6 -pady 12
    grid $w.but.close -sticky ews -padx 6 -pady 12 -row 0 -column 1



    #enpaquetamos marcos
    grid $w.f -sticky news -padx 0 -pady 0
    grid $w.but -sticky wes
    if { $::tcl_version >= 8.5 } { grid anchor $w.but center }

    grid columnconfigure $w 0 -weight 1
    grid rowconfigure $w 0 -weight 1

    focus $w.but.apply
    bind $w <Return> "+$w.but.apply invoke"
    bind $w <Escape> "focus $w.but.close; $w.but.close invoke"

    update idletasks

    SetTraceVariables
    ActualizaVariables

    bind $w <Destroy> "+ PostGeom::DeleteTraceVariables %W $w"
}

