# tclfile -*- TCL -*-


proc StatusBarToPre {} {
    if { [GidUtils::IsTkDisabled]} {
        return
    }
    global GidPriv       
    if { [info exists GidPriv(PrePostStatusWindowGeom)] } {
	set action [lindex $GidPriv(PrePostStatusWindowGeom) 0]       
	if { $action != "NONE" } {
	    putStatusButton .gid.bottominfo.1 ::GiDStatus(ZoomFactor)          [_ "Zoom"] \
		{WriteZoom}        {}                         [_ "Zoom"]                                               {1} {60}
	    
	    putStatusButton .gid.bottominfo.2 ::GiDStatus(MeshInfo)            [list [_ "Nodes"] [_ "Elements"]] \
		{WriteMeshInfo}    {ShowHideListStatusWindow} [_ "Number of total elements\n(Click for status list)"]  {2} {105}
	    
	    putStatusButton .gid.bottominfo.3 ::GiDStatus(RenderMode)          [_ "Render"] \
		{WriteTxtVar}      {RenderRing}               [_ "Render status\n(Click to change)"]                   {3} {85}
	    
	    putStatusButton .gid.bottominfo.4 ::GiDStatus(LayersOrSetsInfo)    [list [_ "Layers"] [_ "Off"] [_ "Back"] [_ "Transparent"]] \
		{WriteLayerInfo}   {}                         [_ "Layers information"]                                 {4} {60}
	    
	    putStatusButton .gid.bottominfo.5 ::GidPriv(Coordinates)           {} \
		{WriteCoordsUnits} {SetCoord}                 [_ "Coordinates and units"]                              {5} {105}
	    
	    putStatusButton .gid.bottominfo.6 ::GiDStatus(PrePost)             {} \
		{WriteOnlyVar}     {}                         [_ "Preprocess / Postprocess"]                           {6} {25}
	}
    }
}

proc StatusBarToPost {} {
    if { [GidUtils::IsTkDisabled]} {
        return
    }
    global GidPriv    
    if { [info exists GidPriv(PrePostStatusWindowGeom)] } {
	set action [lindex $GidPriv(PrePostStatusWindowGeom) 0]   
	if { $action != "NONE" } {
	    putStatusButton .gid.bottominfo.1 ::GiDStatus(ZoomFactor)          [_ "Zoom"] \
		{WriteZoom}        {}                         [_ "Zoom"]                                               {1} {60}
	    
	    putStatusButton .gid.bottominfo.2 ::GiDStatus(MeshInfo)            [list [_ "Nodes"] [_ "Elements"]] \
		{WriteMeshInfo}    {ShowHideListStatusWindow} [_ "Number of total elements\n(Click for status list)"]  {2} {105}
	    
	    putStatusButton .gid.bottominfo.3 ::GiDStatus(RenderMode)          [_ "Render"] \
		{WriteTxtVar}      {RenderRing}               [_ "Render status\n(Click to change)"]                   {3} {85}
	    
	    putStatusButton .gid.bottominfo.4 ::GiDStatus(LayersOrSetsInfo)    [list [_ "Sets"] [_ "Off"] [_ "Back"] [_ "Transparent"]] \
		{WriteSetsInfo}   {}                         [_ "Sets information"]                                    {4} {60}
	    
	    putStatusButton .gid.bottominfo.5 ::GidPriv(Coordinates)           {} \
		{WriteCoordsUnits} {ChangeResultUnits}        [_ "Coordinates and units | Results information"]        {5} {105}
	    
	    putStatusButton .gid.bottominfo.6 ::GiDStatus(PrePost)             {} \
		{WriteOnlyVar}     {}                         [_ "Preprocess / Postprocess"]                           {6} {30}
	}
    }
}

#Write functions txt is translated text, varvalue its comming from GiD
proc WriteZoom { w txt varvalue } {
    if { ![winfo exists $w] } return
    $w configure -text "${txt}: ${varvalue}"
}

proc FormatWithLetterNumber { number } {
  if { [string length  $number] > 3 } {
    if { [string length  $number] > 6 } {
      if { [string length  $number] > 9 } {
        if { [string length  $number] > 12 } {
          if { [string length  $number] > 15 } {
            return "[string range $number 0 end-15]P"
          } else {
            return "[string range $number 0 end-12]T"
          }
        } else {
          return "[string range $number 0 end-9]G"
        }
      } else {
        return "[string range $number 0 end-6]M"
      }
    } else {
      return "[string range $number 0 end-3]K"
    }
  } else {
    return $number
  }
}

proc WriteMeshInfo { w txt varvalue } {

#WarnWinText "WriteMeshInfo $w $txt $varvalue"

  if { ![winfo exists $w] } return
  set output "[lindex $txt 0]: "
  append output [FormatWithLetterNumber [lindex $varvalue 0]]
  append output ", [lindex $txt 1]: "
  append output [FormatWithLetterNumber [lindex $varvalue 1]]
  $w configure -text "$output"
}
proc WriteOnlyVar { w txt varvalue } {
  if { ![winfo exists $w] } return
  $w configure -text "${txt}:${varvalue}"
}

proc WriteLayerInfo { w txt varvalue } {
  if { ![winfo exists $w] } return
  set output "[lindex $txt 0]: "
  append output [lindex $varvalue 0]
  if { [lindex $varvalue 1] != 0 || [lindex $varvalue 2]!=0 } {
    append output "("
    if { [lindex $varvalue 1] != 0 } {
      append output "[lindex $txt 1]: "
      append output [lindex $varvalue 1]  
      if { [lindex $varvalue 2] != 0 } {
        append output ", "
      }
    }
    if { [lindex $varvalue 2] != 0 } {
      append output "[lindex $txt 2]: "
      append output [lindex $varvalue 2]
    }
    append output ")"
  }
  $w configure -text "$output"
}

proc WriteSetsInfo { w txt varvalue } {
  if { ![winfo exists $w] } return
  set output "[lindex $txt 0]: "
  append output [lindex $varvalue 0]
  if { [lindex $varvalue 1] != 0 || [lindex $varvalue 3]!=0 } {
    append output "("
    if { [lindex $varvalue 1] != 0 } {
      append output "[lindex $txt 1]: "
      append output [lindex $varvalue 1]  
      if { [lindex $varvalue 3] != 0 } {
        append output ", "
      }
    }
    if { [lindex $varvalue 3] != 0 } {
      append output "[lindex $txt 3]: "
      append output [lindex $varvalue 3]
    }
    append output ")"
  }
  $w configure -text "$output"
}

proc AddSpaceUntilLength { var length } {
    if { [regexp {[0-9]} [string range $var 0 0]] } {
        set var " $var"
    }
    while { [string length $var] < $length } {
        append var " "
    }
    return $var
}

proc WriteCoordsUnits { w txt varvalue } {
  if { ![winfo exists $w] } return
  # mouse inside draw window
    set output ""
    if { $varvalue == "Orthogonal" } {
	set output [_ "Orthogonal view to Z"]
    } elseif { [ string first result [ string tolower $varvalue]] != -1} {
	# information is {Result interval 19} {[ min, max]}
	set output [_ "Result"]
	append output " "
	append output [ lindex $varvalue 1]
    } elseif { [ string first unkown [ string tolower $varvalue]] != -1} {
	# information is unknown
	set output $varvalue
    } elseif { $varvalue != "" } {
	set output "( "
	append output [AddSpaceUntilLength [lindex $varvalue 0] 8]
	append output ", "
	append output [AddSpaceUntilLength [lindex $varvalue 1] 8]
	append output ", "
	append output [AddSpaceUntilLength [lindex $varvalue 2] 1]
	append output ")"
	if { $::GiDStatus(Units) != "" } {
	    append output "  $::GiDStatus(Units)"
	}
    }
    if { $output != ""} {
	$w configure -text "$output"
    }
}
proc WriteTxtVar { w txt varvalue } {
  if { ![winfo exists $w] } return
  $w configure -text "${txt}: ${varvalue}"
}
proc WriteOnlyVar { w txt varvalue } {
  if { ![winfo exists $w] } return
  $w configure -text "${varvalue}"
}


proc actualizeStatusLabel { fillfunction w txt n1 n2 op} {
    if { ![winfo exists $w] } return
    #WarnWinText "Fill: $fillfunction Txt: $txt n1: $n1 n2: $n2 op: $op"
    $fillfunction $w $txt [set ::${n1}($n2)]
    #cut text to space available
    set acttext [$w cget -text]    
    while { [winfo reqwidth $w] > [winfo width $w] && [string length $acttext]>4} {        
        $w configure -text "[string range $acttext 0 end-4]..."
        set acttext [$w cget -text]
    }
}

proc readjustwidth { w var txt fillfunction } {
    #WarnWinText "readjustwidth $var"
    
    set acttext [$w cget -text]
    if { [string range $acttext end-2 end] == "..." } {     
      $fillfunction $w $txt [ set $var] 
      if { [winfo width $w] > "3" } { #it jumps first call before windows is well rendered
        set acttext [$w cget -text]        
        while { [winfo reqwidth $w] > [winfo width $w] && [string length $acttext]>4} {            
            $w configure -text "[string range $acttext 0 end-4]..."
            set acttext [$w cget -text]
            #WarnWinText "$acttext [winfo reqwidth $w] > [winfo width $w]"
        }
      }
    } else {        
        while { [winfo reqwidth $w] > [winfo width $w] && [string length $acttext]>4} {        
            $w configure -text "[string range $acttext 0 end-4]..."
            set acttext [$w cget -text]
        }   
    }
    #grid configure $w -sticky nes
    
}

proc putStatusButton {w var txt fillfunction command help column weight} {
   #WarnWinText "putStatusButton $w $var $txt $fillfunction $command $help"
    # set f [ tk::frame $w -borderwidth 0 -bg yellow]
    # label $f.l -text hola -relief flat
    # grid $f.l -sticky e
    
   if { ![info exists $var] } {
    set $var ""
   }
    
    #ttk::label $w -text hola -style Horizontal.IconButton
    #ttk::label $w -text ""
    #bind $w <Double-1> [list $command]
    #set alreadygrid ""
    if { [winfo exists $w] } { 
      #set alreadygrid [grid info $w]             
      destroy $w
    }
    
    if { $command != "" } { 
      ttk::button $w -text "" -command [list $command] -style TopMenu.IconButton
    } else {
      ttk::label $w -text "" -style TopMenu.IconButton
    }
    
    
   
    bind $w <Destroy> [list trace remove variable $var write [ list actualizeStatusLabel $fillfunction $w "$txt"]  ]
    $fillfunction $w $txt [ set $var]
    trace add variable $var write [ list actualizeStatusLabel $fillfunction $w "$txt"] 
    
    GidHelp $w $help
    
    grid $w -in .gid.bottominfo -row 1 -column $column -sticky nsew -pady 0      
    grid columnconfigure .gid.bottominfo $column -weight $weight -uniform 1
            
    readjustwidth $w $var $txt $fillfunction
    bind $w <Configure> [list readjustwidth $w $var $txt $fillfunction]
    
}

proc menuStatusLabel { w var txt} {
  if { ![winfo exists $w] } return
    #WarnWin "hola $w"
    #$w configure -text "hola $w"
    # $w configure -text "[_ Render]: $::GiDStatus(RenderMode)"
}

proc RenderRing { } {
    if { ![ info exists ::GiDStatus(RenderMode)]} {
	return
    }
    set lstRender [ list Normal Flat Smooth]
    set lstRenderTrad [ list [_ "Normal#C#Render"] [_ "Flat#C#Render"] [_ "Smooth#C#Render"]]
    set idxRender [ lsearch $lstRenderTrad $::GiDStatus(RenderMode)]
    # if $idxRender == -1 => nextRender == Normal
    set nRender [ llength $lstRender]
    set nextRender [ expr ( $idxRender + $nRender + 1) % $nRender]   
    GiD_Process 'Render [ lindex $lstRender $nextRender]
    set ::GiDStatus(RenderMode) [ lindex $lstRenderTrad $nextRender]
}

proc SwitchTransparency { } {
    if { ![ info exists ::GiDStatus(Transparencies)]} {
	return
    }
    set lstTransp [ list Normal Flat Smooth]
    set lstTranspTrad [ list [_ "All"] [_ "Some"] [_ "No"]]
    set idxTransp [ lsearch $lstTranspTrad $::GiDStatus(Transparencies)]
    if { $idxTransp == 2} {
	set cmd "Transparent"
    } else {
	set cmd "Opaque"
    }
    GiD_Process 'Render $cmd
}

proc ShowHideListStatusWindow { } {
    if { [ winfo exists .gid.listent]} {
	CloseListWindow .gid.listent
    } else {
	GiD_Process escape escape escape escape Utilities List Status
    }
}


proc ChangeResultUnitsApply { w } {
  if { ![winfo exists $w] } return
    # WarnWin "Apply to $::GidPriv(ChangeResultUnits,Result)"
    if { $::GidPriv(ChangeResultUnits,WhichUnits) == "Original"} {
	# WarnWinText [ list GiD_Process Mescape escape escape Results Options UnitSettings \
	#                   $::GidPriv(ChangeResultUnits,Result) \
	#                   $::GidPriv(ChangeResultUnits,WhichSteps) \
	#                   Original]
	GiD_Process Mescape escape escape Results Options UnitSettings \
	    $::GidPriv(ChangeResultUnits,Result) \
	    $::GidPriv(ChangeResultUnits,WhichSteps) \
	    Original
    } else {
	# WarnWinText [ list GiD_Process Mescape escape escape Results Options UnitSettings \
	#                   $::GidPriv(ChangeResultUnits,Result) \
	#                   $::GidPriv(ChangeResultUnits,WhichSteps) \
	#                   ChangeUnit \
	#                   $::GidPriv(ChangeResultUnits,NewUnitName) \
	#                   $::GidPriv(ChangeResultUnits,NewUnitMultFactor) \
	#                   $::GidPriv(ChangeResultUnits,NewUnitAddFactor)]
	GiD_Process Mescape escape escape Results Options UnitSettings \
	    $::GidPriv(ChangeResultUnits,Result) \
	    $::GidPriv(ChangeResultUnits,WhichSteps) \
	    ChangeUnit \
	    $::GidPriv(ChangeResultUnits,NewUnitName) \
	    $::GidPriv(ChangeResultUnits,NewUnitMultFactor) \
	    $::GidPriv(ChangeResultUnits,NewUnitAddFactor)
    }
}

proc ChangeResultUnitsClose { w } {
  if { ![winfo exists $w] } return
    destroy $w
}

proc CRU_EnableDisableResSel { frame} {
    if { $::GidPriv(ChangeResultUnits,WhichUnits) == "Original"} {
	foreach w [ winfo children $frame] {
	    set cl [ winfo class $w]
	    # WarnWinText "$w --> $cl"
	    switch $cl {
		TLabel {
		    $w configure -foreground grey60
		}
		TEntry {
		    $w configure -state disabled
		}
		default {
		}
	    }
	}
    } else {
	foreach w [ winfo children $frame] {
	    set cl [ winfo class $w]
	    # WarnWinText "$w --> $cl"
	    switch $cl {
		TLabel {
		    $w configure -foreground black
		}
		TEntry {
		    $w configure -state normal
		}
		default {
		}
	    }
	}
    }
}

proc CRUChangeUnitEntries { } {
    set resUnit [ lindex [ GiD_Info postprocess get result_unit $::GidPriv(ChangeResultUnits,Result)] 0]
    if { [ lindex $resUnit 0] != ""} {
	set ::GidPriv(ChangeResultUnits,NewUnitName) [ lindex $resUnit 0]
	set ::GidPriv(ChangeResultUnits,NewUnitMultFactor) [ lindex $resUnit 1]
	set ::GidPriv(ChangeResultUnits,NewUnitAddFactor) [ lindex $resUnit 2]
    } else {
	set ::GidPriv(ChangeResultUnits,NewUnitName) [_ "New unit name"]
	set ::GidPriv(ChangeResultUnits,NewUnitMultFactor) 1.0
	set ::GidPriv(ChangeResultUnits,NewUnitAddFactor) 0.0
    }
}

proc CRUSetTraces {} {
    trace variable ::GidPriv(ChangeResultUnits,Result) w "CRUChangeUnitEntries;\#"
}

proc CRUDeleteTraces { w_evento w_padre} {
    if { $w_evento == $w_padre} {
	trace vdelete ::GidPriv(ChangeResultUnits,Result) w "CRUChangeUnitEntries;\#"
    }
}

proc ChangeResultUnitsByHand { { w .gid.wPostChangeResultUnits}} {
    if { ![ info exists ::GiDStatus(Units)]} {
	return
    }

    InitWindow $w [_ "Change result units"] PostChangeUnitsWindowGeom ChangeResultUnits

    CRUDeleteTraces $w $w

    ttk::frame $w.ftop

    # selection of result
    set values [ lsort -dictionary [ GiD_Info postprocess get cur_results_list Contour_Fill]]
    set labels {}
    foreach j $values {
	lappend labels [TranslateResultName $j]
    }

    ttk::label $w.ftop.lbr -text [_ "Select result"]:
    TTKComboBox $w.ftop.cbr -textvariable ::GidPriv(ChangeResultUnits,Result) \
	-values $values -labels $labels \
	-state readonly -width 16 -command CRUChangeUnitEntries

    set curRes [ GiD_Info postprocess get cur_result]
    if { $curRes != ""} {        
	set ::GidPriv(ChangeResultUnits,Result) [TranslateResultName $curRes]
    } else {
	set ::GidPriv(ChangeResultUnits,Result) [ lindex $labels 0]
    }

    
    ttk::radiobutton $w.ftop.rbOriginal -text [_ "Original units"] -value Original \
	    -variable ::GidPriv(ChangeResultUnits,WhichUnits) -command "CRU_EnableDisableResSel $w.ftop.fNewUnit"
    ttk::radiobutton $w.ftop.rbChange -text [_ "Change units to"]: -value ChangeUnit \
	    -variable ::GidPriv(ChangeResultUnits,WhichUnits) -command "CRU_EnableDisableResSel $w.ftop.fNewUnit"


    # definition of frame - new unit
    ttk::frame $w.ftop.fNewUnit
    ttk::label $w.ftop.fNewUnit.lun -text [_ "New unit name"]:
    ttk::entry $w.ftop.fNewUnit.eun -textvariable ::GidPriv(ChangeResultUnits,NewUnitName) -width 12
    ttk::label $w.ftop.fNewUnit.lmf -text [_ "Multiplication factor"]:
    ttk::entry $w.ftop.fNewUnit.emf -textvariable ::GidPriv(ChangeResultUnits,NewUnitMultFactor) -width 8
    ttk::label $w.ftop.fNewUnit.laf -text [_ "Addition factor"]:
    ttk::entry $w.ftop.fNewUnit.eaf -textvariable ::GidPriv(ChangeResultUnits,NewUnitAddFactor) -width 8

    grid $w.ftop.fNewUnit.lun $w.ftop.fNewUnit.eun -sticky e
    grid configure $w.ftop.fNewUnit.eun -sticky ew
    grid $w.ftop.fNewUnit.lmf $w.ftop.fNewUnit.emf -sticky e
    grid configure $w.ftop.fNewUnit.emf -sticky w
    grid $w.ftop.fNewUnit.laf $w.ftop.fNewUnit.eaf -sticky e
    grid configure $w.ftop.fNewUnit.eaf -sticky w
    grid columnconfigure $w.ftop.fNewUnit 1 -weight 1
    grid rowconfigure $w.ftop 0 -weight 1
    grid rowconfigure $w.ftop 1 -weight 1
    grid rowconfigure $w.ftop 2 -weight 1
    # end of frame - new unit

    # apply changes for this or all steps
    if { ![info exists ::GidPriv(ChangeResultUnits,WhichSteps)] } { set ::GidPriv(ChangeResultUnits,WhichSteps) "ThisStep" }
    ttk::checkbutton $w.ftop.cbSteps -text [_ "Use unit changes for all steps"] \
	-onvalue "AllSteps" -offvalue "ThisStep" -variable ::GidPriv(ChangeResultUnits,WhichSteps)


    grid $w.ftop.lbr $w.ftop.cbr -sticky w -padx 8 -pady 1
    grid configure $w.ftop.cbr -sticky ew

    grid $w.ftop.rbOriginal -columnspan 2 -sticky ew -padx 8 -pady 1

    grid $w.ftop.rbChange -columnspan 2 -sticky ew -padx 8 -pady 1

    grid $w.ftop.fNewUnit -columnspan 2 -sticky news -padx 16 -pady 0

    grid $w.ftop.cbSteps -columnspan 2 -sticky ew -padx 8 -pady 1

    grid columnconfigure $w.ftop 1 -weight 1
    grid rowconfigure $w.ftop 0 -weight 1
    grid rowconfigure $w.ftop 1 -weight 1
    grid rowconfigure $w.ftop 2 -weight 1
    grid rowconfigure $w.ftop 3 -weight 1
    grid rowconfigure $w.ftop 4 -weight 1

    
    # botones inferiores
    ttk::frame $w.fbut -style BottomFrame.TFrame 
#-padding 5

    ttk::button $w.fbut.apply -text [_ "Apply"] -command "ChangeResultUnitsApply $w" -takefocus 0 -style BottomFrame.TButton
    ttk::button $w.fbut.close -text [_ "Close"] -command "ChangeResultUnitsClose $w" -takefocus 0 -style BottomFrame.TButton
    #SetWidgetsWidthFromText $w.fbut.apply $w.fbut.close

    grid $w.fbut.apply -sticky ews -padx 4 -pady 10
    grid $w.fbut.close -sticky ews -padx 4 -pady 10 -row 0 -column 1

    #enpaquetamos marcos
    grid $w.ftop -sticky news -padx 4 -pady 4
    grid $w.fbut -sticky wes
    if { $::tcl_version >= 8.5 } { grid anchor $w.fbut center }

    grid columnconfigure $w 0 -weight 1
    grid rowconfigure $w 0 -weight 1

    focus $w.fbut.apply
    bind $w <Return> "+$w.fbut.apply invoke"
    bind $w <Escape> "focus $w.fbut.close; \
	    $w.fbut.close invoke"

    bind $w <Destroy> "+ CRUDeleteTraces %W $w"

    #Default values
    CRUChangeUnitEntries
    set ::GidPriv(ChangeResultUnits,WhichSteps) AllSteps
    set ::GidPriv(ChangeResultUnits,WhichUnits) ChangeUnit

    CRUSetTraces
}

proc ShowDataMenu { w x y} {
    if { ![ winfo exists $w.dmenu]} {
	menu $w.dmenu
    }
    set oldMenuType $::GidPriv(MenuType)
    set ::GidPriv(MenuType) "generic"
    PostDataMenu $w.dmenu
    $w.dmenu post $x $y
    set ::GidPriv(MenuType) $oldMenuType
}


proc ChangeResultUnitsWithTable { { w .gid.wPostChangeResultUnits}} {
    if { ![ info exists ::GiDStatus(Units)]} {
	return
    }

    InitWindow $w [_ "Change result units"] PostChangeUnitsWindowGeom ChangeResultUnits

    # CRUDeleteTraces $w $w

    ttk::frame $w.ftop

    # selection of result
    set values [ lsort -dictionary [ GiD_Info postprocess get cur_results_list Contour_Fill]]
    set labels {}
    foreach j $values {
	lappend labels [TranslateResultName $j]
    }

    ttk::label $w.ftop.lbr -text [_ "Select result"]:
    TTKComboBox $w.ftop.cbr -textvariable ::GidPriv(ChangeResultUnits,Result) \
	-values $values -labels $labels \
	-state readonly -width 16 -command CRUChangeUnitEntries

    set curRes [ GiD_Info postprocess get cur_result]
    if { $curRes != ""} {        
	set ::GidPriv(ChangeResultUnits,Result) [TranslateResultName $curRes]
    } else {
	set ::GidPriv(ChangeResultUnits,Result) [ lindex $labels 0]
    }

    
    # ttk::radiobutton $w.ftop.rbOriginal -text [_ "Original units"] -value Original \
    #         -variable ::GidPriv(ChangeResultUnits,WhichUnits) -command "CRU_EnableDisableResSel $w.ftop.fNewUnit"
    # ttk::radiobutton $w.ftop.rbChange -text [_ "Change units to"]: -value ChangeUnit \
    #         -variable ::GidPriv(ChangeResultUnits,WhichUnits) -command "CRU_EnableDisableResSel $w.ftop.fNewUnit"
    # 
    # 
    # # definition of frame - new unit
    # ttk::frame $w.ftop.fNewUnit
    # ttk::label $w.ftop.fNewUnit.lun -text [_ "New unit name"]:
    # ttk::entry $w.ftop.fNewUnit.eun -textvariable ::GidPriv(ChangeResultUnits,NewUnitName) -width 12
    # ttk::label $w.ftop.fNewUnit.lmf -text [_ "Multiplication factor"]:
    # ttk::entry $w.ftop.fNewUnit.emf -textvariable ::GidPriv(ChangeResultUnits,NewUnitMultFactor) -width 8
    # ttk::label $w.ftop.fNewUnit.laf -text [_ "Addition factor"]:
    # ttk::entry $w.ftop.fNewUnit.eaf -textvariable ::GidPriv(ChangeResultUnits,NewUnitAddFactor) -width 8
    # 
    # grid $w.ftop.fNewUnit.lun $w.ftop.fNewUnit.eun -sticky e
    # grid configure $w.ftop.fNewUnit.eun -sticky ew
    # grid $w.ftop.fNewUnit.lmf $w.ftop.fNewUnit.emf -sticky e
    # grid configure $w.ftop.fNewUnit.emf -sticky w
    # grid $w.ftop.fNewUnit.laf $w.ftop.fNewUnit.eaf -sticky e
    # grid configure $w.ftop.fNewUnit.eaf -sticky w
    # grid columnconfigure $w.ftop.fNewUnit 1 -weight 1
    # grid rowconfigure $w.ftop 0 -weight 1
    # grid rowconfigure $w.ftop 1 -weight 1
    # grid rowconfigure $w.ftop 2 -weight 1
    # # end of frame - new unit
    # 
    # # apply changes for this or all steps
    # init variable
    # ttk::checkbutton $w.ftop.cbSteps -text [_ "Use unit changes for all steps"] \
    #         -onvalue "AllSteps" -offvalue "ThisStep" -variable ::GidPriv(ChangeResultUnits,WhichSteps)
    # 
    # 
    # grid $w.ftop.lbr $w.ftop.cbr -sticky w -padx 8 -pady 1
    # grid configure $w.ftop.cbr -sticky ew
    # 
    # grid $w.ftop.rbOriginal -columnspan 2 -sticky ew -padx 8 -pady 1
    # 
    # grid $w.ftop.rbChange -columnspan 2 -sticky ew -padx 8 -pady 1
    # 
    # grid $w.ftop.fNewUnit -columnspan 2 -sticky news -padx 16 -pady 0
    # 
    # grid $w.ftop.cbSteps -columnspan 2 -sticky ew -padx 8 -pady 1
    # 
    # grid columnconfigure $w.ftop 1 -weight 1
    # grid rowconfigure $w.ftop 0 -weight 1
    # grid rowconfigure $w.ftop 1 -weight 1
    # grid rowconfigure $w.ftop 2 -weight 1
    # grid rowconfigure $w.ftop 3 -weight 1
    # grid rowconfigure $w.ftop 4 -weight 1

    
    gid_groups_conds::entry_units $w.ftop.u \
	-unit_magnitude_variable ::GidPriv(ChangeResultUnits,Magnitude) \
	-units_variable ::GidPriv(ChangeResultUnits,Variable)
    ttk::label $w.ftop.gpc_umvl -text "Unit magnitude variable:"
    ttk::entry $w.ftop.gpc_umvt -textvariable ::GidPriv(ChangeResultUnits,Magnitude)
    ttk::label $w.ftop.gpc_uvl -text "Units variable:"
    ttk::entry $w.ftop.gpc_uvt -textvariable ::GidPriv(ChangeResultUnits,Variable)

    grid $w.ftop.u -columnspan 2 -sticky ew
    grid $w.ftop.gpc_umvl $w.ftop.gpc_umvt -sticky e
    grid configure $w.ftop.gpc_umvt -sticky ew
    grid $w.ftop.gpc_uvl $w.ftop.gpc_uvt -sticky e
    grid configure $w.ftop.gpc_uvt -sticky ew
    
    # botones inferiores
    ttk::frame $w.fbut -style BottomFrame.TFrame
#-padding 5

    ttk::button $w.fbut.apply -text [_ "Apply"] -command "ChangeResultUnitsApply $w" -takefocus 0 -style BottomFrame.TButton
    ttk::button $w.fbut.close -text [_ "Close"] -command "ChangeResultUnitsClose $w" -takefocus 0 -style BottomFrame.TButton
    #SetWidgetsWidthFromText $w.fbut.apply $w.fbut.close

    grid $w.fbut.apply -sticky ews -padx 4 -pady 10
    grid $w.fbut.close -sticky ews -padx 4 -pady 10 -row 0 -column 1

    #enpaquetamos marcos
    grid $w.ftop -sticky news -padx 4 -pady 4
    grid $w.fbut -sticky wes
    if { $::tcl_version >= 8.5 } { grid anchor $w.fbut center }

    grid columnconfigure $w 0 -weight 1
    grid rowconfigure $w 0 -weight 1

    focus $w.fbut.apply
    bind $w <Return> "+$w.fbut.apply invoke"
    bind $w <Escape> "focus $w.fbut.close; \
	    $w.fbut.close invoke"

    bind $w <Destroy> "+ CRUDeleteTraces %W $w"

    #Default values
    CRUChangeUnitEntries
    set ::GidPriv(ChangeResultUnits,WhichSteps) AllSteps
    set ::GidPriv(ChangeResultUnits,WhichUnits) ChangeUnit

    # CRUSetTraces
}

proc ChangeResultUnits { { w .gid.wPostChangeResultUnits}} {
    if { [ catch { package require gid_groups_conds}]} {
	ChangeResultUnitsByHand $w
    } else {
	ChangeResultUnitsWithTable $w
    }
}
