proc CreateCompassInfo_win {} {
    global ProblemTypePriv
    
    set image1 [imagefromtdyn valid_pass.png]
    set image2 [imagefromtdyn invalid_pass.png]
    
    set w .gid.val
    catch {destroy $w}
    toplevel $w
    wm title $w "Modules validation"

    set columns [list \
	    [list 20 [= "Module"] left text 0] \
	    [list 10 [= "Validation"] right image 0]]
#             [list 20 [= "Expiration"] right text 0]]
    set tree [fulltktree $w.tree \
	    -columns $columns -expand 1 -bd 1 \
	    -selectmode single -showheader 1 -showlines 0 \
	    -indent 1 -compass_background 1 \
	    -item_image $gid_groups_conds::images(finish-16) \
	    -folder_image $gid_groups_conds::images(finish-16)]
    set but [ttk::button $w.bt -text "Register ..."\
	    -command {CompassFEM::check_passwords_GiD_CompassFEM init}]
    grid $tree -sticky nsew -columnspan 3
    grid $but -sticky nsew
       
    set x0 [winfo rootx .gid]
    set y0 [winfo rooty .gid]
    set x [expr $x0 + [winfo width .gid] - 225]
    set y [expr $y0 + 20]
    wm geometry $w 200x245+$x+$y
    wm resizable $w 0 1
    
    grid columnconfigure $w 0 -weight 1
    grid rowconfigure $w 0 -weight 1
       
    CompassFEM::fill_validation_modules_table $tree
}

proc CreateCompassInfo_win_deprecated {} {
    global GIDDEFAULT GidPriv tcl_platform

    set base .gid.info_gid
    InitWindow $base [_ "Compass Info"] GiDInfowin "" "" 1
    $base configure -background #EEEEEE
    #wm minsize $base 459 330
    #wm maxsize $base 459 330
    set image_top  [image create photo -file [file join $GIDDEFAULT bitmaps compassinfo.gif]]       
    set image_but1 [image create photo -file [file join $GIDDEFAULT bitmaps buton_about.gif]]       
    set image_but2 [image create photo -file [file join $GIDDEFAULT bitmaps buton_help.gif]]       
    set image_but3 [image create photo -file [file join $GIDDEFAULT bitmaps buton_tutorials.gif]]       
    set image_but4 [image create photo -file [file join $GIDDEFAULT bitmaps buton_web.gif]]       
    set image_but5 [image create photo -file [file join $GIDDEFAULT bitmaps buton_register.gif]]       
    set image_but6 [image create photo -file [file join $GIDDEFAULT bitmaps buton_close.gif]]       

    set image_but1_over [image create photo -file [file join $GIDDEFAULT bitmaps buton_about_o.gif]]
    set image_but2_over [image create photo -file [file join $GIDDEFAULT bitmaps buton_help_o.gif]]    
    set image_but3_over [image create photo -file [file join $GIDDEFAULT bitmaps buton_tutorials_o.gif]]
    set image_but4_over [image create photo -file [file join $GIDDEFAULT bitmaps buton_web_o.gif]]  
    set image_but5_over [image create photo -file [file join $GIDDEFAULT bitmaps buton_register_o.gif]] 
    set image_but6_over [image create photo -file [file join $GIDDEFAULT bitmaps buton_close_o.gif]] 




    set image_txt1 [image create photo -file [file join $GIDDEFAULT bitmaps text_about.gif]]       
    set image_txt2 [image create photo -file [file join $GIDDEFAULT bitmaps text_gidhelp.gif]]       
    set image_txt3 [image create photo -file [file join $GIDDEFAULT bitmaps text_gidtutorials.gif]]
    set image_txt4 [image create photo -file [file join $GIDDEFAULT bitmaps text_www.gif]]       
    set image_txt5 [image create photo -file [file join $GIDDEFAULT bitmaps text_register.gif]] 
    set image_txt6 [image create photo -file [file join $GIDDEFAULT bitmaps text_close.gif]] 

    label $base.label_imgtop -image $image_top -bd 0

#     label $base.label_about                -image $image_txt1 -bd 0  -bg #EEEEEE
#     label $base.label_help                -image $image_txt2 -bd 0  -bg #EEEEEE
#     label $base.label_tutorials        -image $image_txt3 -bd 0  -bg #EEEEEE
#     label $base.label_web                -image $image_txt4 -bd 0  -bg #EEEEEE
#     label $base.label_register        -image $image_txt5 -bd 0  -bg #EEEEEE
#     label $base.label_close         -image $image_txt6 -bd 0  -bg #EEEEEE

    set font [list -family "Tahoma" -size 10 -weight bold]

    label $base.label_about -text [_ "About"] -fg \#1c7cac -bd 0  -bg \#EEEEEE -font $font
    label $base.label_help -text [_ "Help"] -fg \#1c7cac -bd 0  -bg \#EEEEEE -font $font
    label $base.label_tutorials -text [_ "Tutorials"] -fg \#1c7cac -bd 0  -bg \#EEEEEE -font $font
    label $base.label_web -text [_ "Visit Compass web"] -fg \#1c7cac -bd 0  -bg \#EEEEEE -font $font

    set len [font measure $font "Visit Compass"]
    $base.label_web conf -wraplength [expr $len+5] -justify left -height 2

    label $base.label_register -text [_ "Register"] -fg \#1c7cac -bd 0  -bg \#EEEEEE -font $font
    label $base.label_close -text [_ "Close"] -fg \#1c7cac -bd 0  -bg \#EEEEEE -font $font


#     label $base.label_help                -image $image_txt2 -bd 0  -bg #EEEEEE
#     label $base.label_tutorials        -image $image_txt3 -bd 0  -bg #EEEEEE
#     label $base.label_web                -image $image_txt4 -bd 0  -bg #EEEEEE
#     label $base.label_register        -image $image_txt5 -bd 0  -bg #EEEEEE
#     label $base.label_close         -image $image_txt6 -bd 0  -bg #EEEEEE

    
    CreateButtonOrMenu $base.button\#1 $image_but1 [_ About]
    CreateButtonOrMenu $base.button\#2 $image_but2 [list [_ Help] [_ FAQ] [_ "What is new"]]
    CreateButtonOrMenu $base.button\#3 $image_but3 [_ Tutorial]
    CreateButtonOrMenu $base.button\#4 $image_but4 [_ Web]
    CreateButtonOrMenu $base.button\#5 $image_but5 [_ Register]

    button $base.button#6 \
	-relief flat -bd 0 -bg #EEEEEE -highlightthickness 0 \
	-image $image_but6  \
	-command {destroy .gid.info_gid }



    #        button $base.button_h1 \
	#                -relief flat -bd 0 -bg #EEEEEE -highlightthickness 0 \
	#                -image $image_txt7 \
	#                -command {destroy .gid.info_gid }
    #
    #        button $base.button_h2 \
	#                -relief flat -bd 0 -bg #EEEEEE -highlightthickness 0 \
	#                -image $image_txt8 \
	#                -command {destroy .gid.info_gid }
    #
    #        button $base.button_h3 \
	#                -relief flat -bd 0 -bg #EEEEEE -highlightthickness 0 \
	#                -image $image_txt9 \
	#                -command {destroy .gid.info_gid }


    #binds - on mouse over 

    bind $base.button#1 <Enter> ".gid.info_gid.button#1 configure -image $image_but1_over"
    bind $base.button#1 <Leave> ".gid.info_gid.button#1 configure -image $image_but1 "

    bind $base.button#2 <Enter> ".gid.info_gid.button#2 configure -image $image_but2_over"
    bind $base.button#2 <Leave> ".gid.info_gid.button#2 configure -image $image_but2 "

    bind $base.button#3 <Enter> ".gid.info_gid.button#3 configure -image $image_but3_over"
    bind $base.button#3 <Leave> ".gid.info_gid.button#3 configure -image $image_but3 "

    bind $base.button#4 <Enter> ".gid.info_gid.button#4 configure -image $image_but4_over"
    bind $base.button#4 <Leave> ".gid.info_gid.button#4 configure -image $image_but4 "

    bind $base.button#5 <Enter> ".gid.info_gid.button#5 configure -image $image_but5_over"
    bind $base.button#5 <Leave> ".gid.info_gid.button#5 configure -image $image_but5 "

    bind $base.button#6 <Enter> ".gid.info_gid.button#6 configure -image $image_but6_over"
    bind $base.button#6 <Leave> ".gid.info_gid.button#6 configure -image $image_but6 "

    # Geometry management



    grid $base.label_imgtop -in $base        -row 1 -column 1  \
	-columnspan 6 -sticky ne
    grid $base.button#1        -in $base        -row 2 -column 2  
    grid $base.label_about        -in $base        -row 2 -column 3 -sticky nw -padx 20 -pady 10
    grid $base.button#3        -in $base        -row 2 -column 4 -ipady 5
    grid $base.label_tutorials  -in $base        -row 2 -column 5 -sticky nw -padx 20 -pady 10

    grid $base.button#2        -in $base        -row 3 -column 2 -ipady 5 
    grid $base.label_help        -in $base        -row 3 -column 3 -sticky nw -padx 20 -pady 10
    
    #        grid $base.button_h1 -in $base        -row 5 -column 3 -sticky wn -pady 0
    #        grid $base.button_h2 -in $base        -row 6 -column 3 -sticky wn -pady 0
    #        grid $base.button_h3 -in $base        -row 7 -column 3 -sticky wn -pady 0

    

    grid $base.button#5        -in $base        -row 3 -column 4 -ipady 5 
    grid $base.label_register        -in $base        -row 3 -column 5 -sticky nw -padx 20 -pady 10
    grid $base.button#4        -in $base        -row 4 -column 2 -ipady 5
    grid $base.label_web        -in $base        -row 4 -column 3 -sticky nw -padx 20 -pady 10
    grid $base.button#6        -in $base        -row 4 -column 4 -ipady 5
    grid $base.label_close        -in $base        -row 4 -column 5 -sticky nw -padx 20 -pady 10
    


    # Resize behavior management

    grid rowconfigure $base 1 -weight 1 
    #grid rowconfigure $base 2 -weight 0 -minsize 2
    grid rowconfigure $base 5 -weight 0 -minsize 10

    grid columnconfigure $base 1 -weight 0 -minsize 15
    grid columnconfigure $base 2 -weight 0 -minsize 30
    grid columnconfigure $base 3 -weight 0 -minsize 30
    grid columnconfigure $base 4 -weight 0 -minsize 30
    grid columnconfigure $base 5 -weight 0 -minsize 40
    grid columnconfigure $base 6 -weight 0 -minsize 10
}


proc CreateButtonOrMenu { w image words } {
  
    set namescommands ""
    set ipos [lsearch $::MenuNames [_ Help]]
    if { $ipos != -1 } {
	set ic 0
	foreach i $::MenuEntries($ipos) {
	    set isgood 0
	    foreach j $words {
		if { [regexp "(?iq)$j" $i] } { set isgood 1 }
	    }
	    if { $isgood } {
		set comm [lindex $::MenuCommands($ipos) $ic]
		if { [lindex $comm 0] == "-np-" } {
		    set comm [lrange $comm 1 end]
		} else {
		    set comm ".central.s process escape escape escape escape $comm"
		}
		lappend namescommands $i $comm
	    }
	    incr ic
	}
    }
    if { [llength $namescommands] == 2 } {
	button $w \
	    -relief flat -bd 0 -bg \#EEEEEE -highlightthickness 0\
	    -image $image  \
	    -command [lindex $namescommands 1]
    } else {
	menubutton $w \
	    -relief flat -bd 0 -bg \#EEEEEE -highlightthickness 0\
	    -image $image  \
	    -menu $w.m
	menu $w.m -bd 1
	foreach "name comm" $namescommands {
	    $w.m add command -label $name -command $comm
	}
    }
}