if {![package vsatisfies [package provide Tcl] 8.4]} return

proc load_library_zlibtcl  { dir basename version } {
    package require Tcl 8.4
    if { $::tcl_platform(pointerSize) == 8 } {
	set bits 64
    } else {
	set bits 32
    }
    if { $::tcl_platform(platform) eq "windows"} {        
	if {  $::tcl_platform(pointerSize) == 8} {
	    set library zlibtcl127.dll
	    load [file join $dir $library] $basename
	    package provide zlibtcl 1.2.7
	} else {
	    set library zlibtcl128.dll
	    load [file join $dir $library] $basename
	    package provide zlibtcl 1.2.8
	}
    } else {
	set library libzlibtcl1.2.8.so
	load [file join $dir $library] $basename      
	package provide zlibtcl 1.2.8
    }
}

if { $::tcl_platform(platform) == "windows" && $::tcl_platform(pointerSize) == 8} {
    package ifneeded zlibtcl 1.2.7 [list load_library_zlibtcl $dir zlibtcl 1.2.7]
} else {
    package ifneeded zlibtcl 1.2.8 [list load_library_zlibtcl $dir zlibtcl 1.2.8]
}