
proc pref_general_ui {base_base args} {
    global ChangeVarInfo

    set c [ CreateScrolledCanvas $base_base.sc]
    $base_base.sc configure -relief flat
    set base [ ttk::frame $c.f]


    ttk::labelframe $base.fr0 -text [_ "Messages"]
    ttk::labelframe $base.fr1 -text [_ "Interface options"]
    ttk::labelframe $base.fr2 -text [_ "Backup"]
    ttk::labelframe $base.fr3 -text [_ "Record batch"]
    ttk::labelframe $base.fr4 -text [_ "Parallelism"]
    ttk::labelframe $base.fst -text [_ "State"]

    ttk::frame $base.frame#1
    ttk::frame $base.frame#2
    ttk::frame $base.frame#3

     
    ttk::label $base.label#10 -text [_ "Language"]:

    set ChangeVarInfo(Language) [::GidUtils::GetCurrentLanguage]
    set langs [::GidUtils::GetAllLanguages]
    #reorder langs by translated strings, not by langs
    set langsandlabels [list]
    foreach i $langs {
      lappend langsandlabels [list [_ "%s" [::GIDi18n::language $i]] $i]
    }
    set langsandlabels [lsort -index 0 $langsandlabels]
    set langlabels ""
    set langs ""
    foreach item $langsandlabels {
	lappend langlabels [lindex $item 0]
	lappend langs [lindex $item 1]
    }

    # ComboBoxRAM $base.menubutton#4 ChangeVarInfo(Language) \
    #             $langlabels $langs
    # TTKMenubutton $base.menubutton#4 -textvariable ::ChangeVarInfo(Language) \
    #             -labels $langlabels -values $langs
    TTKComboBox $base.menubutton#4 -textvariable ::ChangeVarInfo(Language) \
	-labels $langlabels -values $langs \
	-state readonly

    GidHelp "$base.label#10 $base.menubutton#4" [_ "It set the program language.\
	    \n -ADA (www.ada.co.jp)owns Copyright of the original Japanese \
	    translation file in standard GiD UI.\
	    \n -Quantech (www.quantech.es) and Melchers Techexport GmbH (www.melchers-techexport.com)\
	    owns Copyright of the original Chinese translation file in standard GiD UI.\
	    \n -Quantech (www.quantech.es) and Men at Work GmbH (http:www.maw-cax.de) \
	    owns Copyright of the original German translation file in standard GiD UI."]


    ttk::label $base.label#11 -text [_ "Number of threads to use"]:
    #this 1024 is the value of MAX_GID_OMP_NUM_THREADS, defined in Main.h
    ttk::spinbox $base.numOfThreads_sb -from 1 -to 1024 -increment 1 -width 8 \
	-textvariable ChangeVarInfo(GID_OMP_NUM_THREADS)
    
    GidHelp "$base.label#11 $base.numOfThreads_sb" [_ "This is the number \
	    of threads used by GiD when running parallel algorithms."]
    
    if { ![info exists ChangeVarInfo(Dialogbrowser)] } { set ChangeVarInfo(Dialogbrowser) 0 }
    ttk::checkbutton $base.checkbutton#1 -text [_ "Dialog browser"] \
	    -variable ChangeVarInfo(Dialogbrowser)
    GidHelp $base.checkbutton#1 \
	[_ "If set, file names are required from the\
	    user with a browser window. If not, file names are required in\
	    the command line"]

	if { ![info exists ChangeVarInfo(SplashWindow)] } { set ChangeVarInfo(SplashWindow) 0 }
    ttk::checkbutton $base.checkbutton#2 -text [_ "Splash window"] -variable ChangeVarInfo(SplashWindow)

    GidHelp $base.checkbutton#2 \
	[_ "If this option is set, the welcome image is\
	    displayed when opening the program"]

	# if { ![info exists ::ChangeVarInfo(DisableTooltips)] } { set ::ChangeVarInfo(DisableTooltips) 0 }
    # ttk::checkbutton $base.cb_tooltip \
	# -text [_ "Disable tooltips"] -variable ::ChangeVarInfo(DisableTooltips)
    # GidHelp $base.cb_tooltip [_ "If this option is set, no tooltips will appear"]

    ttk::frame $base.cb_tooltip -borderwidth 0
    ttk::label $base.cb_tooltip.l -text [_ "Tooltips"]:
    TTKComboBox $base.cb_tooltip.cb \
	-labels [ list [_ "Normal"] [_ "Disabled"] [_ "Bottom Main Window"]] \
	-values [ list normal disabled bottom] \
	-textvariable ::ChangeVarInfo(TooltipPopup) \
	-width 21 \
	-state readonly

    grid $base.cb_tooltip.l $base.cb_tooltip.cb -sticky ew -padx 2
    grid rowconfigure $base.cb_tooltip 0 -weight 1
    grid columnconfigure $base.cb_tooltip 0 -weight 1
    grid columnconfigure $base.cb_tooltip 1 -weight 1

    GidHelp $base.cb_tooltip [_ "Select the behaviour of tooltips"]

	ttk::frame $base.cb_icontext -borderwidth 0
    ttk::label $base.cb_icontext.l -text [_ "Toolbars"]
    TTKComboBox $base.cb_icontext.cb \
	-labels [ list [_ "Icons"] [_ "Icons and Text"] [_ "Text"]] \
	-values [ list Icon IconText Text] \
	-textvariable ::ChangeVarInfo(BarButtonLook) \
	-width 12 \
	-state readonly

    grid $base.cb_icontext.l $base.cb_icontext.cb -sticky ew -padx 2
    grid rowconfigure $base.cb_icontext 0 -weight 1
    grid columnconfigure $base.cb_icontext 0 -weight 1
    grid columnconfigure $base.cb_icontext 1 -weight 1

    GidHelp $base.cb_icontext [_ "If this option is set, \
		         a short text will appear below or on the right of the icons in the icon's bar"]

    if { ![info exists ChangeVarInfo(ViewMenu)] } { set ChangeVarInfo(ViewMenu) 0 }
    ttk::checkbutton $base.checkbutton#22 -text [_ "View menu"] \
	    -variable ChangeVarInfo(ViewMenu)
    GidHelp $base.checkbutton#22 [_ "If this option is set, a 'view' menu entry will\
	    appear on the top menu bar view several view options."]

    ttk::label $base.label#4 -text [_ "Create new point"]:

    # ComboBoxRAM $base.menubutton#1 ChangeVarInfo(Createnewpoint) \
    #             [list [_ "Always"] [_ "Ask"] [_ "Never"]] \
    #             {Always Ask Never}
    TTKComboBox $base.menubutton#1 -textvariable ::ChangeVarInfo(Createnewpoint) \
	-labels [list [_ "Always"] [_ "Ask"] [_ "Never"]] \
	-values {Always Ask Never} \
	-state readonly

    GidHelp  "$base.label#4 $base.menubutton#1" [_ "It alters the way how the\
	    points are entered. Options are:\
	    \nAlways: If trying to create a new point in the vicinity of\
	    an existing one, the new point is always created.\
	    \nAsk: If trying to create a new point in the vicinity of an\
	    existing one, the program asks the user whether to make use of the\
	    existing point or create a new one.\
	    \nNever: Only allows to select existing points. It can be changed\
	    interactively  when in creation point mode by setting 'No join'\
	    until all points are entered."]


    if { ![info exists ChangeVarInfo(Displaycoordinates)] } { set ChangeVarInfo(Displaycoordinates) 0 }
    ttk::checkbutton $base.checkbutton#3 -text [_ "Display coordinates"] \
	    -variable ChangeVarInfo(Displaycoordinates)

    GidHelp $base.checkbutton#3 [_ "If set, coordinates are shown in the\
	    graphical window. "]

	#if { ![info exists ChangeVarInfo(AutomaticRedraw))] } { set  ChangeVarInfo(AutomaticRedraw)) 0 }
    #ttk::checkbutton $base.checkbutton#4 -text {Automatic redraw} \
    #        -variable ChangeVarInfo(AutomaticRedraw)

    #GidHelp $base.checkbutton#4 "If this option is not set, redraws caused " \
    #        "by window expositions, or by internal functions are not " \
    #        "performed. This avoids spending a lot of time for large models."

    ttk::label $base.label#8 -text [_ "Automatic redraw"]:

    # ComboBoxRAM $base.menubutton#3 ChangeVarInfo(AutomaticRedraw) \
    #             [list [_ "All windows"] [_ "Current window"] [_ "None"]] \
    #             {"All windows" "Current window" "None"}
    TTKComboBox $base.menubutton#3 -textvariable ::ChangeVarInfo(AutomaticRedraw) \
	-labels [list [_ "All windows"] [_ "Current window"] [_ "None"]] \
	-values {"All windows" "Current window" "None"} \
	-state readonly


    GidHelp "$base.label#8 $base.menubutton#3" [_ "The option 'All' redraw all the windows,
	    'Current' only redraw the window with the focus, and
	    'None' avoid the redraws (must be util to work with large models)."]

    ttk::label $base.label#7 -text [_ "Popup messages"]:
    # ComboBoxRAM $base.menubutton#2 ChangeVarInfo(Usemorewindows) \
    #             [list [_ "Normal"] [_ "Beginner"]] {normal beginner}
    TTKComboBox $base.menubutton#2 -textvariable ::ChangeVarInfo(Usemorewindows) \
	-labels [list [_ "Normal"] [_ "Beginner"]] -values {normal beginner} \
	-state readonly

    GidHelp "$base.label#7 $base.menubutton#2" [_ "Depending on the selected
	    field, 'normal' or 'beginner', some options are asked to
	    the user inside a new window or with a message in the regular
	    messages window."]

    if { ![info exists ChangeVarInfo(LoadMeshingPrefOfModel)] } { set ChangeVarInfo(LoadMeshingPrefOfModel) 0 }
    ttk::checkbutton $base.checkLoadMeshingPrefOfModel -text [_ "Get meshing preferences from model"] -variable ChangeVarInfo(LoadMeshingPrefOfModel)
    GidHelp "$base.checkLoadMeshingPrefOfModel" [_ "If this option is set, when a model is loaded, its meshing preferences are loaded."]
	
	if { ![info exists ChangeVarInfo(Sound)] } { set ChangeVarInfo(Sound) 0 }
    ttk::checkbutton $base.checkSound -text [_ "Play sound"] -variable ChangeVarInfo(Sound)
    GidHelp "$base.checkSound" [_ "If this option is set, a sound is played to indicate a task has finished."]

	if { ![info exists ChangeVarInfo(SmallWinSelecting)] } { set ChangeVarInfo(SmallWinSelecting) 0 }
    ttk::checkbutton $base.checkSmallWinSelecting -text [_ "Shrink windows when selecting"] -variable ChangeVarInfo(SmallWinSelecting)
    GidHelp "$base.checkSmallWinSelecting" [_ "If this option is set, when selecting some windows are resized in order to facilitate the selection."]
	
    ttk::label $base.numOfRecentProjects -text [_ "Num of recent projects"]:
    ttk::spinbox $base.numOfRecentProjects_sb -from 1 -to 15 -increment 1 -width 8 \
	-textvariable ChangeVarInfo(MaxNumOfRecentProjects)
    GidHelp $base.numOfRecentProjects [_ "Number of recent projects in Files menu."]

    ttk::label $base.numOfRecentPostFiles -text [_ "Num of recent post files"]:
    ttk::spinbox $base.numOfRecentPostFiles_sb -from 1 -to 15 -increment 1 -width 8 \
	-textvariable ChangeVarInfo(MaxNumOfRecentPostFiles)
    GidHelp $base.numOfRecentPostFiles [_ "Number of recent post files in Files menu."]

    ttk::label $base.numOfRecentViewFiles -text [_ "Num of recent view files"]:
    ttk::spinbox $base.numOfRecentViewFiles_sb -from 1 -to 15 -increment 1 -width 8 \
	-textvariable ChangeVarInfo(MaxNumOfRecentViewFiles)
    GidHelp $base.numOfRecentViewFiles [_ "Number of recent view files in Files menu."]
    
    if { ![info exists ChangeVarInfo(ProgressBar)] } { set ChangeVarInfo(ProgressBar) 0 }
    ttk::checkbutton $base.checkProgressBar -text [_ "Embedded progress bar"] -variable ChangeVarInfo(ProgressBar)
    GidHelp "$base.checkProgressBar" [_ "If this option is set, the progress bar appears embedded."]

    if { ![info exists ChangeVarInfo(BackupCheck)] } { set ChangeVarInfo(BackupCheck) 0 }
    ttk::checkbutton $base.checkbutton#7 -text [_ "Backup time (min)"]: -variable ChangeVarInfo(BackupCheck)

    ttk::entry $base.entry#12 -textvariable ChangeVarInfo(BackupTime) -width 14

    GidHelp "$base.frame#2 \
	$base.checkbutton#7 $base.entry#12" \
	[_ "If this option is set, the model is saved automatically \
	    with the frequency given by the number of minutes\
	    \n'Note:' Mesh is not saved into the backup to save time."]

	if { ![info exists ChangeVarInfo(WriteBatchCheck)] } { set ChangeVarInfo(WriteBatchCheck) 0 }
    ttk::checkbutton $base.checkbutton#5 -text [_ "Write batch file"]: \
	-variable ChangeVarInfo(WriteBatchCheck)

    ttk::entry $base.entry#10 -textvariable ChangeVarInfo(WriteBatchFile) -width 14

    ttk::button $base.button#1 -command "OpenBrowserForBatch $base" -image [gid_themes::GetImage "folder.png" small_icons]

	if { ![info exists ChangeVarInfo(WriteRotationsInBatch)] } { set ChangeVarInfo(WriteRotationsInBatch) 0 }
    ttk::checkbutton $base.checkbutton#6 -text [_ "Write rotations in batch"] \
	    -variable ChangeVarInfo(WriteRotationsInBatch)

    GidHelp "$base.frame#1 $base.checkbutton#5 $base.entry#10 $base.button#1 \
	    $base.checkbutton#6" [_ "If this option is set, and a filename is\
	    given, all commands used during the current session are saved\
	    into this file. It can be executed later by means of a script\
	    file with the predefined commands to be run in the program\
	    (see 'Batch file').\
	    \nWith option 'Write rotations in batch' all dynamic rotations\
	    and movements are stored in the batch file. This permits to see\
	    these movements when reading this batch file with\
	    'Read batch window'."]

    
    set f [ttk::labelframe $base.gf -text [_ "Generic format"]]
    ttk::label $f.l1 -text [_ "Real format"]:
    ttk::entry $f.e1 -textvariable ChangeVarInfo(RealFormat,Default)
    GidHelp "$f.l1 $f.e1" [_ "Numeric format used for example when showing coordinates \
	    (see general preferences, display coordinates, list entities)"]

    grid $f.l1 $f.e1 -padx 2 -sticky e
    grid configure $f.e1 -sticky ew
    grid rowconfigure $f 0 -weight 1
    grid columnconfigure $f 1 -weight 1
    
    # state variables
    set frame $base.fst 
    if { ![info exists ::ChangeVarInfo(ReloadLastModel)] } { set ::ChangeVarInfo(ReloadLastModel) 0 }
    ttk::checkbutton $frame.cbReloadLastModel -text [_ "Reload last model"] -variable ::ChangeVarInfo(ReloadLastModel)
    setTooltip $frame.cbReloadLastModel [_ "If this option is set, the last model is reloaded at startup."]
    
    # set ::ChangeVarInfo(ReloadLastModel) [GiD_Set ReloadLastModel]
    # set ::ChangeVarInfo(SaveViewAutomatic) [GiD_Set SaveViewAutomatic]
    # set ::ChangeVarInfo(PostReadResultState) [GiD_Set PostReadResultState]
    if { ![ info exists ::ChangeVarInfo(SaveViewAutomatic)] } { set ::ChangeVarInfo(SaveViewAutomatic) 1 }
    ttk::checkbutton $frame.cbSaveViewAutomatic \
	-text [_ "Read and save view parameters of model or results files automatically"] \
	-variable ::ChangeVarInfo(SaveViewAutomatic)
    setTooltip $frame.cbSaveViewAutomatic \
	[_ "Enabling this option allows GiD to automatically 
read and save the current view parameters of the model or results files"]

    if { ![ info exists ::ChangeVarInfo(PostReadResultState)] } { set ::ChangeVarInfo(PostReadResultState) 1 }
    ttk::checkbutton $frame.cbPostReadResultState \
	-text  [_ "Read result visualization state"] \
	-variable ::ChangeVarInfo(PostReadResultState)
    setTooltip $frame.cbPostReadResultState \
	[_ "If checked, tries to draw the last visualized result for the model."]

    grid $frame.cbReloadLastModel -sticky w
    grid $frame.cbSaveViewAutomatic -sticky w
    grid $frame.cbPostReadResultState -sticky w


    # Geometry management

    grid $base.fr0 -in $base -sticky ewns -row 0 -column 1 -padx 2
    grid $base.fr1 -in $base -sticky ewns -row 1 -column 1 -padx 2
    grid $base.fr2 -in $base -sticky ewns -row 2 -column 1 -padx 2
    grid $base.fr3 -in $base -sticky ewns -row 3 -column 1 -padx 2
    grid $f -in $base -sticky ewns -row 4 -column 1 -padx 2
    grid $base.fr4 -in $base -sticky ewns -row 5 -column 1 -padx 2
    grid $base.fst -in $base -sticky ewns -row 6 -column 1 -padx 2

    grid columnconfigure $base 1 -weight 1

    if { $::MSGCAT_GID } {
	grid $base.label#10     -in $base.fr0 -row 0 -column 0 -sticky w
	grid $base.menubutton#4 -in $base.fr0 -row 0 -column 1 -sticky w -padx 2
    }
   
    grid $base.label#11     -in $base.fr4 -row 0 -column 0 -sticky w
    grid $base.numOfThreads_sb -in $base.fr4 -row 0 -column 1 -sticky w -padx 2
    
    #grid $base.checkbutton#1 -in $base.fr1 -sticky w -columnspan 2
    # grid $base.checkbutton#2 -in $base.fr1 -sticky w -columnspan 2
    grid $base.checkbutton\#2 -in $base.fr1 -sticky w -padx 4 -columnspan 2
    grid $base.cb_tooltip -in $base.fr1 -sticky w -padx 4 -columnspan 2
    grid $base.cb_icontext -in $base.fr1 -sticky w -padx 4 -columnspan 2

    # grid configure  $base.cb_icontext -sticky e
    #grid $base.checkbutton#22 -in $base.fr1 -sticky w -columnspan 2
    grid $base.label#4 $base.menubutton#1 -in $base.fr1 -sticky w
    grid $base.checkbutton#3 -in $base.fr1 -sticky w -columnspan 2
    grid $base.label#8 $base.menubutton#3 -in $base.fr1 -sticky w
    grid $base.label#7 $base.menubutton#2 -in $base.fr1  -sticky w

#     grid $base.checkLoadMeshingPrefOfModel -in $base.fr1 -sticky w -columnspan 2

    grid $base.checkSound -in $base.fr1  -sticky w -columnspan 2
    grid $base.checkSmallWinSelecting -in $base.fr1 -sticky w -columnspan 2
    grid $base.numOfRecentProjects $base.numOfRecentProjects_sb -in $base.fr1  -sticky w
    grid $base.numOfRecentPostFiles $base.numOfRecentPostFiles_sb -in $base.fr1  -sticky w
    grid $base.numOfRecentViewFiles $base.numOfRecentViewFiles_sb -in $base.fr1  -sticky w
    grid $base.checkProgressBar -in $base.fr1 -sticky w -columnspan 2

    grid columnconfigure $base.fr1 1 -weight 0 -minsize 30
    grid columnconfigure $base.fr1 2 -weight 1 -minsize 30

    grid $base.frame#2 -in $base.fr2 -columnspan 2 -row 1 -column 1 -sticky ew
    grid $base.checkbutton#7 -in $base.fr2        -row 2 -column 1  -sticky e
    grid $base.entry#12 -in $base.fr2        -row 2 -column 2  -sticky ew -padx 2

    grid columnconfigure $base.fr2 1 -weight 0 -minsize 30
    grid columnconfigure $base.fr2 2 -weight 1 -minsize 30

    grid $base.frame#1 -in $base.fr3 -columnspan 2 -row 1 -column 1  \
	    -sticky ew
    grid $base.checkbutton#6  -in $base.fr3     -row 2 -column 1 \
	    -sticky e

    grid columnconfigure $base.fr3 1 -weight 0 -minsize 30
    grid columnconfigure $base.fr3 2 -weight 1 -minsize 30

    grid $base.checkbutton#5 -in $base.frame#1        -row 1 -column 1
    grid $base.entry#10 -in $base.frame#1        -row 1 -column 2 -sticky ew  -padx 2
    grid $base.button#1 -in $base.frame#1        -row 1 -column 3 -padx 2

    grid rowconfigure $base.frame#1 1 -weight 0 -minsize 30
    grid columnconfigure $base.frame#1 1 -weight 0 -minsize 2
    grid columnconfigure $base.frame#1 2 -weight 1 -minsize 30
    grid columnconfigure $base.frame#1 3 -weight 0 -minsize 30

    grid rowconfigure $base.frame#2 1 -weight 0 -minsize 30
    grid columnconfigure $base.frame#2 1 -weight 0 -minsize 2
    grid columnconfigure $base.frame#2 2 -weight 1 -minsize 30
    grid columnconfigure $base.frame#2 3 -weight 0 -minsize 30

    AddToScrolledCanvas $base_base.sc $c.f
    grid $base_base.sc -sticky news
    grid rowconfigure $base_base 0 -weight 1
    grid columnconfigure $base_base 0 -weight 1

    # additional interface code

    trace add variable ChangeVarInfo(WriteBatchCheck) write BatchFileCheck
    set ChangeVarInfo(basew) $base

    proc BatchFileCheck { name1 name2 op } {
	global ChangeVarInfo
	if { ![info exists ChangeVarInfo(WriteBatchFile)] ||
	    $ChangeVarInfo(WriteBatchFile) == "" } {
	    set ChangeVarInfo(WriteBatchFile) batch
	}
	if { $ChangeVarInfo(WriteBatchCheck) == 1 } {
	    $ChangeVarInfo(basew).entry#10 configure -state normal
	    $ChangeVarInfo(basew).button#1 configure -state normal
	} else {
	    $ChangeVarInfo(basew).entry#10 configure -state disabled
	    $ChangeVarInfo(basew).button#1 configure -state disabled
	}
    }

    trace add variable ChangeVarInfo(BackupCheck) write BackupFileCheck

    proc BackupFileCheck { name1 name2 op } {
	global ChangeVarInfo
	
	if { $ChangeVarInfo(BackupCheck) == 1 } {
	    $ChangeVarInfo(basew).entry#12 configure -state normal
	
	    if { [catch {
		if { $ChangeVarInfo(BackupTime) <= 0 } {
		    set ChangeVarInfo(BackupTime) 20
		} elseif { $ChangeVarInfo(BackupTime) > 70000 } {
		    set ChangeVarInfo(BackupTime) 70000
		}
	    } ] } { set ChangeVarInfo(BackupTime) 20 }
	
	} else {
	    set ChangeVarInfo(BackupTime) 0
	    $ChangeVarInfo(basew).entry#12 configure -state disabled
	}
    }

    proc OpenBrowserForBatch { w } {
	global ChangeVarInfo
	set types [list \
	    [list [_ "Batch file"] [list .bch]] \
	    [list [_ "All files"] .*]]
	set ChangeVarInfo(WriteBatchFile) [Browser-ramR file write $w [_ "write batch file"] \
	    $ChangeVarInfo(WriteBatchFile) $types .bch 0]
    }
}
