﻿<?xml version="1.0" encoding="utf-8"?><!-- -*- coding: utf-8;-*- -->
<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
xmlns:svg="http://www.w3.org/2000/svg"
>
  <xsl:output method = "xml" indent = "yes" />

  <xsl:param name='language' select='en'/>
  <xsl:param name='base_path' select='none'/>
  <xsl:param name='page' select='none'/>
  <xsl:param name='from_formatted_param' select='0'/>
  <!--   this can be: none, new, edit, denied, response, profile or incidence -->
  <xsl:param name='form_type' select='none'/>
  
  <xsl:param name='form_dialog' select='0'/>
  <xsl:param name='a_n' select='Accept'/>
  <xsl:param name='e_n' select='Edit'/>
  <xsl:param name='r_n' select='Reset'/>
  <xsl:param name='rj_n' select='Reject'/>
  <xsl:param name='c_n' select='Cancel'/>
  <xsl:param name='cl_n' select='Close'/>
  <xsl:param name='eP_n'/>
  <xsl:param name='db_n_n' select='Create'/>
  <xsl:param name='db_d_n' select='Delete'/>
  <xsl:param name='db_e_n' select='Export'/>
  <xsl:param name='db_load_admin_n'/>
  <xsl:param name='db_load_user_n'/>
  
  <xsl:param name='edit_choose_name'/>
  <xsl:param name='edit_choose_value'/>
  <xsl:param name='edit_choose_id'/>

  <xsl:param name='db_view' select='0'/>
  <xsl:param name='selection_mode' select='0'/>
  
  <xsl:template name='att'>
    <xsl:for-each select="@*">
      <xsl:attribute name="{translate(name(),'ABCDEFGHIJKLMNOPQRSTUVWXYZ',
		                         'abcdefghijklmnopqrstuvwxyz')}">
        <xsl:value-of select="."/>
      </xsl:attribute>
    </xsl:for-each>
    <xsl:apply-templates/>
  </xsl:template>

  <!-- The Identity Transformation -->
  <!-- Whenever you match any node or any attribute -->
  <xsl:template match="node()|@*">
    <!-- Copy the current node -->
    <xsl:copy>
      <!-- Including any attributes it has and any child nodes -->
      <xsl:apply-templates select="@*|node()"/>
    </xsl:copy>
  </xsl:template>

  <xsl:template match="@*">
    <!-- Create the same element with a lowercase name -->
    <xsl:attribute name="{translate(name(),'ABCDEFGHIJKLMNOPQRSTUVWXYZ',
		                         'abcdefghijklmnopqrstuvwxyz')}">
      <!-- Including any attributes it has and any child nodes -->
      <xsl:apply-templates select="@*|node()"/>
      <xsl:value-of select="."/>
    </xsl:attribute>
  </xsl:template>

  <!-- When you match any element -->
  <xsl:template match="*">
    <!-- Create the same element with a lowercase name -->
    <xsl:element name="{translate(local-name(),'ABCDEFGHIJKLMNOPQRSTUVWXYZ',
		                         'abcdefghijklmnopqrstuvwxyz')}">
      <!-- Including any attributes it has and any child nodes -->
      <xsl:apply-templates select="@*|node()"/>
    </xsl:element>
  </xsl:template>

  <xsl:template match="/*">
    <div>
      <xsl:if test="title != '' and not((//text())[1]/parent::emphasis[@role='warning' or @role='status' or @role='status warning'])
                    and not(//formulae) and not(//login_menu)">
        <h3 class="header contents">
          <xsl:value-of select="title"/>
        </h3>
      </xsl:if>
      <xsl:call-template name='att'/>
    </div>
  </xsl:template>

  <xsl:template match="lognoter[formulae/@only_form_view_mode='1']">
    <div>
      <xsl:apply-templates select="formulae"/>
    </div>
  </xsl:template>

  <xsl:template match="section">
    <h1>
      <xsl:value-of select="title"/>
    </h1>
    <xsl:call-template name='att'/>
  </xsl:template>

  <xsl:template match="itemizedlist">
    <ul>
      <xsl:call-template name='att'/>
    </ul>
  </xsl:template>

  <xsl:template match="listitem">
    <li>
      <xsl:call-template name='att'/>
    </li>
  </xsl:template>

  <xsl:template match="row">
    <tr>
      <xsl:call-template name='att'/>
    </tr>
  </xsl:template>

  <xsl:template name='lindex'>
    <xsl:param name="list"/>
    <xsl:param name="position"/>
    <xsl:choose>
      <xsl:when test = "$position &gt; 0">
        <xsl:call-template name="lindex">
          <xsl:with-param name="list" select="substring-after($list,' ')"/>
          <xsl:with-param name="position" select="-1+$position"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:when test = "contains($list,' ')">
        <xsl:value-of select="substring-before($list,' ')"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$list"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  
  <xsl:template match="entry">

    <xsl:variable name="entry_type">
      <xsl:choose>
        <xsl:when test=".//para/mediaobject/imageobject or .//para/ulink/mediaobject/imageobject">entry image</xsl:when>
        <xsl:otherwise>entry</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <td class="{$entry_type}" bgcolor="{@bgcolor}">
       <xsl:attribute name="width">
        <xsl:call-template name="lindex">
          <xsl:with-param name="list" select="ancestor::table[1]/@relativesizes"/>
          <xsl:with-param name="position" select="position()"/>
        </xsl:call-template>
        <xsl:text>%</xsl:text>
      </xsl:attribute>
      <xsl:apply-templates>
        <xsl:with-param name="position" select="position()"/>
      </xsl:apply-templates>
    </td>
  </xsl:template>                          

  <xsl:template match="para[emphasis[@role='header']]">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="para">
    <xsl:choose>
      <xsl:when test = ".//table[1]">
        <xsl:param name="position"/>
        <xsl:choose>
          <xsl:when test = "parent::entry/@cols_justify">
            <xsl:attribute name="class">
              <xsl:call-template name="lindex">
                <xsl:with-param name="list" select="parent::entry/@cols_justify"/>
                <xsl:with-param name="position" select="0"/>
              </xsl:call-template>
            </xsl:attribute>
          </xsl:when>
          <xsl:when test = "parent::entry/parent::row/@cols_justify">
            <xsl:attribute name="class">
              <xsl:call-template name="lindex">
                <xsl:with-param name="list" select="parent::entry/parent::row/@cols_justify"/>
                <xsl:with-param name="position" select="-1+$position"/>
              </xsl:call-template>
            </xsl:attribute>
          </xsl:when>
          <xsl:when test = "parent::entry/parent::row/parent::table/@cols_justify">
            <xsl:attribute name="class">
              <xsl:call-template name="lindex">
                <xsl:with-param name="list" select="parent::entry/parent::row/parent::table/@cols_justify"/>
                <xsl:with-param name="position" select="-1+$position"/>
              </xsl:call-template>
            </xsl:attribute>
          </xsl:when>
        </xsl:choose>
        <xsl:call-template name='att'/>
      </xsl:when>
      <xsl:otherwise>
        <p>
          <xsl:choose>
            <xsl:when test = ".//mediaobject[1]/imageobject/imagedata/@align or .//ulink[1]/mediaobject/imageobject/@align">
              <xsl:attribute name="class">
                <xsl:choose>
                  <xsl:when test= ".//mediaobject[1]/imageobject/imagedata/@align = 'center'">
                    <xsl:text>image center</xsl:text>
                  </xsl:when>
                  <xsl:when test= ".//mediaobject[1]/imageobject/imagedata/@align = 'right'">
                    <xsl:text>image right</xsl:text>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:text>image left</xsl:text>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:attribute>
            </xsl:when>
          </xsl:choose>
          <xsl:call-template name='att'/>
        </p>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="emphasis">
    <xsl:choose>
      <xsl:when test = "@role='header' and (text() or node())">
        <h3 class="header">
          <xsl:call-template name='att'/>
        </h3>
      </xsl:when>
      <xsl:when test = "@role = 'strong'">
        <b>
          <xsl:call-template name='att'/>
        </b>
      </xsl:when>
      <xsl:when test = "@role = 'italic'">
        <i>
          <xsl:call-template name='att'/>
        </i>
      </xsl:when>
       <xsl:when test = "@role = 'missing_translation'">
        <i class="missingTranslation">
          <xsl:call-template name='att'/>
        </i>
      </xsl:when>
      <xsl:when test = "@role = 'warning'">
        <i class="warning">
          <xsl:call-template name='att'/>
        </i>
      </xsl:when>
      <xsl:when test = "@role = 'status'">
        <i class="status">
          <xsl:call-template name='att'/>
        </i>
      </xsl:when>
      <xsl:when test = "@role = 'status warning'">
        <i class="status_warning">
          <xsl:call-template name='att'/>
        </i>
      </xsl:when>
      <xsl:otherwise>
        <xsl:call-template name='att'/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="sub|subscript">
    <sub>
      <xsl:call-template name='att'/>
    </sub>
  </xsl:template>

  <xsl:template match="sup|superscript">
    <sup>
      <xsl:call-template name='att'/>
    </sup>
  </xsl:template>

  <xsl:template name='url-parameter'>
    <xsl:param name="url" />
    <xsl:param name="param-name"/>

    <xsl:variable name='tmp' select="substring-after($url,concat($param-name,'='))"/>
    <xsl:choose>
      <xsl:when test="substring-before($tmp,'&amp;') != ''">
        <xsl:value-of select="substring-before($tmp,'&amp;')"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="$param-name = 'width' and $tmp = ''">
            <xsl:text>400</xsl:text>
          </xsl:when>
          <xsl:when test="$param-name = 'height' and $tmp = ''">
            <xsl:text>300</xsl:text>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$tmp"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  
  <xsl:template name='url-add-parameter'>
    <xsl:param name="url"/>
    <xsl:param name="param-name"/>
    <xsl:param name="param-value"/>

    <xsl:variable name="url-video">
      <xsl:choose>
        <xsl:when test="contains($param-name,',')">
          <xsl:choose>
            <xsl:when test="not(contains($url,'?'))"> 
              <xsl:value-of select="concat($url,'?',substring-before($param-name,','),'=',substring-before($param-value,','))"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="concat($url,'&amp;',substring-before($param-name,','),'=',substring-before($param-value,','))"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:when>
        <xsl:otherwise>
          <xsl:choose>
            <xsl:when test="not(contains($url,'?'))">
              <xsl:value-of select="concat($url,'?',$param-name,'=',$param-value)"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="concat($url,'&amp;',$param-name,'=',$param-value)"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:choose>
      <xsl:when test="contains($param-name,',')">
        <xsl:call-template name='url-add-parameter'>
          <xsl:with-param name="url" select="$url-video"/>
          <xsl:with-param name="param-name" select="substring-after($param-name,',')"/>
          <xsl:with-param name="param-value" select="substring-after($param-value,',')"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise><xsl:value-of select="$url-video"/></xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template name='url-remove-parameter'>
    <xsl:param name="url" />
    <xsl:param name="param-name"/>

    <xsl:choose>
      <xsl:when test="substring-before($url,concat($param-name,'=')) = ''">
        <xsl:value-of select="$url"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:variable name='tmp1'>
          <xsl:choose>
            <xsl:when test="substring-before($url,concat('?',$param-name,'=')) != ''">
              <xsl:value-of select="substring-before($url,concat('?',$param-name,'='))"/>
            </xsl:when>
            <xsl:when test="substring-before($url,concat('&amp;',$param-name,'=')) != ''">
              <xsl:value-of select="substring-before($url,concat('&amp;',$param-name,'='))"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="substring-before($url,concat($param-name,'='))"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>
        <xsl:variable name='tmp2' select="substring-after(substring-after($url,concat($param-name,'=')),'&amp;')"/>
        <xsl:choose>
          <xsl:when test="$tmp2 = ''">
            <xsl:value-of select="$tmp1"/>
          </xsl:when>
          <xsl:when test="not(contains($tmp1,'?'))">
            <xsl:value-of select="concat($tmp1,'?',$tmp2)"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="concat($tmp1,'&amp;',$tmp2)"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template name="url-substring-after-last">
    <xsl:param name="url"/>
    <xsl:param name="delimiter"/>

    <xsl:choose>
      <xsl:when test="contains($url, $delimiter)">
        <xsl:call-template name="url-substring-after-last">
          <xsl:with-param name="url" select="substring-after($url, $delimiter)"/>
          <xsl:with-param name="delimiter" select="$delimiter"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$url"/>
      </xsl:otherwise>
    </xsl:choose>

  </xsl:template>

  <xsl:template match="ulink">

    <xsl:choose>

      <xsl:when test="@linktype='url' or @linktype='url_ext'">

        <xsl:variable name="url">
          <xsl:choose>
            <xsl:when test="not(contains(@url, 'http://')) and not(contains(@url, 'https://')) and contains(@url, 'www')">
              <xsl:text>http://</xsl:text>
              <xsl:value-of select="@url"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="@url"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>

        <xsl:choose>

          <xsl:when test="contains($url,'www.youtube.com') or contains($url,'youtu.be') or contains($url,'player.youku.com') or contains($url,'v.youku.com')">

            <xsl:variable name="url-video">
              <xsl:call-template name='url-add-parameter'>
                <xsl:with-param name="url">
                  <xsl:call-template name='url-remove-parameter'>
                    <xsl:with-param name="url">
                      <xsl:call-template name='url-remove-parameter'>
                        <xsl:with-param name="url" select="$url"/>
                        <xsl:with-param name="param-name" select="'width'"/>
                      </xsl:call-template>
                    </xsl:with-param>
                    <xsl:with-param name="param-name" select="'height'"/>
                  </xsl:call-template>
                </xsl:with-param>
                <xsl:with-param name="param-name" select="'fs,autohide,showinfo,modestbranding,border,theme'"/>
                <xsl:with-param name="param-value" select="'1,0,0,1,1,light'"/>
              </xsl:call-template>
            </xsl:variable>

            <xsl:variable name="url-video-tail">
              <xsl:call-template name='url-substring-after-last'>
                <xsl:with-param name="url" select="substring-before(substring-after($url-video, '/'), '?')"/>
                <xsl:with-param name="delimiter" select="'/'"/>
              </xsl:call-template>
            </xsl:variable>

            <xsl:variable name="url-video-id">
              <xsl:choose>
                <xsl:when test="$url-video-tail = 'watch'">
                  <xsl:value-of select="substring-after($url, '?v=')"/>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:value-of select="$url-video-tail"/>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:variable>

            <xsl:variable name="url-video-width">
              <xsl:call-template name='url-parameter'>
                <xsl:with-param name="url" select="$url"/>
                <xsl:with-param name="param-name" select="'width'"/>
              </xsl:call-template>
            </xsl:variable>

            <xsl:variable name="url-video-height">
              <xsl:call-template name='url-parameter'>
                <xsl:with-param name="url" select="$url"/>
                <xsl:with-param name="param-name" select="'height'"/>
              </xsl:call-template>
            </xsl:variable>

            <xsl:choose>

              <xsl:when test="contains(text(),'www.youtube.com/embed/') or contains(text(),'player.youku.com/embed/')">

                <xsl:choose>

                  <xsl:when test="@linktype = 'url'">

                    <xsl:choose>

                      <xsl:when test="not(@ref_contents) or @ref_contents = '0'">

                        <div class="object video" style="width: {$url-video-width}px;height: {$url-video-height}px;margin: 40px auto 50px;border: 12px solid #cbcbcb;border-radius: 15px;">
                          <iframe src="{$url-video}" type="application/x-shockwave-flash" linktype="{@linktype}" class="video" frameborder="0"
                                  allowfullscreen="true" allowscriptaccess="always" width="{$url-video-width}" height="{$url-video-height}">
                          </iframe>
                        </div>
                        
                      </xsl:when>

                      <xsl:otherwise>

                        <div class="object video">
                          <object width="{$url-video-width}" height="{$url-video-height}">
                            <embed src="{$url-video}" type="application/x-shockwave-flash" linktype="{@linktype}" class="video"
                                   allowfullscreen="true" allowscriptaccess="always" width="{$url-video-width}" height="{$url-video-height}">
                            </embed>
                          </object>
                        </div>
                        
                      </xsl:otherwise>

                    </xsl:choose>

                  </xsl:when>

                  <xsl:otherwise>

                    <xsl:choose>

                      <xsl:when test="contains(text(),'www.youtube.com/embed/')">

                        <xsl:variable name="videoPlayerStyle">
                          height: <xsl:value-of select="$url-video-height"/>px;width: <xsl:value-of select="$url-video-width"/>px;background: #CBCBCB;
                          margin: 40px auto 60px;cursor: pointer;position: relative;border: 12px solid #cbcbcb;border-radius: 15px;display:block;
                          background: #CBCBCB url('//i1.ytimg.com/vi/<xsl:value-of select="$url-video-id"/>/0.jpg') no-repeat center;overflow: hidden;
                          -webkit-background-size: cover;-moz-background-size: cover;-o-background-size: cover;background-size: cover;

                        </xsl:variable>

                        <xsl:variable name="videoPlayerNStyle">
                          <xsl:value-of select="normalize-space($videoPlayerStyle)"/>
                        </xsl:variable>

                        <xsl:variable name="videoPlayerHoverScript">
                          function play_main_video_hover_<xsl:value-of select="@n"/>() {
                            if (document.getElementById('play_button_main_video_<xsl:value-of select="@n"/>')) {
                               document.getElementById('play_button_main_video_<xsl:value-of select="@n"/>').setAttribute('class', 'play hover');
                            }
                          }
                        </xsl:variable>

                        <xsl:variable name="videoPlayerUnHoverScript">
                          function play_main_video_unhover_<xsl:value-of select="@n"/>() {
                            if (document.getElementById('play_button_main_video_<xsl:value-of select="@n"/>')) {
                               document.getElementById('play_button_main_video_<xsl:value-of select="@n"/>').setAttribute('class', 'play');
                            }
                          }
                        </xsl:variable>

                        <div class="object video">
                          <a href='{$url}' target="_blank">
                            <div id="ytplayer_main_{@n}" style="{$videoPlayerNStyle}" onMouseEnter="play_main_video_hover_{@n}();" onMouseLeave="play_main_video_unhover_{@n}();">
                              <div id="play_button_main_video_{@n}" class="play" style="top: 38%;left: 45%"></div>
                            </div>
                            <script type="text/javascript">
                              <xsl:value-of select="normalize-space($videoPlayerHoverScript)"/>
                            </script>
                            <script type="text/javascript">
                              <xsl:value-of select="normalize-space($videoPlayerUnHoverScript)"/>
                            </script>
                          </a>
                        </div>

                      </xsl:when>

                      <xsl:otherwise>

                        <a href='{$url}' target="_blank">
                          <xsl:apply-templates/>
                        </a>

                      </xsl:otherwise>

                    </xsl:choose>

                  </xsl:otherwise>

                </xsl:choose>

              </xsl:when>

              <xsl:when test = "mediaobject/imageobject/imagedata">

                <xsl:variable name="videoPlayerImageSource">
                  <xsl:choose>
                    <xsl:when test="substring(mediaobject/imageobject/imagedata/@fileref,1,8)='local://'">
                      <xsl:value-of select="concat($base_path,'/img/',substring-after(mediaobject/imageobject/imagedata/@fileref,'local://'))"/>
                    </xsl:when>
                    <xsl:when test = "substring(mediaobject/imageobject/imagedata/@fileref,1,11)='internal://'">
                      <xsl:value-of select="concat($base_path,'/imgi/',substring-after(mediaobject/imageobject/imagedata/@fileref,'internal://'))"/>
                    </xsl:when>
                    <xsl:when test = "substring(mediaobject/imageobject/imagedata/@fileref,1,15)='data:image/jpeg'">
                      <xsl:value-of select="concat($base_path,'/imgp/',$page,'/',count(preceding::imageobject/imagedata[@fileref])+1,'.jpeg')"/>
                    </xsl:when>
                    <xsl:when test = "substring(mediaobject/imageobject/imagedata/@fileref,1,14)='data:image/png'">
                      <xsl:value-of select="concat($base_path,'/imgp/',$page,'/',count(preceding::imageobject/imagedata[@fileref])+1,'.png')"/>
                    </xsl:when>
                    <xsl:when test = "substring(mediaobject/imageobject/imagedata/@fileref,1,14)='data:image/gif'">
                      <xsl:value-of select="concat($base_path,'/imgp/',$page,'/',count(preceding::imageobject/imagedata[@fileref])+1,'.gif')"/>
                    </xsl:when>
                    <xsl:otherwise>
                      <!--  nothing at the moment -->
                    </xsl:otherwise>
                  </xsl:choose>
                </xsl:variable>

                <xsl:variable name="videoPlayerStyle">
                  height: <xsl:value-of select="$url-video-height"/>px;width: <xsl:value-of select="$url-video-width"/>px;background: #CBCBCB;
                  margin: 40px auto 60px;border: 12px solid #cbcbcb;border-radius: 15px;display:block;cursor: pointer;position: relative;
                  background: #CBCBCB url('<xsl:value-of select="$videoPlayerImageSource"/>') no-repeat center;-webkit-background-size: cover;
                  -moz-background-size: cover;-o-background-size: cover;background-size: cover;overflow: hidden;

                </xsl:variable>

                <xsl:variable name="videoPlayerNStyle">
                  <xsl:value-of select="normalize-space($videoPlayerStyle)"/>
                </xsl:variable>

                <xsl:variable name="videoEmbedSrc">
                  <xsl:choose>
                    <xsl:when test="contains($url,'www.youtube.com') or contains($url,'youtu.be')">
                      <xsl:text>http://www.youtube.com/embed/</xsl:text>
                      <xsl:value-of select="$url-video-id"/>
                    </xsl:when>
                    <xsl:when test="contains($url,'player.youku.com') or contains($url,'v.youku.com')">
                      <xsl:text>http://player.youku.com/embed/</xsl:text>
                      <xsl:value-of select="$url-video-id"/>
                    </xsl:when>
                    <xsl:otherwise>
                      <xsl:value-of select="$url-video"/>
                    </xsl:otherwise>
                  </xsl:choose>
                </xsl:variable>

                <xsl:variable name="videoPlayerScript">
                  function play_main_video_<xsl:value-of select="@n"/>() {
                      document.getElementById('ytplayer_main_<xsl:value-of select="@n"/>').innerHTML = "&lt;iframe width='<xsl:value-of select="$url-video-width"/>' height='<xsl:value-of select="$url-video-height"/>' src='<xsl:value-of select="$videoEmbedSrc"/>' frameborder='0'&gt;&lt;/iframe&gt;";
                  }
                </xsl:variable>

                <xsl:variable name="videoPlayerHoverScript">
                  function play_main_video_hover_<xsl:value-of select="@n"/>() {
                    if (document.getElementById('play_button_main_video_<xsl:value-of select="@n"/>')) {
                       document.getElementById('play_button_main_video_<xsl:value-of select="@n"/>').setAttribute('class', 'play hover');
                    }
                  }
                </xsl:variable>

                <xsl:variable name="videoPlayerUnHoverScript">
                  function play_main_video_unhover_<xsl:value-of select="@n"/>() {
                    if (document.getElementById('play_button_main_video_<xsl:value-of select="@n"/>')) {
                       document.getElementById('play_button_main_video_<xsl:value-of select="@n"/>').setAttribute('class', 'play');
                    }
                  }
                </xsl:variable>

                <xsl:choose>

                  <xsl:when test="not(@ref_contents) or @ref_contents = '0'">

                    <xsl:choose>

                      <xsl:when test="@linktype='url'">

                        <div class="object video">
                          <div id="ytplayer_main_{@n}" style="{$videoPlayerNStyle}" onclick="play_main_video_{@n}();" onMouseEnter="play_main_video_hover_{@n}();" onMouseLeave="play_main_video_unhover_{@n}();">
                            <div id="play_button_main_video_{@n}" class="play" style="top: 38%;left: 45%"></div>
                          </div>
                          <script type="text/javascript">
                            <xsl:value-of select="normalize-space($videoPlayerScript)"/>
                          </script>
                          <script type="text/javascript">
                            <xsl:value-of select="normalize-space($videoPlayerHoverScript)"/>
                          </script>
                          <script type="text/javascript">
                            <xsl:value-of select="normalize-space($videoPlayerUnHoverScript)"/>
                          </script>
                        </div>

                      </xsl:when>

                      <xsl:otherwise>

                        <div class="object video">
                          <a href='{$url}'>
                            <xsl:if test="@linktype='url_ext'">
                              <xsl:attribute name="target">_blank</xsl:attribute>
                            </xsl:if>
                            <div id="ytplayer_main_{@n}" style="{$videoPlayerNStyle}" onMouseEnter="play_main_video_hover_{@n}();" onMouseLeave="play_main_video_unhover_{@n}();">
                              <div id="play_button_main_video_{@n}" class="play" style="top: 38%;left: 45%"></div>
                            </div>
                            <script type="text/javascript">
                              <xsl:value-of select="normalize-space($videoPlayerHoverScript)"/>
                            </script>
                            <script type="text/javascript">
                              <xsl:value-of select="normalize-space($videoPlayerUnHoverScript)"/>
                            </script>
                          </a>
                        </div>

                      </xsl:otherwise>

                    </xsl:choose>

                  </xsl:when>

                  <xsl:otherwise>

                    <div class="object video">
                      <object>
                        <embed src="{$url-video}" type="application/x-shockwave-flash" linktype="{@linktype}" class="video"
                               img_src="{$videoPlayerImageSource}" allowfullscreen="true" allowscriptaccess="always"
                               width="{$url-video-width}" height="{$url-video-height}">
                        </embed>
                      </object>
                    </div>

                  </xsl:otherwise>

                </xsl:choose>

              </xsl:when>

              <xsl:otherwise>

                <xsl:choose>

                  <xsl:when test="not(@ref_contents) or @ref_contents = '0'">

                    <a href='{$url}'>
                      <xsl:if test="@linktype='url_ext'">
                        <xsl:attribute name="target">_blank</xsl:attribute>
                      </xsl:if>
                      <xsl:apply-templates/>
                    </a>

                  </xsl:when>

                  <xsl:otherwise>

                    <xsl:choose>

                      <xsl:when test="contains(text(),'youtube.com') or contains(text(),'youtu.be') or contains(text(),'youku.com')">

                        <div class="object video">
                          <object>
                            <embed src="{$url-video}" type="application/x-shockwave-flash" linktype="{@linktype}" class="video"
                                   allowfullscreen="true" allowscriptaccess="always" width="{$url-video-width}" height="{$url-video-height}">
                            </embed>
                          </object>
                        </div>

                      </xsl:when>

                      <xsl:otherwise>

                        <a href='{$url}'>
                          <xsl:if test="@linktype='url_ext'">
                            <xsl:attribute name="target">_blank</xsl:attribute>
                          </xsl:if>
                          <xsl:apply-templates/>
                        </a>

                      </xsl:otherwise>
                      
                    </xsl:choose>

                  </xsl:otherwise>

                </xsl:choose>

              </xsl:otherwise>

            </xsl:choose>

          </xsl:when>

          <xsl:when test="contains($url,'javascript: ')">

            <xsl:variable name="javascript_url">
              <xsl:value-of select="substring-after($url, 'javascript: ')"/>
            </xsl:variable>

            <button class="javascript" data-dojo-type="dijit.form.Button" data-dojo-props="type:'button', tabindex:'-1'">
              <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                <xsl:value-of select="substring-after($url, 'javascript: ')"/>
              </script>
              <a href="javascript:void(0)" class="javascript">
                <xsl:if test="@linktype='url_ext'">
                  <xsl:attribute name="target">_blank</xsl:attribute>
                </xsl:if>
                <xsl:apply-templates/>
              </a>
            </button>

          </xsl:when>

          <xsl:otherwise>

            <a href='{$url}'>
              <xsl:if test="@linktype='url_ext'">
                <xsl:attribute name="target">_blank</xsl:attribute>
              </xsl:if>
              <xsl:apply-templates/>
            </a>
            
          </xsl:otherwise>
          
        </xsl:choose>

      </xsl:when>

      <xsl:when test = "@linktype='local' or @linktype='local_ext'">
        <xsl:if test="@exists='0'">
          <font color="red">[</font>
        </xsl:if>
        <a href="{concat($base_path,'/',translate(@url,'&gt;','/'))}">
          <xsl:if test="@linktype='local_ext'">
            <xsl:attribute name="target">_blank</xsl:attribute>
          </xsl:if>
          <xsl:apply-templates/>
        </a>
        <xsl:if test="@exists='0'">
          <font color="red">]</font>
        </xsl:if>
      </xsl:when>

      <xsl:when test = "@linktype='localfile'">
        <a href="{concat($base_path,'/','intfile/',translate(@url,'&gt;','/'))}">
          <xsl:apply-templates/>
        </a>
      </xsl:when>

      <xsl:otherwise>
        <xsl:copy>
          <xsl:call-template name='att'/>
        </xsl:copy>
      </xsl:otherwise>

    </xsl:choose>
  </xsl:template>

  <xsl:template match="mediaobject">
    <xsl:choose>
      <xsl:when test="$from_formatted_param = '0'">
        <xsl:choose>
          <xsl:when test = "substring(imageobject/imagedata/@fileref,1,8)='local://'">
            <img src="{concat($base_path,'/img/',substring-after(imageobject/imagedata/@fileref,'local://'))}" align="middle" title="{caption}">
              <xsl:attribute name="width">
                <xsl:choose>
                  <xsl:when test="imageobject/imagedata/@width != ''">
                    <xsl:value-of select="imageobject/imagedata/@width"/>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:if test="ancestor::table">
                       <xsl:text>80%</xsl:text>
                    </xsl:if>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:attribute>
            </img>
          </xsl:when>
          <xsl:when test = "substring(imageobject/imagedata/@fileref,1,11)='internal://'">
            <img src="{concat($base_path,'/imgi/',substring-after(imageobject/imagedata/@fileref,'internal://'))}" align="middle">
              <xsl:attribute name="width">
                <xsl:choose>
                  <xsl:when test="imageobject/imagedata/@width != ''">
                    <xsl:value-of select="imageobject/imagedata/@width"/>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:if test="ancestor::table">
                       <xsl:text>80%</xsl:text>
                    </xsl:if>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:attribute>
            </img>
          </xsl:when>
          <xsl:when test = "substring(imageobject/imagedata/@fileref,1,15)='data:image/jpeg'">
            <img src="{concat($base_path,'/imgp/',$page,'/',count(preceding::imagedata[@fileref])+1,'.jpeg')}" align="middle">
              <xsl:attribute name="width">
                <xsl:choose>
                  <xsl:when test="imageobject/imagedata/@width != ''">
                    <xsl:value-of select="imageobject/imagedata/@width"/>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:if test="ancestor::table">
                       <xsl:text>80%</xsl:text>
                    </xsl:if>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:attribute>
            </img>
          </xsl:when>
          <xsl:when test = "substring(imageobject/imagedata/@fileref,1,14)='data:image/png'">
            <img src="{concat($base_path,'/imgp/',$page,'/',count(preceding::imagedata[@fileref])+1,'.png')}" align="middle">
              <xsl:attribute name="width">
                <xsl:choose>
                  <xsl:when test="imageobject/imagedata/@width != ''">
                    <xsl:value-of select="imageobject/imagedata/@width"/>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:if test="ancestor::table">
                       <xsl:text>80%</xsl:text>
                    </xsl:if>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:attribute>
            </img>
          </xsl:when>
          <xsl:when test = "substring(imageobject/imagedata/@fileref,1,14)='data:image/gif'">
            <img src="{concat($base_path,'/imgp/',$page,'/',count(preceding::imagedata[@fileref])+1,'.gif')}" align="middle">
              <xsl:attribute name="width">
                <xsl:choose>
                  <xsl:when test="imageobject/imagedata/@width != ''">
                    <xsl:value-of select="imageobject/imagedata/@width"/>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:if test="ancestor::table">
                       <xsl:text>80%</xsl:text>
                    </xsl:if>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:attribute>
            </img>
          </xsl:when>
          <xsl:when test = "imageobject/svg:svg">
            <object data="{concat($base_path,'/svg/',$page,'/',count(preceding::svg:svg)+1,'.svg')}"
                    type="image/svg+xml" width="350" height="350">
              <xsl:if test = "imageobject/svg:svg/@width != ''">
                <xsl:attribute name="width">
                  <xsl:value-of select="imageobject/svg:svg/@width"/>
                </xsl:attribute>
              </xsl:if>
              <xsl:if test = "imageobject/svg:svg/@height != ''">
                <xsl:attribute name="height">
                  <xsl:value-of select="imageobject/svg:svg/@height"/>
                </xsl:attribute>
              </xsl:if>
              <img src="{concat($base_path,'/svg/',$page,'/',count(preceding::svg:svg)+1,'.png')}" width="350" height="350">
                <xsl:if test = "imageobject/svg:svg/@width != ''">
                  <xsl:attribute name="width">
                    <xsl:value-of select="imageobject/svg:svg/@width"/>
                  </xsl:attribute>
                </xsl:if>
                <xsl:if test = "imageobject/svg:svg/@height != ''">
                  <xsl:attribute name="height">
                    <xsl:value-of select="imageobject/svg:svg/@height"/>
                  </xsl:attribute>
                </xsl:if>
              </img>
            </object>
          </xsl:when>
          <xsl:otherwise>
            <img src="{imageobject/imagedata/@fileref}" align="middle" title="{caption}">
              <xsl:attribute name="width">
                <xsl:choose>
                  <xsl:when test="imageobject/imagedata/@width != ''">
                    <xsl:value-of select="imageobject/imagedata/@width"/>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:if test="ancestor::table">
                       <xsl:text>80%</xsl:text>
                    </xsl:if>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:attribute>
            </img>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-templates/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="cl_button">
    <table class="formButtons non-form">
      <td class="B_Cl">
        <button data-dojo-type="dijit.form.Button" data-dojo-props="type:'button', tabindex:'-1'">
          <xsl:value-of select="$cl_n"/>
          <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
            dijit.byId('dialog').hide();
          </script>
        </button>
      </td>
    </table>
  </xsl:template>

  <xsl:template match="formulae">

    <script type="text/javascript">
      if (typeof _tableWidgetStorage == 'undefined') { _tableWidgetStorage = new Array(); }
    </script>
    <script type="text/javascript">
      if (typeof _chartWidgetStorage == 'undefined') { _chartWidgetStorage = new Array(); }
    </script>
    <script type="text/javascript">
      if (typeof _optionsTreeWidgetStorage == 'undefined') { _optionsTreeWidgetStorage = new Array(); }
    </script>
    
    <xsl:variable name="formClass">
      <xsl:choose>
        <xsl:when test="@chart = '1'">
          <xsl:text>dialogChart</xsl:text>
        </xsl:when>
        <xsl:otherwise>
          <xsl:text></xsl:text>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:choose>

      <xsl:when test="$form_type != 'response'">

        <xsl:variable name="Page">
          <xsl:value-of select='translate($page," >","_-")'/>
        </xsl:variable>

        <xsl:if test="($form_type = 'new' or $form_type = 'edit') and $selection_mode = '0'">

          <!-- Form updating script -->

          <xsl:variable name="updateScript">
            function update(){
              formUpdate (this.id, this.class, this.value);
            }
          </xsl:variable>
          <script type="text/javascript">
            <xsl:value-of select="normalize-space($updateScript)"/>
          </script>

          <xsl:variable name="dialogUpdateScript">
            function dialogUpdate(){
              if (this.id == 'd_chart_selection') {
                 formDialogChartUpdate (this.id, this.value);
              } else {
                 formDialogUpdate (this.id, this.value);
              }
            }
          </xsl:variable>
          <script type="text/javascript">
            <xsl:value-of select="normalize-space($dialogUpdateScript)"/>
          </script>

          <xsl:variable name="fileUpdateScript">
            function fileUpdate(id, value) { formFileUpdate (id, value); }
          </xsl:variable>
          <script type="text/javascript">
            <xsl:value-of select="normalize-space($fileUpdateScript)"/>
          </script>

          <xsl:variable name="mSelectUpdateScript">
            function mSelectUpdate() {
              formSelectUpdate (this.id, this.value);
            }
          </xsl:variable>
          <script type="text/javascript">
            <xsl:value-of select="normalize-space($mSelectUpdateScript)"/>
          </script>
          <script type="text/javascript">
             function noUpdate() { return true }
          </script>

        </xsl:if>

        <xsl:if test="($form_type = 'new' or $form_type = 'edit' or $form_type = 'profile') and $form_dialog = '0'">
          <div class="dijitHidden">
            <div data-dojo-type="dijit.Dialog" class="formErrorDialog" data-dojo-props="id:'formErrorDialog'">
              <div class="dijitDialogPaneContentArea">
                <table class='alertDialog'>
                  <td>
                    <img width='40' height='40' src="{$base_path}/int/js/custom/images/alert.png"></img>
                  </td>
                  <td style="padding:5pt 20pt">
                    <span id='errorDialogStatus' class='errorDialogStatus'></span>
                  </td>
                </table>
                <table class="formButtons">
                   <td class="B_Cl">
                     <button data-dojo-type="dijit.form.Button" data-dojo-props="type:'button'">
                        <xsl:value-of select="$cl_n"/>
                        <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                           dijit.byId('formErrorDialog').hide();
                        </script>
                     </button>
                   </td>
                </table>
              </div>
            </div>
          </div>
        </xsl:if>

        <xsl:choose>

          <xsl:when test="$form_type != 'response' and $db_view = '1' and $selection_mode = '0'">

            <!-- Forms with database interactivity -->

            <div class="formTitle Int">
              <table class="formTitle">
                <td>
                  <img height="32" width="32" src="{$base_path}/int/js/custom/images/form.png"></img>
                </td>
                <td>
                  <span class="formTitle">
                    <div class="titleForm">
                      <xsl:value-of select="@title"/>
                    </div>
                  </span>
                </td>
                <td id="dbShow" class="dbShow" onclick="dbShowAction()" style="visibility: hidden">
                  <div data-dojo-type="dijit/Tooltip"
                       data-dojo-props="id:'udbShow', connectId:'dbShow_img', label:'Display database', position:['below']"></div>
                  <img id="dbShow_img" height="30" width="35" src="{$base_path}/int/js/custom/images/database.png"></img>
                </td>
                <td id="dbDescription" class="dbDescription" onclick="dbShowDescriptionDialog()" style="display: none">
                  <div data-dojo-type="dijit/Tooltip"
                       data-dojo-props="id:'udbDescription', connectId:'dbDescription_img', label:'Form information', position:['below']"></div>
                  <img id="dbDescription_img" width="26" src="{$base_path}/int/js/custom/images/formsInfo.png"></img>
                </td>
              </table>
            </div>
            <div id="formContents" class="formContents Int">
              <div id="preloader"></div>

              <xsl:choose>
                
                <xsl:when test="$form_type != 'denied'">

                  <div id="customContents">
                    <div id="dbLeftFormLayer" class="dbLeftFormLayer">
                      <div id="dbLayer" class="dbLayer">
                        <div data-dojo-type="dijit.form.Form" data-dojo-props="id:'SelectForm', method:'post', action:''">
                          <input type="hidden" id="edit_choose_name" name="edit_choose_name" value="{$edit_choose_name}"/>
                          <input type="hidden" id="selected_value" name="edit_choose_value" value="{$edit_choose_value}"/>
                          <input type="hidden" id="selected_id" name="edit_choose_id" value="{$edit_choose_id}"/>
                          <input type="hidden" id="post_key_5" name="key" value="{@key}"/>
                          <table id="dbLeftGridTable" class="dbLeftGrid">
                            <tr>
                              <td class="formContainerButtonsArea" colspan="2">
                                <table id="formContainerButtons" class="formContainerButtons">
                                  <xsl:call-template name='print-db_new_form_button'></xsl:call-template>
                                  <xsl:call-template name='print-db_export_form_button'></xsl:call-template>
                                  <xsl:if test="@has_global_button = '1'">
                                    <xsl:call-template name='print-db_global_form_button'>
                                      <xsl:with-param name="name" select="@global_button_name"/>
                                      <xsl:with-param name="pname" select="@global_button_pname"/>
                                    </xsl:call-template>
                                  </xsl:if>
                                  <xsl:call-template name='print-db_delete_form_button'></xsl:call-template>
                                </table>
                              </td>
                            </tr>
                            <tr>
                              <td colspan="2">
                                <div>
                                  <div id="dbHide" class="dbHide" onclick="dbHideAction()">
                                    <img id="actiondbHideIcon" width="12" src="{$base_path}/int/js/custom/images/hide.png"/>
                                  </div>
                                </div>
                                <div>
                                  <div id="dbExtend" class="dbExtend" onclick="dbExtendAction()">
                                    <img id="actiondbExtendIcon" width="12" src="{$base_path}/int/js/custom/images/next_b.png"/>
                                  </div>
                                </div>
                              </td>
                            </tr>
                            <tr>
                              <xsl:call-template name='print-db_search_form'>
                                <xsl:with-param name="has_global_button" select="@has_global_button"/>
                              </xsl:call-template>
                            </tr>
                            <tr>
                              <td id="dbLeftGridContainer" class="dbLeftGridContainer" colspan="2">
                                <div id="dbLeftGrid"></div>
                              </td>
                            </tr>
                            <tr>
                              <td class="formContainerButtonsArea bottom">
                                <table class="formContainerButtons2">
                                  <xsl:call-template name='print-db_delete_form_button2'></xsl:call-template>
                                  <td class="exportPL">
                                    <img id="exportPL2" width="18" height="18" style="display:none"
                                         src="//ajax.googleapis.com/ajax/libs/dojo/1.7.4/dijit/themes/claro/images/loadingAnimation.gif"></img>
                                  </td>
                                </table>
                              </td>
                            </tr>
                          </table>
                        </div>
                      </div>
                      <div id="dbFormLayer" class="dbFormLayer">
                        <div data-dojo-type="dojox.layout.ContentPane" class="formContentPanel"
                             data-dojo-props="id:'formContainer', title:'Form', onLoad:'this.containerNode.scrollTop=0'">
                          <div id="FormTablePreloader"></div>
                          <xsl:call-template name='print-form'></xsl:call-template>
                        </div>
                        <div class="dijitHidden">
                          <div data-dojo-type="dijit.Dialog" class="formResponseDialog" data-dojo-props="id:'formResponseDialog'">
                            <div class="dijitDialogPaneContentArea">
                              <table class='responseDialog'>
                                <td>
                                  <span id='responseDialogStatus' class='responseDialogStatus'></span>
                                </td>
                                <td>
                                  <img width='18' height='18' src="{$base_path}/int/js/custom/images/true.png"></img>
                                </td>
                              </table>
                            </div>
                          </div>
                        </div>
                      </div>
                    </div>
                    <xsl:call-template name='print-db_delete_form_dialog'></xsl:call-template>
                  </div>
                  
                </xsl:when>
                
                <xsl:otherwise>

                  <div id="customContents">
		    <div class="deniedFormBox">
                    <table id="deniedForm" class="deniedForm">
                      <tr>
                        <td class="deniedFormT">
                          <img width="40" src="{$base_path}/int/js/custom/images/wrong_tick.png"></img>
                        </td>
                        <td>
                          <xsl:value-of select="@nA_msg1"/>
                        </td>
                      </tr>
                      <tr>
                        <td colspan="2">
                          <xsl:value-of select="@nA_msg2"/>
                        </td>
                      </tr>
                    </table>
		    </div>
                  </div>

                </xsl:otherwise>
                
              </xsl:choose>

            </div>
          </xsl:when>

          <xsl:when test="$form_type = 'profile'">

            <xsl:variable name="Form_id">
              <xsl:choose>
                <xsl:when test="$form_dialog = '0'">
                  <xsl:text>Form_Profile</xsl:text>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>Form_d_Profile</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:variable>

            <xsl:variable name="Form_Class">
              <xsl:choose>
                <xsl:when test="$form_dialog = '0'">
                  <xsl:text></xsl:text>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>loginLayer users management</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:variable>

              <div data-dojo-type="dijit.layout.ContentPane" data-dojo-props="id:'usersProfilePane'" class="usersProfilePane">

                <div>
                  <xsl:choose>
                    <xsl:when test="$form_dialog = '0'">
                      <div id="managerStatusPane" class="managerStatusPane">
                        <table>
                          <td id="managerStatusImgPane"></td>
                          <td id="managerStatusPaneText" class="managerStatusPaneText"></td>
                        </table>
                      </div>
                      <div id="managerEditionPane" class="managerEditionPane">
                        <div data-dojo-type="dijit/Tooltip"
                             data-dojo-props="id:'pAEdP',connectId:'managerEditionPane', label:'{$eP_n}', position:['below']">
                        </div>
                        <table>
                          <td>
                            <a id="editButton" class="editButton">
                              <xsl:value-of select="$e_n"/>
                            </a>
                          </td>
                          <td>
                            <img id="keyIcon" width="18" src="{$base_path}/int/js/custom/images/form_pencil.jpg"/>
                          </td>
                        </table>
                      </div>
                    </xsl:when>
                    <xsl:otherwise>
                      <div id="d_managerEditionPane" class="managerEditionPane">
                        <div data-dojo-type="dijit/Tooltip"
                             data-dojo-props="id:'d_pAEdP', connectId:'d_managerEditionPane', label:'{$eP_n}', position:['below']">
                        </div>
                        <table>
                          <td>
                            <a id="d_editButton" class="editButton">
                              <xsl:value-of select="$e_n"/>
                            </a>
                          </td>
                          <td>
                            <img id="d_keyIcon" width="18" src="{$base_path}/int/js/custom/images/form_pencil.jpg"/>
                          </td>
                        </table>
                      </div>
                    </xsl:otherwise>
                  </xsl:choose>
                </div>

                <div id="FormTableContainer">
                  <table id="FormTable" class="FormTable {$Form_Class}" cellpadding="0" cellspacing="0">
                    <tr>
                      <td>
                        <div data-dojo-type="dijit.form.Form" class="form" 
                             data-dojo-props="id:'{$Form_id}', method:'', action:''">

                          <div id="initProfileFormPosition"></div>
                          <xsl:apply-templates/>

                          <xsl:choose>
                            <xsl:when test="$form_dialog = '1'">
                              <div id="d_managerConfirmPane" class="managerConfirmPane" style="display: none">
                                <table class="formButtons">
                                  <td class="B_R">
                                    <button data-dojo-type="dijit.form.Button" label="&#60;&#60;&#32;Previous"
                                            data-dojo-props="type:'reset', id:'d_backButton', name:'back', style:'margin:0 35pt 0 2pt'">
                                    </button>
                                  </td>
                                  <td class="B_A">
                                    <button data-dojo-type="dijit.form.Button" label="{$a_n}"
                                            data-dojo-props="type:'button', id:'d_submitButton', name:'new'">
                                    </button>
                                  </td>
                                  <td class="B_R">
                                    <button data-dojo-type="dijit.form.Button" label="{$c_n}"
                                            data-dojo-props="type:'reset', id:'d_resetButton', name:'reset', iconClass:'dijitIconDelete', style:'margin:0 10pt'">
                                    </button>
                                  </td>
                                </table>
                              </div>
                              <div id="d_managerClosePane" class="managerClosePane">
                                <table class="formButtons">
                                  <td class="B_Cl">
                                    <button data-dojo-type="dijit.form.Button"
                                            data-dojo-props="type:'button', id:'d_closeButton', name:'close'">
                                      <xsl:value-of select="$cl_n"/>
                                    </button>
                                  </td>
                                </table>
                              </div>
                            </xsl:when>
                            <xsl:otherwise>
                              <div id="managerConfirmPane" class="managerConfirmPane" style="visibility: hidden">
                                <table class="formButtons">
                                  <td class="B_A">
                                    <button data-dojo-type="dijit.form.Button" label="{$a_n}"
                                            data-dojo-props="type:'button', id:'submitButton', name:'new'">
                                    </button>
                                  </td>
                                  <td class="B_R">
                                    <button data-dojo-type="dijit.form.Button" label="{$c_n}"
                                            data-dojo-props="type:'reset', id:'resetButton', name:'reset', iconClass:'dijitIconDelete'">
                                    </button>
                                  </td>
                                </table>
                              </div>
                              <div class="profileStatusBox">
                                <table>
                                  <tr>
                                    <td class="profilePL">
                                      <img id="profilePL" width="18" height="18" style="display:none"
                                           src="//ajax.googleapis.com/ajax/libs/dojo/1.7.4/dijit/themes/claro/images/loadingAnimation.gif"></img>
                                    </td>
                                    <td class="profileStatus">
                                      <table>
                                        <td id="profileStatus_image" class="profileStatus_image"></td>
                                        <td class="profileStatusInfo">
                                          <span id="profileStatus_text" class="profileStatus_text"></span>
                                        </td>
                                      </table>
                                    </td>
                                  </tr>
                                </table>
                              </div>
                            </xsl:otherwise>
                          </xsl:choose>
                          <input type="hidden" id="post_key_1" name="edit" value="{$a_n}"/>
                          <input type="hidden" id="post_key_2" name="edit_choose_name" value="{$edit_choose_name}"/>
                          <input type="hidden" id="post_key_3" name="edit_choose_value" value="{$edit_choose_value}"/>
                          <input type="hidden" id="post_key_4" name="edit_choose_id" value="{$edit_choose_id}"/>
                          <input type="hidden" id="post_key_5" name="key" value="{@key}"/>
                        </div>
                      </td>
                    </tr>
                  </table>
                </div>
              </div>
            
          </xsl:when>

          <xsl:when test="($form_type = 'new' or $form_type = 'edit') and $db_view = '1' and $selection_mode = '1'">

            <!-- Initialization of forms with database interactivity -->

            <xsl:call-template name='print-form'></xsl:call-template>

          </xsl:when>

          <xsl:when test="$form_type = 'table'">

              <div data-dojo-type="dijit.form.Form" class="form" style="width:100%"
                   data-dojo-props="id:'Form_Table', method:'', action:''">
                <xsl:apply-templates/>
                <table class="formButtons">
                  <td class="B_A">
                    <button data-dojo-type="dijit.form.Button" class="tableButton"
                            data-dojo-props="type:'button', id:'aB_Table'">
                      <xsl:value-of select="$a_n"/>
                    </button>
                  </td>
                  <td class="B_R">
                    <button data-dojo-type="dijit.form.Button" class="tableButton"
                            data-dojo-props="type:'button', iconClass:'dijitIconDelete', id:'cB_Table'">
                      <xsl:value-of select="$c_n"/>
                    </button>
                  </td>
                </table>
              </div>

          </xsl:when>

          <xsl:when test="$form_dialog = '1'">

            <table id="formDialog" class="formDialog dialog {$formClass}" cellpadding="0" cellspacing="0">
              <tr>
                <td>
                  <div data-dojo-type="dijit.form.Form" class="form" 
                       data-dojo-props="id:'Form_Dialog', method:'', action:''">
                    <xsl:apply-templates/>
                    <input type="hidden" id="post_key_2" name="edit_choose_name" value="{$edit_choose_name}"/>
                    <input type="hidden" id="post_key_3" name="edit_choose_value" value="{$edit_choose_value}"/>
                    <input type="hidden" id="post_key_4" name="edit_choose_id" value="{$edit_choose_id}"/>
                    <input type="hidden" id="post_key_5" name="key" value="{@key}"/>
                    <input type="hidden" id="post_key_6" name="command" value="{@command}"/>
                  </div>
                </td>
              </tr>
            </table>
            <table class="formButtons">
              <xsl:choose>
                <xsl:when test="not(@chart) or @chart = '0'">
                  <td class="B_A">
                    <button data-dojo-type="dijit.form.Button" 
                            data-dojo-props="type:'button', id:'aB_Dialog'">
                      <xsl:value-of select="$a_n"/>
                    </button>
                  </td>
                  <td class="B_R">
                    <button data-dojo-type="dijit.form.Button" 
                            data-dojo-props="type:'button', id:'cB_Dialog', iconClass:'dijitIconDelete'">
                      <xsl:value-of select="$c_n"/>
                    </button>
                  </td>
                </xsl:when>
                <xsl:otherwise>
                  <td class="B_Cl">
                    <button data-dojo-type="dijit.form.Button" 
                            data-dojo-props="type:'button', id:'cB_Dialog'">
                      <xsl:value-of select="$cl_n"/>
                    </button>
                  </td>
                </xsl:otherwise>
              </xsl:choose>
            </table>

          </xsl:when>

          <xsl:otherwise>

            <!-- forms without database interactivity -->

            <xsl:variable name="containerPage">
              <xsl:value-of select='translate($page," >","_-")'/>
            </xsl:variable>

            <div class="formTitle nInt">
              <table class="formTitle">
                <td>
                  <img height="32" width="32" src="{$base_path}/int/js/custom/images/form.png"></img>
                </td>
                <td>
                  <span class="formTitle">
                    <xsl:value-of select="@title"/>
                  </span>
                </td>
              </table>
            </div>
            <h3 class="formTitle">
              <xsl:value-of select="@title"/>
            </h3>
            
            <div id="formContents" class="formContents nInt">
              <div id="preloader"></div>

              <xsl:choose>

                <xsl:when test="$form_type != 'denied'">
              
                  <div id="customContents">
                    <div data-dojo-type="dijit.form.Form"
                         data-dojo-props="id:'Form', method:'post', action:'{$base_path}/{$page}', encType:'multipart/form-data'">
                      <xsl:choose>
                        <xsl:when test="$form_type != 'response' and @tabstyle = 'notebook'">
                          <div id="tabContainerForm" data-dojo-type="dijit.layout.TabContainer" doLayout="false">
                            <xsl:for-each select="container[not(@location)]">
                              <xsl:choose>
                                <xsl:when test="@pns != ''">
                                  <div data-dojo-type="dijit.layout.ContentPane" data-dojo-props="title:'{@pns}'">
                                    <xsl:apply-templates select="."/>
                                    <xsl:for-each select="following-sibling::container[@location='same_page' and 
		                                                    generate-id(preceding-sibling::container[not(@location)][1]) = generate-id(current())]">
                                      <xsl:apply-templates select="."/>
                                    </xsl:for-each>
                                  </div>
                                </xsl:when>
                                <xsl:otherwise>
                                  <div data-dojo-type="dijit.layout.ContentPane" data-dojo-props="title:'{@pn}'">
                                    <xsl:apply-templates select="."/>
                                    <xsl:for-each select="following-sibling::container[@location='same_page' and 
		                                                    generate-id(preceding-sibling::container[not(@location)][1]) = generate-id(current())]">
                                      <xsl:apply-templates select="."/>
                                    </xsl:for-each>
                                  </div>
                                </xsl:otherwise>
                              </xsl:choose>
                            </xsl:for-each>
                          </div>
                        </xsl:when>
                        <xsl:when test="$form_type != 'response' and @tabstyle = ''">
                          <xsl:apply-templates/>
                        </xsl:when>
                      </xsl:choose>
                      <xsl:choose>
                        <xsl:when test="@pn != ''">
                          <xsl:value-of select="@pn" disable-output-escaping="yes"/>
                        </xsl:when>
                        <xsl:otherwise>
                          <xsl:value-of select="@n"/>
                        </xsl:otherwise>
                      </xsl:choose>
                      <xsl:choose>
                        <xsl:when test="$edit_choose_id = ''">
                          <input type="hidden" id="post_key_1" name="new" value="{$a_n}"/>
                        </xsl:when>
                        <xsl:otherwise>
                          <input type="hidden" id="post_key_1" name="edit" value="{$a_n}"/>
                        </xsl:otherwise>
                      </xsl:choose>
                      <input type="hidden" id="post_key_2" name="edit_choose_name" value="{$edit_choose_name}"/>
                      <input type="hidden" id="post_key_3" name="edit_choose_value" value="{$edit_choose_value}"/>
                      <input type="hidden" id="post_key_4" name="edit_choose_id" value="{$edit_choose_id}"/>
                      <input type="hidden" id="post_key_5" name="key" value="{@key}"/>
                      <xsl:if test="not(@creation_access) or @creation_access = '1'">
                        <div class="container {$containerPage} buttons">
                          <table class="formButtons">
                            <td class="B_A">
                              <button data-dojo-type="dijit.form.Button" data-dojo-props="id:'submitButton', type:'button'">
                                <xsl:value-of select="$a_n"/>
                                <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                                  fM_submitAction();
                                </script>
                              </button>
                            </td>
                            <td class="B_R">
                              <button data-dojo-type="dijit.form.Button" data-dojo-props="type:'button', iconClass:'dijitIconDelete'">
                                <xsl:value-of select="$r_n"/>
                                <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                                  fM_resetAction();
                                </script>
                              </button>
                            </td>
                            <td class="B_PL">
                              <img id="B_PL" width="25" height="25" style="visibility: hidden"
                                   src="{$base_path}/int/js/custom/images/preloader.gif"></img>
                            </td>
                            <td class="B_PL_T">
                              <xsl:choose>
                                <xsl:when test="$language = 'es'">
                                  <div id="B_PL_T" style="visibility: hidden">Cargando...</div>
                                </xsl:when>
                                <xsl:otherwise>
                                  <div id="B_PL_T" style="visibility: hidden">Loading...</div>
                                </xsl:otherwise>
                              </xsl:choose>
                            </td>
                          </table>
                        </div>
                      </xsl:if>
                    </div>
                  </div>

                </xsl:when>

                <xsl:otherwise>

                  <div id="customContents">
		    <div class="deniedFormBox">
                    <table id="deniedForm" class="deniedForm">
                      <tr>
                        <td class="deniedFormT">
                          <img width="40" src="{$base_path}/int/js/custom/images/wrong_tick.png"></img>
                        </td>
                        <td>
                          <xsl:value-of select="@nA_msg1"/>
                        </td>
                      </tr>
                      <tr>
                        <td colspan="2">
                          <xsl:value-of select="@nA_msg2"/>
                        </td>
                      </tr>
                    </table>
		    </div>
                  </div>

                </xsl:otherwise>

              </xsl:choose>
   
            </div>
          </xsl:otherwise>

        </xsl:choose>

      </xsl:when>

      <xsl:otherwise>

        <!-- Response pages -->

        <script type="text/javascript">
          function noUpdate() { return true }
        </script>

        <div class="formTitle nInt">
          <table class="formTitle">
            <td>
              <img height="32" width="32" src="{$base_path}/int/js/custom/images/form.png"></img>
            </td>
            <td>
              <span class="formTitle">
                <xsl:value-of select="@title"/>
              </span>
            </td>
          </table>
        </div>
        <h3 class="formTitle">
          <xsl:value-of select="@title"/>
        </h3>
        
        <div id="formContents" class="formContents nInt">
          <div id="preloader"></div>
          <div id="customContents">
            <div id="Form">
              <xsl:apply-templates/>
            </div>
            <input type="hidden" id="post_key_1" name="response" value="{$a_n}"/>
            <input type="hidden" id="post_key_2" name="edit_choose_name" value=""/>
            <input type="hidden" id="post_key_3" name="edit_choose_value" value=""/>
            <input type="hidden" id="post_key_4" name="edit_choose_id" value="{$edit_choose_id}"/>
            <input type="hidden" id="post_key_5" name="key" value="{@key}"/>
          </div>
        </div>

      </xsl:otherwise>

    </xsl:choose>

  </xsl:template>


  <!-- Template NAMES  -->

  <xsl:template name="print-form">

    <div id="FormTableContainer">
      <table id="FormTable" class="FormTable" cellpadding="0" cellspacing="0">
        <tr>
          <td>
            <div data-dojo-type="dijit.form.Form" id="Form" 
		             data-dojo-props="id:'Form', method:'post', action:'', encType:'multipart/form-data'">
              <xsl:variable name="dbSubmitScript">
                if (dijit.byId('Form').validate()) {
                   dbSubmit('accept');
                   return true;
                }
                dbInvalidForm();
                return false;
              </xsl:variable>
              <script type="dojo/method" event="onSubmit">
                <xsl:value-of select="normalize-space($dbSubmitScript)"/>
              </script>
              <xsl:choose>
                <xsl:when test="@tabstyle = 'notebook'">
                  <div style="width:500pt">
                    <div dojotype="dijit.layout.TabContainer" doLayout="false" style="width:90%">
                      <xsl:for-each select="container[not(@location)]">
                        <xsl:choose>
                          <xsl:when test="@pns != ''">
                            <div data-dojo-type="dijit.layout.ContentPane" data-dojo-props="title:'{@pns}'"
                                 style="margin:20pt 10pt 10pt 10pt">
                              <xsl:apply-templates select="."/>
                              <xsl:for-each select="following-sibling::container[@location='same_page' and 
		                                                generate-id(preceding-sibling::container[not(@location)][1]) = generate-id(current())]">
                                <xsl:apply-templates select="."/>
                              </xsl:for-each>
                            </div>
                          </xsl:when>
                          <xsl:otherwise>
                            <div data-dojo-type="dijit.layout.ContentPane" data-dojo-props="title:'{@pn}'"
                                 style="margin:20pt 10pt 10pt 10pt">
                              <xsl:apply-templates select="."/>
                              <xsl:for-each select="following-sibling::container[@location='same_page' and 
		                                                generate-id(preceding-sibling::container[not(@location)][1]) = generate-id(current())]">
                                <xsl:apply-templates select="."/>
                              </xsl:for-each>
                            </div>
                          </xsl:otherwise>
                        </xsl:choose>
                      </xsl:for-each>
                    </div>
                  </div>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:apply-templates/>
                </xsl:otherwise>
              </xsl:choose>
              <xsl:choose>
                <xsl:when test="$edit_choose_id = ''">
                  <input type="hidden" id="post_key_1" name="new" value="{$a_n}"/>
                </xsl:when>
                <xsl:otherwise>
                  <input type="hidden" id="post_key_1" name="edit" value="{$a_n}"/>
                </xsl:otherwise>
              </xsl:choose>
              <input type="hidden" id="post_key_2" name="edit_choose_name" value="{$edit_choose_name}"/>
              <input type="hidden" id="post_key_3" name="edit_choose_value" value="{$edit_choose_value}"/>
              <input type="hidden" id="post_key_4" name="edit_choose_id" value="{$edit_choose_id}"/>
              <input type="hidden" id="post_key_5" name="key" value="{@key}"/>
              <xsl:if test="not(@edition_access) or @edition_access = '1'">
                <xsl:call-template name='print-form_buttons'></xsl:call-template>
              </xsl:if>
            </div>
          </td>
        </tr>
      </table>
    </div>
  </xsl:template>

  <xsl:template name="print-form_buttons">
    <xsl:choose>
      <xsl:when test="$db_view = '1'">
        <div id="formControlButtonContainer">
          <div class="dbFormButtons">
            <table class="formButtons">
              <td id="submitButtonLayer" class="B_A">
                <input data-dojo-type="dijit.form.Button" label="{$a_n}"
                       data-dojo-props="type:'submit', id:'submitButton'">
                </input>
              </td>
              <xsl:if test="@rejection_access = '1'">
                <td class="B_R">
                  <button data-dojo-type="dijit.form.Button"
                          data-dojo-props="type:'button', id:'{@n}', name:'p_{@n}', iconClass:'dijitIconError'">
                    <xsl:text>Reject</xsl:text>
                    <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                      dbRejectDialog();
                    </script>
                  </button>
                </td>
              </xsl:if>
            </table>
          </div>
          <div class="dbFormManager">
            <table width="100%" class="dbFormManager">
              <td class="managerStatus">
                <table>
                  <td id="managerStatus_image" class="managerStatus_image"></td>
                  <td class="managerStatusInfo">
                    <span id="managerStatus_text" class="managerStatus_text"></span>
                  </td>
                </table>
              </td>
              <td id="managerPL" style="display:none">
                <img width="20" height="20" src="//ajax.googleapis.com/ajax/libs/dojo/1.7.4/dijit/themes/claro/images/loadingAnimation.gif"></img>
              </td>
            </table>
          </div>
        </div>
      </xsl:when>
      <xsl:otherwise>
        <table class="formButtons">
          <td>
            <button data-dojo-type="dijit.form.Button"
                    data-dojo-props="type:'submit', id:'submitButton', name:'new', iconClass:'dijitIconEditTask'">
              <xsl:value-of select="$a_n"/>
            </button>
            <button data-dojo-type="dijit.form.Button"
                    data-dojo-props="type:'reset', id:'resetButton', name:'reset', iconClass:'dijitIconDelete', style:'margin-left:8pt'">
              <xsl:value-of select="$r_n"/>
            </button>
          </td>
        </table>          
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>


  <xsl:template name="print-db_new_form_button">
    <xsl:choose>
      <xsl:when test="not(@creation_access) or @creation_access = '1'">
        <td class="dbFormNewButton">
          <button data-dojo-type="dijit.form.Button"
                  data-dojo-props="type:'button', id:'dbFormNewButton', name:'new', iconClass:'dijitIconEdit', style:'margin-left:1pt;padding:0 2px 0'">
            <xsl:value-of select="$db_n_n"/>
            <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">dbNew();</script>
          </button>
        </td>
      </xsl:when>
      <xsl:otherwise>
        <td class="dbFormNewButton">
          <button data-dojo-type="dijit.form.Button"
                  data-dojo-props="type:'button', id:'dbFormNewButton', name:'new', disabled:'disabled', iconClass:'dijitIconEdit', style:'margin-left:1pt;padding:0 2px 0'">
            <xsl:value-of select="$db_n_n"/>
            <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">dbNew();</script>
          </button>
        </td>
      </xsl:otherwise>
    </xsl:choose>

  </xsl:template>

  <xsl:template name="print-db_global_form_button">
    <xsl:param name="name"/>
    <xsl:param name="pname"/>
    <td id="dbFormGlobalButton" class="dbFormGlobalButton">
      <button data-dojo-type="dijit.form.Button"
	      data-dojo-props="type:'button', id:'dbFormGlobalButton', name:'db_button_{$name}', iconClass:'dijitIconChart', style:'margin-left:1pt'">
        <xsl:value-of select="$pname"/>
        <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">dbButton('<xsl:value-of select="$name"/>');</script>
      </button>
    </td>
  </xsl:template>

  <xsl:template name="print-db_export_form_button">
    <td id="dbFormExportButton" class="dbFormExportButton">
      <button data-dojo-type="dijit.form.Button"
		          data-dojo-props="type:'button', id:'dbFormExportButton', name:'export', iconClass:'filePDFIcon', style:'margin-left:1pt', disabled:'disabled'">
        <xsl:value-of select="$db_e_n"/>
        <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">dbExport();</script>
      </button>
    </td>
  </xsl:template>

  <xsl:template name="print-db_delete_form_button">
    <td id="dbFormDeleteButton" class="dbFormDeleteButton">
      <button data-dojo-type="dijit.form.Button"
              data-dojo-props="type:'button', id:'dbFormDeleteButton', name:'delete', iconClass:'dijitIconDelete', style:'margin-left:1pt', disabled:'disabled'">
        <xsl:value-of select="$db_d_n"/>
        <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">showDeleteDialog();</script>
      </button>
    </td>
  </xsl:template>

  <xsl:template name="print-db_delete_form_button2">
    <td id="dbFormDeleteButton2" class="dbFormDeleteButton" style="visibility:hidden">
      <button data-dojo-type="dijit.form.Button"
              data-dojo-props="type:'button', id:'dbFormDeleteButton2', name:'delete', iconClass:'dijitIconDelete', style:'margin-left:1pt', disabled:'disabled'">
        <xsl:value-of select="$db_d_n"/>
        <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">showDeleteDialog();</script>
      </button>
    </td>
  </xsl:template>

  <xsl:template name="print-db_delete_form_dialog">
    <div class="dijitHidden">
      <div data-dojo-type="dijit.Dialog" data-dojo-props="title:'&lt;b&gt;Delete&lt;/&gt;'" id="formDeleteDialog" class="formDeleteDialog">
        <div class="dijitDialogPaneContentArea">
          <table class='alertDialog'>
            <td>
              <img width='40' height='40' src="{$base_path}/int/js/custom/images/alert.png"></img>
            </td>
            <td style="padding: 5pt 20pt">
              <span class='errorDialogStatus'>The selected items will be deleted</span>
            </td>
          </table>
          <table class="formButtons">
            <td class="B_A">
              <button data-dojo-type="dijit.form.Button" label="{$a_n}"
                      data-dojo-props="type:'button'">
                <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                  dbDelete();
                </script>
              </button>
            </td>
            <td class="B_R">
              <button data-dojo-type="dijit.form.Button" label="{$c_n}"
                      data-dojo-props="type:'button', iconClass:'dijitIconDelete'">
                <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                  hideDeleteDialog();
                </script>
              </button>
            </td>
            <td id="form_dialog_preloader"></td>
          </table>
        </div>
      </div>
    </div>
  </xsl:template>

  <xsl:template name="print-db_search_form">
    <xsl:param name="has_global_button"/>
    <xsl:variable name="db_updating">dbSearch</xsl:variable>
    <td>
      <table cellpadding="0" cellspacing="0" class="formSearchWidget">
        <td id="formSearchInput" class="formSearchInput">
          <input data-dojo-type="dijit.form.TextBox"
		             data-dojo-props="id:'database_search',name:'p_database_search',placeHolder:'Search an item',onKeyUp:{$db_updating},onMouseEnter:searchFormHovered,onMouseLeave:searchFormUnHovered">
            <div class="formSearchClearIcon">
              <img width="13" height="13" src="{$base_path}/int/js/custom/images/clear.png" onclick="searchFormClear()"></img>
            </div>
          </input>
        </td>
        <td class="formSearchIcon">
          <img width="21" height="21" src="{$base_path}/int/js/custom/images/search.png" onclick="dbSearch()"></img>
        </td>
        <td class="globalBPL">
           <img id="globalBPL" width="18" height="18" style="visibility:hidden"
                src="//ajax.googleapis.com/ajax/libs/dojo/1.7.4/dijit/themes/claro/images/loadingAnimation.gif"></img>
        </td>
      </table>
    </td>
    <td id="sdbViewLayer">
      <div id="sdbLoadControl" style="display:none">0</div>
      <a id="sdbAdminLoad" onclick="sdbAdminControlLoad(1)" style="display:none"><xsl:value-of select="$db_load_admin_n"/></a>
      <a id="sdbUserLoad" onclick="sdbAdminControlLoad(0)"><xsl:value-of select="$db_load_user_n"/></a>
    </td>
  </xsl:template>

  <xsl:template name="print-form_fields">

    <xsl:if test="param">
      <xsl:for-each select="param[not(@location) or @location='']">

        <xsl:choose>
          <xsl:when test="following-sibling::param[1][@location = 'same_line'] or 
		                      following-sibling::condition[1][@location = 'same_line']">

            <xsl:variable name="isCheckBoxParam">
              <xsl:choose>
                <xsl:when test="@field_type = 'options non-editable' and (@values = '1,0' or @values = '0,1') and 
                                following-sibling::param[1][@field_type = 'options non-editable'] and 
                                (following-sibling::param[1][@values = '1,0'] or following-sibling::param[1][@values = '0,1'])">
                  <xsl:text>1</xsl:text>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>0</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:variable>
 
            <xsl:choose>

              <xsl:when test="@field_type = 'button' or following-sibling::param[1][@field_type = 'button'] or $isCheckBoxParam = '1'">
                <tr class="nLBc">
                  <td colspan="4">
                    <table>
                      <tr>
                        <xsl:apply-templates select="."/>
                        <xsl:for-each select="following-sibling::param[@location = 'same_line' and
		                                          generate-id(preceding-sibling::param[not(@location)][1]) = generate-id(current())]">
                          <xsl:apply-templates select="."/>
                        </xsl:for-each>
                      </tr>
                    </table>
                  </td>
                </tr>
              </xsl:when>
              <xsl:otherwise>
                <tr class="nL">
                  <xsl:if test="$db_view = '1' and @n = $edit_choose_name">
                    <td class="formKeyIcon">
                      <img id="keyIcon" width="20" src="{$base_path}/int/js/custom/images/form_pencil.jpg"/>
                    </td>
                  </xsl:if>
                  <xsl:apply-templates select="."/>
                  <xsl:choose>
                    <xsl:when test="following-sibling::param[1]">
                      <xsl:for-each select="following-sibling::param[@location = 'same_line' and
		                                            generate-id(preceding-sibling::param[not(@location)][1]) = generate-id(current())]">
                        <xsl:apply-templates select="."/>
                      </xsl:for-each>
                    </xsl:when>
                    <xsl:when test="following-sibling::condition[1]">
                      <xsl:for-each select="following-sibling::condition[@location = 'same_line' and
		                                            generate-id(preceding-sibling::param[not(@location)][1]) = generate-id(current())]">
                        <xsl:apply-templates select="."/>
                      </xsl:for-each>
                    </xsl:when>
                  </xsl:choose>
                </tr>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:when>
          <xsl:otherwise>
            <xsl:choose>
              <xsl:when test="@field_type = 'button' and @condition != 'readonly' and @condition != 'hidden'">
                <tr class="nLBc">
                  <td>
                    <table>
                      <tr>
                        <xsl:apply-templates select="."/>
                      </tr>
                    </table>
                  </td>
                </tr>
              </xsl:when>
              <xsl:otherwise>

                <xsl:variable name="newLineClass">
                  <xsl:choose>
                    <xsl:when test="(@field_type = 'formatted expression' or @field_type = 'text expression') and @value != ''">
                      <xsl:text>nLF</xsl:text>
                    </xsl:when>
                    <xsl:when test="@field_type = 'table'">
                      <xsl:text>nLT</xsl:text>
                    </xsl:when>
                    <xsl:otherwise>
                      <xsl:text>nL</xsl:text>
                    </xsl:otherwise>
                  </xsl:choose>
                </xsl:variable>

                <tr class="{$newLineClass}">
                  <xsl:if test="$db_view = '1' and @n = $edit_choose_name">
                    <td class="formKeyIcon">
                      <img id="keyIcon" width="20" src="{$base_path}/int/js/custom/images/form_pencil.jpg"/>
                    </td>
                  </xsl:if>
                  <xsl:apply-templates select="."/>
                  <xsl:if test="@field_type != 'table' and @has_next_dummy_param = '1'">
                    <td class="fieldTitle"></td>
                    <td></td>
                  </xsl:if>
                </tr>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:for-each>
    </xsl:if>  

    <xsl:if test="userparam">
      <xsl:for-each select="userparam[not(@location) or @location='']">
        <xsl:choose>
          <xsl:when test="following-sibling::userparam[1][@location = 'same_line']">
            <tr class="reg mrow">
              <td class="login">
                <xsl:apply-templates select="."/>
              </td>
              <xsl:for-each select="following-sibling::userparam[@location = 'same_line' and
		                                    generate-id(preceding-sibling::userparam[not(@location)][1]) = generate-id(current())]">
                <td class="login">
                  <xsl:apply-templates select="."/>
                </td>
              </xsl:for-each>
            </tr>    
          </xsl:when>
          <xsl:otherwise>
            <tr class="reg mrow">
              <td class="login">
                <xsl:apply-templates select="."/>
              </td>
            </tr>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:for-each>
    </xsl:if>

    <xsl:if test="condition">
      <xsl:for-each select="condition[not(@location)]">
        <xsl:choose>
          <xsl:when test="following-sibling::condition[1][@location='same_line']">
            <tr>
              <xsl:apply-templates select="."/>
              <xsl:for-each select="following-sibling::condition[@location='same_line' and 
		                                  generate-id(preceding-sibling::condition[not(@location)][1]) = generate-id(current())]">
                <xsl:apply-templates select="."/>
              </xsl:for-each>
            </tr>
          </xsl:when>
          <xsl:when test="following-sibling::param[1][@location='same_line']">
            <tr>
              <xsl:apply-templates select="."/>
              <xsl:for-each select="following-sibling::param[@location='same_line' and @field_type='button' and
		                                  generate-id(preceding-sibling::condition[not(@location)][1]) = generate-id(current())]">
                <td>
                  <table>
                    <xsl:apply-templates select="."/>
                    <td id="buttonPL">
                      <img id="{@n}_preloader" width="20" height="20" style="display:none"
                           src="//ajax.googleapis.com/ajax/libs/dojo/1.7.4/dijit/themes/claro/images/loadingAnimation.gif"></img>
                    </td>
                  </table>
                </td>
              </xsl:for-each>
            </tr>
          </xsl:when>
          <xsl:otherwise>
            <tr>
              <xsl:apply-templates select="."/>
            </tr>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:for-each>
    </xsl:if>  
     
  </xsl:template>

  <xsl:template name="print-menu_button">
    <xsl:param name="name"/>
    <xsl:param name="pname"/>
    <xsl:param name="command"/>
    <div>
      <xsl:value-of select="$name"></xsl:value-of>
      <xsl:value-of select="$pname"></xsl:value-of>
      <xsl:value-of select="$command"></xsl:value-of>
    </div>

  </xsl:template>

  <xsl:template name='print-tree-option'>
    <xsl:param name="values"/>
    <xsl:param name="label-values"/>
    <xsl:param name="name-values"/>
    <xsl:param name="count"/>
    
    <xsl:variable name="nameValues">
      <xsl:choose>
        <xsl:when test="$name-values = ''">
          <xsl:value-of select="$values"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$name-values"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:choose>
      <xsl:when test="contains($values,',')">
        {id:'<xsl:value-of select="substring-before($values,',')"/>', name:'<xsl:value-of select="substring-before($nameValues,',')"/>', label:'<xsl:value-of select="substring-before($label-values,',')"/>'},
      </xsl:when>
      <xsl:otherwise>
        {id:'<xsl:value-of select="$values"/>', name:'<xsl:value-of select="$nameValues"/>', label:'<xsl:value-of select="$label-values"/>'}
      </xsl:otherwise>
    </xsl:choose>
    <xsl:if test="contains($values,',')">
      <xsl:call-template name='print-tree-option'>
        <xsl:with-param name="values" select="substring-after($values,',')"/>
        <xsl:with-param name="label-values" select="substring-after($label-values,',')"/>
        <xsl:with-param name="name-values" select="substring-after($name-values,',')"/>
        <xsl:with-param name="count" select="$count + 1"/>
      </xsl:call-template>
    </xsl:if>
  </xsl:template>

  <xsl:template name='print-data-table'>
    <xsl:param name='values'/>
    <xsl:param name='cols'/>
    <xsl:param name='count'/>
    <xsl:if test="$count = 1">{</xsl:if>
    <xsl:choose>
      <xsl:when test="contains($values,',') and $count &lt; $cols">
        column_<xsl:value-of select="$count"/>:'<xsl:value-of select="substring-before($values,',')"/>',
      </xsl:when>
      <xsl:when test="contains($values,',') and $count = $cols">
        column_<xsl:value-of select="$count"/>:'<xsl:value-of select="substring-before($values,',')"/>'
      </xsl:when>
    </xsl:choose>
    <xsl:choose>
      <xsl:when test="contains($values,',') and $count &lt; $cols">
        <xsl:call-template name='print-data-table'>
          <xsl:with-param name="values" select="substring-after($values,',')"/>
          <xsl:with-param name="cols" select="$cols"/>
          <xsl:with-param name="count" select="$count + 1"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:when test="contains($values,',') and $count = $cols">
        },
        <xsl:call-template name='print-data-table'>
          <xsl:with-param name="values" select="substring-after($values,',')"/>
          <xsl:with-param name="cols" select="$cols"/>
          <xsl:with-param name="count" select="1"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        column_<xsl:value-of select="$count"/>:'<xsl:value-of select="$values"/>'}
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template name='print-header-response-table'>
    <xsl:param name='name'/>
    <xsl:param name='count'/>
    <xsl:choose>
      <xsl:when test="contains($name,',')">
        <th width="10%" editable="false" field="column_{$count}">
          <xsl:value-of select="substring-before($name,',')"/>
        </th>
      </xsl:when>
      <xsl:otherwise>
        <th width="10%" editable="false" field="column_{$count}">
          <xsl:value-of select="$name"/>
        </th>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:if test="contains($name,',')">
      <xsl:call-template name='print-header-response-table'>
        <xsl:with-param name="name" select="substring-after($name,',')"/>
        <xsl:with-param name="count" select="$count + 1"/>
      </xsl:call-template>
    </xsl:if>
  </xsl:template>

  <xsl:template name='print-header-table'>
    <xsl:param name='name'/>
    <xsl:param name='length'/>
    <xsl:param name='justify'/>
    <xsl:param name='expand'/>
    <xsl:param name='field_type'/>
    <xsl:param name='editable'/>
    <xsl:param name='color'/>
    <xsl:param name='count'/>

    <xsl:choose>
      <xsl:when test="contains($name,',')">
         { name:'<xsl:value-of select="substring-before($name,',')"/>', field: 'column_<xsl:value-of select="$count"/>', width:'<xsl:value-of select="substring-before($length,',')"/>px', styles: 'text-align: <xsl:value-of select="substring-before($justify,',')"/>; color:<xsl:value-of select="substring-before($color,',')"/>;'},
      </xsl:when>
      <xsl:otherwise>
         { name:'<xsl:value-of select="$name"/>', field: 'column_<xsl:value-of select="$count"/>', width:'<xsl:value-of select="$length"/>%', styles: 'text-align: <xsl:value-of select="$justify"/>; color:<xsl:value-of select="$color"/>;'},
      </xsl:otherwise>
    </xsl:choose>
    <xsl:if test="contains($name,',')">
      <xsl:call-template name='print-header-table'>
        <xsl:with-param name="name" select="substring-after($name,',')"/>
        <xsl:with-param name="length" select="substring-after($length,',')"/>
        <xsl:with-param name="justify" select="substring-after($justify,',')"/>
        <xsl:with-param name="expand" select="substring-after($expand,',')"/>
        <xsl:with-param name="field_type" select="substring-after($field_type,',')"/>
        <xsl:with-param name="editable" select="substring-after($editable,',')"/>
        <xsl:with-param name="color" select="substring-after($color,',')"/>
        <xsl:with-param name="count" select="$count + 1"/>
      </xsl:call-template>
    </xsl:if>
  </xsl:template>

  <xsl:template name='print-option'>
    <xsl:param name='valueList'/>
    <xsl:param name='labelList'/>
    <xsl:param name='defaultValue'/>
    <option>
      <xsl:choose>
        <xsl:when test="contains($valueList,',')">
	        <xsl:choose>
	          <xsl:when test="substring-before($valueList,',') = '*separator*'">
		          <xsl:attribute name="type">separator</xsl:attribute>
            </xsl:when>
            <xsl:otherwise>
              <xsl:if test="substring-before($valueList,',') = $defaultValue">
                <xsl:attribute name="selected">selected</xsl:attribute>
              </xsl:if>
              <xsl:attribute name="value">
                <xsl:value-of select="substring-before($valueList,',')"/>
              </xsl:attribute>
              <xsl:attribute name="value">
                <xsl:value-of select="substring-before($valueList,',')"/>
              </xsl:attribute>
              <xsl:choose>
                <xsl:when test="substring-before($labelList,',') != ''">
                  <xsl:value-of select="substring-before($labelList,',')"/>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:value-of select="substring-before($valueList,',')"/>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:when>
        <xsl:otherwise>
          <xsl:if test="$valueList = $defaultValue">
            <xsl:attribute name="selected">selected</xsl:attribute>
          </xsl:if>
          <xsl:attribute name="value">
            <xsl:value-of select="$valueList"/>
          </xsl:attribute>
          <xsl:choose>
            <xsl:when test="$labelList != ''">
              <xsl:value-of select="$labelList"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="$valueList"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:otherwise>
      </xsl:choose>
    </option>

    <xsl:if test="contains($valueList,',')">
      <xsl:call-template name='print-option'>
        <xsl:with-param name="valueList" select="substring-after($valueList,',')"/>
        <xsl:with-param name="labelList" select="substring-after($labelList,',')"/>
        <xsl:with-param name="defaultValue" select="$defaultValue"/>
      </xsl:call-template>
    </xsl:if>
  </xsl:template>

  <xsl:template name="ToLower">
    <xsl:param name="inputString"/>
    <xsl:variable name="upperCase" select="'ABCDEFGHIJKLMNOPQRSTUVWXYZ*'"/>
    <xsl:variable name="smallCase" select="'abcdefghijklmnopqrstuvwxyz'"/>
    <xsl:value-of select="translate($inputString,$upperCase,$smallCase)"/>
  </xsl:template>


  <xsl:template name='print-multiple-option'>
    <xsl:param name='valueList'/>
    <xsl:param name='labelList'/>
    <xsl:param name='defaultValues'/>
    <option>
      <xsl:choose>
        <xsl:when test="contains($valueList,',')">
          <xsl:if test="contains($defaultValues,substring-before($valueList,','))">
            <xsl:attribute name="selected">selected</xsl:attribute>
          </xsl:if>
          <xsl:attribute name="value">
            <xsl:value-of select="substring-before($valueList,',')"/>
          </xsl:attribute>
          <xsl:choose>
            <xsl:when test="substring-before($labelList,',') != ''">
              <xsl:value-of select="substring-before($labelList,',')"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="substring-before($valueList,',')"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:when>
        <xsl:otherwise>
          <xsl:if test="contains($defaultValues,$valueList)">
            <xsl:attribute name="selected">selected</xsl:attribute>
          </xsl:if>
          <xsl:attribute name="value">
            <xsl:value-of select="$valueList"/>
          </xsl:attribute>
          <xsl:choose>
            <xsl:when test="$labelList != ''">
              <xsl:value-of select="$labelList"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="$valueList"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:otherwise>
      </xsl:choose>
    </option>

    <xsl:if test="contains($valueList,',')">
      <xsl:call-template name='print-multiple-option'>
        <xsl:with-param name="valueList" select="substring-after($valueList,',')"/>
        <xsl:with-param name="labelList" select="substring-after($labelList,',')"/>
        <xsl:with-param name="defaultValues" select="$defaultValues"/>
      </xsl:call-template>
    </xsl:if>
  </xsl:template>




  <!-- Template MATCHES -->

  <xsl:template match="description">
    <xsl:if test="$db_view = '0'">
      <xsl:choose>
        <xsl:when test=". != ''">

          <xsl:variable name="descriptionPage">
            <xsl:value-of select='translate($page," >","_-")'/>
          </xsl:variable>

	        <xsl:variable name="descriptionClass">
	          <xsl:choose>
              <xsl:when test="$form_type = 'response'">
                <xsl:text>description response</xsl:text>
              </xsl:when>
              <xsl:otherwise>
                <xsl:text>description</xsl:text>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:variable>

          <div class="{$descriptionPage} {$descriptionClass}">
            <xsl:value-of select="." disable-output-escaping="yes"/>
          </div>
        </xsl:when>
        <xsl:otherwise>
          <div class="separator"></div>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:if>
    <xsl:if test="$db_view = '1' and . != ''">
      <script type="text/javascript">
        dbShowDescriptionIcon();
      </script>
      <div class="dijitHidden">
        <div data-dojo-type="dijit.Dialog" class="formDescriptionDialog"
             data-dojo-props="id:'formDescriptionDialog'">
          <div class="dijitDialogPaneContentArea">
            <table class="description">
	            <td class="descriptionIcon">
		            <img width="85" src="{$base_path}/int/js/custom/images/formsInfoDialog.png"/>
              </td>
              <td class="description">
                <xsl:value-of select="."/>
              </td>
            </table>
            <table class="formButtons">
              <tr>
                <td class="B_Cl">
                  <button data-dojo-type="dijit.form.Button" data-dojo-props="type:'button', style:'margin:20pt'">
                    <xsl:value-of select="$cl_n"/>
                    <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                      dijit.byId('formDescriptionDialog').hide();
                    </script>
                  </button>
                </td>
              </tr>
            </table>  
          </div>
        </div>
      </div>
    </xsl:if>
  </xsl:template>

  <xsl:template match="container">
    <xsl:variable name="optsR">,options editable,options non-editable,text,date,time,file,formatted,numeric,long text,text expression,formatted expression,table,"</xsl:variable>
    <xsl:variable name="opts">,options editable,options non-editable,text,date,time,file,formatted,numeric,long text,expression,text expression,formatted expression,button,table,"</xsl:variable>

    <xsl:variable name="title">
      <xsl:choose>
        <xsl:when test="@pn != ''">
	        <xsl:if test="@pn != '-'">
            <xsl:value-of select="@pn"/>
          </xsl:if>
        </xsl:when>
        <xsl:otherwise>
	        <xsl:value-of select="@n"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>


    <xsl:choose>

      <xsl:when test="$form_type = 'profile' or $form_type = 'table'">

        <fieldset class="nInt">
          <legend>
            <xsl:value-of select="$title"/>
          </legend>
          <div class="formContainer">
            <table class="formContainer" cellspacing="2" cellpadding="3">
              <xsl:call-template name='print-form_fields'></xsl:call-template>
            </table>
          </div>
        </fieldset>

      </xsl:when>

      <xsl:when test="$form_type = 'incidence'">
	      <div class="formContainer">
          <table class="formContainer" cellspacing="2" cellpadding="3">
            <xsl:call-template name='print-form_fields'></xsl:call-template>
          </table>
          <table class="formButtons">
            <td class="B_A">
              <button data-dojo-type="dijit.form.Button" label="{$rj_n}"
                      data-dojo-props="type:'button', id:'submitIncidenceButton'">
                <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                  dbReject();
                </script>
              </button>
            </td>
            <td class="B_R">
              <button data-dojo-type="dijit.form.Button" label="{$c_n}"
                      data-dojo-props="type:'button', id:'cancelIncidenceButton', iconClass:'dijitIconDelete'">
                <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                  dijit.byId('formIncidenceDialog').hide();
                </script>
              </button>
            </td>
            <td id="form_dialog_preloader"></td>
          </table>
        </div>
      </xsl:when>

      <xsl:when test="(($form_type = 'new' or $form_type = 'edit') and (param[(string(@is_response)!= '1' 
                      and not(starts-with(@value,'[')) and contains($opts,concat(',',@field_type,',')))])) or 
                      ($form_type = 'response' and (param[(string(@is_response) != '0' and not(starts-with(@value,'[')) 
                      and contains($optsR,concat(',',@field_type,',')))]))">

        <xsl:variable name="containerType">
          <xsl:choose>
            <xsl:when test="@n = 'edit_choose_name' or @n = 'status'">
              <xsl:text>formControlContainer</xsl:text>
            </xsl:when>
            <xsl:otherwise>
              <xsl:text>formContainer</xsl:text>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>

        <xsl:variable name="containerSchema">
          <xsl:choose>
            <xsl:when test="@n = 'edit_choose_name' or @n = 'status'">
              <xsl:text>control</xsl:text>
            </xsl:when>
            <xsl:when test="@error = '1'">
	            <xsl:text>error</xsl:text>
            </xsl:when>
            <xsl:otherwise>
              <xsl:text>normal</xsl:text>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>

        <xsl:variable name="containerType2">
          <xsl:choose>
            <xsl:when test="@param_same_line_num > '0'">
              <xsl:text>sLpC</xsl:text>
            </xsl:when>
            <xsl:otherwise></xsl:otherwise>
          </xsl:choose>
        </xsl:variable>

        <xsl:variable name="formType">
          <xsl:choose>
            <xsl:when test="$form_type = 'response'">
              <xsl:text>response nInt</xsl:text>
            </xsl:when>
            <xsl:otherwise>
              <xsl:text></xsl:text>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>

        <xsl:variable name="containerPage">
          <xsl:value-of select='translate($page," >","_-")'/>
        </xsl:variable>

        <xsl:choose>

          <xsl:when test="@condition = 'hidden'">
            <xsl:for-each select="param">
              <input type="hidden" id="{@n}" name="p_{@n}" value="{@value}"/>
            </xsl:for-each>
          </xsl:when>

          <xsl:when test="@condition = 'disabled' or @condition = 'readonly'">

            <xsl:variable name="containerEdition">
              <xsl:choose>
                <xsl:when test="(@condition = 'readonly' or @pns = 'resume')">
                  <xsl:text>nEdC</xsl:text>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>EdC</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:variable>

            <xsl:variable name="tableBorder">
              <xsl:choose>
                <xsl:when test="$containerEdition = 'EdC' or $containerType = 'formControlContainer'">
                  <xsl:text>0</xsl:text>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>1</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:variable>

            <xsl:variable name="tableCellPadding">
              <xsl:choose>
                <xsl:when test="$containerEdition = 'EdC' or $containerType = 'formControlContainer'">
                  <xsl:text>1</xsl:text>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>5</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:variable>

            <div class="container {$formType} {$containerSchema} {$containerPage} container-{@num}">
              <fieldset class="{$containerEdition}">
                <xsl:if test="$title != '-' and $containerEdition = 'EdC'">
                  <legend>
                    <xsl:value-of select="$title"/>
                  </legend>
                </xsl:if>
 
                <div class="{$containerType} {$containerEdition}">
                  <table class="formContainer {$containerType2}" cellspacing="5" cellpadding="{$tableCellPadding}" border="{$tableBorder}">
		                <xsl:if test="$title != '-' and $containerEdition = 'nEdC' and $containerType = 'formContainer'">
		                  <tr>
                        <td colspan="4" class="nEdC title legend"><xsl:value-of select="$title"/></td>
                      </tr>
                    </xsl:if>
                    <xsl:call-template name='print-form_fields'></xsl:call-template>
                  </table>
                </div>
              </fieldset>
            </div>
            
          </xsl:when>

          <xsl:otherwise>

            <xsl:variable name="containerEdition">
              <xsl:choose>
                <xsl:when test="@pns = 'resume'">
                  <xsl:text>nEdC</xsl:text>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>EdC</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:variable>

            <xsl:variable name="status">
              <xsl:choose>
                <xsl:when test="@n = 'status'">
                  <xsl:text>status</xsl:text>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text></xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:variable>

            <xsl:choose>

              <xsl:when test="$db_view = '1' or $form_dialog = '1'">
                
                <span id='initContainerPosition_{@num}'></span>
                <xsl:choose>
                  <xsl:when test="$containerType = 'formContainer'">
                    <div class="container {$containerSchema} {$containerPage} container-{@num}">
                      <fieldset class="EdC">
                        <xsl:if test="$title != '-'">
                          <legend>
                            <xsl:value-of select="$title"/>
                          </legend>
                        </xsl:if>
                        <div class="{$containerType} {$containerEdition}">
                          <xsl:if test="preceding-sibling::node() and @pns = 'resume'">
                            <table class="dropDownContainer" cellspacing="2" cellpadding="3">
                              <tr>
                                <td id="containerAction_{@num}" class="containerAction" onclick="containerAction(this.id)">
                                  <span id="actionText_{@num}">Show data</span>
                                  <img id="actionIcon_{@num}" src="{$base_path}/int/js/custom/images/more.png"/>
                                </td>
                              </tr>
                            </table>
                          </xsl:if>
                          <table class="formContainer {$containerType2}" cellspacing="2" cellpadding="3">
                            <xsl:call-template name='print-form_fields'></xsl:call-template>
                          </table>
                        </div>
                      </fieldset>
                    </div>
                  </xsl:when>

                  <xsl:otherwise>
                    <div class="container {$containerSchema} {$containerPage} container-{@num}">
                    <fieldset class="nEdC {$status}">
                      <div class="formControlContainer">
                        <table class="formContainer {$containerType2}" cellspacing="2" cellpadding="3">
                          <xsl:call-template name='print-form_fields'></xsl:call-template>
                        </table>
                      </div>
                    </fieldset>
                    </div>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>

              <xsl:otherwise>
	              <span id='initContainerPosition_{@num}'></span>
                <div class="container {$formType} {$containerSchema} {$containerPage} container-{@num}">
                  <fieldset>
                    <legend>
                      <xsl:value-of select="$title"/>
                    </legend>
                    <div class="formContainer c">
                      <table class="formContainer {$containerType2}" cellspacing="2" cellpadding="3">
                        <xsl:call-template name='print-form_fields'></xsl:call-template>
                      </table>
                    </div>
                  </fieldset>
                </div>
              </xsl:otherwise>
            </xsl:choose>

          </xsl:otherwise>

        </xsl:choose>

      </xsl:when>

    </xsl:choose>

  </xsl:template>

  <xsl:template match="param[@state='hidden']">
    <input type="hidden" name="p_{@n}" value='{@value}'/>
  </xsl:template>

  <xsl:template match="condition">
    <xsl:if test="($form_type = 'new' or $form_type = 'edit')">
      <xsl:variable name="base_path">
        <xsl:value-of select="$base_path"/>
      </xsl:variable>
      <xsl:choose>
        <xsl:when test="not(@location) or @location=''">
          <td>
            <table class="expressions" cellpadding="0" cellspacing="0">
              <xsl:if test="@value != ''">
                <xsl:if test="not(@print) or (@print and @print='')">
                  <td style="padding:15pt 0 0 8pt">
                    <img id="img_{@n}" width="16" height="16" src="{$base_path}/int/js/custom/images/{@value}.png"></img>
                  </td>
                </xsl:if>
                <xsl:if test="@print and @print!=''">
                  <td style="padding:0 0 0 10pt">
                    <img id="img_{@n}" width="16" height="16" src="{$base_path}/int/js/custom/images/{@value}.png"></img>
                  </td>
                  <td id="condition_{@n}" style="padding-left:10pt">
                    <i>
                      <xsl:value-of select="@print" disable-output-escaping="yes"/>
                    </i>
                  </td>
                </xsl:if>
              </xsl:if>
            </table>
          </td>
        </xsl:when>
        <xsl:otherwise>
          <td>
            <table class="expressions" cellpadding="0" cellspacing="0">
              <xsl:if test="@value != ''">
                <xsl:if test="not(@print) or (@print and @print='')">
                  <td style="padding:0 0 0 10pt">
                    <img id="img_{@n}" width="15" height="15" src="{$base_path}/int/js/custom/images/{@value}.png"></img>
                  </td>
                </xsl:if>
                <xsl:if test="@print and @print!=''">
                  <td style="padding:0 0 0 10pt">
                    <img id="img_{@n}" width="15" height="15" src="{$base_path}/int/js/custom/images/{@value}.png"></img>
                  </td>
                  <td id="condition_{@n}" style="padding-left:5pt">
                    <i>
                      <xsl:value-of select="@print" disable-output-escaping="yes"/>
                    </i>
                  </td>
                </xsl:if>
              </xsl:if>
            </table>
          </td>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:if>
  </xsl:template>

  <xsl:template match="param">

    <xsl:variable name="inputTypes">,text,long text,date,time,file,formatted,numeric,options non-editable,options editable,options multiple non-editable,options multiple editable,button,table,expression,text expression,formatted expression,table,</xsl:variable>
    <xsl:variable name="inputLongTypes">,formatted,formatted expression,table,expression,</xsl:variable>
    <xsl:variable name="is_non_response_field" select="contains($inputTypes,concat(',',@field_type,',')) and not(@is_response)"/>
    <xsl:variable name="is_response_requires" select="($form_type = 'response' and string(@is_response)='1') or
		                                                  ($form_type != 'response' and string(@is_response)='0') or @is_response='both'"/>
    <xsl:variable name="is_response_denies" select="($form_type = 'response' and string(@is_response)='0') or
		                                                ($form_type != 'response' and string(@is_response)='1')"/>


    <xsl:if test="@n = $edit_choose_name or (not($is_response_denies) and ($is_response_requires or $is_non_response_field))">

        <xsl:variable name="n">
          <xsl:choose>
            <xsl:when test="@pn != ''">
              <xsl:value-of select="@pn"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="@n"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>

        <xsl:variable name="n_m">
          <xsl:choose>
            <xsl:when test="@pn != ''">
              <xsl:value-of select="translate(@pn,'ABCDEFGHIJKLMNOPQRSTUVWXYZ*','abcdefghijklmnopqrstuvwxyz ')"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="translate(@n,'ABCDEFGHIJKLMNOPQRSTUVWXYZ*','abcdefghijklmnopqrstuvwxyz ')"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>

        <xsl:variable name="colspan">
          <xsl:choose>
            <xsl:when test="@location = 'same_line' or following-sibling::param[@location = 'same_line']">
              <xsl:text>1</xsl:text>
            </xsl:when>
            <xsl:otherwise>
              <xsl:choose>
                <xsl:when test="preceding-sibling::node()">
                  <xsl:text>4</xsl:text>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:choose>
                    <xsl:when test="@field_type = 'formatted expression'">
                      <xsl:text>1</xsl:text>
                    </xsl:when>
                    <xsl:otherwise>
                      <xsl:text>4</xsl:text>
                    </xsl:otherwise>
                  </xsl:choose>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>

        <xsl:variable name="updating">
          <xsl:choose>
            <xsl:when test="$form_type != 'response' and $form_type != 'profile'">
              <xsl:choose>
                <xsl:when test="$form_dialog = '1'">
                  <xsl:text>dialogUpdate</xsl:text>
                </xsl:when>
                <xsl:when test="@field_type = 'options multiple non-editable'">
                  <xsl:text>mSelectUpdate</xsl:text>
                </xsl:when>
                <xsl:when test="$form_type != 'profile' and $form_type != 'table'">
                  <xsl:text>update</xsl:text>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>noUpdate</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:when>
            <xsl:otherwise>
              <xsl:text>noUpdate</xsl:text>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>

        <xsl:variable name="condition">
          <xsl:choose>
            <xsl:when test="@condition = 'disabled' or @condition = 'readonly'">
              <xsl:text>disabled: 'disabled',</xsl:text>
            </xsl:when>
            <xsl:otherwise></xsl:otherwise>
          </xsl:choose>
        </xsl:variable>

        <xsl:variable name="paramEdition">
          <xsl:choose>
            <xsl:when test="@condition = 'readonly'">
              <xsl:text>nEdP</xsl:text>
            </xsl:when>
            <xsl:otherwise></xsl:otherwise>
          </xsl:choose>
        </xsl:variable>

        <xsl:variable name="mMessage">
          <xsl:choose>
            <xsl:when test="@help != ''">
              <xsl:text>missingMessage: '</xsl:text>
              <xsl:value-of select="@help"/>
              <xsl:text>'</xsl:text>
            </xsl:when>
            <xsl:otherwise>
              <xsl:choose>
                <xsl:when test="$language = 'es'">
                  <xsl:text>missingMessage: 'Campo obligatorio'</xsl:text>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>missingMessage: 'Required </xsl:text>
                  <xsl:value-of select="$n_m"/>
                  <xsl:text>'</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>

        <xsl:variable name="iMessage">
          <xsl:choose>
            <xsl:when test="$language = 'es'">
              <xsl:text>invalidMessage: 'Campo inválido'</xsl:text>
            </xsl:when>
            <xsl:otherwise>
              <xsl:text>invalidMessage: 'Invalid </xsl:text>
              <xsl:value-of select="$n_m"/>
              <xsl:text>'</xsl:text>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:variable>

        <xsl:variable name="imMessages">
          <xsl:value-of select="$mMessage"></xsl:value-of>
          <xsl:text>,</xsl:text>
          <xsl:value-of select="$iMessage"></xsl:value-of>
        </xsl:variable>

        <xsl:if test="$n != '-' and @field_type != 'button' and not(contains($inputLongTypes,concat(',',@field_type,',')))">
          <xsl:if test="not(@condition) or @condition != 'hidden'">
            <xsl:choose>
              <xsl:when test="$form_type != 'response'">
                <xsl:if test="(@field_type != 'options non-editable' or (@field_type = 'options non-editable' and @values != '0,1' and @values != '1,0')) or @condition = 'readonly'">
                  <td class="fieldTitle">
                    <div class="fieldTitleBox">
                      <xsl:value-of select="$n" disable-output-escaping="yes"/>
                    </div>
                  </td>
                </xsl:if>
              </xsl:when>
              <xsl:otherwise>
                <xsl:variable name="fieldTitleType">
                  <xsl:choose>
                    <xsl:when test="@field_type = 'text expression'">
                      <xsl:text>textExpression</xsl:text>
                    </xsl:when>
                    <xsl:when test="@field_type = 'options non-editable' and (@values = '0,1' or @values = '1,0')">
                      <xsl:text>checkBox</xsl:text>
                    </xsl:when>
                    <xsl:otherwise></xsl:otherwise>
                  </xsl:choose>
                </xsl:variable>
                <td class="fieldTitle {$fieldTitleType}">
                  <div class="fieldTitleBox">
                    <xsl:value-of select="$n" disable-output-escaping="yes"/>
                  </div>
                </td>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:if>
        </xsl:if>

        <xsl:choose>

          <xsl:when test="@field_type = 'options non-editable' and (@values = '1,0' or @values = '0,1')">

            <xsl:variable name="colspanCheckBox">
              <xsl:choose>
                <xsl:when test="$form_type != 'response'">
                  <xsl:choose>
                    <xsl:when test="(not(@location) or @location != 'same_line') and following-sibling::param[1][not(@location) or @location != 'same_line']">
                      <xsl:text>4</xsl:text>
                    </xsl:when>
                    <xsl:otherwise>
                      <xsl:text>2</xsl:text>
                    </xsl:otherwise>
                  </xsl:choose>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>1</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:variable>

            <xsl:variable name="isRequiredCheckBox">
              <xsl:choose>
                <xsl:when test="@required = 'true'">
                  <xsl:text>required</xsl:text>
                </xsl:when>
                <xsl:otherwise></xsl:otherwise>
              </xsl:choose>
            </xsl:variable>

            <xsl:if test="@help and @help != '' and (not(@required) or @required = 'false')">
              <div data-dojo-type="dijit/Tooltip" class="dijitTooltip" data-dojo-props="connectId:'{@n}', label:'{@help}', position:['below']"></div>
            </xsl:if>

            <xsl:choose>
              <xsl:when test="@condition = 'hidden'">
                <input type="hidden" id="{@n}" name="p_{@n}" value="{@value}"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:if test="@condition = 'readonly'">
                  <input type="hidden" class="readonly hidden" name="p_{@n}" value="{@value}"/>
                </xsl:if>

                <td class="fieldInput checkBox {$paramEdition}" colspan="{$colspanCheckBox}">

                  <xsl:choose>
                    <xsl:when test="@value='1'">
                      <xsl:choose>
                        <xsl:when test="@condition = 'readonly'">
                          <div>Yes</div>
                        </xsl:when>
                        <xsl:otherwise>
                          <input data-dojo-type="dijit.form.CheckBox" required="{@required}" class="widget, {$isRequiredCheckBox}"
                                 data-dojo-props="id:'{@n}', name:'p_{@n}', value:'1', {$condition} checked:true, onClick:{$updating}, {$imMessages}">
                          </input>
                          <label id="label_{@n}" for="{@n}" style="vertical-align:middle">
                            &#160;<xsl:value-of select="$n"/>
                          </label>
                        </xsl:otherwise>
                      </xsl:choose>
                    </xsl:when>

                    <xsl:otherwise>
                      <xsl:choose>
                        <xsl:when test="@condition = 'readonly'">
                          <div>No</div>
                        </xsl:when>
                        <xsl:otherwise>
                          <input data-dojo-type="dijit.form.CheckBox" required="{@required}" class="widget, {$isRequiredCheckBox}"
                                 data-dojo-props="id:'{@n}', name:'p_{@n}', value:'1', {$condition} checked:false, onClick:{$updating}, {$imMessages}">
                          </input>
                          <label id="label_{@n}" for="{@n}" style="vertical-align:middle">
                            &#160;<xsl:value-of select="$n"/>
                          </label>
                        </xsl:otherwise>
                      </xsl:choose>
                    </xsl:otherwise>

                  </xsl:choose>

                </td>

              </xsl:otherwise>
            </xsl:choose>

          </xsl:when>

          <xsl:when test="@field_type = 'options non-editable' and @values != '' and (not(@values_tree) or @values_tree = '')">

            <xsl:variable name="first_value">
              <xsl:value-of select="substring-before(@values,',')"/>
            </xsl:variable>
            <xsl:variable name="second_value">
              <xsl:value-of select="substring-after(@values,',')"/>
            </xsl:variable>

            <xsl:choose>
              <xsl:when test="@condition = 'hidden'">
                <input type="hidden" id="{@n}" name="p_{@n}" value="{@value}"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:if test="@condition = 'readonly'">
                  <input type="hidden" class="readonly hidden" name="p_{@n}" value="{@value}"/>
                </xsl:if>
                <td>
                  <table cellspacing="0" cellpadding="0">
                    <td class="fieldInput" colspan="{$colspan}">
                      <xsl:choose>
                        <xsl:when test="@radio = '1'">

                          <xsl:if test="@help and @help != ''">
                            <div data-dojo-type="dijit/Tooltip" data-dojo-props="connectId:'radioButton', label:'{@help}', position:['above']"></div>
                          </xsl:if>

                          <table class="radioButton {$paramEdition}">
                            <xsl:choose>
                              <xsl:when test="@value = substring-before(@values,',')">
                                <td class="radioButton checked">
                                  <input data-dojo-type="dijit.form.RadioButton"
                                         data-dojo-props="id:'{@n}_1', name:'p_{@n}', value:'{$first_value}', {$condition} checked:true, onClick:{$updating}">
                                  </input>
                                  <label id="label_{@n}_1" for="{@n}_1">
                                    <xsl:value-of select="$first_value"/>
                                  </label>
                                </td>
                              </xsl:when>
                              <xsl:otherwise>
                                <td class="radioButton noChecked">
                                  <input data-dojo-type="dijit.form.RadioButton"
                                         data-dojo-props="id:'{@n}_1', name:'p_{@n}', value:'{$first_value}', {$condition} checked:false, onClick:{$updating}">
                                  </input>
                                  <label id="label_{@n}_1" for="{@n}_1">
                                    <xsl:value-of select="$first_value"/>
                                  </label>
                                </td>
                              </xsl:otherwise>
                            </xsl:choose>
                            <xsl:choose>
                              <xsl:when test="@value = substring-after(@values,',')">
                                <td class="radioButton checked">
                                  <input data-dojo-type="dijit.form.RadioButton"
                                         data-dojo-props="id:'{@n}_2', name:'p_{@n}', value:'{$second_value}', {$condition} checked:true, onClick:{$updating}">
                                  </input>
                                  <label id="label_{@n}_2" for="{@n}_2">
                                    <xsl:value-of select="$second_value"/>
                                  </label>
                                </td>
                              </xsl:when>
                              <xsl:otherwise>
                                <td class="radioButton noChecked">
                                  <input data-dojo-type="dijit.form.RadioButton"
                                         data-dojo-props="id:'{@n}_2', name:'p_{@n}', value:'{$second_value}', {$condition} checked:false, onClick:{$updating}">
                                  </input>
                                  <label id="label_{@n}_2" for="{@n}_2">
                                    <xsl:value-of select="$second_value"/>
                                  </label>
                                </td>
                              </xsl:otherwise>
                            </xsl:choose>
                          </table>
                        </xsl:when>

                        <xsl:otherwise>

                          <xsl:if test="@help and @help != ''">
                            <div data-dojo-type="dijit/Tooltip" data-dojo-props="connectId:'{@n}', label:'{@help}', position:['above']"></div>
                          </xsl:if>

                          <xsl:variable name="selectionType">
                            <xsl:choose>
                              <xsl:when test="string-length(@values) &lt; 500">
                                <xsl:text>dijit.form.Select</xsl:text>
                              </xsl:when>
                              <xsl:otherwise>
                                <xsl:text>dijit.form.FilteringSelect</xsl:text>
                              </xsl:otherwise>
                            </xsl:choose>
                          </xsl:variable>

                          <xsl:variable name="selectionClass">
                            <xsl:choose>
                              <xsl:when test="string-length(@values) &lt; 500">
                                <xsl:text>readonly</xsl:text>
                              </xsl:when>
                              <xsl:otherwise></xsl:otherwise>
                            </xsl:choose>
                          </xsl:variable>

                          <xsl:variable name="selection">
                            <xsl:text>Focused_Selection</xsl:text>
                          </xsl:variable>

                          <table class="select {$paramEdition}" cellpadding="0" cellspacing="0">
                            <td>
                              <select data-dojo-type="{$selectionType}" class="widget {$selectionClass}" required="{@required}"
                                      data-dojo-props="id:'{@n}', name:'p_{@n}', value:'{@value}', {$condition} maxHeight:'200', onClick:{$selection}, onChange:{$updating}, {$imMessages}">
                                <xsl:call-template name='print-option'>
                                  <xsl:with-param name="valueList" select="@values"/>
                                  <xsl:with-param name="defaultValue" select="@value"/>
                                </xsl:call-template>
                              </select>
                            </td>
                          </table>
                        </xsl:otherwise>
                      </xsl:choose>
                    </td>
                    <xsl:if test="@units">
                      <td class="fieldUnits units">
                        <xsl:value-of select="@units"/>
                      </td>
                    </xsl:if>
                  </table>
                </td>
              </xsl:otherwise>
            </xsl:choose>

          </xsl:when>

          <xsl:when test="@field_type = 'options non-editable' and @values_tree != ''">

            <xsl:choose>
              <xsl:when test="@condition = 'hidden'">
                <input type="hidden" id="{@n}" name="p_{@n}" value="{@value}"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:if test="@condition = 'readonly'">
                  <input type="hidden" class="readonly hidden" name="p_{@n}" value="{@value}"/>
                </xsl:if>
                <td>
                  <table cellspacing="0" cellpadding="0">
                    <td class="fieldInput filterTreeSelect" colspan="{$colspan}">
                      <table class="select {$paramEdition}" cellpadding="0" cellspacing="0">
                        <td>
                          <input id="{@n}"></input>

                          <xsl:variable name="optionsTreeNoEditableStorageScript">
                            var numOpT = <xsl:value-of select="@options_tree_num"/>;

                            var data = [
                            <xsl:variable name="data_count">1</xsl:variable>
                            <xsl:call-template name='print-tree-option'>
                              <xsl:with-param name="values" select="@values"/>
                              <xsl:with-param name="label-values" select="@label_values"/>
                              <xsl:with-param name="name-values" select="@name_values"/>
                              <xsl:with-param name="count" select="$data_count"/>
                            </xsl:call-template>
                            ];

                            _optionsTreeWidgetStorage[numOpT] = new Array();
                            _optionsTreeWidgetStorage[numOpT][0] = 'options non-editable';
                            _optionsTreeWidgetStorage[numOpT][1] = '<xsl:value-of select="@n"></xsl:value-of>';
                            _optionsTreeWidgetStorage[numOpT][2] = '<xsl:value-of select="@value"></xsl:value-of>';
                            _optionsTreeWidgetStorage[numOpT][3] = '<xsl:value-of select="@condition"></xsl:value-of>';
                            _optionsTreeWidgetStorage[numOpT][4] = '<xsl:value-of select="@required"></xsl:value-of>';
                            _optionsTreeWidgetStorage[numOpT][5] = data;
                            _optionsTreeWidgetStorage[numOpT][6] = '<xsl:value-of select="$edit_choose_name"/>';
                          </xsl:variable>

                          <script type="text/javascript">
                            <xsl:value-of select="normalize-space($optionsTreeNoEditableStorageScript)"/>
                          </script>

                        </td>
                      </table>
                    </td>
                  </table>
                </td>
              </xsl:otherwise>
            </xsl:choose>

          </xsl:when>

          <xsl:when test="@field_type = 'options editable' and @values != '' and (not(@values_tree) or @values_tree = '')">

            <xsl:if test="@help and @help != ''">
              <div data-dojo-type="dijit/Tooltip" data-dojo-props="connectId:'{@n}', label:'{@help}', position:['above']"></div>
            </xsl:if>

            <xsl:choose>
              <xsl:when test="@condition = 'hidden'">
                <input type="hidden" id="{@n}" name="p_{@n}" value="{@value}"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:if test="@condition = 'readonly'">
                  <input type="hidden" class="readonly hidden" name="p_{@n}" value="{@value}"/>
                </xsl:if>
                <td>
                  <table cellspacing="0" cellpadding="0">
                    <td class="fieldInput" colspan="{$colspan}">
                      <table class="select {$paramEdition}" cellpadding="0" cellspacing="0">
                        <td>
                          <select data-dojo-type="dijit.form.ComboBox" class="widget" required="{@required}"
                                  data-dojo-props="id:'{@n}', name:'p_{@n}', value:'{@value}', {$condition} maxHeight:'200', onChange:{$updating}, {$imMessages}">
                            <xsl:call-template name='print-option'>
                              <xsl:with-param name="valueList" select="@values"/>
                              <xsl:with-param name="defaultValue" select="@value"/>
                            </xsl:call-template>
                          </select>
                        </td>
                      </table>
                    </td>
                    <xsl:if test="@units">
                      <td class="fieldUnits units">
                        <xsl:value-of select="@units"/>
                      </td>
                    </xsl:if>
                  </table>
                </td>
              </xsl:otherwise>
            </xsl:choose>

          </xsl:when>

          <xsl:when test="@field_type = 'options editable' and @values_tree != ''">

            <xsl:choose>
              <xsl:when test="@condition = 'hidden'">
                <input type="hidden" id="{@n}" name="p_{@n}" value="{@value}"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:if test="@condition = 'readonly'">
                  <input type="hidden" class="readonly hidden" name="p_{@n}" value="{@value}"/>
                </xsl:if>
                <td>
                  <table cellspacing="0" cellpadding="0">
                    <td class="fieldInput filterTreeSelect" colspan="{$colspan}">
                      <table class="select {$paramEdition}" cellpadding="0" cellspacing="0">
                        <td>
                          <input id="{@n}"></input>

                          <xsl:variable name="optionsTreeEditableStorageScript">
                            var numOpT = <xsl:value-of select="@options_tree_num"/>;

                            var data = [
                            <xsl:variable name="data_count">1</xsl:variable>
                            <xsl:call-template name='print-tree-option'>
                              <xsl:with-param name="values" select="@values"/>
                              <xsl:with-param name="label-values" select="@label_values"/>
                              <xsl:with-param name="name-values" select="@name_values"/>
                              <xsl:with-param name="count" select="$data_count"/>
                            </xsl:call-template>
                            ];

                            _optionsTreeWidgetStorage[numOpT] = new Array();
                            _optionsTreeWidgetStorage[numOpT][0] = 'options editable';
                            _optionsTreeWidgetStorage[numOpT][1] = '<xsl:value-of select="@n"></xsl:value-of>';
                            _optionsTreeWidgetStorage[numOpT][2] = '<xsl:value-of select="@value"></xsl:value-of>';
                            _optionsTreeWidgetStorage[numOpT][3] = '<xsl:value-of select="@condition"></xsl:value-of>';
                            _optionsTreeWidgetStorage[numOpT][4] = '<xsl:value-of select="@required"></xsl:value-of>';
                            _optionsTreeWidgetStorage[numOpT][5] = data;
                            _optionsTreeWidgetStorage[numOpT][6] = '<xsl:value-of select="$edit_choose_name"/>';
                          </xsl:variable>

                          <script type="text/javascript">
                            <xsl:value-of select="normalize-space($optionsTreeEditableStorageScript)"/>
                          </script>

                        </td>
                      </table>
                    </td>
                  </table>
                </td>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:when>

          <xsl:when test="@field_type = 'options multiple non-editable'">

            <xsl:if test="@help and @help != ''">
              <div data-dojo-type="dijit/Tooltip" data-dojo-props="connectId:'{@n}', label:'{@help}', position:['above']"></div>
            </xsl:if>

            <xsl:choose>
              <xsl:when test="@condition = 'hidden'">
                <input type="hidden" id="{@n}" name="p_{@n}" value="{@value}"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:if test="@condition = 'readonly'">
                  <input type="hidden" class="readonly hidden" name="p_{@n}" value="{@value}"/>
                </xsl:if>
                <input type="hidden" id="mSelect_status_{@n}" name="p_mSelect_status_{@n}" value="{@status_value}"></input>
                <td>
                  <table class="mSelect {$paramEdition}" cellspacing="0" cellpadding="0">
                    <td class="fieldInput">
                      <table id="mSelectWidget_{@n}" class="mSelectWidget {@condition}" cellspacing="0" cellpadding="0">
                        <td class="mSelectInput">
                          <div id="mSelectData_{@n}" class="mSelectData" onmouseover="Hovered_mSelect('{@n}')" onmouseout="UnHovered_mSelect('{@n}')">
                            <xsl:value-of select="@value"/>
                          </div>
                          <select data-dojo-type="dojox.form.CheckedMultiSelect" class="mSelectBox" required="{@required}" multiple="true"
                                  data-dojo-props="id:'{@n}', name:'p_{@n}', maxHeight:'200', {$condition} onChange:{$updating}, {$imMessages}">
                            <xsl:call-template name='print-multiple-option'>
                              <xsl:with-param name="valueList" select="@values"/>
                              <xsl:with-param name="defaultValues" select="@value"/>
                            </xsl:call-template>
                          </select>
                        </td>
                        <td id="mSelectTableButton_{@n}" class="mSelectButton">
                          <div id="mSelectButton_{@n}">
                            <button data-dojo-type="dijit.form.Button" baseClass="_mSelectButton"
                                    data-dojo-props="type:'button', id:'mSelectButton_{@n}', {$condition} onMouseEnter:Hovered_mSelect_Button, onMouseLeave:UnHovered_mSelect_Button">
                              <script type="dojo/connect" data-dojo-event="onClick" data-dojo-args="evt">
                                Open_mSelectBox('<xsl:value-of select="@n"/>');
                              </script>
                            </button>
                          </div>
                        </td>
                      </table>
                    </td>
                  </table>
                </td>
              </xsl:otherwise>
            </xsl:choose>

          </xsl:when>

          <xsl:when test="@field_type = 'options multiple editable'">

            <xsl:if test="@help and @help != ''">
              <div data-dojo-type="dijit/Tooltip" data-dojo-props="connectId:'{@n}', label:'{@help}', position:['above']"></div>
            </xsl:if>

            <xsl:choose>
              <xsl:when test="@condition = 'hidden'">
                <input type="hidden" id="{@n}" name="p_{@n}" value="{@value}"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:if test="@condition = 'readonly'">
                  <input type="hidden" class="readonly hidden" name="p_{@n}" value="{@value}"/>
                </xsl:if>
                <td class="fieldInput" colspan="{$colspan}">
                  <table class="mSelect {$paramEdition}" cellspacing="0" cellpadding="0">
                    <td style="padding: 2pt">
                      <i>Not available</i>
                    </td>
                  </table>
                </td>
              </xsl:otherwise>
            </xsl:choose>

          </xsl:when>

          <xsl:when test="@field_type = 'text expression'">

            <xsl:if test="@help and @help != ''">
              <div data-dojo-type="dijit/Tooltip" data-dojo-props="connectId:'{@n}', label:'{@help}', position:['above']"></div>
            </xsl:if>

            <xsl:choose>
              <xsl:when test="@condition = 'hidden'">
                <input type="hidden" id="{@n}" name="p_{@n}" value="{@value}"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:if test="@condition = 'readonly'">
                  <input type="hidden" class="readonly hidden" name="p_{@n}" value="{@value}"/>
                </xsl:if>
                <xsl:choose>
                  <xsl:when test="$form_type != 'response' and (not(@is_response) or @is_response = '1')">
                    <input type="hidden" id="{@n}" name="p_{@n}" value="{@value}"/>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:choose>
                      <xsl:when test="@location = 'same_line'">
                        <td class="fieldInput textExpression">
                          <table class="textExpression" cellpadding="0" cellspacing="0">
                            <xsl:choose>
                              <xsl:when test="$form_type != 'response' and string-length(@value) &gt; 50">
                                <td class="fieldInput textExpression">
                                  <input data-dojo-type="dijit.form.SimpleTextarea" class="widget" rows="2" required="{@required}"
                                         data-dojo-props="id:'{@n}', name:'p_{@n}', value:'{@value}', onfocus:'this.blur()', readonly:'readonly'">
                                  </input>
                                </td>
                              </xsl:when>
                              <xsl:otherwise>
                                <td id="{@n}">
                                  <xsl:value-of select="@value" disable-output-escaping="yes"/>
                                  <xsl:text>&#160;</xsl:text>
                                  <xsl:value-of select="@units"></xsl:value-of>
                                </td>
                                <input type="hidden" id="{@n}" name="p_{@n}" value="{@value}"/>
                              </xsl:otherwise>
                            </xsl:choose>
                          </table>
                        </td>
                      </xsl:when>
                      <xsl:otherwise>
                        <td class="fieldInput textExpression">
                          <table class="textExpression" cellspacing="0" cellpadding="0">
                            <td id="{@n}">
                              <xsl:value-of select="@value" disable-output-escaping="yes"/>
                              <xsl:text>&#160;</xsl:text>
                              <xsl:value-of select="@units"></xsl:value-of>
                            </td>
                            <input type="hidden" id="{@n}" name="p_{@n}" value="{@value}"/>
                          </table>
                        </td>
                      </xsl:otherwise>
                    </xsl:choose>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:otherwise>
            </xsl:choose>

          </xsl:when>

          <xsl:when test="@field_type = 'formatted expression'">

            <xsl:if test="@help and @help != ''">
              <div data-dojo-type="dijit/Tooltip" data-dojo-props="connectId:'{@n}', label:'{@help}', position:['above']"></div>
            </xsl:if>

            <xsl:choose>
              <xsl:when test="@condition = 'hidden'">
                <input type="hidden" id="{@n}" name="p_{@n}" value="{@value}"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:if test="@condition = 'readonly'">
                  <input type="hidden" class="readonly hidden" name="p_{@n}" value="{@value}"/>
                </xsl:if>
                <xsl:choose>
                  <xsl:when test="$form_type != 'response' and (not(@is_response) or @is_response = '1')">
                    <input type="hidden" id="{@n}" name="p_{@n}" value="{@value}"/>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:choose>
                      <xsl:when test="@condition='readonly' or parent::container[@n = 'status'] or parent::container[@n = 'edit_choose_name']">
                        <td id="{@n}" class="fieldInput formattedExpression" colspan="{$colspan}">
                          <xsl:value-of select="@value" disable-output-escaping="yes"/>
                        </td>
                      </xsl:when>
                      <xsl:otherwise>
                        <xsl:choose>
                          <xsl:when test="string-length(@value) &gt; 500 and (not(@chart) or @chart = '0') and not(@min_max_height)">
                            <td class="fieldInput editor" colspan="4">
                              <table cellspacing="0" cellpadding="0">
                                <xsl:if test="$n != '-'">
                                  <tr>
                                    <td class="fieldTitle">
                                      <xsl:value-of select="$n" disable-output-escaping="yes"/>:
                                    </td>
                                  </tr>
                                </xsl:if>
                                <tr>
                                  <td>
                                    <div data-dojo-type="dijit.Editor" class="formatted" required="{@required}" style="font-size:75% !important"
                                         data-dojo-props="id:'e_{@n}', name:'p_e_{@n}', disabled:'disabled'">
                                      <xsl:value-of select="@value" disable-output-escaping="yes"/>
                                    </div>
                                  </td>
                                </tr>
                              </table>
                            </td>
                          </xsl:when>
                          <xsl:otherwise>
                            <xsl:variable name="chart">
                              <xsl:choose>
                                <xsl:when test="not(@chart) or @chart = '0'"></xsl:when>
                                <xsl:otherwise>chart</xsl:otherwise>
                              </xsl:choose>
                            </xsl:variable>
                            <xsl:choose>
                              <xsl:when test="not(@chart) or @chart = '0'">
                                <xsl:if test="$n != '-'">
                                  <td class="fieldTitle">
                                    <xsl:value-of select="$n" disable-output-escaping="yes"/>
                                  </td>
                                </xsl:if>
                                <td id="{@n}" class="fieldInput formattedExpression" colspan="{$colspan}">
                                  <xsl:value-of select="@value" disable-output-escaping="yes"/>
                                </td>
                              </xsl:when>
                              <xsl:otherwise>
                                <xsl:variable name="chartWidgetScript">
                                  var numC = <xsl:value-of select="@chart_num"/>;
                                  _chartWidgetStorage[numC] = new Array();
                                  _chartWidgetStorage[numC][0] = '<xsl:value-of select="@type"></xsl:value-of>';
                                  _chartWidgetStorage[numC][1] = '<xsl:value-of select="@pn"></xsl:value-of>';
                                  _chartWidgetStorage[numC][2] = '<xsl:value-of select="@xaxisname"></xsl:value-of>';
                                  _chartWidgetStorage[numC][3] = '<xsl:value-of select="@yaxisname"></xsl:value-of>';
                                  _chartWidgetStorage[numC][4] = '<xsl:value-of select="@radius"></xsl:value-of>';
                                  _chartWidgetStorage[numC][5] = '<xsl:value-of select="@labels"></xsl:value-of>';
                                  _chartWidgetStorage[numC][6] = '<xsl:value-of select="@colours"></xsl:value-of>';
                                  _chartWidgetStorage[numC][7] = '<xsl:value-of select="@legend"></xsl:value-of>';
                                  _chartWidgetStorage[numC][8] = '<xsl:value-of select="@dataX"></xsl:value-of>';
                                  _chartWidgetStorage[numC][9] = '<xsl:value-of select="@data"></xsl:value-of>';
                                </xsl:variable>

                                <xsl:variable name="colspanChart">
                                  <xsl:choose>
                                    <xsl:when test="not(@location)">
                                      <xsl:choose>
                                        <xsl:when test="not(following-sibling::node()) or 
                                                (following-sibling::node() and following-sibling::param[1][@location != 'same_line'])">
                                          <xsl:text>4</xsl:text>
                                        </xsl:when>
                                        <xsl:otherwise>
                                          <xsl:text>2</xsl:text>
                                        </xsl:otherwise>
                                      </xsl:choose>
                                    </xsl:when>
                                    <xsl:otherwise>
                                      <xsl:text>2</xsl:text>
                                    </xsl:otherwise>
                                  </xsl:choose>
                                </xsl:variable>

                                <td id="{@n}" class="formattedExpression {$chart} {@display}" colspan="{$colspanChart}">
                                  <input type="hidden" id="fC_n_{@n}" value="{@chart_num}"></input>
                                  <div id="chart_{@n}_Warning" class="chartWarning inactiveChartWarning"></div>
                                  <div id="chart_{@n}_PL" class="chartPL contentChartPreloader"></div>
                                  <div id="chart_{@n}" class="fieldChart chartNode {@display}"></div>
                                  <div id="chart_{@n}_Legend" class="chartLegend {@display}"></div>
                                  <script type="text/javascript">
                                    <xsl:value-of select="normalize-space($chartWidgetScript)"/>
                                  </script>
                                </td>
                              </xsl:otherwise>
                            </xsl:choose>
                          </xsl:otherwise>
                        </xsl:choose>
                      </xsl:otherwise>
                    </xsl:choose>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:otherwise>
            </xsl:choose>

          </xsl:when>

          <xsl:when test="@field_type = 'long text'">

            <xsl:variable name="class">
              <xsl:choose>
                <xsl:when test="@n = '_incidence'">longTextIncidence</xsl:when>
                <xsl:otherwise>longText</xsl:otherwise>
              </xsl:choose>
            </xsl:variable>

            <xsl:if test="@help and @help != ''">
              <div data-dojo-type="dijit/Tooltip" data-dojo-props="connectId:'{@n}', label:'{@help}', position:['above']"></div>
            </xsl:if>

            <xsl:choose>
              <xsl:when test="@condition = 'hidden'">
                <input type="hidden" id="{@n}" name="p_{@n}" value="{@value}"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:if test="@condition = 'readonly'">
                  <input type="hidden" class="readonly hidden" name="p_{@n}" value="{@value}"/>
                </xsl:if>
                <td>
                  <table class="{$class} {$paramEdition}" cellpadding="0" cellspacing="0">
                    <td class="fieldInput">
                      <input data-dojo-type="dijit.form.SimpleTextarea"
                             data-dojo-props="id:'{@n}', name:'p_{@n}', value:'{@value}', {$condition} onKeyUp:{$updating}, {$imMessages}">
                      </input>
                    </td>
                  </table>
                </td>
              </xsl:otherwise>
            </xsl:choose>

          </xsl:when>

          <xsl:when test="@field_type = 'text'">

            <xsl:if test="@help and @help != ''">
              <div data-dojo-type="dijit/Tooltip" data-dojo-props="connectId:'{@n}', label:'{@help}', position:['above']"></div>
            </xsl:if>

            <xsl:choose>
              <xsl:when test="@condition = 'hidden'">
                <input type="hidden" id="{@n}" name="p_{@n}" value="{@value}"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:if test="@condition = 'readonly'">
                  <input type="hidden" class="readonly hidden" name="p_{@n}" value="{@value}"/>
                </xsl:if>
                <td>
                  <table cellspacing="0" cellpadding="0">
                    <td class="fieldInput" colspan="{$colspan}">
                      <table class="text {$paramEdition}" cellpadding="0" cellspacing="0">
                        <td>
                          <input data-dojo-type="dijit.form.ValidationTextBox" class="widget" required="{@required}"
                                 data-dojo-props="id:'{@n}', name:'p_{@n}', value:'{@value}', {$condition} onKeyUp:{$updating}, {$imMessages}">
                          </input>
                        </td>
                      </table>
                    </td>
                    <xsl:if test="@units">
                      <td class="fieldUnits units">
                        <xsl:value-of select="@units"/>
                      </td>
                    </xsl:if>
                  </table>
                </td>
              </xsl:otherwise>
            </xsl:choose>

          </xsl:when>

          <xsl:when test="@field_type = 'date'">

            <xsl:variable name="constraints_date">{datePattern:'yy-MM-dd'}</xsl:variable>
            <xsl:variable name="dateWidgetClass">
              <xsl:choose>
                <xsl:when test="@condition = 'disabled'">
                  <xsl:text>dateWidgetDisabled</xsl:text>
                </xsl:when>
                <xsl:when test="@condition = 'readonly'">
                  <xsl:text>dateWidgetDisabled nEdP</xsl:text>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>dateWidget</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:variable>
            <xsl:variable name="selectMenuDateScript">
              dateWidgetSelection('<xsl:value-of select="@n"/>');
            </xsl:variable>

            <xsl:if test="@help and @help != ''">
              <div data-dojo-type="dijit/Tooltip" data-dojo-props="connectId:'{@n}', label:'{@help}', position:['above']"></div>
            </xsl:if>

            <xsl:choose>
              <xsl:when test="@condition = 'hidden'">
                <input type="hidden" id="{@n}" name="p_{@n}" value="{@value}"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:if test="@condition = 'readonly'">
                  <input type="hidden" class="readonly hidden" name="p_{@n}" value="{@value}"/>
                </xsl:if>
                <td>
                  <table cellspacing="0" cellpadding="0">
                    <td class="fieldInput" colspan="{$colspan}">
                      <table class="date" cellspacing="0" cellpadding="0">
                        <td>
                          <table id="dateWidget_{@n}" class="{$dateWidgetClass}" cellspacing="0" cellpadding="0">
                            <td class="dateInput">
                              <xsl:choose>
                                <xsl:when test="@value = ''">
                                  <input data-dojo-type="dijit.form.DateTextBox" class="widget date" required="{@required}"
                                         data-dojo-props="id:'{@n}',name:'p_{@n}', {$condition} constraints:{$constraints_date}, onChange:{$updating}, onKeyPress:{$updating}, onMouseEnter:Hovered_Date, onClick:Focused_Date, onMouseLeave: UnHovered_Date, onBlur:UnFocused_Date">
                                  </input>
                                </xsl:when>
                                <xsl:otherwise>
                                  <input data-dojo-type="dijit.form.DateTextBox" class="widget date" required="{@required}"
                                         data-dojo-props="id:'{@n}', name:'p_{@n}', value:'{@value}', {$condition} constraints:{$constraints_date}, onChange:{$updating}, onKeyPress:{$updating}, onMouseEnter:Hovered_Date, onClick:Focused_Date, onMouseLeave: UnHovered_Date, onBlur:UnFocused_Date">
                                  </input>
                                </xsl:otherwise>
                              </xsl:choose>
                            </td>
                            <td id="dateTableButton_{@n}" class="dateButton">
                              <div data-dojo-type="dijit.form.DropDownButton"
                                   data-dojo-props="id:'dateButton_{@n}', {$condition} iconClass:'dateIcon', onMouseEnter:Hovered_Date_Button, onMouseLeave:UnHovered_Date_Button">
                                <span></span>
                                <div data-dojo-type="dijit.Menu" data-dojo-props="id:'dateMenu_{@n}'">
                                  <div data-dojo-type="dijit.MenuItem" data-dojo-props="iconClass:'dijitIconTable'">
                                    <xsl:value-of select="@pD_sel_n"/>
                                    <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                                      <xsl:value-of select="normalize-space($selectMenuDateScript)"/>
                                    </script>
                                  </div>
                                  <div data-dojo-type="dijit.MenuItem" data-dojo-props="iconClass:'todayIcon'">
                                    <xsl:value-of select="@pD_today_n"/>
                                    <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                                      dijit.byId('<xsl:value-of select="@n"/>').set('value',new Date());<xsl:value-of select="$updating"/>;
                                    </script>
                                  </div>
                                  <div data-dojo-type="dijit.MenuItem" data-dojo-props="iconClass:'dijitIconDelete'">
                                    <xsl:value-of select="@pD_rem_n"/>
                                    <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                                      dijit.byId('<xsl:value-of select="@n"/>').set('value',null);<xsl:value-of select="$updating"/>
                                    </script>
                                  </div>
                                </div>
                              </div>
                            </td>
                          </table>
                        </td>
                      </table>
                    </td>
                    <xsl:if test="@units">
                      <td class="fieldUnits units">
                        <xsl:value-of select="@units"/>
                      </td>
                    </xsl:if>
                  </table>
                </td>
              </xsl:otherwise>
            </xsl:choose>

          </xsl:when>

          <xsl:when test="@field_type = 'time'">

            <xsl:variable name="constraints_time">{timePattern: 'HH:mm', clickableIncrement: 'T00:30:00', visibleIncrement: 'T02:00:00', visibleRange: 'T02:00:00'}</xsl:variable>
            <xsl:variable name="timeWidgetClass">
              <xsl:choose>
                <xsl:when test="@condition='disabled'">
                  <xsl:text>timeWidgetDisabled</xsl:text>
                </xsl:when>
                <xsl:when test="@condition='readonly'">
                  <xsl:text>timeWidgetDisabled nEdP</xsl:text>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>timeWidget</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:variable>
            <xsl:variable name="selectMenuTimeScript">
              timeWidgetSelection('<xsl:value-of select="@n"/>');
            </xsl:variable>

            <xsl:if test="@help and @help != ''">
              <div data-dojo-type="dijit/Tooltip" data-dojo-props="connectId:'{@n}', label:'{@help}', position:['above']"></div>
            </xsl:if>

            <xsl:choose>
              <xsl:when test="@condition = 'hidden'">
                <input type="hidden" id="{@n}" name="p_{@n}" value="{@value}"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:if test="@condition = 'readonly'">
                  <input type="hidden" class="readonly hidden" name="p_{@n}" value="{@value}"/>
                </xsl:if>
                <td>
                  <table cellspacing="0" cellpadding="0">
                    <td class="fieldInput" colspan="{$colspan}">
                      <table class="time" cellspacing="0" cellpadding="0">
                        <td>
                          <table id="timeWidget_{@n}" class="{$timeWidgetClass}" cellspacing="0" cellpadding="0">
                            <td class="timeInput">
                              <xsl:choose>
                                <xsl:when test="@value = ''">
                                  <input data-dojo-type="dijit.form.TimeTextBox" class="widget time" required="{@required}"
                                         data-dojo-props="id:'{@n}', name:'p_{@n}', {$condition} constraints:{$constraints_time}, maxHeight:'200', onChange:{$updating}, onKeyPress:{$updating}, onMouseEnter:Hovered_Time, onClick:Focused_Time, onMouseLeave: UnHovered_Time, onBlur:UnFocused_Time">
                                  </input>
                                </xsl:when>
                                <xsl:otherwise>
                                  <input data-dojo-type="dijit.form.TimeTextBox" class="widget time" required="{@required}"
                                         data-dojo-props="id:'{@n}', name:'p_{@n}', value:'{@value}', {$condition} constraints:{$constraints_time}, maxHeight:'200', onChange:{$updating}, onKeyPress:{$updating}, onMouseEnter:Hovered_Time, onClick:Focused_Time, onMouseLeave: UnHovered_Time, onBlur:UnFocused_Time">
                                  </input>
                                </xsl:otherwise>
                              </xsl:choose>
                            </td>
                            <td id="timeTableButton_{@n}" class="timeButton">
                              <div data-dojo-type="dijit.form.DropDownButton"
                                   data-dojo-props="id:'timeButton_{@n}', {$condition} iconClass:'timeIcon', onMouseEnter:Hovered_Time_Button, onMouseLeave:UnHovered_Time_Button">
                                <span></span>
                                <div data-dojo-type="dijit.Menu" data-dojo-props="id:'timeMenu_{@n}'">
                                  <div data-dojo-type="dijit.MenuItem" data-dojo-props="iconClass:'dijitIconTable'">
                                    <xsl:value-of select="@pT_sel_n"/>
                                    <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                                      <xsl:value-of select="normalize-space($selectMenuTimeScript)"/>
                                    </script>
                                  </div>
                                  <div data-dojo-type="dijit.MenuItem" data-dojo-props="iconClass:'dijitIconDelete'">
                                    <xsl:value-of select="@pT_rem_n"/>
                                    <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                                      dijit.byId('<xsl:value-of select="@n"/>').set('value',null);<xsl:value-of select="$updating"/>
                                    </script>
                                  </div>
                                </div>
                              </div>
                            </td>
                          </table>
                        </td>
                      </table>
                    </td>
                    <xsl:if test="@units">
                      <td class="fieldUnits units">
                        <xsl:value-of select="@units"/>
                      </td>
                    </xsl:if>
                  </table>
                </td>
              </xsl:otherwise>
            </xsl:choose>

          </xsl:when>

          <xsl:when test="@field_type = 'file'">

            <xsl:variable name="fileWidgetCondition">
              <xsl:choose>
                <xsl:when test="@condition='disabled'">
                  <xsl:text>disabled: 'disabled',</xsl:text>
                </xsl:when>
                <xsl:otherwise></xsl:otherwise>
              </xsl:choose>
            </xsl:variable>
            <xsl:variable name="fileWidgetClass">
              <xsl:choose>
                <xsl:when test="@condition = 'disabled'">
                  <xsl:text>fileWidgetDisabled</xsl:text>
                </xsl:when>
                <xsl:when test="@condition = 'readonly'">
                  <xsl:text>fileWidgetDisabled nEdP</xsl:text>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>fileWidget</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:variable>
            <xsl:variable name="fileWidgetType">
              <xsl:choose>
                <xsl:when test="@signature_required = '1'">
                  <xsl:text>fileSignature</xsl:text>
                </xsl:when>
                <xsl:otherwise></xsl:otherwise>
              </xsl:choose>
            </xsl:variable>
            <xsl:variable name="fileWidgetSignature">
              <xsl:choose>
                <xsl:when test="@signature_required = '1'">
                  <xsl:text>signature_required: '1', accept:'application/pdf'</xsl:text>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>signature_required: '0'</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:variable>
            <xsl:variable name="fileWidgetIcon">
              <xsl:choose>
                <xsl:when test="@signature_required = '1'">
                  <xsl:text>filePDFIcon</xsl:text>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>fileIcon</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:variable>
            <xsl:variable name="selectMenuFileScript">
              fileWidgetSelection('<xsl:value-of select="@n"/>');
            </xsl:variable>
            <xsl:variable name="clearMenuFileScript">
              fileWidgetClear('<xsl:value-of select="@n"/>','<xsl:value-of select="@signature_required"/>');
              <xsl:value-of select="$updating"/>();
            </xsl:variable>

            <xsl:if test="@help and @help != ''">
              <div data-dojo-type="dijit/Tooltip" data-dojo-props="connectId:'{@n}', label:'{@help}', position:['above']"></div>
            </xsl:if>

            <input type="hidden" id="file_status_{@n}" name="p_file_status_{@n}" value="{@value}"></input>

            <xsl:if test="@signature_required = '1'">
              <xsl:variable name="signatureInfoScript">
                function sig_info<xsl:value-of select="@n"/> (id, depth) { fM_s_info ('<xsl:value-of select="@n"/>', id, depth); }
              </xsl:variable>
              <script type="text/javascript">
                <xsl:value-of select="normalize-space($signatureInfoScript)"/>
              </script>

              <div class="dijitHidden">
                <div data-dojo-type="dijit.Dialog" class="sigsDialog certsDialog" autofocus="false"
                     data-dojo-props="id:'fileSignatureDialog_{@n}', title:'Signature details', autofocus:'false'">
                  <div class="dijitDialogPaneContentArea certificateContents">
                    <span id="fileSignatureDialogContents_{@n}" tabindex="0" class="sigInfoDialogContents"></span>
                    <div class="sigInfoButton B_Cl">
                      <button data-dojo-type="dijit.form.Button" data-dojo-props="type:'button', style:'margin:10pt'">
                        <xsl:value-of select="$cl_n"/>
                        <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                          dijit.byId('fileSignatureDialog_<xsl:value-of select="@n"/>').hide();
                        </script>
                      </button>
                    </div>
                  </div>
                </div>
              </div>
            </xsl:if>

            <xsl:choose>
              <xsl:when test="@condition = 'hidden'">
                <input type="hidden" id="{@n}" name="p_{@n}" value="{@value}"/>
              </xsl:when>
              <xsl:otherwise>
                <td>
                  <table cellspacing="0" cellpadding="0">
                    <td class="fieldInput" colspan="{$colspan}">
                      <table class="file {$fileWidgetType}" cellspacing="0" cellpadding="0">
                        <tr>
                          <td>
                            <table id="fileWidget_{@n}" class="{$fileWidgetClass}" cellspacing="0" cellpadding="0">
                              <td class="fileInput">
                                <xsl:choose>
                                  <xsl:when test="@condition = 'readonly'">
                                    <input type="hidden" name="p_{@n}" value="{@value}"/>
                                    <input data-dojo-type="dijit.form.ValidationTextBox" class="widget dijitFileInputReception"
                                           data-dojo-props="id:'{@n}', value:'{@value}', table:'{@fileTable}', condition:'{@condition}', disabled:'disabled', readonly:'readonly', {$fileWidgetSignature}">
                                    </input>
                                  </xsl:when>
                                  <xsl:otherwise>
                                    <input data-dojo-type="custom.FileInput" class="fileInput"
                                           data-dojo-props="id:'{@n}', name:'p_{@n}', value:'{@value}', table:'{@fileTable}', condition:'{@condition}', readonly:'readonly', {$fileWidgetSignature}">
                                    </input>
                                  </xsl:otherwise>
                                </xsl:choose>
                              </td>
                              <td id="fileTableButton_{@n}" class="fileButton">
                                <div data-dojo-type="dijit.form.DropDownButton"
                                     data-dojo-props="id:'fileButton_{@n}', {$fileWidgetCondition} iconClass:'{$fileWidgetIcon}', onMouseEnter:Hovered_File_Button, onMouseLeave:UnHovered_File_Button">
                                  <span></span>
                                  <div data-dojo-type="dijit.Menu" data-dojo-props="id:'fileMenu_{@n}'">
                                    <xsl:if test="not(@condition) or @condition != 'readonly'">
                                      <div data-dojo-type="dijit.MenuItem" data-dojo-props="iconClass:'dijitIconFolderOpen'">
                                        <xsl:value-of select="@pF_sel_n"/>
                                        <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                                          <xsl:value-of select="normalize-space($selectMenuFileScript)"/>
                                        </script>
                                      </div>
                                      <div data-dojo-type="dijit.MenuItem" data-dojo-props="id:'fileButtonClear_{@n}', iconClass:'dijitIconDelete'">
                                        <xsl:value-of select="@pF_rem_n"/>
                                        <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                                          <xsl:value-of select="normalize-space($clearMenuFileScript)"/>
                                        </script>
                                      </div>
                                    </xsl:if>
                                    <div data-dojo-type="dijit.MenuItem" id="fileButtonDownload_{@n}" class="fileButtonDownload"
                                         data-dojo-props="id:'fileButtonDownload_{@n}', iconClass:'dijitIconEditTask', disabled:'disabled'">
                                      <xsl:value-of select="@pF_down_n"/>
                                    </div>
                                  </div>
                                </div>
                              </td>
                            </table>
                          </td>
                        </tr>
                        <xsl:if test="@signature_required = '1'">
                          <tr>
                            <td class="fileSignatureBox">
                              <div>
                                <img id="fileSignaturePL_{@n}" width="12" height="12" style="display:none"
                                   src="//ajax.googleapis.com/ajax/libs/dojo/1.7.4/dijit/themes/claro/images/loadingAnimation.gif">
                                </img>
                                <span id="fileSignatureContents_{@n}" class="fileSignatureContents">
                                  <xsl:value-of select="@pF_sig_req_n"/>
                                </span>
                                <img id="fileSignatureCheck_{@n}" width="13" height="13" style="display:none"></img>
                              </div>
                            </td>
                          </tr>
                        </xsl:if>
                      </table>
                    </td>
                    <xsl:if test="@units">
                      <td class="fieldUnits units">
                        <xsl:value-of select="@units"/>
                      </td>
                    </xsl:if>
                  </table>
                </td>
              </xsl:otherwise>
            </xsl:choose>

          </xsl:when>

          <xsl:when test="@field_type = 'numeric'">

            <xsl:if test="@help and @help != ''">
              <div data-dojo-type="dijit/Tooltip" data-dojo-props="connectId:'{@n}', label:'{@help}', position:['above']"></div>
            </xsl:if>

            <xsl:choose>
              <xsl:when test="@condition = 'hidden'">
                <input type="hidden" id="{@n}" name="p_{@n}" value="{@value}"/>
              </xsl:when>
              <xsl:otherwise>
                <td>
                  <table cellspacing="0" cellpadding="0">
                    <td class="fieldInput" colspan="{$colspan}">
                      <table class="text {$paramEdition}" cellpadding="0" cellspacing="0">
                        <td>
                          <input data-dojo-type="dijit.form.NumberTextBox" class="widget" required="{@required}"
                                 data-dojo-props="id:'{@n}', name:'p_{@n}', value:'{@value}', {$condition} onKeyUp:{$updating}">
                          </input>
                        </td>
                      </table>
                    </td>
                    <xsl:if test="@units">
                      <td class="fieldUnits units">
                        <xsl:value-of select="@units"/>
                      </td>
                    </xsl:if>
                  </table>
                </td>
              </xsl:otherwise>
            </xsl:choose>

          </xsl:when>

          <xsl:when test="@field_type = 'button'">

            <xsl:if test="@help and @help != ''">
              <div data-dojo-type="dijit/Tooltip" data-dojo-props="connectId:'{@n}',label:'{@help}',position:['above']"></div>
            </xsl:if>

            <xsl:choose>
              <xsl:when test="@condition = 'hidden' or @condition = 'readonly'"></xsl:when>
              <xsl:otherwise>
                <xsl:choose>
                  <xsl:when test="following-sibling::param[1][@field_type = 'button' and @location = 'same_menu']">
                    <td class="button dropDown">
                      <div data-dojo-type="dijit.form.DropDownButton"
                         data-dojo-props="id:'menuDropDownButton_{@n}', {$condition}">
                        <span>
                          <xsl:value-of select="@pn"/>
                        </span>
                        <div data-dojo-type="dijit.Menu" data-dojo-props="id:'menuDropDown_{@n}'">
                          <xsl:variable name="dropDownButtonId">
                            <xsl:value-of select="@n"></xsl:value-of>
                          </xsl:variable>
                          <div data-dojo-type="dijit.MenuItem" data-dojo-props="id:'{@n}', {$condition} name:'p_{@n}'">
                            <xsl:value-of select="@pn"/>
                            <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                              buttonRespond('<xsl:value-of select="@n"/>', '<xsl:value-of select="$dropDownButtonId"/>');
                            </script>
                          </div>
                          <xsl:for-each select="following-sibling::param[@field_type = 'button' and @location = 'same_menu' and 
                                              generate-id(preceding-sibling::param[@field_type = 'button' and @location != 'same_menu'][1]) = generate-id(current())]">
                            <div data-dojo-type="dijit.MenuItem" data-dojo-props="id:'{@n}', {$condition} name:'p_{@n}'">
                              <xsl:value-of select="@pn"/>
                              <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                                buttonRespond('<xsl:value-of select="@n"/>', '<xsl:value-of select="$dropDownButtonId"/>');
                              </script>
                            </div>
                          </xsl:for-each>
                        </div>
                      </div>
                    </td>
                  </xsl:when>
                  <xsl:otherwise>
                    <td class="button">
                      <button data-dojo-type="dijit.form.Button"
                              data-dojo-props="type:'button', id:'{@n}', {$condition} name:'p_{@n}'">
                        <xsl:value-of select="$n"/>
                        <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                          buttonRespond('<xsl:value-of select="@n"/>');
                        </script>
                      </button>
                    </td>
                  </xsl:otherwise>
                </xsl:choose>
                <td id="buttonPL_{@n}" class="buttonPL" style="visibility:hidden">
                  <img width="18" height="18" src="//ajax.googleapis.com/ajax/libs/dojo/1.7.4/dijit/themes/claro/images/loadingAnimation.gif"></img>
                </td>
              </xsl:otherwise>
            </xsl:choose>

          </xsl:when>

          <xsl:when test="@field_type = 'formatted'">

            <xsl:if test="@help and @help != ''">
              <div data-dojo-type="dijit/Tooltip" data-dojo-props="connectId:'{@n}',label:'{@help}',position:['above']"></div>
            </xsl:if>

            <xsl:choose>
              <xsl:when test="@condition = 'hidden'">
                <input type="hidden" id="{@n}" name="p_{@n}" value="{@value}"/>
              </xsl:when>
              <xsl:otherwise>

                <td class="editor" colspan="{$colspan}">
                  <table cellspacing="0" cellpadding="0">
                    <xsl:if test="$n!='-'">
                      <tr>
                        <td class="fieldTitle editor">
                          <xsl:value-of select="$n" disable-output-escaping="yes"/>
                        </td>
                      </tr>
                    </xsl:if>
                    <tr>
                      <td class="fieldInput editor">
                        <xsl:choose>
                          <xsl:when test="$form_type != 'response'">
                            <input type="hidden" id="{@n}" name="p_{@n}" class="input_editor" value="{@value}" defaultvalue="{@value}"/>
                            <div data-dojo-type="dijit.Editor" class="widget editor" required="{@required}" style="font-size: 85% !important"
                                 data-dojo-props="id:'editor_{@n}', name:'p_editor_{@n}', {$condition}  {$imMessages}">
                              <xsl:value-of select="@value" disable-output-escaping="yes"/>
                              <script type="dojo/method" data-dojo-event="onChange" data-dojo-args="evt">
                                dojo.byId('<xsl:value-of select="@n"/>').value = this.getValue();
                              </script>
                            </div>
                          </xsl:when>
                          <xsl:otherwise>
                            <div data-dojo-type="dijit.Editor" class="formatted" required="{@required}" style="font-size: 85% !important"
                                 data-dojo-props="id:'e_{@n}', name:'p_e_{@n}', disabled:'disabled',  {$imMessages}">
                              <xsl:value-of select="@value" disable-output-escaping="yes"/>
                            </div>
                          </xsl:otherwise>
                        </xsl:choose>
                      </td>
                    </tr>
                  </table>
                </td>
              </xsl:otherwise>
            </xsl:choose>

          </xsl:when>

          <xsl:when test="@field_type = 'expression'">

            <xsl:choose>
              <xsl:when test="@condition = 'hidden'">
                <input type="hidden" id="{@n}" name="p_{@n}" value="{@value}"/>
              </xsl:when>
              <xsl:otherwise>
                <input type="hidden" id="{@n}" name="p_{@n}" value="{@value}" onChange="{$updating}()"/>
                <td class="fieldExpression" colspan="2">
                  <table class="expressions" cellspacing="0" cellpadding="0">
                    <td>
                      <xsl:choose>
                        <xsl:when test="@condition = 'disabled'">
                          <div id="e_{@n}" style="visibility: hidden">
                            <xsl:value-of select="@print" disable-output-escaping="yes"/>
                            <span></span>
                            <xsl:value-of select="@units"/>
                          </div>
                        </xsl:when>
                        <xsl:otherwise>
                          <div id="e_{@n}">
                            <xsl:value-of select="@print" disable-output-escaping="yes"/>
                            <span></span>
                            <xsl:value-of select="@units"/>
                          </div>
                        </xsl:otherwise>
                      </xsl:choose>
                    </td>
                  </table>
                </td>
              </xsl:otherwise>
            </xsl:choose>

          </xsl:when>

          <xsl:when test="@field_type = 'table'">

            <xsl:choose>
              <xsl:when test="@condition = 'hidden'">
                <input type="hidden" id="fT_n_{@n}" value="{@table_num}"></input>
                <input type="hidden" id="{@n}" name="p_{@n}" value="{@value}"></input>
              </xsl:when>
              <xsl:otherwise>
                <input type="hidden" id="fT_n_{@n}" value="{@table_num}"></input>
                <input type="hidden" id="{@n}" name="p_{@n}" value="{@value}"></input>

                <input type="hidden" id="fT_mode_{@n}" name="table_mode_{@n}" value=""></input>
                <input type="hidden" id="fT_rowValues_{@n}" name="row_values_{@n}" value=""></input>

                <xsl:variable name="tableWidgetScript">
                  var gridLayout = [{
                  cells: [
                  <xsl:variable name="header_count">1</xsl:variable>
                  <xsl:call-template name='print-header-table'>
                    <xsl:with-param name="name" select="@columns_name"/>
                    <xsl:with-param name="length" select="@columns_length"/>
                    <xsl:with-param name="justify" select="@columns_justify"/>
                    <xsl:with-param name="expand" select="@columns_expand"/>
                    <xsl:with-param name="field_type" select="@columns_type"/>
                    <xsl:with-param name="editable" select="@columns_editable"/>
                    <xsl:with-param name="color" select="@columns_color"/>
                    <xsl:with-param name="count" select="$header_count"/>
                  </xsl:call-template>
                  ]
                  }];
                  var numT = <xsl:value-of select="@table_num"/>;
                  _tableWidgetStorage[numT] = new Array();
                  _tableWidgetStorage[numT][0] = gridLayout;
                  _tableWidgetStorage[numT][1] = '<xsl:value-of select="@table_width"></xsl:value-of>';
                  _tableWidgetStorage[numT][2] = '<xsl:value-of select="@table_height"></xsl:value-of>';
                  _tableWidgetStorage[numT][3] = '<xsl:value-of select="@table_values"></xsl:value-of>';
                  _tableWidgetStorage[numT][4] = '<xsl:value-of select="@columns_type"></xsl:value-of>';
                  _tableWidgetStorage[numT][5] = '<xsl:value-of select="@condition"></xsl:value-of>';
                  _tableWidgetStorage[numT][6] = '';
                </xsl:variable>

                <xsl:variable name="colspanTable">
                  <xsl:choose>
                    <xsl:when test="not(@location)">
                      <xsl:choose>
                        <xsl:when test="following-sibling::node() and following-sibling::param[1][@location = 'same_line']">
                          <xsl:text>2</xsl:text>
                        </xsl:when>
                        <xsl:otherwise>
                          <xsl:text>4</xsl:text>
                        </xsl:otherwise>
                      </xsl:choose>
                    </xsl:when>
                    <xsl:otherwise>
                      <xsl:text>2</xsl:text>
                    </xsl:otherwise>
                  </xsl:choose>
                </xsl:variable>

                <td class="tableGrid" colspan="{$colspanTable}">
                  <table cellspacing="0" cellpadding="0">
                    <xsl:if test="$n!='-'">
                      <tr>
                        <td class="fieldTitle">
                          <xsl:value-of select="$n" disable-output-escaping="yes"/>
                        </td>
                        <xsl:if test="$form_type != 'response'">
                          <td class="tableButton">
                            <div data-dojo-type="dijit.form.Button" data-dojo-props="id:'tableExButton_{@n}', iconClass:'dijitIconTable'">
                              <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                                resizeTable('tableGrid_<xsl:value-of select="@n"/>');
                              </script>
                            </div>
                            <xsl:if test="not(@default_buttons) or @default_buttons='1'">
                              <div data-dojo-type="dijit.form.DropDownButton" data-dojo-props="id:'tableButton_{@n}'">
                                <span></span>
                                <div data-dojo-type="dijit.Menu" data-dojo-props="id:'table_menu_{@n}'">
                                  <xsl:if test="not(@add_option) or @add_option = '1'">
                                    <div data-dojo-type="dijit.MenuItem" data-dojo-props="id:'addTableRowButton_{@n}', iconClass:'dijitIconEdit'">
                                      <xsl:value-of select="@pT_r_add_n"/>
                                      <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                                        addTableRow('tableGrid_<xsl:value-of select="@n"/>');
                                      </script>
                                    </div>
                                  </xsl:if>
                                  <div data-dojo-type="dijit.MenuItem" data-dojo-props="id:'editTableRowButton_{@n}', iconClass:'dijitIconEdit', disabled:'disabled'">
                                    <xsl:value-of select="@pT_r_edit_n"/>
                                    <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                                      editTableRow('tableGrid_<xsl:value-of select="@n"/>');
                                    </script>
                                  </div>
                                  <div data-dojo-type="dijit.MenuItem" data-dojo-props="id:'removeTableRowButton_{@n}', iconClass:'dijitIconDelete', disabled:'disabled'">
                                    <xsl:value-of select="@pT_r_rem_n"/>
                                    <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                                      removeTableRow('tableGrid_<xsl:value-of select="@n"/>');
                                    </script>
                                  </div>
                                </div>
                              </div>
                            </xsl:if>
                          </td>
                        </xsl:if>
                      </tr>
                    </xsl:if>
                    <tr>
                      <td colspan="2">
                        <div id="tableGrid_{@n}" class="tableGridParam"></div>
                      </td>
                    </tr>
                  </table>
                </td>
                <script type="text/javascript">
                  <xsl:value-of select="normalize-space($tableWidgetScript)"/>
                </script>
              </xsl:otherwise>
            </xsl:choose>

          </xsl:when>

        </xsl:choose>

    </xsl:if>

  </xsl:template>

  <xsl:template match="tcl">
    <!-- nothing -->
  </xsl:template>

  

  <!-- USERS MANAGEMENT -->

  <xsl:template name='print-users_management'>
    
      <input type="hidden" id="activeUser" name="activeUser" value="{@active_user}"/>
      <input type="hidden" id="userAction" name="userAction" value=""/>
      <input type="hidden" id="certAction" name="certAction" value=""/>
      <input type="hidden" id="sigAction" name="sigAction" value=""/>
      <input type="hidden" id="selUser" name="selUser" value=""/>
      <input type="hidden" id="selUserProfile" name="selUserProfile" value=""/>
      <input type="hidden" id="selCert" name="selCert" value=""/>
      <input type="hidden" id="selSig" name="selSig" value=""/>
      <div data-dojo-type="dijit.form.Form" data-dojo-props="id:'FormUsersDatabase', method:'post', action:''">

        <xsl:variable name="searchUsersUpdating">uM_search</xsl:variable>
        <xsl:variable name="checkFilterScript">
          function checkManagerFilter(){ uM_checkFilter(); }
        </xsl:variable>
        <script type="text/javascript">
          <xsl:value-of select="normalize-space($checkFilterScript)"/>
        </script>
        <xsl:variable name="f_checkUpdating">checkManagerFilter</xsl:variable>
        <xsl:variable name="filterByScript">
          function filterManagerBy(){ uM_filterBy('load'); }
        </xsl:variable>
        <script type="text/javascript">
          <xsl:value-of select="normalize-space($filterByScript)"/>
        </script>
        <xsl:variable name="f_byUpdating">filterManagerBy</xsl:variable>
        <xsl:variable name="filterWhatScript">
          function filterManagerWhat(){ uM_filterWhat(); }
        </xsl:variable>
        <script type="text/javascript">
          <xsl:value-of select="normalize-space($filterWhatScript)"/>
        </script>
        <xsl:variable name="f_whatUpdating">filterManagerWhat</xsl:variable>

        <div class="usersManager">
          <table class="usersManager">
            <tr>
              <td>
                <table class="usersManagerContainer1" cellpadding="0" cellspacing="0">
                  <tr>
                    <td>
                      <table class="usersManagerContainer2" cellspacing="0" cellpadding="0">
                        <tr>
                          <td class="usersMenu">
                            <div>
                              <div class="usersMenu">
                                <table cellpadding="0" cellspacing="0">
                                  <td class="pf_sh_c"></td>
                                  <td id="usersSelection" class="usersSelection" onclick="uM_select('users')">
                                    <div id="usersSelectionControl" style="display: none">init</div>
                                    <xsl:value-of select="@uM_U_n"/>
                                    <xsl:choose>
                                      <xsl:when test="@uM_U_nt > '0'">
                                        <span class="nIconGlobe">
                                          <span id="users_nCount" class="nCount">
                                            <xsl:value-of select="@uM_U_nt"/>
                                          </span>
                                        </span>
                                      </xsl:when>
                                      <xsl:otherwise>
                                        <span class="nIconGlobe">
                                          <span id="users_nCount" class="nCount" style="visibility:hidden">
                                            <xsl:value-of select="@uM_U_nt"/>
                                          </span>
                                        </span>
                                      </xsl:otherwise>
                                    </xsl:choose>
                                  </td>
                                  <td class="pf_sh_c"></td>
                                  <td id="usersProfileSelection" class="profileSelection pf_sh_c" onclick="uM_select('profile')">
                                    <div id="usersProfileSelectionControl" style="display: none">init</div>
                                    <xsl:value-of select="@uM_G_n"/>
                                    <span class="nIconGlobe">
                                      <span id="profile_nCount" class="nCount" style="visibility:hidden">
                                        <xsl:text>0</xsl:text>
                                      </span>
                                    </span>
                                  </td>
                                  <td class="pf_sh_c"></td>
                                  <td id="certificateSelection" class="certificateSelection pf_sh_c" onclick="uM_select('certificates')">
                                    <div id="certificateSelectionControl" style="display: none">init</div>
                                    <xsl:value-of select="@uM_C_n"/>
                                    <xsl:choose>
                                      <xsl:when test="@uM_C_nt > '0'">
                                        <span class="nIconGlobe">
                                          <span id="certs_nCount" class="nCount">
                                            <xsl:value-of select="@uM_C_nt"/>
                                          </span>
                                        </span>
                                      </xsl:when>
                                      <xsl:otherwise>
                                        <span class="nIconGlobe">
                                          <span id="certs_nCount" class="nCount" style="visibility:hidden">
                                            <xsl:value-of select="@uM_C_nt"/>
                                          </span>
                                        </span>
                                      </xsl:otherwise>
                                    </xsl:choose>
                                  </td>
                                  <td class="pf_sh_c"></td>
                                  <td id="signatureSelection" class="signatureSelection pf_sh_c" onclick="uM_select('signatures')">
                                    <div id="signatureSelectionControl" style="display: none">init</div>
                                    <xsl:value-of select="@uM_S_n"/>
                                    <xsl:choose>
                                      <xsl:when test="@uM_S_nt > '0'">
                                        <span class="nIconGlobe">
                                          <span id="sigs_nCount" class="nCount">
                                            <xsl:value-of select="@uM_S_nt"/>
                                          </span>
                                        </span>
                                      </xsl:when>
                                      <xsl:otherwise>
                                        <span class="nIconGlobe">
                                          <span id="sigs_nCount" class="nCount" style="visibility:hidden">
                                            <xsl:value-of select="@uM_S_nt"/>
                                          </span>
                                        </span>
                                      </xsl:otherwise>
                                    </xsl:choose>
                                  </td>
                                  <td class="pf_sh_c">
                                    <div style="float:right">
                                      <table width="100%">
                                        <tr>
                                          <td class="managerStatus">
                                            <table>
                                              <td id="managerStatus_image" class="managerStatus_image"></td>
                                              <td class="managerStatusInfo">
                                                <span id="managerStatus_text" class="managerStatus_text"></span>
                                              </td>
                                            </table>
                                          </td>
                                          <td id="managerPL" class="managerPL" style="display:none">
                                            <img width="18" src="//ajax.googleapis.com/ajax/libs/dojo/1.7.4/dijit/themes/claro/images/loadingAnimation.gif"></img>
                                          </td>
                                        </tr>
                                      </table>
                                    </div>
                                  </td>
                                </table>
                              </div>
                            </div>
                          </td>
                        </tr>
                      </table>
                    </td>
                  </tr>
                  <tr>
                    <td class="usersManager">
                      <div>
                        <div id="usersTitle" class="managerTitle">
                          <table>
                            <td>
                              <img id="usersIcon" height="30" width="30" src="{$base_path}/int/js/custom/images/users.png"></img>
                            </td>
                            <td>
                              <span class="usersTitle">
                                <xsl:value-of select="@uM_U_n"/>
                              </span>
                            </td>
                          </table>
                        </div>
                        <div id="profileTitle" class="managerTitle" style="display:none">
                          <table>
                            <td>
                              <img id="profileIcon" height="30" width="30" src="{$base_path}/int/js/custom/images/usersGroup.png"></img>
                            </td>
                            <td>
                              <span class="profileTitle">
                                <xsl:value-of select="@uM_G_n"/>
                              </span>
                            </td>
                          </table>
                        </div>
                        <div id="certsTitle" class="managerTitle" style="display:none">
                          <table>
                            <td>
                              <img id="certsIcon" height="30" width="30" src="{$base_path}/int/js/custom/images/cert_2.png"></img>
                            </td>
                            <td>
                              <span class="certsTitle">
                                <xsl:value-of select="@uM_C_n"/>
                              </span>
                            </td>
                          </table>
                        </div>
                        <div id="sigsTitle" class="managerTitle" style="display:none">
                          <table>
                            <td>
                              <img id="sigsIcon" height="30" width="30" src="{$base_path}/int/js/custom/images/sigs.png"></img>
                            </td>
                            <td>
                              <span class="sigsTitle">
                                <xsl:value-of select="@uM_S_n"/>
                              </span>
                            </td>
                          </table>
                        </div>
                        <div style="float:right">
                          <table cellspacing="0" class="usersControlPane">
                            <tr>
                              <td id="usersManagerPane">
                                <table>
                                  <tr>
                                    <td>
                                      <table class="managerSubPane1">
                                        <td id="usersManagerCreateRegion">
                                          <div data-dojo-type="dijit/Tooltip"
                                               data-dojo-props="id:'uManagerT_c',connectId:'usersManagerCreateRegion', label:'{@uM_U_c_n}', position:['below']"></div>
                                          <button data-dojo-type="dijit.form.Button"
                                                  data-dojo-props="type:'button', id:'uManagerB_c', name:'uManagerB_c', iconClass:'createIcon'">
                                            <xsl:variable name="createUserScript">
                                              dojo.byId('userAction').setAttribute('value','create');
                                              uM_u_doAction();
                                            </xsl:variable>
                                            <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                                              <xsl:value-of select="normalize-space($createUserScript)"/>
                                            </script>
                                          </button>
                                        </td>
                                      </table>
                                    </td>
                                    <td>
                                      <table class="managerSubPane2">
                                        <!-- Disabled at the moment 
                                        <td id="usersManagerPermissionsRegion">
                                          <div data-dojo-type="dijit/Tooltip"
                                               data-dojo-props="connectId:'usersManagerPermissionsRegion', label:'{@uM_U_ep_n}', position:['below']"></div>
                                          <button data-dojo-type="dijit.form.Button"
                                                  data-dojo-props="type:'button', id:'uManagerB_m', name:'uManagerB_m', iconClass:'permissionsIcon'">
                                            <xsl:variable name="manageUserScript">
                                              dojo.byId('userAction').setAttribute('value','managePerm');
                                              uM_u_action();
                                            </xsl:variable>
                                            <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                                              <xsl:value-of select="normalize-space($manageUserScript)"/>
                                            </script>
                                          </button>
                                        </td>
                                        -->
                                        <td id="usersManagerPasswordRegion">
                                          <div data-dojo-type="dijit/Tooltip"
                                               data-dojo-props="connectId:'usersManagerPasswordRegion', label:'{@uM_U_p_n}', position:['below']"></div>
                                          <button data-dojo-type="dijit.form.Button"
                                                  data-dojo-props="type:'button', id:'uManagerB_p', name:'uManagerB_p', iconClass:'passwordIcon', disabled:'disabled'">
                                            <xsl:variable name="passwordUserScript">
                                              dojo.byId('userAction').setAttribute('value','password');
                                              uM_u_action();
                                            </xsl:variable>
                                            <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                                              <xsl:value-of select="normalize-space($passwordUserScript)"/>
                                            </script>
                                          </button>
                                        </td>
                                      </table>
                                    </td>
                                    <td>
                                      <table class="managerSubPane3">
                                        <td id="usersManagerActivateRegion">
                                          <div data-dojo-type="dijit/Tooltip"
                                               data-dojo-props="connectId:'usersManagerActivateRegion', label:'{@uM_a_n}', position:['below']"></div>
                                          <button data-dojo-type="dijit.form.Button"
                                                  data-dojo-props="type:'button', id:'uManagerB_a', name:'uManagerB_a', iconClass:'activateUserIcon', disabled:'disabled'">
                                            <xsl:variable name="activateCertScript">
                                              dojo.byId('userAction').setAttribute('value','activate');
                                              uM_u_action();
                                            </xsl:variable>
                                            <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                                              <xsl:value-of select="normalize-space($activateCertScript)"/>
                                            </script>
                                          </button>
                                        </td>
                                        <td id="usersManagerInactivateRegion">
                                          <div data-dojo-type="dijit/Tooltip"
                                               data-dojo-props="connectId:'usersManagerInactivateRegion', label:'{@uM_U_ia_n}', position:['below']"></div>
                                          <button data-dojo-type="dijit.form.Button"
                                                  data-dojo-props="type:'button', id:'uManagerB_ia', name:'uManagerB_ia', iconClass:'inactivateUserIcon', disabled:'disabled'">
                                            <xsl:variable name="inactivateUserScript">
                                              dojo.byId('userAction').setAttribute('value','inactivate');
                                              uM_u_action();
                                            </xsl:variable>
                                            <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                                              <xsl:value-of select="normalize-space($inactivateUserScript)"/>
                                            </script>
                                          </button>
                                        </td>
                                        <td id="usersManagerRemoveRegion">
                                          <div data-dojo-type="dijit/Tooltip"
                                               data-dojo-props="connectId:'usersManagerRemoveRegion', label:'{@uM_U_r_n}', position:['below']"></div>
                                          <button data-dojo-type="dijit.form.Button"
                                                  data-dojo-props="type:'button', id:'uManagerB_d', name:'uManagerB_d', iconClass:'removeUserIcon', disabled:'disabled'">
                                            <xsl:variable name="deleteUserScript">
                                              dojo.byId('userAction').setAttribute('value','delete');
                                              uM_u_action();
                                            </xsl:variable>
                                            <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                                              <xsl:value-of select="normalize-space($deleteUserScript)"/>
                                            </script>
                                          </button>
                                        </td>
                                      </table>
                                    </td>
                                  </tr>
                                </table>
                              </td>
                              <td id="usersProfileManagerPane" class="usersProfileManagerPane" style="display:none">
                                <table>
                                  <tr>
                                    <td>
                                      <table class="managerSubPane3">
                                        <td id="usersManagerProfileRegion">
                                          <div data-dojo-type="dijit/Tooltip"
                                               data-dojo-props="connectId:'usersManagerProfileRegion', label:'Profile properties', position:['below']"></div>
                                          <button data-dojo-type="dijit.form.Button"
                                                  data-dojo-props="type:'button', id:'ugManagerB_e', name:'ugManagerB_e', iconClass:'permissionsIcon', disabled:'disabled'">
                                            <xsl:variable name="manageUserProfileScript">
                                              uM_p_action();
                                            </xsl:variable>
                                            <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                                              <xsl:value-of select="normalize-space($manageUserProfileScript)"/>
                                            </script>
                                          </button>
                                        </td>
                                      </table>
                                    </td>
                                  </tr>
                                </table>
                              </td>
                              <td id="certsManagerPane" class="certsManagerPane" style="display:none">
                                <table>
                                  <tr>
                                    <td>
                                      <table class="managerSubPane1">
                                        <td id="certsManagerActivate" class="certsManagerActivate">
                                          <table cellspacing="0" cellpadding="0">
                                            <tr>
                                              <td id="certsManagerActivateRegion">
                                                <div data-dojo-type="dijit/Tooltip"
                                                    data-dojo-props="connectId:'certsManagerActivateRegion', label:'{@uM_a_n}', position:['below']"></div>
                                                <button data-dojo-type="dijit.form.Button"
                                                        data-dojo-props="type:'button', id:'cManagerB_a', name:'cManagerB_a', disabled:'disabled', iconClass:'activateUserIcon'">
                                                  <xsl:variable name="activateCertScript">
                                                    dojo.byId('certAction').setAttribute('value','activate');
                                                    uM_c_action();
                                                  </xsl:variable>
                                                  <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                                                    <xsl:value-of select="normalize-space($activateCertScript)"/>
                                                  </script>
                                                </button>
                                              </td>
                                            </tr>
                                          </table>
                                        </td>
                                      </table>
                                    </td>
                                    <td>
                                      <table class="managerSubPane3">
                                        <td id="certsManagerRevokeRegion">
                                          <div data-dojo-type="dijit/Tooltip"
                                               data-dojo-props="connectId:'certsManagerRevokeRegion', label:'{@uM_rk_n}', position:['below']"></div>
                                          <button data-dojo-type="dijit.form.Button"
                                                  data-dojo-props="type:'button', id:'cManagerB_r', name:'cManagerB_r', disabled:'disabled', iconClass:'inactivateUserIcon'">
                                            <xsl:variable name="revokeCertScript">
                                              dojo.byId('certAction').setAttribute('value','revoke');
                                              uM_c_action();
                                            </xsl:variable>
                                            <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                                              <xsl:value-of select="normalize-space($revokeCertScript)"/>
                                            </script>
                                          </button>
                                        </td>
                                        <td id="certsManagerRemoveRegion">
                                          <div data-dojo-type="dijit/Tooltip"
                                               data-dojo-props="connectId:'certsManagerRemoveRegion', label:'{@uM_r_n}', position:['below']"></div>
                                          <button data-dojo-type="dijit.form.Button"
                                                  data-dojo-props="type:'button', id:'cManagerB_d', name:'cManagerB_d', disabled:'disabled', iconClass:'removeUserIcon'">
                                            <xsl:variable name="revokeCertScript">
                                              dojo.byId('certAction').setAttribute('value','delete');
                                              uM_c_action();
                                            </xsl:variable>
                                            <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                                              <xsl:value-of select="normalize-space($revokeCertScript)"/>
                                            </script>
                                          </button>
                                        </td>
                                      </table>
                                    </td>
                                  </tr>
                                </table>
                              </td>
                              <td id="sigsManagerPane" class="certsManagerPane" style="display:none">
                                <table>
                                  <tr>
                                    <td>
                                      <table class="managerSubPane1">
                                        <td id="sigsManagerActivate" class="certsManagerActivate">
                                          <table cellspacing="0" cellpadding="0">
                                            <tr>
                                              <td id="sigsManagerActivateRegion">
                                                <div data-dojo-type="dijit/Tooltip"
                                                    data-dojo-props="connectId:'sigsManagerActivateRegion', label:'{@uM_a_n}', position:['below']"></div>
                                                <button data-dojo-type="dijit.form.Button"
                                                        data-dojo-props="type:'button', id:'sManagerB_a', name:'sManagerB_a', disabled:'disabled', iconClass:'activateSigIcon'">
                                                  <xsl:variable name="activateSigScript">
                                                    dojo.byId('sigAction').setAttribute('value','activate');
                                                    uM_s_action();
                                                  </xsl:variable>
                                                  <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                                                    <xsl:value-of select="normalize-space($activateSigScript)"/>
                                                  </script>
                                                </button>
                                              </td>
                                            </tr>
                                          </table>
                                        </td>
                                      </table>
                                    </td>
                                    <td>
                                      <table class="managerSubPane3">
                                        <td id="sigsManagerRevokeRegion">
                                          <div data-dojo-type="dijit/Tooltip"
                                               data-dojo-props="connectId:'sigsManagerRevokeRegion', label:'{@uM_rk_n}', position:['below']"></div>
                                          <button data-dojo-type="dijit.form.Button"
                                                  data-dojo-props="type:'button', id:'sManagerB_r', name:'sManagerB_r', disabled:'disabled', iconClass:'revokeSigIcon'">
                                            <xsl:variable name="revokeSigScript">
                                              dojo.byId('sigAction').setAttribute('value','revoke');
                                              uM_s_action();
                                            </xsl:variable>
                                            <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                                              <xsl:value-of select="normalize-space($revokeSigScript)"/>
                                            </script>
                                          </button>
                                        </td>
                                        <td id="sigsManagerRemoveRegion">
                                          <div data-dojo-type="dijit/Tooltip"
                                               data-dojo-props="connectId:'sigsManagerRemoveRegion', label:'{@uM_r_n}', position:['below']"></div>
                                          <button data-dojo-type="dijit.form.Button"
                                                  data-dojo-props="type:'button', id:'sManagerB_d', name:'sManagerB_d', disabled:'disabled', iconClass:'removeSigIcon'">
                                            <xsl:variable name="revokeSigScript">
                                              dojo.byId('sigAction').setAttribute('value','delete');
                                              uM_s_action();
                                            </xsl:variable>
                                            <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                                              <xsl:value-of select="normalize-space($revokeSigScript)"/>
                                            </script>
                                          </button>
                                        </td>
                                      </table>
                                    </td>
                                  </tr>
                                </table>
                              </td>
                              <td class="managerUndoButton">
                                <table>
                                  <td>
                                    <div data-dojo-type="dijit/Tooltip"
                                         data-dojo-props="id:'managerT_undo', connectId:'managerB_undo', label:'', position:['below']"></div>
                                    <button data-dojo-type="dijit.form.Button"
                                            data-dojo-props="type:'button', id:'managerB_undo', name:'managerB_undo', iconClass:'undoIcon', disabled:'disabled'">
                                      <xsl:variable name="undoScript">undo();</xsl:variable>
                                      <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                                        <xsl:value-of select="normalize-space($undoScript)"/>
                                      </script>
                                    </button>
                                  </td>
                                </table>
                              </td>
                            </tr>
                          </table>
                        </div>
                      </div>
                    </td>
                  </tr>
                  <tr>
                    <td>
                      <table class="usersManagerContainer3">
                        <tr>
                          <td id="usersGridZone">
                            <table cellspacing="0" cellpadding="0" width="100%">
                              <tr>
                                <td id="usersGridHeader" class="usersGridHeader">
                                  <table width="100%" cellspacing="0" cellpadding="0" >
                                    <td>
                                      <div>
                                        <div class="usersSearch">
                                          <table class="usersManagerSearchWidget" cellspacing="0" cellpadding="0">
                                            <td id="usersManagerSearchInput" class="usersManagerSearchInput">
                                              <input data-dojo-type="dijit.form.TextBox"
                                                     data-dojo-props="id:'to_search',name:'p_to_search',placeHolder:'{@uM_s_n}',onKeyUp:{$searchUsersUpdating},onMouseEnter:searchUsersHovered,onMouseLeave:searchUsersUnHovered">
                                              </input>
                                              <div class="usersManagerSearchClearIcon">
                                                <img width="13" height="13" src="{$base_path}/int/js/custom/images/clear.png" onclick="searchUsersClear();uM_search()"></img>
                                              </div>
                                            </td>
                                            <td class="usersManagerSearchIcon">
                                              <img width="21" height="21" src="{$base_path}/int/js/custom/images/search.png" onclick="searchUsers()"></img>
                                            </td>
                                          </table>
                                        </div>
                                        <div class="usersFilter">
                                          <table cellspacing="0" cellpadding="0">
                                            <td id="filterCheckRegion" class="filterCheckRegion">
                                              <input data-dojo-type="dijit.form.CheckBox"
                                                     data-dojo-props="id:'filter_check',name:'filter_check',checked:false,onChange:{$f_checkUpdating}">
                                              </input>
                                            </td>
                                            <td id="filterLabelRegion" style="padding-right:8pt;opacity:0.5">
                                              <span id="filterLabel" style="color:#000">
                                                <xsl:value-of select="@uM_f_n"/>
                                              </span>
                                            </td>
                                            <td id="filterSelect1" class="filterSelect1Region">
                                              <select data-dojo-type="dijit.form.Select"
                                                      data-dojo-props="id:'filter_by',name:'filter_by',disabled:'disabled',onChange:{$f_byUpdating}">
                                                <option value="status" selected="selected">
                                                  <xsl:value-of select="@uM_f_s_n"/>
                                                </option>
                                                <option value="type">
                                                  <xsl:value-of select="@uM_f_t_n"/>
                                                </option>
                                                <option value="group">
                                                  <xsl:value-of select="@uM_f_g_n"/>
                                                </option>
                                                <option value="certificate">
                                                  <xsl:value-of select="@uM_f_c_n"/>
                                                </option>
                                                <option value="password">
                                                  <xsl:value-of select="@uM_f_p_n"/>
                                                </option>
                                              </select>
                                            </td>
                                            <td id="filterSelect2" class="filterSelect2Region">
                                              <select data-dojo-type="dijit.form.Select"
                                                      data-dojo-props="id:'filter_what',name:'filter_what',disabled:'disabled',onChange:{$f_whatUpdating}">
                                                <option value="all" selected="selected">
                                                  <xsl:value-of select="@uM_f_s_all_n"/>
                                                </option>
                                                <option value="active">
                                                  <xsl:value-of select="@uM_f_s_a_n"/>
                                                </option>
                                                <option value="inactive">
                                                  <xsl:value-of select="@uM_f_s_ia_n"/>
                                                </option>
                                                <option value="new">
                                                  <xsl:value-of select="@uM_f_s_new_n"/>
                                                </option>
                                              </select>
                                            </td>
                                          </table>
                                        </div>
                                      </div>
                                    </td>
                                  </table>
                                </td>
                              </tr>
                              <tr>
                                <td>
                                  <div id="usersGrid">
                                    <div class="usersGridPL">
                                      <img width="30" height="30" src="{$base_path}/int/js/custom/images/preloader_.gif"></img>
                                    </div>
                                  </div>
                                </td>
                              </tr>
                              <tr>
                                <td>
                                  <div id="usersProfileGrid">
                                    <div class="usersProfileGridPL">
                                      <img width="30" height="30" src="{$base_path}/int/js/custom/images/preloader_.gif"></img>
                                    </div>
                                  </div>
                                </td>
                              </tr>
                              <tr>
                                <td>
                                  <div id="certsGrid">
                                    <div class="certsGridPL">
                                      <img width="30" height="30" src="{$base_path}/int/js/custom/images/preloader_.gif"></img>
                                    </div>
                                  </div>
                                </td>
                              </tr>
                              <tr>
                                <td>
                                  <div id="sigsGrid">
                                    <div class="sigsGridPL">
                                      <img width="30" height="30" src="{$base_path}/int/js/custom/images/preloader_.gif"></img>
                                    </div>
                                  </div>
                                </td>
                              </tr>
                            </table>
                          </td>
                        </tr>
                      </table>
                    </td>
                  </tr>
                </table>
              </td>
            </tr>
          </table>
        </div>
      </div>
      <div class="dijitHidden">
        <div data-dojo-type="dijit.Dialog" class="formErrorDialog" data-dojo-props="id:'formErrorDialog'">
          <div class="dijitDialogPaneContentArea">
            <table class='alertDialog'>
              <td>
                <img width='30' height='30' src="{$base_path}/int/js/custom/images/alert.png"></img>
              </td>
              <td style="padding: 5pt 20pt">
                <span id='errorDialogStatus' class='errorDialogStatus'></span>
              </td>
            </table>
            <div class='formErrorDialogButton'>
              <button data-dojo-type="dijit.form.Button" data-dojo-props="type:'button', style:'margin:10pt'">
                <xsl:value-of select="$cl_n"/>
                <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                  dijit.byId('formErrorDialog').hide();
                </script>
              </button>
            </div>
          </div>
        </div>
      </div>
    
  </xsl:template>



  <!-- LOGIN -->

  <xsl:template match="userparam">

    <xsl:variable name="condition">
      <xsl:choose>
        <xsl:when test="@condition = 'disabled' or @condition = 'readonly'">
          <xsl:text>disabled: 'disabled',</xsl:text>
        </xsl:when>
        <xsl:otherwise></xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:choose>
      <xsl:when test="@type = 'text'">
        <input data-dojo-type="dijit.form.ValidationTextBox" class="login" tabindex="1"
               data-dojo-props="id:'{@name}', name:'{@name}', placeholder:'{@placeholder}', {$condition} value:'{@value}'">
        </input>
      </xsl:when>
      <xsl:when test="@type = 'password'">
        <input data-dojo-type="dijit.form.ValidationTextBox" class="login" tabindex="2" 
               data-dojo-props="id:'{@name}_', type:'password', name:'{@name}', placeholder:'{@placeholder}', value:'{@value}'">
        </input>
      </xsl:when>

      <xsl:when test="@type = 'options non-editable'">
        <xsl:choose>
          <xsl:when test="@values = '0,1' or @values = '1,0'">
            <xsl:variable name="updating">
              <xsl:choose>
                <xsl:when test="@name = 'remove_password'">uM_rmPassUpdate</xsl:when>
                <xsl:when test="@name = 'convert_administrator'">uM_cnvAdminUpdate</xsl:when>
                <xsl:otherwise>function() { return true }</xsl:otherwise>
              </xsl:choose>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="not(@disabled) or @disabled = 'false'">
                <xsl:choose>
                  <xsl:when test="@value='1'">
                    <input data-dojo-type="dijit.form.CheckBox"
                           data-dojo-props="id:'{@name}', name:'{@name}', value:'{@value}', checked:true, onChange:{$updating}">
                    </input>
                  </xsl:when>
                  <xsl:otherwise>
                    <input data-dojo-type="dijit.form.CheckBox"
                           data-dojo-props="id:'{@name}', name:'{@name}', value:'{@value}', checked:false, onChange:{$updating}">
                    </input>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>
              <xsl:otherwise>
                <xsl:choose>
                  <xsl:when test="@value='1'">
                    <input data-dojo-type="dijit.form.CheckBox"
                           data-dojo-props="id:'{@name}', name:'{@name}', value:'{@value}', checked:true, disabled:'disabled', onChange:{$updating}">
                    </input>
                  </xsl:when>
                  <xsl:otherwise>
                    <input data-dojo-type="dijit.form.CheckBox"
                           data-dojo-props="id:'{@name}', name:'{@name}', value:'{@value}', checked:false, disabled:'disabled', onChange:{$updating}">
                    </input>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:when>
          <xsl:otherwise>
            <xsl:variable name="selectionType">
              <xsl:choose>
                <xsl:when test="string-length(@values) &lt; 500">
                  <xsl:text>dijit.form.Select</xsl:text>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:text>dijit.form.FilteringSelect</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:variable>
            <select data-dojo-type="dijit.form.FilteringSelect" class="login readonly" 
                    data-dojo-props="id:'{@id}', name:'{@name}', placeholder:'{@placeholder}', maxHeight:'200'">
              <option value=""></option>
              <xsl:call-template name='print-option'>
                <xsl:with-param name="valueList" select="@values"/>
                <xsl:with-param name="defaultValue" select="@value"/>
              </xsl:call-template>
            </select>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>

      <xsl:when test="@type = 'hidden'">
        <input type="hidden" id="{@name}" name="{@name}" value="{@value}"/>
      </xsl:when>

      <xsl:when test="@type = 'button' and @name = 'loginButton'">
        <input type="hidden" name="action" value="{@value}"/>
        <table class="formButtons">
          <tr>
            <td class="B_A">
              <button data-dojo-type="dijit.form.Button" class="loginButton" tabindex="3"
                      data-dojo-props="type:'button', id:'{@name}', name:'{@name}'">
                <xsl:value-of select="$a_n"/>
              </button>
            </td>
            <td class="B_R">
              <button data-dojo-type="dijit.form.Button" class="loginButton"
                      data-dojo-props="type:'button', id:'loginButtonCancel', iconClass:'dijitIconDelete'">
                <xsl:value-of select="$c_n"/>
              </button>
            </td>
            <td class="usersDialogStatus">
              <table>
                <td>
                  <img id="usersDialogPL" width="22" height="22" style="display:none"
                       src="{$base_path}/int/js/custom/images/preloader.gif"></img>
                </td>
                <td id="usersDialogStatus_icon" class="usersDialogStatus_icon">
                  <img id="usersDialogStatus_icon_false" width="13" height="13" style="display:none"
                       src="{$base_path}/int/js/custom/images/false.png"></img>
                  <img id="usersDialogStatus_icon_true" width="13" height="13" style="display:none"
                       src="{$base_path}/int/js/custom/images/true.png"></img>
                </td>
                <td>
                  <span id="usersDialogStatus_text" class="usersDialogStatus_text"></span>
                </td>
                <td>
                  <img id="usersDialogStatus_info" class="usersDialogStatus_info" width="22" height="22" 
                       style="display:none" src="{$base_path}/int/js/custom/images/info.png"></img>
                </td>
              </table>
            </td>
          </tr>
        </table>
      </xsl:when>

      <xsl:when test="@type = 'button' and @name = 'loginRegCertButton'">
        <xsl:variable name="updating">uLR_update</xsl:variable>
        <table class="formButtons">
          <tr>
            <td>
              <input data-dojo-type="dijit.form.CheckBox"
                     data-dojo-props="id:'loginRegCertCheckBox', value:'0', checked:false, onChange:{$updating}">
              </input>
            </td>
            <td class="certTxt">
              <xsl:value-of select="@title"/>
            </td>
            <td class="B_A_Reg">
              <button data-dojo-type="dijit.form.Button" class="loginButton disabled" tabindex="6"
                      data-dojo-props="type:'button', id:'{@name}', name:'{@name}', disabled:'disabled'">
                <xsl:value-of select="@a_n"/>
              </button>
            </td>
          </tr>
        </table>    
      </xsl:when>

      <xsl:when test="@type = 'button' and @name = 'loginButtonClose'">
        <input type="hidden" name="action" value="{@value}"/>
        <table class="formButtons">
          <tr>
            <td class="B_Cl">
              <button data-dojo-type="dijit.form.Button" data-dojo-props="type:'button', id: '{@name}', tabindex:'-1'">
                <xsl:value-of select="$cl_n"/>
              </button>
            </td>
          </tr>
        </table>
      </xsl:when>

      <xsl:when test="@type = 'button' and (@name = 'assignUserCertButton' or @name = 'createAssignUserCertButton')">
        <input type="hidden" name="action" value="{@value}"/>
        <table class="formButtons">
          <td class="B_A">
            <xsl:choose>
              <xsl:when test ="@name = 'assignUserCertButton'">
                <button data-dojo-type="dijit.form.Button" class="loginButton"
                        data-dojo-props="type:'button', id:'{@name}', name:'{@name}'">
                  <xsl:value-of select="@value"/>
                  <script type="dojo/connect" data-dojo-event="onClick" data-dojo-args="evt">
                    assignUserCert();
                  </script>
                </button>
              </xsl:when>
              <xsl:otherwise>
                <button data-dojo-type="dijit.form.Button" class="loginButton"
                        data-dojo-props="type:'button', id:'{@name}', name:'{@name}'">
                  <xsl:value-of select="@value"/>
                  <script type="dojo/connect" data-dojo-event="onClick" data-dojo-args="evt">
                    createAssignUserCert();
                  </script>
                </button>
              </xsl:otherwise>
            </xsl:choose>
          </td>
          <td class="B_R">
            <button data-dojo-type="dijit.form.Button" class="loginButton" tabindex='1'
                    data-dojo-props="type:'button', id:'loginButtonCancel'">
              <xsl:value-of select="$c_n"/>
              <script type="dojo/connect" data-dojo-event="onClick" data-dojo-args="evt">
                dijit.byId('usersDialog').hide();
              </script>
            </button>
          </td>
          <td class="usersDialogStatus">
            <table>
              <td>
                <img id="usersDialogPL" width="20" height="20" style="display:none"
                     src="//ajax.googleapis.com/ajax/libs/dojo/1.7.4/dijit/themes/claro/images/loadingAnimation.gif"></img>
              </td>
              <td id="usersDialogStatus_image" class="usersDialogStatus_image"></td>
              <td>
                <span id="usersDialogStatus_text" class="usersDialogStatus_text"></span>
              </td>
            </table>
          </td>
        </table>
      </xsl:when>

      <xsl:when test="@type = 'button' and @name = 'manageUserPagePermButton'">
        <input type="hidden" name="action" value="{@value}"/>
        <table class="formButtons">
          <td class="B_A">
            <button data-dojo-type="dijit.form.Button" class="loginButton"
                        data-dojo-props="type:'button', id:'{@name}', name:'{@name}'">
              <xsl:value-of select="@value"/>
              <script type="dojo/connect" data-dojo-event="onClick" data-dojo-args="evt">
                uM_u_permPage();
              </script>
            </button>
          </td>
        </table>
      </xsl:when>

    </xsl:choose>
  </xsl:template>





  <!-- PERSONAL AREA PAGE -->

  <xsl:template match="personal_area">

    <xsl:variable name="usersManagementSelectionClass">
      <xsl:choose>
         <xsl:when test="@tab_selection = 'users'">
           <xsl:text></xsl:text>
         </xsl:when>
         <xsl:otherwise>
           <xsl:text>pf_sh_c</xsl:text>
         </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="usersManagementDisplay">
      <xsl:choose>
         <xsl:when test="@tab_selection = 'users'">
           <xsl:text></xsl:text>
         </xsl:when>
         <xsl:otherwise>
           <xsl:text>display: none</xsl:text>
         </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:if test="$usersManagementDisplay = ''">
      <script type="text/javascript">uM_AutoInit('users');</script>
    </xsl:if>

    <xsl:variable name="profileSelectionClass">
      <xsl:choose>
         <xsl:when test="@tab_selection = 'profile'">
           <xsl:text></xsl:text>
         </xsl:when>
         <xsl:otherwise>
           <xsl:text>pf_sh_c</xsl:text>
         </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="profileDisplay">
      <xsl:choose>
        <xsl:when test="@tab_selection = 'profile'">
           <xsl:text></xsl:text>
         </xsl:when>
         <xsl:otherwise>
           <xsl:text>display: none</xsl:text>
         </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:if test="$profileDisplay = ''">
      <script type="text/javascript">uP_AutoInit();</script>
    </xsl:if>

    <xsl:variable name="notificationSelectionClass">
      <xsl:choose>
        <xsl:when test="@tab_selection = 'notifications'">
          <xsl:text></xsl:text>
        </xsl:when>
        <xsl:otherwise>
          <xsl:choose>
	          <xsl:when test="@isdemo = '1'">
		          <xsl:text>pf_sh_c</xsl:text>
            </xsl:when>
            <xsl:otherwise>
              <xsl:choose>
                <xsl:when test="@tab_selection = ''">
			<xsl:text></xsl:text>
                </xsl:when>
                <xsl:otherwise>
			<xsl:text>pf_sh_c</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="notificationsDisplay">
      <xsl:choose>
        <xsl:when test="@tab_selection = 'notifications'">
          <xsl:text></xsl:text>
        </xsl:when>
        <xsl:otherwise>
          <xsl:choose>
	          <xsl:when test="@isdemo = '1'">
		          <xsl:text>display: none</xsl:text>
            </xsl:when>
            <xsl:otherwise>
              <xsl:choose>
                <xsl:when test="@tab_selection = ''">
			<xsl:text></xsl:text>
                </xsl:when>
                <xsl:otherwise>
			<xsl:text>display: none</xsl:text>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="liveDemoSelectionClass">
      <xsl:choose>
         <xsl:when test="@tab_selection = 'demo'">
           <xsl:text></xsl:text>
         </xsl:when>
         <xsl:otherwise>
           <xsl:choose>
	     <xsl:when test="@tab_selection = '' and @isdemo = '1'">
		<xsl:text></xsl:text>
             </xsl:when>
             <xsl:otherwise>
                <xsl:text>pf_sh_c</xsl:text>
             </xsl:otherwise>
           </xsl:choose>
         </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="liveDemoDisplay">
      <xsl:choose>
         <xsl:when test="@tab_selection = 'demo'">
           <xsl:text></xsl:text>
         </xsl:when>
         <xsl:otherwise>
           <xsl:choose>
	     <xsl:when test="@tab_selection = '' and @isdemo = '1'">
		<xsl:text></xsl:text>
             </xsl:when>
             <xsl:otherwise>
                <xsl:text>display: none</xsl:text>
             </xsl:otherwise>
           </xsl:choose>
         </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <div id="preloader"></div>
    <div id="customContents" class="personalArea">
      <div class="pAMenu">
        <table class="pAMenu" cellpadding="0" cellspacing="0">
          <td id="pAId" class="pf_sh_c">
	          <xsl:value-of select="@active_user_name"/>
          </td>
          <xsl:if test="@isadmin = '1'">
	          <td id="usersManagementSelection" class="usersManagementSelection {$usersManagementSelectionClass}">
              <table class="pAUsers" onclick="uPa_select('management')" cellspacing="0">
                <td>
                  <img width="18" src="{$base_path}/int/js/custom/images/usersManagement.png"></img>
                </td>
                <td>
                  <xsl:value-of select="@pA_U_n"/>
                </td>
              </table>
            </td>
            <td class="pf_sh_c c"></td>
          </xsl:if>
          <td id="profileSelection" class="profileSelection {$profileSelectionClass}">
            <table class="pAProfile" onclick="uPa_select('profile')" cellspacing="0">
              <td>
                <img width="18" src="{$base_path}/int/js/custom/images/usersProfile.png"></img>
              </td>
              <td>
                <xsl:value-of select="@pA_P_n"/>
              </td>
            </table>
          </td>
          <td class="pf_sh_c c"></td>
          <td id="notificationSelection" class="notificationSelection {$notificationSelectionClass}">
            <table class="pANot" onclick="uPa_select('notifications')" cellspacing="0">
               <td>
                 <img width="22" src="{$base_path}/int/js/custom/images/usersNotifications.png"></img>
               </td>
               <td>
                 <xsl:value-of select="@pA_N_n"/>
               </td>
            </table>
          </td>
          <td class="pf_sh_c c"></td>
          <xsl:if test="@isdemo = '1'">
            <td id="liveDemoSelection" class="liveDemoSelection {$liveDemoSelectionClass}">
              <table class="pADemo" onclick="uPa_select('liveDemo')" cellspacing="0">
                <td>
                  <img width="18" src="{$base_path}/int/js/custom/images/formsInfo.png"></img>
                </td>
                <td>
                  <xsl:value-of select="@pA_D_n"/>
                </td>
              </table>
            </td>
            <td class="pf_sh_c c"></td>
          </xsl:if>
          <td class="pf_sh_c">
            <table>
              <td style="width:100%"></td>
            </table>
          </td>
        </table>
      </div>
      <div id="pAContents" class="pAContents">
        <xsl:if test="@isadmin = '1'">
          <div id="usersManagement" style="{$usersManagementDisplay}">
            <xsl:call-template name='print-users_management'/>
          </div>
        </xsl:if>
        <div id="profile" style="{$profileDisplay}">
          <div id="profileGPL" class="profileGPL">
             <img width="30" height="30" src="{$base_path}/int/js/custom/images/preloader_.gif"></img>
          </div>
          <div id="profileContents"></div>
        </div>
        <div id="notifications" style="{$notificationsDisplay}">
          <xsl:apply-templates select="div[@id='notificationsLayer']"/>
        </div>
        <xsl:if test="@isdemo = '1'">
          <div id="liveDemo" style="{$liveDemoDisplay}">
            <xsl:apply-templates select="div[@id='demoLayer']"/>
          </div>
        </xsl:if> 
      </div>
    </div>
  </xsl:template>









  <!-- SEARCHING PAGE -->

  <xsl:template match="search">
    <div data-dojo-type="dijit.form.Form" data-dojo-props="id:'f_search', name:'seek_main', method:'post', action:''">
      <script type="text/javascript">
        searchInit();
      </script>
      <h4 style="margin: 20pt 0 0 12pt">
        <xsl:value-of select="@command"/>
      </h4>
      <table class="search">
        <tr>
          <td>
            <table id="searchWidget" class="searchWidget" border="0" cellspacing="0">
              <td class="searchInput">
                <input data-dojo-type="dijit.form.TextBox" tabindex="1"
                       data-dojo-props="id:'search',name:'search',placeHolder:'Search...',onMouseEnter:HoveredSearch,onMouseLeave:UnHoveredSearch,onClick:UnHoveredSearch">
                </input>
              </td>
              <td id="searchClearIcon" class="searchClearIcon">
                <img width="13" height="13" src="{$base_path}/int/js/custom/images/clear.png" onclick="clearSearch()"></img>
              </td>
            </table>
          </td>
          <td class="searchButton">
            <button data-dojo-type="dijit.form.Button" id="searchButton" class="searchButton"
                    data-dojo-props="type:'button', name:'Accept'">
              <xsl:value-of select="@name"/>
              <script type="dojo/connect" data-dojo-event="onClick" data-dojo-args="evt">
                searchDo();
              </script>
            </button>
          </td>
          <td>
            <img id="searchPL" width="25" height="25" style="display:none"
                 src="//ajax.googleapis.com/ajax/libs/dojo/1.7.4/dijit/themes/claro/images/loadingAnimation.gif"></img>
          </td>
        </tr>
      </table>
      <table class="searchResults">
        <div id="searchResults"></div>
      </table>
    </div>
  </xsl:template>



  <!-- PAGES EDITION (WIKI) -->

  <xsl:template match="wiki">
    <div data-dojo-type="dijit.form.Form" data-dojo-props="id:'Wiki', method:'post', action:''">
      <table class="wiki_buttons">
        <td style='text-align:center'>
          <xsl:choose>
            <xsl:when test="@mode = 'wiki' and @type = 'html'">
              <xsl:variable name="wikiSelectionScript">
                require(['dojo/dom','dojo/dom-style'], function(dom, domStyle){
                  dom.byId('wiki_syntax').value = 'wiki';
                  dom.byId('wiki_mode').setAttribute('name','change');
                  dom.byId('wikitext_manage').setAttribute('name','wikitext');
                  dom.byId('wikitext_manage').value = dijit.byId('editor_<xsl:value-of select="@name"/>').get('value');
                  dijit.byId('WikiManage').submit();
                });
              </xsl:variable>
              <button data-dojo-type="dijit.form.Button"
                      data-dojo-props="type:'button', name:'syntax', style:'margin:0 180pt 0 8pt'">
                <xsl:text>Wiki Editor</xsl:text>
                <script type="dojo/connect" data-dojo-event="onClick" data-dojo-args="evt">
                  <xsl:value-of select="normalize-space($wikiSelectionScript)"/>
                </script>
              </button>
            </xsl:when>
            <xsl:when test="@mode = 'wiki' and @type = 'wiki'">
              <xsl:variable name="htmlSelectionScript">
                require(['dojo/dom','dojo/dom-style'], function(dom, domStyle){
                  dom.byId('wiki_syntax').value = 'html';
                  dom.byId('wiki_mode').setAttribute('name','change');
                  dom.byId('wikitext_manage').setAttribute('name','wikitext');
                  dom.byId('wikitext_manage').value = dijit.byId('<xsl:value-of select="@name"/>').get('value');
                  dijit.byId('WikiManage').submit();
                });
              </xsl:variable>
              <button data-dojo-type="dijit.form.Button"
                      data-dojo-props="type:'button', name:'syntax', style:'margin:0 180pt 0 8pt'">
                <xsl:text>HTML Editor</xsl:text>
                <script type="dojo/connect" data-dojo-event="onClick" data-dojo-args="evt">
                  <xsl:value-of select="normalize-space($htmlSelectionScript)"/>
                </script>
              </button>
            </xsl:when>
          </xsl:choose>
          <xsl:choose>
            <xsl:when test="@mode = 'wiki'">
              <button data-dojo-type="dijit.form.Button"
                      data-dojo-props="type:'submit', id:'accept', name:'accept', style:'margin:8pt'">
                <xsl:value-of select="@accept_name"/>
              </button>
              <button data-dojo-type="dijit.form.Button"
                      data-dojo-props="type:'submit', id:'preview', name:'preview', style:'margin:8pt'">
                <xsl:value-of select="@preview_name"/>
              </button>
              <xsl:choose>
                <xsl:when test="not(@is_mod)">
                  <xsl:variable name="wikiResetNotModScript">
                    require(['dojo/dom','dojo/dom-style','dojo/_base/xhr'], function(dom, domStyle, xhr){
                      dom.byId('wiki_mode').setAttribute('name','reset');
                      syntax = dojo.byId('wiki_syntax').getAttribute('value');
                      if ( syntax == 'html' ) {
                        dijit.byId('editor_wikitext').set('value','');
                      } else {
                      dijit.byId('wikitext').set('value','');
                      }
                      xhr.post({
                        url: '<xsl:value-of select="$base_path"/>/edit/<xsl:value-of select="$page"/>',
                        handleAs: 'text',
                        preventCache: 'true',
                        form: dom.byId('WikiManage'),
                        load: function(data) {
                          if (syntax == 'html') {
                            dijit.byId('editor_wikitext').set('value',data);
                            dom.byId('wikitext').value = data;
                          } else {
                            dijit.byId('wikitext').set('value',data);
                          }
                          dijit.byId('reset').setAttribute('disabled','disabled');
                        }
                      });
                    });
                  </xsl:variable>
                  <button data-dojo-type="dijit.form.Button"
                          data-dojo-props="type:'button', id:'reset', name:'reset', style:'margin:8pt', disabled:'disabled'">
                    <xsl:value-of select="@reset_name"/>
                    <script type="dojo/connect" data-dojo-event="onClick" data-dojo-args="evt">
                      <xsl:value-of select="normalize-space($wikiResetNotModScript)"/>
                    </script>
                  </button>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:variable name="wikiResetModScript">
                    require(['dojo/dom','dojo/dom-style','dojo/_base/xhr'], function(dom, domStyle, xhr){
                      dom.byId('wiki_mode').setAttribute('name','reset');
                      syntax = dojo.byId('wiki_syntax').getAttribute('value');
                      if ( syntax == 'html' ) {
                        dijit.byId('editor_wikitext').set('value','');
                      } else {
                        dijit.byId('wikitext').set('value','');
                      }
                      xhr.post({
                        url: '<xsl:value-of select="$base_path"/>/edit/<xsl:value-of select="$page"/>',
                        handleAs: 'text',
                        preventCache: 'true',
                        form: dom.byId('WikiManage'),
                        load: function(data) {
                          if (syntax == 'html') {
                            dijit.byId('editor_wikitext').set('value',data);
                            dojo.byId('wikitext').value = data;
                          } else {
                            dijit.byId('wikitext').set('value',data);
                          }
                          dijit.byId('reset').setAttribute('disabled','disabled');
                        }
                      });
                    });
                  </xsl:variable>
                  <button data-dojo-type="dijit.form.Button"
                          data-dojo-props="type:'button', id:'reset', name:'reset', style:'margin:8pt'">
                    <xsl:value-of select="@reset_name"/>
                    <script type="dojo/connect" data-dojo-event="onClick" data-dojo-args="evt">
                      <xsl:value-of select="normalize-space($wikiResetModScript)"/>
                    </script>
                  </button>
                </xsl:otherwise>
              </xsl:choose>
              <button data-dojo-type="dijit.form.Button"
                      data-dojo-props="type:'button', id:'cancel', name:'cancel', style:'margin:8pt'">
                <xsl:value-of select="@cancel_name"/>
                <script type="dojo/method" data-dojo-event="onClick" data-dojo-args="evt">
                  window.location.href = '<xsl:value-of select="$base_path"/>/<xsl:value-of select="$page"/>';
                </script>
              </button>
            </xsl:when>
            <xsl:otherwise>
              <xsl:variable name="wikiPreviewViewScript">
                require(['dojo/dom','dojo/dom-style'], function(dom, domStyle){
                  dom.byId('wiki_mode').setAttribute('name','accept');
                  dijit.byId('WikiManage').submit();
                });
              </xsl:variable>
              <xsl:variable name="wikiPreviewViewBackScript">
                require(['dojo/dom','dojo/dom-style'], function(dom, domStyle){
                  dom.byId('wiki_mode').setAttribute('name','back');
                  dijit.byId('WikiManage').submit();
                });
              </xsl:variable>
              <table class="wiki_buttons_preview" cellspacing="0" cellpadding="0">
                <td>
                  <button data-dojo-type="dijit.form.Button"
                          data-dojo-props="type:'button', name:'accept', style:'margin: 0 20pt 10pt'">
                    <xsl:value-of select="@accept_name"/>
                    <script type="dojo/connect" data-dojo-event="onClick" data-dojo-args="evt">
                      <xsl:value-of select="normalize-space($wikiPreviewViewScript)"/>
                    </script>
                  </button>
                  <button data-dojo-type="dijit.form.Button"
                          data-dojo-props="type:'button', id:'back', name:'back', style:'margin: 0 20pt 10pt'">
                    <xsl:value-of select="@back_name"/>
                    <script type="dojo/connect" data-dojo-event="onClick" data-dojo-args="evt">
                      <xsl:value-of select="normalize-space($wikiPreviewViewBackScript)"/>
                    </script>
                  </button>
                </td>
              </table>
            </xsl:otherwise>
          </xsl:choose>
        </td>
      </table>
      <input type="hidden" name="wiki_syntax" value="{@type}"/>
      <xsl:if test="@mode = 'wiki' and @type = 'html'">
        <xsl:variable name="wiki_value">
          <xsl:value-of select="text()" disable-output-escaping="yes"/>
        </xsl:variable>
        <table class="wikiEditor" cellspacing="0" cellpadding="0">
          <td>
            <input type="hidden" id="{@name}" name="{@name}" class="input_editor" value="{$wiki_value}"/>
            <div data-dojo-type="dijit.Editor"
                 data-dojo-props="id:'editor_{@name}', name:'p_editor_{@name}', height:'500px'">
              <xsl:value-of select="text()" disable-output-escaping="yes"/>
              <script type="dojo/method" data-dojo-event="onKeyUp" data-dojo-args="evt">
                dojo.byId('<xsl:value-of select="@name"/>').value = this.getValue();
                dijit.byId('reset').set('disabled',false);
              </script>
            </div>
          </td>
        </table>
      </xsl:if>
      <xsl:if test="@mode = 'wiki' and @type = 'wiki'">
        <xsl:variable name="wiki_value">
          <xsl:value-of select="text()"/>
        </xsl:variable>
        <script type="text/javascript">
          function enable_reset(){dijit.byId('reset').set('disabled',false);}
        </script>
        <table class="wikiEditor" cellspacing="0" cellpadding="0">
          <td>
            <input data-dojo-type="dijit.form.SimpleTextarea" class="wiki_area" value="{$wiki_value}" rows="20"
                   data-dojo-props="id:'{@name}', name:'{@name}', onKeyUp:enable_reset">
            </input>
          </td>
        </table>
      </xsl:if>
    </div>
    <div data-dojo-type="dijit.form.Form" data-dojo-props="id:'WikiManage', method:'post', action:''">
      <input type="hidden" id="wiki_syntax" name="wiki_syntax" value="{@type}"/>
      <input type="hidden" id="wiki_mode" name="" value=""/>
      <xsl:choose>
        <xsl:when test="@mode = 'preview'">
          <xsl:variable name="wiki_user_value">
            <xsl:value-of select="text()"/>
          </xsl:variable>
          <input type="hidden" id="wikitext_manage" name="wikitext" value="{$wiki_user_value}"/>
        </xsl:when>
        <xsl:otherwise>
          <input type="hidden" id="wikitext_manage" name="" value=""/>
        </xsl:otherwise>
      </xsl:choose>
    </div>
  </xsl:template>



</xsl:stylesheet>













