#-*- mode: Tcl; tcl-indent-level :  4 -*-

set ::MSGCAT_GID 1

set _DebugDefaultValues 0

set ::GidPriv(VerticalRoundBars)  1

set ::GidPriv(GiDRuedas) 1 ;#deprecated, but not remove it because some old problemtype ask for this variable!

# one of Icon, Text, IconText
if { ![ info exists ::GidPriv(BarButtonLook)]} {
    set ::GidPriv(BarButtonLook) Icon
}

proc IconTextConfigureLook { w img text } {
    #w its a ttk button or ttk menubutton

    # set ::GidPriv(BarButtonLook,$w,image) $img
    # set ::GidPriv(BarButtonLook,$w,text) $img
    if { "$::GidPriv(BarButtonLook)" == "Icon"} {
        $w configure -image $img -compound none
        # -font SmallFont
        # -padx 1 -pady 1
    } elseif { "$::GidPriv(BarButtonLook)" == "Text"} {
        $w configure -text " $text " -image "" -compound top
        # -height 1 -font SmallFont -padx 8 -pady 4
    } elseif { "$::GidPriv(BarButtonLook)" == "IconText"} {
        $w configure -image $img -text " $text " -compound top
        # -font SmallFont -padx 1 -pady 1 
    }
}

proc IconTextAdjustText { w } {
    set comp_mode ""
    catch { 
        set comp_mode [ $w cget -compound]
    }
    if { ( $comp_mode == "top") || ( $comp_mode == "left")} {
        $w configure -compound left
        if { $::GidPriv(BarButtonLook) == "Text"} {
            $w configure -height 1 -width [ string length [ $w cget -text]]
        }
    }
}

proc IconTextOrTextGetWidth { w } {    
    set comp_mode ""
    catch { set comp_mode [ $w cget -compound] }
    set width 0
    if { ( $comp_mode == "top") || ( $comp_mode == "left")} {
        if { $::GidPriv(BarButtonLook) == "IconText"} {
            #in ttk width=number of characters
            set width [string length [ $w cget -text]]
        } elseif {$::GidPriv(BarButtonLook) == "Text" } {
            set width [string length [ $w cget -text]]
        }
    }
    return $width
}

proc IconTextAdjustPads { w } {    
    set comp_mode ""
    catch { set comp_mode [ $w cget -compound] }   
    if { ( $comp_mode == "top") || ( $comp_mode == "left")} {
        if { $::GidPriv(BarButtonLook) == "Text"} {
            grid configure $w -padx 4 -pady 2           
        }
    }
}


if { ![ info exists ::GidPriv(TooltipPopup)]} {
    set ::GidPriv(TooltipPopup) "normal"
}

if { $::MSGCAT_GID } {
    # forzamos el autoload de msgcat
    msgcat::mc ""

    # ahora sobreescribimos el procedimiento mcunknown
    proc msgcat::mcunknown {locale src args} {
        # para encontrar en la fase de desarrollo cadenas por traducir
        # Retornamos el string con la primera letra en minuscula y el resto en mayusculas
        # Evitamos modificar los argumentos al printf para evitar errores
        if {[llength $args]} {
            set src [eval [ list format $src] $args]
        }
        return $src
        #         set ret [string tolower [string index $src 0]
        #         set prevchar ""
        #         for {set i 1} {$i < [string length $src]} {incr i} {
        #             set char [string index $src $i]
        #             if { $prevchar == "%" } {
        #                 # to avoid errors as %d format translated as %D
        #                 append ret $char
        #             } else {
        #                 append ret [string toupper $char]
        #             }
        #             set prevchar $char
        #         }
        #         return $ret
    }
}

proc GidTkBackCompatibility {} {
    #tcl/tk 8.4 hide private tk[a-Z]* procedures
    set comms { tkSaveGrabInfo tkButtonInvoke tkTextSelectTo tkEntryInsert tkEntryBackspace \
                    tk_textCut tk_textCopy tk_textPaste tk_focusNext tk_focusPrev tkTextClosestGap \
                    tkTextAutoScan tkCancelRepeat tkTextInsert tkTabToWindow \
                    tkGenerateMenuSelect tk_popup tk_menuSetFocus tkMbPost }
    set hay_expose [ info commands tk::unsupported::ExposePrivateCommand]
    foreach i $comms {
        auto_load $i
        if { ![llength [info commands $i]] && $hay_expose != "" } {
            tk::unsupported::ExposePrivateCommand $i
        }
    }
    set vars { tkPriv }
    foreach i $vars {
        ::tk::unsupported::ExposePrivateVariable $i
    }
}

set err [catch { package present Tk }]
if { !$err } {
    GidTkBackCompatibility
}

#avoid wrong menu images with Windows animation effects
if { $::tcl_platform(platform) == "windows" } {
    proc GiD_PopupMenu {menu x y} {
        # temporarily disable menu animations because they trigger a bug in
        # Tk causing menu images to be incorrectly displayed
        set enabled [ GiD_SetMenuAnimation]
        if {$enabled} {
            GiD_SetMenuAnimation 0
        }
        tk_popup $menu $x $y
        if {$enabled} {
            GiD_SetMenuAnimation $enabled
        }
    }
} else {
    proc GiD_PopupMenu {menu x y} {
        tk_popup $menu $x $y
    }
}

proc .central.s { args } {
    return [eval .gid.central.s $args]
}

proc IsValidWmGeometry { newgeometry } {
    return [regexp {^([0-9]+x[0-9]+)?([+-][0-9]+[+-][0-9]+)?$} $newgeometry]
}

proc GiveGidDefaultsFile { } {
    return [ gidgetdefaultsfile]   
}

global GidPriv

set err [catch { package present Tk }]
if { !$err } {
    package require Img

    if { ![ info exists GidPriv(VerifImage)]} {
        #set GidPriv(VerifImage) [ gid_themes::GetImage dialog-ok-apply.png small_icons]
        set GidPriv(VerifImage) [ image create photo -data {
            iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAFo9M/3AAAABGdBTUEAAYagMeiWXwAAAmpJ
                REFUOI1jYEAGEXVrPjAwMDAwaAZOaGDACkzip99lYGBgYLArWvNXPXjKJQwVigFTguEcj7wl
                1xkYGBiYxPW6FRgY/jPff/GOkYGBgYFBzHmi3bSN5/9htwYKRO2nKLUtPfhXwrbTAkNS3KrP
                unzOnn9SzpNNGRgYGBgZ7Ot5Il1M3r57+WHb1Rtvdzh5qM3YuP+B4cetWRdQdAq7TnY3SZn/
                UdiqUxWv/RA/TBS1SZ6xi4EhlJMFm7yXuvDGX3/+SDIwrP7OhC7Jbz9f19pc1uLajc9hWE0P
                KF3+VD962i0Yn4mBoZ6HwXgmPwMDA4OM50xfAQk+ybevv0fCdSj5TGzuWXnqF7/3NIPIxvXf
                VEMmX0U2keXelnfNszlO+cR5ap599eU306vXfyKQFUAigKGeTStM4vjf3/9e3Fyf7Y1FATGg
                ns0oVjrCTEd8wvvv39jPnn5ec2erzAyMYMAOVnGaRMjmu1rJzfrN8I/39Nk3M+/c/7iQgSHs
                O2EXGM/kN1L9U+tgp5z/7M1nhpPHX/Tff8XWynA2/SMDAwMD1piCA4+JokYC/3rdnTWiT157
                +vf+jbfd919xdcE0Qw0I5VRwsw9SUObL5WZjPn/qwvvu1wdzHkoa10uJC7LPcnfRdN989Oaf
                D0+/tj55wzUBWTMDAyQQmfmsJuob6PLNEpMWM1AS4/5/7frTs+8/fxe2tlZX3nXs1u+3z740
                P/72bgLDwcYv6I5ECoN6NmFrLgcxaZ4+WRVpLX1VScb9x67/fP34fc3D7x9mYNOMZgDCIEFn
                VjU+Ng7Zb1+Zb78+VHCfgYHxL65gAgAfTeU4YgmgfwAAAABJRU5ErkJggg==
        } -format png]
    }
    if { ![ info exists GidPriv(VerifNoImage)]} {
        #set GidPriv(VerifNoImage) [ gid_themes::GetImage blank.png small_icons]
        set GidPriv(VerifNoImage) [ image create photo -data {
            iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAFo9M/3AAAABGdBTUEAAYagMeiWXwAAADhJ
                REFUOI1j/P//PwMDAwMDEwMUMOIWgQEmBjRAWAVhAQwzCOqgvoLB4IbBoIBgOFBsw6gBQ8EA
                ABlgFSH9bX7LAAAAAElFTkSuQmCC
        } -format png]
    }
}

# Author:       RAMSAN
# Date:         7 Feb 1997
# Function:     ReadDefaultValues
# Description:  Reads in file ~/.gidDefaults or window\gid.ini  and finds there
#               some GUI configuration variables
#
# Note: ReadDefaultValues now is called before with the best estimated size file gidDefaults1024x768
# and after with gid.init or .gidDefaults, ant the second time overwrite previous values,
# with the old - inverse system if call again ReadDefaultValues with other file, previous values don't change

proc ReadDefaultValues { file } {
    #don't forget to check Main.cc which uses GidUnknownDefaults GidKnownDefaults
    global GidPriv GidUnknownDefaults GidKnownDefaults
    global MainWindowGeom DefaultSearchDirectoryP
    global CalcAngleUnits RunProcInfo GidProcWin
    global tcl_platform
    if { $::_DebugDefaultValues} {
        DebugText ReadDefaultValues file= $file
    }

    if { ![info exists ::GiDTBLayout] } {
        array set ::GiDTBLayout {
            INSIDE,CURRENT ""
            INSIDE,INI     ""
            INSIDE,PRE     ""
            INSIDE,POST    ""
        }
    }
    if { ![info exists GidProcWin(remoteserver)] } {
        set GidProcWin(remoteserver) ""
    }
    if { ![info exists GidProcWin(remotegroup)] } {
        set GidProcWin(remotegroup) ""
    }
    if { ![info exists GidProcWin(remoteuser)] } {
        set GidProcWin(remoteuser) ""
    }

    if { $::tcl_platform(platform) ne "windows" } {
        if { ![file exists $file] } {
            #if file does not exist, but exists without .gid folder (previous style) use it
            set foldername [file dirname $file]
            if { [file tail $foldername] eq ".gid" } {               
                set fileold [file join [file dirname $foldername] [file tail $file]]
                if { [file exists $fileold] } {
                    set file $fileold
                }
            }
        }
    }
    if { [catch { set fileid [open $file r] }] } {
        #after idle [WarnWinText [_ "Configuration file %s not found" $file]]
        return
    }
    fconfigure $fileid -encoding "utf-8"

    lappend ::GiDTBLayout(inifile) $file
    set ::GiDTBLayout($file,INSIDE,INI) [list]
    #set ::GiDTBLayout($file,INSIDE,cmd)  [list]

    while { ![eof $fileid] } {
        set aa [string trim [gets $fileid]]
        if { $aa == "" } continue
        if { [catch { set varname [lindex $aa 0] } ] } continue
        set unknow 0
        switch -- $varname {
            MainWindowGeom {
                set MainWindowGeom [lrange $aa 1 end]
            }
            BitmapsGeom {
                set varname PrePostBitmapsWindowGeom
                if { [lindex $aa 1] != "NONE" } {
                    set GidPriv(PrePostBitmapsWindowGeom) "OPEN [lindex $aa 1] 1 CreateBitmaps"
                    #why ? after idle CreateBitmaps
                } else {
                    set GidPriv(PrePostBitmapsWindowGeom) "NONE {} 1 CreateBitmaps"
                }
            }
            DefaultSearchDirectory {
                # old compatibility
                # set DefaultSearchDirectory [lrange $aa 1 end]
                set ::DefaultDirectories(file) [lrange $aa 1 end]
            }
            DefaultSearchDirectoryP {
                set DefaultSearchDirectoryP [lrange $aa 1 end]
            }
            DefaultDirectories {
                array set ::DefaultDirectories [ lrange $aa 1 end]
            }
            RightButtonsGeom {
                set varname PrePostRightButWindowGeom
                if { [lindex $aa 1] != "NONE" } {
                    set GidPriv(PrePostRightButWindowGeom) "OPEN [lindex $aa 1] 1 RightButtons"
                    #why ? after idle RightButtons
                } else {
                    set GidPriv(PrePostRightButWindowGeom) "NONE {} 1 RightButtons"
                }
            }
            BottomEntryGeom {
                set varname PrePostEntryWindowGeom
                if { [lindex $aa 1] != "NONE" } {
                    set GidPriv(PrePostEntryWindowGeom) "OPEN [lindex $aa 1] 1 BottomEntryFrame"
                    # why? after idle CreateBitmaps
                } else {
                    set GidPriv(PrePostEntryWindowGeom) "NONE {} 1 BottomEntryFrame"
                }
            }
            CalcAngleUnits {
                set CalcAngleUnits [lindex $aa 1]
            }
            ListEntitiesGeom {
                if { [lindex $aa 1] != "NONE" } {
                    set GidPriv(ListEntitiesWindowGeom) "OPEN [lindex $aa 1]"
                } else {
                    set GidPriv(ListEntitiesWindowGeom) "NONE +0+176 "
                }
            }
            RunProcInfo {
                set RunProcInfo [lrange $aa 1 end]
                # 3 seconds to permmit the GiD window to appear
                after 3000 ActualizeProcInfoBegin
            }
            remoteserver {
                set GidProcWin(remoteserver) [lindex $aa 1]
            }
            remotegroup {
                set GidProcWin(remotegroup) [lindex $aa 1]
            }
            remoteuser {
                set GidProcWin(remoteuser) [lindex $aa 1]
            }
            remoteauto {
                set GidProcWin(remoteauto) [lindex $aa 1]
            }
            remotetime {
                set GidProcWin(remotetime) [lindex $aa 1]
            }
            remoteport  {
                set GidProcWin(remoteport) [lindex $aa 1]
            }
            remotetimeout {
                set GidProcWin(remotetimeout) [lindex $aa 1]
            }
            remoteresultsdownload {
                set GidProcWin(remoteresultsdownload) [lindex $aa 1]
            }
            remoteresultsdelete {
                set GidProcWin(remoteresultsdelete) [lindex $aa 1]
            }
            NormalFont {
                if { !$::GidPriv(OffScreen) && ![GidUtils::IsTkDisabled] } {
                    lassign $aa fn family size weight slant
                    font configure $fn -family $family -size $size -weight $weight -slant $slant
                    font configure BoldFont -family $family -size $size -weight bold -slant $slant
                    font configure SmallFont -family $family -size [expr $size-2] -weight $weight -slant $slant
                }
            }
            FixedFont -
            BigFont -
            SmallFont {
                if { !$::GidPriv(OffScreen) && ![GidUtils::IsTkDisabled]} {
                    lassign $aa fn family size weight slant
                    font configure $fn -family $family -size $size -weight $weight -slant $slant
                }
            }
            LayersAlsoLower {
                set GidPriv(LayersAlsoLower) [lindex $aa 1]
            }
            LayersBackOpposite {
                set GidPriv(LayersBackOpposite) [lindex $aa 1]
            }
            DuplicateEntities {
                set GidPriv(DuplicateEntities) [lindex $aa 1]
            }
            GiDTkFBoxPreview {
                set GidPriv(GiDTkFBoxPreview) [lindex $aa 1]
            }
            LayersAlphabetic {
                set GidPriv(LayersAlphabetic) [lindex $aa 1]
            }
            SoftwareOpenGL {
                set GidPriv(SoftwareOpenGL) [ lindex $aa 1]
            }
            DisableTooltips {
                set ::GidPriv(TooltipPopup) "disabled"
            }
            TooltipPopup {
                set ::GidPriv(TooltipPopup) [ lindex $aa 1]
            }
            BarButtonLook {
                set ::GidPriv(BarButtonLook) [ lindex $aa 1]
            }
            HaveViewMenu {
                #obsolete option
            }
            DisplayCoordinates {
                set GidPriv(Displaycoordinates) [lindex $aa 1]
            }
            LayerLayout {
                set GidPriv(LayerLayout) [lindex $aa 1]
            }
            PostDisplayLocation {
                set GidPriv(PostDisplayLocation) [lindex $aa 1]
            }
            ToglWinMode {
                set GidPriv(ToglWinMode) [lindex $aa 1]
            }
            Language {
                GidUtils::SetCurrentLanguage [lindex $aa 1] 0
            }                  
            RealFormatDefault {
                set GidPriv(RealFormat,Default) [lindex $aa 1]
            }
            AdvanceBarInMainWindow {
                #deprecated, now use ProgressBarInMainWindow instead of AdvanceBarInMainWindow and PostProgressBarInMainWindow
                GiD_Set ProgressBarInMainWindow [lindex $aa 1]
            }
            PostProgressBarInMainWindow {
                #deprecated, now use ProgressBarInMainWindow instead of AdvanceBarInMainWindow and PostProgressBarInMainWindow
                GiD_Set ProgressBarInMainWindow [lindex $aa 1]
            }
            ProgressBarInMainWindow {
                GiD_Set ProgressBarInMainWindow [lindex $aa 1]
            }
            ProgressInMeshingMore {
                set ::GidPriv(ProgressInMeshing,More) [lindex $aa 1]
            }
            MeshCartesianSameSizes {
                set ::MeshCartesianDataPriv(samesizes) [lindex $aa 1]
            }
            ShowCheckNewVersion {
                set ::GidPriv(ShowCheckNewVersion) [lindex $aa 1]
            }
        default {
        if { [string match Theme* $varname] } {
            set unknow 1
            if { [string match $varname Theme] || [string match $varname Theme(Current)] } {                
                if {![GidUtils::IsTkDisabled] && $::GidPriv(ThemeSelection)=="1" } {
                    gid_themes::SetCurrentTheme [lindex $aa 1]
                }
                set unknow 0
            } elseif { [string match Theme(Size,* $varname] } {
                foreach theme [gid_themes::GetThemes] {
                    if { [string match Theme(Size,$theme) $varname] } {
                        set GidPriv(ThemeSize,$theme) [lindex $aa 1]
                        gid_themes::UpdateCurrentThemeSize
                        set unknow 0
                        break;
                    }
                }
            }             
        } elseif { [string match *WindowGeom $varname] } {
                    #set name [lindex $aa 0]
                    set GidPriv($varname) [lrange $aa 1 end]
                    if { [lindex $GidPriv($varname) 2] != "0" && \
                             [lindex $GidPriv($varname) 2] != "1" } {
                        set GidPriv($varname) [linsert $GidPriv($varname) 2 1]
                    }
                } else {
                    set unknow 1
                }
            }
        }
        if { $unknow } {
            #don't forget to check Main.cc and Post/utils_post.cc which uses GidUnknownDefaults GidKnownDefaults
            #to preserve unknown variables (probably used by a new version), because the file is shared by all versions
            set GidUnknownDefaults($varname) [lrange $aa 1 end]
        } else {
            #don't forget to check Main.cc and Post/utils_post.cc which uses GidUnknownDefaults GidKnownDefaults
            set GidKnownDefaults($varname) [lrange $aa 1 end]
        }
        if {[regexp ^INSIDE [lindex $aa 1]]} {
            if {[lsearch $::GiDTBLayout($file,INSIDE,INI) $varname] == -1} {
                lappend ::GiDTBLayout($file,INSIDE,INI) $varname
                #                 set cmd [lindex $aa 4 end]
                #                 if {$cmd eq ""} {
                #                     # PrePostRightButWindowGeom INSIDE {} RightButtons
                #                     set cmd [lindex $aa end]
                #                 }
                #                 lappend ::GiDTBLayout($file,INSIDE,cmd)  $cmd
            }
        }
    }
    if {[llength $::GiDTBLayout($file,INSIDE,INI)]} {
        set ::GiDTBLayout(INSIDE,INI) $::GiDTBLayout($file,INSIDE,INI)
    }
    close $fileid
}

# GiDTBLayout -- Data Structure
#
#  INSIDE,CURRENT : PRE | POST | {}
#
#  INSIDE,INI : names from ini file
#
#  INSIDE,PRE : last order of toolbars in PRE, initially it's empty
#
#  INSISE,POST : last order of toolbars in POST, initially it's empty
#
#  .gid.$frame : the list of toolbars gridded in order
#
#

# where must be PRE or POST
#
proc SetGiDTBLayout { where } {
    set current $::GiDTBLayout(INSIDE,CURRENT)
    if {$current eq ""} {
        set ::GiDTBLayout(INSIDE,PRE) $::GiDTBLayout(INSIDE,INI)
        set ::GiDTBLayout(INSIDE,POST) $::GiDTBLayout(INSIDE,INI)
    } else {
        # save current status
        set ::GiDTBLayout(INSIDE,$current) {}
        foreach f {top left right bottom} {
            foreach tb $::GiDTBLayout(.gid.$f) {
                lappend ::GiDTBLayout(INSIDE,$current) $::GiDTBLayout(tb,$tb)
                destroy $tb
            }
            set ::GiDTBLayout(.gid.$f) {}
            grid remove .gid.$f
        }
    }
    set ::GiDTBLayout(INSIDE,CURRENT) $where
}

#
# what can be: PRE or POST
#

proc OpenOutsideWindows { what } {
    global GidPriv
    if { [winfo exists .gid.central.s] && ( [.gid.central.s disable windows] || \
                                                [ GiD_Set usemorewindows] == 0 ) } return

    # hace falta? update idletasks
    set visited {}

    SetGiDTBLayout $what

    # create the INSIDE windows just in the order they where read
    # from ini or saved
    #WarnWinText "=========== Visitando $what [clock format [clock seconds]] ==========="
    set ::tb_errors {}
    foreach name $::GiDTBLayout(INSIDE,$what) {
        lappend visited $name
        if {[catch {set val $GidPriv($name)}]} continue
        if {[catch { eval [lrange $val 3 end] } msg]} {
            lappend ::tb_errors $msg
            # remove that entry GidPriv and ::GiDTBLayout
            set GidPriv($name) [lindex $GidPriv($name) 0]
        }
        #WarnWinText "$name -> $val"
        #if {[catch { eval [lrange $val 3 end] } msg]} {
        #    WarnWinText "failed: $msg"
        #    WarnWinText "$::errorInfo"
        #}
    }
    #WarnWinText "=========== Saliendo $what [clock format [clock seconds]] ==========="

    foreach {name val} [array get GidPriv PrePost*Geom] {
        if {[lsearch $visited $name] != -1} continue
        lappend visited $name
        if { ([lindex $val 0] == "OPEN" || [string match INSIDE* [lindex $val 0]]) \
                 || $name == "PrePostTopMenuWindowGeom" } {
            #check if the widget exists and then not re-create it when swapping pre <-> post
            regsub {Geom$} $name {} geomwinname
            if { [info exists GidPriv($geomwinname)] && [winfo exists $GidPriv($geomwinname)] } {
                #WarnWinText "not recreate $name"
                set recreate 0
            } else {
                set recreate 1
            }            
            #
            if { $recreate } {
                if {[catch { eval [lrange $val 3 end] } msg]} {
                    lappend ::tb_errors "$name \n\t $msg"
                }
            }
        }
    }
    
    if { $what == "PRE" } {
        # first close all POST windows
        foreach {name val} [array get GidPriv *Geom] {
            if {[lsearch $visited $name] != -1} continue
            regsub {Geom$} $name {} namegeom
            if { [string match *PrePost* $name] } {
                continue
            } elseif { [string match *Post* $name] } {
                set aa [lindex $val 0]
                if { $name == "PostDisplayWindowGeom" } {
                    if { $aa == "OPEN" } {
                        set prev $GidPriv($name)
                        GidUtils::CloseWindow POSTDISPLAY
                        set $GidPriv($name) $prev ;#to restore when changing to pre
                    }
                } else {
                    if { [info exists GidPriv($namegeom)] && [winfo exists $GidPriv($namegeom)] } {
                        destroy $GidPriv($namegeom)
                    }
                }
                set GidPriv($name) "$aa [lrange $val 1 end]"
            }
        }
        
        # then open PRE windows
        foreach {name val} [array get GidPriv *Geom] {
            if {[lsearch $visited $name] != -1} continue
            regsub {Geom$} $name {} namegeom
            if { [string match *PrePost* $name] } {
                continue
            }  elseif { ![string match *Post* $name] && \
                ([lindex $val 0] == "OPEN" || \
                    [string match INSIDE* [lindex $val 0]])} {
                catch { eval [lrange $val 3 end] }
            }
        }
    }
     
    if { $what == "POST" } {
        # first close all PRE windows
        foreach {name val} [array get GidPriv *Geom] {
            if {[lsearch $visited $name] != -1} continue
            regsub {Geom$} $name {} namegeom
            if { [string match *PrePost* $name] } {
                continue
            } elseif { ![string match *Post* $name] } {
                set aa [lindex $val 0]
                if { $name == "LayersWindowGeom" } {
                    if { $aa == "OPEN" } {
                        set prev $GidPriv($name)
                        GidUtils::CloseWindow LAYER
                        set $GidPriv($name) $prev ;#to restore when changing to pre
                    }
                } else {
                    if { [info exists GidPriv($namegeom)] && [winfo exists $GidPriv($namegeom)] } {
                        destroy $GidPriv($namegeom)
                    }
                }
                set GidPriv($name) "$aa [lrange $val 1 end]"
            }
        }
        
        # then open POST windows
        foreach {name val} [array get GidPriv *Geom] {
            if {[lsearch $visited $name] != -1} continue
            regsub {Geom$} $name {} namegeom
            if { [string match *PrePost* $name] } {
                continue
            }  elseif { [string match *Post* $name] && \
                [lindex $val 0] == "OPEN"  || \
                    [string match INSIDE* [lindex $val 0]]} {
                catch { eval [lrange $val 3 end] }
            } 
        }
    }

  
    #     set name LayersWindowGeom
    #     set val $GidPriv($name)
    #     if { $what == "POST" } {
    #         if { [lindex $val 0] == "OPEN" } {
    #             GidUtils::CloseWindow LAYER
    #         }
    #     } else {
    #         if { [lindex $val 0] == "OPEN" } {
    #             catch { eval [lrange $val 3 end] } ;#ChangeLayers
    #         }
    #     }

    ###puts " . fin"
    if {[info exists GidPriv(ToglWinMode)]} {       
        .gid.central.s makenewwindow $GidPriv(ToglWinMode)
        #after idle [list GiD_Process 'NewWin $GidPriv(ToglWinMode)]
    }
}

proc IsSplashWindowOnInFile { file} {

    # set file [ GiveGidDefaultsFile]

    if { [catch { set fileid [open $file r] }] } {
        return -1
    }
    fconfigure $fileid -encoding "utf-8"
    while { ![eof $fileid] } {
        set aa [gets $fileid]
        if { [regexp {SplashWindow[ ]*([01])} $aa {} val] } {
            close $fileid
            return $val
        }
    }
    close $fileid
    return 1
}

proc IsSplashWindowOnInDefaults { } {

    set ret [ IsSplashWindowOnInFile [ GiveGidDefaultsFile]]

    # ahora probamos como quiere Ramon: segun el gidDefaultXXXxXXX
    if { $ret == -1} {
        set ret [ IsSplashWindowOnInFile [ GiveBestGidDefaults]]
    }
    if { $ret == -1} {
        set ret 1
    }
    return $ret
}

proc WriteTCLDefaults { } {
    WriteTCLDefaultsInFile [ GiveGidDefaultsFile]


    #to know the more important messages to be translated
    if { [info exists ::COUNTHITSMSGS] && $::COUNTHITSMSGS } {
        set filename [file join [file dirname [ GiveGidDefaultsFile]] "MsgsHits.xml"]
        if { [file exists $filename] } {
            #append the previous hits counter
            set fp [open $filename r]
            if { $fp != "" } {
                set map [list "&gt;" > "&lt;" < "&amp;" & "&quot;" \" "&apos;" ']
                while { ![eof $fp] } {
                    gets $fp aa
                    if { [regexp {<string>(.*)</string><hits>([0-9]*)</hits>} $aa dummy name frequency] } {
                        if { [string is integer $frequency] } {
                            set name [string map $map $name]
                            if { [info exists ::MsgsHits($name)] } {
                                incr ::MsgsHits($name) $frequency
                            } else {
                                set ::MsgsHits($name) $frequency
                            }
                        }
                    }
                }
                close $fp
            }
        }
        #save accumulated hits counter
        set fp [open $filename w]
        if { $fp != "" } {
            set map [list > "&gt;" < "&lt;" & "&amp;" \" "&quot;" ' "&apos;"]
            puts $fout <frequencies>
            set orderedlist [lsort -integer -decreasing [array names ::MsgsHits]]
            foreach str $orderedlist {
                puts -nonewline $fp "<string>[string map $map $str]</string>"
                puts $fp "<hits>$::MsgsHits($str)</hits>"
            }
            puts $fout </frequencies>
            close $fp
        }
    }

}

proc WriteTCLDefaultsInFile { file } {
    #don't forget to check Main.cc and Post/utils_post.cc which uses GidUnknownDefaults GidKnownDefaults
    global GidPriv GiDPrivToolBar GidUnknownDefaults
    global MainWindowGeom DefaultSearchDirectoryP
    global CalcAngleUnits RunProcInfo GidProcWin
    global tcl_platform

    if { $::GidPriv(OffScreen) || [GidUtils::IsTkDisabled] } {
        return
    }

    if { $::_DebugDefaultValues} {
        DebugText "WriteTCLDefaultsInFile  file = $file"
    }
    
    if { ![winfo exists .gid] } {
        set MainWindowGeom "800x600+100+100"
    } else {
        if { $::tcl_platform(platform) eq "windows" && [wm state .gid] eq "zoomed" } {
            set zoomed 1
        } elseif { ![catch { wm attributes .gid -zoomed } ret] && $ret } {
            set zoomed 1
        } else {
            set zoomed 0
        }
        if { $zoomed } {
            if { ![info exists MainWindowGeom] } {
                set MainWindowGeom "800x600+100+100"
            }
            set geom $MainWindowGeom
            if { [lindex $geom 0] ne "ZOOMED" && \
                     [regexp {([^x]*)x([^+-]*)([+-]*[0-9]*)([+-]*[0-9]*)} $geom] } {
                set MainWindowGeom "ZOOMED $geom"
            } elseif { [regexp {([^x]*)x([^+-]*)([+-]*[0-9]*)([+-]*[0-9]*)} \
                            [lindex $geom 1]] } {
                set MainWindowGeom $geom
            } else {
                set MainWindowGeom "ZOOMED 800x600+100+100"
            }
        } else {
            set MainWindowGeom [wm geom .gid]
            regexp {([^x]*)x([^+-]*)([+-]*[0-9]*)([+-]*[0-9]*)} $MainWindowGeom \
                trash w h x y
            if { [.gid cget -menu] != "" } {
                if { $::tcl_platform(platform) eq "windows" } {
                    set menuheight [ GiD_Info menuheight]
                } else {
                    set menuheight 0
                }
                incr h $menuheight
            }
            if { $::tcl_platform(platform) eq "windows" } {
                set windowcaptionheight [ GiD_Info windowcaptionheight]
            } else {
                set windowcaptionheight 0
            }
            if { $x <= 0 } { set x +-4 }
            if { $y <= 0 } { set y +-4 }
            if { $w >= [ winfo screenwidth .gid] && \
                     [expr $h+$windowcaptionheight] >= [ winfo screenheight .gid] } {
                set w [ winfo screenwidth .gid]
                set h [ winfo screenheight .gid]
                set x +-4
                set y +-4
            }
            set MainWindowGeom ${w}x${h}${x}${y}
        }
    }

   
    if { ![info exists CalcAngleUnits] } {
        set CalcAngleUnits "rad"
    }
    set varslist { MainWindowGeom $::DefaultDirectories(file) \
                       DefaultSearchDirectoryP CalcAngleUnits}

    set fileid [open $file a]
    fconfigure $fileid -encoding "utf-8"
    
    #If exist GiDPriv(NextRestartTheme) we must over write all these options (the same as gid_themes::SetCurrentThemeAndApplyBackground)
    set listcolorkeys {BackgroundColor BackColorType BackColorTop BackColorBottom BackColorSense ColorPoints
                     ColorNodes ColorLines ColorPolyLines ColorSurfaces ColorSurfsIsoparametric ColorVolumes
                     ColorElements}
    if { [gid_themes::GetCurrentTheme] != [gid_themes::GetNextRestartTheme] } {
        set name [gid_themes::GetNextRestartTheme]
        foreach key $listcolorkeys {
            puts $fileid "$key [set ::gid_themes::Themes($name,$key)]"
        }        
    } else {
        foreach key $listcolorkeys {
            puts $fileid "$key [GiD_Set $key]"
        }
    }
    
    
    foreach i $varslist {
        if { [info exists $i] } {
            puts $fileid "$i [set $i]"
        }
    }
    puts $fileid "DefaultDirectories [ array get ::DefaultDirectories]"

    if { [info exists GidPriv(LayersAlsoLower)] } {
        puts $fileid "LayersAlsoLower $GidPriv(LayersAlsoLower)"
    }
    if { [info exists GidPriv(LayersBackOpposite)] } {
        puts $fileid "LayersBackOpposite $GidPriv(LayersBackOpposite)"
    }
    if { [info exists GidPriv(DuplicateEntities)] } {
        puts $fileid "DuplicateEntities $GidPriv(DuplicateEntities)"
    }
    if { [info exists GidPriv(GiDTkFBoxPreview)] } {
        puts $fileid "GiDTkFBoxPreview $GidPriv(GiDTkFBoxPreview)"
    }
    if { [info exists GidPriv(LayersAlphabetic)] } {
        puts $fileid "LayersAlphabetic $GidPriv(LayersAlphabetic)"
    }
    if { [info exists GidPriv(SoftwareOpenGL)] } {
        puts $fileid "SoftwareOpenGL $GidPriv(SoftwareOpenGL)"
    }

    if { [ info exists ::GidPriv(TooltipPopup)]} {
        puts $fileid "TooltipPopup $::GidPriv(TooltipPopup)"
    }
    if { [ info exists ::GidPriv(BarButtonLook)]} {
        puts $fileid "BarButtonLook $::GidPriv(BarButtonLook)"
    }

    if {[info exists ::GidPriv(RealFormat,Default)]} {
        puts $fileid "RealFormatDefault $::GidPriv(RealFormat,Default)"
    }
    
    foreach i "NormalFont FixedFont BigFont SmallFont" {
        set family [font configure $i -family]
        set size [font configure $i -size]
        set weight [font configure $i -weight]
        set slant [font configure $i -slant]
        puts $fileid [list $i $family $size $weight $slant]
    }

    if { $::_DebugDefaultValues} {
        DebugText "in WriteTCLDefaultsInFile: array get GidPriv *Geom"
    }

    catch {
        # write toolbars in order
        set visited [list]
        foreach f {top left right bottom} {
            foreach tb $::GiDTBLayout(.gid.$f) {
                lappend visited [set name $::GiDTBLayout(tb,$tb)]
                puts $fileid "$name $GidPriv($name)"
                # why not unset GidPriv($name)?
            }
        }
        foreach {name val} [array get GidPriv *Geom] {
            if {[lsearch $visited $name] != -1} continue
            if { $::_DebugDefaultValues} {
                DebugText "  processing: $name $val"
            }
            regsub {Geom$} $name {} geomwinname
            if { $::_DebugDefaultValues} {
                DebugText "  geomwinname = $geomwinname ([info exists GidPriv($geomwinname)]) ([info exists GiDPrivToolBar($name)])"
            }
            if { [info exists GidPriv($geomwinname)] } {
                set w $GidPriv($geomwinname)
                if { [winfo exists $w] && [winfo class $w] == "Toplevel" } {
                    set InitComm $GidPriv($geomwinname,InitComm)
                    WriteYourGeomToVar $w OPEN $name $InitComm
                    set val $GidPriv($name)
                }
            } elseif { [info exists GiDPrivToolBar($name)] } {
                set w $GiDPrivToolBar($name)
                if { $::_DebugDefaultValues} {
                    DebugText "    $GiDPrivToolBar($name) is a toolbar"
                }
                set type [lindex $GidPriv($name) 0]
                if { [regexp {(INSIDE[a-zA-Z]+)[0-9]*} $type {} type] } {
                    set vv $GidPriv($name)
                    #                   set par [lindex [pack info $w] 1]
                    #                   set type $type[lsearch [pack slaves $par] $w]
                    array set  grid_info [grid info $w]
                    if {$grid_info(-sticky) eq "ns" ||
                        $grid_info(-sticky) eq "sn" } {
                        set type $type$grid_info(-column)
                    } else {
                        set type $type$grid_info(-row)
                    }
                    set GidPriv($name) "$type [lrange $vv 1 end]"
                    set val $GidPriv($name)
                }
            }
            puts $fileid "$name $val"
        }
    } msg

    if { $::_DebugDefaultValues} {
        DebugText "msg = $msg"
        DebugText "in WriteTCLDefaultsInFile: end of array get GidPriv *Geom"
    }

    if { [info exists ::RunProcInfo] } {
        if { $::RunProcInfo != "" } {
            puts $fileid "RunProcInfo $::RunProcInfo"
        }
    }
    foreach i "remoteserver remotegroup remoteuser remoteauto remotetime remoteport \
        remotetimeout remoteresultsdownload remoteresultsdelete" {
        if { [info exists ::GidProcWin($i)] } {
            puts $fileid "$i $::GidProcWin($i)"
        }
    }
    
    if {[info exists GidPriv(LayerLayout)]} {
        puts $fileid "LayerLayout $::GidPriv(LayerLayout)"
    }

    if {[info exists GidPriv(PostDisplayLocation)]} {
        puts $fileid "PostDisplayLocation $::GidPriv(PostDisplayLocation)"
    }

    if {[info exists ::GidPriv(ToglWinMode)]} {
        puts $fileid "ToglWinMode $GidPriv(ToglWinMode)"
    }

    puts $fileid "Language [ GidUtils::GetCurrentLanguage]"

    if { [gid_themes::GetCurrentTheme] != ""} {
        if { [gid_themes::GetNextRestartTheme] != ""} {
                puts $fileid "Theme(Current) [gid_themes::GetNextRestartTheme]"
        } else {
            puts $fileid "Theme(Current) [gid_themes::GetCurrentTheme]"
        }
    }
    
    foreach varname {ProgressBarInMainWindow} {
        if { [GiD_Set $varname] != [GiD_Set -default $varname] } {
            puts $fileid "$varname [GiD_Set $varname]"
        }
    }
    
    if { [ info exists ::GidPriv(ProgressInMeshing,More)]} {
        puts $fileid "ProgressInMeshingMore $::GidPriv(ProgressInMeshing,More)"
    }   
    
    if { [info exists ::MeshCartesianDataPriv(samesizes)]} {
        puts $fileid "MeshCartesianSameSizes $::MeshCartesianDataPriv(samesizes)"
    }

    if {[info exists ::GidPriv(ShowCheckNewVersion)]} {
        puts $fileid "ShowCheckNewVersion $::GidPriv(ShowCheckNewVersion)"
    }
 
    foreach theme [gid_themes::GetThemes] {
        if {[info exists ::GidPriv(ThemeSize,$theme)]} {
            puts $fileid "Theme(Size,$theme) $::GidPriv(ThemeSize,$theme)"
        }
    }
    #to preserve unknown variables (probably used by a new version), because the file is shared by all versions
    #don't forget to check Main.cc and Post/utils_post.cc which uses GidUnknownDefaults GidKnownDefaults
    foreach varname [lsort [array names GidUnknownDefaults]] {
        puts $fileid "$varname $GidUnknownDefaults($varname)"
    }
    close $fileid

    CheckFileOwner $file

    #look for it in tk.tcl
    if { [info exists GidPriv(EventFile)] } {
        close $GidPriv(EventFile)
    }
}

proc MakeAlwaysOnTop { w } {
    set ::GidPriv(Transient,$w) 1
    ToggleTransientWin $w
}

proc ToggleTransientWin { w } {
    global GidPriv

    set top [winfo parent [winfo toplevel $w]]
    if { [info exists GidPriv(Transient,$w)] && $GidPriv(Transient,$w) == 1 && $top != "." } {
        #wm transient $w .gid
        wm transient $w $top
    } else {
        wm transient $w ""
    }
    if { ( $::tcl_platform(platform) == "windows") || ( $::tcl_platform(os) == "Darwin") } {
        AddAlwaysOnTopFlag $w
    }
}

#to centralize this useful, return PRE or POST
proc GetCurrentPrePostMode { } {
    set ViewMode [ GiD_Info Project ViewMode]
    if { $ViewMode == "GEOMETRYUSE" || $ViewMode == "MESHUSE" }  {
        return PRE
    } else { 
        #ViewMode == "POSTUSE" || #ViewMode == "GRAPHUSE"
        return POST
    }
}

proc AddAlwaysOnTopFlag { w } {
    global GidPriv
    if { [winfo exists $w._topmenu] } {
        destroy $w._topmenu
    }
    menu $w._topmenu -tearoff 0
    $w configure -menu $w._topmenu
    menu $w._topmenu.system -tearoff 0
    $w._topmenu add cascade -menu $w._topmenu.system
    $w._topmenu.system add checkbutton -label [_ "Always on top"] -variable \
        GidPriv(Transient,$w) -command "ToggleTransientWin $w"
}

proc ConfigureWinIdle { w prev_bind } {
    if { [winfo exists $w] } {        
        bind $w <Configure> $prev_bind
    }
}

proc ConfigureWin { W w geomname {InitComm ""}} {
    if { $W == $w } {
        set prev_bind [bind $w <Configure>]
        bind $w <Configure> ""
        WriteYourGeomToVar $w OPEN $geomname $InitComm
        after idle [list ConfigureWinIdle $w $prev_bind]
    }
}

proc DestroyWin { W w geomname {InitComm ""}} {
    if { $W == $w } {        
        WriteYourGeomToVar $w NONE $geomname $InitComm
    }
}

proc WriteYourGeomToVar { w what geomname {InitComm ""}} {
    global GidPriv tcl_platform
    if { [winfo class $w] != "Toplevel" } {
        return
    }
    if { [wm transient $w] != "" } {
        set trans 1
    } else {
        set trans 0
    }
    set geom [wm geom $w]
    if { $::tcl_platform(platform) == "windows" } {
        regexp {([^x]*)x([^+-]*)([+-]*[0-9]*)([+-]*[0-9]*)} $geom trash width height x y
        if { $width == "" } { set width 1 }
        if { $height == "" } { set height 1 }
        set menuheight [GiD_Info menuheight]
        if { [catch { incr height [expr $menuheight*-1] }] } {
            set height 0
        }
        if { $height < 1 } { set height 20 }
        set geom ${width}x${height}${x}${y}
    }
    set GidPriv($geomname) "$what $geom $trans $InitComm"
}

#w: toplevel name
#title: window title (marked to translation)
#geomname: must be <prefix><name>WindowGeom, 
#with <prefix> Pre Post or PrePost to allow open the window only in pre, post or both
#and geomname must be unique
#InitComm: the Tcl procedure to be called to reopen the window
proc InitWindow { w title geomname {InitComm ""} { class ""} { OnlyPos 0 } {ontop 1} {nodestroy 0} } {
    global GidPriv tcl_platform

    if { [ GidUtils::AreWindowsDisabled] } {
        return close
    }    

    if { ![info exists GidPriv(TopLevelsList)] } {
        set GidPriv(TopLevelsList) ""
    }
    if { [lsearch $GidPriv(TopLevelsList) $w] == -1 } {
        lappend GidPriv(TopLevelsList) $w
    }

    if { [winfo exists $w] } {
        destroy $w
    }
    if { $class == "" } {
        toplevel $w
    } else {
        toplevel $w -class $class
    }

    if { $::tcl_platform(platform) == "windows" || $::tcl_platform(platform) == "unix" } {
        if { [info exists GidPriv($geomname)] } {
            set GidPriv(Transient,$w) [lindex $GidPriv($geomname) 2]
        } else {
            set GidPriv(Transient,$w) $ontop
        }
        ToggleTransientWin $w
    }

    wm title $w $title
    if { $::tcl_platform(platform) == "windows" } {
        wm attributes $w -toolwindow 1
    }

    if { [info exists GidPriv($geomname)] } {
        # verificamos que la ventana tenga un tamanno aceptable
        # si no lo tiene, mantenemos solo la posicion
        if { [ regexp {([0-9]+)x([0-9]+)(\+.*)} $GidPriv($geomname) dummy ancho alto posicion]} {
            if { ( $ancho < 20) || ($alto < 20)} {
                unset GidPriv($geomname)
            }
        }
    }
    if { [info exists GidPriv($geomname)] } {
        if { $OnlyPos == 0 } {
            set posgeom [lindex $GidPriv($geomname) 1]
        } else {
            regexp {[+-].*} [lindex $GidPriv($geomname) 1] posgeom
        }
	# WarnWinText "geomname = $geomname"
	# WarnWinText "posgeom = $posgeom"
        WmGidGeom $w $posgeom
	# WarnWinText "posgeom = $posgeom"

	# foreach cmd [ list screenwidth screenheight vrootwidth vrootheight ] {
	#     WarnWinText "$cmd = [ winfo $cmd .]"
	# }

	# if { [ winfo exists .gid]} {
	#     toplevel .pepe
	#     label .pepe.l -text hola
	#     button .pepe.b -text "close" -command "destroy .pepe"
	#     pack .pepe.l
	#     pack .pepe.b
	#     update
	#     foreach cmd [ list rootx vrootx x rooty vrooty y] {
	# 	WarnWinText "$cmd . = [ winfo $cmd .]"
	# 	WarnWinText "$cmd .gid = [ winfo $cmd .gid]"
	# 	WarnWinText "$cmd .pepe = [ winfo $cmd .pepe]"
	#     }
	#     WarnWinText "wm maxsize . = [ wm maxsize .]"
	#     WarnWinText "wm maxsize .gid = [ wm maxsize .gid]"
	#     WarnWinText "wm maxsize .pepe = [ wm maxsize .pepe]"
	#     destroy .pepe
	# }


    } else {
        WmGidGeom $w ""
    }
    if { !$nodestroy } {
        bind $w <Destroy> [ list DestroyWin %W $w $geomname $InitComm]
    }
    bind $w <Configure> [ list ConfigureWin %W $w $geomname $InitComm]

    regsub {Geom$} $geomname {} geomwinname
    set GidPriv($geomwinname) $w
    set GidPriv($geomwinname,InitComm) $InitComm
    if { ![info exists GidPriv(InitWindowList)] } {
        set GidPriv(InitWindowList) ""
    }
    if { [lsearch $GidPriv(InitWindowList) $geomwinname] == "-1" } {
        lappend GidPriv(InitWindowList) $geomwinname
    }   
      
    #wm minsize $w 28 0
    #kike: commented. Avoid set a generic minimum size, or at least not set minimum 
    #greater than 28 (for toolbars that have this width using normal icons 24x24)
    return $w
}

proc InitWindow_ModifyInitComm { w geomname InitComm } {
    global GidPriv

    bind $w <Destroy> [ list DestroyWin %W $w $geomname $InitComm]
    bind $w <Configure> [ list ConfigureWin %W $w $geomname $InitComm]

    regsub {Geom$} $geomname {} geomwinname
    set GidPriv($geomwinname) $w
    set GidPriv($geomwinname,InitComm) $InitComm
}

proc QuadraticMenu { w } {
    set quadratic [GiD_Set Model(QuadraticType)]
    
#     set newstate $quadratic
#     set thisproc $w
#     if { [info exists ::MenuPrevState($thisproc)] } {
#         if { $::MenuPrevState($thisproc) == $newstate && [$w index end] != "none" } {
#             return
#         }
#     }
#     set ::MenuPrevState($thisproc) $newstate

    switch $quadratic {
        0 { set curr Normal }
        1 { set curr Quadratic }
        2 { set curr Quadratic9 }
        default { set curr Normal }
    }

    set names {Normal Quadratic Quadratic9}
    set namesLabel [list [_ "Normal"] [_ "Quadratic"] [_ "Quadratic9"]]
    set values {0 1 2}
    set integer {1 2 4}
    $w delete 0 end
    set UnderLineList {}
    foreach i $names j $namesLabel k $values m $integer {
        set under [FindUnderChar j UnderLineList]
        
        if { [expr {$::GidPriv(HideQuadraticTypeLevel) & $m}] } {
            continue
        } 
        
        if { $i == $curr } {
            $w add check -label $j -underline $under -variable $w
            set ::$w 1
        } else {
            $w add command -label $j -underline $under -command \
                "GiD_Process MEscape Utilities Variables Model(QuadraticType) $k escape escape"
        }  
    }
}     


proc ViewModeMenu { w what } {
    if { $what == "PRE" } {
        set newstate $what[lindex [ GiD_Info mesh] 0]
    } else {
        set newstate $what[llength [GiD_Graph list]]
        
    }
    set thisproc $w
    if { [info exists ::MenuPrevState($thisproc)] } {
        if { $::MenuPrevState($thisproc) == $newstate && $w != "" && [$w index end] != "none" } {
            return
        }
    }
    set ::MenuPrevState($thisproc) $newstate

    if { $w ne "" } {       
        $w delete 0 end
    }
    set UnderLineList {}
    if { $what == "PRE" } {
        set names {GEOMETRYUSE MESHUSE ""}
        set namesLabel [ list [_ "Geometry"] [_ "Mesh"] [_ "Toggle"]]
        set namesAcc [list "" "" [list ${::acceleratorText}-m ${::acceleratorKey}-m]]
        set namesimages [list "" "" [ gid_themes::GetImage "view_geom_mesh.png" menu] ]
        set colors [ list black black black]
        set commands { GeometryView MeshView ToggleGeomMesh}

        if { [lindex [ GiD_Info mesh] 0] == 0 } {
            lset colors 1 $::GidPriv(Color,DisabledForegroundMenu)
            lset colors 2 $::GidPriv(Color,DisabledForegroundMenu)          
        }
        
        if { $w eq "" } {
            foreach k $commands acc $namesAcc {
                if { $acc ne "" } {
                    bind .gid <[lindex $acc 1]> $k
                }
            }
        } else {
            foreach i $names j $namesLabel k $commands acc $namesAcc col $colors image $namesimages {
                if { $j eq "---" } {
                    $w add separator
                    continue
                }
                set under [FindUnderChar j UnderLineList]
                if { $i eq "" } {
                    $w add command -label $j -underline $under -command $k -accelerator [lindex $acc 0] \
                        -foreground $col -image $image -compound left
                    if { $acc ne "" } {
                        bind .gid <[lindex $acc 1]> $k
                    }
                } else {
                    $w add checkbutton -label $j -underline $under -variable ::CurrentViewMode \
                        -onvalue $i -command $k -accelerator [lindex $acc 0] \
                        -foreground $col -image $image -compound left
                    if { $acc ne "" } {
                        bind .gid <[lindex $acc 1]> $k
                    }
                }
            }
        }
    } else {
        set names {POSTUSE GRAPHUSE ""}
        set namesLabel [ list [_ "Mesh"] [_ "Graphs"] [_ "Toggle"] ]
        set namesimages [list "" "" [ gid_themes::GetImage "postgraf.png" menu]]
        set commands { {GiD_Process MEscape Results Graphs OptionsGraph ShowGraphs No} \
                           {GiD_Process MEscape Results Graphs OptionsGraph ShowGraphs Yes} \
                           TogglePostGraph }
        set colors [ list black black black]
        if { [llength [GiD_Graph list]] == 0} {
            lset colors 1 $::GidPriv(Color,DisabledForegroundMenu)
            lset colors 2 $::GidPriv(Color,DisabledForegroundMenu)          
        }
        if { $w eq "" } {
            # nothing by now
        } else {
            foreach i $names j $namesLabel k $commands image $namesimages col $colors {
                if { $j eq "---" } {
                    $w add separator
                    continue
                }
                set under [FindUnderChar j UnderLineList]
                if { $i eq "" } {
                    $w add command -label $j -underline $under -command $k \
                        -foreground $col -image $image -compound left
                } else {
                    $w add checkbutton -label $j -underline $under -variable ::CurrentViewMode \
                        -onvalue $i -command $k  \
                        -foreground $col -image $image -compound left
                }       
            }
        }
    }
}

proc GetGeometryLabels { {alltypes 0} } {
    if { $::GidPriv(HideVolumeLevel) == 0 } {
        set res [list [_ "Points"] [_ "Lines"] [_ "Surfaces"] [_ "Volumes"]]
    } else {
        set res [list [_ "Points"] [_ "Lines"] [_ "Surfaces"]]
    }
    if { $alltypes } {
        lappend res --- [_ "All types"]        
    }
    return $res
}

proc GetGeometryCommands { {alltypes 0} } { 
    if { $::GidPriv(HideVolumeLevel) == 0 } {
        set res {Points Lines Surfaces Volumes}
    } else {
        set res {Points Lines Surfaces}
    }
    if { $alltypes } {
        lappend res --- All        
    }
    return $res
}

proc GetGeometryImageFiles { {alltypes 0} } {
    if { $::GidPriv(HideVolumeLevel) == 0 } {
        set res {point.png line.png surface.png volume.png}
    } else {
        set res {point.png line.png surface.png}
    }
    if { $alltypes } {
        lappend res sep_hori.png alltypes.png        
    }
    return $res
}

#to set menu colors disabled/enabled at runtime
proc GetGeometryStateColors { npoints nlines nsurfs nvols {alltypes 0} } {
    if { $::GidPriv(HideVolumeLevel) == 0 } {
        set res [list [GetColorTrueFalse $npoints] [GetColorTrueFalse $nlines] [GetColorTrueFalse $nsurfs] [GetColorTrueFalse $nvols]]
    } else {
        set res [list [GetColorTrueFalse $npoints] [GetColorTrueFalse $nlines] [GetColorTrueFalse $nsurfs]]
    }
    if { $alltypes } {
        lappend res [GetColorTrueFalse $npoints] [GetColorTrueFalse $npoints]        
    }
    return $res
}

proc GetMeshLabels { {alltypes 0} } {
    set res  [list [_ "Nodes"] [_ "Elements"]]
    if { $alltypes } {
        lappend res --- [_ "All types"]        
    }
    return $res
}

proc GetMeshCommands { {alltypes 0} } { 
    set res {Nodes Elements}
    if { $alltypes } {
        lappend res --- All        
    }
    return $res
}

proc GetMeshImageFiles { {alltypes 0} } {
    set res {node.png element.png}
    if { $alltypes } {
        lappend res sep_hori.png alltypes_mesh.png
    }
    return $res
}

proc GetMeshStateColors { nnodes nelements {alltypes 0} } {
    set res [list [GetColorTrueFalse $nnodes] [GetColorTrueFalse $nelements]]        
    if { $alltypes } {
        lappend res [GetColorTrueFalse $nnodes]         [GetColorTrueFalse $nnodes]
    }
    return $res
}

proc DrawSize { w } {
    set backgroundfilename [ GiD_Info Project BackgroundFilename]

    set newstate $backgroundfilename
    set thisproc $w
    if { [info exists ::MenuPrevState($thisproc)] } {
        if { $::MenuPrevState($thisproc) == $newstate && [$w index end] != "none" } {
            return
        }
    }
    set ::MenuPrevState($thisproc) $newstate

    $w delete 0 end
    set UnderLineList {}

    if { $backgroundfilename != "" } {
        set j [_ "Background mesh"]
        set under [FindUnderChar j UnderLineList]
        $w add command -label $j -underline $under \
            -command [list GiD_Process Mescape Meshing DrawSizes Background AsElems]
    } else {
        set geomlistNames [GetGeometryLabels 1]      
        set geomlist [GetGeometryCommands 1]       
        
        foreach i $geomlist j $geomlistNames {
            if { $j=="---" } {
                $w add separator
            } else {
                set under [FindUnderChar j UnderLineList]
                $w add command -label $j -underline $under -command \
                    "GeometryView ; GiD_Process Mescape Meshing DrawSizes $i"
            }
        }
        
    }
}

proc DrawMeshNoMesh { w } {
    set newstate CONSTANT
    set thisproc $w
    if { [info exists ::MenuPrevState($thisproc)] } {
        if { $::MenuPrevState($thisproc) == $newstate && [$w index end] != "none" } {
            return
        }
    }
    set ::MenuPrevState($thisproc) $newstate

    $w delete 0 end
    set UnderLineList {}
    set geomlistNames [ GetGeometryLabels]
    lappend geomlistNames {*}[list "" [_ "All types"]]
    set geomlist [ GetGeometryCommands]
    lappend geomlist {*}"Separator All"

    foreach i $geomlist j $geomlistNames {
        if { $i == "Separator" } {
            $w add separator
        } else {
            set under [FindUnderChar j UnderLineList]
            $w add command -label $j -underline $under -command \
                "GeometryView ; GiD_Process Mescape Meshing DrawMeshNoMesh $i"
        }
    }
}

proc DrawForcePointsToMesh { w } {
    set newstate CONSTANT
    set thisproc $w
    if { [info exists ::MenuPrevState($thisproc)] } {
        if { $::MenuPrevState($thisproc) == $newstate && [$w index end] != "none" } {
            return
        }
    }
    set ::MenuPrevState($thisproc) $newstate

    set geomlistNames [list [_ "Surface mesh"]]
    set geomlist "Surface"
    if { $::GidPriv(HideVolumeLevel)==0 } {
        lappend geomlistNames [_ "Volume mesh"]
        lappend geomlist "Volume"
    }    
    $w delete 0 end
    set UnderLineList {}
    foreach i $geomlist j $geomlistNames {
        set under [FindUnderChar j UnderLineList]
        $w add command -label $j -underline $under -command \
            "GeometryView ; GiD_Process Mescape Meshing DrawForcedPointsToMesh $i"
    }
}

# proc DrawBoundaryLayerMesh { w } {
#     set newstate CONSTANT
#     set thisproc $w
#     if { [info exists ::MenuPrevState($thisproc)] } {
#         if { $::MenuPrevState($thisproc) == $newstate && [$w index end] != "none" } {
#             return
#         }
#     }
#     set ::MenuPrevState($thisproc) $newstate
#
#     $w delete 0 end
#     set UnderLineList {}
#     set geomlistNames [ list [_ "2D"] [_ "3D"]]
#     set geomlist "2d 3d"
#
#     foreach i $geomlist j $geomlistNames {
#         set under [FindUnderChar j UnderLineList]
#         $w add command -label $j -underline $under -command \
    #             "GeometryView ; GiD_Process Mescape Meshing DrawBoundaryLayerMesh $i"
#     }
# }


proc DrawElementType { w } {
    set whatuse [ GiD_Info Project ViewMode]
    set newstate $whatuse
    set thisproc $w
    if { [info exists ::MenuPrevState($thisproc)] } {
        if { $::MenuPrevState($thisproc) == $newstate && [$w index end] != "none" } {
            return
        }
    }
    set ::MenuPrevState($thisproc) $newstate

    set geomlistNames [lrange [ GetGeometryLabels] 1 end]
    lappend geomlistNames {*}[list "" [_ "All types"]]
    set geomlist [lrange [ GetGeometryCommands] 1 end]
    lappend geomlist {*}{--- All}
    $w delete 0 end
    set UnderLineList {}
    foreach i $geomlist j $geomlistNames {
        if { $i == {---} } {
            $w add separator
        } else {
            set under [FindUnderChar j UnderLineList]
            $w add command -label $j -underline $under -command \
                "GeometryView ; GiD_Process Mescape Meshing DrawElementType $i"
        }
    }
}

proc DrawStructuredType { w } {
    set whatuse [ GiD_Info Project ViewMode]
    set newstate $whatuse
    set thisproc $w
    if { [info exists ::MenuPrevState($thisproc)] } {
        if { $::MenuPrevState($thisproc) == $newstate && [$w index end] != "none" } {
            return
        }
    }
    set ::MenuPrevState($thisproc) $newstate

    set geomlistNames [lrange [ GetGeometryLabels] 1 end]
    lappend geomlistNames {*}[list "" [_ "All types"]]
    set geomlist [lrange [ GetGeometryCommands] 1 end]
    lappend geomlist {*}{--- All}
    $w delete 0 end
    set UnderLineList {}
    foreach i $geomlist j $geomlistNames {
        if { $i == {---} } {
            $w add separator
        } else {
            set under [FindUnderChar j UnderLineList]
            $w add command -label $j -underline $under -command \
                "GeometryView ; GiD_Process Mescape Meshing DrawStructuredType $i"
        }
    }
}

proc ChooseElemType { etype { ltype ""} } {
    set MoreWin [ GiD_Set UseMoreWindows]

    set list1 "Default Linear Triangle Quadrilateral Tetrahedra Hexahedra Prism OnlyPoints Sphere Circle"
    set list2 " -      -      surfaces surfaces      volumes    volumes   volumes volumes  -      -"

    set inum [lsearch -exact $list1 $etype]
    if { $inum == 0 ||  $inum == 1 } { #Default or Linear
        GiD_Process Mescape Meshing ElemType $etype $ltype
        set word $ltype
    } elseif { $inum == 8 } { #Sphere
        GiD_Process Mescape Meshing ElemType $etype $ltype
        set word $ltype
    } elseif { $inum == 9 } { #Circle
        GiD_Process Mescape Meshing ElemType $etype $ltype
        set word $ltype
    } elseif { $inum != -1 } {
        GiD_Process Mescape Meshing ElemType $etype
        set word [lindex $list2 $inum]
    } else {
        WarnWinText [_ "Unknown element type %s" $etype]
        return
    }

    if { $MoreWin > 1 } {
        tk_dialogRAM .gid.tempwiniw [_ "information window"] \
            [_ "Select %1\$s to assign elem type: %2\$s" $word $etype]  \
            gidquestionhead 0 [_ "OK"]
    }
}

# proc ChangeEntryPlace { {geom NONE}  {ini ""} } {
#     set hhscr [winfo screenheight .]
#     set makeMB 0
#     if { ($ini == "yes" && $geom != "NONE") || ([winfo exists .comm] && \
    #             [winfo class .comm] != "Toplevel") } {
#         catch { destroy .comm }
#         set hh [expr [winfo x .]]
#         set vv [expr [winfo y .]+[winfo height .]+25]
#         toplevel .comm
#         if { $geom != "NONE" } { wm geometry .comm $geom } else {
#             wm geometry .comm [winfo width .]x100+$hh+$vv
#         }
#         wm minsize .comm  1 1
#         set makeMB 1
#         bind .comm <Destroy> { set BottomEntryGeom [wm geom .comm] }

#     } else {
#         if { [winfo exists .comm] } {
#             destroy .comm
#             set makeMB 1
#         }
#         ttk::frame .comm
#         pack forget .gid.central
#         pack .comm -fill x -side bottom
#         catch { pack .gid.central -fill both -expand yes }
#     }
#     entry .comm.e -relief sunken
#     ttk::frame .comm.fwarn
#     scrollbar .comm.fwarn.yscroll -relief sunken  -takefocus 0 \
    #             -command ".comm.fwarn.list yview"
#     listbox .comm.fwarn.list -yscroll ".comm.fwarn.yscroll \
    #             set"  -relief groove  -borderwidth 4 -takefocus 0
#     if {[winfo class .comm] != "Toplevel" } {
#         .comm.fwarn.list configure -width 20 -height 2
#     }

#     .comm.fwarn.list configure -selectmode single
#     pack .comm.fwarn.yscroll -side right -fill y
#     pack .comm.fwarn.list -expand yes -fill both

#     pack .comm.e -fill x -side bottom -pady 5 -padx 5
#     pack .comm.fwarn -fill both -side top -pady 5 -expand yes


#     if { $makeMB == 1 } { MakeBindings }

# }


proc EnterCommand { w command { entry -1 } } {
    #if entry!=-1 => uses entryconfigure

    #if { $command == "" } { return }

    set cls [ winfo class $w]

    set isMenu 0

    switch -- $entry {
        -1 {
            set lstWidgetsSinCommand [ list Label TLabel Frame]
            if { [ lsearch $lstWidgetsSinCommand $cls] == -1} {
                set comm "$w configure -command "
            } else {
                set comm "bind $w <1> "
            }
        }
        -2 {
            set comm "$w configure -postcommand "
            set isMenu 1
        }
        default {
            set comm "$w entryconfigure $entry -command "
        }
    }
    if { $command == "" } {
        lappend comm ""
        eval $comm
        return
    }

    set doMacTrick 0
    switch -- [lindex $command 0] {
        "-npw-" {
            set vareval "$comm{[lrange $command 1 end] $w}"
        }
        "-np-" {
            set vareval "$comm{[lrange $command 1 end]}"
        }
        "-npm-" {
            set vareval "$comm{[lrange $command 1 end]}"
            if { $isMenu && [ esMac]} {
                set doMacTrick 0
            }
        }
        "-ne-" {
            set vareval "$comm{GiD_Process [lrange $command 1 end]}"
        }
        default {
            set vareval "$comm{GiD_Process Mescape $command}"
        }
    }
    # set vareval2 ""
    # while 1 {
    #         if { [string first %W $vareval] == -1 } {
    #             append vareval2 $vareval
    #             break
    #         }
    #         append vareval2 [string range $vareval 0 [expr [string first %W $vareval]-1]]
    #         append vareval2 $w
    #         set vareval [string range $vareval [expr [string first %W $vareval]+2] end]
    # }

    regsub -all {%W} $vareval $w vareval2
    regsub -all {%X} $vareval2 {[ winfo pointerx .gid]} vareval2
    regsub -all {%Y} $vareval2 {[ winfo pointery .gid]} vareval2

    if { $doMacTrick} {
        # to register de variables for the mac Menubar trick
        eval {*}[ lrange $vareval2 3 end]
    }
    eval $vareval2
}

proc AddAccelerator { key menu index } {

    regsub -all ${::acceleratorKey} $key ${::acceleratorText} keyname
    $menu entryconfigure $index -accelerator $keyname

    if { [llength $key] == 1 } {
        bind .gid <$key> "$menu invoke $index ; break"
    } elseif { [llength $key] == 2 } {
        bind .gid <[lindex $key 0]><[lindex $key 1]> "$menu invoke $index ; break"
    }
}

proc AddLittleIcon { icon menu index } {
    set es_imagen_tk 0

    if { ( [ llength $icon] > 1) && ( "[ lindex $icon 0]" == "-np-")} {
        set icon [ eval [ lrange $icon 1 end]]
        # pueden devolvernos la imagen en si, en vez del archivo
        set res [ catch {
            set pp [ image type $icon]
        }]
        if { !$res} {
            set es_imagen_tk 1
        }
    }

    if { !$es_imagen_tk} {
        if { $icon != "" } {
            $menu entryconfigure $index -image [ gid_themes::GetImage $icon menu] -compound left
        } else {
            #add a dummy image to left align all rows
            $menu entryconfigure $index -image [ gid_themes::GetImage blank.png menu] -compound left
        }
    } else {
        $menu entryconfigure $index -image $icon -compound left
    }
}

proc AppleAbout { } {
    startGiDMenuOption About
}

proc CreateBasicMacMenubar { w} {
    set top [winfo toplevel $w]
    if { $top != ".gid" } {
        set t $top
        if { [.gid cget -menu] != "" } {
            .gid configure -menu ""
            destroy .mm1
        }
    } else {
        set t ""
    }
    
    if { ![winfo exists $t.mm1] } {
        menu $t.mm1 -type menubar
        #        $top configure -menu $t.mm1
    } else {
        $t.mm1 delete 0 end
    }
    $top configure -menu $t.mm1

    foreach i [winfo children $t.mm1] {
        destroy $i
    }

    # from  https://www.tcl.tk/man/tcl8.6/TkCmd/tk_mac.htm

    if { [tk windowingsystem] eq "aqua"} {

        proc startGiDMenuOption { menu_name } {
            global MenuEntries MenuCommands
            
            foreach "n v" [array get MenuEntries] {
                set ipos 0
                foreach i $v {
                    if { $i in [list [_ $menu_name] [_ $menu_name#C#menu] [_ $menu_name]... [_ $menu_name#C#menu]...] } {
                        set cmd [lindex $MenuCommands($n) $ipos]
                        if { [lindex $cmd 0] eq "-np-" } {
                            uplevel #0 [lrange $cmd 1 end]
                        } else {
                            GiD_Process Mescape {*}$cmd
                        }
                        return
                    }
                    incr ipos
                }
            }
        }
        
        proc ::tk::mac::ShowPreferences {} [list startGiDMenuOption Preferences]
        
        $t.mm1 add cascade -label GiD -menu $t.mm1.apple
        menu $t.mm1.apple
        $t.mm1.apple add command -label [_ "About"]... -command [ list startGiDMenuOption About]
        # shoule be renamed  tkAboutDialog because of Tk 8.6.1 internals ....
        rename AppleAbout tkAboutDialog
        # proc ::tk::mac::standardAboutPanel {} {
        #     startGiDMenuOption About
        # }
    }
    proc ::tk::mac::Quit {}  [ list QuitFullScreen]
    # $t.mm1 add command -label [_ "Quit"] -command [ list startGiDMenuOption Quit]
}

proc CreateTopMenusUnix { w } {
    global MenuNames MenuNamesP ViewMenuPriv

    if { ![winfo exists $w] } { return }

    #$w configure -style Horizontal.IconButton
    #-relief round_raised

    set wtop [ winfo toplevel $w]

    #set col_act [CCColorActivo [option get $w activeBackground color] 33]
    #set hili_back [ CCColorActivo [ $wtop cget -background] 33 ]
    #set gid_10_hili [ CCColorComponente [ $wtop cget -background] 0 -17 -17]

    #set hili_back $gid_10_hili

    # WarnWinText "$w configure -background $hili_back"
    # $w configure -background $hili_back
    if {[winfo class $w] != "Toplevel"} {
        $w configure -style TFrame.IconButton
        #-style Horizontal.TFrame.IconButton
    }

    if { [ esMac]} {
        # deshabilitar o poner casi nada en el MenuBar de Mac
        CreateBasicMacMenubar $w
    }

    if { [ GetCurrentPrePostMode] == "PRE" } {
        set MenuNamesInto $MenuNames
        set MenuEntriesName MenuEntries
        set MenuCommandsName MenuCommands
        set MenuAccelerName MenuAcceler
        set MenuLittleIcons MenuIcons
    } else {
        set MenuNamesInto $MenuNamesP
        set MenuEntriesName MenuEntriesP
        set MenuCommandsName MenuCommandsP
        set MenuAccelerName MenuAccelerP
        set MenuLittleIcons MenuIconsP
        unset -nocomplain ViewMenuPriv
    }
    upvar #0 $MenuEntriesName ME
    upvar #0 $MenuCommandsName MC
    upvar #0 $MenuLittleIcons MI

    set NumMenus [llength $MenuNamesInto]

    set UnderLineList ""

    for {set i 0} { $i< 15 } { incr i } {
        if { [winfo exists $w.button$i] } {
            destroy $w.button$i
        }
    }

    proc PostTopMenuBarMenu { w m x y} {
        $m post $x [ expr $y + [ winfo height $w]]
    }

    # $w configure -background $hili_back
  
    for {set i 0 } { $i< $NumMenus } { incr i } {
        set text [lindex $MenuNamesInto $i]
        set under [FindUnderChar text UnderLineList]
        if { ![winfo exists $w.button$i] } {
            if { ![ useAlternativeWidgetsForMac]} {
                ttk::menubutton $w.button$i -text $text -menu $w.button$i.m.m \
                    -style TopMenu.IconButton   
                #-style TopMenu.Horizontal.IconButton               
            } else {
                ttk::label $w.button$i -text $text \
                    -style TopMenu.IconButton
                #-style TopMenu.Horizontal.IconButton
                set h [ winfo reqheight $w.button$i]
                # bind $w.button$i <1> "$w.button$i.m.m post %X %Y"
                bind $w.button$i <1> "PostTopMenuBarMenu $w.button$i $w.button$i.m.m %X %Y"
                #$w.button$i configure -background $hili_back
            }
            ChangeRoundRelief $w.button$i horizontal
            if { $under != -1 } {            
                $w.button$i configure -underline $under            
                set letter [string tolower [string index $text $under]]
                #tk::MbPost assume a -relief option that is missing in ttk::menubutton
                #bind all <Alt-$letter> "set ::tk::Priv(postedMb) {} ; ::tk::MbPost $w.button$i %X %Y"        
                bind all <Alt-$letter> [list ttk::menubutton::Pulldown $w.button$i]               
            }
            ttk::frame $w.button$i.m -class OverlayWindowN
            wm colormapwindows .gid $w.button$i.m
            menu $w.button$i.m.m -tearoff no
            # -borderwidth 2
        } else {
            $w.button$i configure -text $text
            if { $under != -1 } { 
            $w.button$i configure -underline $under
            }
            if { [$w.button$i.m.m index end] != "none" } {
                ClearMenu $w.button$i.m.m
            }
            $w.button$i.m.m configure -postcommand ""
        }
        
        if { $ME($i) == "" } {
            if { [lindex $MC($i) 0] != "-np-" } {
                
                WarnWin [_ "Error creating menu '%s'. Needed -np-" $text]
            }
            set comm [lrange $MC($i) 1 end]
            regsub -all {%W} $comm $w.button$i.m.m comm
            regsub -all {%I} $comm $i comm
            regsub -all {%X} $comm [ winfo pointerx .gid] comm
            regsub -all {%Y} $comm [ winfo pointery .gid] comm
            
            $w.button$i.m.m configure -postcommand $comm
        }
        CreateCascadedMenu $w.button$i.m.m $MenuEntriesName $MenuCommandsName \
            $MenuAccelerName $i $MenuLittleIcons
    }

    for {set i 0 } { $i< [expr $NumMenus-1] } { incr i } {
        #pack $w.button$i -side left
        grid $w.button$i -row 0 -column $i -sticky w
        grid columnconfigure $w $i -weight 0
    }
    #pack $w.button$i -side right ;#help button to the right side
    grid $w.button$i -row 0 -column $i -sticky w
    grid columnconfigure $w $i -weight 1

    GidHelpT $w [_ "Menu with the main commands."]

    if { [ GetCurrentPrePostMode] == "PRE" } {
        foreach name { "Files#C#menu" "View#C#menu" "Geometry#C#menu" \
                           "Utilities#C#menu" "Mesh#C#menu" "Calculate#C#menu"} \
            comm { SetFilesMenuState SetViewMenuState SetGeometryMenuState \
                       SetUtilitiesMenuState SetMeshMenuState SetCalculateMenuState } {
                           set i [ GiDMenu::_FindIndex $name PRE]
                           if { $i != -1 } {
                               if { [winfo exists $w.button$i.m.m] } {
                                   $w.button$i.m.m configure -postcommand $comm
                               }
                           }
                       }
    }
}

proc CreateTopMenusWin { w } {
    global MenuNames MenuNamesP ViewMenuPriv

    if { ![winfo exists $w] } { return }

    set top [winfo toplevel $w]
    if { $top != ".gid" } {
        set t $top
        if { [.gid cget -menu] != "" } {
            .gid configure -menu ""
            destroy .mm1
        }
    } else {
        set t ""
    }

    if { [ GetCurrentPrePostMode] == "PRE" } {
        set MenuNamesInto $MenuNames
        set MenuEntriesName MenuEntries
        set MenuCommandsName MenuCommands
        set MenuAccelerName MenuAcceler
        set MenuLittleIcons MenuIcons
    } else {
        set MenuNamesInto $MenuNamesP
        set MenuEntriesName MenuEntriesP
        set MenuCommandsName MenuCommandsP
        set MenuAccelerName MenuAccelerP
        set MenuLittleIcons MenuIconsP

        unset -nocomplain ViewMenuPriv
    }

    upvar #0 $MenuEntriesName ME
    upvar #0 $MenuCommandsName MC
    upvar #0 $MenuLittleIcons MI

    set NumMenus [llength $MenuNamesInto]

    set UnderLineList ""

    if { ![winfo exists $t.mm1] } {
        menu $t.mm1 -type menubar
        #        $top configure -menu $t.mm1
    } else {
        $t.mm1 delete 0 end
    }
    $top configure -menu $t.mm1

    foreach i [winfo children $t.mm1] {
        destroy $i
    }
    
    if { [tk windowingsystem] eq "aqua"} {
        
        proc startGiDMenuOption { menu_name } {
            global MenuEntries MenuCommands
            
            foreach "n v" [array get MenuEntries] {
                set ipos 0
                foreach i $v {
                    if { $i in [list [_ $menu_name] [_ $menu_name#C#menu] [_ $menu_name]... [_ $menu_name#C#menu]...] } {
                        set cmd [lindex $MenuCommands($n) $ipos]
                        if { [lindex $cmd 0] eq "-np-" } {
                            uplevel #0 [lrange $cmd 1 end]
                        } else {
                            GiD_Process Mescape {*}$cmd
                        }
                        return
                    }
                    incr ipos
                }
            }
        }
        
        proc ::tk::mac::ShowPreferences {} [list startGiDMenuOption Preferences]
        #proc ::tkAboutDialog {} [list lognoter About]
        
        $t.mm1 add cascade -label Lognoter -menu $t.mm1.apple
        menu $t.mm1.apple
        $t.mm1.apple add command -label [_ "About"]... -command [list startGiDMenuOption About]
    }

    for {set i 0 } { $i< $NumMenus } { incr i } {

        set text [lindex $MenuNamesInto $i]
        set under [FindUnderChar text UnderLineList]
        set namemenu $t.mm1.button$i
        if { ![winfo exists $namemenu] } {
            menu $namemenu
        } else {
            ClearMenu $namemenu
            $namemenu configure -postcommand ""
            #$namemenu delete 0 end
        }
        $t.mm1 add cascade -label $text -underline $under -menu $namemenu
        
        
        if { $ME($i) == "" } {
            if { [lindex $MC($i) 0] != "-np-" } {
                WarnWin [_ "Error creating menu '%s'. Needed -np-" $text]
            }
            set comm [lrange $MC($i) 1 end]
            regsub -all {%W} $comm $namemenu comm
            regsub -all {%I} $comm $i comm
            regsub -all {%X} $comm [ winfo pointerx .gid] comm
            regsub -all {%Y} $comm [ winfo pointery .gid] comm
            $namemenu configure -postcommand $comm
        }
        
        CreateCascadedMenu $namemenu $MenuEntriesName $MenuCommandsName \
            $MenuAccelerName $i $MenuLittleIcons
    }

    # for debugging
    #InstrumentMenu $t.mm1

    if { [ GetCurrentPrePostMode]  == "PRE" } {
        set idata [ GiDMenu::_FindIndex "Data" PRE]
        if { $idata != -1 } {
            #force create Data menu (else first user click will be slow)
            #create FastCacheFromProblemtypeMenu, read customized problemtype images for the
            #file browser (specified in .xml file), and create the menus
            after idle "PostDataMenu $t.mm1.button$idata ; SetProblemTypeMenu $t.mm1.button$idata.0"
        }
    }

    $t.mm1 configure -postcommand SetMenusStates
}

#use it to know when is invoked a procedure
#WarnWinText [StackTrace]
proc StackTrace { } {
    set text ""
    for {set i [expr [info level]-1]} {$i>=1 } {incr i -1} {
        append text [info level $i]\n
    }
    return $text 
}

proc CreateTopMenus { { w .gid.menu } } {
    global GidPriv

    set err [catch { package present Tk }]
    if { $err } { return }    

    set GidPriv(POSTDATA) 1
    if { $GidPriv(MenuType) == "native" } {
        CreateTopMenusWin $w
    } else {
        #use "generic" menus
        CreateTopMenusUnix $w
    }
}

# for debugging
proc InstrumentCommand { label script } {
    set time [time {uplevel \#0 $script}]
    WarnWinText "$label $script $time"
}
proc InstrumentMenu { menu {label "" } } {

    set comm [$menu cget -postcommand]
    if { $comm != "" } {
        set comm [ list InstrumentCommand $label $comm]
        $menu configure -postcommand $comm
    }
    set ni [$menu index end]
    if { $ni == "none" } { set ni -1 }
    for { set i 0 } { $i <= $ni } { incr i } {
        if { [$menu type $i] == "cascade" } {
            InstrumentMenu [$menu entrycget $i -menu] [$menu entrycget $i -label]
        }
    }
}

proc UpdateMouseMenu {} {
    Set3dButtonVariables
    .gid.phantom.display3dbutton delete 0 end
    Create3rdButtonMenu .gid.phantom.display3dbutton
}

proc ChangeTopMenusAndWindows {} {
    #commented GiDMenu::UpdateMenus because it is invoked in OpenOutsideWindows
    #set DisableGraphics [.central.s disable graphics]
    #.central.s disable graphics 1
    #GiDMenu::UpdateMenus    
    #.central.s disable graphics $DisableGraphics
    if { [GetCurrentPrePostMode] == "PRE" } {
        OpenOutsideWindows PRE                              
        # UpdateDataOptions
    } else {
        OpenOutsideWindows POST              
    }
    UpdateMouseMenu
    update idletasks
    #.central.s disable graphics $DisableGraphics
    GiD_Redraw
}

set DelayedConfigureButsVar 0
set DelayedConfigureSize "0 0"

proc DelayedConfigureButsFunc {} {
    global DelayedConfigureButsVar DelayedConfigureSize GidPriv

    incr DelayedConfigureButsVar -1
    if { $DelayedConfigureButsVar > 0 } {  return }
    if { ![winfo exists .gid.buts] } {
        set GidPriv(PrePostRightButWindowGeom) "NONE {} RightButtons"
    } elseif { [winfo class .gid.buts] == "Toplevel" } {
        set GidPriv(PrePostRightButWindowGeom) "OPEN [wm geom .gid.buts] RightButtons"
    } else {
        set GidPriv(PrePostRightButWindowGeom) "INSIDE {} RightButtons"
    }
    if { [winfo exists .gid.buts] } {
        set w [winfo width .gid.buts]
        set h [winfo height .gid.buts]
        if { $w != [lindex $DelayedConfigureSize 0] || \
                 $h != [lindex $DelayedConfigureSize 1] } {
            SetButtons
            set DelayedConfigureButsVar 0
            set DelayedConfigureSize "$w $h"
        }
    }
}

proc SetButtons { { first 0 } } {
    global ActionsMenuVar mxbutwidth PostButStack

    set w .gid.buts.f
    if { ![winfo exists $w] } {
        return
    }

    if { $first == 0 } { set PostButStack "" }
    if { $PostButStack != "" } {
        set num [lindex $PostButStack [expr [llength $PostButStack]-1]]
        pack $w.al -side left -padx 0
        $w.al configure -command "set PostButStack \"[lrange $PostButStack \
                0 [expr [llength $PostButStack]-2]]\" ; SetButtons $num"
    } else { 
        pack forget $w.al 
    }
    pack forget $w.ar


    set xpos 3 ; set ypos 5
    set butpady 2
    #if { [winfo width $w] == 1 } {
    #sobra?# update idletasks
    #}

    set tothei [expr [winfo height $w]-20]
    set totwid [winfo width $w]
    set overflow 0
    set last [llength $ActionsMenuVar]
    for {set k 0 } { $k<$last } { incr k } {
        if { ![winfo exists $w.b$k] } {
            # en macOsX los botoncitos tienen los extremos redondos: necesitan un poco mas de espacio
            #create initially only GidPriv(MaxRightButtons)=100 buttons, but more could be required
            ttk::button $w.b$k -width 20 -takefocus 0 -style RightButtons.IconButton
            #in ttk width is number os characters: -width $rightButtonWidth 
            if { $::GidPriv(MaxRightButtons) < $k } {
                set ::GidPriv(MaxRightButtons) $k
            }
        }
        
        if {$k < $first || $k>=$last || $overflow } {
            place forget $w.b$k
        } else {
            set name [lindex $ActionsMenuVar $k]
            # traduccion de los botones de la derecha
            # $w.b$k configure -text [_ $name] -command [list GiD_Process $name]
            $w.b$k configure -text $name -command [list GiD_Process $name]
            place $w.b$k -x $xpos -y $ypos
            set reqh [ winfo reqheight $w.b$k]
            set ypos [ expr $ypos + $reqh + $butpady]
            #incr ypos 31
            if { $ypos > $tothei && $k < [expr $last-1] } {
                incr xpos 130
                if { [expr $xpos+80] > $totwid } {
                    pack $w.ar -side right -padx 0
                    $w.ar configure -command \
                        "lappend PostButStack $first ; SetButtons [expr $k+1]"
                    set overflow 1
                }
                set ypos 5
            }
        }
    }
    
    #hide the rest of buttons, assumed that 100 is a maximum of visible buttons of the right buttons
    for {set k $last } { $k< $::GidPriv(MaxRightButtons) } { incr k } {
        if { ![winfo exists $w.b$k] } {
            break
        }
        place forget $w.b$k        
    }

}

proc MenuInCommandButton { e x y } {
    global ActionsMenuVar

    set w .gid.menuincommandwindow
    catch { destroy $w }
    menu $w
    set words ""
    foreach i $ActionsMenuVar {
        regsub -all {([a-z])([A-Z])} $i "\\1 \[string tolower \\2]" name
        set name [subst $name]
        set name [string toupper [string index $name 0]][string range $name 1 end]
        if { $i == "Join" || $i == "NoJoin" } { append name " ${::acceleratorText}-a" }
        lappend words [ list $name "$e insert end \" $i\""]
    }
    rmenuconf $w $words

    $w add separator
    set UnderLineList {}
    set j [_ "Previous"]
    set under [FindUnderChar j UnderLineList]
    $w add command -label $j -underline $under -command [bind $e <Up>]
    set j [_ "Next"]
    $w add command -label $j -underline $under -command [bind $e <Down>]

    GiD_PopupMenu $w $x $y
}


proc AutoCompleteGiDEntry { e } {
    global ActionsMenuVar

    if { [string trim [$e get]] == "" } {
        if { [winfo exists .gid.wSetCoord.xe] } {
            focus .gid.wSetCoord.xe
        }
        return
    }
    if { [catch {
        set beginwords [lrange [$e get] 0 end-1]
        set lastword [lindex [$e get] end]
    }] } { return }

    if { $beginwords != "" } {
        $e delete 0 end
        $e insert end $beginwords
        uplevel #0 [bind $e <Return>]
        $e insert end $lastword
        after idle AutoCompleteGiDEntry $e
        return
    }

    set idx [lsearch -glob [string tolower $ActionsMenuVar] [string tolower ${lastword}*]]
    set word [lindex $ActionsMenuVar $idx]
    set wordoptions $word
    set isfull 1
    if { $idx != -1 } {
        set idx2 $idx
        while 1 {
            set idx2new [lsearch -glob [string tolower [lrange $ActionsMenuVar [expr $idx2+1] end]] \
                             [string tolower ${lastword}*]]
            if { $idx2new == -1 } { break }
            set idx2 [expr $idx2+1+$idx2new]
            set newword [lindex $ActionsMenuVar $idx2]
            lappend wordoptions $newword
            for { set i [string length $lastword] } { $i < [string length $word] } { incr i } {
                set l1 [string tolower [string index $word $i]]
                set l2 [string tolower [string index $newword $i]]
                if {  $l1 != $l2 } { break }
            }
            if { $i < [string length $word] } { set isfull 0 }
            set word [string range $word 0 [expr $i-1]]
        }
        set text [lrange [$e get] 0 end-1]
        $e delete 0 end
        if { $isfull } {
            $e insert end "$word "
        } else {
            $e insert end "$word"
            ChangeWarnLineVar [_ "Options: %s" $wordoptions]
        }
        $e icursor end
        $e xview moveto 1
    }
}

proc ReGridChildrenBitmapsGeom { Nombre bw StartFunc { prefix PrePost } } {
    global GidPriv
#for {set i [expr [info level]-1]} {$i>=0 } {incr i -1} {
# WarnWinText [info level $i]
# }    
    if { 0 } {
        #trick to avoid infinite loop (and crash) resizing to small size
        if { [info exists ::LastTimeReGridChildrenBitmapsGeom($Nombre)] } {
            if { [expr {[clock seconds]-$::LastTimeReGridChildrenBitmapsGeom($Nombre)}] < 1.0 } {
                return
            }
        }
        set ::LastTimeReGridChildrenBitmapsGeom($Nombre) [clock seconds]
    }

    regexp {[0-9]+x[0-9]+(.*)} [winfo geom $bw] trash rest
    #temporary remove binding to avoid reentering
    set previous_binding [bind $bw <Configure>]
    bind $bw <Configure> ""

    set NumBitmaps 0
    while { [winfo exists $bw.$NumBitmaps] } {
        incr NumBitmaps
    }

    set w [winfo width $bw]
    set h [winfo height $bw]

    if { ![ info exists toolbarmacros::preferences(toolbar_one_col)]} {
        #toolbarmacros::ReadMacros
        # ramsan: init is used here to also load the macros accelerators for the case that the toolbar is not active
        toolbarmacros::Init
    }   

    set term Separadores
    
    set orientation ""
    if { [info exists ::ToolbarsPriv(toolbars)] } {
        foreach item $::ToolbarsPriv(toolbars) {
            if { [lindex $item 2] == $StartFunc } {
                set geomname [lindex $item 1]
                if { [info exists GidPriv($geomname)] } {
                    set position [lindex $GidPriv($geomname) 0]                   
                    if { $position == "INSIDELEFT" } {
                        set orientation vertical
                    } elseif { $position == "INSIDERIGHT" } {
                        set orientation vertical
                    } elseif { $position == "INSIDETOP" } {
                        set orientation horizontal
                    } elseif { $position == "INSIDEBOTTOM" } {
                        set orientation horizontal                        
                    } else {                      
                        set orientation ""  
                    }                                           
                }                
                break
            }        
        }
    }    
    if { $orientation == "" } {
        if { $w > $h} {
            set orientation horizontal           
        } else {
            set orientation vertical           
        }
    }
    if { $orientation == "horizontal" } {
        # barra horizontal
        foreach icn $GidPriv($Nombre$term) {
            $bw.$icn configure -image [ gid_themes::GetImage sep_vert.png toolbar]
        }

        set nrow 1
        #enpaquetamos
        set children [winfo children $bw]
        if { $children != "" } {
            grid forget {*}$children
        }

        set ult 1

        for { set ir 0} { $ir < $nrow} { incr ir} {
            set ic 0          
            for { set icn 0} { $icn < $NumBitmaps} { incr icn} { 
                if { $Nombre == "StdBar" } { #special tricks
                    if { $ult == 14 } {
                        grid $bw.$icn  -in $bw.f$ir -row 0 -column $ic -sticky wns
                        #truco combobox layers
                        if { [ GetCurrentPrePostMode] == "PRE" } {
                            if { ![winfo exists $bw.flayer] } {
                                ttk::frame $bw.flayer -style Horizontal.TFrame.IconButton                                               
                                CreateLayerCombo $bw.flayer
                            }
                            incr ic                            
                            grid $bw.flayer -in $bw.f$ir -row 0 -column $ic -padx 10 -sticky news
                        }
                        #                    
                    } elseif { $ult == $NumBitmaps } {
                        grid $bw.$icn -in $bw.f$ir -row 0 -column $ic -sticky ens
                        grid columnconfig $bw.f$ir $ic -weight 1
                        set GidPriv(InfoGiDButtonName) $bw.$icn
                        ShowGiDVersionType
                    } else {
                        grid $bw.$icn -in $bw.f$ir -row 0 -column $ic -sticky wns
                    }
                } else {
                    grid $bw.$icn -in $bw.f$ir -row 0 -column $ic -sticky wns
                }
                incr ic
                if { [ winfo class $bw.$icn] == "TLabel"} {
                    grid configure $bw.$icn -pady 0 -sticky wns
                }
                incr ult
            }
            grid rowconfig $bw.f$ir 0 -weight 1
            if { ( $Nombre != "StdBar") || ( [ expr $ir + 1] != $nrow)} {
                grid $bw.f$ir -sticky nw
            } else {
                grid $bw.f$ir -sticky new
            }
            grid rowconfig $bw $ir -weight 1
            if { ( $Nombre == "StdBar") && ( $ult >= $NumBitmaps)} {
            }
        }
        grid columnconfig $bw 0 -weight 1

        set changed 0
        foreach ch [ winfo children $bw] {
            set changed [ ChangeRoundRelief $ch horizontal]
        }
        if { $changed } {
            if { [winfo class $bw] != "Toplevel" } { 
                ChangeRoundRelief $ch horizontal
                #$bw configure -style Horizontal.IconButton
            }           
        }

    } else {
        # barra vertical
        if { $Nombre == "StdBar"} {
            set NumBitmaps [ expr $NumBitmaps - 1]
        }
        # es mas vertical que horizontal ( enpaquetmos de arriba a abajo)
        set term Separadores
        foreach icn $GidPriv($Nombre$term) {
            $bw.$icn configure -image [ gid_themes::GetImage sep_hori.png toolbar]
        }
        set ncol 1

        #enpaquetamos
        set children [winfo children $bw]
        if { $children != "" } {
            grid forget {*}$children
        }

        for { set ic 0} { $ic < $ncol} { incr ic} {           
            set ir 0            
            for { set icn 0} { $icn < $NumBitmaps} { incr icn} {        
                grid $bw.$icn -in $bw.f$ic -column 0 -row $ir -sticky nwe
                incr ir
                grid rowconfig $bw.f$ic $ir -weight 0        
            }
            grid columnconfig $bw.f$ic 0 -weight 1
            grid $bw.f$ic -sticky nwe -column $ic -row 0
            grid columnconfig $bw $ic -weight 0
        }

        grid rowconfig $bw 0 -weight 1

        set changed 0
        foreach ch [ winfo children $bw] {
            set changed [ ChangeRoundRelief $ch vertical]
        }

        if { $changed && $::GidPriv(VerticalRoundBars) } {
            if { [winfo class $bw] != "Toplevel" } { 
                ChangeRoundRelief $bw vertical
                #$bw configure -style Vertical.IconButton
            }           
        }

    }

    if { [winfo class $bw] == "Toplevel" } {

        if { $Nombre == "StdBar" && [info exists GidPriv(ComboLayers,entry)] &&
             [ winfo exists $GidPriv(ComboLayers,entry) ] } {
            incr w_width [winfo width $GidPriv(ComboLayers,entry)]
        }

        wm geom $bw 
        #${w_width}x${w_height}$rest
        # OJO!!!!!  a nadie se le ocurra quitar este 'update', sin el
        # un segfault es generado en Tk_MapWindow mientras se hace un
        # resize de la ventana.
        update
        if { [winfo exists $bw] } {
            set trans 0
            if { [winfo class $bw] == "Toplevel" } {
                if { [wm transient $bw] != "" } {
                    set trans 1
                } else {
                    set trans 0
                }
            }
            set term WindowGeom
            set GidPriv($prefix$Nombre$term) \
                "OPEN [wm geom $bw] $trans $StartFunc"
        }        
    }
    
    if { [winfo exists $bw] } {
        #restore its binding
        bind $bw <Configure> $previous_binding
    }
}

#
# Destroy a given widget. If the parent container remains empty it is
# also "grid_removed". Later on the parent container could be
# remembered if needed.
#
proc DestroySlave { w } {
    catch {array set grid_info [grid info $w]}
    destroy $w
    if {[info exists grid_info(-in)]} {
        # if w is gridded its parent must be a member of GiDTBLayout
        set parent $grid_info(-in)
        set idx [lsearch $::GiDTBLayout($parent) $w]

        if {![llength [set ::GiDTBLayout($parent) \
                           [lreplace $::GiDTBLayout($parent) $idx $idx]]]} {
            grid remove $parent
        }
    }
}

# GridInside --
#
# grid a widget w inside a master, making sure master is remembered in
# case it was previouly removed. master must be previously gridded with
# initial options.
#
proc GridInside { name w master sticky } {
    grid $master
    set slaves $::GiDTBLayout($master)
    if {$sticky eq "ns" || $sticky eq "sn"} {
        set c 0
        foreach s $slaves {
            if {[winfo exists $s]} {
                grid $s -in $master -row 0 -column $c -sticky $sticky
                incr c
            }
        }
        grid $w -in $master -row 0 -column $c -sticky $sticky
    } else {
        set r 0
        foreach s $slaves {
            if {[winfo exists $s]} {
                grid $s -in $master -row $r -column 0 -sticky $sticky
                incr r
            }
        }
        grid $w -in $master -row $r -column 0 -sticky $sticky
    }
    if { [lsearch ::GiDTBLayout($master) $w] == -1 } {
        lappend ::GiDTBLayout($master) $w
    }
    set ::GiDTBLayout(tb,$w) $name
}

proc esMac { } {
    if { $::tcl_platform(os) == "Darwin"} {
        return 1
    } else {
        return 0
    }
}

proc useAlternativeWidgetsForMac  { } {
    # if { $::tcl_platform(os) == "Darwin"} {
    #     return 1
    # } else {
        return 0
    # }
}

proc ChangeRoundRelief { w direction} { 

    if { [winfo class $w] == "Toplevel" || [winfo class $w] == "Menu" } { return 0 }
    
    set ret 0
    set old_direction [$w cget -style]
    set old_direction [split $old_direction .]
    set horit [lsearch $old_direction Horizontal]
    set vert [lsearch $old_direction Vertical]
    if { $horit != -1 } {
        if { $direction eq "vertical"} {
            $w configure -style [join [lreplace $old_direction $horit $horit Vertical] .]
            set ret 1
        }    
    } elseif { $vert != -1 } {
        if { $direction eq "horizontal"} {
            $w configure -style [join [lreplace $old_direction $vert $vert Horizontal] .]
            set ret 1
        }
    } else {
        #WarnWinText "Some widget without horizontal or vertical defined"
    }   
    return $ret
}

# queda feo pero de momento es lo que hay,
# en mac no se admiten (menu)botones con iconos, gid pone labels y hace un bind
# para que aparezca el menu
# los menus se llaman igual que antes: nombre de icono + .m

proc CreateBitmaps { { what "DEFAULT" } } {
    global GidPriv GiDPrivToolBar
    
    set w .gid.bitmaps
    set title [_ "Geometry & View bar"]
    AddNewToolbar "Geometry & View bar" PrePostBitmapsWindowGeom CreateBitmaps $title
    
    if { ![info exists GidPriv(PrePostBitmapsWindowGeom)] && $what == "NONE" } {
        set GidPriv(PrePostBitmapsWindowGeom) NONE
    }
    set vv $GidPriv(PrePostBitmapsWindowGeom)
    # esta parte intenta corregir algunos gidDefaults corruptos
    if {[lindex $vv end] ne "CreateBitmaps"} {
        set ll [llength $vv]
        set vv [concat $vv  [lrange {INSIDELEFT 1 1 CreateBitmaps} $ll end]]
        set GidPriv(PrePostBitmapsWindowGeom) $vv
    }
    if { $what != "DEFAULT" } {
        set GidPriv(PrePostBitmapsWindowGeom) "$what [lrange $vv 1 end]"
    }
    DestroySlave $w
    if { [lindex $GidPriv(PrePostBitmapsWindowGeom) 0] == "NONE" } {
        return
    }
    
    if { ![string match INSIDE* [lindex $GidPriv(PrePostBitmapsWindowGeom) 0]] } {
        InitWindow $w [_ "Geom & view operations"] PrePostBitmapsWindowGeom CreateBitmaps "" 0 1 1
        if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0
        
        wm transient $w .gid
        catch { wm attributes $w -toolwindow 1 }
        $w config -background $GidPriv(Color,ToolbarBg)
        
        set bitmap_geom "[winfo width $w]x[winfo height $w]"
    } else {
        set vv $GidPriv(PrePostBitmapsWindowGeom)
        set GidPriv(PrePostBitmapsWindowGeom) $vv
        set GiDPrivToolBar(PrePostBitmapsWindowGeom) $w
        
        ttk::frame $w -style Horizontal.TFrame.IconButton
        #.TFrame
        # -borderwidth 0 -background $GidPriv(Color,ToolbarBg)
        bind $w <Destroy> "+ unset GiDPrivToolBar(PrePostBitmapsWindowGeom)"
        
        regexp {([a-zA-Z]*)([0-9]*)} [lindex $GidPriv(PrePostBitmapsWindowGeom) 0] {} where pos
        set widget ""
        switch $where {
            INSIDETOP {
                GridInside PrePostBitmapsWindowGeom $w .gid.top "we"
            }
            INSIDELEFT {
                GridInside PrePostBitmapsWindowGeom $w .gid.left "ns"
            }
            INSIDEBOTTOM {
                GridInside PrePostBitmapsWindowGeom $w .gid.bottom "we"           
            }
            INSIDERIGHT {
                GridInside PrePostBitmapsWindowGeom $w .gid.right "ns"
            }
        }
    }
    
    UpdateToolbarGeometryAndView
    
    bind $w <Configure> [list ReGridChildrenBitmapsGeom Bitmaps $w CreateBitmaps]
    if { [winfo class $w] == "Toplevel" } {
        bind $w <Leave> [ list wm title $w $title]
        foreach i [bind .gid] {
            bind $w $i [bind .gid $i]
        }
    }   
}


#update the "Geometry & View bar" toolbar from the BitMapsNames, etc contents
proc UpdateToolbarGeometryAndView { } {
    global BitMapsNames BitMapsCommands BitmapsHelp
    global BitMapsNamesP BitMapsCommandsP BitmapsHelpP
    global BitMapsShortNames BitMapsShortNamesP
    global GidPriv

    set w .gid.bitmaps
    if { [GidUtils::IsTkDisabled] || ![winfo exists $w] } {
        return
    }
    foreach item [winfo children $w] {
        destroy $item
    }

    set separadores ""
    set num_separadores  0
    set round_bar 0
    set round_bar_v 0
    if { [winfo width $w] >= [winfo height $w]} {
        set separadores V
        set round_bar 1        
    } else {
        set separadores H
        set round_bar_v $::GidPriv(VerticalRoundBars)        
    }

    if { [ GetCurrentPrePostMode] == "PRE" } {
        upvar #0 BitMapsNames names
        upvar #0 BitMapsCommands commands
        upvar #0 BitmapsHelp thehelp
        if { [ info exists BitMapsShortNames]} {
            upvar \#0 BitMapsShortNames shortnames
        } else {
            set shortnames(0) ""
        }
    } else {
        upvar #0 BitMapsNamesP names
        upvar #0 BitMapsCommandsP commands
        upvar #0 BitmapsHelpP thehelp
        if { [ info exists BitMapsShortNamesP]} {
            upvar \#0 BitMapsShortNamesP shortnames
        } else {
            set shortnames(0) ""
        }
    }

    set i 0
    set GidPriv(BitmapMenus) 0
    set GidPriv(BitmapsSeparadores) ""
    set GidPriv(BitmapsMenusList) ""
    set reqmbw 0
    set reqmbh 0
    set reqmbbw 0
    set reqbw 0
    set reqbh 0
    set lst_botones ""
    set images_menu 1
    # if { $::tcl_platform(os) == "Darwin" } {
    #     set images_menu 0
    # }
    foreach j $names(0) {
        # para rehacer los bitmaps con separadores
        ttk::frame $w.f$i -style TFrame.IconButton
        if { $round_bar} {
            $w.f$i configure -style Horizontal.TFrame.IconButton
        } elseif { $round_bar_v} {
            $w.f$i configure -style Vertical.TFrame.IconButton
        }

        if { $j != "---" } {
            if { ![info exists names(0,$i)] } {
                if { ![ useAlternativeWidgetsForMac]} {
                    ttk::button $w.$i -image [ gid_themes::GetImage $j toolbar] \
                        -style Horizontal.IconButton
                    set icon_text [ file root $j]
                    if { $shortnames(0) != ""} {
                        set icon_text [ lindex $shortnames(0) $i]
                    }
                    IconTextConfigureLook $w.$i [ gid_themes::GetImage $j toolbar] $icon_text
                } else {
                    ttk::label $w.$i -image [ gid_themes::GetImage $j toolbar] -style Horizontal.IconButton
                }
                
                if { $::tcl_platform(platform) == "windows" } {
                    bind $w.$i <ButtonRelease-1> "catch \"focus .gid.comm.e\" "
                }
                set comm [lindex $commands(0) $i]
                regsub -all {%I} $comm $i comm
                EnterCommand $w.$i $comm
                set reqbw [ winfo reqwidth $w.$i]
                set reqbh [ winfo reqheight $w.$i]
                lappend lst_botones $w.$i
                
            } else {
                if { ![ useAlternativeWidgetsForMac]} {
                    ttk::menubutton $w.$i \
                        -image [ gid_themes::GetImage $j toolbar] \
                        -style Horizontal.IconButton \
                        -menu $w.$i.m -direction right                                
                    if { $shortnames(0) != ""} {
                        set icon_text [ lindex $shortnames(0) $i]
                    }
                    IconTextConfigureLook $w.$i [ gid_themes::GetImage $j toolbar] $icon_text
                } else {
                    ttk::label $w.$i -image [ gid_themes::GetImage $j toolbar] -style Horizontal.IconButton
                    bind $w.$i <1> "$w.$i.m post %X %Y"
                }
                $w.$i configure -style Horizontal.IconButtonWithMenu
                
                menu $w.$i.m -tearoff no                        
                
                set comm [lindex $commands(0) $i]
                regsub -all {%I} $comm $i comm
                if { $comm != "" } {
                    EnterCommand $w.$i.m $comm -2
                }
                set ii 0
                foreach jj $names(0,$i) {
                    if { $images_menu} {
                        $w.$i.m add command -image [ gid_themes::GetImage $jj toolbar] -hidemargin 1
                    } else  {
                        $w.$i.m add command -label [ file root [ file tail [ [ gid_themes::GetImage $jj toolbar] cget -file]]] -hidemargin 1
                    }
                    set comm [lindex $commands(0,$i) $ii]
                    regsub -all {%I} $comm $ii comm
                    EnterCommand $w.$i.m $comm $i
                    incr ii
                }
                incr GidPriv(BitmapMenus)
                set reqmbw [winfo reqwidth $w.$i]
                set reqmbh [winfo reqheight $w.$i]
                #ttk no borderwidth option set reqmbbw [$w.$i cget -borderwidth]
                set reqmbbw 0
            }
            #nos pone un borde uno en los menubuttons que queda feo
            lappend GidPriv(BitmapsMenusList) $i
            
            set help [lindex $thehelp(0) $i]
            if { ![ useAlternativeWidgetsForMac]} { # en mac cogemos el binding <1> en label para simular un boton
                # if { $round_bar} {
                #     bind $w.$i <ButtonPress-1> "$w.$i configure -relief round_sunken"
                #     bind $w.$i <Enter> "catch { wm title $w \"$help\" } ; \
                                 #     $w.$i configure -relief round_raised"
                #     bind $w.$i <Leave> "$w.$i configure -relief round_raised"
                #     bind $w.$i <ButtonRelease-1> "$w.$i configure -relief round_raised"
                # } elseif { $round_bar_v} {
                #     bind $w.$i <ButtonPress-1> "$w.$i configure -relief round_sunken_v"
                #     bind $w.$i <Enter> "catch { wm title $w \"$help\" } ; \
                                 #     $w.$i configure -relief round_raised_v"
                #     bind $w.$i <Leave> "$w.$i configure -relief round_raised_v"
                #     bind $w.$i <ButtonRelease-1> "$w.$i configure -relief round_raised_v"
                # } else {
                #bind $w.$i <ButtonPress-1> "$w.$i configure -relief flat"
                #bind $w.$i <ButtonPress-1> "$w.$i configure -state active"
                #bind $w.$i <Enter> [ list catch { wm title $w $help } ]
                #bind $w.$i <Enter> "catch { wm title $w \"$help\" }"
                #bind $w.$i <Leave> "$w.$i configure -relief flat"
                #bind $w.$i <Leave> "$w.$i configure -state normal"
                #bind $w.$i <ButtonRelease-1> "$w.$i configure -relief raised"
                #bind $w.$i <ButtonRelease-1> "$w.$i configure -state normal"
                # }
            }


            if { "$help" != ""} {
                #if { $::GidPriv(TooltipPopup) != "bottom"} {
                    GidHelpT $w.$i $help
                #} else {
                #    setTooltip $w.$i -text $help -delay 0 -bottom .gid
                #}
            }

        } else {
            if { $separadores != "" } {
                if { $separadores == "H" } {
                    set archivo sep_hori.png
                } else {
                    set archivo sep_vert.png
                }
                ttk::label $w.$i -image [ gid_themes::GetImage $archivo toolbar] -style Horizontal.IconButton
                    #-style ForcedLabel
                    
                incr num_separadores
                lappend GidPriv(BitmapsSeparadores) $i
            } else {
                ttk::label $w.$i -style Horizontal.IconButton
                #-style ForcedLabel
            }
        }
        if { $round_bar} {
            #$w.$i could be TButton, TMenuButton or TLabel
            ChangeRoundRelief $w.$i horizontal            
        } elseif { $round_bar_v} {
            #$w.$i could be TButton, TMenuButton or TLabel
            ChangeRoundRelief $w.$i vertical
        }
        incr i
    }
 
    ReGridChildrenBitmapsGeom Bitmaps $w CreateBitmaps
}


# -np- WarnWin [ winfo reqheight .gid.bitmaps.4]
# -np- WarnWin [ winfo reqheight .gid.bitmapsStdBar.4]
# -np- WarnWin [ winfo reqheight .gid.bitmapsMacrosToolbar.w4]

#Procedure to create an additional toolbar
#Nombre: internal toolbar name "<name> bar" (must finish with 'bar', and a unique name)
#      this name must be the same used by AddNewToolbar and ReleaseToolbar
#title: a text (marked for translation)
#BitMapsNames: name of a global variable that store a list of filenames with the button images (.png)
#BitMapsCommands: name of a global variable that store a list of button commands
#BitmapsHelp: name of a global variable that store a list of button commands help strings (translated)
#BitmapsPath: the full path to the images
#StartFunc: the proc name the create the bar calling CreateOtherBitmaps and AddToolbar
#type: bar location: "DEFAULT ?INSIDELEFT|INSIDERIGHT|INSIDETOP|INSIDEBOTTOM|OUTSIDE?"
#      e.g. "DEFAULT INSIDELEFT"
#prefix: where to show bar: Pre|Post|PrePost

proc CreateOtherBitmaps { Nombre title BitMapsNames BitMapsCommands BitmapsHelp \
                              BitmapsPath StartFunc { what "DEFAULT" } { prefix PrePost} \
                              { BitMapsShortNames ""}} {
    global GidPriv GiDPrivToolBar GIDDEFAULT

    set term WindowGeom
    set w .gid.bitmaps
    DestroySlave $w$Nombre
    if { [ info exists GidPriv($prefix$Nombre$term)] } {
        set vv $GidPriv($prefix$Nombre$term)
        set _head_ [lrange $vv 0 3]
        set _ll_ [llength $vv]
        if {$_ll_ == 1} {
            lappend _head_ {} 1
        } elseif {$_ll_ == 2} {
            lappend _head_ 1
        }
        if { [lindex $what 0] != "DEFAULT" } {
            set GidPriv($prefix$Nombre$term) "$what [lrange $_head_ 1 2] $StartFunc"
        } else {
            set GidPriv($prefix$Nombre$term) "[lrange $_head_ 0 2] $StartFunc"
        }
        if { [lindex $GidPriv($prefix$Nombre$term) 0] == "NONE" } {
            return ""
        }
    } elseif { [lindex $what 0] == "DEFAULT" && [lindex $what 1] != "" } {
        set GidPriv($prefix$Nombre$term) "[lindex $what 1] {} 1 $StartFunc"
    }
    # y en este else que puede pasar ?

    
    set what [ GetCurrentPrePostMode]

    # busco si hay otra TB previa con este proc asociado, si existe le
    # dejo solo la posicion.
    set _this_ $prefix$Nombre$term
    set _this_cmd_ [lindex $StartFunc 0]
    foreach _tb_ "$::GiDTBLayout(INSIDE,PRE) $::GiDTBLayout(INSIDE,POST)" {
        if {$_tb_ eq $_this_} continue
        set _cmd_ [lindex [lindex $GidPriv($_tb_) 3] 0]
        if {$_cmd_ eq $_this_cmd_} {
            # esta es una TB que se crea con mi mismo proc, por tanto
            # solo le dejo la posicion para que no me moleste.
            set GidPriv($_tb_) [lindex $GidPriv($_tb_) 0]
        }
    }

    if { $prefix != "PrePost" } {
        if { ($what == "POST" && ![string match *Post* $prefix]) || \
                 ($what == "PRE" && [string match *Post* $prefix]) } {
            if { [info exists GidPriv($prefix$Nombre$term)] } {
                set aa [lindex $GidPriv($prefix$Nombre$term) 0]
            }
            #             catch {
            #                 DestroySlave $w$Nombre
            #             }
            if { [info exists GidPriv($prefix$Nombre$term)] } {
                set GidPriv($prefix$Nombre$term) \
                    "$aa [lrange $GidPriv($prefix$Nombre$term) 1 end]"
            }
            return
        }
    }


    set separadores ""
    set num_separadores  0
    set round_bar 0
    set round_bar_v 0

    if { ![ info exists GidPriv($prefix$Nombre$term)] || \
             ![string match INSIDE* [lindex $GidPriv($prefix$Nombre$term) 0]] } {
        InitWindow $w$Nombre $title $prefix$Nombre$term $StartFunc "" 0 1 1
        if { ![winfo exists $w$Nombre] } return ;# windows disabled || usemorewindows == 0

        wm transient $w$Nombre .gid
        catch { wm attributes $w$Nombre -toolwindow 1 }
        $w$Nombre config -background $GidPriv(Color,ToolbarBg)
        set bitmap_geom "[ winfo width $w$Nombre]x[ winfo height $w$Nombre]"
        #puts $bitmap_geom
        if { [ winfo width $w$Nombre] >= [ winfo height $w$Nombre]} {
            set separadores V
            set round_bar 1            
        } else {
            set separadores H
            set round_bar_v $::GidPriv(VerticalRoundBars)            
        }        
    } else {
        set vv $GidPriv($prefix$Nombre$term)
        set GidPriv($prefix$Nombre$term) $vv
        set GiDPrivToolBar($prefix$Nombre$term) $w$Nombre

        set GidPriv($prefix${Nombre}Window) $w$Nombre

        ttk::frame $w$Nombre -style Horizontal.TFrame.IconButton
        #.TFrame
        # -borderwidth 0 -background $GidPriv(Color,ToolbarBg)
        # -borderwidth 2 -relief round_raised -background $::GidPriv(CustomColor,ToolbarBg)

        bind $w$Nombre <Destroy> "+ unset GiDPrivToolBar($prefix$Nombre$term)"

        regexp {([a-zA-Z]*)([0-9]*)} [lindex $GidPriv($prefix$Nombre$term) 0] {} \
            where pos
        set widget ""
        switch $where {
            INSIDETOP {
                GridInside $prefix$Nombre$term $w$Nombre .gid.top "we"
                set separadores V        
                set round_bar 1               
            }
            INSIDELEFT {
                GridInside $prefix$Nombre$term $w$Nombre .gid.left "ns"
                set separadores H
                set round_bar_v $::GidPriv(VerticalRoundBars)                
            }
            INSIDEBOTTOM {
                GridInside $prefix$Nombre$term $w$Nombre .gid.bottom "we"
                set separadores V
                set round_bar $::GidPriv(VerticalRoundBars)                
            }
            INSIDERIGHT {
                GridInside $prefix$Nombre$term $w$Nombre .gid.right "ns"
                set separadores H
                set round_bar_v $::GidPriv(VerticalRoundBars)                
            }

        }
    }

    upvar #0 $BitMapsNames names
    upvar #0 $BitMapsCommands commands
    upvar #0 $BitmapsHelp thehelp
    if { $BitMapsShortNames != ""} {
        upvar \#0 $BitMapsShortNames shortnames
    } else {
        set shortnames(0) ""
    }
    if { [winfo class $w$Nombre] == "Toplevel" } {
        $w$Nombre configure -background $::GidPriv(CustomColor,ToolbarBg)
    } else {
        if { $round_bar} {
            ChangeRoundRelief $w$Nombre horizontal
            #conf -style Horizontal.IconButton
            # -background $::GidPriv(CustomColor,ToolbarBg)
        } elseif { $round_bar_v} {
            ChangeRoundRelief $w$Nombre vertical
            #$w$Nombre configure -style Vertical.IconButton
            # -background $::GidPriv(CustomColor,ToolbarBg)
        }
    }


    #already not set problemtype to use: [ GiD_Info Project ProblemType]
    if { $BitmapsPath == "GiD_image_folder" } {
        set ptpref ""
    } elseif { [regexp {problemtypes[/|\\](.*)} $BitmapsPath dummy problemtype] } {
        set ptpref "$problemtype/"
    } else {
        set ptpref "$BitmapsPath/"
    }
   
    set term_sep Separadores
    set term_ml  MenusList
    set GidPriv($Nombre$term_sep) ""
    set GidPriv($Nombre$term_ml) ""

    set images_menu 1
    # if { $::tcl_platform(os) == "Darwin" } {
    #     set images_menu 0
    # }

    set i 0
    foreach j $names(0) {
        # para rehacer los bitmaps con separadores
        ttk::frame $w$Nombre.f$i -style Horizontal.TFrame.IconButton
        #.TFrame
        # -borderwidth 0 -background $GidPriv(Color,ToolbarBg)
        if { $round_bar} {
            ChangeRoundRelief $w$Nombre.f$i horizontal
            #conf -style Horizontal.IconButton
            #.TFrame
            # -background $::GidPriv(CustomColor,ToolbarBg)
        } elseif { $round_bar_v} {
            ChangeRoundRelief $w$Nombre.f$i vertical
            #conf -style Vertical.IconButton
            #.TFrame
            # -background $::GidPriv(CustomColor,ToolbarBg)
        }

        if { $j == ""} {
            if { $separadores == "H" } {
                set j blank_vertical.png
            } else {
                set j blank_horizontal.png
            }
        }

        if { $j != "---" } {
            #warning: not use gid_themes::GetImage because image must be outside /bitmaps
            #GetImageGiDorProblemtype solve this problem
            
            if { ![info exists names(0,$i)] } {
                set pref [ lindex $j 0]
                if { ( [ llength $j] != 1) && ( $pref == "-np-")} {
                    # set cmd_widget [ regsub -all {%W} [ lrange $j 1 end] $w$Nombre.$i]
                    regsub -all {%W} [ lrange $j 1 end] $w$Nombre.$i cmd_widget
                    regsub -all {%I} $cmd_widget $i cmd_widget
                    regsub -all {%X} $cmd_widget [ winfo pointerx .gid] cmd_widget
                    regsub -all {%Y} $cmd_widget [ winfo pointery .gid] cmd_widget
                    eval $cmd_widget
                } else {
                    if { ![ useAlternativeWidgetsForMac]} {
                        ttk::button $w$Nombre.$i -image [GetImageGiDorProblemtype $BitmapsPath $j] -style Horizontal.IconButton
                        set icon_text [ file root $j]
                        if { $shortnames(0) != ""} {
                            set icon_text [ lindex $shortnames(0) $i]
                        }
                        IconTextConfigureLook $w$Nombre.$i [ GetImageGiDorProblemtype $BitmapsPath $j ] $icon_text
                    } else {
                        ttk::label $w$Nombre.$i -image  [ GetImageGiDorProblemtype $BitmapsPath $j ] \
                            -borderwidth 1 \
                            -relief flat -style Horizontal.IconButton
                    }
                }
                global tcl_platform
                if { $::tcl_platform(platform) == "windows" } {
                    bind $w$Nombre.$i <ButtonRelease-1> "catch \"focus .gid.comm.e\" "
                }
                set comm [lindex $commands(0) $i]
                regsub -all {%I} $comm $i comm
                EnterCommand $w$Nombre.$i $comm
                
            } else {
                if { ![ useAlternativeWidgetsForMac]} {
                    ttk::menubutton $w$Nombre.$i \
                        -image [ GetImageGiDorProblemtype $BitmapsPath $j ] \
                        -style Horizontal.IconButton \
                        -menu $w$Nombre.$i.m -direction right
                    set icon_text [ file root $j]
                    if { $shortnames(0) != ""} {
                        set icon_text [ lindex $shortnames(0) $i]
                    }
                    IconTextConfigureLook $w$Nombre.$i [ GetImageGiDorProblemtype $BitmapsPath $j ] $icon_text
                } else {
                    ttk::label $w$Nombre.$i \
                        -image [ GetImageGiDorProblemtype $BitmapsPath $j ] \
                        -relief flat -borderwidth 1
                       
                    bind $w$Nombre.$i <1> "$w$Nombre.$i.m post %X %Y"
                }
                $w$Nombre.$i configure -style Horizontal.IconButtonWithMenu

                menu $w$Nombre.$i.m -tearoff no
                #-background $GidPriv(Color,ToolbarBg) -borderwidth 1 -relief raised -activeborderwidth 0
                set comm [lindex $commands(0) $i]
                regsub -all {%I} $comm $i comm
                if { $comm != "" } { EnterCommand $w$Nombre.$i.m $comm -2}
                set ii 0
                foreach jj $names(0,$i) {
                    if { $jj == ""} {
                        if { $separadores == "H" } {
                            set jj blank_vertical.png
                        } else {
                            set jj blank_horizontal.png
                        }
                    }

                    if { $images_menu} {
                        $w$Nombre.$i.m add command -image [ GetImageGiDorProblemtype $BitmapsPath $jj ] -hidemargin 1
                    } else  {
                        set icon_text [ file root $jj]
                        $w$Nombre.$i.m add command -label $icon_text -hidemargin 1
                    }
                    # $w$Nombre.$i.m add command -image $GidPriv(image_$ptpref$jj) -hidemargin 1
                    set comm [lindex $commands(0,$i) $ii]
                    regsub -all {%I} $comm $ii comm
                    EnterCommand $w$Nombre.$i.m $comm $i
                    incr ii
                }
                #incr GidPriv(BitmapMenus)
            }
            #nos pone un borde uno en los menubuttons que queda feo
            lappend GidPriv($Nombre$term_ml) $i
            
            set help [lindex $thehelp(0) $i]
            
            #bind $w$Nombre.$i <Enter> [ list catch { wm title $w$Nombre $help } ]
            set cls [ winfo class $w$Nombre.$i]
            if { $cls  != "Label"} {
                if { ![ useAlternativeWidgetsForMac]} { # en mac cogemos el binding <1> en label para simular un boton
                    if { $round_bar} {
                        #bind $w$Nombre.$i <ButtonPress-1> "+$w$Nombre.$i configure -relief round_sunken"
                        bind $w$Nombre.$i <Enter> "+catch { wm title $w$Nombre \"$help\" }"
                        #bind $w$Nombre.$i <ButtonRelease-1> "+$w$Nombre.$i configure -relief round_raised"
                    } elseif { $round_bar_v} {
                        #bind $w$Nombre.$i <ButtonPress-1> "+$w$Nombre.$i configure -relief round_sunken_v"
                        bind $w$Nombre.$i <Enter> "+catch { wm title $w$Nombre \"$help\" }"
                        #bind $w$Nombre.$i <ButtonRelease-1> "+$w$Nombre.$i configure -relief round_raised_v"
                    } else {
                        #ttk not accepted bind $w$Nombre.$i <ButtonPress-1> "+$w$Nombre.$i configure -relief flat"
                        bind $w$Nombre.$i <Enter> "+catch { wm title $w$Nombre \"$help\" }"
                        #ttk not acceptedbind $w$Nombre.$i <ButtonRelease-1> "+$w$Nombre.$i configure -relief raised"
                    }
                }
            }           
            
            if { "$help" != ""} {
            #    if { $::GidPriv(TooltipPopup) != "bottom"} {
                    GidHelpT $w$Nombre.$i $help
            #    } else {
            #        setTooltip $w$Nombre.$i -text $help -delay 0 -bottom .gid
            #    }
            }
            
        } else {
            if { $separadores != "" } {
                if { $separadores == "H" } {
                    set archivo sep_hori.png
                } else {
                    set archivo sep_vert.png
                }
                
                ttk::label $w$Nombre.$i -image [ gid_themes::GetImage $archivo toolbar] -style Horizontal.IconButton
                #-style ForcedLabel
                incr num_separadores
                lappend GidPriv($Nombre$term_sep) $i
            } else {
                ttk::label $w$Nombre.$i -style Horizontal.IconButton
                #-style ForcedLabel
            }
        }
        if { $round_bar} {
            #set cls [ winfo class $w$Nombre.$i]
            #if { $cls != "Label"} {
            ChangeRoundRelief $w$Nombre.$i horizontal
            #conf -relief round_raised -background $::GidPriv(CustomColor,ToolbarBg)
            #}
        } elseif { $round_bar_v} {
            #set cls [ winfo class $w$Nombre.$i]
            #if { $cls != "Label"} {
            ChangeRoundRelief $w$Nombre.$i vertical
            #conf -relief round_raised_v -background $::GidPriv(CustomColor,ToolbarBg)
            #}
        }
        #sep# bind $w$Nombre.$i <ButtonPress-1> "$w$Nombre.$i configure -relief flat"
        #sep# bind $w$Nombre.$i <Enter> "catch { wm title $w$Nombre $help } ; \
            #sep#           $w$Nombre.$i configure -relief raised"
        #sep# bind $w$Nombre.$i <Leave> "$w$Nombre.$i configure -relief flat"

        #set help [lindex $thehelp(0) $i]
        #GidHelp $w$Nombre.$i $help
        #         bind $w$Nombre.$i <ButtonPress-2> [ list DisplayHelp $help %W %x %y]
        #         bind $w$Nombre.$i <ButtonPress-3> [ list DisplayHelp $help %W %x %y]
        incr i
    }
    
    bind $w$Nombre <Configure> [list ReGridChildrenBitmapsGeom $Nombre $w$Nombre $StartFunc $prefix]
    if { [winfo class $w$Nombre] == "Toplevel" } {
        bind $w$Nombre <Leave> [ list wm title $w$Nombre $title]
        
        foreach i [bind .gid] {
            bind $w$Nombre $i [bind .gid $i]
        }
    }

    #GidHelpT $w$Nombre $title
    return $w$Nombre
}

proc SetAllLatersTo { onoff } {
    GiD_Process 'Layers
    if { $onoff == "ON" } {
        foreach i [ GiD_Info layers -off] {
            GiD_Process On $i
        }
    } else {
        foreach i [ GiD_Info layers -on] {
            GiD_Process Off $i
        }
    }
    GiD_Process escape
    FillInfoLayers
}

proc AddLayerOnOff { onoff w basecommand } {
    global GidPriv
    $w delete 0 end
    if { $onoff == "ON" } {
        set words [list [list [_ "-All-"] "SetAllLatersTo $onoff"]]
        set LayerNames [ GiD_Info layers -off]
        if { [info exists GidPriv(LayersAlphabetic)] && $GidPriv(LayersAlphabetic) } {
            set LayerNames [lsort -dictionary $LayerNames]
        }

        set ic 0
        foreach i $LayerNames {
            lappend words [list $i "$basecommand [list $i] escape ; FillInfoLayers"]
            incr ic
            if { $ic > 6 } {
                lappend words [list "..." ChangeLayers]
                break
            }
        }
        rmenuconf $w $words
    } elseif { $onoff == "OFF" } {
        set words [list [list [_ "-All-"] "SetAllLatersTo $onoff"]]
        set LayerNames [ GiD_Info layers -on]
        if { [info exists GidPriv(LayersAlphabetic)] && $GidPriv(LayersAlphabetic) } {
            set LayerNames [lsort -dictionary $LayerNames]
        }
        set ic 0
        foreach i $LayerNames {
            lappend words [list $i "$basecommand [list $i] escape ; FillInfoLayers"]
            incr ic
            if { $ic > 6 } {
                lappend words [list "..." ChangeLayers]
                break
            }
        }
        rmenuconf $w $words
    } else {
        set layertouse [ GiD_Info Project LayerToUse]
        set LayerNames [ GiD_Info layers]
        if { [info exists GidPriv(LayersAlphabetic)] && $GidPriv(LayersAlphabetic) } {
            set LayerNames [lsort -dictionary $LayerNames]
        }
        set words ""
        set ic 0
        foreach i $LayerNames {
            if { $i != $layertouse } {
                lappend words [list $i "$basecommand [list $i] escape ; FillInfoLayers"]
            } else {
                lappend words [list $i "$basecommand [list $i] escape ; FillInfoLayers" check]
            }
            incr ic
            if { $ic > 6 } {
                lappend words [list "..." ChangeLayers]
                break
            }
        }
        rmenuconf $w $words
    }
}

proc LayerEntitiesSub { w entity } {
    global GidPriv

    set LayerNames [ GiD_Info layers]
    if { [info exists GidPriv(LayersAlphabetic)] && $GidPriv(LayersAlphabetic) } {
        set LayerNames [lsort -dictionary $LayerNames]
    }
    set words ""
    if { $GidPriv(LayersAlsoLower) == 0 } {
        set ic 0
        foreach i $LayerNames {
            lappend words [ list $i "GiD_Process 'Layers Entities [list $i] $entity"]
            incr ic
            if { $ic > 6 } {
                lappend words [ list "..." ChangeLayers]
                break
            }
        }
    } else {
        set ic 0
        foreach i $LayerNames {
            lappend words [ list $i "GiD_Process 'Layers Entities [list $i] LowerEntities $entity"]
            incr ic
            if { $ic > 6 } {
                lappend words [ list "..." ChangeLayers]
                break
            }
        }
    }
    rmenuconf $w $words
}

proc LayerEntities { w } {
    global GidPriv

    set geomlistNames [GetGeometryLabels 1]   
    set geomlist [GetGeometryCommands 1]  
    set meshlistNames [GetMeshLabels 1]   
    set meshlist [GetMeshCommands 1]   

    $w delete 0 end

    $w add check -label [_ "Also lower entities"]  -variable GidPriv(LayersAlsoLower)
    if { ![info exists GidPriv(LayersAlsoLower)] } {
        set GidPriv(LayersAlsoLower) 1
    }

    switch [ GiD_Info Project ViewMode] {
        GEOMETRYUSE {
            foreach i $geomlist j $geomlistNames {
                if { $j eq "---" } {
                    $w add separator
                    continue
                }
                set menuname [join "$w . [string tolower $i]" ""]
                $w add cascade -label $j -menu $menuname
                if { ![winfo exists $menuname] } {
                    menu $menuname -postcommand [list LayerEntitiesSub $menuname $i]
                } else {
                    $menuname configure -postcommand [list LayerEntitiesSub $menuname $i]
                }
            }
        }
        MESHUSE {
            foreach i $meshlist j $meshlistNames {
                if { $j eq "---" } {
                    $w add separator
                    continue
                }
                set menuname [join "$w . [string tolower $i]" ""]
                $w add cascade -label $j -menu $menuname
                if { ![winfo exists $menuname] } {
                    menu $menuname -postcommand [list LayerEntitiesSub $menuname $i]
                } else {
                    $menuname configure -postcommand [list LayerEntitiesSub $menuname $i]
                }
            }
        }
    }
}

proc PostActualizeStateLightsSubMenu { w} {
    set num_lights [ GiD_Info postprocess get num_lights]
    # 1 - one light
    # 2 - two lights
    # 3 - three lights
    # 4 - blue light
    # 5 - orange light
    set lst_idx [ list 0 3 4 1 2]
    $w entryconfigure 0 -state normal
    $w entryconfigure 1 -state normal
    $w entryconfigure 2 -state normal
    $w entryconfigure 3 -state normal
    $w entryconfigure 4 -state normal
    $w entryconfigure [ lindex $lst_idx [ expr $num_lights - 1]] -state disable
}

proc PostProcessLights { w which } {
    GiD_Process 'Render $which
    PostActualizeStateLightsSubMenu $w
}

proc PostCreateLightsSubMenu { w} {
    if { ![ winfo exists $w]} {
        menu $w -tearoff 0
    }
    $w delete 0 end
    $w add command -label [_ "One light ( dynamic)"] -command [ list PostProcessLights $w OneLight]
    $w add command -label [_ "Blue light ( fixed)"] -command [ list PostProcessLights $w BlueLight]
    $w add command -label [_ "Orange light ( fixed)"] -command [ list PostProcessLights $w OrangeLight]
    $w add command -label [_ "Two lights ( blue & orange)"] -command [ list PostProcessLights $w TwoLights]
    $w add command -label [_ "Three lights"] -command [ list PostProcessLights $w ThreeLights]
    return $w
}

proc ChangeReflectionState { } {
    set reflejo [ GiD_Reflection get state]
    set ::VREPriv(HayReflejoEntorno) [ lindex $reflejo 0]
    set cmd "On"
    if { [ string equal -nocase $::VREPriv(HayReflejoEntorno) "on"]} {
        set cmd "Off"
    }
    GiD_Process 'Render ReflectEnvironment $cmd
    set reflejo [ GiD_Reflection get state]
    set ::VREPriv(HayReflejoEntorno) [ lindex $reflejo 0]
}

proc AddChangeToRender { w } {
    set whatuse [ GiD_Info Project ViewMode]
    set rendertype [ GiD_Info Project RenderMode]
    if { $rendertype == "postprocess" } {
        set postrender [ GiD_Info postprocess get cur_display_render]
        set newstate $rendertype:$postrender
    } else {
        set newstate $rendertype:$whatuse
    }
    set thisproc $w
    if { [info exists ::MenuPrevState($thisproc)] } {
        if { $::MenuPrevState($thisproc) == $newstate && [$w index end] != "none" } {
            return
        }
    }
    set ::MenuPrevState($thisproc) $newstate

    $w delete 0 end
    set UnderLineList {}
    switch $whatuse {
        GEOMETRYUSE - MESHUSE {
            #set labels [ list [_ "Normal"] [_ "Flat lighting"] [_ "Smooth lighting"]]
            set labels [ list [_ "Normal"] [_ "Flat#C#render"] [_ "Smooth#C#render"]]
            set commands  { Normal FlatLighting SmoothLighting }
            foreach i $labels j $commands {
                set under [FindUnderChar i UnderLineList]
                $w add command -label $i -underline $under -command [list GiD_Process 'Render $j]
            }
            foreach i [ GiD_Info customrenders] {
                set under [FindUnderChar i UnderLineList]
                $w add command -label $i -underline $under -command [list GiD_Process 'Render Customized ChangeCustom $i]
            }
        }
        POSTUSE {
            foreach i [ list [_ "Normal"] [_ "Flat#C#render"] [_ "Smooth#C#render"]] j { Normal Flat Smooth } {
                set under [FindUnderChar i UnderLineList]
                $w add command -label $i -underline $under -command [list GiD_Process 'Render $j]
            }
        }
        default {
            $w add command -label $whatuse -command  ""
        }
    }

    switch $rendertype {
        normal {
            $w entryconfigure 0 -state disabled
        }
        polygons {
            $w entryconfigure 1 -state disabled
        }
        render {
            $w entryconfigure 2 -state disabled
        }
        custom {
            #$w entryconfigure 3 -state disabled
            set customrenders [ GiD_Info customrenders]
            set current [ GiD_Info customrenders current]
            set j 3
            foreach i $customrenders {
                if { $i == $current } {
                    $w entryconfigure $j -state disabled
                    break
                }
                incr j
            }
        }
        postprocess {
            # miguel 1999-01-21 correctec filled render mode in preprocess ( it uses the postprocess mode)
            if { ( $whatuse == "GEOMETRYUSE") || ( $whatuse == "MESHUSE") } {
                #$w entryconfigure 1 -state disabled
            } else {
                set postrender [ GiD_Info postprocess get cur_display_render]
                switch $postrender {
                    Normal {
                        $w entryconfigure 0 -state disabled
                    }
                    Flat {
                        $w entryconfigure 1 -state disabled
                    }
                    Smooth {
                        $w entryconfigure 2 -state disabled
                    }
                }
                
            }
        }
    }

    $w add separator
    if { ( $whatuse == "GEOMETRYUSE") || ( $whatuse == "MESHUSE") } {
        set i [_ "Change light dir"]
        set under [FindUnderChar i UnderLineList]
        $w add command -label $i -underline $under -command {GiD_Process 'ChangeLightVec}
        set i [_ "Customize"]...
        set under [FindUnderChar i UnderLineList]
        $w add command -label $i -underline $under -command "CustomizeRender"
    }
    if { $whatuse == "POSTUSE" } {
        set i [_ "Change light dir"]
        set under [FindUnderChar i UnderLineList]
        $w add command -label $i -underline $under -command {GiD_Process Mescape view render ChangeLightVec}
        set txt [_ "Lights"]
        set under [ FindUnderChar txt UnderLineList]
        $w add cascade -label $txt -underline $under -menu [ PostCreateLightsSubMenu $w.menuLights]
    }

    $w add separator

    set reflejo [ GiD_Reflection get state]
    set ::VREPriv(HayReflejoEntorno) [ lindex $reflejo 0]
    set i [_ "Reflection#C#render"]
    set under [FindUnderChar i UnderLineList]
    $w add checkbutton -label $i -underline $under \
        -command ChangeReflectionState \
        -variable ::VREPriv(HayReflejoEntorno) \
        -onvalue On -offvalue Off

    #set ind_val 0
    #set cmd "RenderFast"
    #if { [ string equal -nocase [ lindex $reflejo 1] "fast"]} {
    #        set ind_val 1
    #        set cmd "RenderNice"
    #}
    #$w add checkbutton -label [_ "Fast reflection#C#render"] -indicatoron $ind_val \
        #        -command [ list GiD_Process 'Render ReflectEnvironment $cmd]
    #

    set i [_ "Define reflection#C#render"]...
    set under [FindUnderChar i UnderLineList]
    $w add command -label $i -underline $under -command VentanaReflejoEntorno
}


proc AddEntitiesToMenuBackgroundImage { w } {
    $w delete 0 end
    
    if { [ GiD_BackgroundImage get filename] == "" } {
        set have_bg_img 0
    } else {
        set have_bg_img 1
    }
    set colors [list black black black]
    if { !$have_bg_img } {
        lset colors 2  $::GidPriv(Color,DisabledForegroundMenu)
    }
    
    set UnderLineList {}
    set labels [list [_ "Fit screen#C#menu"]... [_ "Real size#C#menu"]...  [_ "Default#C#menu"]]
    set commands {BackgroundImg RealSizeImg Default}
    foreach i $labels j $commands color $colors {
        set under [FindUnderChar i UnderLineList]
        $w add command -label $i -underline $under -command [list GiD_Process Mescape Utilities BackgroundImg $j] -foreground $color
    }
    
    if { !$have_bg_img } {
        set color $::GidPriv(Color,DisabledForegroundMenu)
    } else {
        set color black
    }
    set ::CurrentBackgroundImageShow [ GiD_BackgroundImage get show]
    if { $::CurrentBackgroundImageShow == 1} {
        set j 0
    } else {
        set j 1
    }
    set i [_ "Show#C#menu"]
    set under [FindUnderChar i UnderLineList]
    $w add checkbutton -label $i -underline $under -command [list GiD_BackgroundImage set show $j] \
        -indicatoron 1 -foreground $color -onvalue 1 -variable ::CurrentBackgroundImageShow
    #compound left
}

proc CreateCascadedMenu { menu varname varcommandname acceleratorname \
                              currentindex {littleiconname ""} } {
    upvar #0 $varname var $varcommandname varcomm
    if { $acceleratorname != ""} {
        upvar #0 $acceleratorname varaccelerator
    }
    if {$littleiconname != "" } {
        upvar #0 $littleiconname varicons
    }
    global GidPriv
    set UnderLineList ""
    set j 0

    foreach i $var($currentindex) {
        set comm [lindex $varcomm($currentindex) $j]
        if { [string match ---* $i] } {
            $menu add separator
        } elseif { [lindex $i 0] == "-CB-" } {
            set text [lrange $i 1 end]
            set under [FindUnderChar text UnderLineList]
            $menu add checkbutton -label $text -underline $under \
                -variable GidPriv([lindex $i 1])
            EnterCommand $menu $comm $j
            if { [info exists varaccelerator($currentindex)] } {
                AddAccelerator [lindex $varaccelerator($currentindex) $j] \
                    $menu $j
            } else { AddAccelerator "" $menu $j }
            if { [info exists varicons($currentindex)] } {
                AddLittleIcon [lindex $varicons($currentindex) $j] $menu $j
            } else {
                AddLittleIcon "" $menu $j
            }
        } elseif { ![info exists var($currentindex,$j)] } {
            set text $i
            set under [FindUnderChar text UnderLineList]
            $menu add command -label $text -underline $under
            # regsub -all {%W} $comm $menu comm
            # regsub -all {%X} $comm "\[ winfo pointerx .gid\]" comm
            # regsub -all {%Y} $comm "\[ winfo pointery .gid\]" comm
            EnterCommand $menu $comm $j
            if { [info exists varaccelerator($currentindex)] } {
                AddAccelerator [lindex $varaccelerator($currentindex) $j] \
                    $menu $j
            } else { AddAccelerator "" $menu $j }
            if { [info exists varicons($currentindex)] } {
                AddLittleIcon [lindex $varicons($currentindex) $j] $menu $j
            } else {
                AddLittleIcon "" $menu $j
            }
        } else {
            set text $i
            set under [FindUnderChar text UnderLineList]
            $menu add cascade -label $text -underline $under -menu $menu.$j
            if { [winfo exists $menu.$j] } {
                #$menu.$j delete 0 end
                destroy $menu.$j
                menu $menu.$j -tearoff no
            } else {
                menu $menu.$j -tearoff no
            }
            EnterCommand $menu.$j $comm -2
            CreateCascadedMenu $menu.$j $varname $varcommandname $acceleratorname \
                "$currentindex,$j" $littleiconname
            
            if { [info exists varicons($currentindex)] } {
                AddLittleIcon [lindex $varicons($currentindex) $j] $menu $j
            } else {
                AddLittleIcon "" $menu $j
            }
        }
        incr j
    }

}

proc Create3rdButtonMenu { w } {    
    if { [$w index end] == "none" } {
        global 3dButtonNames 3dButtonCommands 3dButtonAcceler 3dButtonIcons
        CreateCascadedMenu $w 3dButtonNames 3dButtonCommands 3dButtonAcceler 0 3dButtonIcons
    }   
}

proc Create3rdButtonMenuGraph { w } {   
    if { [$w index end] == "none" } {
        global 3dButtonNamesGraph 3dButtonCommandsGraph 3dButtonAccelerGraph 3dButtonIconsGraph        
        CreateCascadedMenu $w 3dButtonNamesGraph 3dButtonCommandsGraph 3dButtonAccelerGraph 0 3dButtonIconsGraph
    }   
}

proc TryToFindVector { vec } {

    set num {([+-]?[0-9]*\.?[0-9]*([eE][+-]?[0-9]+)?)}
    set sep [join {[ " " , \n ] +} ""]
    set sepv [join {[ " " , \n
                     ] *} ""]

    set res [regexp ^$sepv$num$sep$num$sep$num$sepv$ $vec trash v1 trash2 \
                 v2 trash3 v3]

    if { $res && $v1 != "" && $v2 != "" && $v3 != ""} { return $v1,$v2,$v3 }
    return $vec
}


proc MakeBottomEntryBindings {} {
    global uparrow

    focus .gid.comm.e

    bind .gid.comm.e <Shift-Return> {
        set aa [TryToFindVector [.gid.comm.e get]]
        .gid.comm.e delete 0 end
        .gid.comm.fwarn.list insert end "->$aa"
        set uparrow [.gid.comm.fwarn.list size]
        .gid.comm.fwarn.list yview [expr $uparrow-2]
        GiD_Process {*}$aa
        break
    }


    bind .gid.comm.e <Return> {
        set aa [.gid.comm.e get]
        .gid.comm.e delete 0 end
        .gid.comm.fwarn.list insert end "->$aa"
        set uparrow [.gid.comm.fwarn.list size]
        .gid.comm.fwarn.list yview [expr $uparrow-2]
        
        if { [string match -np-* $aa] } {
            regsub -- {-np-} $aa {} aa
            eval $aa
        } elseif { [llength $aa] } {
            GiD_Process {*}$aa
        }
    }
   
    set uparrow 0
    bind .gid.comm.e <Up> {
        .gid.comm.e delete 0 end
        while 1 {
            incr uparrow -1
            if { $uparrow < 0 } {
                set uparrow -1
                break
            } elseif { [regexp {^->.*[^ ]+.*$} [.gid.comm.fwarn.list get $uparrow]] } {
                .gid.comm.e insert 0 [string range [.gid.comm.fwarn.list get $uparrow] \
                                          2 end]
                break
            }
        }
    }
    bind .gid.comm.e <Down> {
        .gid.comm.e delete 0 end
        while 1 {
            incr uparrow 1
            if { $uparrow >= [.gid.comm.fwarn.list size] } {
                set uparrow [.gid.comm.fwarn.list size]
                break
            } elseif { [regexp {^->.*[^ ]+.*$} [.gid.comm.fwarn.list get $uparrow]] } {
                .gid.comm.e insert 0 [string range [.gid.comm.fwarn.list get $uparrow] \
                                          2 end]
                break
            }
        }
    }
    bind .gid.comm.e <Alt-KeyPress-3> {
        set x [expr [winfo rootx %W]+%x+2]
        set y [expr [winfo rooty %W]+%y]
        GiDShowContextualMenu $x $y        
    }
    bind .gid.comm.e <Tab> "AutoCompleteGiDEntry %W; break"

    #para dejar el 'pegar' con el boton del medio del raton
    bind .gid.comm.e <ButtonPress-2> ""
    #.gid.comm.e insert insert \"[selection get]\"; break;"
    #bind .gid.comm.e <ButtonRelease-2> ""
}

proc AddEntitiesToMenu { w basecommand args} {
    return [AddEntitiesToMenuAfter -1 $w $basecommand {*}$args]
}

proc AddEntitiesToMenuCollapse { w } {
    set whatuse [ GiD_Info Project ViewMode]
    set newstate $whatuse
    set thisproc $w
    if { [info exists ::MenuPrevState($thisproc)] } {
        if { $::MenuPrevState($thisproc) == $newstate && [$w index end] != "none" } {
            return
        }
    }
    set ::MenuPrevState($thisproc) $newstate

    set basecommand {GiD_Process Mescape utilities Collapse}
    set geomlist {Model}
    lappend geomlist {*}[ GetGeometryCommands]
    set geomlistnames [list [_ "Model"]]
    lapped geomlistnames {*}[ GetGeometryLabels]
    set meshlist {Mesh Edges Nodes Elements}
    set meshlistnames [ list [_ "Mesh"] [_ "Edges"] [_ "Nodes"] [_ "Elements"] ]
    
    $w delete 0 end
    set UnderLineList {}
    switch $whatuse {
        GEOMETRYUSE {
            foreach text $geomlistnames i $geomlist {
                set under [FindUnderChar text UnderLineList]
                $w add command -label $text -underline $under -command "$basecommand $i"
            }
        }
        MESHUSE {
            foreach text $meshlistnames i $meshlist {
                set under [FindUnderChar text UnderLineList]
                $w add command -label $text -underline $under -command "$basecommand $i"
            }
        }
    }
}

proc AddEntitiesToMenuSwapNormals { w } {
    set whatuse [ GiD_Info Project ViewMode]
    #set newstate $whatuse
    #set thisproc $w
    #if { [info exists ::MenuPrevState($thisproc)] } {
    #if { $::MenuPrevState($thisproc) == $newstate && [$w index end] != "none" } {
    #   return
    #}
    #}
    #set ::MenuPrevState($thisproc) $newstate

    set basecommand "GiD_Process Mescape utilities SwapNormals"
    set geomlist [list "Lines" "Surfaces"]
    set geomlistnames [list [_ "Lines"] [_ "Surfaces"]]
    set nlines [ GiD_Info Geometry NumLines]
    set nsurfs [ GiD_Info Geometry NumSurfaces]
    set geomstatecolors [list [ GetColorTrueFalse $nlines] [ GetColorTrueFalse $nsurfs]]
    set meshlist [list "Select" "MakeGroupCoherent" "SelByNormal"]
    set meshlistnames [list [_ "Select"] [_ "Make coherent"] [_ "Select by normal"]]
    
    $w delete 0 end
    set i [lindex [split $w .] end]
    set parent [winfo parent $w]
    set UnderLineList {}
    switch $whatuse {
        GEOMETRYUSE {
            $parent entryconfigure $i -foreground [ GetColorTrueFalse $nlines]
            foreach name $geomlistnames i $geomlist color $geomstatecolors {
                set under [FindUnderChar name UnderLineList]
                if { $i == "Lines" } {                    
                    set id_menu 0
                    $w add cascade -label $name -underline $under -foreground $color -menu $w.m$id_menu
                    if { [ winfo exists $w.m$id_menu ] } {
                        $w.m$id_menu delete 0 end
                    } else {
                        menu $w.m$id_menu
                    }
                    set UnderLineList2 {}
                    set text [_ "Select"]
                    set under [FindUnderChar text UnderLineList2]
                    $w.m$id_menu add command -label $text -underline $under -foreground $color -command "$basecommand $i Select"
                    set text [_ "Pointing inside surfaces"]
                    set under [FindUnderChar text UnderLineList2]
                    $w.m$id_menu add command -label $text -underline $under -foreground $color -command "$basecommand PointingInside Surfaces"
                } elseif { $i == "Surfaces" } {
                    set id_menu 1
                    $w add cascade -label $name -underline $under -foreground $color -menu $w.m$id_menu
                    if { [ winfo exists $w.m$id_menu ] } {
                        $w.m$id_menu delete 0 end
                    } else {
                        menu $w.m$id_menu
                    }
                    set UnderLineList2 {}
                    set text [_ "Select"]
                    set under [FindUnderChar text UnderLineList2]
                    $w.m$id_menu add command -label $text -underline $under -foreground $color -command "$basecommand $i Select"
                    set text [_ "Make coherent"]
                    set under [FindUnderChar text UnderLineList2]
                    $w.m$id_menu add command -label $text -underline $under -foreground $color -command "$basecommand $i MakeGroupCoherent"
                    set text [_ "Select by normal"]
                    set under [FindUnderChar text UnderLineList2]
                    $w.m$id_menu add command -label $text -underline $under -foreground $color -command "$basecommand $i SelByNormal"
                    set text [_ "Pointing inside volumes"]
                    set under [FindUnderChar text UnderLineList2]
                    $w.m$id_menu add command -label $text -underline $under -foreground $color -command "$basecommand PointingInside Volumes"
                }
            }
        }
        MESHUSE {
            set nelems [ GiD_Info Mesh NumElements]
            set color [ GetColorTrueFalse $nelems]
            $parent entryconfigure $i -foreground [ GetColorTrueFalse $nlines]           
            foreach name $meshlistnames i $meshlist {
                set under [FindUnderChar name UnderLineList]
                $w add command -label $name -underline $under -foreground $color -command "$basecommand $i"
            }
        }
    }
}

proc AddEntitiesToMenuDrawNormals { w } {
    set whatuse [ GiD_Info Project ViewMode]
    set newstate $whatuse
    set thisproc $w
    if { [info exists ::MenuPrevState($thisproc)] } {
        if { $::MenuPrevState($thisproc) == $newstate && [$w index end] != "none" } {
            return
        }
    }
    set ::MenuPrevState($thisproc) $newstate

    set basecommand {GiD_Process Mescape Utilities Drawnormals}
    set geomlist [ list Lines Surfaces ]
    set geomlistnames [ list [_ "Lines"] [_ "Surfaces"] ]
    set meshlist [ list "$basecommand" "$basecommand Color"]
    set meshlistnames [ list [_ "Elements"] [_ "Colored elements"]]

    $w delete 0 end
    set UnderLineList {}
    switch $whatuse {
        GEOMETRYUSE {
            set colors [list black black ]
            if { [winfo exists .gid.central.s] } {
                set nlines [ GiD_Info Geometry NumLines]
                set nsurfs [ GiD_Info Geometry NumSurfaces]
                set i [lindex [split $w .] end]
                set parent [winfo parent $w]
                if { !$nlines } {
                    $parent entryconfigure $i -foreground $::GidPriv(Color,DisabledForegroundMenu)
                    lset colors 0  $::GidPriv(Color,DisabledForegroundMenu)
                    lset colors 1  $::GidPriv(Color,DisabledForegroundMenu)
                    #lset colors 2  $::GidPriv(Color,DisabledForegroundMenu)
                } else {
                    $parent entryconfigure $i -foreground black
                    lset colors 0  black
                    if { $nsurfs } {
                        lset colors 1  black
                    } else {
                        lset colors 1  $::GidPriv(Color,DisabledForegroundMenu)
                    }
                    #lset colors 2  black
                }
            }
            foreach name $geomlistnames i $geomlist col $colors {
                if { $i == "Lines" } {
                    set under [FindUnderChar name UnderLineList]
                    $w add command -label $name -underline $under -command [list {*}$basecommand $i] -foreground $col
                } elseif { $i == "Surfaces" } {
                    set id_menu 1
                    set under [FindUnderChar name UnderLineList]
                    $w add cascade -label $name -underline $under  -menu $w.m$id_menu -foreground $col
                    if { [ winfo exists $w.m$id_menu ] } {
                        $w.m$id_menu delete 0 end
                    } else {
                        menu $w.m$id_menu
                    }
                    set text [_ "Normal"]
                    set under [FindUnderChar text UnderLineList]
                    $w.m$id_menu add command -label $text -underline $under -command [list {*}$basecommand $i] -foreground $col
                    set text  [_ "Colored#C#Surfaces"]
                    set under [FindUnderChar text UnderLineList]
                    $w.m$id_menu add command -label $text -underline $under -command  [list {*}$basecommand $i Color] -foreground $col
                }
            }
        }
        MESHUSE {
            set i [lindex [split $w .] end]
            set parent [winfo parent $w]
            $parent entryconfigure $i -foreground black
            foreach name $meshlistnames i $meshlist {
                set under [FindUnderChar name UnderLineList]
                $w add command -label $name -underline $under -command $i -foreground black
            }
        }
    }
}

proc AddEntitiesToMenuDrawHigher { w } {
    set whatuse [ GiD_Info Project ViewMode]
    set newstate $whatuse
    set thisproc $w
    if { [info exists ::MenuPrevState($thisproc)] } {
        if { $::MenuPrevState($thisproc) == $newstate && [$w index end] != "none" } {
            return
        }
    }
    set ::MenuPrevState($thisproc) $newstate

    set basecommand "GiD_Process Mescape Utilities DrawHigher"
    set geomlist "Points Lines Surfaces Separator All"
    set geomlistnames [list [_ "Points"] [_ "Lines"] [_ "Surfaces"] "Separator" [_ "All"]]
    set meshlist "Nodes Edges"
    set meshlistnames [list [_ "Nodes"] [_ "Edges"]]

    $w delete 0 end
    set UnderLineList {}
    switch $whatuse {
        GEOMETRYUSE {
            set colors [list black black black black black ]
            set npoints [ GiD_Info Geometry NumPoints]
            set nlines [ GiD_Info Geometry NumLines]
            set nsurfs [ GiD_Info Geometry NumSurfaces]
            set i [lindex [split $w .] end]
            set parent [winfo parent $w]
            if { !$npoints } {
                $parent entryconfigure $i -foreground $::GidPriv(Color,DisabledForegroundMenu)
                lset colors 0  $::GidPriv(Color,DisabledForegroundMenu)
                lset colors 1  $::GidPriv(Color,DisabledForegroundMenu)
                lset colors 2  $::GidPriv(Color,DisabledForegroundMenu)
                # lset colors 4  $::GidPriv(Color,DisabledForegroundMenu)
            } else {
                $parent entryconfigure $i -foreground black
                lset colors 0  black
                # lset colors 4  black
                if { $nsurfs } {
                    lset colors 1  black
                    lset colors 2  black
                } else {
                    lset colors 2  $::GidPriv(Color,DisabledForegroundMenu)
                    if { $nlines } {
                        lset colors 1  black
                    } else {
                        lset colors 1  $::GidPriv(Color,DisabledForegroundMenu)
                    }
                }
            }
            foreach name $geomlistnames i $geomlist col $colors {
                if { $i == "Separator" } {
                    $w add separator
                } else {
                    set under [FindUnderChar name UnderLineList]
                    $w add command -label $name -underline $under -command [concat $basecommand $i] -foreground $col
                }
            }
        }
        MESHUSE {
            set i [lindex [split $w .] end]
            set parent [winfo parent $w]
            $parent entryconfigure $i -foreground black
            foreach name $meshlistnames i $meshlist {
                set under [FindUnderChar name UnderLineList]
                $w add command -label $name -underline $under -command [concat $basecommand $i] -foreground black
            }
        }
    }
}

proc AddEntitiesToMenuCreateElement { w } {
    set basecommand {GiD_Process Mescape Meshing EditMesh CreateElement}
    
    set element_types ""
    set is_cartesian [ GiD_Cartesian get iscartesian]
    if { $is_cartesian } {
        if { [ GiD_Cartesian get dimension] == 2 } {
            set is_2d 1
        } else {
            set is_2d 0
        }
    } else {
        set is_2d 0
    }
    if { $::GidPriv(HideVolumeLevel)==1 } {
        set is_2d 1
    }
    if { $is_cartesian } {
        if { $is_2d } {           
            set meshlist [list Linear Quadrilateral]
            set meshlistnames [list [_ "Linear"] [_ "Quadrilateral"]]
        } else {
            set meshlist [list Linear Quadrilateral Hexahedra]
            set meshlistnames [list [_ "Linear"] [_ "Quadrilateral"] [_ "Hexahedra"]]
        }
    } else {
        if { $is_2d } {           
            set meshlist [list Point --- Linear Triangle Quadrilateral Circle]
            set meshlistnames [list [_ "Point"] "" [_ "Linear"] [_ "Triangle"] [_ "Quadrilateral"] [_ "Circle"]]
        } else {
            set meshlist [list Point --- Linear Triangle Quadrilateral Circle --- Tetrahedra Hexahedra Prism Pyramid Sphere]
            set meshlistnames [list [_ "Point"] "" [_ "Linear"] [_ "Triangle"] [_ "Quadrilateral"] [_ "Circle"] \
                                   "" [_ "Tetrahedra"] [_ "Hexahedra"] [_ "Prism"] [_ "Pyramid"] [_ "Sphere"]]           
        }
    }           
    
    $w delete 0 end
    set UnderLineList {}
    
    set i [lindex [split $w .] end]
    set parent [winfo parent $w]
    $parent entryconfigure $i -foreground black
    foreach name $meshlistnames i $meshlist {
        if { $i eq "---" } {
            $w add separator
            continue
        }
        set under [FindUnderChar name UnderLineList]
        $w add command -label $name -underline $under -command [list {*}$basecommand $i] -foreground black
    }    
}

proc AddEntitiesToMenuDrawCurvatures { w } {
    global GidPriv
    if { ![info exists GidPriv(DrawMainDirections)] } {
        set GidPriv(DrawMainDirections) 0
    }

    set whatuse [ GiD_Info Project ViewMode]
    set newstate $whatuse:$GidPriv(DrawMainDirections)
    set thisproc $w
    if { [info exists ::MenuPrevState($thisproc)] } {
        if { $::MenuPrevState($thisproc) == $newstate && [$w index end] != "none" } {
            return
        }
    }
    set ::MenuPrevState($thisproc) $newstate


    if { !$GidPriv(DrawMainDirections) } {
        set basecommand "GiD_Process Mescape Utilities DrawCurvature Surfaces NoShowMainDir"
    } else {
        set basecommand "GiD_Process Mescape Utilities DrawCurvature Surfaces ShowMainDir"
    }
    set geomlist "CurvatureMax CurvatureMin CurvatureMean CurvatureGauss"
    set geomlistnames [list [_ "Max.#C#curvature"] [_ "Min.#C#curvature"] [_ "Mean#C#curvature"] [_ "Gaussian#C#curvature"]]

    $w delete 0 end
    set UnderLineList {}
    if { $whatuse == "GEOMETRYUSE" && [ GiD_Info Geometry NumSurfaces] > 0 } {
        set col black
    } else {
        set col $::GidPriv(Color,DisabledForegroundMenu)
    }
    set i [lindex [split $w .] end]
    set parent [winfo parent $w]
    $parent entryconfigure $i -foreground $col
    foreach name $geomlistnames i $geomlist {
        if { $i=="Separator" } {
            $w add separator
        } else {
            set under [FindUnderChar name UnderLineList]
            $w add command -label $name -underline $under -command "$basecommand $i" -foreground $col
        }
    }
    $w add separator
    if { !$GidPriv(DrawMainDirections) } {
        set name [_ "Main directions"]
        set under [FindUnderChar name UnderLineList]
        $w add checkbutton -label $name -underline $under -variable GidPriv(DrawMainDirections) -foreground $col \
            -command "GiD_Process Mescape Utilities DrawCurvature ShowMainDir"
    } else {
        set name [_ "Main directions"]
        set under [FindUnderChar name UnderLineList]
        $w add checkbutton -label $name -underline $under -variable GidPriv(DrawMainDirections) -foreground $col \
            -command "GiD_Process Mescape Utilities DrawCurvature NoShowMainDir"
    }
}

#create a name to show abreviated the full path of a file, for example:  "d:\Documents\...\myfile"
proc ShortFilenameToShowMenu { filename {maxlength 40} } {
    if { [string length $filename] > $maxlength } {
        set splitname [file split $filename]
        set l [llength $splitname]
        set availablelength $maxlength
        set shortname [lindex $splitname 0]
        incr availablelength [expr -[string length $shortname]-[string length [lindex $splitname [expr $l-1]]-5]]
        for {set i 1 } { $i < [expr $l-1] } {incr i} {
            incr availablelength [expr -[string length [lindex $splitname $i]]-1]
            if { $availablelength >=0 } {
                set shortname [file join $shortname [lindex $splitname $i]]
            } else {
                break
            }
        }
        set shortname [file join $shortname {...} [lindex $splitname [expr $l-1]]]
        set shortname [file nativename $shortname]
    } else {
        set shortname [file nativename $filename]
    }
    return $shortname
}

proc UltimoTrozoNombreArchivo { archivo} {
    set nombre [ file tail $archivo]
    set dir [ file tail [ file dirname $archivo]]
    if { $dir != ""} {
        set nombre [ file join $dir $nombre]
    }
    return $nombre
}

proc AddEntitiesToMenuRecentProjects { w } {
    set names [ GiD_Info RecentProjects]
    set newstate $names
    set thisproc $w
    if { [info exists ::MenuPrevState($thisproc)] } {
        if { $::MenuPrevState($thisproc) == $newstate && [$w index end] != "none" } {
            return
        }
    }
    set ::MenuPrevState($thisproc) $newstate

    $w delete 0 end
    set UnderLineList {}

    set menuIdx 0
    # definimos una variable que se actualizara con el contenido de la ayuda
    set ::txtAyuda$w ""

    # package require BWidget
    DynamicHelp::register $w menu ::txtAyuda$w

    foreach i $names {
        set text [ShortFilenameToShowMenu $i]
        set under [FindUnderChar text UnderLineList]
        $w add command -label $text -underline $under -command [list LoadFileInGid $i.gid]

        DynamicHelp::register $w menuentry $menuIdx $i.gid
        incr menuIdx
    }
    # el balon de ayuda:

    if { $::GidPriv(TooltipPopup) != "bottom"} {
        setTooltip $w -textvariable ::txtAyuda$w
    } else {
        setTooltip $w -textvariable ::txtAyuda$w -delay 0 -bottom .gid
    }
}

proc AddEntitiesToMenuRecentPostFiles { w } {
    set names [ GiD_Info RecentPostFiles]
    set newstate $names
    set thisproc $w
    if { [info exists ::MenuPrevState($thisproc)] } {
        if { $::MenuPrevState($thisproc) == $newstate && [$w index end] != "none" } {
            return
        }
    }
    set ::MenuPrevState($thisproc) $newstate

    $w delete 0 end
    set UnderLineList {}

    set menuIdx 0
    # definimos una variable que se actualizara con el contenido de la ayuda
    set ::txtAyuda$w ""

    # package require BWidget
    DynamicHelp::register $w menu ::txtAyuda$w

    foreach i $names {
        if { [catch {
            # es multiple si hay varios .msh y .res o .bin
            set varias_msh [ regexp {^.*\.msh.*\.msh\}?$} $i]
            set varios_res [ regexp {^.*\.res.*\.res\}?$} $i]
            set varios_bin [ regexp {^.*\.bin.*\.bin\}?$} $i]
            if { !$varias_msh && !$varios_res && !$varios_bin} {
                set text [ShortFilenameToShowMenu $i]
                set under [FindUnderChar text UnderLineList]
                $w add command -label $text -underline $under -command [ list LoadFileInGidPost $i]

                DynamicHelp::register $w menuentry $menuIdx $i
            } else {
                # es un open multiple
                set a1 [ lindex $i 0]
                set a2 [ lindex $i end]
                set text [format "%s: %s, ..., %s ( %s)" [_ "Multiple"] \
                              [ UltimoTrozoNombreArchivo $a1] [ UltimoTrozoNombreArchivo $a2] [ llength $i]]
                set under [ FindUnderChar text UnderLineList]
                $w add command -label $text -underline $under \
                    -command [ list ExecuteFileCommand ReadMultiple POST "" $i]

                regsub -all "bin " $i "bin\n" txt
                DynamicHelp::register $w menuentry $menuIdx $txt
                #WarnWinText "$i\n$txt"
            }
        } err_txt] } {
            WarnWinText $err_txt
        }
        incr menuIdx
    }

    # el balon de ayuda:
    if { $::GidPriv(TooltipPopup) != "bottom"} {
        setTooltip $w -textvariable ::txtAyuda$w
    } else {
        setTooltip $w -textvariable ::txtAyuda$w -delay 0 -bottom .gid
    }
}

proc AddEntitiesToMenuRecentViewFiles { w } {
    set names [ GiD_Info RecentViewFiles]
    set newstate $names
    set thisproc $w
    if { [info exists ::MenuPrevState($thisproc)] } {
        if { $::MenuPrevState($thisproc) == $newstate && [$w index end] != "none" } {
            return
        }
    }
    set ::MenuPrevState($thisproc) $newstate

    $w delete 0 end
    set UnderLineList {}

    set menuIdx 0
    # definimos una variable que se actualizara con el contenido de la ayuda
    set ::txtAyuda$w ""

    # package require BWidget
    DynamicHelp::register $w menu ::txtAyuda$w
    foreach i $names {
        set text [ShortFilenameToShowMenu $i]
        set under [FindUnderChar text UnderLineList]
        $w add command -label $text -underline $under -command [ list LoadFileInGidPost $i]

        DynamicHelp::register $w menuentry $menuIdx $i
        incr menuIdx
    }

    # el balon de ayuda:
    if { $::GidPriv(TooltipPopup) != "bottom"} {
        setTooltip $w -textvariable ::txtAyuda$w
    } else {
        setTooltip $w -textvariable ::txtAyuda$w -delay 0 -bottom .gid
    }
}

proc AddRecentViewFiles2IconBar { w } {
    $w delete 0 end
    set UnderLineList {}
    # Vistas predefinidas:
    set img [ list zframe.png \
                  view_rotate_xy.png view_rotate_xz.png view_rotate_yz.png \
                  view_rotate_-xy.png view_rotate_-xz.png view_rotate_-yz.png \
                  isometric.png]
    set txt [ list [_ "Zoom frame"] \
                  [_ "View XY plane (original)"] [_ "View XZ plane"] [_ "View YZ plane"] \
                  [_ "View -XY plane"] [_ "View -XZ plane"] [_ "View -YZ plane"] \
                  [_ "Isometric"]]
    set cmd [ list "GiD_Process 'Zoom Frame" \
                  "GiD_Process 'Rotate Angle 270 90" \
                  "GiD_Process 'Rotate Angle 270 0" \
                  "GiD_Process 'Rotate Angle 0 0" \
                  "GiD_Process 'Rotate Angle 90 -90" \
                  "GiD_Process 'Rotate Angle 90 0" \
                  "GiD_Process 'Rotate Angle 180 0" \
                  "GiD_Process 'Rotate Angle 45 45"]

    foreach i $img t $txt c $cmd {
        set under [FindUnderChar t UnderLineList]
        if { $i != ""} {
            $w add command -image [ gid_themes::GetImage $i menu] -label $t -underline $under -command $c -compound left
        } else {
            $w add command -label $t -underline $under -command $c
        }
    }
    $w add separator

    set names [ GiD_Info RecentViewFiles]

    # ya se han anyadido algunas entradas
    set menuIdx [ $w index last]
    incr menuIdx
    # definimos una variable que se actualizara con el contenido de la ayuda
    set ::txtAyuda$w ""

    # package require BWidget
    DynamicHelp::register $w menu ::txtAyuda$w

    foreach i $names {
        if { ![ regexp {^\{([^\}]*).*\{([^\}]*)\}$} $i tonto a1 a2]} {
            set text [ShortFilenameToShowMenu $i]
            set under [FindUnderChar text UnderLineList]
            $w add command -label $text -underline $under -command [list LoadFileInGidPost $i]

            DynamicHelp::register $w menuentry $menuIdx $i
        } else {
            # es un open multiple
            set text [_ "Multiple: %s, ..., %s" [UltimoTrozoNombreArchivo $a1] [UltimoTrozoNombreArchivo $a2]]
            set under [FindUnderChar text UnderLineList]
            $w add command -label $text -underline $under \
                -command [list ExecuteFileCommand ReadMultiple POST "" $i]

            DynamicHelp::register $w menuentry $menuIdx $i
        }
        incr menuIdx
    }

    $w add separator
    foreach t [ list [_ "Read#C#menu"]... [_ "Save#C#menu"]...] c { {Mescape View ReadView} {Mescape View SaveView}} {
        set under [ FindUnderChar t UnderLineList]
        $w add command -label $t -underline $under -command [ list GiD_Process {*}$c]
    }

    # el balon de ayuda:
    if { $::GidPriv(TooltipPopup) != "bottom"} {
        setTooltip $w -textvariable ::txtAyuda$w
    } else {
        setTooltip $w -textvariable ::txtAyuda$w -delay 0 -bottom .gid
    }
}

#num: num to append after (to preserve previous menu items).  -1 to delete all menu
#w: menu name 
#basecommand: Tcl command to append $i entity type
#args: alternative list of entities names and labels, then expected 4 or 6 sublists
proc AddEntitiesToMenuAfter { num w basecommand args} {
    set whatuse [ GiD_Info Project ViewMode]
    #     set newstate $whatuse
    #     set thisproc $w
    #     if { [info exists ::MenuPrevState($thisproc)] } {
    #         if { $::MenuPrevState($thisproc) == $newstate && [$w index end] != "none" } {
    #             return
    #         }
    #     }
    #     set ::MenuPrevState($thisproc) $newstate

    
    incr num
    if { [$w index $num] == $num } {
        $w delete $num end
    } 

    if { [llength $args] == 4 } {
        set geomlistnames [lindex $args 0]
        set geomlist [lindex $args 1]
        set meshlistnames [lindex $args 2]
        set meshlist [lindex $args 3]
        set graphlist {Nodes}        
        set graphlistnames [ list [_ "Nodes"] ]
    } elseif { [llength $args] == 6 } {
        set geomlistnames [lindex $args 0]
        set geomlist [lindex $args 1]
        set meshlistnames [lindex $args 2]
        set meshlist [lindex $args 3]
        set graphlist [lindex $args 4]
        set graphlistnames [lindex $args 5]
    } else {
        switch $whatuse {
            GEOMETRYUSE {
                set geomlist [GetGeometryCommands]
                set geomlistnames [GetGeometryLabels]
            }
            MESHUSE {        
                set meshlist [GetMeshCommands]
                set meshlistnames [GetMeshLabels]
            }
            POSTUSE {
                set meshlist [GetMeshCommands]
                set meshlistnames [GetMeshLabels]
            }
            GRAPHUSE {
                set graphlist {Nodes}        
                set graphlistnames [ list [_ "Nodes"] ]
            }
        }
        
    }

    #set colors to enable/disable
    switch $whatuse {
        GEOMETRYUSE {           
            set colors [lrepeat [llength $geomlist] black]
            #SendLayerEntitiesToBackAA Layers->To Back
            if { [string trim $basecommand] != "SendLayerEntitiesToBackAA" } {
                if { [winfo exists .gid.central.s] } {
                    set npoints [ GiD_Info Geometry NumPoints]
                    set nlines [ GiD_Info Geometry NumLines]
                    set nsurfs [ GiD_Info Geometry NumSurfaces]
                    set nvols [ GiD_Info Geometry NumVolumes]
                    set i [lindex [split $w .] end]
                    set parent [winfo parent $w]
                    if { [string is integer $i] && $i >=0 && $i < [$parent index end] } {
                        $parent entryconfigure $i -foreground black
                    }
                    if { !$npoints } {
                        #if { [string is integer $i] && $i >=0 && $i < [$parent index end] } {
                        #    $parent entryconfigure $i -foreground $::GidPriv(Color,DisabledForegroundMenu)
                        #}
                        lset colors 0  $::GidPriv(Color,DisabledForegroundMenu)
                        lset colors 1  $::GidPriv(Color,DisabledForegroundMenu)
                        lset colors 2  $::GidPriv(Color,DisabledForegroundMenu)
                        if { $::GidPriv(HideVolumeLevel)==0} {
                            lset colors 3  $::GidPriv(Color,DisabledForegroundMenu)
                        }
                    } else {
                        if { [string is integer $i] && $i >=0 && $i < [$parent index end] } {
                            $parent entryconfigure $i -foreground black
                        }
                        lset colors 0  black
                        if { $nvols } {
                            if { $::GidPriv(HideVolumeLevel)==0} {
                                lset colors 3 black
                            }
                            lset colors 2 black
                            lset colors 1 black
                        } else {
                            if { $::GidPriv(HideVolumeLevel)==0} {
                                lset colors 3  $::GidPriv(Color,DisabledForegroundMenu)
                            }
                            if { $nsurfs } {
                                lset colors 2 black
                                lset colors 1 black
                            } else {
                                lset colors 2 $::GidPriv(Color,DisabledForegroundMenu)
                                if { $nlines } {
                                    lset colors 1 black
                                } else {
                                    lset colors 1 $::GidPriv(Color,DisabledForegroundMenu)
                                }
                            }
                        }
                    }
                }
            }
        }
        MESHUSE {                      
            set colors [lrepeat [llength $meshlist] black]           
            if { [winfo exists .gid.central.s] } {
                set nnodes [ GiD_Info Mesh NumNodes]
                set nelements [ GiD_Info Mesh NumElements]        
                set i [lindex [split $w .] end]
                set parent [winfo parent $w]
                if { [string is integer $i] && $i >=0 && $i < [$parent index end] } {
                    $parent entryconfigure $i -foreground black
                }
                if { !$nnodes } {
                    #if { [string is integer $i] && $i >=0 && $i < [$parent index end] } {
                    #    $parent entryconfigure $i -foreground $::GidPriv(Color,DisabledForegroundMenu)
                    #}
                    lset colors 0  $::GidPriv(Color,DisabledForegroundMenu)
                    lset colors 1  $::GidPriv(Color,DisabledForegroundMenu)                   
                } else {
                    if { [string is integer $i] && $i >=0 && $i < [$parent index end] } {
                        $parent entryconfigure $i -foreground black
                    }
                    lset colors 0  black
                    if { $nelements } {
                        lset colors 1 black
                    } else {
                        lset colors 1 $::GidPriv(Color,DisabledForegroundMenu)
                    }
                }
            }
        }
        POSTUSE {           
            set colors [lrepeat [llength $meshlist] black]
        }
        GRAPHUSE {           
            set colors [lrepeat [llength $graphlist] black]
        }
    }

    set UnderLineList {}
    switch $whatuse {
        GEOMETRYUSE {        
            foreach name $geomlistnames i $geomlist color $colors {
                if { $name eq "---" } {
                    $w add separator
                    continue
                }
                set under [FindUnderChar name UnderLineList]
                $w add command -label $name -underline $under -command [list {*}$basecommand $i] -foreground $color \
                    -image [ gid_themes::GetImage "blank.png" menu] -compound left
            }
        }
        MESHUSE {
            set i [lindex [split $w .] end]
            set parent [winfo parent $w]
            if { [string is integer $i] && $i >=0 && $i < [$parent index end] } {
                $parent entryconfigure $i -foreground black
            }
            foreach name $meshlistnames i $meshlist color $colors {
                if { $name eq "---" } {
                    $w add separator
                    continue
                }
                set under [FindUnderChar name UnderLineList]
                $w add command -label $name -underline $under -command [list {*}$basecommand $i] -foreground $color \
                    -image [ gid_themes::GetImage "blank.png" menu] -compound left
            }
        }
        POSTUSE {
            foreach name $meshlistnames i $meshlist {
                if { $name eq "---" } {
                    $w add separator
                    continue
                }
                set under [FindUnderChar name UnderLineList]
                $w add command -label $name -underline $under -command [list {*}$basecommand $i] \
                    -image [ gid_themes::GetImage "blank.png" menu] -compound left
            }
        }
        GRAPHUSE {
            foreach name $graphlistnames i $graphlist {
                if { $name eq "---" } {
                    $w add separator
                    continue
                }
                set under [FindUnderChar name UnderLineList]
                $w add command -label $name -underline $under -command [list {*}$basecommand $i] \
                    -image [ gid_themes::GetImage "blank.png" menu] -compound left
            }
        }
    }
}

proc AddEntitiesToMenuGeomOrMeshOrGraph { w namesG namesM namesF commandsG commandsM commandsF } {
    set nlist(GEOMETRYUSE) $namesG
    set nlist(MESHUSE) $namesM
    set nlist(GRAPHUSE) $namesF

    set clist(GEOMETRYUSE) $commandsG
    set clist(MESHUSE) $commandsM
    set clist(GRAPHUSE) $commandsF

    set whatuse [ GiD_Info Project ViewMode]
    if { $whatuse == "POSTUSE" } {
        set whatuse MESHUSE
    }

    $w delete 0 end
    set UnderLineList {}
    foreach i $nlist($whatuse) j $clist($whatuse) {
        set under [FindUnderChar i UnderLineList]
        $w add command -label $i -underline $under -command $j
    }
}


proc AddCutsToMenu { w basecommand} {
    #     global ViewMenuPriv

    #if { ![ GiD_Info postprocess get changed_geom_list]} { return}

    set cutlist [ GiD_Info postprocess get all_cuts]
    #    set what cuts2

    #    if { [ info exists ViewMenuPriv($what)]} {
    #        if { ![ string compare $ViewMenuPriv($what) $cutlist ]} {
    #            return
    #        }
    #    }

    #    set ViewMenuPriv($what) $cutlist

    $w delete 0 end
    set UnderLineList {}
    foreach i $cutlist {        
        regsub -all {_} $i { } text
        set under [FindUnderChar text UnderLineList]
        $w add command -label $text -underline $under -command "$basecommand $i"
    }
    if { [ llength $cutlist] > 1} {
        set text [_ "All cuts"]
        set under [FindUnderChar text UnderLineList]
        $w add command -label $text -underline $under -command "$basecommand ALL_CUTS"
    }
    if { $cutlist == ""} {
        $w add command -label [_ "There are no Cuts"] -state disabled
    }
}

proc AddGraphSetsToMenu { w basecommand all } {
    #    global ViewMenuPriv
    set graphsetlist [GiD_GraphSet list]   
    set exists_graphs 0
    foreach i $graphsetlist {
        if { [llength [GiD_Graph list $i]] } {
            set exists_graphs 1   
            break
        }
    }
    $w delete 0 end
    if { !$exists_graphs } {    
        $w add command -label [_ "There are no Graphs"] -state disabled
    } else {
        set UnderLineList {}
        set id_menu 0
        foreach i $graphsetlist {
            set graphlist [GiD_Graph list $i]
            if { [llength $graphlist] } {                                
                set m $w.m$id_menu
                set text $i
                set under [FindUnderChar text UnderLineList]                            
                $w add cascade -label $text -underline $under -menu $m
                if { [ winfo exists $m ]} {
                    $m delete 0 end
                } else {
                    menu $m
                }
                set UnderLineList2 {}
                foreach j $graphlist {
                    set text $j
                    set under [FindUnderChar text UnderLineList2]
                    $m add command -label $text -underline $under -command [list {*}$basecommand OneGraph $i $j]
                }
                if { $all } {
                    set text [_ "All graphs of %s" $i]
                    set under [FindUnderChar text UnderLineList]
                    $m add command -label $text -underline $under -command [list {*}$basecommand OneGraphSet $i ""]
                }
            }
            incr id_menu
        }
        if { $all } {
            set text [_ "All graphsets"]
            set under [FindUnderChar text UnderLineList]
            $w add command -label $text -underline $under -command [list {*}$basecommand AllGraphSets "" ""]
        }
    }
}

#the procedure ExportGraph could be deleted when activating GiD_GraphSet
proc ExportGraph { graph_name } {
    set lst_ext [ list [ list [_ "ASCII file"] ".grf"]]

    set hay_amelet 0
    if { [ info proc Amelet::WritePostGraphToFile] != ""} {
        set hay_amelet 1
    } else {
        # try it again
        SourcePlugins [file join $::GIDDEFAULT plugins]
        if { [ info proc Amelet::WritePostGraphToFile] != ""} {
            set hay_amelet 1
        }
    }
    if { $hay_amelet} {
        lappend lst_ext [ list "Amelet hdf5" ".h5"]
    }
    lappend lst_ext [ list [_ "All files"] "*"]

    set filename [ Browser-ramR graphfile write .gid [_ "Save Graph on"]... \
                       {} $lst_ext ".grf" ]
    if { $filename != ""} {
        set ext [ file extension $filename]
        switch $ext {
            .grf {
                GiD_Process Mescape Results Graphs WriteGraph $graph_name $filename
            }
            .txt {
                GiD_Process Mescape Results Graphs WriteGraph $graph_name $filename
            }
            .h5 {                
                Amelet::WritePostGraphToFile $filename $graph_name                
            }
            default {
                WarnWin [_ "Unknown extension %s" $ext]
            }
        }
    }
}

#what should be: AllGraphSets OneGraphSet OneGraph
proc ExportGraphSet { what graphset_name graph_name } {
    set lst_ext [ list [ list [_ "ASCII file"] ".grf"]]
    if { [ info proc Amelet::WritePostGraphToFile] != ""} {
        lappend lst_ext [ list "Amelet hdf5" ".h5"]
    }   
    lappend lst_ext [ list [_ "All files"] "*"]
    
    set filename [ Browser-ramR graphfile write .gid [_ "Save Graph on"]... {} $lst_ext ".grf" ]
    if { $filename != ""} {
        set ext [ file extension $filename]
        switch $ext {
            .grf -
            .txt {
                if { $what == "AllGraphSets" } {
                    GiD_Process Mescape Results Graphs WriteGraphSet $what $filename
                } elseif { $what == "OneGraphSet" } {
                    GiD_Process Mescape Results Graphs WriteGraphSet $what $graphset_name $filename
                } elseif { $what == "OneGraph" } {
                    GiD_Process Mescape Results Graphs WriteGraphSet $what $graphset_name $graph_name $filename    
                } else {
                    WarnWin [_ "Unexpected case %s" $what]
                }                       
            }
            .h5 {                               
                Amelet::WritePostGraphToFile $filename $graph_name             
            }
            default {
                WarnWin [_ "Unknown extension %s" $ext]
            }
        }
    }
}

proc AddGraphsToMenu { w basecommand all } {
    #    global ViewMenuPriv
    set graphlist [GiD_Graph list]   

    $w delete 0 end    
    if { ![llength $graphlist] } {
        $w add command -label [_ "There are no Graphs"] -state disabled
    } else {
        set UnderLineList {}
        foreach i $graphlist {
            set text $i
            set under [FindUnderChar text UnderLineList]
            $w add command -label $text -underline $under -command [list {*}$basecommand $i]
        }
        if { $all } {
            set text [_ "All"]
            set under [FindUnderChar text UnderLineList]
            $w add command -label $text -underline $under -command [list {*}$basecommand -All-]
        }
    }
}

proc AddLineGraphsToMenu { w basecommand { todos 0}} {
    set graphlist [ GiD_Info postprocess get all_line_graphs]

    $w delete 0 end
    set UnderLineList {}
    foreach i $graphlist {
        set text $i        
        set under [FindUnderChar text UnderLineList]
        $w add command -label $text -underline $under -command [list {*}$basecommand $i]
    }
    if { $todos && ( [ llength $graphlist] > 1) } {
        set text [_ "All"]
        set under [FindUnderChar text UnderLineList]
        $w add command -label $text -underline $under -command [list {*}$basecommand all]
    }
    if { $graphlist == ""} {
        $w add command -label [_ "There are no Graphs"] -state disabled
    }
}

proc AddPostGeomToMenu { w basecommand what color_opt color_labels} {
    global ViewMenuPriv

    set geomlist [ GiD_Info postprocess get all_$what]

    if { [ info exists ViewMenuPriv($w,$what)]} {
        if { ![ string compare $ViewMenuPriv($w,$what) $geomlist ]} {
            return
        }
    }

    $w delete 0 end

    if { $geomlist == ""} {
        $w add command -label [_ "There are no %s" $what] -state disabled
        return
    }

    set ViewMenuPriv($w,$what) $geomlist

    set id_menu 0
    set UnderLineList {}
    foreach i $geomlist {
        regsub -all {_} $i { } geomlabel
        if { $color_opt == ""} {
            set under [FindUnderChar geomlabel UnderLineList]
            $w add command -label $geomlabel -underline $under -command "$basecommand $i"
        } else {
            set under [FindUnderChar geomlabel UnderLineList]
            $w add cascade -label $geomlabel -underline $under -menu $w.m$id_menu
            if { [ winfo exists $w.m$id_menu ]} {
                $w.m$id_menu delete 0 end
            } else {
                menu $w.m$id_menu
            }
            set UnderLineList2 {}
            foreach j $color_opt k $color_labels {
                set under [FindUnderChar k UnderLineList2]
                $w.m$id_menu add command -label $k -underline $under -command "$basecommand $i $j ; GiD_Redraw"
            }
        }
        incr id_menu
    }
}

proc HardcopyToPrint { basecommand { prncomm ""} { parent ""}} {
    global tcl_platform GidPriv
    if { $::tcl_platform(platform) == "windows" } {
        GiD_Process 'Hardcopy Print
        return
    } else {
        if { ! [ info exists GidPriv(PrinterCommand)] } {
            set GidPriv(PrinterCommand) "lpr"
        }
        if { $prncomm != ""} {
            set GidPriv(PrinterCommand) $prncomm
        }
        set wname .gid.tempwinw
        if { ( $parent != "" ) && ( $parent != ".") } {
            set wname $parent.tempwinw
        }
        if { $prncomm != ""} {
            set pepe "ok"
        } else {
            set pepe [ tk_dialogEntryRAM $wname [_ "Enter value window"] \
                           [_ "Which command do you use to print files?"] gidquestionhead  "any" \
                           $GidPriv(PrinterCommand)]
        }
        # nos devuelve pepe entre comillas si hay mas de una palabra
        if { $pepe != "--CANCEL--"} {
            set tmp_filename [ file join [ GiD_Info Project TmpDirectory] \
                                   print_[ clock format [clock seconds] -format "%Y-%m-%d-%H:%M:%S"].ps]          
            eval GiD_Process $basecommand $tmp_filename
            if { [ file exists $tmp_filename] } {
                #para quitar las comillas de pepe si hay mas de una palabra,
                # pues exec toma pepe como nombre de programa ( con espacios y todo)
                set res [ eval [ join "exec $GidPriv(PrinterCommand) $tmp_filename"]]
                if { $res != ""} {
                    WarnWin $res
                } else {
                    WarnWin [_ "Job succesfully printed or queued."]
                }
                file delete -force $tmp_filename
            }
        }
        return
    }
}

proc AddImageCommandToMenu { menu img cmd { st normal}} {
    # if { $::tcl_platform(os) != "Darwin" } {
        if { $cmd != ""} {
            $menu add command -image $img -hidemargin 1 -state $st -command $cmd
        } else {
            $menu add command -image $img -hidemargin 1 -state $st
        }
    # } else {
    #     if { $cmd != ""} {
    #         $menu add command -label [ file root [ file tail [ $img cget -file]]] -hidemargin 1 -state $st -command $cmd
    #     } else {
    #         $menu add command -label [ file root [ file tail [ $img cget -file]]] -hidemargin 1 -state $st
    #     }
    # }
    return cm
}

proc AddBitmapsToMenu { w basecommand args } {
    set whatuse [ GiD_Info Project ViewMode]
    #     set newstate $whatuse
    #     set thisproc $w
    #     if { [info exists ::MenuPrevState($thisproc)] } {
    #         if { $::MenuPrevState($thisproc) == $newstate && [$w index end] != "none" } {
    #             return
    #         }
    #     }
    #     set ::MenuPrevState($thisproc) $newstate

    set geomlist [ GetGeometryImageFiles]
    set lst_geom_labels [ list Points Lines Surfaces Volumes]
    set lst_geom_labels [ lrange $lst_geom_labels 0 [ expr [ llength $geomlist] - 1]]

    set meshlist {node.png element.png}
    set lst_mesh_labels [ list Nodes Elements]

    set postlist {node.png element.png resultonview.png}
    set lst_post_labels [ list Nodes Elements ResultOnView]

    set graphlist {node.png resultonview.png}
    set lst_graph_labels [ list Nodes ResultOnView]

    if { [llength $args] == 2 } {
        set geomlist [lindex $args 0]
        set meshlist [lindex $args 1]
    }

    $w delete 0 end

    switch $whatuse {
        GEOMETRYUSE {
            foreach i $geomlist t $lst_geom_labels {
                set command $t
                AddImageCommandToMenu $w [ gid_themes::GetImage $i toolbar] "$basecommand $command"
                # $w add command -image [ gid_themes::GetImage $i toolbar] -command "$basecommand $command" -hidemargin 1
            }
        }
        MESHUSE {
            foreach i $meshlist t $lst_mesh_labels {
                set command $t
                AddImageCommandToMenu $w [ gid_themes::GetImage $i toolbar] "$basecommand $command"
                # $w add command -image [ gid_themes::GetImage $i toolbar] -command "$basecommand $command" -hidemargin 1
            }
        }
        POSTUSE {
            if { $args == "list"} {
                set postlist $meshlist
                set lst_post_labels $lst_mesh_labels
            }
            foreach i $postlist t $lst_post_labels {
                set command $t
                AddImageCommandToMenu $w [ gid_themes::GetImage $i toolbar] "$basecommand $command"
                # $w add command -image [ gid_themes::GetImage $i toolbar] -command "$basecommand $command" -hidemargin 1
            }
        }
        GRAPHUSE {
            foreach i $graphlist t $lst_graph_labels {
                set command $t
                AddImageCommandToMenu $w [ gid_themes::GetImage $i toolbar] "$basecommand $command"
                # $w add command -image [ gid_themes::GetImage $i toolbar] -command "$basecommand $command" -hidemargin 1
            }
        }
    }
}

proc AddBitmapsDeleteMenu { w } {
    set whatuse [ GiD_Info Project ViewMode]
    #     set newstate $whatuse
    #     set thisproc $w
    #     if { [info exists ::MenuPrevState($thisproc)] } {
    #         if { $::MenuPrevState($thisproc) == $newstate && [$w index end] != "none" } {
    #             return
    #         }
    #     }
    #     set ::MenuPrevState($thisproc) $newstate

    $w delete 0 end
    switch $whatuse {
        GEOMETRYUSE {
            set commoncommand {Geometry Delete}
            set images [ GetGeometryImageFiles]
            lappend images {*}{alltypes.png}
            set commands [ GetGeometryCommands]
            lappend commands {AllTypes}
        }
        MESHUSE {
            set commoncommand {Meshing EditMesh}
            set images {element.png node.png}
            set commands {DeleteElems DeleteNodes}
        }
        POSTUSE -
        GRAPHUSE {
            set images {}
            set commands {}
        }
        default {
            set images {}
            set commands {}
        }
    }
    foreach image $images command $commands {
        AddImageCommandToMenu $w [ gid_themes::GetImage $image toolbar] [list GiD_Process Mescape {*}$commoncommand $command]
        # $w add command -image [ gid_themes::GetImage $image] -command "GiD_Process Mescape $command" -hidemargin 1
    }
}

proc AddBitmapsToCamera { w basecommand args} {
    $w delete 0 end
    set hardcopylist "eps.png ps.png bmp.png gif.png jpeg.png png.png tga.png tiff.png vrml.png"
    foreach i $hardcopylist {
        set command [file rootname $i]
        #AddImageCommandToMenu $w [ gid_themes::GetImage $i menu] "$basecommand $command"
        set text " $command image"
        $w add command -label $text -image [ gid_themes::GetImage $i menu] -command "$basecommand $command" -compound left        
    }
    $w add command -label [_ "PDF file"] -image [ gid_themes::GetImage pdf.png menu] -command PrintToPdf -compound left
}

proc CambiaImagen { w toca command} {
    $w configure -image [ gid_themes::GetImage $toca toolbar]
    eval $command
}

proc AddBitmapsToDisplayStyle { w basecommand args} {
    global GidPriv
    set idx [ string last "." $w]
    if { $idx != -1 } {
        set GidPriv(PostDisplayStyleBitmap) [ string range $w 0 [ expr $idx - 1]]
    } else {
        set GidPriv(PostDisplayStyleBitmap) ""
    }

    set displaystylelist "boundaries hiddenbound alllines hiddenlines body bodybound bodylines point pointsbound"

    set var [ string tolower [ GiD_Info postprocess get cur_display_style]]
    regsub {_} $var {} var

    $w delete 0 end
    foreach i $displaystylelist {
        if { $i != $var} {
            AddImageCommandToMenu $w [ gid_themes::GetImage $i.png toolbar] [ list CambiaImagen $GidPriv(PostDisplayStyleBitmap) $i.png "$basecommand $i"]           
        } else {
            AddImageCommandToMenu $w [ gid_themes::GetImage $i.png toolbar] "" disabled            
        }
    }
}

proc AddBitmapsToCullStyle { w basecommand args} {
    global GidPriv
    set idx [ string last "." $w]
    if { $idx != -1 } {
        set GidPriv(PostDisplayCullBitmap) [ string range $w 0 [ expr $idx - 1]]
    } else {
        set GidPriv(PostDisplayCullBitmap) ""
    }
    set cullstylelist "none frontfaces backfaces"
    set var [string tolower [ GiD_Info postprocess get cur_display_culling]]

    $w delete 0 end
    foreach i $cullstylelist {
        if { $i != $var} {
            AddImageCommandToMenu $w [ gid_themes::GetImage cull$i.png toolbar] [list CambiaImagen $GidPriv(PostDisplayCullBitmap) cull$i.png "$basecommand $i"]
            # $w add command -image [ gid_themes::GetImage cull$i.png toolbar] \
                #         -command [list CambiaImagen $GidPriv(PostDisplayCullBitmap) cull$i.png "$basecommand $i"] \
                #                 -hidemargin 1
        } else {
            AddImageCommandToMenu $w [ gid_themes::GetImage cull$i.png toolbar] "" disabled
            # $w add command -image [ gid_themes::GetImage cull$i.png toolbar] -state disabled -hidemargin 1
        }
    }
}

proc AddBitmapsToCutDivide { w basecommand que args} {
    set displaystylelist "cut2p.png cut3p.png"
    $w delete 0 end
    AddImageCommandToMenu $w [ gid_themes::GetImage cut2p.png toolbar] "$basecommand $que"
    # $w add command -image [ gid_themes::GetImage cut2p.png toolbar] -command "$basecommand $que" -hidemargin 1
    AddImageCommandToMenu $w [ gid_themes::GetImage cut3p.png toolbar] "$basecommand $que ThreePoints"
    # $w add command -image [ gid_themes::GetImage cut3p.png toolbar] -command "$basecommand $que ThreePoints" -hidemargin 1
    if { $que == "CutPlane"} {
        AddImageCommandToMenu $w [ gid_themes::GetImage cut_succesion.png toolbar] "$basecommand Succesion"
        # $w add command -image [ gid_themes::GetImage cut_succesion.png toolbar] -command "$basecommand Succesion" -hidemargin 1
    }
}

proc AddBitmapsToMeshSetCut { w basecommand que args} {
    global GIDDEFAULT GidPriv

    $w delete 0 end
    set UnderLineList {}
    set all_que [ GiD_Info postprocess get all_$que]
    if { $all_que == ""} {
        $w add command -label [_ "There are no %s" $que] -state disabled
        return
    }
    if { [ llength $all_que] < 17 } {
        set all_colors [ GiD_Info postprocess get all_$que\_colors]
        set que_on [ GiD_Info postprocess get cur_$que]
        set jc 0
        foreach j $all_que {
            regsub {_} $j { } lab
            set under [FindUnderChar lab UnderLineList]
            set col_set [ lindex $all_colors $jc]
            # es una lista { ambient diffuse specular shininess}
            set col_diffuse [ lindex $col_set 1]
            if { [lsearch $que_on $j] != -1 } {
                $w add command -image [gid_themes::GetImage $que\_on_OneColor.png large_icons] -background $col_diffuse \
                    -command "$basecommand $que $j escape" -label $lab -underline $under \
                    -hidemargin 1
            } else {
                $w add command -image [gid_themes::GetImage $que\_OneColor.png large_icons] -background $col_diffuse \
                    -command "$basecommand $que $j escape" -label $lab -underline $under \
                    -hidemargin 1
            }
            incr jc            
        }
        if { [ llength $all_que] > 1} {
            set lab [_ "All On"]
            set under [FindUnderChar lab UnderLineList]
            $w add command -label $lab -underline $under -command "$basecommand $que all_$que escape" \
                -hidemargin 1
            set lab [_ "All Off"]
            set under [FindUnderChar lab UnderLineList]
            $w add command -label $lab -underline $under -command "$basecommand $que no_$que escape" \
                -hidemargin 1
        }
    } else {
        set lab [_ "Style Window"]
        set under [FindUnderChar lab UnderLineList]
        $w add command -label $lab -underline $under -command " \
            set GidPriv(WinList_volumes) 0; \
            set GidPriv(WinList_surfaces) 0; \
            set GidPriv(WinList_cuts) 0; \
            set GidPriv(WinList_$que) 1; \
            PostDisplay" \
            -hidemargin 1
    }
}

#to get the full keyword from its initial letter
proc GetPostMeshTypeFromInitialLetter { letter } {        
    if { $letter == "V" } {
        set type VolumeSets
    } elseif { $letter == "S" } {
        set type SurfaceSets
    } elseif { $letter == "C" } {
        set type CutSets
    } else {
        #unexpected type
        set type $letter
    }
    return $type
}

#return the 'internal decorated name' removing spaces from the 'true name'
#in future versions the true name must be allowed everywhere without do dark tricks...
proc GetPostDecoratedName { name } {
    regsub -all { } $name {_} decorated_name
    return $decorated_name
}

proc AddMeshSetCutMenu { w basecommand que args} {
    global GIDDEFAULT GidPriv

    $w delete 0 end
    set UnderLineList {}
    set type [GetPostMeshTypeFromInitialLetter [string toupper [string index $que 0]]]
    set all_que [ GiD_Info postprocess get all_$que]
    if { $all_que == ""} {
        $w add command -label [_ "There are no %s" $que] -state disabled
        return
    }

    set all_colors [ GiD_Info postprocess get all_$que\_colors]
    set jc 0
    foreach j $all_que {
        regsub {_} $j { } lab
        set under [FindUnderChar lab UnderLineList]
        set col_set [ lindex $all_colors $jc]
        # es una lista { ambient diffuse specular shininess}
        set col_diffuse [ lindex $col_set 1]
        
        $w add command -background $col_diffuse -command [list {*}$basecommand $type $j] -label $lab -underline $under
        set jc [ expr $jc + 1]
    }
    if { [ llength $all_que] > 1} {
        set lab [_ "All"]
        set under [FindUnderChar lab UnderLineList]
        $w add command -label $lab -underline $under -command [list {*}$basecommand $type all_$que]
    }
}

proc ToDoWhenChoosingStep { comm } {
    global ViewMenuPriv

    eval [ concat $comm]
    set ViewMenuPriv(DirtyMenus) 1
}

#proc ListCurrentResults { } {
#
#    set cur_anal [ GiD_Info postprocess get cur_analysis]
#
#    set cur_step [ GiD_Info postprocess get cur_step $cur_anal]
#
#    set cur_res [ GiD_Info postprocess get cur_result]
#
#    if { $cur_res == ""} {
#         set info_res [_ "First select any result representation, please"]
#         WarnWin $info_res
#    } else {
#         set info_res [ GiD_Info list_entities results $cur_anal $cur_step $cur_res 1:1 196:197 ]
#         #WarnWinText $info_res
#         foreach res_val $info_res {
#             WarnWinText "[ llength $res_val] -> $res_val"
#         }
#    }
#}

proc AddAnalysisStepsToMenu { w args} {
    global ViewMenuPriv GidPriv RMenuRPriv

    # registramos los menus
    # if { [ esMac]} {
    #         registerPostAnalysisStepMenu $w
    #         $w configure -postcommand ""
    # }

    rmenuinit
    set all_anal [lsort -dictionary [ GiD_Info postprocess get all_analysis]]
    # set all_anal [ GiD_Info postprocess get all_analysis]

    #if { ![esMac]}  # en mac solo nos llaman cuando hay que rehacer los menus
    if { 1} { # en mac solo nos llaman cuando hay que rehacer los menus
        if { ![ GiD_Info postprocess get changed_analysis_step] && \
                 ![ GiD_Info postprocess get changed_results_view] && \
                 [ info exists ViewMenuPriv($w,all_anal)] && \
                 ( $ViewMenuPriv($w,all_anal) == $all_anal) } {
            set igual 1
            foreach i $all_anal {
                if { [ info exists ViewMenuPriv($w,$i)]} {
                    if { [ catch { set all_step [ GiD_Info postprocess get all_steps $i]}]} {
                        set all_step {}
                    }
                    if { $ViewMenuPriv($w,$i) != $all_step} {
                        set igual 0
                        break
                    }
                } else {
                    set igual 0
                    break
                }
            }
            if { $igual} {
                return
            }
        }
    }

    $w delete 0 end

    set ViewMenuPriv($w,all_anal) $all_anal

    # get current result visualization
    set cur_anal [ GiD_Info postprocess get cur_analysis]
    set cur_step [ GiD_Info postprocess get cur_step $cur_anal]
    set cur_res [ GiD_Info postprocess get cur_result]
    set cur_res_view  [ GiD_Info postprocess get cur_results_view]
    set cur_comp [ GiD_Info postprocess get cur_component]

    regsub -all {_} $cur_res_view {} pp
    set restcommand "escape escape escape escape results $pp $cur_res $cur_comp"
    set no_res_command "escape escape escape escape results Geometry NoResults"
    set no_def_command "Geometry Original escape escape escape escape View Label Off"
    set iso_hecho 0
    switch $cur_res_view {
        "Iso_Surfaces" {
            set values [ GiD_Info postprocess get iso_cur_result_values]
            set values [ lindex $values 0]
            set lstVal [lindex $values 1]
            set restcommand "$pp exact $cur_res $cur_comp [lindex $values 0] {*}$lstVal"
            set iso_hecho 1
        }
        "Stream_Lines" {
            set restcommand ""
        }
        "No_Result" {
            set restcommand ""
        }
        "Display_Vectors" {
            set value [ GiD_Info postprocess get cur_vector_factor $cur_res_view \
                            $cur_res $cur_anal $cur_step ]
            set restcommand "$restcommand $value escape"
        }
        "Contour_Fill" {
            if { "[ string tolower [ GiD_Set postresoverres]]" == "yes"} {
                set restcommand "$no_res_command $restcommand"
            }
        }
        default {
        }
    }

    # may be together with an iso-surface
    set iso_cmd ""
    set iso_res ""
    if { !$iso_hecho} {
        set iso_values [ lindex [ GiD_Info postprocess get iso_cur_result_values] 0]
        # set iso_values [ lindex $iso_values 0]
        if { [ llength $iso_values] != 0} {
            set iso_res [ lindex $GidPriv(PostAnimateIsoSurfaces) 2]
            set lstVal [lindex $iso_values 1]
            set iso_cmd "escape escape escape escape results IsoSurfaces Exact [ lindex $iso_res 0] [ lindex $iso_res 1]"
            set iso_cmd "$iso_cmd [ lindex $iso_values 0] {*}$lstVal"
        }
    }

    # check for deformation ...
    set is_deformed 0
    set defor_command ""
    set cur_defor ""
    set mainst [ GiD_Info postprocess get main_geom_state]
    if { $mainst == "Deformed" } {
	# if deformation analysis and step are the same as current ones, then
	# when the user changes analysis and step, we'll actualize deformation too
	set cur_defor_anal [ GiD_Info postprocess get main_geom_cur_anal]
	set cur_defor_step [ GiD_Info postprocess get main_geom_cur_step]
	if { ( $cur_defor_anal == $cur_anal) && ( $cur_defor_step == $cur_step)} {
	    set is_deformed 1
	    set cur_defor [ GiD_Info postprocess get main_geom_cur_deform]
	    set cur_defor_factor [GiD_Info postprocess get main_geom_cur_factor]
	    set defor_command "Mescape results Geometry Original" 
	    append defor_command " Geometry Deformation $cur_defor $cur_defor_factor escape"
	}
    }

    set basecommand "GidUtils::DisableGraphics; GiD_Process Mescape results analysissel"

    if { $all_anal == ""} {
        $w add command -label [_ "Please load a MODEL first"] -state disabled
        return
    }

    set UnderLineList {}
    foreach i $all_anal {
        set menu_txt [TranslateResultName $i]        
        set under [FindUnderChar menu_txt UnderLineList]

        regsub -all {\.} $i {_} menu_name

        set img $GidPriv(VerifNoImage)
        if { $cur_anal == $i } {
            set img $GidPriv(VerifImage)
        }
        $w add cascade -label $menu_txt -underline $under -menu $w.m$menu_name  -image $img -compound left

        # set all_step [ GiD_Info postprocess get all_steps $i]
        if { [ catch { set all_step [ GiD_Info postprocess get all_steps $i]}]} {
            set all_step {}
        }
        set ViewMenuPriv($w,$i) $all_step
        set cur_step [ GiD_Info postprocess get cur_step $i]
        if { [ winfo exists $w.m$menu_name ]} {
            $w.m$menu_name delete 0 end
        } else {
            menu $w.m$menu_name
        }

        set words ""

        set entrada_ventana 0
        if { ( [ llength $all_step] > $RMenuRPriv(MaxAbsolute)) && ( $RMenuRPriv(MaxAbsolute) > 2)} {
            set all_step [ lrange $all_step 0 [ expr $RMenuRPriv(MaxAbsolute) - 2]]
            set entrada_ventana 1
        }

        foreach j $all_step {
            set all_res [ GiD_Info postprocess get results_list $cur_res_view $i $j]
            set all_defor_res [ GiD_Info postprocess get main_geom_all_deform $i $j]
	    if { [ lsearch $all_defor_res $cur_defor] == -1} {
		set cmds $no_def_command
	    } else {
		set cmds $defor_command
	    }
            if { [ lsearch $all_res $cur_res] == -1} {
                append cmds " $no_res_command"
            } else {
                append cmds " $restcommand"
	    }
            if { ( $iso_res != "") && ( [ lsearch $all_res [ lindex $iso_res 0]] != -1)} {
                set cmds "$iso_cmd; GiD_Process $cmds"
            }
            append cmds "; GidUtils::EnableGraphics; GiD_Process 'Redraw"
            if { [ esMac]} {
                append cmds "; doUpdateMenusMac;"
            }
            if { ( $cur_anal != $i) || ( $cur_step != $j) } {
                lappend words [ list $j "$basecommand $i $j $cmds"]
            } else {
                lappend words [ list $j "$basecommand $i $j $cmds" check]
            }

            #lappend words [ list $j "$basecommand $i $j" check]
            #$w.m$menu_name add command -label $j -command "$basecommand $i $j"
        }
        rmenuconf $w.m$menu_name $words

        if { $entrada_ventana} {
            $w.m$menu_name add separator
            $w.m$menu_name add command -label ...[_ "More"]... -command PostGeom::Create
        }
    }
}

proc ResultsNoStep { } {
    WarnWin [_ "Please select a Step first"]
}

proc GetResultMenuFromPath { w name img} {
    global GidPriv

    if { ![ regexp {^/?/?(.*)//(.*?)$} $name dum path res_name]} {
        #WarnWinText "nothing to do"
        return $w
    }
    regsub -all { } $path {_} nname
    #WarnWinText "doing '$name' $path + $nname"
    set wm $w
    #set nname [ split $nname /]
    regsub -all {//} $nname { } nname
    #set menu_name ""

    #WarnWinText "Exists $w ? [ winfo exists $w]"
    # WarnWinText "[ llength $nname] - $nname"
    # en windows parece haber un nivel de anidamiento maximo de 10 para el top menu bar
    # 8 del path del resultado + 1 del resultado + 1 del componente del resultado
    if { [ llength $nname] >= 7} {
        return ""
    }
    foreach subm $nname {
        if { $subm == ""} { continue}        
        set txt [TranslateResultName $subm]

        regsub -all {\.} $subm {_} menu_name
        if { [ catch { $wm index $txt}] || ( [ $wm index $txt] == "none")} {
            #WarnWinText "$wm Adding cascade m$menu_name LABEL: $txt"
            if { $img != ""} {
                $wm add cascade -label $txt -menu $wm.m$menu_name \
                    -image $img -compound left
            } else {
                $wm add cascade -label $txt -menu $wm.m$menu_name
            }
            if { [ winfo exists $wm.m$menu_name ]} {
                $wm.m$menu_name delete 0 end
            } else {
                menu $wm.m$menu_name
            }
        } else {
            #WarnWinText "[winfo class $wm] $wm index '$txt' [ $wm index [ list $txt]]"
        }
        #WarnWinText "set wm $w.m$menu_name"
        #WarnWinText "set wm $wm.m$menu_name"
        set wm $wm.m$menu_name
    }
    return $wm
}

proc AutomaticConvertCutToMesh { w idx} {
    # WarnWin "$w - [ winfo parent $w]"
    set nuevo 1
    if { [ GiD_Set PostCutToMesh]} {
        set nuevo 0
    }
    GiD_Process escape escape escape escape utilities variables PostCutToMesh $nuevo
    GiD_Process escape escape escape escape 

    $w entryconfigure $idx -image [ IconoAutomaticConvertCutToMesh] -compound left
}

proc IconoAutomaticConvertCutToMesh {} {
    global GidPriv
    set img $GidPriv(VerifNoImage)
    if { [ GiD_Set PostCutToMesh]} {
        set img $GidPriv(VerifImage)
    }
    return $img
}

proc doDeformationWithScale { w basecommand args} {
    # set basecommand [ lrange $basecommand 1 end]
    set resName [ lindex $args 0]
    # set compName [ lindex $args 1]

    # get previous deformation scale for the result...
    # check if user want only change factor of actual deformation:
    set previousFactor ""
    if { [ GiD_Info postprocess get main_geom_state] == "Deformed" } {
        set current_deformation_result [ GiD_Info postprocess get main_geom_cur_deform]
        if { "$current_deformation_result" == "$resName"} {
            set previousFactor [ GiD_Info postprocess get main_geom_cur_factor]
        }
    }

    if { "$previousFactor" != "" } {
        # WarnWinText "doDeformationWithScale: $w---$basecommand---$args"
        {*}$basecommand $resName $previousFactor escape escape escape escape
    } else {
        {*}$basecommand $resName escape escape escape escape
    }
    set an [ GiD_Info postprocess get main_geom_cur_anal]
    set st [ GiD_Info postprocess get main_geom_cur_step]

    set suggestedFactor [ GiD_Info postprocess get main_geom_factor $an $st $resName]
    if { $suggestedFactor <= 0 } {
            set suggestedFactor 1
    }

    # WarnWinText $suggestedFactor
    # set w .gid
    set x [ winfo x $w]
    set y [ winfo y $w]
    set wi [ winfo width $w]
    set w [ winfo parent $w]
    set xo $x
    set yo $y
    while { $w != "" } {
        set xp [ winfo x $w]
        set yp [ winfo y $w]
        set x [ expr $x + $xp]
        set y [ expr $y + $yp + 16]
        if { "[ winfo class $w]" == "Toplevel"} {
            break
        }
        set w [ winfo parent $w]
    }
    if { $::tcl_platform(os) != "Linux" } {
        set x [expr $x + $wi + 16]
        set y [expr $y]
    } else {
        set x [ expr $xo + 16]
        set y [ expr $yo]
    }

    #WarnWin "$w = +$x+$y"

    if { [ winfo exists .wPostDefScale]} {
        destroy .wPostDefScale
    }
    toplevel .wPostDefScale
    wm geometry .wPostDefScale +$x+$y
    wm title .wPostDefScale [_ "Deformation scale"]
    wm minsize .wPostDefScale 1 1
    wm overrideredirect .wPostDefScale 1

    ttk::frame .wPostDefScale.f -style ridge.TFrame -borderwidth 2

    proc updateDeformation { comm res fact} {
        set old [ .central.s disable warnline]
        .central.s disable warnline 1
        {*}$comm $res $fact
        .central.s disable warnline $old
    }
    # WarnWinText "from: 0 to [ expr $suggestedFactor * 10]"
    set from_val 0
    # set to_val [ expr $suggestedFactor * 100.0]
    set to_val [ expr $suggestedFactor * 20.0]
    set resol_val [ expr $suggestedFactor * 0.1]
    # ttk::scale .wPostDefScale.f.defScale -orient horizontal -from 0 -to [ expr $suggestedFactor * 10] \
        #         -value $suggestedFactor -length 200 \
        #         -command "updateDeformation [ list $basecommand] $resName"
    gidscale .wPostDefScale.f.defScale -orient horizontal \
        -from $from_val -to $to_val -resolution $resol_val \
        -showbuttons 1 -symbolbuttons "< >" \
        -command "updateDeformation [ list $basecommand] $resName"
        
    .wPostDefScale.f.defScale set $suggestedFactor 
    
    ttk::button .wPostDefScale.f.b1 -text 1x -width 2 -command \
        " updateDeformation [ list $basecommand] $resName 1.0
          .wPostDefScale.f.defScale set 1.0 "
    ttk::button .wPostDefScale.f.b2 -image [gid_themes::GetImage document-close-2.png] -command "destroy .wPostDefScale"
    bind .wPostDefScale <Return> "destroy .wPostDefScale"
    bind .wPostDefScale <Escape> "destroy .wPostDefScale"
    bind .wPostDefScale <1> "+PostCloseFLoatingWindow %W %x %y"

    grid .wPostDefScale.f.defScale -padx 2 -pady 1 -sticky news
    grid .wPostDefScale.f.b1 -column 1 -row 0 -padx 1 -pady 1
    grid .wPostDefScale.f.b2 -column 2 -row 0 -padx 1 -pady 1
    grid rowconfigure .wPostDefScale.f 0 -weight 1
    grid columnconfigure .wPostDefScale.f 0 -weight 1
    grid .wPostDefScale.f -sticky news
    grid rowconfigure .wPostDefScale 0 -weight 1
    grid columnconfigure .wPostDefScale 0 -weight 1
    focus -force .wPostDefScale.f.defScale
    update
    # make slider a bit bigger
    set reqh [ winfo reqheight .wPostDefScale]
    wm geometry .wPostDefScale 250x$reqh
    grab .wPostDefScale
    
}

set ::debugCFILL 0
proc DebugCFILL { que_res msg} {
    if { $::debugCFILL && ( [ string first "Contour_Fill" $que_res] != -1)} {
        WarnWinText "$que_res - $msg"
    }    
}

proc AddResultsToMenu { w basecommand que_res { sub 0}} {
    global ViewMenuPriv GidPriv RMenuRPriv

    # registramos los menus
    # if { [ esMac]} {
    #         registerPostResultsMenu $w $basecommand $que_res $sub
    #         $w configure -postcommand ""
    # }
    #after 10000 [ list $w configure -postcommand "AddResultsToMenu $w $basecommand $que_res $sub"]
    
    # defineDummyResults $w

    #degug MAC

    rmenuinit
    set UnderLineList {}
    set all_anal [lsort -dictionary [ GiD_Info postprocess get all_analysis]]
    # set all_anal [ GiD_Info postprocess get all_analysis]
    if { $all_anal == ""} {
        set msg [_ "Please load a MODEL first"]
    } else {
        set msg [_ "Please select a STEP first"]
    }
    set cur_anal [ GiD_Info postprocess get cur_analysis]
    if { $cur_anal == ""} {
        $w delete 0 end
        $w add command -label $msg -state disabled
        return
    }

    set cur_step [ GiD_Info postprocess get cur_step $cur_anal]
    if { $cur_step == ""} {
        $w add command -label [_ "Please select a STEP first"] -state disabled
        $w delete 0 end
        return
    }

    set all_res {}
    set all_smooth_res {}
    if { $que_res != "Deformation" } {
        # at the moment only Smooth Contour Fill and Smooth Contour Lines
        set add_smooth 0
        if { ( "$que_res" == "Contour_Fill") || ( "$que_res" == "Contour_Lines") ||
             ( "$que_res" == "Iso_Surfaces") || ( "$que_res" == "Result_Surface") ||
             ( "$que_res" == "Line_Thickness") } {
            set add_smooth 1
        }
        if { $add_smooth && ( [ string first Smooth_ $que_res] != 0)} {
            # $que_res does not begin with "Smooth_XXX"
            set all_smooth_res [ lsort -dictionary [ GiD_Info postprocess get cur_results_list Smooth_$que_res]]
        }
        set all_res [ lsort -dictionary [ GiD_Info postprocess get cur_results_list $que_res]]
    } else {
        set all_res [ lsort -dictionary [ GiD_Info postprocess get show_geom_all_deform $cur_anal \
                                              $cur_step]]
    }
    if { $all_res == ""} {
        $w delete 0 end
        $w add command -label [_ "No useful results found"] -state disabled
        return
    }

    ### if { ![ info exists ViewMenuPriv($w,OldResView)]} {
    ###         set ViewMenuPriv($w,OldResView) ""
    ### }

    set cur_res_view [ GiD_Info postprocess get cur_results_view]
    if { $que_res == "Deformation" } {
        # mas que nada para que cree los menus
        if { [ GiD_Info postprocess get main_geom_state] == "Deformed"} {
            set cur_res_view $que_res
        }
    }

    set add_smooth_submenu 0
    if { [ llength $all_smooth_res] > 0} {
        set add_smooth_submenu 1
    }

    # check if menu needs to be rebuild:
    # if variable exists and is != rebuild, then return ( no need to rebuild)
    if { ![ info exists ::GiDPostResultsMenu(Menu,$que_res,$w)]} {
        DebugCFILL $que_res "::GiDPostResultsMenu(Menu,$que_res,$w) does NOT exists"
    } else {
        DebugCFILL $que_res "::GiDPostResultsMenu(Menu,$que_res,$w) does exists"
        DebugCFILL $que_res "string equal $::GiDPostResultsMenu(Menu,$que_res,$w) rebuild"
    }
    if { [ info exists ::GiDPostResultsMenu(Menu,$que_res,$w)] && ( [ string equal $::GiDPostResultsMenu(Menu,$que_res,$w) "rebuild"] == 0)} {
        return
    }

    ### ## miramos si el menu que ya tenemos aun es valido
    ### #if { ![esMac]}  # en mac solo nos llaman cuando hay que rehacer los menus
    ### if { 1} { # en mac solo nos llaman cuando hay que rehacer los menus
    ###         # para el conyazo de windows, que es mas lento que una tortuga con reuma
    ###         if { ( $cur_anal != "") && ( $cur_step != "") && ( $all_res != "") } {
    ###             if { [ info exists ViewMenuPriv($w,$que_res/$sub/analstep)] && \
    ###                      [ info exists ViewMenuPriv($w,$que_res/$sub/allres)] } {
    ###                 if { ![ string compare $ViewMenuPriv($w,$que_res/$sub/analstep) "$cur_anal $cur_step" ] && \
    ###                          ![ string compare $ViewMenuPriv($w,$que_res/$sub/allres) $all_res] } {
    ###                     # esto para actualizar el checkbox del resultado elegido
    ###                     DebugCFILL $que_res "checking result selection ( cur_res_view != que_res) && ( ViewMenuPriv($w,OldResView) != que_res)"
    ###                     DebugCFILL $que_res "checking result selection ( $cur_res_view != $que_res) && ( $ViewMenuPriv($w,OldResView) != $que_res)"
    ###                     set wsmooth ""
    ###                     if { $add_smooth_submenu && [ info exists ::ViewMenuPriv($w,SmoothSubMenu)]} {
    ###                         set wsmooth $::ViewMenuPriv($w,SmoothSubMenu)
    ###                         DebugCFILL $que_res "checking result selection ( $cur_res_view != Smooth_$que_res) && ( $ViewMenuPriv($wsmooth,OldResView) != Smooth_$que_res)"
    ###                     }
    ###                     # if we have smooth result sub-menu, checkit too
    ###                     if { ( $cur_res_view != $que_res) && ( $ViewMenuPriv($w,OldResView) != $que_res) && \
    ###                          ( !$add_smooth_submenu || ( $cur_res_view != "Smooth_$que_res") && ( $wsmooth != "") && ( $ViewMenuPriv($wsmooth,OldResView) != "Smooth_$que_res"))} {
    ###                         # ahora a mirar los componentes
    ###                         set igual 1
    ###                         foreach i $all_res {
    ###                             set all_comp [ GiD_Info postprocess get components_list $que_res $i $cur_anal $cur_step ]
    ###                             regsub -all { } $i {_} idx
    ###                             if { [ info exists ViewMenuPriv($w,$que_res/$sub/$idx)] } {
    ###                                 if { [ string compare $ViewMenuPriv($w,$que_res/$sub/$idx) $all_comp]} {
    ###                                     # no son iguales
    ###                                     set igual 0
    ###                                     break
    ###                                 }
    ###                             } else {
    ###                                 # no son iguales
    ###                                 set igual 0
    ###                                 break
    ###                             }
    ###                         }
    ###                         if { $igual} {
    ###                             DebugCFILL $que_res "$w ( exists = [ winfo exist $w]) menus iguales, return"
    ###                             # if { [ winfo exist $w]} {
    ###                             #         DebugCFILL $que_res "$w last = [ $w index last] = [ $w entrycget last -label]"
    ###                             # }
    ###                             # as this menu can be a sub-menu from another result menu ( Contour --> Smooth --> ...)
    ###                             # check also if it exists and is full
    ###                             if { [ winfo exist $w] && ( [ $w index last] != "none")} {
    ###                                 return
    ###                             }
    ###                         } else {
    ###                             DebugCFILL $que_res "$w ( exists = [ winfo exist $w]) menus NO iguales"
    ###                             # if { [ winfo exist $w]} {
    ###                             #         DebugCFILL $que_res "$w last = [ $w index last] = [ $w entrycget last -label]"
    ###                             # }
    ###                         }
    ###                     }
    ###                 }
    ###             }
    ###         }
    ### }

    ### # para ahorrarnos construir cosas
    ### set ViewMenuPriv($w,$que_res/$sub/analstep) "$cur_anal $cur_step"
    ### set ViewMenuPriv($w,$que_res/$sub/allres) $all_res
    ### foreach i $all_res {
    ###         set all_comp [ GiD_Info postprocess get components_list $que_res $i $cur_anal $cur_step ]
    ###         regsub -all { } $i {_} idx
    ###         set ViewMenuPriv($w,$que_res/$sub/$idx) $all_comp
    ### }

    set UnderLineList {}
    if { $que_res != "Deformation" } {
        set cur_res [ GiD_Info postprocess get cur_result]
        set cur_comp [ GiD_Info postprocess get cur_component]
    } else {
        set cur_res [ GiD_Info postprocess get main_geom_cur_deform]
        set cur_comp ""
        if { [ string first bitmaps $w] != -1} {
            # si viene de la barra de iconos, hacemos una deformacion interactiva
            set basecommand "doDeformationWithScale $w [ list $basecommand]"
        }
    }

    set entrada_ventana 0
    if { [ llength $all_res] > $RMenuRPriv(MaxNumCol)} {
        set all_res [ lrange $all_res 0 [ expr $RMenuRPriv(MaxNumCol) - 2]]
        set entrada_ventana 1
    }
    DebugCFILL $que_res "$cur_res <------------------------------------------"
    if { [ info exists entrara_ya_anyadida]} {
        unset entrara_ya_anyadida
    }

    #degug MAC
    DebugCFILL $que_res "$w deleted"
    
    $w delete 0 end

    if { $que_res == "Node_Trace"} {
        # add followNodes entry
        set txt "Follow nodes"
        set postcmd ""
        set under [ FindUnderChar txt UnderLineList]
        $w add command -label $txt -underline $under \
            -command "$basecommand followNodes $postcmd"
    }

    foreach i $all_res {
        
        # DebugCFILL $que_res "components_list '$que_res' '$i' '$cur_anal' '$cur_step'"
        # DebugCFILL $que_res "+++[encoding system] : ([string length $i]:[string bytelength $i]) '$i'---"

        set img ""
        DebugCFILL $que_res "geeting image for ( cur_res != i) || ( cur_res_view != que_res)"
        DebugCFILL $que_res "geeting image for ( $cur_res != $i) || ( $cur_res_view != $que_res)"
        if { ( $cur_res != $i) || ( $cur_res_view != $que_res) } {
            set img $GidPriv(VerifNoImage)
        } else {
            set img $GidPriv(VerifImage)
        }

        #degug MAC
        DebugCFILL $que_res "GetResultMenuFromPath $w $i $img = [ GetResultMenuFromPath $w $i $img]"

        set wm [ GetResultMenuFromPath $w $i $img]
        if { $wm == ""} {
            # set entrada_ventana 1
            # break
            if { [ regexp {^/?/?([^/]*)} $i dum path_tmp ] } {
                regsub -all {_} $path_tmp { } path_parcial
                if { ![ info exists entrara_ya_anyadida($path_tmp)]} {
                    set trad [_ "More"]
                    $w add command -label "${path_parcial}/... ${trad}..." \
                        -command "PostGeom::Create; PostResultsSetResultsView $que_res"
                    set entrara_ya_anyadida($path_tmp) 1
                }
                continue
            } else {
                set entrada_ventana 1
                break
            }
        }
        DebugCFILL $que_res "$w getting path '$wm' from '$i'"

        set txt $i
        if { $wm != $w } {
            if { [regexp {^/?/?(.*)//(.*?)$} $i dum path res_txt] } {
                set txt $res_txt
            }                    
        }
        set txt [TranslateResultName $txt]

        set all_comp [ GiD_Info postprocess get components_list $que_res $i $cur_anal $cur_step ]

        #         if { ( [ llength $all_comp] > 1) && \
            #                 ( $que_res != "Stream_Lines") && ( $que_res != "Deformation") }

        set create_submenu 0
        if { ( [ llength $all_comp] > 1) && ( $que_res != "Deformation") && ( $que_res != "Node_Rrace") } {
            set create_submenu 1
        }

        # check if althought it's a scalar there are some created components elsewhere
        if { [ llength $all_comp] == 1} {
            set root_res ${i}//
            if { [ string first $root_res $all_res] != -1} {
                # may be of the form t//something
            # if { [ lsearch $all_res $root_res] != -1} 
                set create_submenu 1
                set txt [TranslateResultName $txt]
            }
            DebugCFILL $que_res "looking for '$root_res' in '$all_res' = [ lsearch $all_res $root_res]"
        }

        if { $create_submenu } {
            
            # anyadimos el menu de las componentes
            DebugCFILL $que_res "###[encoding system] : ([string length $i]:[string bytelength $i]) '$i'***"

            regsub -all {\.} $i {_} menu_name
            #set txt $i

            # DebugCFILL $que_res "adding cascade"
            set under [FindUnderChar txt UnderLineList]
            if { ![ useAlternativeWidgetsForMac]} {
                $wm add cascade -label $txt -underline $under -menu $wm.m$menu_name \
                    -image $img -compound left
            } else {
                $wm add cascade -label $txt -underline $under -menu $wm.m$menu_name
            }

            #degug MAC
            DebugCFILL $que_res "$wm added cascade '$txt' menu '$wm.m$menu_name'"

            if { [ winfo exists $wm.m$menu_name ]} {
                $wm.m$menu_name delete 0 end
            } else {
                menu $wm.m$menu_name
            }
            set UnderLineList2 {}
            foreach j $all_comp {
                set txt_comp [TranslateResultName $j]
                set under [FindUnderChar txt_comp UnderLineList2]        
                set img ""
                if { ( $cur_res != $i) || ( $cur_res_view != $que_res) || \
                         ( $cur_comp != $j ) } {
                    set img $GidPriv(VerifNoImage)
                } else {
                    set img $GidPriv(VerifImage)
                    ### set ViewMenuPriv($w,OldResView) $que_res
                }
                if { ![ useAlternativeWidgetsForMac]} {
                    $wm.m$menu_name add command -label $txt_comp -underline $under -command "$basecommand $i $j" \
                        -image $img -compound left
                } else {
                    $wm.m$menu_name add command -label $txt_comp -underline $under -command "$basecommand $i $j"
                }

                #degug MAC
                DebugCFILL $que_res "$wm.m$menu_name added command '$txt_comp'"
            }
            
        } else {
            set postcmd ""
            #if { $que_res == "Deformation"} {
            #         set postcmd "escape"
            #}
            # anyadimos el comando
            set img ""
            if { ( $cur_res != $i) || ( $cur_res_view != $que_res) } {
                set img $GidPriv(VerifNoImage)
            } else {
                set img $GidPriv(VerifImage)
                ### set ViewMenuPriv($w,OldResView) $que_res
            }

            # DebugCFILL $que_res "adding command"

            set under [FindUnderChar txt UnderLineList]
            if { ![ useAlternativeWidgetsForMac]} {
                $wm add command -label $txt -underline $under -command "$basecommand $i $postcmd" \
                    -image $img -compound left
            } else {
                $wm add command -label $txt -underline $under -command "$basecommand $i $postcmd"
            }

            #degug MAC
            DebugCFILL $que_res "$wm added command '$txt'"
        }
    }

    if { $add_smooth_submenu} {
        if { $que_res != "Iso_Surfaces"} {
            regsub -all {_} $que_res {} subst_cmd
            set smooth_cmd Smooth$subst_cmd
        } else {
            # iso_surface commands are of the style: IsoSurfaces Exact/Automatic/AutomaticWidth 
            # which should be changed to: IsoSurfaces SmoothExact/SmoothAutomatic/SmoothAutomaticWidth 
            if { [ string first "Automatic" $basecommand ] != -1} {
                # this will also include AutomaticWidth
                set subst_cmd Automatic
                set smooth_cmd SmoothAutomatic
            } elseif { [ string first "Exact" $basecommand ] != -1} {
                set subst_cmd Exact
                set smooth_cmd SmoothExact
            } 
        }
        DebugCFILL $que_res "adding smooth menu"
        if { [ regsub $subst_cmd $basecommand $smooth_cmd smoothbasecommand]} {
            set menu_name "__smoothed_results"
            if { [ winfo exists $w.m$menu_name ]} {
                $w.m$menu_name delete 0 end
            } else {
                menu $w.m$menu_name
            }
            set txt [_ "Smoothed#C#MenuEntryForSmoothedGaussPointsResults"]
            set under [FindUnderChar txt UnderLineList]
            
            if { ( $cur_res_view != "Smooth_$que_res") } {
                set img $GidPriv(VerifNoImage)
            } else {
                set img $GidPriv(VerifImage)
            }

            if { ![ useAlternativeWidgetsForMac]} {
                $w add cascade -label $txt -underline $under -menu $w.m$menu_name \
                    -image $img -compound left
            } else {
                $w add cascade -label $txt -underline $under -menu $w.m$menu_name
            }
            
            DebugCFILL $que_res "adding smooth menu Smooth_$que_res in $w.m$menu_name"
            AddResultsToMenu $w.m$menu_name $smoothbasecommand Smooth_$que_res $sub
            ### set ::ViewMenuPriv($w,SmoothSubMenu) $wm.m$menu_name
        }
    }

    if { [ info exists entrara_ya_anyadida]} {
        unset entrara_ya_anyadida
    }

    if { $entrada_ventana} {
        $w add separator
        $w add command -label ...[_ "More"]... \
            -command "PostGeom::Create; PostResultsSetResultsView $que_res"
    }
    DebugCFILL $que_res "END - $cur_res <------------------------------------------"
    set ::GiDPostResultsMenu(Menu,$que_res,$w) done
}

proc DoLineGraph { w basecmd res { comp ""}} {
    if { "$comp" != ""} {
        eval $basecmd $res $comp $::ViewMenuPriv(LineGraphXAxis)
    } else {
        set res_comp [ GiD_Info postprocess get cur_components_list $res]
        eval $basecmd $res $res_comp $::ViewMenuPriv(LineGraphXAxis)
    }
}

proc AddGraphsResultsToMenu { w basecommand que_res } {
    global ViewMenuPriv

    # registramos los menus
    # if { [ esMac]} {
    #         registerPostGraphsResultsMenu $w $basecommand $que_res
    #         $w configure -postcommand ""
    # }

    set all_anal [lsort -dictionary [ GiD_Info postprocess get all_analysis]]
    # set all_anal [ GiD_Info postprocess get all_analysis]
    if { $all_anal == ""} {
        set msg [_ "Please load a MODEL first"]
    } else {
        set msg [_ "Please select a STEP first"]
    }
    set cur_anal [ GiD_Info postprocess get cur_analysis]
    if { $cur_anal == "" } {
        $w delete 0 end
        $w add command -label $msg -state disabled
        return
    }

    set cur_step [ GiD_Info postprocess get cur_step $cur_anal]
    if { $cur_step == ""} {
        $w delete 0 end
        $w add command -label [_ "Please select a STEP first"] -state disabled
        return
    }

    set all_res [ lsort -dictionary [ GiD_Info postprocess get cur_results_list $que_res]]
    if { $all_res == ""} {
        $w delete 0 end
        $w add command -label [_ "No useful results found"] -state disabled
        return
    }
    
    if { $que_res == "Integrate_Vector_Normal" || $que_res == "Integrate_Vector_Tangential" } {
        set also_components 0
    } else {
        set also_components 1
    }

    ## miramos si el menu que ya tenemos aun es valido
    # if { ![esMac]}  # en mac solo nos llaman cuando hay que rehacer los menus
    if { 1} { # en mac solo nos llaman cuando hay que rehacer los menus
        # para el conyazo de windows, que es mas lento que una tortuga con reuma
        if { ( $cur_anal != "") && ( $cur_step != "") && ( $all_res != "") } {
            if { [ info exists ViewMenuPriv($w,$que_res//analstep)] && \
                     [ info exists ViewMenuPriv($w,$que_res//allres)] } {
                if { ![ string compare $ViewMenuPriv($w,$que_res//analstep) "$cur_anal $cur_step" ] || \
                         ![ string compare $ViewMenuPriv($w,$que_res//allres) $all_res] } {
                    # ahora a mirar los componentes
                    set igual 1
                    foreach i $all_res {
                        if { $also_components } {
                            set all_comp [ GiD_Info postprocess get cur_components_list $i ]
                        } else {
                            set all_comp ""
                        }
                        regsub -all { } $i {_} idx
                        if { [ info exists ViewMenuPriv($w,$que_res//$idx)] } {
                            if { [ string compare $ViewMenuPriv($w,$que_res//$idx) $all_comp]} {
                                # no son iguales
                                set igual 0
                                break
                            }
                        } else {
                            # no son iguales
                            set igual 0
                            break
                        }
                    }
                    if { $igual} {
                        return
                    }
                }
            }
        }
    }

    # para ahorrarnos construir cosas
    set ViewMenuPriv($w,$que_res//analstep) "$cur_anal $cur_step"
    set ViewMenuPriv($w,$que_res//allres) $all_res
    foreach i $all_res {
        if { $also_components } {
            set all_comp [ GiD_Info postprocess get cur_components_list $i ]
        } else {
            set all_comp ""
        }
        regsub -all { } $i {_} idx
        set ViewMenuPriv($w,$que_res//$idx) $all_comp
    }

    $w delete 0 end

    if { $que_res == "Line_Graph"} {
        set eje X
        # construyamos el menu del eje X
        if { [ winfo exists $w.m$eje ]} {
            $w.m$eje delete 0 end
        } else {
            menu $w.m$eje
        }
        set cmds {X_Variation Y_Variation Z_Variation LineVariation}
        set labels [ list [_ "X Variation"] [_ "Y Variation"] [_ "Z Variation"] [_ "Line Variation"]]
        set values [ list "X_Variation" "Y_Variation" "Z_Variation" "LineVariation"]
        set UnderLineList {}
        if { ![ info exists ::ViewMenuPriv(LineGraphXAxis) ]} {
            set ::ViewMenuPriv(LineGraphXAxis) "LineVariation"
        }
        foreach i $cmds l $labels v $values {
            set under [FindUnderChar l UnderLineList]
            $w.m$eje add checkbutton -label $l -underline $under \
                -onvalue $v -variable ::ViewMenuPriv(LineGraphXAxis)
        }
        $w add cascade -label [_ "Set X axis"] -menu $w.m$eje
    }

    set entrada_ventana 0
    if { $all_res != ""} {
        foreach i $all_res {
            if { $also_components } {
                if { $que_res != "Point_Complex_Evolution"} {
                    set all_comp [ GiD_Info postprocess get cur_components_list $i ]
                } else {
                    set all_comp [ GiD_Info postprocess get cur_complex_components_list $i ]
                }
            } else {
                set all_comp ""
            }
            
            set wm [ GetResultMenuFromPath $w $i ""]
            if { $wm == ""} {
                set entrada_ventana 1
                break
            }

            set txt $i
            if { $wm != $w} {
                if { [regexp {^/?/?(.*)//(.*?)$} $i dum path txt_res] } {
                    set txt $txt_res
                }                 
            }
            set txt_res [TranslateResultName $txt]

            set create_submenu 0
            if { [ llength $all_comp] > 1 } {
                set create_submenu 1
            }
            
            # check if althought it's a scalar there are some created components elsewhere
            if { [ llength $all_comp] == 1} {
                set root_res ${i}//
                if { [ string first $root_res $all_res] != -1} {
                    # may be of the form t//something
                    # if { [ lsearch $all_res $root_res] != -1} 
                    set create_submenu 1
                    set txt_res [TranslateResultName $txt]
                }
               # WarnWinText "looking for '$root_res' in '$all_res' = [ string first $root_res $all_res]"
            }

            if { $create_submenu } {
                # add component's menu
                regsub -all {\.} $i {_} menu_name
                $wm add cascade -label $txt_res -menu $wm.m$menu_name
                if { [ winfo exists $wm.m$menu_name ]} {
                    $wm.m$menu_name delete 0 end
                } else {
                    menu $wm.m$menu_name
                }
                foreach j $all_comp {
                    set txt_comp [TranslateResultName $j]                   
                    set do_graph_cmd [list {*}$basecommand $i $j]                    
                    if { $que_res == "Line_Graph"} {
                        # set do_graph_cmd [list DoLineGraph $w {*}$basecommand $i $j]
                        set do_graph_cmd [list DoLineGraph $w $basecommand $i $j]
                    }
                    $wm.m$menu_name add command -label $txt_comp -command $do_graph_cmd
                }
            } else {
                # add the command
                set do_graph_cmd [list {*}$basecommand $i]
                if { $que_res == "Line_Graph"} {
                    # set do_graph_cmd [list DoLineGraph $w {*}$basecommand $i]
                    set do_graph_cmd [list DoLineGraph $w $basecommand $i]
                }
                $wm add command -label $txt_res -command $do_graph_cmd
            }
        }
    }

    if { $entrada_ventana} {
        $w add separator
        $w add command -label ...[_ "More"]... -command PostGraphs::Create
    }
}

proc AddIntegrateResultsGraphOptions { w which_step} {
    $w delete 0 end

    if { ![info exists ::GidPriv(PostSpaceDimension)] } {
        set ::GidPriv(PostSpaceDimension) "3D"
        #used for example if 2D do to integrals on lines in  the XY space 
        #e.g for triangle meshes with z but results XY only like IBER, to do
        #  -integral along cutting line 
        #  -streamlines in z=0 (else the streamline go outside the triangle/quads 3D domain)
    }

    set r_menu $w.mScalarResult
    $w add cascade -label [_ "Scalar result"] -menu $r_menu
    if { ![ winfo exists $r_menu]} {
        menu $r_menu
    }
    AddGraphsResultsToMenu $r_menu \
        [ list GiD_Process Mescape Results Graphs Integrate $::GidPriv(PostSpaceDimension) $which_step ScalarResult] Integrate_Scalar
    set r_menu $w.mVectorResult
    $w add cascade -label [_ "Vector result (normal)"] -menu $r_menu
    if { ![ winfo exists $r_menu]} {
        menu $r_menu
    }
    AddGraphsResultsToMenu $r_menu [ list GiD_Process Mescape Results Graphs Integrate $::GidPriv(PostSpaceDimension) $which_step NormalIntegration VectorResult] \
        Integrate_Vector_Normal
    
    set r_menu $w.mVectorResult2
    $w add cascade -label [_ "Vector result (tangential)"] -menu $r_menu
    if { ![ winfo exists $r_menu]} {
        menu $r_menu
    }
    AddGraphsResultsToMenu $r_menu [ list GiD_Process Mescape Results Graphs Integrate $::GidPriv(PostSpaceDimension) $which_step TangentialIntegration VectorResult] \
        Integrate_Vector_Tangential
    
}

proc AddIntegrateGraphOptions { w} {
    $w delete 0 end

    set r_menu $w.mThisStep
    $w add cascade -label [_ "This step"] -menu $r_menu
    if { ![ winfo exists $r_menu]} {
        menu $r_menu
    }
    AddIntegrateResultsGraphOptions $r_menu ThisStep

    set r_menu $w.mAllSteps
    $w add cascade -label [_ "All steps"] -menu $r_menu
    if { ![ winfo exists $r_menu]} {
        menu $r_menu
    }
    AddIntegrateResultsGraphOptions $r_menu AllSteps
}

proc PointEvolutionSetAxisTo { que_eje res res_comp} {
    global ViewMenuPriv

    if { [ info exists ViewMenuPriv(point_evolution_ax$que_eje)]} {
        set old_res [ lindex $ViewMenuPriv(point_evolution_ax$que_eje) 0]
        set old_res_comp [ lindex $ViewMenuPriv(point_evolution_ax$que_eje) 1]
        set ViewMenuPriv(point_evolution_ax$que_eje//$old_res//$old_res_comp) 0
    }
    set ViewMenuPriv(point_evolution_ax$que_eje) "$res $res_comp"
    set ViewMenuPriv(point_evolution_ax$que_eje//$res//$res_comp) 1
}

proc PointEvolutionDoIt { basecommand} {
    global ViewMenuPriv

    if { ![ info exists ViewMenuPriv(point_evolution_axX)]} {
        WarnWin [_ "Please set X axis first"]
        return
    }
    if { ![ info exists ViewMenuPriv(point_evolution_axY)]} {
        WarnWin [_ "Please set Y axis first"]
        return
    }


    set comm "$basecommand $ViewMenuPriv(point_evolution_axX) $ViewMenuPriv(point_evolution_axY)"
    if { $::ViewMenuPriv(pointgraphallsteps) } {
        lappend comm AllSteps
    }

    eval [ concat $comm]
}

proc BorderGraphSetAxisTo { w que_eje res { res_comp ""}} {
    global ViewMenuPriv

    if { [ info exists ViewMenuPriv(border_graph_ax$que_eje)]} {
        set old_res [ lindex $ViewMenuPriv(border_graph_ax$que_eje) 0]
        set old_res_comp [ lindex $ViewMenuPriv(border_graph_ax$que_eje) 1]
        set ViewMenuPriv(border_graph_ax$que_eje//$old_res//$old_res_comp) 0
    }
    if { $que_eje == "Y"} {
        set ViewMenuPriv(border_graph_ax$que_eje) "$res $res_comp"
        set ViewMenuPriv(border_graph_ax$que_eje//$res//$res_comp) 1
    }
    if { $que_eje == "X"} {
        set ViewMenuPriv(border_graph_ax$que_eje) "$res"
        foreach i "X_Variation Y_Variation Z_Variation LineVariation" {
            set ViewMenuPriv(border_graph_ax$que_eje//$i) 0
        }
        set ViewMenuPriv(border_graph_ax$que_eje//$res) 1
    }

    set opt [ list X_Variation Y_Variation Z_Variation LineVariation]
    if { "$res_comp" == ""} {
        foreach o $opt {
            set ::ViewMenuPriv($w,border_graph_ax$que_eje//$o) 0
        }
        set ::ViewMenuPriv($w,border_graph_ax$que_eje//$res) 1
    } else {
        foreach o $opt {
            set ::ViewMenuPriv($w,border_graph_ax$que_eje//$o//$res_comp) 0
        }
        set ::ViewMenuPriv($w,border_graph_ax$que_eje//$res//$res_comp) 1
    }
}

proc BorderGraphDoIt { basecommand} {
    global ViewMenuPriv

    if { ![ info exists ViewMenuPriv(border_graph_axX)]} {
        WarnWin [_ "Please set X axis first"]
        return
    }
    if { ![ info exists ViewMenuPriv(border_graph_axY)]} {
        WarnWin [_ "Please set Y axis first"]
        return
    }

    set comm "$basecommand $ViewMenuPriv(border_graph_axX) $ViewMenuPriv(border_graph_axY)"

    eval [ concat $comm]
}

proc AddGraphsXYResultsToMenu { w basecommand que_res args} {
    global ViewMenuPriv

    # registramos los menus
    # if { [ esMac]} {
    #         registerPostGraphsXYResultsMenu $w $basecommand $que_res
    #         $w configure -postcommand ""
    # }

    if { ![info exists ::ViewMenuPriv(pointgraphallsteps)] } {
        set ::ViewMenuPriv(pointgraphallsteps) 1
    }
    set all_anal [lsort -dictionary [ GiD_Info postprocess get all_analysis]]
    # set all_anal [ GiD_Info postprocess get all_analysis]
    if { $all_anal == ""} {
        set msg [_ "Please load a MODEL first"]
    } else {
        set msg [_ "Please select a STEP first"]
    }
    set cur_anal [ GiD_Info postprocess get cur_analysis]
    if { $cur_anal == ""} {
        $w delete 0 end
        set UnderLineList {}
        foreach eje "X Y" {
            set text [_ "Set %s axis" $eje]
            set under [FindUnderChar text UnderLineList]
            $w add cascade -label $text -underline $under -menu $w.m$eje
            if { [ winfo exists $w.m$eje ]} {
                $w.m$eje delete 0 end
                $w.m$eje add command -label $msg -state disabled
            } else {
                menu $w.m$eje
                $w.m$eje add command -label $msg -state disabled
            }
        }
        if { $que_res == "Point_Graph"} {
            set text [_ "Select Points"]
            set under [FindUnderChar text UnderLineList]
            $w add command -label $text -underline $under -command ResultsNoStep
            set text [_ "All steps"]
            set under [FindUnderChar text UnderLineList]
            $w add checkbutton -label $text -underline $under -variable ::ViewMenuPriv(pointgraphallsteps) -indicatoron 1
        }
        if { $que_res == "Border_Graph"} {
            set text [_ "Select Border"]
            set under [FindUnderChar text UnderLineList]
            $w add command -label $text -underline $under -command ResultsNoStep
        }
        return
    }

    set cur_step [ GiD_Info postprocess get cur_step $cur_anal]
    if { $cur_step == ""} {
        $w delete 0 end
        set UnderLineList {}
        foreach eje "X Y" {
            set text [_ "Set %s axis" $eje]
            set under [FindUnderChar text UnderLineList]
            $w add cascade -label $text -underline $under -menu $w.m$eje
            if { [ winfo exists $w.m$eje ]} {
                $w.m$eje delete 0 end
                $w.m$eje add command -label [_ "Please select a STEP first"] -state disabled
            } else {
                menu $w.m$eje
                $w.m$eje add command -label [_ "Please select a STEP first"] -state disabled
            }
        }
        if { $que_res == "Point_Graph"} {
            set text [_ "Select Points"]
            set under [FindUnderChar text UnderLineList]
            $w add command -label $text -underline $under -command ResultsNoStep
            set text [_ "All steps"]
            set under [FindUnderChar text UnderLineList]
            $w add checkbutton -label $text -underline $under -variable ::ViewMenuPriv(pointgraphallsteps) -indicatoron 1
        }
        if { $que_res == "Border_Graph"} {
            set text [_ "Select Border"]
            set under [FindUnderChar text UnderLineList]
            $w add command -label $text -underline $under -command ResultsNoStep
        }
        return
    }

    set all_res [ lsort -dictionary [ GiD_Info postprocess get cur_results_list $que_res]]
    if { $all_res == ""} {
        $w delete 0 end
        set UnderLineList {}
        foreach eje "X Y" {
            set text [_ "Set %s axis" $eje]
            set under [FindUnderChar text UnderLineList]
            $w add cascade -label $text -underline $under -menu $w.m$eje
            if { [ winfo exists $w.m$eje ]} {
                $w.m$eje delete 0 end
            } else {
                menu $w.m$eje
            }
        }
        if { $que_res == "Point_Graph"} {
            set text [_ "Select Points"]
            set under [FindUnderChar text UnderLineList]
            $w add command -label $text -underline $under -command ResultsNoStep
            set text [_ "All steps"]
            set under [FindUnderChar text UnderLineList]
            $w add checkbutton -label $text -underline $under -variable ::ViewMenuPriv(pointgraphallsteps) -indicatoron 1
        }
        if { $que_res == "Border_Graph"} {
            set text [_ "Select Border"]
            set under [FindUnderChar text UnderLineList]
            $w add command -label  $text -underline $under -command ResultsNoStep
        }
        return
    }

    ## miramos si el menu que ya tenemos aun es valido
    # if { ![esMac]} # en mac solo nos llaman cuando hay que rehacer los menus
    if { 1} { # en mac solo nos llaman cuando hay que rehacer los menus
        # para el conyazo de windows, que es mas lento que una tortuga con reuma
        if { ( $cur_anal != "") && ( $cur_step != "") && ( $all_res != "") } {
            if { [ info exists ViewMenuPriv($w,$que_res//analstep)] && \
                     [ info exists ViewMenuPriv($w,$que_res//allres)] } {
                if { ![ string compare $ViewMenuPriv($w,$que_res//analstep) "$cur_anal $cur_step" ] || \
                         ![ string compare $ViewMenuPriv($w,$que_res//allres) $all_res] } {
                    # ahora a mirar los componentes
                    set igual 1
                    foreach i $all_res {
                        set all_comp [ GiD_Info postprocess get cur_components_list $i ]
                        regsub -all { } $i {_} idx
                        if { [ info exists ViewMenuPriv($w,$que_res//$idx)] } {
                            if { [ string compare $ViewMenuPriv($w,$que_res//$idx) $all_comp]} {
                                # no son iguales
                                set igual 0
                                break
                            }
                        } else {
                            # no son iguales
                            set igual 0
                            break
                        }
                    }
                    if { $igual} {
                        return
                    }
                }
            }
        }
    }

    # para ahorrarnos construir cosas
    set ViewMenuPriv($w,$que_res//analstep) "$cur_anal $cur_step"
    set ViewMenuPriv($w,$que_res//allres) $all_res
    foreach i $all_res {
        set all_comp [ GiD_Info postprocess get cur_components_list $i ]
        regsub -all { } $i {_} idx
        set ViewMenuPriv($w,$que_res//$idx) $all_comp
    }

    if { ( [ $w type 0] != "cascade") || ( [ $w type 1] != "cascade") } {
        $w delete 0 end
        set UnderLineList {}
        foreach eje "X Y" {
            set text [_ "Set %s axis" $eje]
            set under [FindUnderChar text UnderLineList]
            $w add cascade -label $text -underline $under -menu $w.m$eje
            if { [ winfo exists $w.m$eje ]} {
                $w.m$eje delete 0 end
            } else {
                menu $w.m$eje
            }
        }
        if { $que_res == "Point_Graph"} {
            set text [_ "Select Points"]
            set under [FindUnderChar text UnderLineList]
            $w add command -label $text -underline $under -command ResultsNoStep
            set text [_ "All steps"]
            set under [FindUnderChar text UnderLineList]
            $w add checkbutton -label $text -underline $under -variable ::ViewMenuPriv(pointgraphallsteps) -indicatoron 1
        }
        if { $que_res == "Border_Graph"} {
            set text [_ "Select Border"]
            set under [FindUnderChar text UnderLineList]
            $w add command -label $text -underline $under  -command ResultsNoStep
        }
    }

    set lista_ejes "X Y"
    if { $que_res == "Border_Graph"} {
        set lista_ejes "Y"
        set eje X
        # construyamos el menu del eje X
        if { [ winfo exists $w.m$eje ]} {
            $w.m$eje delete 0 end
        }
        set cmds {X_Variation Y_Variation Z_Variation LineVariation}
        set labels [list [_ "X Variation"] [_ "Y Variation"] [_ "Z Variation"] [_ "Line Variation"]]
        set UnderLineList {}
        foreach i $cmds l $labels {
            set under [FindUnderChar l UnderLineList]
            $w.m$eje add checkbutton -label $l -underline $under -command "BorderGraphSetAxisTo $w $eje $i" \
                -onvalue 1 -variable ::ViewMenuPriv($w,border_graph_ax$eje//$i)
            set ViewMenuPriv($w,border_graph_ax$eje//$i) 0
        }
    }

    set entrada_ventana 0
    foreach eje $lista_ejes {
        if { [ winfo exists $w.m$eje ]} {
            $w.m$eje delete 0 end
        }

        foreach i $all_res {
            set all_comp [ GiD_Info postprocess get cur_components_list $i ]

            set wm [ GetResultMenuFromPath $w.m$eje $i ""]
            if { $wm == ""} {
                set entrada_ventana 1
                break
            }

            set txt $i
            if { $wm != "$w.m$eje" } {
                if { [regexp {^/?/?(.*)//(.*?)$} $i dum path txt_res] } {
                    set txt $txt_res
                }                 
            }
            set txt_res [TranslateResultName $txt]

            set create_submenu 0
            if { [ llength $all_comp] > 1} {
                set create_submenu 1
            }
            
            # check if althought it's a scalar there are some created components elsewhere
            if { [ llength $all_comp] == 1} {
                set root_res ${i}//
                if { [ string first $root_res $all_res] != -1} {
                    # may be of the form t//something
                    # if { [ lsearch $all_res $root_res] != -1} 
                    set create_submenu 1
                    set txt_res [TranslateResultName $txt]
                }
                # WarnWinText "looking for '$root_res' in '$all_res' = [ lsearch $all_res $root_res]"
            }

            if { $create_submenu } {
                # anyadimos el menu de las componentes
                regsub -all {\.} $i {_} menu_name
                $wm add cascade -label $txt_res -menu $wm.m$menu_name
                if { [ winfo exists $wm.m$menu_name ]} {
                    $wm.m$menu_name delete 0 end
                } else {
                    menu $wm.m$menu_name
                }
                foreach j $all_comp {
                    set txt_comp [TranslateResultName $j]                    
                    if { $que_res == "Point_Graph"} {
                        $wm.m$menu_name add checkbutton -label $txt_comp \
                            -command "PointEvolutionSetAxisTo $eje $i $j" \
                            -onvalue 1 -variable ::ViewMenuPriv($w,point_evolution_ax$eje//$i//$j)
                        set ViewMenuPriv($w,point_evolution_ax$eje//$i//$j) 0
                    }
                    if { $que_res == "Border_Graph"} {
                        $wm.m$menu_name add checkbutton -label $txt_comp \
                            -command "BorderGraphSetAxisTo $w $eje $i $j" \
                            -onvalue 1 -variable ::ViewMenuPriv($w,border_graph_ax$eje//$i//$j)
                        set ViewMenuPriv($w,border_graph_ax$eje//$i//$j) 0
                    }
                }
            } else {
                
                #component name of single component results ( scalar) may be different from result name
                set j $all_comp
                set txt_comp [TranslateResultName $j]   
                
                if { $que_res == "Point_Graph"} {
                    $wm add checkbutton -label $txt_res \
                        -command "PointEvolutionSetAxisTo $eje $i $j" \
                        -onvalue 1 -variable ::ViewMenuPriv($w,point_evolution_ax$eje//$i//$j)
                    set ViewMenuPriv($w,point_evolution_ax$eje//$i//$j) 0
                }
                if { $que_res == "Border_Graph"} {
                    $wm add checkbutton -label $txt_res \
                        -command "BorderGraphSetAxisTo $w $eje $i $j" \
                        -onvalue 1 -variable ::ViewMenuPriv($w,border_graph_ax$eje//$i//$j)
                    set ViewMenuPriv($w,border_graph_ax$eje//$i//$j) 0
                }
            }
        }
    }

    if { $que_res == "Point_Graph"} {
        $w entryconfigure 2 -command "PointEvolutionDoIt [ list $basecommand]"
    }
    if { $que_res == "Border_Graph"} {
        $w entryconfigure 2 -command "BorderGraphDoIt [ list $basecommand]"
    }

    if { $entrada_ventana} {
        $w add separator
        $w add command -label ...[_ "More"]... -command PostGraphs::Create
    }
}


# Position a dialog box at a reasonable place on the screen.

proc dpos { w } {
    set hh [expr [winfo screenheight .gid]*.55]
    set hh [string range $hh 0 [expr [string first . $hh]-1]]
    wm geometry $w -0+400
}

proc GiveDpos {} {
    return "-0+400"
}


proc ReduceImage { img factor } {
    set img_w [ image width $img]
    set img_h [ image height $img]
    set new_h [ expr int( 0.5 + $factor * $img_h)]
    set new_w [ expr int( 0.5 + $factor * $img_w)]
    set new_img [ image create photo -width $new_w -height $new_h]
    img_zoom $new_img $img Lanczos3
    image delete $img        
    return $new_img    
}

proc AddMoreWelcome { moreSize lessSize} {
    global GIDDEFAULTTCL tcl_platform GidPriv
    set base .gid.pepe

    # WarnWin "more: wm geometry .gid.pepe $moreSize"
    wm geometry .gid.pepe $moreSize
    text $base.text \
        -height 3 -width 1 -yscroll "$base.scrollbar set"

    ttk::scrollbar $base.scrollbar \
        -orient vertical -command "$base.text yview"

    $base.text insert end [_ "%s internal version: %s ( %s bits)" \
                               $GidPriv(ProgName) [ GiD_Info GiDVersion] [ GiD_Info GiDbits]]\n

    if { 0 } {
        set compilationtime ""
        if { ![ catch { set fcomp [ open [ file native [ file join $GIDDEFAULTTCL Compiled]]]}]} {
            while { ![ eof $fcomp] } {
                set compilationtime [read $fcomp]
            }
            close $fcomp
            $base.text insert end [_ "Last compilation time: %s" $compilationtime]\n
        }
    }

    $base.text insert end [_ "Operating system"]:
    foreach i "machine platform os osVersion" {
        $base.text insert end " '$::tcl_platform($i)'"
    }
    $base.text insert end \n

    catch { $base.text insert end [ GiD_Info internalstate] }

    if { ![ catch { set fcomp [ open [ file join $GIDDEFAULTTCL Compiled-more]]}] } {
        while { ![ eof $fcomp] } {
            $base.text insert end [ gets $fcomp]
            $base.text insert end \n
        }
        close $fcomp
    }


    grid $base.text -in $base -row 3 -column 1 -sticky nesw -padx 2 -pady 2
        
    grid $base.scrollbar -in $base -row 3 -column 2 -sticky nse

    grid rowconfigure $base 3 -weight 1

    proc lessAbout { moreSize lessSize} {
        destroy .gid.pepe.text
        destroy .gid.pepe.scrollbar
        # WarnWin "less: wm geometry .gid.pepe $lessSize"
        wm geometry .gid.pepe $lessSize
        
        .gid.pepe.bottomframe.button_more configure -text [_ "More"] \
            -command "AddMoreWelcome $moreSize $lessSize"
    }

    $base.bottomframe.button_more configure -text [_ "Less"] \
        -command "lessAbout $moreSize $lessSize"
}

proc CreateWelcomeWin { { overw .gid } } {
    global GIDDEFAULT GidPriv
    global tcl_platform

    toplevel .gid.pepe
    wm title .gid.pepe $GidPriv(ProgName)
    set base .gid.pepe
    set winWidth 650
    set winHeight 385
    set winMoreHeight [ expr ${winHeight} + 150]
    wm minsize $base $winWidth $winHeight
    wm maxsize $base ${winWidth} 10000
    set moreSize ${winWidth}x${winMoreHeight}
    set lessSize ${winWidth}x${winHeight}

    set yTapa 330
    set xTapa 0   

    set yVersionLabel 94
    # set xVersionLabel 494
    # set widthVersionLabel 140
    # set heightVersionLabel 34
    set xVersionLabel 474
    set widthVersionLabel 160
    set heightVersionLabel 26
    set sizeVersionLabel 12
    
    wm geometry .gid.pepe +[expr [winfo x $overw]+[winfo width $overw]/2-315]+[ expr [winfo y $overw]+[winfo height $overw]/2-315]

    set imatge_about [image create photo]
    $imatge_about copy [ gid_themes::GetImage $::GidPriv(AboutWindow)]
    #WARNING: ReduceImage can delete the image, avoid ::GidPrivImages($filename) pointing it
    unset -nocomplain ::GidPrivImages($::GidPriv(AboutWindow))

    set base_name [file rootname $::GidPriv(AboutWindow)]
    set extension [file extension $::GidPriv(AboutWindow)]    
    set imatge_tapa [image create photo]
    $imatge_tapa copy [ gid_themes::GetImage ${base_name}_grey${extension}]
    #WARNING: ReduceImage can delete the image, avoid ::GidPrivImages($filename) pointing it
    unset -nocomplain ::GidPrivImages(${base_name}_grey${extension})

    if { [ winfo screenheight .gid] < 768 } {    
        # reducir la imagen para que tambien quepa la ventana, por ejemplo
        # en los netbooks, pues su resolucion es 1024x600
        # a 4/5
        set diffMore [ expr $winMoreHeight - $winHeight]
        set diffVersionLabel [ expr $winHeight - $yVersionLabel]
        set factor 0.8
        set winWidth [ expr int( 0.5 + $factor * ${winWidth})]
        set winHeight [ expr int( 0.5 + $factor * ${winHeight} + 10)]
        # set winMoreHeight [ expr ${winHeight} + ${diffMore}]
        set winMoreHeight [ expr int( 0.5 + $factor * ${winMoreHeight})]
        wm minsize $base $winWidth $winHeight
        set lessSize ${winWidth}x${winHeight}
        set moreSize ${winWidth}x${winMoreHeight}
        set yTapa [ expr int( 0.5 + $factor * ${yTapa})]
        set xTapa [ expr int( 0.5 + $factor * ${xTapa})]
        # set yVersionLabel [ expr ${winHeight} - ${diffVersionLabel}]
        set yVersionLabel [ expr int( 0.5 + $factor * ${yVersionLabel})]
        set xVersionLabel [ expr int( 0.5 + $factor * ${xVersionLabel})]        
        set widthVersionLabel [ expr int( 0.5 + $factor * $widthVersionLabel)]
        set heightVersionLabel [ expr int( 0.5 + $factor * $heightVersionLabel)]
        set sizeVersionLabel 9

        # WarnWin "$moreSize - $lessSize - $yVersionLabel"
        set imatge_about [ReduceImage $imatge_about $factor]
        set imatge_tapa [ReduceImage $imatge_tapa $factor]
        
    }
    set height_tapa [image height $imatge_tapa] 
    

    if { $GidPriv(TextOfVersion) != "" } {
        set GidVersion $GidPriv(TextOfVersion)
    } else {
        set GidVersion [ GiD_Info GiDVersion]
    }


    tk::label $base.label_img -image $imatge_about
    tk::label $base.label_tapa -image $imatge_tapa -borderwidth 0 -background #010101 -anchor sw

    place $base.label_tapa -x $xTapa -y $yTapa -in $base -anchor sw

    ttk::frame $base.bottomframe -style BottomFrame.TFrame

    ttk::button $base.bottomframe.button_ok \
        -text [_ "OK"] -style BottomFrame.TButton  -command "destroy .gid.pepe"
        #-width 6 -padx 2
        
    ttk::button $base.bottomframe.button_more \
        -text [_ "More"] -style BottomFrame.TButton  -command "AddMoreWelcome $moreSize $lessSize"
        #-padx 2

    global credits_about
    set credits_about 0

    ttk::button $base.bottomframe.button_credits \
        -text [_ "Credits"] -style BottomFrame.TButton -command "start_credits $base 0 $height_tapa"
        #-padx 2


    #SetWidgetsWidthFromText $base.button_ok $base.button_more $base.button_credits

    # Geometry management

    grid $base.label_img -in $base -row 1 -column 1 -columnspan 2
    
    grid $base.bottomframe -in $base -row 2 -column 1 -sticky news -columnspan 2
    
    grid $base.bottomframe.button_ok -in $base.bottomframe  -row 1 -column 1  \
        -sticky e -padx 8 -pady 8

    grid $base.bottomframe.button_credits -in $base.bottomframe -row 1 -column 2  \
        -padx 8 -pady 8

    grid $base.bottomframe.button_more -in $base.bottomframe -row 1 -column 3  \
        -sticky w -padx 8 -pady 8


    # ponemos el numero de version encima de la imagen
    canvas $base.c -borderwidth 0 -highlightthickness 0 -width $widthVersionLabel -height $heightVersionLabel -background #010101

    place $base.c -x $xVersionLabel -y $yVersionLabel -in $base
    

    # ttk::frame $base.fv -borderwidth 0
    # label $base.fv.label_version -text $GidVersion -font BigFont -foreground #cccccc -background black
    # grid $base.fv.label_version -sticky we

    #set rw [ winfo reqwidth $base.fv.label_version]
    #place $base.label_version -x [ expr [ winfo reqwidth $base.label_img] - $rw - 16] -y 420 -in $base


    # Resize behavior management

    grid rowconfigure $base 1 -weight 0 -minsize 30
    grid rowconfigure $base 2 -weight 0 -minsize 30
    grid rowconfigure $base 3 -weight 1


    grid columnconfigure $base 1 -weight 1
    
    grid columnconfigure $base.bottomframe 1 -weight 1 -minsize 30
    grid columnconfigure $base.bottomframe 2 -weight 1 -minsize 30
    grid columnconfigure $base.bottomframe 3 -weight 1 -minsize 30
    

    bind $base <Return> "destroy .gid.pepe"
    bind $base <Escape> "destroy .gid.pepe"

    if { $::tcl_platform(os) != "Darwin"} {
        if { [winfo exists .gid.pepe] } {
            tkwait visibility .gid.pepe
        }
    } else {
        update
    }

    grab  .gid.pepe


    # a mover las letras
    update idletasks
    if { ![ winfo exists $base.c ]} {
        break
    }
    set txt [_ "Version %s" $GidVersion]
    set len_txt [ string length $txt]
    # set dest_x [ expr [ $base.c cget -width] - 36]
    set dest_x [ expr [ $base.c cget -width] - $heightVersionLabel]
    set dest_x $widthVersionLabel
    for { set is 0} { $is < $len_txt} { incr is} {
        ttk::frame $base.fv$is
        # -borderwidth 0 
        label $base.fv$is.l -text [ string index $txt [ expr $len_txt - $is - 1]] \
            -font "Helvetica $sizeVersionLabel bold" -foreground #9d9d9d -background #010101 -borderwidth 0 -highlightthickness 0
        grid $base.fv$is.l -sticky we -padx 0 -pady 0
        
        set rw [ winfo reqwidth $base.fv$is.l]
        set dest_x [ expr $dest_x - $rw]
        set ini_x 0
        set c_id [ $base.c create window $ini_x 0 -anchor nw -window $base.fv$is]
        set dif_x [ expr $dest_x - $ini_x]
        update
        update idletasks
        for { set ix $ini_x} { $ix < $dest_x} { set ix [ expr $ix + 5]} {
            # por si han cerrado la ventana antes de acabar con las letritas
            if { ![ winfo exists $base.c ]} {
                break
            }
            $base.c coords $c_id $ix 0
            update
            update idletasks
        }
        # por si han cerrado la ventana antes de acabar con las letritas
        if { ![ winfo exists $base.c ]} {
            break
        }
        $base.c coords $c_id $dest_x 0
        
    }

    set tip_base_widget $base.label_img
    if { $::tcl_platform(platform) != "windows" } {
            set tip_base_widget .gid.pepe
    }
    
    if { ![info exists ::GidPriv(ShowCheckNewVersion)] || $::GidPriv(ShowCheckNewVersion) != 0 } {
        after 1000 "ShowCheckNewVersion 1 $tip_base_widget"    
    }
    
    # por si han cerrado la ventana antes de acabar con las letritas
    if { [ winfo exists .gid.pepe]} {
        tkwait window .gid.pepe
    }
}


proc start_credits {base i height_tapa} {
    global credits_about
    if {$credits_about==0} {  show_credits $base $i $height_tapa}
}

proc show_credits {w i height_tapa} {
    #credits
    global credits_about

    set credits_about 1

    if {[winfo exists $w.label_tapa]} {                  
        $w.label_tapa configure -height [expr {$height_tapa-$i}]
    } else {set i 9998}
    incr i   
    if { [expr {$height_tapa-$i}] > 0 } {after 100 "show_credits $w $i $height_tapa"}
}

proc ChangeWindowTitle { { projectname "" } { problemType ""}} {
    global GidPriv
    if { [GidUtils::IsTkDisabled] } {
        return 1
    } 
    if { ![winfo exists .gid] } {
	return 1
    }
    if { $projectname == "" } {
        set projectname [ GiD_Info Project ModelName]
    }
    if { $problemType == "" } {
        set problemType [ GiD_Info Project ProblemType]
    }
    if { $problemType == "UNKNOWN" } {
        set problemType ""
    }
    set que64 ""
    # This is misleading on Linux. exe-32bits on Linux 64bits = machine == x86_64
    # if { [ lsearch {"amd64" "x86_64"} $::tcl_platform(machine)] != -1 } {
    #         set que64 x64
    # }
    if { $::tcl_platform(pointerSize) == 8} {
        set que64 x64
    }
    set compoundName [_ "Project: %s" [file tail $projectname]]
    if { [ string tolower $::GidPriv(ProgName,Default)] == "gid"} {
        if { $problemType != ""} {
            append compoundName " ($problemType)"
        }
    }
    set title [join [ list "$GidPriv(ProgName) $que64                       " \
                          $compoundName]]
    wm title .gid $title
    # wm iconname .gid [file tail $projectname]
    wm iconname .gid $compoundName
}

proc MakeNoise { name } {
    #     catch { exec playaiff $::GIDDEFAULT/resources/audio/$name & }
}


proc PrintLayerName {} {
    set layer [ GiD_Info Project LayerToUse]
    if { $layer != "*****" } {
        ChangeWarnLineVar [_ "Layer in use is '%s'" $layer]
    } else {
        ChangeWarnLineVar [_ "There is no layer in use"]
    }
}


proc OpenTemporaryWindow { text commands {names ""} { help "" } } {

    if { $names == "" } { regsub -all escape $commands Cancel names}

    if {$help == "" } {
        set var [ list tk_dialogRAM .gid.tempwinw [_ "Dialog window"] $text gidquestionhead 0]
    } else {
        set HelpCommand [ list HelpWindow "" $help .gid.tempwinw.helpwin]
        
        set var [ list tk_dialogRAMHelp .gid.tempwinw [_ "Dialog window"] $text gidquestionhead $HelpCommand 0]
    }
    append var " $names"


    set retval [eval $var]
    after idle GiD_Process [lindex $commands $retval]
}

proc OpenTemporaryEntryWindow { text {default ""} {type any} {btnstxt ""} } {

    if { $btnstxt == "" } {
        set retval [tk_dialogEntryRAM .gid.tempwine [_ "Enter value window"] $text gidquestionhead \
                        $type $default]
    } else {
        set retval [tk_dialogEntryRAM .gid.tempwine [_ "Enter value window"] $text gidquestionhead \
                        $type $default $btnstxt]
    }

    if { $retval == "--CANCEL--" } {
        GiD_Process escape
    } else {
        GiD_Process $retval
    }
}

proc OpenTemporaryComboWindow { text AcceptNew args} {
    if { [llength $args] } {
        set retval [tk_dialogComboRAM .gid.tempwinec [_ "Enter value window"] \
                        $text gidquestionhead $AcceptNew $args]
    } else {
        set retval [tk_dialogComboRAM .gid.tempwinec [_ "Enter value window"] $text \
                        gidquestionhead $AcceptNew ]
    }
    if { $retval == "--CANCEL--" } {
        GiD_Process escape
    } else {
        GiD_Process $retval
    }
}

proc AddProblemtypeNamesToVar { prefix dir varname recurse } {
    global GiDVisitedDir
    if { [info exists GiDVisitedDir($dir)] } {
        return ;#to avoid infinite loops with links
    }
    set GiDVisitedDir($dir) 1
    upvar #0 $varname var
    set dirs [glob -nocomplain -tails -directory $dir -types d *]
    foreach link [glob -nocomplain -tails -directory $dir -types f *.lnk] {
        if { [ GidUtils::IsLink [file join $dir $link]] == 2 } {
            lappend dirs $link
        }
    }
    foreach i [lsort -dictionary $dirs] {
        set ifull [file join $dir $i]
        if { [file extension $i] == ".lnk" && [ GidUtils::IsLink $ifull] == 2 } {
            set i [file root $i] ;#to remove .lnk
            set ifull [ GidUtils::ReadLink $ifull 1]
        }
        if { [file extension $i] == ".gid" } {
            if { $prefix == "" } {
                set name [file root $i]
            } else {
                set name [file join $prefix [file root $i]]
            }
            set var($name) ""
        } elseif { $recurse } {
            if { $prefix == "" } {
                set name $i
            } else {
                set name [file join $prefix $i]
            }
            AddProblemtypeNamesToVar $name $ifull $varname 1
        }
    }
}

proc OpenTemporaryTransformProblemTypeWindow { text } {

    global GIDDEFAULT GidPriv TransformPrtypeVar
    global GiDVisitedDir

    set current [ GiD_Info Project ProblemType]

    unset -nocomplain TransformPrtypeVar
    unset -nocomplain GiDVisitedDir
    #AddProblemtypeNamesToVar "" $GIDDEFAULT TransformPrtypeVar 0
    AddProblemtypeNamesToVar "" [file join $GIDDEFAULT problemtypes] TransformPrtypeVar 1

    set args [lsort -dictionary [array names TransformPrtypeVar]]
    catch { unset TransformPrtypeVar }

    if { [llength $args] } {
        set retval [tk_dialogComboRAM .gid.tempwinetp [_ "Enter name"] \
                        $text gidquestionhead 1 $args]
    } else {
        set retval [tk_dialogComboRAM .gid.tempwinetp [_ "Enter name"] $text \
                        gidquestionhead 1]
    }
    if { $retval == "--CANCEL--" } {
        GiD_Process Mescape
    } else {
        GiD_Process $retval
    }
}

#is_modul sould be 1 for problemtypes or 0 for GID
proc OpenPasswordEntryWindow { is_module id_machinename id_sotype id_sysinfo } {
    global GidPriv

    if { $is_module } {
        #ask password for a problemtype
        set default ""
        set retval [tk_dialogEntryPASS .gid.tempwineps [_ "Register Problem type"] $is_module $id_machinename $id_sotype $id_sysinfo $default]
        set GidPriv(pass_info) $retval
        if { $retval != ""} {
            if {$retval != "--CANCEL--" && ( $GidPriv(RegisterModuletext) == "" || $GidPriv(RegisterModuletext) == "..." ) } {
                WarnWin [_ "Before entering the password, it is necessary to select one or more Problem types"]
            }
            GiD_Info setpassword $retval
        }
    } else {
        #ask password for GiD
        set default ""
        set fin 0
        while { !$fin} {
            set retval [tk_dialogEntryPASS .gid.tempwineps [_ "Enter password window"] $is_module $id_machinename $id_sotype $id_sysinfo $default]
            if { $retval == "--CANCEL--" } {
                GiD_Info setpassword "--CANCEL--abcdef"
                set fin 1
            } elseif { $retval == "--ACADEMIC--" } {
                GiD_Info setpassword "--ACADEMIC--"
                set fin 1
            } else {
                # longitud password v7 = 24 chars, v6 y anteriores = 16
                # accept also a password-server valid IP
                if { [ string length $retval] > 20 ||
                     [regexp {([0-9]+)[.]([0-9]+)[.]([0-9]+)[.]([0-9]+):?([0-9]+)?} $retval c1 c2 c3 c4 c5] } {
                    GiD_Info setpassword $retval
                    set fin 1
                } else {
                    set msg [_ "This password is not valid for version %s" [lindex [split [ GiD_Info GiDVersion] .] 0]]
                    append msg "\n"
                    append msg [_ "Passwords and licences from version 8.x or older are incompatible with this version."]
                    append msg "\n"
                    append msg [_ "Get a temporal password at %s" $GidPriv(PassWeb)]
                    append msg "\n"
                    append msg [_ "Please, contact %s to get a new licence." $GidPriv(ContactMail)]
                    WarnWin $msg
                }
            }
        }
    }
}


proc SavePassword { pass_file machine password date module } {
    set exists 0
    if { [llength [split $password .]] == 4 } {
        #for an IP save only a word: the IP, avoiding the machine
        set buf "$password # $date Password for module '$module'"
    } else {
        set buf "$machine $password # $date Password for module '$module'"
    }
    if { [file exists $pass_file] } {
        set fp [open $pass_file r]
        if { $fp != "" } {
            while { [gets $fp line] >= 0} {
                if { [string trim $line] == $buf } {
                    set exists 1
                    break
                }
            }
            close $fp
        }
    }
    if { !$exists } {
        set fp [open $pass_file a]
        if { $fp != "" } {
            puts $fp $buf
            close $fp
        }
    }
}

#return fail==1 if some password module fail, -1 if can't be verified or 0 else
proc GiDValidateModulePassword {def_pass_file id_name academic usb_pass_file password modules disablewindows } {
    global GidPriv GIDDEFAULT

    #package require tdom

    #set pass_info $GidPriv(pass_info)
    #if {[llength $pass_info] != 2} {
    #  return 0
    #}
    #set pass [string trim [lindex $pass_info 0]]
    #set pt_list [lindex $pass_info 1]
    set pass [string trim $password]
    if {$pass eq ""} {
        # empty password is invalid
        return 0
    }
    set pt_list $modules
    if {$pass eq "--ACADEMIC--"} {
        set pass $academic
    }
    set date [clock format [clock second] -format "%Y %m %d"]
    set invalid_list [list]
    set valid_list [list]
    set unverified_list [list]  
    proc trunc_fname {name} {
        set items [file split $name]
        if {[llength $items]>3} {
            return [eval file join ... [lrange $items end-2 end]]
        }
        return $name
    }
    foreach dir $pt_list {
        if { [file exists $dir.lnk] && [ GidUtils::IsLink $dir.lnk] == 2 } {
            set dir [ GidUtils::ReadLink $dir.lnk 1]
        }
        set pass_file $def_pass_file
        # load validation routine
        set xmlfile [file join $dir [file root [file tail $dir]]].xml
        set possible_msg ""
        if {[file exists $xmlfile]} {
            set xml [tDOM::xmlReadFile $xmlfile]
            if {[info exists xmldoc]} {
                $xmldoc delete
            }
            set xmldoc [dom parse $xml]
            set root [$xmldoc documentElement]
            set vp_node [$root select Program/ValidatePassword]
            if {$vp_node ne ""} {
                set vp_script [$vp_node text]
                if {$vp_script eq ""} {
                    lappend unverified_list [list $dir [_ "Node ValidatePassword doesn't have script"]]
                    continue
                }
                # now try to validate the password
                namespace eval GiD_TmpNS set dir [list $dir]
                namespace eval GiD_TmpNS set key [list $pass]
                namespace eval GiD_TmpNS set computername $id_name
                set tcl_code [catch {
                    namespace eval GiD_TmpNS $vp_script
                } catch_res]
                namespace delete GiD_TmpNS
                if {$tcl_code == 1} {
                    lappend unverified_list \
                        [list $dir [_ "tcl error: %s" $catch_res]]
                    continue
                }
                if {[llength $catch_res] == 2} {
                    set it0 [lindex $catch_res 0]
                    if {[string is integer $it0]} {
                        if {!$it0} {
                            lappend invalid_list \
                                [list $dir [lindex $catch_res 1]]
                            continue
                        }
                        if {$it0 == 2 && [lindex $catch_res 1] ne ""} {
                            lappend valid_list \
                                [list $dir [lindex $catch_res 1]]
                            continue
                        }
                        set possible_msg [lindex $catch_res 1]
                    }
                } elseif {$catch_res eq "0"} {
                    lappend invalid_list [list $dir "password rejected"]
                } elseif {$catch_res eq "2"} {
                    # 2 means password has being written.
                    continue
                }
            } else {
                #lappend unverified_list [list $dir [_ "Node ValidatePassword does not exist"]]
            }
            set passdir_node [$root select Program/PasswordPath]
            if {$passdir_node ne ""} {
                set passdir_txt [$passdir_node text]
                if {$passdir_txt eq ""} {
                    lappend invalid_list \
                        [list $dir [_ "Node PasswordPath is empty"]]
                    continue
                }
                if {[file pathtype $passdir_txt] eq "absolute"} {
                    set dir $passdir_txt
                } else {
                    set dir [file join $dir $passdir_txt]
                }
            }
        } else {
            lappend unverified_list [list $dir [_ "The password has not been verified now. It will be verified when running the analysis code"]]
        }

        # write the password in the default way
        # now write the password info.
        set pass_file [file join $dir $pass_file]
        set exists_file [file exists $pass_file]
        if {!$exists_file} {
            if {![file writable [file dir $pass_file]]} {
                lappend invalid_list \
                    [list $dir \
                         [_ "couldn't write into %s" [trunc_fname $pass_file]]]
                continue
            }
        } elseif {![file writable $pass_file]} {
            lappend invalid_list \
                [list $dir \
                     [_ "file %s isn't writable" [trunc_fname $pass_file]]]
            continue
        }

        set dir [file normalize $dir]
        if { $usb_pass_file != {} } {
            set lst_mod [ file split $dir]
            set lst_gid [ file split $GIDDEFAULT]
            lappend lst_gid problemtypes
            set idx 0
            set fin [ llength $lst_gid]
            set fin2 [ llength $lst_mod]
            if { $fin2 < $fin} { set fin $fin2}
            for { set idx 0 } { ( $idx < $fin) && \
                                    ( [ string tolower [ lindex $lst_mod $idx]] == [ string tolower [ lindex $lst_gid $idx]])} { incr idx} {
            }
            set module_name [ eval file join [ lrange $lst_mod $idx end]]
            regsub -all { } $module_name {_} tmp_mod
            regsub -all {\\} $tmp_mod {/} tmp_mod2
            set module [ string tolower $tmp_mod2]

            SavePassword $usb_pass_file $id_name $pass $date $dir
            # y en el archivo normal tambien:
            SavePassword $pass_file $id_name $pass $date $dir
        } else {
            SavePassword $pass_file $id_name $pass $date $dir
        }
        if {$possible_msg ne ""} {
            lappend valid_list [list $dir $possible_msg]
        }
    }

    if { !$disablewindows } {
        set title [_ "Password Validation"]
        set rows [list]

        set GidPriv(RegisterModuletext) ""
        set GidPriv(RegisterModule) ""
        foreach i $invalid_list {
            set pt_dir [lindex $i 0]
            set pt_name [file root [file tail $pt_dir]]
            lappend GidPriv(RegisterModuletext) $pt_name
            lappend GidPriv(RegisterModule) $pt_dir
            lappend rows [list $pt_name [_ "fail"] [lindex $i 1]]
        }
        foreach i $unverified_list {
            set pt_dir [lindex $i 0]
            set pt_name [file root [file tail $pt_dir]]
            lappend rows [list $pt_name [_ "unverified"] [lindex $i 1]]
        }
        foreach i $valid_list {
            set pt_dir [lindex $i 0]
            set pt_name [file root [file tail $pt_dir]]
            lappend rows [list $pt_name [_ "ok"] [lindex $i 1]]
        }

        if {[llength $rows]} {
            if {[winfo exists .gid.tempwineps]} {
                set ivpw .gid.tempwineps.ivpw
            } else {
                set ivpw .gid.ivpw
            }
            if {[llength $rows]==1} {
                set i [lindex $rows 0]
                set pt_name [lindex $i 0]
                MessageDlg $ivpw -title $title -type ok \
                    -message [lindex $i 2]
            } else {

                package require tablelist_tile

                dialogwin_snit $ivpw -title $title -cancelname -
                set f [$ivpw giveframe]
                tablelist::tablelist $f.tb -width 60 \
                    -columns [list 10 [_ "Problem type"] 10 [_ "Status"] 40 [_ "Reason"]]
                grid $f.tb -sticky snew
                grid rowconfigure $f 0 -weight 1
                grid columnconfigure $f 0 -weight 1
                eval $f.tb insert end $rows
                $ivpw createwindow
                destroy $ivpw
            }
        }
    }

    set has_invalid [llength $invalid_list]
    set has_valid [llength $valid_list]
    set has_unverified [llength $unverified_list]
    if { $has_invalid > 0 } {
        set fail 1
    } else {
        if { $has_unverified > 0 } {
            set fail -1
        } else {
            set fail 0
        }
    }
    return $fail
}

proc RegisterFromFileW { } {
    global GidPriv
    if { ![info exists GidPriv(filename,RegisterFromFileW)] } {
        set GidPriv(filename,RegisterFromFileW) ""
    }   
    set types [list [list [_ "Passwords file"] ".pwd"] [list [_ "All files"] ".*"]]
    set filename [Browser-ramR passwordfile read .gid [_ "read passwords file"] \
                      $GidPriv(filename,RegisterFromFileW) $types .pwd 0]
    if { $filename != "" } {
        set GidPriv(filename,RegisterFromFileW) [file tail $filename]
        set msg [_ "Register status"]\n
        foreach item [RegisterFromFile $filename] {
            if { [lindex $item 0] == 0 } {
                set res [_ "ok"]
            } elseif { [lindex $item 0] == 1 } {
                set res [_ "fail"]
            } elseif { [lindex $item 0] == -1 } {
                #unverified
                set res "??"
            } else {
                #unexpected
                set res "!!"
            }
            set type [lindex $item 1]
            if { $type == "GID" } {
                set msgi "$GidPriv(ProgName) for [lindex $item 2] ([lindex $item 3])"
            } elseif { $type == "GID_PASSERVER" } {
                set msgi "$GidPriv(ProgName) from server [lindex $item 2]"
            } elseif { $type == "MODULE" } {
                set msgi "[lindex $item 4] for [lindex $item 2] ([lindex $item 3])"
            } else { ;#UNKNOWN
                set msgi "unknown $line"
            }
            append msg "$res ----- $msgi\n"
        }
        WarnWinText $msg
    }
}

proc RegisterFromFile { filename } {
    # sample of file contents:
    # mediador 33137efc1jqvyvy0 # 2006 01 10 Password for Problem type 'C:/gid project/problemtypes/tdyn4.10/tdyn3d.gid'
    # mediador a6b0c6561jpp4v70 # 2005 05 03 Password for module 'C:/gid project/problemtypes/Tdyn5/tdyn2d.gid'
    # mediador bq9akuu1p851cub9vnmmv2kc1g # V8 Registration date: Mar 16 2006; Expiration date: Jan  1 2035.
    # usb_17 badakuu1p851cub9vnmmv2kc1g # V7 Registration date: Mar 16 2006; Expiration date: Jan  1 2035.
    # 142.183.133.108:1625
    set res ""
    set fp [open $filename r]
    if { $fp != "" } {
        while { [gets $fp line] >= 0} {
            set line [string trim $line]
            if { [string index $line 0] == "#" } continue
            #si el comentario contiene llaves abiertas o cosas asi no seria una lista, y llength daria error!!!
            if { [llength $line] == 1 } {
                set type GID_PASSERVER
                set ip [lindex $line 0]
                set fail [gidregister GiD $ip]
            } elseif { [llength $line] > 1 } {
                set machine [lindex $line 0]
                set password [lindex $line 1]
                set comments [lrange $line 2 end]
                if { [regexp -nocase {(?:Password for module|Password for Problem type)\s+'(.*)'} $comments dummy pt] } {
                    set type MODULE
                    set ptsplit [file split $pt]
                    set pos [lsearch $ptsplit problemtypes]
                    if { $pos != -1 } {
                        set ptrelative [eval file join [lrange $ptsplit [expr $pos+1] end]]
                    } else {
                        set ptrelative $pt
                    }
                    set ptfull [file join $::GIDDEFAULT problemtypes $ptrelative]
                    set existspt 0
                    if { [file exists $ptfull] && [file isdirectory $ptfull] } {
                        set existspt 1
                    } elseif { [file exists $ptfull.lnk] && [ GidUtils::IsLink $ptfull.lnk] == 2 } {
                        set existspt 1
                        set ptfull [ GidUtils::ReadLink $ptfull.lnk 1]
                    } elseif { [file exists [file dirname $ptfull].lnk] && \
                                   [ GidUtils::IsLink [file dirname $ptfull].lnk] == 2 } {
                        set existspt 1
                        set ptname [file tail $ptfull]
                        set ptfull [file join [ GidUtils::ReadLink [file dirname $ptfull].lnk 1] $ptname]
                    }
                    if { $existspt } {
                        set fail [gidregister module $machine $password [list $ptfull]]
                    } else {
                        #molule not found
                        set fail 1
                    }
                } else {
                    #try for GiD
                    set type GID
                    set fail [gidregister GiD $machine $password]
                }
            } else {
                set type UNKNOWN
                set fail 1
            }
            
            if { $type == "GID" } {
                lappend res [list $fail $type $machine $password]
            } elseif { $type == "GID_PASSERVER" } {
                lappend res [list $fail $type $ip]
            } elseif { $type == "MODULE" } {
                lappend res [list $fail $type $machine $password $ptrelative]
            } else { ;#UNKNOWN
                lappend res [list $fail $type $line]
            }
            
        }
        close $fp
    }
    return $res
}

proc PrintTimeTable { tt } {
    upvar #0 $tt aa
    puts "\n--------------TIME TABLE--------\n"
    foreach {name val} [array get aa] {
        puts "Time for [format %-20s:%lf $name \
                [expr 1e-6*[lindex $val 0]]] seconds"
    }
}

#ChooseType == "project" or "file" or "image" or "AnyType"
#    ( each different type will have a DefaultDirectory storing the last accessed folder for that type)
#NOTE: if ChooseType == "project" then filetypes and defaultextension are set automatically for GiD
#OpenMode == "read" or "write"
#w == parent
#title == "title of window"
#DefaultFile == "Name of file"
#filetypes == list of names and extensions, e.g: {{"Jpeg Image" ".jpg .jpeg"} {"All files" ".*"} }
#defaultextension == extension to automatically ( and always) append to name, e.g: ".jpg, *.gif.jpg (although user wrote .gif!)
#defaultextension == does not select the extension from the filetypes to display
#Multiple == 1 can return multiple filenames , Multiple == 0 only one
#MoreOpts: to add to the window more settings. Must provide a list with "subtitle proc1 ?proc2?"
#  where subtitle: is a "subtitle for this frame"
#  proc1 is a procedure with prototype proc procname { frame }  with frame a parent frame already existint where pack our widgets
#                                      and can return "" or "open" to show or not this frame
#  proc2 is an optional procedure without arguments, that will be invoked to send commands to the process
#  e.g. set MoreOpts [list [_ "Import options"] CreateImportGeomOpts ProcessImportGeomOpts]
proc Browser-ram { ChooseType OpenMode { w .gid }  { title "Browser" }
                   { DefaultFile {} }  { filetypes {} } { defaultextension {} }
                   { Multiple 0 }
                   { MoreOpts {} } } {

    # Traduccion argumentos por defecto
    if { $title == "Browser" } {
        set title [_ "Browser"]
    }
    set ret [Browser-ramR $ChooseType $OpenMode $w $title $DefaultFile $filetypes $defaultextension $Multiple [lrange $MoreOpts 0 1]]


    update
    #update idletasks

    if { $ret == "" } {
        GiD_Process escape
    } else {
        
        if {[llength $MoreOpts]>2} {
            # MoreOptions[2] is responsible of inserting in .process
            # the extra arguments.
            eval [lindex $MoreOpts 2]
            if {[string index $ret 0] eq "-"} {
                GiD_Process "--"
            }
        }
        if { $ChooseType == "project" && $OpenMode == "write" } {
            set SelectedSaveVersion \
                $::gidtk::dialog::file::__tk_filedialog(typeCombo,textvar)
            if { $SelectedSaveVersion == [concat [_ "%s project" $::GidPriv(ProgName)] (*.gid)] } {
                GiD_Process "geoversion:current"
            } elseif { $SelectedSaveVersion == [concat [_ "Old %s project 7" $::GidPriv(ProgName)] (*.gid)] } {
                GiD_Process "geoversion:2.24"
            } else {
                GiD_Process "geoversion:current"
            }
        }
        GiD_Process $ret
    }
}

array set ::VXLOptions {
    ab,dir          "open"
    isov            0
    method,names    { "Marching cubes" "Uniform Hexahedra"
                      "Orthogonal Hexahedra" "Isosurface Stuffing" }
    method,codes    { "mc" "hu" "fd" "is" }
    method,current  0
}

proc VxlOptsChangeMethod { w } {
    set ::VXLOptions(method,current) [$w getvalue]
}

#
# CreateReadVxlOpts --
#
# Este proc es invocado por el dialogo de importar volumen de voxels
# (.vtk). Recibe como argumentos un frame donde se deben crear las
# opciones extras necesarias para importar los datos. El resultado del
# proc debe ser una variable donde dejar el estado del frame
# contenedor de opciones extras: open o close.
#
proc CreateReadVxlOpts { f } {
    ttk::label $f.liso -text [_ "Iso-surface"]:
    ttk::entry $f.eiso -textvariable ::VXLOptions(isov)
    ttk::label $f.lmet -text [_ "Method"]:
    ComboBox $f.cbmet -values $::VXLOptions(method,names) -editable false \
        -modifycmd "VxlOptsChangeMethod $f.cbmet"
    $f.cbmet setvalue "@$::VXLOptions(method,current)"
    grid $f.liso $f.eiso $f.lmet $f.cbmet
    return "VXLOptions(ab,dir)"
}

#
# ProcessReadVxlOpts --
#
# Este proc es invocado al aceptar el dialogo de importar de importar
# volumen de voxels (.vtk). Debe encargarse de enviar al GiD_Process
# los argumentos extras necesarios para importar los datos.
#
proc ProcessReadVxlOpts { } {
    set meth [lindex $::VXLOptions(method,codes) $::VXLOptions(method,current)]
    GiD_Process "-isovalue:$::VXLOptions(isov)" "-method:$meth" "--"
}


proc CreateImportShapefileOpts { f } {
    CreateImportGeomOpts $f
    if { ![info exists ::ImportShapefileOptions(var,out_polylines)] } {
        set ::ImportShapefileOptions(var,out_polylines) 0
    }
    ttk::checkbutton $f.chkout_polylines -text [_ "Create polylines"] -variable ::ImportShapefileOptions(var,out_polylines)
    grid $f.chkout_polylines -sticky w    
}

proc ProcessImportShapefileOpts { } {
    GiD_Process "-out_polylines:$::ImportShapefileOptions(var,out_polylines)"
    ProcessImportGeomOpts   
}

proc CreateImportXYZOpts { f } {    
    CreateImportGeomOpts $f
    if { ![info exists ::ImportXYZOptions(var,triangulate)] } {
        set ::ImportXYZOptions(var,triangulate) 0
    }    
    ttk::checkbutton $f.chktriangulate -text [_ "Triangulate"] -variable ::ImportXYZOptions(var,triangulate)
    grid $f.chktriangulate -sticky w
}

proc ProcessImportXYZOpts { } {
    GiD_Process "-triangulate:$::ImportXYZOptions(var,triangulate)"
    ProcessImportGeomOpts
}

array set ::AviMSVCOptions {
    dir "open"
    widget ""
    var 0
}

proc CreateExportAviMSVCOpts { f } {
    ttk::label $f.lqavimsvc -text [_ "Compression option"]:
    if { ![info exists ::AviMSVCOptions(var)] } { set ::AviMSVCOptions(var) 0 }
    set ::AviMSVCOptions(widget) \
        [ ttk::checkbutton $f.cbAviMSVCusePrev \
              -text [_ "Use info of previous frame"] -onvalue 1 -offvalue 0 \
              -variable ::AviMSVCOptions(var) ]
    set ::AviMSVCOptions(var) [ GiD_Set "AviMSVCUsePreviousInfo"]
    grid $f.lqavimsvc $f.cbAviMSVCusePrev -sticky "s"
    if { ![ info exists ::AviMSVCOptions(dir)]} {
        #trick to show the more options
        set ::AviMSVCOptions(dir) "open"
    }
    return "::AviMSVCOptions(dir)"
}

proc ProcessExportAviMSVCOpts { } {
    GiD_Process "-avimsvcuseprevious:[$::AviMSVCOptions(widget) get]" "--"
}

array set ::JPEGOptions {
    dir "open"
    widget ""
}

proc CreateExportJPEGOpts { f } {
    ttk::label $f.lquality -text [_ "JPEG quality"]:
    set ::JPEGOptions(widget) \
        [ gidscale $f.quality -from 0 -to 100 -orient "horizontal" \
        -showbuttons 0 ]
    $f.quality set [ GiD_Set "JPEGQuality"]
    grid $f.lquality $f.quality -sticky "s"
    if { ![ info exists ::JPEGOptions(dir)]} {
        #trick to show the more options
        set ::JPEGOptions(dir) "open"
    }
    return "::JPEGOptions(dir)"
}

proc ProcessExportJPEGOpts { } {
    GiD_Process "-jpegquality:[$::JPEGOptions(widget) get]" "--"
}

array set ::FLVOptions {
    dir "open"
    widget ""
}

proc CreateExportFLVOpts { f } {
    # set CCBG [ CCColorActivo [$f cget -background]]
    ttk::label $f.lblocksize -text [_ "Flash video block size"]:
    set ::FLVOptions(widget) \
        [ gidscale $f.blocksize \
              -from 16 -to 256 -resolution 16 \
              -showbuttons 0 \
              -orient "horizontal"]
    $f.blocksize set [ GiD_Set "FLVBlockSize"]
    grid $f.lblocksize $f.blocksize -sticky "s"
    if { ![ info exists ::FLVOptions(dir)]} {
        #trick to show the more options
        set ::FLVOptions(dir) "open"
    }
    return "::FLVOptions(dir)"
}

proc ProcessExportFLVOpts { } {
    GiD_Process "-flvblocksize:[ $::FLVOptions(widget) get]" "--"
}

array set ::AnimationOptions {
    dir "open"
    jpegwidget ""
    flvwidget ""
    msvcwidget ""
    msvc_var 0
}

proc CreateAnimationOpts { f } {
    set CCBG [ CCColorActivo [$f cget -background]]
    ttk::label $f.lquality -text [_ "AVI/msjpg quality"]:
    set ::AnimationOptions(jpegwidget) \
        [ gidscale $f.quality -from 0 -to 100 \
              -showbuttons 0 \
              -orient "horizontal" ]
    $f.quality set [ GiD_Set "JPEGQuality"]
    grid $f.lquality $f.quality -sticky "s" -pady 0 -padx 2
    gridconfigure $f.lquality -sticky w
    
    ttk::label $f.lqavimsvc -text [_ "AVI/msvc compression"]:
    if { ![info exists ::AnimationOptions(msvc_var)] } { set ::AnimationOptions(msvc_var) 0 }
    set ::AnimationOptions(msvcwidget) \
        [ ttk::checkbutton $f.cbAviMSVCusePrev \
              -text [_ "use info of previous frame"] -onvalue 1 -offvalue 0 \
              -variable ::AnimationOptions(msvc_var)]
    set ::AnimationOptions(msvc_var) [ GiD_Set "AviMSVCUsePreviousInfo"]
    grid $f.lqavimsvc $f.cbAviMSVCusePrev -sticky "s" -pady 2 -padx 2
    gridconfigure $f.lqavimsvc -sticky w
    
    ttk::label $f.lblocksize -text [_ "Flash video block size"]:
    set ::AnimationOptions(flvwidget) \
        [ gidscale $f.blocksize -from 16 -to 256 -resolution 16 \
              -showbuttons 0 \
              -orient "horizontal" ]
    $f.blocksize set [ GiD_Set "FLVBlockSize"] 
    grid $f.lblocksize $f.blocksize -sticky "s" -pady 0 -padx 2
    gridconfigure  $f.lblocksize -sticky w
    if { ![ info exists ::AnimationOptions(dir)]} {
        #trick to show the more options
        set ::AnimationOptions(dir) "open"
    }
    return "::AnimationOptions(dir)"
}

proc ProcessAnimationOpts { } {
    GiD_Process "-jpegquality:[ $::AnimationOptions(jpegwidget) get]" \
        "-avimsvcuseprevious:[ $::AnimationOptions(msvcwidget) get]" \
        "-flvblocksize:[ $::AnimationOptions(flvwidget) get]" "--"
}

array set ::GIFOptions {
    dir "open"
    widget ""
}

proc CreateExportGIFOpts { f } {
    set textoAyuda [_ "Dithering uses a noise function to prevent color banding on images."]
    ttk::label $f.ldither -text [_ "Dither mode"]:
    ttk::label $f.ldither2 -text "( $textoAyuda )"
    set fmt [_ "Red %d, Green %d, Blue %d"]
    ttk::radiobutton $f.r1dither -text [_ "None"] -variable ::GIFOptions(dither) -value "None"
    ttk::radiobutton $f.r2dither -text [ format $fmt 6 6 6] -variable ::GIFOptions(dither) -value Dither666
    ttk::radiobutton $f.r3dither -text [ format $fmt 5 9 5] -variable ::GIFOptions(dither) -value Dither595
    set ::GIFOptions(dither) [ GiD_Set "GIFDithering"]
    grid $f.ldither -sticky "ws"
    grid $f.ldither2 -sticky "ws" -columnspan 4
    grid $f.r1dither $f.r2dither $f.r3dither -sticky "ews" -padx 4
    grid configure $f.r1dither -column 1 -row 2
    grid configure $f.r2dither -column 2 -row 2
    grid configure $f.r3dither -column 3 -row 2

    # set textoAyuda [_ "Dithering uses a noise function to \nprevent color banding on images."]
    # setTooltip $f $textoAyuda

    if { ![ info exists ::GIFOptions(dir)]} {
        #trick to show the more options
        set ::GIFOptions(dir) "open"
    }
    return "::GIFOptions(dir)"
}

proc ProcessExportGIFOpts { } {
    GiD_Process "-dither:$::GIFOptions(dither)" "--"
}

proc CreateExportSTLOpts { f } {
    ttk::label $f.ltype -text [_ "STL file type"]:
    ttk::radiobutton $f.r1type -text [_ "Ascii"] -variable ::STLOptions(type) -value "Ascii"
    ttk::radiobutton $f.r2type -text [_ "Binary"] -variable ::STLOptions(type) -value "Binary"
    if { ![info exists ::STLOptions(quads4triangs)] } { set ::STLOptions(quads4triangs) 0 }
    ttk::checkbutton $f.quads4triangs -text [_ "Divide quads to 4 triangles"] \
        -variable ::STLOptions(quads4triangs) -onvalue 1 -offvalue 0
    set ::STLOptions(type) [ GiD_Set "STLExportType"]
    set ::STLOptions(quads4triangs) [ GiD_Set "STLQuads4Triangles"]
    grid $f.ltype $f.r1type $f.r2type -sticky "ews" -padx 4
    grid configure $f.ltype -sticky "ws"
    grid $f.quads4triangs -sticky "ews" -padx 4 -columnspan 3
    if { ![ info exists ::STLOptions(dir)]} {
        #trick to show the more options
        set ::STLOptions(dir) "open"
    }
    return "::STLOptions(dir)"
}

proc ProcessExportSTLOpts { } {
    GiD_Process "-type:$::STLOptions(type)" "-quads4triangs:$::STLOptions(quads4triangs)" "--"
}

proc CreateExportPLYOpts { f } {
    ttk::label $f.ltype -text [_ "PLY file type"]:
    ttk::radiobutton $f.r1type -text [_ "Ascii"] -variable ::PLYOptions(type) -value "Ascii"
    ttk::radiobutton $f.r2type -text [_ "Binary"] -variable ::PLYOptions(type) -value "Binary"
    set ::PLYOptions(type) [ GiD_Set "PLYExportType"]
    grid $f.ltype $f.r1type $f.r2type -sticky "ews" -padx 4
    grid configure $f.ltype -sticky "ws"
    if { ![ info exists ::PLYOptions(dir)]} {
        #trick to show the more options
        set ::PLYOptions(dir) "open"
    }
    return "::PLYOptions(dir)"
}

proc ProcessExportPLYOpts { } {
    GiD_Process "-type:$::PLYOptions(type)"
}

proc CreateImportXYZasciiOpts { f } {
    if { ![ info exists ::XYZasciiOptions(comment)]} {
        set ::XYZasciiOptions(comment) ""
    }
    ttk::label $f.lcomment -text [_ "Comments start with"]:
    ttk::entry $f.ecomment -textvariable ::XYZasciiOptions(comment)
    ttk::label $f.lcomment2 -text [_ "until the end of the line."]
    grid $f.lcomment $f.ecomment $f.lcomment2 -sticky "ws" -padx 4
    grid configure $f.ecomment -sticky "ews"

    if { ![ info exists ::XYZasciiOptions(format)]} {
        set ::XYZasciiOptions(format) ""
    }
    ttk::label $f.linputFormat -text [_ "Format of lines"]:
    ttk::entry $f.einputFormat -textvariable ::XYZasciiOptions(format)

    set textoAyuda [_ "Enter format to parse X, Y and Z coordinates\nFor instance:\n\
\t%g %g %g\t\tto parse X Y Z with spaces in between\n\
\t%*d %g %g %g\tto skip the initial index\n\
\t%g, %g, %g\t\tto parse X Y Z with commas"]

    setTooltip $f.einputFormat $textoAyuda
    ttk::button $f.bh -image [ gid_themes::GetImage "help.png" small_icons] \
        -command "showTooltip $f.bh [ list [ list $textoAyuda]]"

    # ttk::frame $f.fDelaunay
    if { ![ info exists ::XYZasciiOptions(delaunay)]} {
        set ::XYZasciiOptions(delaunay) no
    }
    ttk::checkbutton $f.cbDelaunay -text [_ "Create Delaunay mesh after import."] \
        -onvalue "yes" -offvalue "no" \
        -variable ::XYZasciiOptions(delaunay)
    set txtDelaunay [_ "Click here to triangulate or tetraedrizate the input point cloud using delaunay."]
    setTooltip $f.cbDelaunay $txtDelaunay

    grid $f.linputFormat $f.einputFormat $f.bh -sticky "w" -padx 4
    grid configure $f.einputFormat -sticky "ew"
    grid $f.cbDelaunay -sticky w -padx 4 -columnspan 3
    # grid $f.linputFormat2 -sticky "wsne" -padx 10 -columnspan 3

    # grid rowconfigure $f 0 -weight 1
    # grid columnconfigure $f 0 -weight 1

    if { ![ info exists ::XYZasciiOptions(dir)]} {
        #trick to show the more options
        set ::XYZasciiOptions(dir) "open"
    }
    return "::XYZasciiOptions(dir)"
}

proc ProcessImportXYZasciiOpts { } {
    if { [ info exists ::XYZasciiOptions(comment)] && ( $::XYZasciiOptions(comment) != "")} {
        GiD_Process "-commentDelimiter:$::XYZasciiOptions(comment)"
    }

    if { [ info exists ::XYZasciiOptions(format)] && ( $::XYZasciiOptions(format) != "")} {
        GiD_Process "-inputFormat:$::XYZasciiOptions(format)"
    }
    if { [ info exists ::XYZasciiOptions(delaunay)] && ( $::XYZasciiOptions(delaunay) != "")} {
        GiD_Process "-createDelaunay:$::XYZasciiOptions(delaunay)"
    }

    GiD_Process "--"
}

proc CreatePostBinaryReadOpts { f } {
    ttk::checkbutton $f.cbDeleteIndex -text [_ "Rebuild binary results index file."] \
        -variable ::PostBinaryReadOpts(rebuildIndex)
    set ::PostBinaryReadOpts(rebuildIndex) 0
    grid $f.cbDeleteIndex -sticky "ews" -padx 4
    if { ![ info exists ::PostBinaryReadOpts(dir)]} {
        #trick to show the more options
        set ::PostBinaryReadOpts(dir) "open"
    }
    return "::PostBinaryReadOpts(dir)"
}

proc ProcessPostBinaryReadOpts { } {
    GiD_Process "-rebuildIndex:$::PostBinaryReadOpts(rebuildIndex)"
}

proc GetPostBinaryReadOpts { } {
    return "-rebuildIndex:$::PostBinaryReadOpts(rebuildIndex)"
}

array set ::ImportGeomOptions {
    dir "close"
    var,collapse 0
    var,ignore 0
    var,tolerance 0
    var,autotol 0
    widget,f ""
}

proc OnCheckIfCollapse { } {
    set f $::ImportGeomOptions(widget,f)

    if {$::ImportGeomOptions(var,collapse)} {
        $f.lf.iglayer configure -state "normal"
        $f.lf.autotol configure -state "normal"
        OnCheckAutoTol
    } else {
        $f.lf.iglayer configure -state "disabled"
        $f.lf.autotol configure -state "disabled"
        $f.lf.etol    configure -state "disabled"
    }
}

proc OnCheckAutoTol { } {
    set f $::ImportGeomOptions(widget,f)

    set state [expr {$::ImportGeomOptions(var,autotol)?"disabled":"normal"}]
    $f.lf.etol    configure -state $state
}

proc CreateImportGeomOpts { f } {
    set ::ImportGeomOptions(widget,f) $f
    if { ![info exists ::ImportGeomOptions(var,collapse)] } { set ::ImportGeomOptions(var,collapse) 0 }
    ttk::checkbutton $f.chkCollapse -text [_ "Automatic collapse after import"] \
        -variable ::ImportGeomOptions(var,collapse) \
        -command OnCheckIfCollapse
    ttk::labelframe $f.lf -labelwidget $f.chkCollapse
    if { ![info exists ::ImportGeomOptions(var,ignore)] } { set ::ImportGeomOptions(var,ignore) 0 }
    ttk::checkbutton $f.lf.iglayer -text [_ "Collapse ignoring layers"] \
        -variable ::ImportGeomOptions(var,ignore)
    if { ![info exists ::ImportGeomOptions(var,autotol)] } { set ::ImportGeomOptions(var,autotol) 0 }
    ttk::checkbutton $f.lf.autotol -text [_ "Use automatic collapse tolerance"] \
        -variable ::ImportGeomOptions(var,autotol) \
        -command OnCheckAutoTol
    ttk::label $f.lf.ltol -text [_ "Tolerance"]:
    ttk::entry $f.lf.etol -textvariable ::ImportGeomOptions(var,tolerance)
    set ::ImportGeomOptions(var,collapse) [ GiD_Set AutoCollapseAfterImport]
    set ::ImportGeomOptions(var,ignore) [ GiD_Set CollapseIgnoringLayers]
    set ::ImportGeomOptions(var,tolerance) [ GiD_Set ImportTolerance]
    set ::ImportGeomOptions(var,autotol) [ GiD_Set AutoImportTolerance]
    OnCheckIfCollapse
    grid columnconfigure $f 1 -weight 1
    grid $f.lf.autotol -sticky w -columnspan 2
    grid $f.lf.ltol $f.lf.etol
    grid $f.lf.iglayer -sticky w -columnspan 2
    grid $f.lf -sticky "snew" -columnspan 3
    return "ImportGeomOptions(dir)"
}

proc ProcessImportGeomOpts { } {
    GiD_Process \
        "-collapse:$::ImportGeomOptions(var,collapse)" \
        "-ignorelayer:$::ImportGeomOptions(var,ignore)" \
        "-tolerance:$::ImportGeomOptions(var,tolerance)" \
        "-autotol:$::ImportGeomOptions(var,autotol)" \
        "--"
}

proc CreateSaveAsOpts { f } {
    global SaveAsAlsoResults

    if { ![info exists SaveAsAlsoResults] } {
        set SaveAsAlsoResults 0
    }
    if { ![info exists SaveAsAlsoResults] } { set SaveAsAlsoResults 0 }
    ttk::checkbutton $f.alsores -text [_ "Include results"] \
        -variable SaveAsAlsoResults
    grid $f.alsores -sticky w
}

proc ProcessSaveAsOpts { } {
    GiD_Process "-alsoresults:${::SaveAsAlsoResults}" "--"
}

proc SaveAsOtherKnownFiles { path_old path_new } {
    #depending on the order invoking commands the destination folder already not exists and must be created 
    set folder_src $path_old.gid
    set folder_dst $path_new.gid
    if { ![file isdirectory $folder_dst] } {
        file mkdir $folder_dst
    }   

    #other files that are not written from the internal save
    #.bgi - background image
    #.spd - specific problemtype data
    #set known_extensions ".bgi .spd" 
    #avoid copy the .spd, else with 'save as' could overwrite the memory file with old file
    #and now the .bgi is saved from GiD without need to do this file copy
    #then this procedure do nothing
    set known_extensions "" ;
    set name_old [file tail $path_old]   
    set src_pref [file join $folder_src $name_old]
    set post_list {}
    foreach ext $known_extensions {
        lappend post_list {*}[glob -nocomplain -path $src_pref *$ext]
    }
    set name_new [file tail $path_new]    
    foreach src $post_list {
        set fname [file tail $src]        
        set fext [file extension $fname]
        set dest [file join $folder_dst $name_new]$fext
        file copy -force $src $dest
    }
}

proc SaveAsResults { path_old path_new } {
    #other posprocess results files that are not written from the internal save
    #.post.res 
    #.post.msh
    #.post.lst
    #.flavia.res
    #.flavia.msh
    set name_old [file tail $path_old]
    append path_old ".gid"
    set src_pref [file join $path_old $name_old]
    set post_list [glob -nocomplain -path $src_pref "*.post.*"]
    set post_lits1 [glob -nocomplain -path $src_pref "*.flavia.*"]
    if {[llength $post_lits1]} {
        set post_list [ concat $post_list $post_lits1]
    }
    set name_new [file tail $path_new]
    append path_new ".gid"
    foreach src $post_list {
        set fname [file tail $src]       
        regexp "^(${name_old})(.+)" $fname dummy froot fext
        set dest [file join $path_new $name_new]$fext
        file copy -force $src $dest
    }
}

proc GetPrjThumbnail { gidprj }  {
    set name [file root [file tail $gidprj]]
    return [file join $gidprj $name].png
}

proc GetImagePath { img_path }  {
    return $img_path
}

proc GetPostThumbnail { post_file } {
    return [file root $post_file].png
}

proc GetThumbnailCmd { filetypes } {
    if {[lindex [lindex $filetypes 0] 0] eq "GiD postprocess"} {
        return GetPostThumbnail
    }
    foreach {ft ext} $filetypes {
        if {[lsearch {GIF JPEG PNG TGA TIFF Image} [lindex $ft 0]]!=-1} {
            return GetImagePath
        }
    }
    return ""
}

proc Browser-ramR { ChooseType OpenMode {w .gid}  {title ""}
                    {DefaultFile {}} {filetypes {}} {defaultextension {}}
                    {Multiple 0} {MoreOpts {}} } {
    global DefaultSearchDirectoryP

    # Se traduce el parametro por defecto
    if { $title == "" } {
        set title [_ "Browser"]
    }

    set filetype [ string tolower $ChooseType]

    if { $ChooseType == "project" } {
        if { ![info exists DefaultSearchDirectoryP] || \
                 ![file isdirectory $DefaultSearchDirectoryP]} {
            set DefaultSearchDirectoryP [pwd]
        }
        set deft $DefaultSearchDirectoryP
    } else {
        if { ![ info exists ::DefaultDirectories($filetype)] || \
                 ![ file isdirectory $::DefaultDirectories($filetype)] } {
            # old compatibility, if !exists $filetype & exist (file) use it
            if { [ info exists ::DefaultDirectories(file)] && \
                     [ file isdirectory $::DefaultDirectories(file)] } {
                set ::DefaultDirectories($filetype) $::DefaultDirectories(file)
            } else {
                set ::DefaultDirectories($filetype) [pwd]
            }
        }
        set deft $::DefaultDirectories($filetype)
    }

    if { $OpenMode == "read" } {
        set comm [ list ::gidtk::dialog::file:: open]
    } else {
        set comm [ list ::gidtk::dialog::file:: save]
    }
    lappend comm -title $title -initialdir $deft -parent $w

    if { $Multiple } {
        lappend comm -multiple 1
    }

    if { $ChooseType == "project" } {
        lappend comm -previewcmd GetPrjThumbnail
        if { $OpenMode == "read" } {
            set types [list \
                           [list [_ "%s project" $::GidPriv(ProgName)] {.gid}]]
            lappend comm \
                -filetypes $types -dirprojectext .gid \
                -defaultextension .gid
        } else {
            set types [list \
                           [list [_ "%s project" $::GidPriv(ProgName)] {.gid}]\
                           [list [_ "Old %s project 7" $::GidPriv(ProgName)] {.gid}]]
            lappend comm \
                -filetypes $types -dirprojectext .gid -defaultextension .gid
        }
    } else {
        #filename, not GiD project
        if { $filetypes != "" } {
            lappend comm -filetypes $filetypes \
                -previewcmd [ GetThumbnailCmd $filetypes]
        }
        if { $defaultextension != "" } {
            lappend comm -defaultextension $defaultextension
        }
    }

    if { $DefaultFile != "" } {
        set _dir_ [ file dir $DefaultFile ]
        if { ( $_dir_ != ".") && (  $_dir_ != "")} {
            lappend comm -initialdir $_dir_
        }
        set _file_ [ file tail $DefaultFile ]
        lappend comm -initialfile $_file_
    }

    if {$MoreOpts ne ""} {
        lappend comm -moreopt $MoreOpts
    }
    set fileName [eval $comm]
    set filetype [ string tolower $ChooseType]
    if { $fileName != "" } {
        if { $ChooseType == "project" } {
            set DefaultSearchDirectoryP [file dirname $fileName]
        } else {
            set file1 $fileName
            if { $Multiple} {
                set file1 [ lindex $fileName 0]
            }
            set ::DefaultDirectories($filetype) [file dirname $file1]
        }
    }
    update
    update idletasks
    return $fileName
}

proc TopMenuFrame { {action ""} { w .gid.menu } } {
    global GidPriv tcl_platform

    if { $action == "" } {
        if { ![info exists GidPriv(PrePostTopMenuWindowGeom)] } {
            set action INSIDE
        } else {
            set action [lindex $GidPriv(PrePostTopMenuWindowGeom) 0]
        }
    }

    if { $action == "NONE" } {
        set GidPriv(PrePostTopMenuWindowGeom) "NONE {} 1 TopMenuFrame"
        if { [winfo exists $w] } { destroy $w }
        .gid configure -menu ""
        return        
    } elseif { $action == "INSIDE" } {
        #atencion, No mover la creacion del frame .gid.topm mas abajo (dentro del siguiente if por ejemplo)
        # sino no va bien algo como esto, no se ven los botones del menu:
        # set GidPriv(MenuType) "generic"
        # TopMenuFrame
        # (al llamar por segunda vez a TopMenuFrame ya se verian los botones)
        if { $GidPriv(MenuType) == "generic" } {
            if { ![winfo exists .gid.topm] } {
                #create a frame with the menu buttons
                ttk::frame .gid.topm
                set ::GiDTBLayout(.gid.topm) {}
            }
        }
        
        if { [winfo exists $w] } {
            destroy $w
        }

        ttk::frame $w
        

        set GidPriv(PrePostTopMenuWindowGeom) "INSIDE {} 1 TopMenuFrame"
        
        if { $GidPriv(MenuType) == "generic" } {
            #grid the frame with the menu buttons
            if { [grid info .gid.topm] == "" } {
                grid .gid.topm -row 0 -column 0 -columnspan 4 -sticky "snew"
                grid columnconfigure .gid.topm 0 -weight 1
            }
            if { [grid info $w] == "" } {
                GridInside PrePostTopMenuWindowGeom $w .gid.topm "we"
            }
            #remove the windows menu if exist
            if { [[winfo toplevel $w] cget -menu] != "" } {
                [winfo toplevel $w] configure -menu ""
            }
        } else {
            #use "native" menus
            #remove the unix frame with the menu buttons
            if { [winfo exists .gid.topm] } {
                destroy .gid.topm
            }
        }
    } else {
        if { ![info exists GidPriv(PrePostTopMenuWindowGeom)] || \
                 [lindex $GidPriv(PrePostTopMenuWindowGeom) 1] == "" } {
            set hh [winfo x .gid]
            set vv [expr [winfo y .gid]+25]
            set GidPriv(PrePostTopMenuWindowGeom) \
                "OPEN [winfo width .gid]x25+$hh+$vv 1 TopMenuFrame"
        }
        catch {DestroySlave $w}
        InitWindow $w $GidPriv(ProgName) PrePostTopMenuWindowGeom TopMenuFrame
        if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0
        wm transient $w .gid
    }
    GiDMenu::UpdateMenus    
    if { [winfo class $w] == "Toplevel" } {
        foreach i [bind .gid] {
            bind $w $i [bind .gid $i]
        }
    }
}

proc UpdateCoordFrameView { show } {
    if { $show } {
        pack forget .gid.comm.fle
        pack forget .gid.comm.fwarn
        pack .gid.comm.fcoord -fill y -side right
        pack .gid.comm.fle -fill x -side bottom -expand yes -pady 2 -padx 2
        pack .gid.comm.fwarn -fill both -side top -expand yes        
    } else {
        pack forget .gid.comm.fcoord        
    }
}

proc UpdateOpenGLIcons { w} {
    if { $::GidPriv(SoftwareOpenGL)} {
        $w.openGLstate1 configure -image [ gid_themes::GetImage acc1dis.png small_icons]
        # $w.openGLstate2 configure -image [ gid_themes::GetImage acc2dis.png]
        # $w.openGLstate3 configure -image [ gid_themes::GetImage acc3dis.png]
        # $w.openGLstate4 configure -image [ gid_themes::GetImage acc4dis.png]
        setTooltip $w.openGLstate1 [_ "Safe visualization - click to change mode"]
        #setTooltip $w.openGLstate2 [_ "Safe visualization - click to change mode"]
        #setTooltip $w.openGLstate3 [_ "Safe visualization - click to change mode"]
        #setTooltip $w.openGLstate4 [_ "Safe visualization - click to change mode"]
    } else {
        $w.openGLstate1 configure -image [ gid_themes::GetImage acc1.png small_icons]
        # $w.openGLstate2 configure -image [ gid_themes::GetImage acc2.png]
        # $w.openGLstate3 configure -image [ gid_themes::GetImage acc3.png]
        # $w.openGLstate4 configure -image [ gid_themes::GetImage acc4.png]
        setTooltip $w.openGLstate1 [_ "Fast visualization - click to change mode"]
        # setTooltip $w.openGLstate2 [_ "Fast visualization - click to change mode"]
        # setTooltip $w.openGLstate3 [_ "Fast visualization - click to change mode"]
        # setTooltip $w.openGLstate4 [_ "Fast visualization - click to change mode"]
    }
}

proc BottomEntryFrame { {action ""} { w .gid.comm } } {
    global GidPriv tcl_platform GIDDEFAULT

    #     if { $action == "" && [winfo exists $w] } { return }

    if { [winfo exists $w.fwarn.list] } {
        set ListboxContents [$w.fwarn.list get 0 end]
    }

    if { $action == "" } {
        if { [winfo exists $w] } { return }
        if { ![info exists GidPriv(PrePostEntryWindowGeom)] } {
            set action INSIDE
        } else {
            set action [lindex $GidPriv(PrePostEntryWindowGeom) 0]
        }
    }

    if { $action == "NONE" } {
        catch {DestroySlave $w}
        set GidPriv(PrePostEntryWindowGeom) "NONE {} 1 BottomEntryFrame"        
        return
    } elseif { $action == "INSIDE" } {
        if { [winfo exists $w] } {
            if { [winfo class $w] != "frame" && [winfo class $w] != "Frame" } {
                destroy $w
            } else {
                return
            }
        }        
        ttk::frame $w
        set GidPriv(PrePostEntryWindowGeom) "INSIDE {} 1 BottomEntryFrame"
        GridInside PrePostEntryWindowGeom $w .gid.bottomc "we"
    } else {
        if { ![info exists GidPriv(PrePostEntryWindowGeom)] || \
                 [lindex $GidPriv(PrePostEntryWindowGeom) 1] == "" } {
            set hh [winfo x .gid]
            set vv [expr [winfo y .gid]+[winfo height .gid]+25]
            set GidPriv(PrePostEntryWindowGeom) \
                "OPEN [winfo width .gid]x100+$hh+$vv 1 BottomEntryFrame"
        }
        catch {DestroySlave $w}
        InitWindow $w [_ "Enter commands"] PrePostEntryWindowGeom BottomEntryFrame
        if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0

        foreach i [bind .gid] {
            bind $w $i [bind .gid $i]
        }
        if { $::tcl_platform(platform) != "windows" } {
            bind .gid <FocusIn> "catch \"focus $w.e\" "
            bind $w <Destroy> "+ bind .gid <FocusIn> {}"
        }        
    }

    
    # Command line of main window
    ttk::frame $w.fle -style ForcedFrame
    ttk::label $w.l -text [_ "Command"]: -style ForcedLabel
    bind $w.l <1> "MenuInCommandButton $w.e %X %Y"
    ttk::entry $w.e -style ForcedEntry
    if { ![info exists ::GidPriv(Grid,Show)] } { set ::GidPriv(Grid,Show) 0 }
    ttk::checkbutton $w.grid -image [ gid_themes::GetImage grid.png small_icons] -variable ::GidPriv(Grid,Show) -style IconButton    
    proc UpdateGridShow { } {
        if { [ GiD_Set Grid(Show)] != $::GidPriv(Grid,Show) } {
            GiD_Set Grid(Show) $::GidPriv(Grid,Show)
        }
        set ::ChangeVarInfo(Grid,Show) $::GidPriv(Grid,Show)
        GiD_Redraw
    }
    
    proc UpdateGridActive { } {    
        if { [ GiD_Set Grid(Active)] != $::GidPriv(Grid,Active) } {
            GiD_Set Grid(Active) $::GidPriv(Grid,Active)
        }
        set ::ChangeVarInfo(Grid,Active) $::GidPriv(Grid,Active)
    }
    trace add variable ::GidPriv(Grid,Show) write "UpdateGridShow ;#"
    trace add variable ::GidPriv(Grid,Active) write "UpdateGridActive ;#"
    #label $w.lcoord -background $GidPriv(Color,ToolbarBg) -textvariable GidPriv(Coordinates)

    ttk::button $w.openGLstate1 -image [ gid_themes::GetImage acc1.png small_icons] \
        -command "InitialConfiguration 0 1 0" -style IconButton

        
    # button $w.openGLstate2 -image [ gid_themes::GetImage acc2.png] \
        #         -borderwidth 0 -padx 0 -pady 0 -relief flat \
        #         -command "InitialOpenGLConfiguration 0"
    # button $w.openGLstate3 -image [ gid_themes::GetImage acc3.png] \
        #         -borderwidth 0 -padx 0 -pady 0 -relief flat \
        #         -command "InitialOpenGLConfiguration 0"
    # button $w.openGLstate4 -image [ gid_themes::GetImage acc4.png] \
        #         -borderwidth 0 -padx 0 -pady 0 -relief flat \
        #         -command "InitialOpenGLConfiguration 0"
    trace add variable ::GidPriv(SoftwareOpenGL) write "UpdateOpenGLIcons $w ; #"

    set ::GidPriv(SoftwareOpenGL) $::GidPriv(SoftwareOpenGL)

    ttk::frame $w.fwarn
    # -style ForcedFrame
    ttk::scrollbar $w.fwarn.yscroll  -takefocus 0 \
        -command "$w.fwarn.list yview" -style ForcedScrollbar
    #pseudottk::
    tk::listbox $w.fwarn.list -yscroll "$w.fwarn.yscroll set" -takefocus 0

    if { [info exists ListboxContents] } {
        foreach i $ListboxContents {
            $w.fwarn.list insert end $i
        }
        $w.fwarn.list see end
    }

    if {[winfo class $w] != "Toplevel" } {
        $w.fwarn.list configure -width 20 -height 2
    }

    #coordenadas en posicion vertical
    ttk::frame $w.fcoord  -style ForcedFrame -borderwidth 2
    set GidPriv(CoordFrame) $w.fcoord
    
    $w.fwarn.list configure -selectmode single
    pack $w.fwarn.yscroll -side right -fill y
    pack $w.fwarn.list -expand yes -fill both -side left -padx {6 0} -pady 1

    #pack .gid.comm.fcoord -fill y -side right
    pack $w.fle -fill x -side bottom -expand yes -pady {2 0} -padx 0
    pack $w.fwarn -fill both -side top -expand yes

    # grid $w.l $w.e $w.openGLstate1 $w.openGLstate2 $w.openGLstate3 $w.openGLstate4 $w.grid -in $w.fle -pady 0 -padx 5 -sticky ew
    grid $w.l $w.e $w.openGLstate1 $w.grid -in $w.fle -pady 0 -padx 5 -sticky ewns
    grid configure $w.l -sticky w
    grid configure $w.openGLstate1 -sticky e -padx 2
    # grid configure $w.openGLstate2 -sticky e -padx 0
    # grid configure $w.openGLstate3 -sticky e -padx 0
    # grid configure $w.openGLstate4 -sticky e -padx 0
    grid configure $w.grid -sticky e -padx 2

    proc ShowMenuGrid { x y preffocus } {
        set w .gid.__gridmenu
        if { [winfo exists $w] } { destroy $w }
        menu $w
        set UnderLineList {}
        set text [_ "Auxiliar grid to aid in points definition"]
        set msg [_ "Help"]
        set under [FindUnderChar msg UnderLineList]
        $w add command -label $msg -underline $under -command [list DisplayGidHelp $w $text menu $x $y]

        if { [ GiD_Set Grid(Show)] == "0" } {
            set msg [_ "Show grid"]
            set under [FindUnderChar msg UnderLineList]
            $w add command -label $msg -underline $under -command {set ::GidPriv(Grid,Show) 1}
        } else {
            set msg [_ "Hide grid"]
            set under [FindUnderChar msg UnderLineList]
            $w add command -label $msg -underline $under -command {set ::GidPriv(Grid,Show) 0}
        }
        if { [ GiD_Set Grid(Active)] == "0" } {
            set msg [_ "Enable snap"]
            set under [FindUnderChar msg UnderLineList]
            $w add command -label $msg -underline $under -command {set ::GidPriv(Grid,Active) 1}
        } else {
            set msg [_ "Disable snap"]
            set under [FindUnderChar msg UnderLineList]
            $w add command -label $msg -underline $under -command {set ::GidPriv(Grid,Active) 0}
        }
        if { [ GiD_Set Grid(DrawAxis)] == "0" } {
            set msg [_ "Show axis"]
            set under [FindUnderChar msg UnderLineList]
            $w add command -label $msg -underline $under -command {GiD_Set Grid(DrawAxis) 1 ; GiD_Redraw}
        } else {
            set msg [_ "Hide axis"]
            set under [FindUnderChar msg UnderLineList]
            $w add command -label $msg -underline $under -command {GiD_Set Grid(DrawAxis) 0 ; GiD_Redraw}
        }
        $w add separator
        set msg [_ "Settings"]...
        set under [FindUnderChar msg UnderLineList]
        if { $preffocus == "grid" } {
            $w add command -label $msg -underline $under -command \
        {ChangeVariables grid}
                #{ChangeVariables .gid.wvar Grid ; focus .gid.wvar.f.nb.fGrid.frame1.cb1}
        } else {
            $w add command -label $msg -underline $under -command \
                {ChangeVariables grid}
        #{ChangeVariables .gid.wvar Grid ; focus .gid.wvar.f.nb.fGrid.frame1.cb2}
        }
        GiD_PopupMenu $w $x $y
    }

    bind $w.grid <3> [list ShowMenuGrid %X %Y grid]

    grid columnconf $w.fle 1 -weight 1

    #pack forget .gid.comm.fcoord    


    set helptxt [_ "Here are output the process messages. At the same time, it is\
            possible to enter written commands or point coordinates or entities\
            labels. Use <Tab> to expand commands."]
    #set nottimepopup 1
    #GidHelp "$w.fwarn $w.e" $helptxt $nottimepopup

    proc WarnMessagesContextualMenu { helptxt listbox w idx0 x y } {

        $listbox selection clear 0 end
        $listbox selection set $idx0
        set idx [$listbox curselection]
        if { [llength $idx] == 1 } {
            set txt [$listbox get $idx]
            if { [regexp {x=(\S+)\s*,\s*y=(\S+)\s*,\s*z=(\S+)} $txt {} xc yc zc] } {
                set txtpoint "$xc $yc $zc"
            }
        }
        catch { destroy .gid.__helpmenu }
        menu .gid.__helpmenu
        set UnderLineList {}
        if { [info exists txt] } {
            set msg [_ "Copy"]
            set under [FindUnderChar msg UnderLineList]
            .gid.__helpmenu add command -label $msg -underline $under -command \
                "clipboard clear ; [list clipboard append $txt]"
        }
        if { [info exists txtpoint] } {
            set msg [_ "Copy point coords"]
            set under [FindUnderChar msg UnderLineList]
            .gid.__helpmenu add command -label $msg -underline $under -command \
                "clipboard clear ; [list clipboard append $txtpoint]"
        }
        .gid.__helpmenu add separator
        set msg [_ "Help"]
        set under [FindUnderChar msg UnderLineList]
        .gid.__helpmenu add command -label $msg -underline $under -command \
            "DisplayGidHelp $w [list $helptxt] menu $x $y"
        set msg [_ "Configure toolbars"]
        set under [FindUnderChar msg UnderLineList]
        .gid.__helpmenu add command -label $msg -underline $under -command \
            TOBegin
        GiD_PopupMenu .gid.__helpmenu $x $y
    }

    foreach i [concat $w.fwarn [winfo children $w.fwarn]] {
        bind $i <ButtonPress-3> [list WarnMessagesContextualMenu $helptxt $w.fwarn.list \
                                     %W @%x,%y %X %Y]
    }   

    GidHelpT $w.l [_ "Press mouse button 1 over it to get a commands menu."]

    MakeBottomEntryBindings

    # para dejar que el boton del medio mueva la barra de scroll
    bind $w.fwarn.yscroll <ButtonPress-2> ""      
}

proc ::GiD_InitPost {} {  
  set ::GiDStatus(PrePost) [_ "Post#C#Postprocess"]
  StatusBarToPost
}
proc ::GiD_InitPre {} {
  set ::GiDStatus(PrePost) [_ "Pre#C#Preprocess"]
  StatusBarToPre
}

proc ::GiD_AfterChangeMesh { num_nodes num_elements } {
  set ::GiDStatus(MeshInfo) [list $num_nodes $num_elements]
}
proc ::GiD_AfterChangeLayersOrSets { num_layers num_off num_withback num_transparent } {
  set ::GiDStatus(LayersOrSetsInfo) [list $num_layers $num_off $num_withback $num_transparent]
}

proc BottomStatusFrame { {action ""} { w .gid.bottominfo } } {
    global GidPriv tcl_platform

    if { $action == ""} {
        set action INSIDE       
    }    
    if { $action == "NONE" } {
        set GidPriv(PrePostStatusWindowGeom) "NONE {} 1 BottomStatusFrame"
        if { [winfo exists $w] } { 
            destroy $w 
        }        
    } elseif { [string range $action 0 5] == "INSIDE" } {       
        if { [winfo exists $w] } { 
            destroy $w 
        }
        set GidPriv(PrePostStatusWindowGeom) "INSIDE {} 1 BottomStatusFrame"
        ttk::frame .gid.bottominfo -style ForcedFrame
        ttk::separator .gid.bottominfo.separator -orient horizontal -style ForcedSeparator
        grid .gid.bottominfo.separator -in .gid.bottominfo -columnspan 100 -sticky "news" -pady {2 0}
        grid columnconfigure .gid.bottominfo 0 -weight 1 
        grid .gid.bottominfo -in .gid -row 50 -column 0 -columnspan 4 -sticky "snew"
        } else {
        set GidPriv(PrePostStatusWindowGeom) "$action {} 1 BottomStatusFrame"
        InitWindow $w [_ "Status & Information"] PrePostStatusWindowGeom BottomStatusFrame
        if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0
        wm transient $w .gid        
    }   
    if { $action == "NONE" } { return }
   
    if { [GidUtils::AreWindowsDisabled] } {
        return
    }
    #temporal for not recreate tclindex
    SRC StatusLabel
    #endtemporal
    if {[set ::GiDStatus(PrePost)]==[_ "Post#C#Postprocess"]} {
        StatusBarToPost            
    } else {        
        StatusBarToPre           
    }    
}


proc RightButtons { {action ""} { w .gid.buts } } {
    #WarnWinText "RightButtons ACT=$action"
    global GidPriv GIDDEFAULT ActionsMenuVar
    ###puts " . -> '$action' '$w'"
    if { $action == "" && [winfo exists $w] } { return }
    if { $action == "INSIDE" || ($action == "" && \
                                     (![info exists GidPriv(PrePostRightButWindowGeom)] || \
                                          [lindex $GidPriv(PrePostRightButWindowGeom) 0] == "INSIDE")) } {
        if { [winfo exists $w] } {
            if { [winfo class $w] != "frame" && [winfo class $w] != "Frame" } {
                destroy $w
            } else { return }
        }
        ttk::frame $w -style flat.TFrame
       
        #         pack forget .gid.central.s
        #         pack $w -side right -fill y -in .gid.central
        #         catch { pack .gid.central.s -fill both -expand yes -side left}
        set GidPriv(PrePostRightButWindowGeom) "INSIDE {} 1 RightButtons"
        GridInside PrePostRightButWindowGeom $w .gid.rightb "ns"
    } elseif { $action == "OPEN" || \
                   ($action == "" && [lindex $GidPriv(PrePostRightButWindowGeom) 0] \
                        == "OPEN") } {
        if { ![info exists GidPriv(PrePostRightButWindowGeom)] || \
                 [lindex $GidPriv(PrePostRightButWindowGeom) 1] == "" } {
            set GidPriv(PrePostRightButWindowGeom) \
                "OPEN 130x300+[expr [winfo x .gid]+[winfo width .gid] \
                    +10]+[expr [winfo y .gid]+25] RightButtons"
        }
        ###puts " . -> InitWindow"
        catch {DestroySlave $w}
        InitWindow $w [_ "Command buttons"] PrePostRightButWindowGeom RightButtons
        if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0
        wm transient $w .gid
    } else {
        catch { DestroySlave $w }
        set GidPriv(PrePostRightButWindowGeom) "NONE {} 1 RightButtons"
        return
    }
    ###puts " . -> frames"
    ttk::frame .gid.buts.f -style ForcedFrame -borderwidth 2
    #-width 130 -height 100 -relief flat
    # -background $GidPriv(Color,ToolbarBg)
    pack propagate .gid.buts.f no
    pack .gid.buts.f -side top -fill both -expand yes -padx 0 -pady 0
    bind .gid.buts <Configure> {
        incr DelayedConfigureButsVar
        after idle DelayedConfigureButsFunc
    }

    # en macOsX los botoncitos tienen los extremos redondos: necesitan un poco mas de espacio

    #create initially only GidPriv(MaxRightButtons)=100 buttons, but more could be required
    #create more in SetButtons when needed 
    if { ![info exists ::GidPriv(MaxRightButtons)] } {
        set ::GidPriv(MaxRightButtons) 100
    }
    for {set i 0 } { $i<$::GidPriv(MaxRightButtons) } { incr i } {
        ttk::button $w.f.b$i -width 15 -takefocus 0  -style RightButtons.IconButton
    }
    set reqwidth [ winfo reqwidth $w.f.b0]
    .gid.buts.f configure -width [ expr $reqwidth + 8]
    ttk::button $w.f.ar -image [ gid_themes::GetImage ArrowRight.png large_icons] -style IconButton
    ttk::button $w.f.al -image [ gid_themes::GetImage ArrowLeft.png large_icons] -style IconButton
    foreach i [bind .gid] {
        bind $w $i [bind .gid $i]
    }
    

    set ::gid_central_button 2
    set ::gid_right_button 3
    
    if { $::tcl_platform(os) == "Darwin" } {
        # http://wiki.tcl.tk/12987 FAQ 7.7:
        # For historical reasons, MacMice buttons 2 and 3 refer to the right and middle buttons
        # respectively, which is indeed the opposite way round from Windows and *nix systems.
        set ::gid_central_button 3
        set ::gid_right_button 2
    }

    bind $w <$::gid_central_button> { .gid.central.s button 2 %x %y }

    bind $w <Right> "if \[winfo ismapped $w.f.ar] \"$w.f.ar invoke\""
    bind $w <Left> "if \[winfo ismapped $w.f.al] \"$w.f.al invoke\""

    ###puts " . -> [info exists ActionsMenuVar] -> { SetButtons }"
    update idletasks
    if { [info exists ActionsMenuVar] } {
        #WarnWinText $::ActionsMenuVar
        SetButtons
    }
    ###puts " . -> FIN"
}

proc UnMapAllWindows { w } {
    global GidPriv
    if { $w != ".gid" || ![info exists GidPriv(TopLevelsList)] } { return }
    foreach i $GidPriv(TopLevelsList) {
        if { [winfo exists $i] && [winfo ismapped $i] && [winfo class $i]== "Toplevel" } {
            wm withdraw $i
        }
    }
}

proc MapAllWindows { w } {
    global GidPriv
    if { $w != ".gid"  || ![info exists GidPriv(TopLevelsList)] } { return }
    foreach i $GidPriv(TopLevelsList) {
        if { [winfo exists $i] && ![winfo ismapped $i] && [winfo class $i]== "Toplevel" } {
            wm deiconify $i
        }
    }
}

proc OpenTextFromFile { title FileNamebase offset { offset2 -1} { quit no } } { 
    set must_invoke 1
    foreach after_id [after info] {
        if { [lindex [lindex [after info $after_id] 0] 0] == "OpenTextFromFile_after" } {           
            set must_invoke 0
            break
        }
    }
    if { $must_invoke } {
        after idle [list OpenTextFromFile_after $title $FileNamebase $offset $offset2 $quit]
    }
}

proc OpenTextFromFile_after { title FileNamebase offset { offset2 -1} { quit no } } {
    #after cancel OpenTextFromFile_after ;#to try to avoid some problems at least when stopping in debug    
    global tcl_platform
    if { [winfo exists .gid] } {
        if { [winfo exists .textwin] } {
            destroy .textwin
        }
        set w .gid.textwin
    } else {
        set w .textwin
    }

    if { $offset2 != -1 } {
        set FileName [lindex $FileNamebase 0]
        set FileName2 [lindex $FileNamebase 1]
    } else {
        set FileName $FileNamebase
    }

    set FileNameGood 1
    if { ![file readable $FileName] } {
        set FileNameGood  0
    } elseif { $offset >= [file size $FileName] } {
        set FileNameGood  0
    }
    if { $FileNameGood == 1 } {
        set f [open $FileName r]
        seek $f $offset
        if { [eof $f] } {
            close $f
            set FileNameGood  0
        }
    }

    if { $offset2 == -1 && $FileNameGood == 0 } { 
        return 
    }

    set FileNameGood2 0
    if { $offset2 != -1 } {
        set FileNameGood2 1
        if { ![file readable $FileName2] } {
            set FileNameGood2  0
        } elseif { $FileNameGood2 == 1 && $offset2 >= [file size $FileName2] } {
            set FileNameGood2 0
        }
        if { $FileNameGood2 == 1 } {
            set f2 [open $FileName2 r]
            seek $f2 $offset2
            if { [eof $f2] } {
                close $f2
                set FileNameGood2 0
            }
        }
        if { $FileNameGood == 0 && $FileNameGood2 == 0 } {           
            return
        }
    }

    set CreatingWindow 0
    if { ![winfo exists $w] || $title != [wm title $w] } {

        set CreatingWindow 1

        InitWindow $w $title PrePostTextWindowGeom
        if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0
        
        #wm attributes $w -topmost 1 
        ttk::frame $w.f
        text $w.f.t -width 50 -borderwidth 1
        ttk::scrollbar $w.f.yscroll -command "$w.f.t yview"
        $w.f.t configure -yscroll "$w.f.yscroll set"
        pack $w.f.yscroll -side right -fill y -pady 5
        pack $w.f.t  -expand yes -fill both -anchor nw -padx 5 -pady 5
        ttk::button $w.b -text [_ "Close"] -command "destroy $w" -style BottomFrame.TButton
        #-borderwidth 1
        #SetWidgetsWidthFromText $w.b
        focus $w.b
        pack $w.b -side bottom -pady 2
        pack $w.f -side top -fill both -expand yes -side top
        update

        scan [ winfo geometry $w] %dx%d ww hh
        if { ( $ww < 200) || ( $hh < 200)} {
            wm geometry $w 200x200
        }             
    }

    $w.f.t configure -state normal

    if { $FileNameGood == 1 } {
        while { ![eof $f] } {
            $w.f.t insert end [gets $f]\n
        }
        close $f
    }
    if { $FileNameGood2 == 1 } {
        while { ![eof $f2] } {
            $w.f.t insert end [gets $f2]\n
        }
        close $f2
    }
    $w.f.t see [$w.f.t index "end-2l"]

    regsub {\..*} [$w.f.t index end] {} NumLines
    incr NumLines -1
    if { $NumLines > 20 } { set NumLines 20 }

    if { $::tcl_platform(platform) != "windows" } {
        $w.f.t configure -state disabled
    }

    if { $CreatingWindow == 1 } {
        set hei $NumLines
        if { $hei < 6 } { set hei 6 }
        $w.f.t configure -height $hei
    }

    if { $quit != "no" } {
        $w.b configure -text [_ "Quit"]
        if { $::tcl_platform(os) != "Darwin"} {
            if { [winfo exists $w] } {
                tkwait visibility $w
            }
        } else {
            update
        }
        raise $w
        grab $w
        tkwait window $w
    }   
}

#this GiD event will be implemented with the new progress mesh advance bar
proc BeforeMeshProgress { n0 n1 n2 n3 } {
    ProgressInMeshing::Init $n0 $n1 $n2 $n3
}

#return -cancel- ;#to set user stop
proc MeshProgress { total_percent partial_percents_0 partial_percents_1 partial_percents_2 partial_percents_3 n_nodes n_elems } {
    set res [ProgressInMeshing::MeshProgress $total_percent $partial_percents_0 $partial_percents_1 \
                 $partial_percents_2 $partial_percents_3 $n_nodes $n_elems]    
    return $res
}

proc AfterMeshProgress { } {   
    #ProgressInMeshing::End     
}

proc GetMeshTxt { } {
    set msg "" 
    set element_types { Sphere Circle OnlyPoints Linear Triangle Quadrilateral Tetrahedra Hexahedra Prism Pyramid }      
    foreach element_type $element_types {
        set ne [GiD_Info Mesh NumElements $element_type]
        if { $ne } {
            append msg [_ "Num. of %s elements=%s" $element_type $ne]\n
        }
    }
    set nn [GiD_Info Mesh NumNodes]
    append msg [_ "Num. of nodes=%s" $nn]\n
    if { [GiD_Info Project Quadratic] } {
        append msg [_ "Quadratic mesh"]
    }
    return $msg
}

proc ShowWindowMeshInformation { } { 
    return

    # old information window: not used any more, but called from GiD
    # set msg [GetMeshTxt]
    # set title [_ "Dialog window"] 
    # set main_label [_ "Mesh generated."]    
    # set res [tk_dialogEntryRAM .gid.tempwin $title $main_label info textro $msg [list [_ "View mesh"] [_ "Close"]]]
    # if { $res != "-CANCEL-" } {
    #         MeshView
    # }
}

proc GiD_AfterMeshGeneration { fail } {
    ProgressInMeshing::AfterMeshGeneration $fail   
    return ok
    # do not return -cancel- avoid printing C messages like: reached limit of 1010 nodes
    # return -cancel- ;#to avoid that gid invoke the old window ShowWindowMeshInformation
}

if { $::tcl_platform(platform) == "windows" } {
    package require twapi
}     

namespace eval ProgressInMeshing {       
    variable user_stop
    variable progress_var
    variable label_n_nodes
    variable label_n_elems
    variable busy
    variable use_ttk_progressbar 1
    variable graph   
}

proc ProgressInMeshing::AfterMeshGeneration { fail } {
    if { [GidUtils::AreWindowsDisabled] } return
    variable label
    set w .gid.wprogress
    if { [winfo exists $w] } {
        if { $fail } {
            ProgressInMeshing::End
        } else {           
            set title [_ "Mesh generated."]            
            grid forget $w.fbars           
            grid forget $w.fnum.lnnodes $w.fnum.nnodes $w.fnum.lnelems $w.fnum.nelems $w.fnum.ltime $w.fnum.time
            ttk::label $w.fnum.ltitle -text $title -font BigFont
            set msg [GetMeshTxt]
            ttk::label $w.fnum.lmsg -image [gid_themes::GetImage InfoWindow.png]
            text $w.fnum.msg -relief groove -height [llength [split $msg \n]]           
            $w.fnum.msg insert end $msg            
            $w.fnum.msg configure -state disabled
            grid $w.fnum.ltitle -sticky ew -pady 3 -padx 4 -columnspan 2
            grid $w.fnum.lmsg $w.fnum.msg -sticky nsew -pady 3 -padx 4           
            grid $w.frmButtons.btnmeshview
            $w.frmButtons.btnclose configure -text [_ "Close"] -command {ProgressInMeshing::End}
	    # focus on view mesh button, as enter invokes this button
	    focus $w.frmButtons.btnmeshview
	    bind $w <Return> [list $w.frmButtons.btnmeshview invoke]
        }
    }
    return ok
    # do not return -cancel- avoid printing C messages like: reached limit of 1010 nodes
    # return -cancel- ;#to avoid that gid show its internal message
}

proc ProgressInMeshing::Init  { n0 n1 n2 n3 } {       
    variable user_stop     
    variable graph
    variable use_ttk_progressbar    
    
    if { $use_ttk_progressbar } {
    } else {
        package require progressbar    
    }       
          
    set user_stop 0    
    set busy 0
    set graph(xs) [list 0]
    set graph(ys_nodes) [list 0]
    set graph(ys_memory) [list 0]
    set graph(t0) [clock seconds]
    set graph(memory0) [ProgressInMeshing::GetMemory]
    set graph(t_prev) $graph(t0)
    set graph(t_refresh) 1 ;#is updated dinamically
    unset -nocomplain graph(plot)
    
    if { ![info exists ::GidPriv(ProgressInMeshing,More)] } {
        set ::GidPriv(ProgressInMeshing,More) 1
    }
    
    ProgressInMeshing::CreateWindow $n0 $n1 $n2 $n3
}

proc ProgressInMeshing::End { } {
    set w .gid.wprogress
    if { [winfo exists $w] } {
        destroy $w
    }
}

proc ProgressInMeshing::CreateWindow  { n0 n1 n2 n3 } {
    if { [GidUtils::AreWindowsDisabled] } return
    variable user_stop
    variable progress_var
    variable label   
    variable graph
    variable use_ttk_progressbar
    variable busy    

    set busy 1          
    set w .gid.wprogress

    set avoid_InitWindow 1
    if { $avoid_InitWindow } {
        if { [winfo exists $w] } {
            destroy $w
            #return
        }
        toplevel $w -class OverlayWindow
        wm withdraw $w
        if { $::tcl_platform(platform) == "windows" } {            
            wm attributes $w -toolwindow 1
        }   
        wm title $w [_ "Progress in meshing"]  
    } else {
        #now has some problem with canvas resize
        InitWindow $w [_ "Progress in meshing"] ProgressInMeshingWindowGeom ""
    }

    ttk::frame $w.fbars
    label $w.fbars.l1 -text [_ "Percentage done"]:
    grid $w.fbars.l1 -sticky w -columnspan 2
    set n_sum [expr {$n0+$n1+$n2+$n3}]
    
    set test 1   
    if { $test == 0 } {        
        set ns [list $n0 $n1 $n2 $n3 $n_sum]
        set types [list other line surface volume total]
        set texts [list [_ "Other"] [_ "Lines"] [_ "Surfaces"] [_ "Volumes"] [_ "Total"]]
    } elseif { $test == 1 } {
        set ns [list $n0 $n2 $n3]
        set types [list other surface volume]
        set texts [list [_ "Other"] [_ "Surfaces"] [_ "Volumes"]]
    } else {
        set ns [list $n_sum]
        set types [list total]
        set texts [list [_ "Total"]]
    }
    foreach n $ns type $types text $texts {
        if { $n } { 
            label $w.fbars.l$type -text ${text}:      
            set progress_var($type) $w.fbars.p$type                        
            if { $use_ttk_progressbar } {
                ttk::progressbar $progress_var($type)                
            } else {
                ::progressbar::progressbar $progress_var($type) -background [[winfo toplevel $w] cget -background]
            }           
            #grid $w.fbars.l$type -sticky w -padx 4
            #grid $w.fbars.p$type -sticky ew -padx 4
            grid $w.fbars.l$type $w.fbars.p$type -sticky w -padx 4
            grid configure $w.fbars.p$type -sticky ew
        } else {
            unset -nocomplain progress_var($type)
        }
    }           

    ttk::frame $w.fnum
    ttk::label $w.fnum.lnnodes -text [_ "Number of nodes"]:
    set label(n_nodes) [ttk::label $w.fnum.nnodes -text 0 -relief groove -anchor center -width 45] ;#set width 45 to force window size
    ttk::label $w.fnum.lnelems -text [_ "Number of elements"]:
    set label(n_elems) [ttk::label $w.fnum.nelems -text 0 -relief groove -anchor center]   
    ttk::label $w.fnum.ltime -text [_ "Elapsed seconds"]:
    set label(time) [ttk::label $w.fnum.time -text 0 -relief groove -anchor center]
    grid $w.fnum.lnnodes $w.fnum.nnodes -sticky ew -pady 3 -padx 4
    grid $w.fnum.lnelems $w.fnum.nelems -sticky ew -pady 3 -padx 4   
    grid $w.fnum.ltime $w.fnum.time -sticky ew -pady 3 -padx 4
    
       
    ttk::frame $w.fplot
         
    ttk::button $w.bmore -command [list ProgressInMeshing::SwapDetail $w]
    GidHelp $w.bmore [_ "Show more or less detail of the mesh generation process"]
        
    grid $w.fbars -sticky new
    grid columnconfigure $w.fbars 1 -weight 1
    grid $w.fnum -sticky new
    grid columnconfigure $w.fnum 1 -weight 1 
    grid $w.fplot -sticky nsew
    grid rowconfigure $w.fplot 0 -weight 1 
    grid columnconfigure $w.fplot 0 -weight 1    
    grid $w.bmore -sticky w               
    
    ttk::frame $w.frmButtons -style BottomFrame.TFrame
    ttk::button $w.frmButtons.btnmeshview -text [_ "View mesh"] -command {MeshView 1 ; ProgressInMeshing::End}
    ttk::button $w.frmButtons.btnclose -text [_ "Stop"] -command {set ::ProgressInMeshing::user_stop -cancel-} \
        -style BottomFrame.TButton
       
    grid $w.frmButtons.btnmeshview $w.frmButtons.btnclose -padx 5 -pady 6
    grid remove $w.frmButtons.btnmeshview

    grid $w.frmButtons -sticky ews
    if { $::tcl_version >= 8.5 } { grid anchor $w.frmButtons center }
    
    grid columnconfigure $w 0 -weight 1
    grid rowconfigure $w 2 -weight 1        
        
    # focus on btnclose button, as enter invokes this button to stop while meshing
    focus $w.frmButtons.btnclose
    bind $w <Alt-c> [list $w.frmButtons.btnclose invoke]
    bind $w <Escape> [list $w.frmButtons.btnclose invoke]
    bind $w <Return> [list $w.frmButtons.btnclose invoke]
    bind $w <Up> [list ProgressInMeshing::HideDetail $w]
    bind $w <Down> [list ProgressInMeshing::ShowDetail $w]
    
    bind $w <Destroy> [list +ProgressInMeshing::DestroyWindow %W $w] ;# + to add to previous script  
    bind $w <Configure> [list +ProgressInMeshing::Resize $w]
    grab $w   
    
    ProgressInMeshing::UpdateDetail $w    
   
    if { $avoid_InitWindow } {
        update
        set parent [winfo parent $w]
        set reqwidth [winfo reqwidth $w]
        set reqheight [winfo reqheight $w]   
        set x [expr [winfo x $parent]+[winfo width $parent]/2-$reqwidth/2]
        set y [expr [winfo y $parent]+[winfo height $parent]/2-$reqheight/2] 
        WmGidGeom $w +$x+$y        
        wm deiconify $w
    } else {        
        #update
        #wm deiconify $w
        #after idle [list ProgressInMeshing::DoResize $w]
    }

    set busy 0 
}

proc ProgressInMeshing::CreateGraph { w } {
    variable graph
    package require Plotchart
   
    #::Plotchart::plotstyle load default
    ::Plotchart::plotconfig xyplot margin bottom 40
    ::Plotchart::plotconfig xyplot margin top 40

    canvas $w.fplot.c
    $w.fplot.c configure -background [Plotchart::plotconfig xyplot background innercolor] 
    #set graph(xscale) [list 0 60 10]
    set graph(xscale) [list 0 10 1]
    set graph(yscale) [list 0 10000 1000]
    set graph(plot) [::Plotchart::createXYPlot $w.fplot.c $graph(xscale) $graph(yscale)]
    ProgressInMeshing::ConfigureGraph $graph(plot) $w.fplot.c
    grid $w.fplot.c -sticky nsew
}

proc ProgressInMeshing::ConfigureGraph { g c } { 
    variable graph
    if { ![ winfo exists $c]} {
        return
    }
    set text_colour black
    set mem_colour #007f7f
    set legend_bg [ $c cget -background]
    if { [gid_themes::GetCurrentTheme] == "GiD_black" } {
        set text_colour white
        set mem_colour cyan
    }
    $g xtext [_ "Time (seconds)"]
    # $g ytext [concat [_ "Num nodes"] & [concat [_ "Memory"] " "  KB]]
    # $g dataconfig nodes -color red
    # $g dataconfig memory -color cyan
    # $g xticklines green
    # $g yticklines green
    $g dataconfig nodes -color red
    $g dataconfig memory -color $mem_colour
    $g xticklines grey70
    $g yticklines grey70
    #$g legendconfig -position bottom-right
    #$g legendconfig -background $legend_bg
    #$g legendconfig -border $text_colour
    #$g legend nodes [_ "Num nodes"]
    #$g legend memory [concat [_ "Memory"] " "  KB]
    $g title [_ "Meshing evolution"] center
    # configure color of text and add vertical axis info:
    $c create text 100 10 -text [_ "Num nodes"] -anchor e -justify right -fill red
    $c create text 100 24 -text [ concat [_ "Memory"] " " KB] -anchor e -justify right -fill $mem_colour
    $c itemconfigure legend_nodes -fill $text_colour
    $c itemconfigure legend_memory -fill $text_colour
}

proc ProgressInMeshing::ShowDetail { w } {    
    set ::GidPriv(ProgressInMeshing,More) 1
    ProgressInMeshing::UpdateDetail $w
}

proc ProgressInMeshing::HideDetail { w } {    
    set ::GidPriv(ProgressInMeshing,More) 0
    ProgressInMeshing::UpdateDetail $w
}

proc ProgressInMeshing::SwapDetail { w } {    
    set ::GidPriv(ProgressInMeshing,More) [expr !$::GidPriv(ProgressInMeshing,More)]
    ProgressInMeshing::UpdateDetail $w
}

proc ProgressInMeshing::UpdateDetail { w } {    
    if { $::GidPriv(ProgressInMeshing,More) } {
        if { ![winfo exists $w.fplot.c] } {
            ProgressInMeshing::CreateGraph $w            
        }
        grid $w.fplot
        $w.bmore configure -image [gid_themes::GetImage ArrowUp.png small_icons]
        GidHelp $w.bmore [_ "Less detail"]
    } else {
        grid remove $w.fplot         
        $w.bmore configure -image [gid_themes::GetImage ArrowDown.png small_icons]
        GidHelp $w.bmore [_ "More detail"]
    }
}

proc ProgressInMeshing::SetProgressBarValue { pb value } {
    variable use_ttk_progressbar
    if { $use_ttk_progressbar } {
        $pb configure -value $value
    } else {        
        $pb configure -percent $value        
    }
}

proc ProgressInMeshing::AddGraphPoint { t_relative n_nodes memory } {   
    variable graph
    lappend graph(xs) $t_relative
    lappend graph(ys_nodes) $n_nodes  
    lappend graph(ys_memory) $memory
    if { $::GidPriv(ProgressInMeshing,More) && [llength $graph(xs)] >= 2 } {                 
        $graph(plot) deletedata
        lassign $graph(xscale) min max increment
        if { [lindex $graph(xs) end] > $max } {
            set graph(t_refresh) [expr {$graph(t_refresh)*2}]
            set max [expr {$max*2}]
            set increment [expr {$increment*2}]
            #incr min
            #incr max           
            set graph(xscale) [list $min $max $increment]
            $graph(plot) xconfig -scale $graph(xscale)  
            $graph(plot) rescale $graph(xscale) $graph(yscale)
        }
        lassign $graph(yscale) min max increment
        if { [lindex $graph(ys_nodes) end] > $max || [lindex $graph(ys_memory) end] > $max} {            
            set max [expr {$max*2}]
            set increment [expr {$increment*2}]
            set graph(yscale) [list $min $max $increment]
            $graph(plot) yconfig -scale $graph(yscale)        
            $graph(plot) rescale $graph(xscale) $graph(yscale)
        }
        $graph(plot) plotlist nodes $graph(xs) $graph(ys_nodes)        

        $graph(plot) plotlist memory $graph(xs) $graph(ys_memory)
    }   
}


proc ProgressInMeshing::Resize { w } { 
    # To avoid redrawing the plot many times during resizing,
    # cancel the callback, until the last one is left.
    #
    variable _resizing
    if { [info exists _resizing] } {
        after cancel $_resizing
    }
    set _resizing [after 50 [list ProgressInMeshing::DoResize $w]]
}

proc ProgressInMeshing::DoResize { w } {      
    variable _resizing    
    variable graph            
    if { $::GidPriv(ProgressInMeshing,More) } {             
        #deletedata also does a $w.fplot.c delete data
        if { [catch { $graph(plot) deletedata } err] } {
            # WarnWinText "ProgressInMeshing::DoResize $err"
        }
        if { [winfo exists $w.fplot.c] } {           
            $w.fplot.c delete all        
            set graph(plot) [::Plotchart::createXYPlot $w.fplot.c $graph(xscale) $graph(yscale)]
            ProgressInMeshing::ConfigureGraph $graph(plot) $w.fplot.c
            if { [llength $graph(xs)] >= 2 } {
                $graph(plot) plotlist nodes $graph(xs) $graph(ys_nodes)
                $graph(plot) plotlist memory $graph(xs) $graph(ys_memory)
            }
        }
    }
    unset -nocomplain _resizing    
}

proc ProgressInMeshing::GetMemory { } {
    set pid [pid]
    if { $::tcl_platform(platform) == "windows" } {
        set memory [lindex [twapi::get_process_info $pid -workingset] 1]
    } else {
        #rss: resident set size, the non-swapped physical memory that a task has used (in KB)
        #vsz: virtual memory size of the process in KB. Device mappings are currently excluded; this is subject to change.
        #size: approximate amount of swap space that would be required if the process were to dirty all writable pages 
        #      and then be swapped out. This number is very rough!
        if { [catch { set memory [lindex [exec ps -p $pid -o rss] 1] } err] } {
            set memory 0
        } else {
            set memory [expr {$memory*1000}]
        }
    }
    return $memory
}

proc ProgressInMeshing::MeshProgress { total_percent partial_percents_0 partial_percents_1 \
                                           partial_percents_2 partial_percents_3 n_nodes n_elems } {   
    variable user_stop
    variable progress_var
    variable label
    variable busy

    variable show_elapsed_time
    variable graph
             
    if { ![info exists busy] || $busy } {
        return 0
    }
    set busy 1
    set w .gid.wprogress
    if { [winfo exists $w] } {
        #set advance_bar_percent $total_percent ;#update advance bar
        foreach type "other line surface volume total" value "$partial_percents_0 $partial_percents_1 $partial_percents_2 $partial_percents_3 $total_percent" {
            if { [info exists progress_var($type)] && [winfo exists $progress_var($type)] } {
                ProgressInMeshing::SetProgressBarValue $progress_var($type) $value        
            }
        }   
        $label(n_nodes) configure -text $n_nodes
        $label(n_elems) configure -text $n_elems        


        set t [clock seconds]
        if { [expr {$t-$graph(t_prev)}] >= $graph(t_refresh) } {
            set t_relative [expr {$t-$graph(t0)}]                 
            $label(time) configure -text $t_relative
            set memory_relative [expr {([ProgressInMeshing::GetMemory]-$graph(memory0))/1000}]              
            ProgressInMeshing::AddGraphPoint $t_relative $n_nodes $memory_relative 
            set graph(t_prev) $t
        }

        update
        if { [winfo exists $w] && [wm state .gid]== "normal" } {        
            #trick to show the advance bar on the top of the stack order
            raise $w
        } 
    }
    set busy 0
    return $user_stop
}

proc ProgressInMeshing::DestroyWindow { W w } {
    variable user_stop
    if { $W == $w } {
        #unset -nocomplain user_stop
    }
}

proc ProgressInMeshing { NumSurfs NumVols isurf ivol SurfNum VolNum SurfFactor VolFactor \
                             Bar3Title Bar3Factor NumNodes NumElems } {
    global GidPriv
    
    package require progressbar

    set w .gid.wprogress

    if { ![winfo exists $w] } {
        
        if {$Bar3Title == ""} {
            if { $isurf == $NumSurfs && $ivol == $NumVols} { return }
        } else {
            if { $Bar3Factor > 0.9999999 } { return }
        }
        #if { $isurf == $NumSurfs && $ivol == $NumVols && $Bar3Title == ""} { return }
        
        toplevel $w -class OverlayWindow
        if { $::tcl_platform(platform) == "windows" } {            
            wm attributes $w -toolwindow 1
        }
        
        #bind $w <Destroy> "catch { unset GidPriv(StopMeshing) }"
        
        
        wm title $w [_ "Progress in meshing"]
        set pare [winfo parent $w]
        set x [expr [winfo x $pare]+[winfo width $pare ]/2- [winfo reqwidth $w]/2]
        set y [expr [winfo y $pare]+[winfo height $pare ]/2- [winfo reqheight $w]/2]
        
        WmGidGeom $w +$x+$y
        
        $w configure -cursor watch
        
        foreach i "surface volume bar3" {
            #             if { $i == "volume" && $NumVols == 0 } { break }
            if { $i == "volume" && $NumVols == 0 } { continue }
            if { $i == "bar3" && $Bar3Title == "" } { break }
            ttk::frame $w.$i -style ridge.TFrame -borderwidth 2
            ttk::frame $w.$i.fr
            if { $i == "surface" } {
                label $w.$i.fr.l1 -text [_ "Meshed#C#surface"]
                label $w.$i.fr.l2 -text 0
                label $w.$i.fr.l3 -text [_ "surfaces of  %s" $NumSurfs]
                label $w.$i.l4 -text [_ "Meshing surface number"]:
                label $w.$i.l5 -text 0 -relief sunken -width 5
            } elseif { $i == "volume" } {
                label $w.$i.fr.l1 -text [_ "Meshed#C#volume"]
                label $w.$i.fr.l2 -text 0
                label $w.$i.fr.l3 -text [_ "volumes of  %s" $NumVols]
                label $w.$i.l4 -text [_ "Meshing volume number"]:
                label $w.$i.l5 -text 0 -relief sunken -width 5
            } else {
                label $w.$i.fr.l1 -text [_ "Percentage done"]:
                label $w.$i.fr.l2 -text 0
                label $w.$i.l4 -text $Bar3Title
            }
            set wp [::progressbar::progressbar $w.$i.f -variable ::progressbar::var$i \
                        -width 200 -background [[winfo toplevel $w] cget -background]]
            set ::progressbar::var$i 0
            
            if { $i == "bar3" } {
                grid $w.$i.l4 -sticky ew -pady 3 -padx 4
                grid $wp -sticky ew -columnspan 4
                grid $w.$i.fr.l1 $w.$i.fr.l2 -pady 3 -sticky e -padx 4
                grid configure $w.$i.fr.l2 -sticky w
                grid $w.$i.fr -sticky ew -columnspan 4
                grid columnconfigure $w.$i.fr {0 1} -weight 1
                grid $w.$i -sticky ew
                grid columnconfigure $w.$i 0 -weight 1
            } else {
                #grid $w.$i.l4 $w.$i.l5 -sticky w -pady 3
                grid $w.$i.l4 -row 0 -column 1 -sticky w -pady 3 -padx 4
                grid $w.$i.l5 -row 0 -column 2 -sticky w -pady 3 -padx 4
                grid $wp -sticky ew -columnspan 4
                #grid $w.$i.l1 $w.$i.l2 $w.$i.l3 -pady 3
                grid $w.$i.fr.l1 $w.$i.fr.l2 $w.$i.fr.l3 -pady 3 -padx 4
                grid $w.$i.fr -sticky ew -columnspan 4
                grid $w.$i -sticky ew
                grid columnconfigure $w.$i 0 -weight 1
            }
        }
        ttk::frame $w.n
        label $w.n.lnnodes -text [_ "Number of nodes"]:
        label $w.n.nnodes -text $NumNodes -relief sunken -width 8 -borderwidth 1 -justify right
        label $w.n.lnelems -text [_ "Number of elements"]:
        label $w.n.nelems -text $NumElems -relief sunken -width 8 -borderwidth 1 -justify right
        grid $w.n.lnnodes $w.n.nnodes -sticky w -pady 3 -padx 4
        grid $w.n.lnelems $w.n.nelems -sticky w -pady 3 -padx 4
        grid configure $w.n.nnodes -sticky ew
        grid configure $w.n.nelems -sticky ew
        grid columnconfigure $w.n 1 -weight 1
        grid rowconfigure $w.n 1 -weight 1
        grid $w.n -sticky ew
        
        #lower buttons
        #set def_back [$w cget -background]
        ttk::frame $w.frmButtons -style BottomFrame.TFrame
        # -background [CCColorActivo $def_back]
        ttk::button $w.frmButtons.btnclose -text [_ "Stop"] \
            -command {set GidPriv(StopMeshing) 1} \
            -style BottomFrame.TButton
        #-underline 0 -width 6
        #SetWidgetsWidthFromText $w.frmButtons.btnclose
        
        grid $w.frmButtons -row 6 -sticky ews -columnspan 7
        if { $::tcl_version >= 8.5 } { grid anchor $w.frmButtons center }
        grid $w.frmButtons.btnclose -padx 5 -pady 6
        
        grid columnconfigure $w 0 -weight 1
        grid rowconfigure $w 3 -weight 1
        
        focus $w.frmButtons.btnclose
        bind $w <Alt-c> "$w.frmButtons.btnclose invoke"
        bind $w <Escape> "$w.frmButtons.btnclose invoke"
        
        bind $w <Destroy> [list +DestroyProgressInMeshing %W $w] ;# + to add to previous script        
        grab $w
    }

    if { $NumSurfs != 0 && $SurfNum != [$w.surface.l5 cget -text] } {
        $w.surface.l5 configure -text $SurfNum
    }
    if { $NumSurfs != 0 && ($isurf != [$w.surface.fr.l2 cget -text] || $SurfFactor>0.05) } {
        $w.surface.fr.l2 configure -text $isurf
        set factor [expr (double($isurf)+$SurfFactor)/$NumSurfs]
        set ::progressbar::varsurface [expr int($factor*100)]
    }
    if { $NumVols != 0 && $VolNum != [$w.volume.l5 cget -text] } {
        $w.volume.l5 configure -text $VolNum
    }
    if { $NumVols != 0 && ($ivol != [$w.volume.fr.l2 cget -text] || $VolFactor>0.05) } {
        $w.volume.fr.l2 configure -text $ivol
        set factor [expr (double($ivol)+$VolFactor)/$NumVols]
        set ::progressbar::varvolume [expr int($factor*100)]
    }

    if { $Bar3Title != "" && $Bar3Factor != [$w.bar3.fr.l2 cget -text] } {
        #         set factor [expr (double($ivol)+$VolFactor)/$NumVols]
        set ::progressbar::varbar3 [expr int($Bar3Factor*100)]
        $w.bar3.fr.l2 configure -text $::progressbar::varbar3
    }


    $w.n.nnodes configure -text $NumNodes
    $w.n.nelems configure -text $NumElems
    
    update
    
    if { [winfo exists $w] && [wm state .gid]== "normal" } {        
        #trick to show the advance bar on the top of the stack order
        raise $w
    }

    if {$Bar3Title == ""} {
        if { $isurf == $NumSurfs && $ivol == $NumVols} {
            after idle EndProgressInMeshing
        }
    } else {
        if { $Bar3Factor > 0.9999999 } {
            after idle EndProgressInMeshing
        }
    }

}

proc DestroyProgressInMeshing { W w } {
    if { $W == $w } {
        unset -nocomplain ::GidPriv(StopMeshing)
    }
}

proc EndProgressInMeshing { } {
    if { [ GidUtils::IsTkDisabled] } {
        return
    }  
    set w .gid.wprogress
    if { [winfo exists $w] } {
        destroy $w
    }
}

proc WmGidGeom { w geom } {
    global tcl_platform

    if { [info exists ::GidPriv(OffScreen)] && $::GidPriv(OffScreen)} {
        wm withdraw $w
        return
    }

    set x 5
    set y 20
    set yeswh 1

    set iszoomed 0
    if { [lindex $geom 0] == "ZOOMED" } {
        set geom [lindex $geom 1]
        set iszoomed 1
    }

    if { [ llength $geom ] > 1} {
        set geom [lindex $geom 1]
    }

    # set screenwidth [winfo screenwidth $w]
    # set screenheight [winfo screenheight $w]
    # multi-monitors support
    # set dumWin .#multi_monitor_test#
    # if { ![ winfo exists $dumWin]} { 
    #         toplevel $dumWin
    #         wm withdraw $dumWin
    # }
    set dumWin .
    set maxW_maxH [ wm maxsize $dumWin]
    set screenwidth [ lindex $maxW_maxH 0]
    set screenheight [ lindex $maxW_maxH 1]
    # multi-monitors if main monitor is on the right and the secondary on the left
    # then offsets may have negative values as vrootx is negative
    set vrootx [ winfo vrootx $dumWin]
    set min_x_off $vrootx
    set max_x_off [ expr $screenwidth + $vrootx]
    set vrooty [ winfo vrooty $dumWin]
    set min_y_off $vrooty
    set max_y_off [ expr $screenwidth + $vrooty]

    if { $geom ==  "" } {
        set x [expr $screenwidth/3]
        set y [expr $screenheight/3]
        set geom +${x}+$y
        set ::GidPriv($w,has,geom) 0
    } else {
        set ::GidPriv($w,has,geom) 1
    }

    if { ![regexp {^([0-9]*)x([0-9]*)([-+]*[0-9]*)([-+]*[0-9]*)$} $geom trash \
               width height x y] } {
        if { ![regexp {([-+]*[0-9]*)([-+]+[0-9]*)$} $geom trash x y] } {
            wm geom $w +32+32
            return
            error "couldn't compute geometry: $geom"
        }
        set width [winfo reqwidth $w]
        set height [winfo reqheight $w]
        set yeswh 0
    }

    if { ![regsub {[+]-} $x {-} x] } {
	if { $x < $min_x_off } { set x [expr $max_x_off+$x-$width] }
    }

    if { ![regsub {[+]-} $y {-} y] } {
        if { $y <  $min_y_off } { set y [expr $max_y_off+$y-$height] }
    }

    if { $x < [ expr $min_x_off -15] } { set x [ expr $min_x_off + 5] }
    if { $y < [ expr $min_y_off -15] } { set y [ expr $min_y_off + 20] }

    if { [expr $x+$width] > [expr $max_x_off+15] } {
        set x [expr $max_x_off-$width]
    }
    if { [expr $y+$height] > [expr $max_y_off+15] } {
        set y [expr $max_y_off-$height]
    }


    if { $x < [ expr $min_x_off -15] } { set width [expr $width+$x+5] }
    if { $y < [ expr $min_y_off -15] } { set height [expr $height+$y+5] }

    if { $::tcl_platform(os) == "Darwin" } {
        if { $y < 32 } { set y 32 }
    }

    if { ![regexp {[+]} $x] } { set x +$x}
    if { ![regexp {[+]} $y] } { set y +$y}

    if { $yeswh } {
        wm geom $w ${width}x$height$x$y
    } else {
        wm geom $w $x$y
    }

    if { $iszoomed } {
        if { $::tcl_platform(platform) == "windows" } {
            wm state $w zoomed
        } else {
            catch { wm attributes $w -zoomed 1 }
        }
    }
}

# proc IsWord
#
# w: parent window
# type -        Can be:
#                        word:    word without spaces
#                        any:     anything
#                        real:    real
#                        real+:   positive real
#                        int:     int
#                        int+:    positive int

proc IsWord { type word { w .gid } { PrintError no } } {

    switch $type {
        word {
            if { ![regexp {^[  ]*[^ \t]+[  ]*$} $word] } {
                set errorRes [_ "A single word must be entered."]
            }
        }
        real {
            if { ![regexp \
                       {^[  ]*([+-]?([0-9]+\.?[0-9]*|[0-9]*\.?[0-9]+)([eE][+-]?[0-9]+)?)[  ]*$} \
                       $word] } {
                set errorRes [_ "One number must be entered"].
            }
        }
        real+ {
            if { ![regexp \
                       {^[  ]*([+]?([0-9]+\.?[0-9]*|[0-9]*\.?[0-9]+)([eE][+-]?[0-9]+)?)[  ]*$} \
                       $word] } {
                set errorRes [_ "One positive number must be entered."]
            }
        }
        int {
            if { ![regexp \
                       {^[  ]*[+-]?[0-9]+[  ]*$} \
                       $word] } {
                set errorRes [_ "One integer number must be entered."]
            }
        }
        int+ {
            if { ![regexp \
                       {^[  ]*[+]?[0-9]*[1-9]+[0-9]*[  ]*$} \
                       $word] } {
                set errorRes [_ "One positive integer number must be entered."]
            }
        }
    }
    if { [info exists errorRes] } {
        if { $PrintError != "no" } {
            tk_dialogRAM $w.tempwinerr [_ "Error window"] "$errorRes $PrintError" \
                error 0 [_ "OK"]
        }
        return 0
    } else {
        return 1
    }
}

proc SetProblemTypeChoose { projecttype {compare_with_internet_retrieve 1} } {    

    if { $compare_with_internet_retrieve } {
        set fail [RetrievePT::SetProblemTypeIfNotExitsTryDownload $projecttype]
        #return if fail and also if not fail because
        #a callback will invoke again SetProblemTypeChoose when the problemtype will be complete
        return        
    }
    
    package require dialogwin

    set oldproblemtype [ GiD_Info Project ProblemType]
    set probname [ GiD_Info Project ModelName]
    set changes [ GiD_Info Project AreChanges]

    if { $changes || $probname != "UNNAMED" } {
        set putyes yes
    } else {
        set putyes ""
    }

    if { $oldproblemtype != "UNKNOWN" && ($changes || $probname != "UNNAMED") } {
        set f [DialogWin::Init .gid [_ "Select new problemtype"] separator]
        set w [winfo toplevel $f]
        label $f.l1 -text [_ "You are going to load problemtype '%s'.\nWhat do you want to do?" \
                               $projecttype] \
            -justify left
        ttk::radiobutton $f.r1 -text [_ "Update to new problemtype"] -variable todo -value update
        label $f.l2 -text [_ "All data information (materials, conditions, data) will be lost"] \
            -justify left -wraplength 180
        ttk::radiobutton $f.r2 -text [_ "Transform to new problemtype"] -variable todo -value transform
        label $f.l3 -text [_ "Data will be converted to new problemtype if possible. Some data may be lost"]\
            -justify left -wraplength 180

        grid $f.l1 -column 0
        grid $f.r1 -column 0 -sticky w -padx 10
        grid $f.l2 -column 0 -sticky w -padx 50
        grid $f.r2 -column 0 -sticky w -padx 10
        grid $f.l3 -column 0 -sticky w -padx 50

        if { $oldproblemtype == "UNKNOWN" } {
            $f.r2 configure -state disabled
            $f.l3 configure -foreground grey
            set ::todo update
        } elseif { ![info exists ::todo] || [lsearch [list update transform] $::todo] == -1 } {
            set ::todo update
        }

        #change Windows shell link by the pointed name
        #if { [ GidUtils::IsLink [file join $::GIDDEFAULT problemtypes $projecttype.gid.lnk]] == 2 } {
        #   set projecttype [file rootname [ GidUtils::ReadLink [file join $::GIDDEFAULT problemtypes $projecttype.gid.lnk] 1]]
        #}

        set action [DialogWin::CreateWindow]
        DialogWin::DestroyWindow
        switch $action {
            0 { return }
            1 {
                switch $::todo {
                    update {
                        if { $putyes != "" } {
                            GiD_Process Mescape Data Defaults ProblemType $putyes $projecttype escape
                        } else {
                            GiD_Process Mescape Defaults ProblemType $projecttype escape
                        }
                    }
                    transform {
                        GiD_Process escape escape escape escape data defaults TransfProblem $projecttype escape
                    }
                }
            }
        }
    } else {
        if { $putyes != "" } {
            GiD_Process Mescape Data Defaults ProblemType $putyes $projecttype escape
        } else {
            GiD_Process Mescape Data Defaults ProblemType $projecttype escape
        }
    }

    if { $::tcl_platform(os) == "Darwin"} {
        # chapuza para desbloquear y refrescar el top menu:
        # el problema es que mientras el topmenu tenga el foco, no se actualiza su contenido
        # hasta que se pierde y se vuelve a tener
        PostDataMenu $::gidDataMenu(wid)
        SetProblemTypeMenu $::gidDataMenu(PT,wid)
        #WarnWin "$projecttype loaded"
        #update idletasks
        after idle doUpdateMacTopMenusTrick
    }   
}

proc ReadProblemtypeConfigFile { path name } {
    global GidPriv
    #package require tdom
    if { [file extension $path] == ".lnk" && [ GidUtils::IsLink [file join $::GIDDEFAULT problemtypes $path]] == 2 } {
        set fullrealpath [ GidUtils::ReadLink [file join $::GIDDEFAULT problemtypes $path] 1]
        set path [file rootname $path] ;#to remove .lnk
    } else  {
        set fullrealpath [file join $::GIDDEFAULT problemtypes $path]
    }

    if { [file extension $name] == ".lnk" && [ GidUtils::IsLink [file join $fullrealpath $name]] == 2 } {
        set realdir [ GidUtils::ReadLink [file join $fullrealpath $name] 1]
        set name [file rootname $name] ;#to remove .lnk
    } else {
        set realdir [file join $fullrealpath $name]
    }

    set pt [file join $path [file rootname $name]]
    
    set filename [file join $realdir [file rootname $name]].xml
    set data [ReadProblemtypeXml $filename Infoproblemtype {ImageFileBrowser ImageFileBrowserHidden}]
    if { $data != "" } {
        foreach {key value} $data {
            if { $value != "" } {
                set imagefilename [file join $realdir $value]
                if { [file exists $imagefilename] } {
                    set ::GidPriv(problemtype,$key,$pt) [image create photo -file $imagefilename]
                }
            }
        }
    } else {
        set filename_download [file join $realdir download.xml]
        if { [file exists $filename_download] } {
            set ::GidPriv(problemtype,ImageFileBrowser,$pt) [gid_themes::GetImage internet_retrieve.png small_icons]
        }
    }
}

proc SetProblemTypeMenuForDir { dir menu current path } {
    global GidPriv
    set inum 0
    # WarnWinText "SetProblemTypeMenuForDir -$dir-$menu-$current-$path-"
    if { ![info exists GidPriv(dirfiles,$dir)] } {
        #set GidPriv(dirfiles,$dir) and subdirectories
        # WarnWinText "   FastCache... $dir"
        FastCacheFromProblemtypeMenuDir $dir
        #FastCacheFromProblemtypeMenuDir also call ReadProblemtypeConfigFile
    }
    set UnderLineList {}
    if { $dir == [file join $::GIDDEFAULT problemtypes] } {
        #to avoid to use for the data menu this reserved underlinded chars
        foreach i [list [_ "Transform"]... [_ "Internet retrieve"]... [_ "Load"]... [_ "Unload"] [_ "Debugger"]...] {
            FindUnderChar i UnderLineList
        }
    }
    foreach i $GidPriv(dirfiles,$dir) {
        set ifull [file join $dir $i]
        if { [file extension $i] == ".lnk" && [ GidUtils::IsLink $ifull] == 2 } {
            set i [file root $i] ;#to remove .lnk
        }
        if { [file extension $i] == ".gid" } {
            set pt [file root $i]
            set under [FindUnderChar pt UnderLineList]
            set fullrelativept [file join $path $pt]
            if { $pt != $current } {
                if { [info exists ::GidPriv(problemtype,ImageFileBrowser,$fullrelativept)] } {
                    $menu add command -label $pt -underline $under -command [list SetProblemTypeChoose $fullrelativept] \
                        -image $::GidPriv(problemtype,ImageFileBrowser,$fullrelativept) -compound left
                } else {
                    $menu add command -label $pt -underline $under -command [list SetProblemTypeChoose $fullrelativept]
                }
            } else {
                if { [info exists ::GidPriv(problemtype,ImageFileBrowser,$fullrelativept)] } {
                    $menu add check -label $pt -underline $under -command [list SetProblemTypeChoose $fullrelativept] \
                        -variable GidPriv(PTMFD) -onvalue 1 \
                        -image $::GidPriv(problemtype,ImageFileBrowser,$fullrelativept) -compound left
                } else {
                    $menu add check -label $pt -underline $under -command [list SetProblemTypeChoose $fullrelativept] \
                        -variable GidPriv(PTMFD) -onvalue 1
                }
                set GidPriv(PTMFD) 1
            }
            incr inum
        } else {
            set newmenu $menu.m$inum
            $menu add cascade -label $i -menu $newmenu
            menu $newmenu
            if { $i == [lindex [file split $current] 0] } {
                set inumin [SetProblemTypeMenuForDir $ifull $newmenu [lrange [file split $current] 1 end] \
                                [file join $path $i]]
            } else {
                set inumin [SetProblemTypeMenuForDir $ifull $newmenu "" [file join $path $i]]
            }
            if { $inumin == 0 } {
                $menu delete end
                destroy $newmenu
            } else {
                incr inum $inumin
            }
        }
    }
    # WarnWinText "   return $inum"
    return $inum
}

proc SetProblemTypeMenu { menu } {
    global GIDDEFAULT GidPriv

    if { ![winfo exists $menu] } {
        # WarnWinText "$menu does not exist"
        return
    }
    set maindir [file join $GIDDEFAULT problemtypes]
    if { [$menu index end] != "none" && [info exists GidPriv(dirfiles,$maindir)] } {
        # WarnWinText "[$menu index end] && $maindir - [info exists GidPriv(dirfiles,$maindir)]"
        return
    }
    $menu delete 0 end
    foreach i [winfo children $menu] { destroy $i }

    set current [ GiD_Info Project ProblemType]

    set inum 0
    if { $inum } { $menu add separator }
    SetProblemTypeMenuForDir [file join $GIDDEFAULT problemtypes] $menu $current ""

    $menu add separator

    if { [ GiD_Info Project ProblemType] == "UNKNOWN" } {
        set color $::GidPriv(Color,DisabledForegroundMenu)
    } else {
        set color black
    }

    set UnderLineList {}
    set text [_ "Transform"]...
    set under [FindUnderChar text UnderLineList]
    $menu add command -label $text -underline $under -command \
        {GiD_Process escape escape escape escape data defaults TransfProblem}
    set text [_ "Internet retrieve"]...
    set under [FindUnderChar text UnderLineList]
    $menu add command -label $text -image [gid_themes::GetImage internet_retrieve.png small_icons] \
        -compound left -underline $under -command RetrievePT::OpenGUI
    set text [_ "Load"]...
    set under [FindUnderChar text UnderLineList]
    $menu add command -label $text -underline $under -command \
        {GiD_Process escape escape escape escape data defaults ProblemType}
    set text [_ "Unload"]
    set under [FindUnderChar text UnderLineList]
    $menu add command -label $text -underline $under -command UnloadProblemtype
   
    if { ![info exists GidPriv(RamdebuggerMenuState)] } {
        set GidPriv(RamdebuggerMenuState) 1
    }
    if { $GidPriv(RamdebuggerMenuState) != 0} {
        if { $GidPriv(RamdebuggerMenuState) == -1} {
            set color $::GidPriv(Color,DisabledForegroundMenu)
        } else {
            set color black
        }
        set text [_ "Debugger"]...
        set under [FindUnderChar text UnderLineList]
        $menu add command -label $text -underline $under -command {package require RamDebugger}
    }
    # WarnWinText "SetProblemTypeMenu - done $menu"
    update idletasks
    update
}

#state can be: normal, hidden or disable (to show in gray)
proc SetRamdebuggerMenuState { state } {
    global GidPriv
    if { $state == "normal" } {
        set GidPriv(RamdebuggerMenuState) 1
    } elseif { $state == "hidden" } {
        set GidPriv(RamdebuggerMenuState) 0
    } elseif { $state == "disable" } {
        set GidPriv(RamdebuggerMenuState) -1
    } else {
        set GidPriv(RamdebuggerMenuState) 1
    }
    set menu_name "Data#C#menu"
    set i [ GiDMenu::_FindIndex $menu_name PRE]
    if { $i != -1 } {
        set menu [ GetMenuName $i].0
        $menu delete 0 end
        SetProblemTypeMenu $menu
    }
}

proc UnloadProblemtype { } {
    if { [ GiD_Info Project AreChanges] || [ GiD_Info Project ModelName] != "UNNAMED" } {
        set msg [_ "All data information (materials,conditions,data) will be lost."]
        set Ret [tk_dialogRAM .gid.askyn [_ "Unload"] \
                     $msg gidquestionhead 0 [_ "Ok"] [_ "Cancel"]]
        if { $Ret == 0 } {
            GiD_Process escape escape escape escape data defaults ProblemType yes UNKNOWN
        }
    } else {
        GiD_Process escape escape escape escape data defaults ProblemType UNKNOWN
    }
}


proc ClearCacheFormProblemtypeMenuDir {} {
    global GidPriv
    foreach i [array names GidPriv dirfiles,*] {
        unset GidPriv($i)
    }
}

proc FastCacheFromProblemtypeMenuDir { dir } {
    global GidPriv
    #recreate this information also if exists GidPriv(dirfiles,$dir)
    #can be created or deleted files or directrories
    set startrelpath [string length [file join $::GIDDEFAULT problemtypes]]
    incr startrelpath
  
    if { [file extension $dir] == ".lnk" && [ GidUtils::IsLink $dir] == 2 } {
        set realdir [ GidUtils::ReadLink $dir 1]
    } else {
        set realdir $dir
    }
    set dirs [glob -nocomplain -tails -directory $realdir -types d *]
    foreach link [glob -nocomplain -tails -directory $realdir -types f *.lnk] {
        if { [ GidUtils::IsLink [file join $realdir $link]] == 2 } {
            lappend dirs $link
        }
    }
    set GidPriv(dirfiles,$dir) [lsort -dictionary $dirs]
    foreach i $GidPriv(dirfiles,$dir) {
        if { [file extension $i] == ".gid" } {
            set path [string range $dir $startrelpath end]
            ReadProblemtypeConfigFile $path $i
            continue
        } elseif { [file extension $i] == ".lnk" && [ GidUtils::IsLink [file join $realdir $i]] == 2 && \
                       [file extension [file rootname $i]] == ".gid" } {
            set path [string range $dir $startrelpath end]
            ReadProblemtypeConfigFile $path $i
            continue
        }
        FastCacheFromProblemtypeMenuDir [file join $dir $i]
    }
}

proc FastCacheFromProblemtypeMenu {} {
    global GIDDEFAULT GidPriv
    #recreate this information also if exists GidPriv(dirfiles,$dir)
    #can be created or deletes files or directrories

    set dir $GIDDEFAULT  
    set dirs [glob -nocomplain -tails -directory $dir -types d *.gid]
    foreach link [glob -nocomplain -tails -directory $dir -types f *.lnk] {
        if { [ GidUtils::IsLink [file join $dir $link]] == 2 } {
            lappend dirs $link
        }
    }
    set GidPriv(dirfiles,$GIDDEFAULT) [lsort -dictionary $dirs]    
    FastCacheFromProblemtypeMenuDir [file join $dir problemtypes]
}


proc GetProblemTypes { } {
    global GIDDEFAULT GidPriv

    set current [ GiD_Info Project ProblemType]

    set probt ""
    foreach i [glob -nocomplain [file join $GIDDEFAULT *.gid]] {
        lappend probt [file tail [file root $i]]
    }
    set probt [lsort -dictionary $probt]

    return $probt
}


#use the same advance bar for pre and post

proc AdvanceBar { numerator divisor inum { title "" } { maintext ""} } {   
    if { [GidUtils::IsTkDisabled] } {
        return 1
    }    
    if { [GiD_Set ProgressBarInMainWindow] } {
        PostProgressBar $numerator $divisor $title $maintext
    } else {
        PostProgressBar $numerator $divisor $maintext $title
    }
}


proc SaveWinConfiguration { } {
    set file [Browser-ramR file write .gid \
                  [_ "Write window configuration"]]
    if { $file == "" } { return }
    file delete $file
    WriteTCLDefaultsInFile $file
}

#cambio por las pantallas panoramicas
# pues la ventana de gid se sale de pantalla
proc GiveBestGidDefaults {} {
    global GIDDEFAULTTCL
    set realh [winfo screenheight .gid]
    foreach i [glob [file join $GIDDEFAULTTCL gidDefaults]*] {
        if { [regexp -nocase {gidDefaults([0-9]*)x([0-9]*)} $i trash w h] } {
            if { $h == $realh } { return $i }
            # la vertical ha de ser menor que la real, si no se salen de pantalla
            if { ![info exists bestf] || ( ( [expr abs($realh-$h)]< $bestdist) && ( $h <= $realh))} {
                set bestf $i
                set bestdist [expr abs($realh-$h)]
            }
        }
    }
    if { [info exists bestf] } { return $bestf }
    return $GIDDEFAULTTCL/gidDefaults
}


proc ContextualSubMenu { w } {
    global ActionsMenuVar ActionsMenuLabels ActionsMenuVarType
    $w delete 0 end
    if { $ActionsMenuVarType == "TMP" } {
        set words ""
        foreach i $ActionsMenuVar j $ActionsMenuLabels {
            #regsub -all {([a-z])([A-Z])} $i "\\1 \[string tolower \\2]" name
            #set name [subst $name]
            #set name [string toupper [string index $name 0]][string range $name 1 end]
            set name $j
            if { $i == "Join" || $i == "NoJoin" } {
                append name " ${::acceleratorText}-a"
            }
            if { [lindex $i 0] == "-np-" } {
                lappend words [list $name [lrange $i 1 end]]
            } else {
                lappend words [list $name [list GiD_Process $i]]
            }
        }
        rmenuconf $w $words
    } else {
        rmenuconf $w  { { -NONE- "" } }
        #$w entryconfigure end -state disabled
        $w entryconfigure end -foreground $::GidPriv(Color,DisabledForegroundMenu)
    }
}


proc SelectJoinOrNoJoin {} {
    global ActionsMenuVar

    if { [lsearch -exact $ActionsMenuVar Join] != -1 } {
        GiD_Process Join
    } elseif { [lsearch -exact $ActionsMenuVar NoJoin] != -1 } {
        GiD_Process NoJoin
    }
}

proc SelectionOnlyVisibleOrAll {} {
    if { [ GiD_Set SelectionOnlyVisible] == 0 } {
        GiD_Set SelectionOnlyVisible 1
        ::GidUtils::SetWarnLine "Now only select visible entities"
    } else {
        GiD_Set SelectionOnlyVisible 0
        ::GidUtils::SetWarnLine "Now select visible and hidden entities"
    }
}

proc UpdateGraphFramesBegin { w HorV x y} {
    global GidPriv
    bind $w <ButtonRelease-1> "UpdateGraphFramesEnd %W $x $y %x %y $HorV"
}

proc UpdateGraphFramesEnd { w xold yold x y HorV } {

    set master [lindex [grid info $w] 1]

    regexp -- {-row[ ]*([0-9]+)} [grid info $w] {} irow
    regexp -- {-column[ ]*([0-9]+)} [grid info $w] {} icol

    if { $HorV == "v" || $HorV == "hv"} {
        set newwidth1 [expr [lindex [grid bbox $master 0 0] 2]+$x]
        set newwidth2 [expr [lindex [grid bbox $master 2 0] 2]-$x]  
        if { $newwidth1 < 0 } { set newwidth1 0 }
        if { $newwidth2 < 0 } { set newwidth2 0 }
        grid columnconf $master 0 -weight $newwidth1
        grid columnconf $master 2 -weight $newwidth2
    }
    if { $HorV == "h" || $HorV == "hv"} {
        set newheight1 [expr [lindex [grid bbox $master 0 0] 3]+$y]
        set newheight2 [expr [lindex [grid bbox $master 0 2] 3]-$y]
        if { $newheight1 < 0 } { set newheight1 0 }
        if { $newheight2 < 0 } { set newheight2 0 }
        grid rowconf $master 0 -weight $newheight1
        grid rowconf $master 2 -weight $newheight2
    }
}

proc PackToglSeparator { w row col type } {
    switch $type {
        h {
            $w configure -cursor sb_v_double_arrow
            bind $w <1> "UpdateGraphFramesBegin %W h %x %y"
            grid $w -in .gid.central.wins -row $row -column $col \
                -sticky nsew
        }
        v {
            $w configure -cursor sb_h_double_arrow
            bind $w <1> "UpdateGraphFramesBegin %W v %x %y"
            grid $w -in .gid.central.wins -row $row -column $col \
                -sticky nsew
        }
        hv {
            $w configure -cursor cross
            bind $w <1> "UpdateGraphFramesBegin %W hv %x %y"
            grid $w -in .gid.central.wins -row $row -column $col \
                -sticky nsew
        }
    }
}

proc PackToglWindows { type } {

    if { ![winfo exists .gid.central.wins] } {
        PrepareToglForSeveralWindows
    }

    set totalnum [string index $type 0]
    set i 2
    while { [winfo exists .gid.central.wins.graphwin$i] } {
        incr i
    }
    incr i -1
    if { $i < $totalnum } { return }

    foreach i [grid slaves .gid.central.wins] { grid forget $i }
    for { set i 1 } { $i <= 5 } { incr i } {
        if { ![winfo exists .gid.central.wins.separator$i] } {
            ttk::frame .gid.central.wins.separator$i
        }
    }

    if { $type == "1" } {
        grid .gid.central.wins.graphwin1 -in .gid.central.wins \
            -row 0 -column 0 \
            -sticky nsew -columnspan 3  -rowspan 3
        .gid.central.s SetPosition 1
        #sobra?# puesto idletasks
        update idletasks
        .gid.central.wins.graphwin1 configure -borderwidth 0
    } elseif { $type == "2LR" || $type == "3L" } {
        grid .gid.central.wins.graphwin1 -rowspan 3 -row 0 -column 0 \
            -sticky nsew
        .gid.central.s SetPosition L
        PackToglSeparator .gid.central.wins.separator1 0 1 v
        if { $type == "2LR" } {
            PackToglSeparator .gid.central.wins.separator2 1 1 v
        } else {
            PackToglSeparator .gid.central.wins.separator2 1 1 hv
        }
        PackToglSeparator .gid.central.wins.separator3 2 1 v
    } elseif { $type == "2UD" || $type == "3U" } {
        grid .gid.central.wins.graphwin1 -columnspan 3 -row 0 -column 0 \
            -sticky nsew
        .gid.central.s SetPosition B
        PackToglSeparator .gid.central.wins.separator4 1 0 h
        if { $type == "2UD" } {
            PackToglSeparator .gid.central.wins.separator2 1 1 v
        } else {
            PackToglSeparator .gid.central.wins.separator2 1 1 hv
        }
        PackToglSeparator .gid.central.wins.separator5 1 2 h
    } else {
        grid .gid.central.wins.graphwin1 -row 0 -column 0 \
            -sticky nsew
        .gid.central.s SetPosition BL
        PackToglSeparator .gid.central.wins.separator1 0 1 v
        PackToglSeparator .gid.central.wins.separator2 1 1 hv
        PackToglSeparator .gid.central.wins.separator4 1 0 h
    }

    set icurr 2
    if { $type == "2UD" || $type == "3D" } {
        grid .gid.central.wins.graphwin$icurr -in .gid.central.wins \
            -columnspan 3 -row 2 -column 0 \
            -sticky nsew
        .gid.central.wins.graphwin${icurr}.s SetPosition T
        incr icurr
    } elseif { $type == "3R" || $type == "3U" || $type == "4" } {
        grid .gid.central.wins.graphwin$icurr -in .gid.central.wins -row 2 -column 0 \
            -sticky nsew
        .gid.central.wins.graphwin${icurr}.s SetPosition TL
        incr icurr
        PackToglSeparator .gid.central.wins.separator3 2 1 v
    }
    if { $type == "2LR" || $type == "3R" } {
        grid .gid.central.wins.graphwin$icurr -in .gid.central.wins -rowspan 3 -row 0 -column 2 \
            -sticky nsew
        .gid.central.wins.graphwin${icurr}.s SetPosition R
        incr icurr
    } elseif { $type == "3L" || $type == "3D" || $type == "4" } {
        grid .gid.central.wins.graphwin$icurr -in .gid.central.wins \
            -rowspan 1 -row 0 -column 2 \
            -sticky nsew
        .gid.central.wins.graphwin${icurr}.s SetPosition BR
        incr icurr
        PackToglSeparator .gid.central.wins.separator5 1 2 h

    }

    if { $type == "3L" || $type == "3U" || $type == "4" } {
        grid .gid.central.wins.graphwin$icurr -in .gid.central.wins -row 2 -column 2 \
            -sticky nsew
        .gid.central.wins.graphwin${icurr}.s SetPosition TR
        incr icurr
    }

    grid columnconf .gid.central.wins 0 -weight 1
    grid rowconf .gid.central.wins 0 -weight 1

    grid columnconf .gid.central.wins 1 -weight 0 -minsize 1
    grid columnconf .gid.central.wins 2 -weight 1

    grid rowconf .gid.central.wins 1 -weight 0 -minsize 1
    grid rowconf .gid.central.wins 2 -weight 1


    #      if { $type == 1 } {
    #          set i 5
    #          while { [winfo exists .gid.central.wins.graphwin$i] } { incr i }
    #          incr i -5
    #          if { $i == 0 } {
    #              .gid.central.wins.wins.graphwin1 configure -borderwidth 0
    #          }
    #      }

}

proc GiveNumToglInteriorWins {} {
    set i 2
    while { [winfo exists .gid.central.wins.graphwin$i] } { incr i }
    incr i -1
    return $i
}

proc DestroyRemainingToglWindows { type } {

    if { [string tolower $type] == "ext" } { return }

    set totalnum [string index $type 0]   
    for { set i [expr $totalnum+1]} { $i <= 6} { incr i} {
        if { [ winfo exists .gid.central.wins.graphwin$i] } {
            destroy .gid.central.wins.graphwin$i
        }
    }
}

proc PrepareToglForSeveralWindows {} {

    ttk::frame .gid.central.wins
    #pack .gid.central.wins -expand 1 -fill both
    switch [winfo manager .gid.central.s] {
        grid {
            eval grid .gid.central.wins [grid info .gid.central.s]
        }
        pack {
            pack .gid.central.wins -in .gid.central -before .gid.central.s \
                -anchor center -expand 1 -fill both -side left
        }
        panedwindow {
            set ws "."
            set found 0
            set j ""
            for { set i 0 } { $i < [llength $ws] } { incr i } {
                foreach j [winfo children [lindex $ws $i]] {
                    if { [winfo class $j] eq "Panedwindow" && [lsearch [$j panes] .gid.central.s] != -1 } {
                        set found 1
                        set ws "" ;#to break also the for loop
                        break
                    }
                    lappend ws $j
                }
            }
            if { $found } {
                #set ipos [lsearch [$j panes] .gid.central.s]
                # Save sash position
                for {set i 0} {$i < [expr [llength [$j panes]]-1]} {incr i} {
                    set _wsash($i) [lindex [$j sash coord $i] 0]
                }

                $j add .gid.central.wins -before .gid.central.s
                $j forget .gid.central.s

                # Restore sash position
                foreach i [array names _wsash]  {
                    update idletask
                    $j sash place $i $_wsash($i) 0
                }
            }
        }
    }


    ttk::frame .gid.central.wins.graphwin1 -style groove.TFrame -borderwidth 2
    pack .gid.central.s -in .gid.central.wins.graphwin1 -expand 1 \
        -fill both
    .gid.central.s configure -width 0 -height 0

    raise .gid.central.s

    grid .gid.central.wins.graphwin1 -in .gid.central.wins -row 0 \
        -column 0 -sticky nsew
    grid rowconf .gid.central.wins 0 -weight 1
    grid columnconf .gid.central.wins 0 -weight 1
}


proc GiDActualizaVentanasTogl { } {
    .central.s render
    if { [winfo exists .gid.central.wins] } {
        # 1, 2, 3, 4, 5 --> interiores
        # 6 --> exterior
        for { set i 0} { $i < 7} { incr i} {
            set new_win .gid.central.wins.graphwin$i
            if { [ winfo exists $new_win] && [ winfo exists ${new_win}.s] } {
                ${new_win}.s render
            }
        }
    }
}

proc CreateNewToglWindow { type parent } {
    global tcl_platform GidPriv

    set type [string toupper $type]

    if { $parent != "" } {
        if { ![winfo exists $parent] } {
            WarnWinText "parent widget $parent not exists"
            return ""
        }
        set w $parent
    } else {
        if { ![winfo exists .gid.central.wins] } {
            PrepareToglForSeveralWindows
        }
        if { $type == "EXT" } {
            set i 6
        } else {
            set i 2
        }
        while { [winfo exists .gid.central.wins.graphwin$i] } { 
            incr i 
        }
        set w .gid.central.wins.graphwin$i
  
        if { $type == "EXT" } {
            # "" 0 0 <- para permitir que se ponga debajo ( y no la haga transient)
            set geomname NewWindow${i}WindowGeom
            #InitWindow $w [_ "View %s" $i] $geomname [list after idle GiD_Process 'NewWin EXT] "" 0 0
            InitWindow $w [_ "View %s" $i] $geomname [list .gid.central.s makenewwindow EXT] "" 0 0
            
            if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0
            if { ![info exists GidPriv($geomname)] } {
                wm geometry $w "320x240+100+100"
            }
            bind $w <Escape> "GiD_Process escape"       
            bind $w <${::acceleratorKey}-a> SelectJoinOrNoJoin
            #bind $w <${::acceleratorKey}-h> SelectionOnlyVisibleOrAll
            
            
            set w $w.f
            ttk::frame $w -style groove.TFrame -borderwidth 2
            pack $w -expand 1 -fill both
        } else {
            ttk::frame $w -style groove.TFrame -borderwidth 2
            #PackToglWindows $type
        }
    }
   
    CreateNewToglGID $w.s 1    
    $w.s configure -width 0 -height 0 ;#if not set togl some -width -height then grid or pack sizes are wrong with multiple windows   
   
    grid $w.s -sticky nsew
    grid columnconfigure $w 0 -weight 1
    grid rowconfigure $w 0 -weight 1    
         
    catch {
        bind $w.s <4> [ list $w.s button 4 %x %y ]
        bind $w.s <5> [ list $w.s button 5 %x %y ]
    }

    bind $w.s <MouseWheel> [list MouseWheelEventToButtonEvent $w.s %D]
    bind $w.s <1> {Togl_Button-1 %W %x %y}
    bind $w.s <ButtonRelease-1> {Togl_ButtonRelease-1 %W %x %y}
    bind $w.s <KeyPress> {Togl_KeyPress %k %N %s}

    set ::gid_central_button 2
    set ::gid_right_button 3
    
    if { $::tcl_platform(os) == "Darwin" } {
        # http://wiki.tcl.tk/12987 FAQ 7.7:
        # For historical reasons, MacMice buttons 2 and 3 refer to the right and middle buttons
        # respectively, which is indeed the opposite way round from Windows and *nix systems.
        set ::gid_central_button 3
        set ::gid_right_button 2
    }

    bind $w.s <$::gid_central_button> { %W button 2 %x %y }
    bind $w.s <Motion> { %W motion %x %y }
    bind $w.s <Leave> { %W leave %x %y }
    bind $w.s <Enter> { %W enter %x %y }

    bind $w <${::acceleratorKey}-a> SelectJoinOrNoJoin
    #bind $w <${::acceleratorKey}-h> SelectionOnlyVisibleOrAll

    bind $w.s <${::acceleratorKey}-Key-1> {GiD_Process 'Rotate Angle 270 90}
    bind $w.s <${::acceleratorKey}-Key-2> {GiD_Process 'Rotate Angle 270 0}
    bind $w.s <${::acceleratorKey}-Key-3> {GiD_Process 'Rotate Angle 0 0}
    bind $w.s <${::acceleratorKey}-Key-4> {GiD_Process 'Rotate Angle 45 45}
    bind $w.s <${::acceleratorKey}-t> {focus .gid.comm.e}

    bind $w.s <$::gid_right_button> {
        #%W gidmakecurrent
        set x [expr [winfo rootx %W]+%x+2]
        set y [expr [winfo rooty %W]+%y]
        GiDShowContextualMenu $x $y          
    }
    foreach i [bind .gid] {
        bind $w $i [bind .gid $i]
    }

    #     bind $w <FocusIn> "catch { focus .gid.comm.e }"
    # in Darwin ( Mac OS X) Drag and Drop events are not inherited
    # and are assigned to final widget's
    if { $::tcl_platform(os) == "Darwin" } {
        register_dnd_event $w.s
    }

    SetButtonMeaning $w.s

    return $w
}



# to initialize
set GidHelp(HelpSystemActive) ""
set GidHelp(helpcanceller) ""
set GidPriv(JustHelpActived) 0
set GidHelp(HelpLeaveBefore) ""
set GidHelp(JustDeleted) ""
set GidPriv(HelpSystem) .gid.helpsystem
set GidPriv(HelpSystemmenu) 0


proc DisplayGidHelpMenu { w text type xbase ybase } {
    global GidHelp

    #if { [ info exists ::GidPriv(TooltipPopup)] && \
        #     ( $::GidPriv(TooltipPopup) == "disabled")} {
        #return
    #}

    after cancel $GidHelp(helpcanceller)
    set GidHelp(helpcanceller) ""

    if { $GidHelp(HelpLeaveBefore) != "" } {
        bind $w <Leave> $GidHelp(HelpLeaveBefore)
    }
    set GidHelp(HelpLeaveBefore) ""

    set x $xbase ; set y $ybase

    catch { destroy .gid.__helpmenu }
    menu .gid.__helpmenu
    set UnderLineList {}
    set lbl [_ "Help"]
    set under [FindUnderChar lbl UnderLineList]
    .gid.__helpmenu add command -label $lbl -underline $under -command \
        [list PopupTransparentInfo $text $xbase $ybase $w 0 -1]
        #[list DisplayGidHelp $w $text menu $xbase $ybase]
    if { $type == "helpandtools" } {
        set lbl [_ "Configure toolbars"]
        set under [FindUnderChar lbl UnderLineList]
        .gid.__helpmenu add command -label $lbl -underline $under -command TOBegin
    }
    GiD_PopupMenu .gid.__helpmenu $x $y
}

proc DisplayGidHelpLeave { w x y { force no } } {
    global GidPriv GidHelp

    if ![winfo exists $w] {
        return
    }
    if { $force == "no" && $x >= [winfo rootx $w] && $y >= [winfo rooty $w] && \
             $x <= [expr [winfo rootx $w]+[winfo width $w]] && \
             $y <= [expr [winfo rooty $w]+[winfo height $w]] } {
        return
    }

    if { [winfo exists $GidPriv(HelpSystem)] } {
        if { $force == "no" && $x >= [winfo rootx $GidPriv(HelpSystem)] && $y >= \
                 [winfo rooty $GidPriv(HelpSystem)] && \
                 $x <= [expr [winfo rootx $GidPriv(HelpSystem)]+[winfo width $GidPriv(HelpSystem)]] && \
                 $y <= [expr [winfo rooty $GidPriv(HelpSystem)]+[winfo height $GidPriv(HelpSystem)]] } {
            return
        }
    }


    bind all <Motion> ""

    after cancel $GidHelp(helpcanceller)
    set GidHelp(helpcanceller) ""

    if { [winfo exists $GidPriv(HelpSystem)] } {
        set GidPriv(JustHelpActived) 1
        after 1000 set GidPriv(JustHelpActived) 0
    }

    if { !$GidPriv(HelpSystemmenu) } {
        catch { destroy $GidPriv(HelpSystem)}
    }
    if { $GidHelp(HelpLeaveBefore) != "" } {
        bind $w <Leave> $GidHelp(HelpLeaveBefore)
    }
    set GidHelp(HelpLeaveBefore) ""
    after cancel set GidHelp(JustDeleted) ""

    if { $force == "no" } {
        set GidHelp(JustDeleted) $w
    } else {
        set GidHelp(JustDeleted) all
    }
    after 3000 "set GidHelp(JustDeleted) {}"
}

proc DisplayGidHelpLauncher { w x y text } {
    global GidPriv GidHelp

    #if { $GidHelp(JustDeleted) == $w || $GidHelp(JustDeleted) == "all" } { return }

    if { $GidPriv(JustHelpActived) } {
        DisplayGidHelp $w $text enter $x $y
    }

    if { [winfo exists $GidPriv(HelpSystem)] } {
        DisplayGidHelp $w $text enter $x $y
    } else {
        after cancel $GidHelp(helpcanceller)
        set GidHelp(helpcanceller) [after 1500 DisplayGidHelp $w [ list $text] enter $x $y]
    }
    #set GidHelp(HelpLeaveBefore) [bind $w <Leave>]

    bind all <Motion> "DisplayGidHelpLeave $w %X %Y"
    #bind $w <Leave> "$GidHelp(HelpLeaveBefore) ; DisplayGidHelpLeave $w"
    bind $w <ButtonPress-1> "+DisplayGidHelpLeave $w %X %Y yes"
}

proc GidHelpL { wlist type args } {
    set text [join $args]

    foreach w $wlist {
        set tag ""
        if { [llength $w] == 2 } {
            set tag [lindex $w 1]
            set w [lindex $w 0]
        }
        if { ![winfo exists $w] } { continue }

        set haveimage 0
        catch {
            if { [$w cget -image] != "" } { set haveimage 1 }
        }
        catch {
            if { [$w cget -bitmap] != "" } { set haveimage 1 }
        }

        if { $haveimage } {
            if { $tag == "" } {        
                bind $w <Enter> "+DisplayGidHelpLauncher $w %X %Y [ list $text]"
                foreach i [winfo children $w] {
                    GidHelpL $i $type $text
                }
            } else {
                $w tag bind $tag <Enter> "+DisplayGidHelpLauncher $w %X %Y [ list $text]"
            }
        }

        if { $tag == "" } {
            # bind $w <ButtonPress-2> \
                               #                   "[ list DisplayGidHelpMenu $w $text $type %X %Y]; break"
            bind $w <ButtonPress-$::gid_right_button> \
                "[ list DisplayGidHelpMenu $w $text $type %X %Y]; break"
            foreach i [winfo children $w] {
                GidHelpL $i $type $text
            }
        } else {
            # $w tag bind $tag <ButtonPress-2> \
                    #                   "[ list DisplayGidHelpMenu $w $text $type %X %Y]; break"
            $w tag bind $tag <ButtonPress-$::gid_right_button> \
                "[ list DisplayGidHelpMenu $w $text $type %X %Y]; break"
        }
    }
}

#from GiD11.1.3d only mantained set dynamic_help_method bwidget (but in fact uses diferent helps)
#last version with dynamic_help_method gid_old and tooltip tclfileP.tcl 1.1346

#use always PopupTransparentInfo for rightbutton menu, option help (colors configuration on Postwidgets.tcl) 
#use showTooltip when ::GidPriv(TooltipPopup)==bottom (colors configuration on Postwidgets.tcl)
#use DynamicHelp when ::GidPriv(TooltipPopup)==normal (colors configuration on gid_themes.tcl DynamicHelp::configure)

    package require textutil
    
    proc GidHelp { wlist text { nottimepopup 0 } {type help}} {      
        if { $text == "" } {
          return
        }
        foreach w $wlist {
            if { ![winfo exists $w] } {
                #WarnWinText "GidHelp $w not exists"
                continue
            }
            #preparing text to be displayed adjust each paragraph to line lenght 72
            set oldparagraphs [::textutil::splitx $text \n]
            set newparagraphs ""
            foreach para $oldparagraphs {
              lappend newparagraphs [::textutil::adjust $para -length 72]
            }
            set text [join $newparagraphs "\n"]
            #end preparing
                
            if { [ info exists ::GidPriv(TooltipPopup)] } {
                if { ( $::GidPriv(TooltipPopup) == "normal" ) && ( $nottimepopup == 0 ) } {
                    DynamicHelp::add $w -type balloon -text $text               
                }
                if { ( $::GidPriv(TooltipPopup) == "bottom" ) && ( $nottimepopup == 0 ) } {
                    setTooltip $w -text $text -delay 0 -bottom .gid
                }
            }            
            #changed on GiD11.1.3d not working properlly
            bind $w <ButtonPress-$::gid_right_button> "[list DisplayGidHelpMenu $w $text $type %X %Y]; break"
            #set show_link 0
            #bind $w <ButtonPress-$::gid_right_button> [list PopupTransparentInfo $text %X %Y $w $show_link]
        }
    }
    proc HasGidHelp { w } {      
        set bindings [bind $w <ButtonPress-$::gid_right_button>]
        return [regexp DisplayGidHelpMenu* $bindings]
    }
    
    proc GidHelpT { wlist text } {
        GidHelp $wlist $text 0 helpandtools
    }
    
    #invoked by DisplayGidHelpMenu, that force show help with contextual Help menu
    proc DisplayGidHelp { w text but x y } {
        #Warning could not have help!! 
        #    set oldtext [DynamicHelp::register $w -text]
        DynamicHelp::add $w -text $text        
        
        DynamicHelp::_show_help $w $w $x $y
        
        DynamicHelp::delete $w
        #DynamicHelp::add $w -text $oldtext
    }


proc GidHelpRecursive { w args } {
    GidHelp $w [join $args]
    foreach i [winfo children $w] {
        GidHelpRecursive $i {*}$args
    }
}

proc NURBSSurfaceMove {} {
    global GidPriv
    set w .gid.nurbsurfmove

    InitWindow $w [_ "NURBS surface movement"] NURBSSurfaceMoveWindowGeom NURBSSurfaceMove
    if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0


    set GidPriv(NURBSsurfoldmove) 0
    gidscale $w.s -from -10 -to 10 -resolution 1 -showvalue 0 \
        -command NURBSSurfaceMoving -orient horizontal

    proc NURBSSurfaceMoving { val } {
        global GidPriv
        set incre [expr $val-$GidPriv(NURBSsurfoldmove)]
        GiD_Process normal=$incre
        set GidPriv(NURBSsurfoldmove) $val
    }
    

    ttk::button $w.b -text [_ "Reset slide"] -command "\
            set GidPriv(NURBSsurfoldmove) 0 ; $w.s set 0" -style BottomFrame.TButton

    ttk::button $w.close -text [_ "Close"] -command "destroy $w" -style BottomFrame.TButton
    #SetWidgetsWidthFromText $w.b $w.close

    grid $w.s -row 1 -column 1 -sticky ew
    grid $w.b -row 2 -column 1
    grid $w.close -row 2 -column 2
    grid columnconf $w 1 -weight 1


}
#NURBSSurfaceMove

proc PostGraphResultsFill { combo_anal combo_step combo_result frame_components type } {
    variable ViewMenuPriv

    if { ![winfo exists $combo_result] } { return }

    if { $type eq "anal" } {
        set all [lsort -dictionary [ GiD_Info postprocess get all_analysis]]
        # set all [ GiD_Info postprocess get all_analysis]
        set curr [ GiD_Info postprocess get cur_analysis]
        
        set all_analysis {}
        set max_len 0
        set l 0
        foreach i $all {
            regsub -all {_} $i { } var
            lappend all_analysis $var
            set l [ string length $var]
            if { $l > $max_len} {
                set max_len $l
            }
        }
        $combo_anal configure -values $all_analysis
        if { $l > 20} {
            grid configure $combo_anal -sticky ew
        }
        if { $curr != "" } {
            regsub -all {_} $curr { } curr
        } else { regsub -all {_} [lindex $all 0] { } curr }
        set var [$combo_anal cget -textvariable]
        uplevel #0 [list set $var $curr]
        return
    } else {
        set var [$combo_anal cget -textvariable]
        set analisis [uplevel #0 [list set $var]]
        regsub -all { } $analisis {_} analisis
        if { [lsearch -exact [ GiD_Info postprocess get all_analysis] \
                  $analisis] == -1 } {
            set analisis [ GiD_Info postprocess get cur_analysis]
        }
    }

    if { $type eq "anal" || $type eq "step" } {
        if { $analisis ne ""} {
            # set all [ GiD_Info postprocess get all_steps $analisis]
            if { [ catch { set all [ GiD_Info postprocess get all_steps $analisis]}]} {
                set all {}
            }
            set current [ GiD_Info postprocess get cur_step $analisis]
            if { ( $current == "") || ( [ lsearch -exact $all $current] == -1) } {
                regsub -all {_} [lindex $all 0] { } current
            }
            $combo_step configure -values $all
            set var [$combo_step cget -textvariable]
            uplevel #0 [list set $var $current]
            $combo_step configure -state normal
            set step $current
        } else {
            $combo_step configure -values ""
            set var [$combo_step cget -textvariable]
            uplevel #0 [list set $var ""]
            $combo_step configure -state disabled
            set step ""
        }
        if { $type eq "step" } { return }
    } else {
        set var [$combo_step cget -textvariable]
        set step [uplevel \#0 [list set $var]]
        if { [ catch { set lst_step [ GiD_Info postprocess get all_steps $analisis]}]} {
            set lst_step {}
        }
        if { [lsearch -exact $lst_step $step] == -1 } {
            set step [ GiD_Info postprocess get cur_step $analisis]
        }
    }
    if { $analisis ne "" && $step ne "" } {
        set res [ lsort -dictionary [ GiD_Info postprocess get results_list Contour_Fill $analisis $step]]
        set var [$combo_result cget -textvariable]
        if { $res eq "" } {
            uplevel #0 [list set $var ""]
            $combo_result configure -values ""
            $combo_result configure -state disabled
            set result ""
        } else {
            set result [uplevel #0 [list set $var]]
            if { [lsearch -exact $res $result] == -1 } {
                set result [lindex $res 0]
                uplevel #0 [list set $var $result]
            }
            $combo_result configure -values $res
            $combo_result configure -state normal
        }
    } else {
        set result ""
        uplevel #0 [list set $var ""]
        $combo_result configure -values ""
        $combo_result configure -state disabled
    }
    foreach i [winfo children $frame_components] {
        catch { destroy $i }
    }
    if { $result eq "" } { return }
    set irow 1
    set componentes_txt [ GiD_Info postprocess get components_list Contour_Fill \
                              $result $analisis $step]
    foreach i $componentes_txt {
        set ww [ string tolower $i]$irow
        regsub -all {\.} $ww  w
        regsub -all {_} $i { } comp
        ttk::radiobutton $frame_components.r$w -text $comp -value $i -variable \
            ViewMenuPriv(border_comp)
        grid $frame_components.r$w -sticky nw -row $irow -column 1
        grid rowconf $frame_components $irow -weight 0
        incr irow
    }
    set ViewMenuPriv(border_comp) [lindex $componentes_txt 0]
    grid rowconf $frame_components $irow -weight 1
    grid columnconf $frame_components 1 -weight 1
    if { [ llength $componentes_txt] != 4} {
        set ViewMenuPriv(border_comp) [ lindex $componentes_txt 0]
    } else {
        set ViewMenuPriv(border_comp) [ lindex $componentes_txt 3]
    }
}

proc PostGraphResultsWindow { {w .gid.graph} } {
    global ViewMenuPriv

    InitWindow $w [_ "View graphs"] PostGraphResultsWindowGeom PostGraphResultsWindow
    if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0
    #PostGraphResultsWindow
    #<- para abrir una ventana sin resultados?

    set cur_anal [ GiD_Info postprocess get cur_analysis]

    ttk::labelframe $w.m1 -text [_ "graph type"]
    set m1 [ttk::frame $w.m1.m]
    pack $m1 -fill both -expand 1

    ttk::radiobutton $m1.r1 -text [_ "Line variation"] -variable ViewMenuPriv(border_graph_axX) \
        -value LineVariation
    ttk::radiobutton $m1.r2 -text [_ "X variation"] -variable ViewMenuPriv(border_graph_axX) \
        -value X_Variation
    ttk::radiobutton $m1.r3 -text [_ "Y variation"] -variable ViewMenuPriv(border_graph_axX) \
        -value Y_Variation
    ttk::radiobutton $m1.r4 -text [_ "Z variation"] -variable ViewMenuPriv(border_graph_axX) \
        -value Z_Variation

    set ViewMenuPriv(border_graph_axX) LineVariation

    grid $m1.r1 $m1.r2 -sticky w
    grid $m1.r3 $m1.r4 -sticky w

    ttk::labelframe $w.m2 -text [_ "result"]
    set m2 [ttk::frame $w.m2.m]
    pack $m2 -fill both -expand 1

    ttk::label $m2.l1 -text [_ "Analysis"]:
    ComboBox $m2.am1 -textvariable ViewMenuPriv(BG_PostResultsAnal) -editable 0 \
        -width 20 -borderwidth 1

    ttk::label $m2.lstep -text [_ "Step"]:
    ComboBox $m2.cbstep -textvariable ViewMenuPriv(BG_PostResultsStep) \
        -editable 0 -width 8 -borderwidth 1

    ttk::label $m2.prr -text [_ "Result"]:
    ComboBox $m2.m2 -textvariable ViewMenuPriv(BG_PostResultsRes) -width 20 \
        -editable 0

    grid $m2.l1 $m2.am1 $m2.lstep -sticky ew -pady 2
    grid $m2.prr $m2.m2 $m2.cbstep -sticky ew -pady 2
    grid columnconfigure $m2 1 -weight 1

    ttk::labelframe $w.fr -text [_ "components"] -height 100
    set fr [ttk::frame  $w.fr.m]
    pack $fr -fill both -expand 1

    #    ttk::frame $w.fr -borderwidth 2 -style ridge.TFrame -height 100

    set cmd [list PostGraphResultsFill $m2.am1 $m2.cbstep $m2.m2 $fr]
    foreach "n t" [list BG_PostResultsAnal step BG_PostResultsStep result \
                       BG_PostResultsRes components] {
        trace add variable ViewMenuPriv($n) write "$cmd $t;#"
        bind $fr <Destroy> [list trace remove variable \
                                ViewMenuPriv($n) write "$cmd $t;#"]
    }
    eval $cmd anal

    #     if { ( $res != "-No results-") && ( $res != "") } {
    #         set cmd "AddComponentsToMenu $m2 $fr ;#"
    #         trace add variable ViewMenuPriv(border_graph_axY) write $cmd
    #         set ViewMenuPriv(border_graph_axY) [lindex $res 0]
    #         bind $fr <Destroy> [list trace remove variable \
        #                 ViewMenuPriv(border_graph_axY) write $cmd]
    #     }
    ttk::frame $w.buts -style BottomFrame.TFrame
    # -background [CCColorActivo [$w cget -background]]


    ttk::button $w.buts.b0 -text [_ "Select 2 points"] -style BottomFrame.TButton \
        -command "ViewGraphs:BorderGraphTwoPointsInternal $w.buts"
    ttk::button $w.buts.b -text [_ "Select border"] -style BottomFrame.TButton -command "ViewGraphs:SelectBorder $w.buts"
    focus $w.buts.b
    
    ttk::menubutton $w.buts.mopt -text [_ "Actions"] -width 10 -menu $w.buts.mopt.m \
        -image [gid_themes::GetImage ArrowDown.png small_icons] \
        -compound right
    menu $w.buts.mopt.m
    set UnderLineList {}
    set text [_ "Draw graphs"]
    set under [FindUnderChar text UnderLineList]
    $w.buts.mopt.m add command -label $text -underline $under -command {
        GiD_Process Mescape Results Graphs OptionsGraph ShowGraphs yes
    }
    set text [_ "No draw graphs"]
    set under [FindUnderChar text UnderLineList]
    $w.buts.mopt.m add command -label $text -underline $under -command {
        GiD_Process Mescape Results Graphs OptionsGraph ShowGraphs No
    }
    set text [_ "Clear graphs"]
    set under [FindUnderChar text UnderLineList]
    $w.buts.mopt.m add command -label $text -underline $under -command {
        GiD_Process Mescape Results Graphs OptionsGraph ClearGraphs
    }

    ttk::button $w.buts.close -text [_ "Close"] -style BottomFrame.TButton -command "destroy $w"

    #SetWidgetsWidthFromText $w.buts.b0 $w.buts.b $w.buts.mopt $w.buts.close

    # necessary as it is a compound
    $w.buts.mopt configure -width 50

    grid $w.buts.b0 $w.buts.b $w.buts.mopt $w.buts.close -padx 3 -pady 3


    grid $w.m1 -sticky nwe -row 1 -column 1
    grid $w.m2 -sticky nwe -row 2 -column 1
    grid $w.fr -sticky nsew -row 3 -column 1
    grid $w.buts -sticky nwe -row 5 -column 1
    if { $::tcl_version >= 8.5 } { grid anchor $w.buts center }
    grid rowconf $w 3 -weight 1
    grid columnconf $w 1 -weight 1
}

proc ViewGraphs:SelectBorder { frame } {
    global ViewMenuPriv

    if {[info exists ViewMenuPriv(border_comp)]} {
        regsub -all { } $ViewMenuPriv(BG_PostResultsAnal) {_} analysis
        GiD_Process escape escape escape escape results AnalysisSel \
            $analysis $ViewMenuPriv(BG_PostResultsStep)

        GiD_Process escape escape escape escape results graphs \
            bordergraph $ViewMenuPriv(border_graph_axX) \
            $ViewMenuPriv(BG_PostResultsRes) $ViewMenuPriv(border_comp)
        set SmallWinSelecting [ GiD_Set SmallWinSelecting]
        FinishButton [winfo toplevel $frame] $frame \
            [_ "Press 'Finish' to end selection"] \
            "" disableall $SmallWinSelecting
    }
}

proc ViewGraphs:BorderGraphTwoPointsInternal { frame } {
    global ViewMenuPriv
    if {[info exists ViewMenuPriv(border_comp)]} {
        GiD_Process escape escape escape escape results graphs linegraph \
            $ViewMenuPriv(BG_PostResultsRes) $ViewMenuPriv(border_comp)
        
        set SmallWinSelecting [ GiD_Set SmallWinSelecting]
        FinishButton [winfo toplevel $frame] $frame \
            [_ "Press 'Finish' to end selection"] \
            "" disableall $SmallWinSelecting
    }
}

#obsolete proc using auxiliary tcl commands, best use BorderGraphTwoPointsInternal
proc ViewGraphs:BorderGraphTwoPoints {} {
    variable ViewMenuPriv

    if {![info exists ViewMenuPriv(border_comp)]} { return }

    if { [ GiD_Info project ViewMode] == "GRAPHUSE" } {
        GiD_Process escape escape Results Graphs OptionsGraph ShowGraphs No
    }
    set p1 [ GidUtils::GetCoordinates [_ "Enter first point (ESC to leave)"]]
    if { $p1=="" } return
    set p2 [ GidUtils::GetCoordinates [_ "Enter second point (ESC to leave)"]]
    if { $p2=="" } return

    if { [MathUtils::VectorDistance $p1 $p2] < $MathUtils::Epsilon } {
        WarnWin [_ "Points cannot be the same"]
        return
    }
    set v1 [MathUtils::VectorDiff $p1 $p2]
    if { [lindex $v1 0] != 0.0 || [lindex $v1 1] != 0.0 } {
        set p3 [MathUtils::VectorSum $p1 [list [expr {-1*[lindex $v1 1]}] \
                                              [lindex $v1 0] 0.0]]
    } else {
        set p3 [list [lindex $v1 2] 0 0]
    }
    set n [MathUtils::VectorVectorialProd [MathUtils::VectorDiff $p2 $p1] \
               [MathUtils::VectorDiff $p3 $p1]]
    set p4 [MathUtils::VectorSum $p1 $n]

    set old_cuts [ GiD_Info postprocess get all_cutsets]
    set old_surfacesets [ GiD_Info postprocess get all_surfacesets]
    set old_volumesets [ GiD_Info postprocess get all_volumesets]

    GidUtils::WaitState .gid
    GidUtils::DisableGraphics

    if { $old_volumesets != "" } {
        ################################################################################
        #    First cut
        ################################################################################

        GiD_Process escape escape escape escape DoCut CutPlane ThreePoints \
            $p1 $p2 $p3
        GiD_Process escape escape escape escape DoCut TurnIntoMeshes

        set newsets ""
        foreach set [ GiD_Info postprocess get all_surfacesets] {
            if { [lsearch -exact $old_surfacesets $set] == -1 } {
                lappend newsets $set
            }
        }
        
        ################################################################################
        #    Delete 2nd cuts
        ################################################################################
        
        set cmd [list GiD_Process escape escape escape escape \
                     Utilities Delete CutSets]
        foreach cut [ GiD_Info postprocess get all_cutsets] {
            if { [lsearch -exact $old_cuts $cut] == -1 } {
                lappend cmd $cut yes
            }
        }
        lappend cmd escape
        eval $cmd
        
        ################################################################################
        #    Sets to off and on
        ################################################################################
        
        set active_vols [ GiD_Info postprocess get cur_volumesets]
        set active_surfs [ GiD_Info postprocess get cur_surfacesets]
        
        set cmd [list GiD_Process escape escape escape escape select \
                     VolumeSets]
        eval lappend cmd $active_vols
        lappend cmd escape
        eval $cmd
        
        set cmd [list GiD_Process escape escape escape escape select \
                     SurfaceSets]
        foreach surf $active_surfs {
            if { [lsearch -exact $newsets $surf] == -1 } {
                lappend cmd $surf
            }
        }
        foreach surf $newsets {
            if { [lsearch -exact $active_surfs $surf] == -1 } {
                lappend cmd $surf
            }
        }
        lappend cmd escape
        eval $cmd

        ################################################################################
        #    Second cut
        ################################################################################
        
        GiD_Process escape escape escape escape DoCut CutPlane ThreePoints \
            $p1 $p2 $p4
        GiD_Process escape escape escape escape DoCut TurnIntoMeshes
        
        ################################################################################
        #    Delete 2nd cuts
        ################################################################################
        
        set cmd [list GiD_Process escape escape escape escape \
                     Utilities Delete CutSets]
        foreach cut [ GiD_Info postprocess get all_cutsets] {
            if { [lsearch -exact $old_cuts $cut] == -1 } {
                lappend cmd $cut yes
            }
        }
        lappend cmd escape
        eval $cmd
        
        ################################################################################
        #    Delete surface sets
        ################################################################################
        
        set cmd [list GiD_Process escape escape escape escape \
                     Utilities Delete SurfaceSets]
        foreach set $newsets {
            lappend cmd $set yes
        }
        lappend cmd escape
        eval $cmd
        
        ################################################################################
        #    Activate created surface sets and rename
        ################################################################################
        
        set allsets [ GiD_Info postprocess get all_surfacesets]
        set newsets ""
        foreach set [ GiD_Info postprocess get all_surfacesets] {
            if { [lsearch -exact $old_surfacesets $set] == -1 } {
                set idx ""
                while { [lsearch -exact $allsets S_border_graph$idx] != -1 } {
                    if { $idx eq "" } { set idx 2 } else { incr idx }
                }
                set newname border_graph$idx
                GiD_Process escape escape escape escape Utilities ChangeName \
                    SurfaceSets $set $newname
                lappend newsets S_$newname
                lappend active_surfs S_$newname
            }
        }
        
        ################################################################################
        #    Leave activated sets as they were
        ################################################################################
        
        set active_vols_new [ GiD_Info postprocess get cur_volumesets]
        set active_surfs_new [ GiD_Info postprocess get cur_surfacesets]
        
        set cmd [list GiD_Process escape escape escape escape select \
                     VolumeSets]
        foreach vol [ GiD_Info postprocess get all_volumesets] {
            if { [lsearch -exact $active_vols_new $vol] == -1 && \
                     [lsearch -exact $active_vols $vol] != -1} {
                lappend cmd $vol
            }
        }
        eval $cmd
        
        set cmd [list GiD_Process escape escape escape escape select \
                     SurfaceSets]
        foreach surf [ GiD_Info postprocess get all_surfacesets] {
            if { [lsearch -exact $active_surfs_new $surf] == -1 && \
                     [lsearch -exact $active_surfs $surf] != -1} {
                lappend cmd $surf
            }
        }
        lappend cmd escape
        eval $cmd
    } elseif { $old_surfacesets != "" } {
        # create cut
        GiD_Process escape escape escape escape DoCut CutPlane $p1 $p2
        # convert to new set
        GiD_Process escape escape escape escape DoCut TurnIntoMeshes
        set newsets ""
        foreach set [ GiD_Info postprocess get all_surfacesets] {
            if { [lsearch -exact $old_surfacesets $set] == -1 } {
                lappend newsets $set
            }
        }
        # delete cut
        set cmd ""
        foreach cut [ GiD_Info postprocess get all_cutsets] {
            if { [lsearch -exact $old_cuts $cut] == -1 } {
                lappend cmd $cut yes
            }
        }
        GiD_Process Mescape Utilities Delete CutSets {*}$cmd escape
        #set set to on (by default, when converting cut, are off!!)
        GiD_Process Mescape select SurfaceSets {*}$newsets escape
    } else {
        set newsets ""
    }
    ################################################################################
    #    bye bye
    ################################################################################
    GidUtils::EnableGraphics
    GidUtils::EndWaitState .gid
    GiD_Redraw
    if { $newsets != "" } {
        regsub -all { } $ViewMenuPriv(BG_PostResultsAnal) {_} analysis
        GiD_Process escape escape escape escape results AnalysisSel \
            $analysis $ViewMenuPriv(BG_PostResultsStep)
        eval [list GiD_Process escape escape escape escape results graphs \
                  bordergraph $ViewMenuPriv(border_graph_axX) \
                  $ViewMenuPriv(BG_PostResultsRes) $ViewMenuPriv(border_comp)] \
            $newsets escape

        #delete new sets
        GiD_Process Mescape Utilities Delete SurfaceSets {*}$newsets yes escape
    } else {
        GidUtils::SetWarnLine [_ "Any volume or surface set does exist to create the graph"]
    }
}


proc PostContLimitsIncr { } {
    global GidPriv

    set GidPriv(PostContLimitsUserMin) [ format "%g" [ expr $GidPriv(PostContLimitsUserMin) - $GidPriv(PostContLimitsUserDiv)]]
    set GidPriv(PostContLimitsUserMax) [ format "%g" [ expr $GidPriv(PostContLimitsUserMax) + $GidPriv(PostContLimitsUserDiv)]]
}

proc PostContLimitsDecr { } {
    global GidPriv

    if { [ expr $GidPriv(PostContLimitsUserMax) - $GidPriv(PostContLimitsUserMin)] > \
             [ expr 2.0 * $GidPriv(PostContLimitsUserDiv)] } {
        set GidPriv(PostContLimitsUserMin) [ format "%g" [ expr $GidPriv(PostContLimitsUserMin) + $GidPriv(PostContLimitsUserDiv)]]
        set GidPriv(PostContLimitsUserMax) [ format "%g" [ expr $GidPriv(PostContLimitsUserMax) - $GidPriv(PostContLimitsUserDiv)]]
    }
}

proc PostContLimitsReset { } {
    global GidPriv

    set GidPriv(PostContLimitsUserMin) [ format "%g" [ lindex $GidPriv(PostContLimitsOrgLimits) 0]]
    set GidPriv(PostContLimitsUserMax) [ format "%g" [ lindex $GidPriv(PostContLimitsOrgLimits) 1]]
}

proc PostContLimitsInitVariables {} {
    global GidPriv

    if { ![ info exists GidPriv(PostContLimitsApplying)]} {
        set GidPriv(PostContLimitsApplying) 0
    }

    if { !$GidPriv(PostContLimitsApplying)} {
        set GidPriv(PostContLimitsOrgLimits) [ GiD_Info postprocess get cur_contour_limits]
        set GidPriv(PostContLimitsUserMin) [ format "%g" [ lindex $GidPriv(PostContLimitsOrgLimits) 0]]
        set GidPriv(PostContLimitsUserMax) [ format "%g" [ lindex $GidPriv(PostContLimitsOrgLimits) 1]]
        set GidPriv(PostContLimitsUserDiv) [ expr ( $GidPriv(PostContLimitsUserMax) - \
                                                        $GidPriv(PostContLimitsUserMin)) * 0.05]

        set pp [ lindex [ GiD_Info postprocess get contour_limits] 0]
        set GidPriv(PostContLimitsUseMax) 0
        set GidPriv(PostContLimitsUseMin) 0
        if { "[ lindex $pp 0]" == "USER" } {
            set GidPriv(PostContLimitsUseMin) 1
            if { [ info exists GidPriv(PostContLimitsWindow)] && \
                     [ winfo exists $GidPriv(PostContLimitsWindow).f.emin] } {
                $GidPriv(PostContLimitsWindow).f.emin configure -state normal -foreground black
            }
        }
        if { "[ lindex $pp 2]" == "USER" } {
            set GidPriv(PostContLimitsUseMax) 1
            if { [ info exists GidPriv(PostContLimitsWindow)] && \
                     [ winfo exists $GidPriv(PostContLimitsWindow).f.emax] } {
                $GidPriv(PostContLimitsWindow).f.emax configure -state normal -foreground black
            }
        }
    }
}

proc PostContLimitsApply {} {
    global GidPriv

    set cur_res [ GiD_Info postprocess get cur_result]
    set cur_res_view  [ GiD_Info postprocess get cur_results_view]
    set cur_comp [ GiD_Info postprocess get cur_component]
    regsub -all {_} $cur_res_view {} tipo_contour

    if { ( $cur_res_view == "Contour_Fill") || ( $cur_res_view == "Smooth_Contour_Fill") || \
             ( $cur_res_view == "Contour_Lines") || ( $cur_res_view == "Smooth_Contour_Lines") || \
             ( $cur_res_view == "Display_Vectors") } {
        set GidPriv(PostContLimitsApplying) 1
        GiD_Process Mescape results contoptions
        if { $GidPriv(PostContLimitsUseMin) } {
            GiD_Process setminoptions setvalue $GidPriv(PostContLimitsUserMin)
        } else {
            GiD_Process setminoptions resetvalue escape
        }

        if { $GidPriv(PostContLimitsUseMax) } {
            GiD_Process setmaxoptions setvalue $GidPriv(PostContLimitsUserMax)
        } else {
            GiD_Process setmaxoptions resetvalue escape
        }
        GiD_Process escape $tipo_contour $cur_res $cur_comp
        #GiD_Process Mescape results \
            #         contoptions setminoptions resetvalue escape \
            #         setmaxoptions resetvalue escape
        set GidPriv(PostContLimitsApplying) 0

        #GiD_Process Mescape Utilities Redisplay
    }
}

proc PostContLimitsCloseWin { w } {

    set GidPriv(PostContLimitsHistoryMin) [ [ $w.f.emin cget list] get 0 end]
    set GidPriv(PostContLimitsHistoryMax) [ [ $w.f.emax cget list] get 0 end]
    destroy $w
}

proc PostContLimitsWin { { w .gid.wPostContLim} { solo 1}} {
    global GidPriv

    if { $solo} {
        InitWindow $w [_ "Contour Limits"] PostContLimitsWindowGeom PostContLimitsWin
        if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0
    }

    if { $solo} {
        set GidPriv(PostContLimitsWindow) $w
    }

    #if { [ winfo exists .postContLim] } {
    #         raise .postContLim
    #         return
    #}
    #set donde [ wm geometry $w]
    #set nodecor 1
    #if { ![ regexp {([0-9]*)x([0-9]*)[\+,-]([0-9]*)[\+,-]([0-9]*)} $donde dummy w h x y] } {
    #         set nodecor 0
    #}

    #toplevel $w
    #wm geometry $w +[expr $x + 50]+[expr $y + 50]

    ttk::frame $w.f -style ridge.TFrame -borderwidth 2    
    if { ![info exists GidPriv(PostContLimitsUseMax)] } { set GidPriv(PostContLimitsUseMax) 0 }
    ttk::checkbutton $w.f.lmax -text [_ "Max"]: -variable GidPriv(PostContLimitsUseMax) -command {
        if { $GidPriv(PostContLimitsUseMax)} {
            $GidPriv(PostContLimitsWindow).f.emax configure -state normal -foreground black
        } else {
            $GidPriv(PostContLimitsWindow).f.emax configure -state disabled -foreground grey60
        }
    }    
    if { ![info exists GidPriv(PostContLimitsHistoryMax)] } {
        set GidPriv(PostContLimitsHistoryMax) ""
    }
    combobox $w.f.emax -width 11 -borderwidth 1 -textvariable GidPriv(PostContLimitsUserMax) \
        -editable 1 -keephistory 1 -history $GidPriv(PostContLimitsHistoryMax)  
    if { ![info exists GidPriv(PostContLimitsUseMin)] } { set GidPriv(PostContLimitsUseMin) 0 }
    ttk::checkbutton $w.f.lmin -text [_ "Min"]: -variable GidPriv(PostContLimitsUseMin) -command {
        if { $GidPriv(PostContLimitsUseMin)} {
            $GidPriv(PostContLimitsWindow).f.emin configure -state normal -foreground black
        } else {
            $GidPriv(PostContLimitsWindow).f.emin configure -state disabled -foreground grey60
        }
    }   
    if { ![info exists GidPriv(PostContLimitsHistoryMin)] } {
        set GidPriv(PostContLimitsHistoryMin) ""
    }
    combobox $w.f.emin -width 11 -borderwidth 1 -textvariable GidPriv(PostContLimitsUserMin) \
        -editable 1 -keephistory 1 -history $GidPriv(PostContLimitsHistoryMin)

    ttk::frame $w.f.fi
    ttk::button $w.f.fi.bmas -text + -command PostContLimitsIncr     
    ttk::button $w.f.fi.breset -text o -command PostContLimitsReset       
    ttk::button $w.f.fi.bmenos -text - -command PostContLimitsDecr       
    grid $w.f.fi.bmas -row 0 -column 0 -padx 3 -sticky news
    grid $w.f.fi.breset -row 1 -column 0 -padx 3 -sticky news
    grid $w.f.fi.bmenos -row 2 -column 0 -padx 3 -sticky news

    if { $solo} {
        ttk::frame $w.but -style BottomFrame.TFrame
        ttk::button $w.but.accept -text [_ "Apply"] -style BottomFrame.TButton -command PostContLimitsApply
        ttk::button $w.but.close -text [_ "Close"] -style BottomFrame.TButton -command "PostContLimitsCloseWin $w"       
    }

    grid $w.f.lmax $w.f.emax
    grid $w.f.lmin $w.f.emin
    grid $w.f.fi -row 0 -column 2 -rowspan 2
    grid $w.f
    
    
    if { $solo} {
        grid $w.but.accept $w.but.close -padx 4 -pady 2
        grid $w.but -sticky nsew -column 0 -row 2
        if { $::tcl_version >= 8.5 } { grid anchor $w.but center }
        
        grid columnconfigure $w 0 -weight 1
        grid rowconfigure $w 1 -weight 1
    }

    set GidPriv(PostContLimitsApplying) 0
    PostContLimitsInitVariables
    $w.f.emax configure -state disabled -foreground grey60
    $w.f.emin configure -state disabled -foreground grey60

    if { $solo} {
        bind $w <Return> PostContLimitsApply
    }

}

proc PostContLimitsApplyMinEntry { w } {
    global GidPriv
    set err 0

    if { $GidPriv(PostContLimitsUserMin) != "" } {
        set err [ catch { format "%g" $GidPriv(PostContLimitsUserMin) } ]
        if { !$err} {
            set cur_res [ GiD_Info postprocess get cur_result]
            set cur_res_view  [ GiD_Info postprocess get cur_results_view]
            set cur_comp [ GiD_Info postprocess get cur_component]
            regsub -all {_} $cur_res_view {} tipo_contour
            
            if { ( $cur_res_view == "Contour_Fill") || ( $cur_res_view == "Smooth_Contour_Fill") || \
                     ( $cur_res_view == "Contour_Lines") || ( $cur_res_view == "Smooth_Contour_Lines") || \
                     ( $cur_res_view == "Display_Vectors") } {
                #set GidPriv(PostContLimitsApplying) 1
                GiD_Process Mescape results contoptions setminoptions setvalue $GidPriv(PostContLimitsUserMin)
                #        escape $tipo_contour $cur_res $cur_comp
                #GiD_Process Mescape results \
                    #         contoptions setminoptions resetvalue escape
                GiD_Process Mescape Utilities Redisplay escape escape
                #PostContLimitsInitVariables
                #set GidPriv(PostContLimitsApplying) 0
            }
        } else {
            WarnWin [_ "A Numerical value must be entered."]
        }
    }

    #WarnWin "$GidPriv(PostContLimitsUserMin) - $err"
    if { !$err} {
        set GidPriv(PostContLimitsHistoryMin) [ [ $w.f.emin cget list] get 0 end]
        destroy $w
        #focus .gid
    }
}

proc PostContLimitsMinEntry { w} {
    global GidPriv tcl_platform

    #set donde [ wm geometry $w]
    #set donde [ winfo geometry $w]
    #set nodecor 1
    #if { ![ regexp {([0-9]*)x([0-9]*)[\+,-]([0-9]*)[\+,-]([0-9]*)} $donde dummy w h x y] } {
    #          set nodecor 0
    #}
    set x [ winfo x $w]
    set y [ winfo y $w]
    set wi [ winfo width $w]
    set w [ winfo parent $w]
    while { $w != "" } {
        set xp [ winfo x $w]
        set yp [ winfo y $w]
        set x [ expr $x + $xp]
        set y [ expr $y + $yp + 16]
        if { "[ winfo class $w]" == "Toplevel"} {
            break
        }
        set w [ winfo parent $w]
    }
    set x [expr $x + $wi+8]
    set y [expr $y + 16]
    #WarnWin "$w = +$x+$y"

    toplevel .wPostLimMin
    wm geometry .wPostLimMin +$x+$y
    wm title .wPostLimMin [_ "Minimum"]
    wm minsize .wPostLimMin 1 1
    wm overrideredirect .wPostLimMin 1

    ttk::frame .wPostLimMin.f -style ridge.TFrame -borderwidth 2
    if { ![info exists GidPriv(PostContLimitsHistoryMin)] } {
        set GidPriv(PostContLimitsHistoryMin) ""
    }
    combobox .wPostLimMin.f.emin -width 11 -borderwidth 1 -textvariable GidPriv(PostContLimitsUserMin) \
        -editable 1 -keephistory 1 -history $GidPriv(PostContLimitsHistoryMin)

    set limites_org [ GiD_Info postprocess get cur_contour_limits]
    set GidPriv(PostContLimitsUserMin) [ format "%g" [ lindex $limites_org 0]]
    .wPostLimMin.f.emin sel to end

    bind .wPostLimMin <Return> "PostContLimitsApplyMinEntry .wPostLimMin"
    bind .wPostLimMin <Escape> "destroy .wPostLimMin"
    bind .wPostLimMin <1> "+PostCloseFLoatingWindow %W %x %y"

    
    ttk::button .wPostLimMin.f.b  -image [gid_themes::GetImage document-close-2.png] -command "destroy .wPostLimMin"   

    #grid .wPostLimMin.f.emin .wPostLimMin.f.b
    grid .wPostLimMin.f.emin -padx 2 -pady 1
    grid .wPostLimMin.f.b -column 1 -row 0 -padx 1 -pady 1

    grid .wPostLimMin.f
    focus -force .wPostLimMin.f.emin
    #raise .wPostLimMin .gid
    update
    grab .wPostLimMin

}

proc PostContLimitsApplyMaxEntry { w }  {
    global GidPriv
    set err 0

    if { $GidPriv(PostContLimitsUserMax) != "" } {
        set err [ catch { format "%g" $GidPriv(PostContLimitsUserMax) } ]
        if { !$err} {
            set cur_res [ GiD_Info postprocess get cur_result]
            set cur_res_view  [ GiD_Info postprocess get cur_results_view]
            set cur_comp [ GiD_Info postprocess get cur_component]
            regsub -all {_} $cur_res_view {} tipo_contour
            
            if { ( $cur_res_view == "Contour_Fill") || ( $cur_res_view == "Smooth_Contour_Fill") || \
                     ( $cur_res_view == "Contour_Lines") || ( $cur_res_view == "Smooth_Contour_Lines") || \
                     ( $cur_res_view == "Display_Vectors") } {
                #set GidPriv(PostContLimitsApplying) 1
                #WarnWin "Set value"
                GiD_Process Mescape results contoptions setmaxoptions setvalue $GidPriv(PostContLimitsUserMax)
                #        escape $tipo_contour $cur_res $cur_comp
                #GiD_Process Mescape results contoptions setmaxoptions resetvalue escape
                #WarnWin "Redisplay"
                GiD_Process Mescape Utilities Redisplay escape escape
                #WarnWin "init vars"
                # PostAnimateInitVariables
                # PostContLimitsInitVariables
                # FillPostLegendInfo
                #set GidPriv(PostContLimitsApplying) 0
            }
        } else {
            WarnWin [_ "A Numerical value must be entered."]
        }
    }

    #WarnWin "$GidPriv(PostContLimitsUserMax) - $err"
    if { !$err} {
        set GidPriv(PostContLimitsHistoryMax) [ [ $w.f.emax cget list] get 0 end]
        destroy $w
    }
    #focus .gid
}


proc PostContLimitsMaxEntry { w } {
    global GidPriv tcl_platform

    #set donde [ wm geometry $w]
    #set donde [ winfo geometry $w]
    #set nodecor 1
    #if { ![ regexp {([0-9]*)x([0-9]*)[\+,-]([0-9]*)[\+,-]([0-9]*)} $donde dummy w h x y] } {
    #          set nodecor 0
    #}
    set x [ winfo x $w]
    set y [ winfo y $w]
    set wi [ winfo width $w]
    set w [ winfo parent $w]
    while { $w != "" } {
        set xp [ winfo x $w]
        set yp [ winfo y $w]
        set x [ expr $x + $xp]
        set y [ expr $y + $yp + 16]
        if { "[ winfo class $w]" == "Toplevel"} {
            break
        }
        set w [ winfo parent $w]
    }
    set x [expr $x + $wi]
    set y [expr $y + 16]
    #WarnWin "$w = +$x+$y"

    toplevel .wPostLimMax
    wm geometry .wPostLimMax +$x+$y
    wm title .wPostLimMax [_ "Maximum"]
    wm minsize .wPostLimMax 1 1
    wm overrideredirect .wPostLimMax 1

    ttk::frame .wPostLimMax.f -style ridge.TFrame -borderwidth 2
    if { ![info exists GidPriv(PostContLimitsHistoryMax)] } {
        set GidPriv(PostContLimitsHistoryMax) ""
    }
    combobox .wPostLimMax.f.emax -width 11 -borderwidth 1 -textvariable GidPriv(PostContLimitsUserMax) \
        -editable 1 -keephistory 1 -history $GidPriv(PostContLimitsHistoryMax)

    set limites_org [ GiD_Info postprocess get cur_contour_limits]
    set GidPriv(PostContLimitsUserMax) [ format "%g" [ lindex $limites_org 1]]
    .wPostLimMax.f.emax sel to end

    bind .wPostLimMax <Return> "PostContLimitsApplyMaxEntry .wPostLimMax"
    bind .wPostLimMax <Escape> "destroy .wPostLimMax"
    bind .wPostLimMax <1> "+PostCloseFLoatingWindow %W %x %y"

    ttk::button .wPostLimMax.f.b -image [gid_themes::GetImage document-close-2.png] -command "destroy .wPostLimMax"   

    grid .wPostLimMax.f.emax -padx 2 -pady 1
    grid .wPostLimMax.f.b -column 1 -row 0 -padx 1 -pady 1
    grid .wPostLimMax.f
    focus -force .wPostLimMax.f.emax
    #raise .wPostLimMax .gid
    update
    grab .wPostLimMax

}

proc PostCloseFLoatingWindow { w x y } {
    if { $x < 0 || $y < 0 || $x > [winfo width $w] || $y > [winfo height $w] } {
        destroy $w
    }
}

proc IconoBotonLogSwitch { } {
    array set opciones [ GiD_Info postprocess get scale_result_options]

    set img [ gid_themes::GetImage ContLog.png toolbar]
    if { $opciones(UseLogScale)} {
        set img [ gid_themes::GetImage ContNoLog.png toolbar]
    }
    return $img
}

proc PostContLogSwitch { w { idx 0}} {
    array set opciones [ GiD_Info postprocess get scale_result_options]

    set nuevo_valor Yes
    if { $opciones(UseLogScale)} {
        set nuevo_valor No
    }
    GiD_Process escape escape escape escape Results Options ScaleResult UseLogScale $nuevo_valor escape

    if { "[ winfo class $w]" == "Menu"} {
        $w entryconfigure $idx -image [ IconoBotonLogSwitch]
    } else {
        $w configure -image [ IconoBotonLogSwitch]
    }
}

#proc IconoBotonFactorEntry { escala} {
#    array set opciones [ GiD_Info postprocess get scale_result_options]
#
#    set img [ gid_themes::GetImage ContLog.png toolbar]
#    if { $opciones($escala) != 1.0} {
#        set img [ gid_themes::GetImage ContNoLog.png toolbar]
#    }
#    return $img
#}


proc PostContFactorEntryApply { w escala} {
    global GidPriv
    set err 0

    if { $::GidPriv(PostCont$escala) != "" } {
        set err [ catch { format "%g" $::GidPriv(PostCont$escala) } ]
        if { !$err} {
            set cur_res [ GiD_Info postprocess get cur_result]
            set cur_res_view [ GiD_Info postprocess get cur_results_view]
            set cur_comp [ GiD_Info postprocess get cur_component]
            regsub -all {_} $cur_res_view {} tipo_contour
            
            if { ( $cur_res_view == "Contour_Fill") || ( $cur_res_view == "Smooth_Contour_Fill") || \
                     ( $cur_res_view == "Contour_Lines") || ( $cur_res_view == "Smooth_Contour_Lines") } {
                GiD_Process escape escape escape escape Results Options ScaleResult $escala \
                    $::GidPriv(PostCont$escala) escape
                # GiD_Process Mescape Utilities Redisplay escape escape
            }
        } else {
            WarnWin [_ "A Numerical value must be entered."]
        }
    }

    if { !$err} {
        set GidPriv(PostContHistory$escala) [ [ $w.f.emin cget list] get 0 end]
        destroy $w
    }
}

proc PostContFactorEntry { w escala} {
    global GidPriv tcl_platform

    #w its a menu dosn't work well
    #parent of w its a menubutton, working better
    set w [ winfo parent $w]
    set x [ winfo x $w]
    set y [ winfo y $w]
    set wi [ winfo width $w]
    set w [ winfo parent $w]
    while { $w != "" } {
        set xp [ winfo x $w]
        set yp [ winfo y $w]
        set x [ expr $x + $xp]
        set y [ expr $y + $yp + 16]
        if { "[ winfo class $w]" == "Toplevel"} {
            break
        }
        set w [ winfo parent $w]
    }
    set x [expr $x + $wi]
    set y [expr $y + 16]
    
    toplevel .wPostContFactor
    wm geometry .wPostContFactor +$x+$y
    wm title .wPostContFactor [_ "Scale result"]
    wm minsize .wPostContFactor 1 1
    wm overrideredirect .wPostContFactor 1

    ttk::frame .wPostContFactor.f -style ridge.TFrame -borderwidth 2
    if { ![info exists ::GidPriv(PostContHistory$escala)] } {
        set ::GidPriv(PostContHistory$escala) ""
    }
    combobox .wPostContFactor.f.emin -width 11 -borderwidth 1 -textvariable ::GidPriv(PostCont$escala) \
        -editable 1 -keephistory 1 -history $::GidPriv(PostContHistory$escala)

    array set opcionesScale [ GiD_Info postprocess get scale_result_options]
    set ::GidPriv(PostContScaleFactor) [ format "%g" $opcionesScale($escala) ]
    .wPostContFactor.f.emin sel to end

    bind .wPostContFactor <Return> "PostContFactorEntryApply .wPostContFactor $escala"
    bind .wPostContFactor <Escape> "destroy .wPostContFactor"
    bind .wPostContFactor <1> "+PostCloseFLoatingWindow %W %x %y"
   
    ttk::button .wPostContFactor.f.b  -image [gid_themes::GetImage document-close-2.png] -command "destroy .wPostContFactor"   

    #grid .wPostContFactor.f.emin .wPostContFactor.f.b
    grid .wPostContFactor.f.emin -padx 2 -pady 1
    grid .wPostContFactor.f.b -column 1 -row 0 -padx 1 -pady 1

    grid .wPostContFactor.f
    focus -force .wPostContFactor.f.emin
    #raise .wPostContFactor .gid
    update
    grab .wPostContFactor

}

proc PostOutMinMaxColourMenu { w que } {
    global GidPriv

    set actual_fuera [ GiD_Info postprocess get results_options]
    set que [ string toupper [ string index $que 0]][ string tolower [ string range $que 1 end]]
    if { $que == "Min"} {
        set curr [ lindex $actual_fuera 4]
        set names "Black White MinColor Transparent Material"
        set namesLabel [ list [_ "Black"] [_ "White"] [_ "Min Color"] [_ "Transparent"] [_ "Material"]]
    } else {
        set curr [ lindex $actual_fuera 5]
        set names "Black White MaxColor Transparent Material"
        set namesLabel [ list [_ "Black"] [_ "White"] [_ "Max Color"] [_ "Transparent"] [_ "Material"]]
    }


    $w delete 0 end
    set UnderLineList {}
    foreach i $names j $namesLabel {
        set img $GidPriv(VerifNoImage)
        if { $i == $curr } {
            set img $GidPriv(VerifImage)
        }
        set under [FindUnderChar j UnderLineList]
        $w add command -label $j -underline $under -image $img -compound left \
            -command "GiD_Process Mescape Results ContOptions Set${que}Options Out${que}Color $i \
                escape escape escape escape Utilities Redisplay escape"
    }
}

proc PostSmoothContourTypeMenu { w } {
    global GidPriv

    set opciones [ GiD_Info postprocess get results_options]
    set curr [ lindex $opciones 8]

    set names "MinimumSmooth MaximumSmooth MeanSmooth"
    set namesLabel [ list [_ "Minimum value"] [_ "Maximum value"] [_ "Mean value"]]

    $w delete 0 end
    set UnderLineList {}
    foreach i $names j $namesLabel {
        set img $GidPriv(VerifNoImage)
        if { $i == $curr } {
            set img $GidPriv(VerifImage)
        }
        set under [FindUnderChar j UnderLineList]
        $w add command -label $j -underline $under -image $img -compound left \
            -command "GiD_Process Mescape Results ContOptions SmoothingType $i escape"
    }
}

proc PostDiagramOptionsMenu { w } {
    global GidPriv

    set opciones [ GiD_Info postprocess get diagram_options]
    set curr [ lindex $opciones 0]

    set names "None NodesOnly WholeLine FilledLine ContFillLine"
    set namesLabel [ list [_ "None"] [_ "Nodes only"] [_ "Whole line"] \
                         [_ "Filled line"] [_ "Contour filled"] ]

    $w delete 0 end
    set UnderLineList {}
    foreach i $names j $namesLabel {
        set under [FindUnderChar j UnderLineList]
        set img $GidPriv(VerifNoImage)
        if { $i == $curr } {
            set img $GidPriv(VerifImage)
        }
        $w add command -label $j -underline $under -image $img -compound left \
            -command [list GiD_Process Mescape Results LineDiagram Options ShowElevations $i escape]
    }
}

proc PostResultSurfaceOptionsMenu { w } {
    global GidPriv

    set opciones [ GiD_Info postprocess get result_surface_options]
    # nos devuelve: {ExtrudedEdges [ContourFill]} {None ExtrudedNodes ExtrudedEdges ExtrudedBoth SwitchContFill}
    set actual [ lindex $opciones 0]
    set curr [ lindex $actual 0]
    set hay_cfill 0
    if { [ llength $actual] != 1} {
        set hay_cfill 1
    }

    set names "None ExtrudedNodes ExtrudedEdges ExtrudedBoth SwitchContFill"
    set namesLabel [ list [_ "None"] [_ "Extruded nodes"] [_ "Extruded edges"] [_ "Extruded nodes & edges"] [_ "Contour Fill"]]

    $w delete 0 end
    set UnderLineList {}
    foreach i $names j $namesLabel {
        set under [FindUnderChar j UnderLineList]
        set img $GidPriv(VerifNoImage)
        if { $i == $curr } {
            set img $GidPriv(VerifImage)
        }
        if { $hay_cfill && ( $i == "SwitchContFill") } {
            set img $GidPriv(VerifImage)
        }
        $w add command -label $j -underline $under -image $img -compound left \
            -command [list GiD_Process Mescape Results Options ResSurfShowElev $i escape]
    }
}

proc PostStreamLinesColorOptionsMenu { w } {
    global GidPriv

    set opciones [ GiD_Info postprocess get result_stream_lines_options]
    # nos devuelve: {4SidedPrism} {Points Ribbons 4SidedPrism 8SidedPrism} {Monochrome} {Monochrome StreamContourFilled ResultContourFilled}

    # primero tipo:
    set curr [ lindex $opciones 0]

    $w delete 0 end

    if { 0} {
        #set names "Points Ribbons 4SidedPrism 8SidedPrism"
        #set namesLabel [ list [_ "Points"] [_ "Ribbons"] [_ "4SidedPrism"] [_ "8SidedPrism"]]
        set names "Points 4SidedPrism"
        set namesLabel [ list [_ "Points"] [_ "4SidedPrism"]]
        set UnderLineList {}
        foreach i $names j $namesLabel {
            set under [FindUnderChar j UnderLineList]
            set img $GidPriv(VerifNoImage)
            if { $i == $curr } {
                set img $GidPriv(VerifImage)
            }
            $w add command -label $j -underline $under -image $img -compound left \
                -command [list GiD_Process Mescape Results Options StreamColor $i escape]
        }
        $w add separator
    }

    set curr [ lindex $opciones 2]

    set names "Monochrome StreamContourFilled ResultContourFilled"
    set namesLabel [ list [_ "Monochrome"] [_ "Stream contour filled"] [_ "Result contour filled"]]
    set UnderLineList {}
    foreach i $names j $namesLabel {
        set under [FindUnderChar j UnderLineList]
        set img $GidPriv(VerifNoImage)
        if { $i == $curr } {
            set img $GidPriv(VerifImage)
        }
        $w add command -label $j -underline $under -image $img -compound left \
            -command [list GiD_Process Mescape Results Options StreamColor $i escape]
    }
}


proc PostVectorsDetailMenu { w } {
    global GidPriv

    set opciones [ GiD_Info postprocess get vector_detail]
    set curr [ lindex $opciones 0]

    set names "NoArrow Points Lines 2Triangles 4Triangles 8Triangles"
    set namesLabel [ list [_ "No arrow head"] [_ "Point"] [_ "Lines"] \
                         [_ "2 Triangles"] [_ "4 Triangles"] [_ "8 Triangles"] ]

    $w delete 0 end
    set UnderLineList {}
    foreach i $names j $namesLabel {
        set under [FindUnderChar j UnderLineList]
        set img $GidPriv(VerifNoImage)
        if { $i == $curr } {
            set img $GidPriv(VerifImage)
        }
        $w add command -label $j -underline $under -image $img -compound left \
            -command [list GiD_Process Mescape Results Options VectorDetail $i escape]
    }
}

proc PostVectorsSizeMenu { w } {
    global GidPriv

    # ramsan: problems mixing versions
    set opciones [list "" ""]
    catch { set opciones [ GiD_Info postprocess get vector_size] }
    set curr [ lindex $opciones 0]

    set names [lindex $opciones 1]
    set namesLabel [ list [_ "Fixed size"] [_ "Modulus dependent"]]

    $w delete 0 end
    set UnderLineList {}
    foreach i $names j $namesLabel {
        set under [FindUnderChar j UnderLineList]
        set img $GidPriv(VerifNoImage)
        if { $i == $curr } {
            set img $GidPriv(VerifImage)
        }
        $w add command -label $j -underline $under -image $img -compound left \
            -command [list GiD_Process Mescape Results Options VectorSize $i escape]
    }
}

proc IconoIsoAlwaysDrawn {} {
    global GidPriv
    set opciones [ GiD_Info postprocess get isosurface_options]
    set lista [ lindex $opciones 8]
    set nombre [ lindex $lista 0]
    set valor [ lindex $lista 1]

    set img $GidPriv(VerifNoImage)
    if { $valor} {
        set img $GidPriv(VerifImage)
    }
    return $img
}

proc PostIsoSurfaceAlwaysDrawn { w idx} {
    set opciones [ GiD_Info postprocess get isosurface_options]
    set lista [ lindex $opciones 8]
    set nombre [ lindex $lista 0]
    set valor [ lindex $lista 1]

    set nuevo_valor Yes
    if { $valor} {
        set nuevo_valor No
    }
    GiD_Process escape escape escape escape Results isosurfaces AlwaysDrawn $nuevo_valor escape

    $w entryconfigure $idx -image [ IconoIsoAlwaysDrawn] -compound left
}

proc IconoIsoDrawIsolineas {} {
    global GidPriv
    set opciones [ GiD_Info postprocess get isosurface_options]
    set lista [ lindex $opciones 9]
    set nombre [ lindex $lista 0]
    set valor [ lindex $lista 1]

    set img $GidPriv(VerifNoImage)
    if { $valor} {
        set img $GidPriv(VerifImage)
    }
    return $img
}

proc PostIsoSurfaceDrawIsolines { w idx} {
    set opciones [ GiD_Info postprocess get isosurface_options]
    set lista [ lindex $opciones 9]
    set nombre [ lindex $lista 0]
    set valor [ lindex $lista 1]

    set nuevo_valor Yes
    if { $valor} {
        set nuevo_valor No
    }
    GiD_Process escape escape escape escape Results isosurfaces $nombre $nuevo_valor escape

    $w entryconfigure $idx -image [ IconoIsoDrawIsolineas] -compound left
}

proc PostIsoSurfaceOptionsMenu { w que} {
    global GidPriv

    set opciones [ GiD_Info postprocess get isosurface_options]
    set curr ""
    set names ""
    set namesLabel ""
    switch "[ string tolower $que]" {
        "displaystyle" {
            set curr [ lindex $opciones 0]
            set names [ lindex $opciones 1]
            set namesLabel [ list [_ "All Lines"] [_ "Hidden Lines"] [_ "Body"] [_ "Body Lines"] ]
        }
        "render" {
            set curr [ lindex $opciones 2]
            set names [ lindex $opciones 3]
            set namesLabel [ list [_ "Normal"] [_ "Flat"] ]
        }
        "transparency" {
            set curr [ lindex $opciones 4]
            set names [ lindex $opciones 5]
            set namesLabel [ list [_ "Opaque"] [_ "Transparent"] ]
        }
        "color" {
            set curr [ lindex $opciones 6]
            set names [ lindex $opciones 7]
            set namesLabel [ list [_ "Monochrome"] [_ "Result color"] [_ "Contour fill color"]]
        }
    }

    $w delete 0 end
    set UnderLineList {}
    foreach i $names j $namesLabel {
        set under [FindUnderChar j UnderLineList]
        set img $GidPriv(VerifNoImage)
        if { $i == $curr } {
            set img $GidPriv(VerifImage)
        }
        $w add command -label $j -underline $under -image $img -compound left \
            -command [list GiD_Process Mescape Results isosurfaces DisplayStyle $i escape]
    }
}

proc PostIsosurfaceMenuPrincipal { w } {
    set MenuEntriesP(5,8) [list [_ "Display Style#C#menu"] [_ "Transparency#C#menu"] \
                               [_ "Color Mode#C#menu"] [_ "Change color#C#menu"] \
                               [_ "Convert to cuts#C#menu"] [_ "Draw always#C#menu"] \
                               [_ "Show isolines#C#menu"]]
    set MenuCommandsP(5,8) [ list  \
                                 [ list PostIsoSurfaceOptionsMenu %W DisplayStyle] \
                                 [ list PostIsoSurfaceOptionsMenu %W Transparency] \
                                 [ list PostIsoSurfaceOptionsMenu %W Color] \
                                 [ list GiD_Process escape escape escape escape Results isosurfaces DisplayStyle ChangeMonoColour] \
                                 [ list GiD_Process escape escape escape escape Results isosurfaces TurnIntoCuts] \
                                 [ list PostIsoSurfaceAlwaysDrawn %W 5] \
                                 [ list PostIsoSurfaceDrawIsolines %W 6]]

    set MenuEntriesP(5,8,0) ""
    set MenuCommandsP(5,8,0) ""

    set MenuEntriesP(5,8,1) ""
    set MenuCommandsP(5,8,1) ""

    set MenuEntriesP(5,8,2) ""
    set MenuCommandsP(5,8,2) ""

    set lst_img [ list $::GidPriv(VerifNoImage) $::GidPriv(VerifNoImage) \
                      $::GidPriv(VerifNoImage) $::GidPriv(VerifNoImage) \
                      $::GidPriv(VerifNoImage) \
                      [ IconoIsoAlwaysDrawn] [ IconoIsoDrawIsolineas]]

    $w delete 0 end
    set UnderLineList {}
    set idx 0
    foreach entrada $MenuEntriesP(5,8) comando $MenuCommandsP(5,8) img $lst_img {
        set under [FindUnderChar entrada UnderLineList]
        if { [ info exists MenuEntriesP(5,8,$idx)]} {
            set m $w.mm$idx
            if { ![ winfo exists $w.mm$idx]} {
                menu $m
            }
            $w add cascade -label $entrada -underline $under -image $img -compound left \
                -menu $m
            regsub -all {%W} $comando $m cmd
            regsub -all {%I} $cmd $idx cmd
            regsub -all {%X} $cmd [ winfo pointerx .gid] cmd
            regsub -all {%Y} $cmd [ winfo pointery .gid] cmd
            $m configure -postcommand $cmd
        } else {
            regsub -all {%W} $comando $w cmd
            regsub -all {%I} $cmd $idx cmd
            regsub -all {%X} $cmd [ winfo pointerx .gid] cmd
            regsub -all {%Y} $cmd [ winfo pointery .gid] cmd
            $w add command -label $entrada -underline $under -image $img -compound left \
                -command $cmd
        }
        incr idx
    }
}

proc IconoScaleResultLogarithmic { } {
    array set opciones [ GiD_Info postprocess get scale_result_options]

    set img $::GidPriv(VerifNoImage)
    if { $opciones(UseLogScale)} {
        set img $::GidPriv(VerifImage)
    }
    return $img
}

proc PostScaleResultLogarithmic { w idx} {
    array set opciones [ GiD_Info postprocess get scale_result_options]

    set nuevo_valor Yes
    if { $opciones(UseLogScale)} {
        set nuevo_valor No
    }
    GiD_Process escape escape escape escape Results Options ScaleResult UseLogScale $nuevo_valor escape

    $w entryconfigure $idx -image [ IconoScaleResultLogarithmic] -compound left
}

proc PostScaleResultMenu { w } {
    set MenuEntriesP(5,6,12) [ list [_ "Multiplier factor"] [_ "Adder factor"] [_ "Use logarithmic scale"]]
    set MenuCommandsP(5,6,12) [ list \
                                    [ list GiD_Process escape escape escape escape Results Options ScaleResult ScaleMultiplier] \
                                    [ list GiD_Process escape escape escape escape Results Options ScaleResult ScaleAdder] \
                                    [ list PostScaleResultLogarithmic %W 1]\
                                   ]

    set lst_img [ list $::GidPriv(VerifNoImage) [ IconoScaleResultLogarithmic]]

    $w delete 0 end
    set idx 0
    set UnderLineList {}
    foreach entrada $MenuEntriesP(5,6,12) comando $MenuCommandsP(5,6,12) img $lst_img {
        set under [FindUnderChar entrada UnderLineList]
        if { [ info exists MenuEntriesP(5,6,12,$idx)]} {
            set m $w.mm$idx
            if { ![ winfo exists $w.mm$idx]} {
                menu $m
            }
            $w add cascade -label $entrada -underline $under -image $img -compound left \
                -menu $m
            regsub -all {%W} $comando $m cmd
            regsub -all {%I} $cmd $idx cmd
            regsub -all {%X} $cmd [ winfo pointerx .gid] cmd
            regsub -all {%Y} $cmd [ winfo pointery .gid] cmd
            $m configure -postcommand $cmd
        } else {
            regsub -all {%W} $comando $w cmd
            regsub -all {%I} $cmd $idx cmd
            regsub -all {%X} $cmd [ winfo pointerx .gid] cmd
            regsub -all {%Y} $cmd [ winfo pointery .gid] cmd
            $w add command -label $entrada -underline $under -image $img -compound left \
                -command $cmd
        }
        incr idx
    }
}

proc PostStreamLinesMenuPrincipal { w } {
    set MenuEntriesP(5,9) [ list [_ "Change color#C#menu"] [_ "Color Mode#C#menu"] [_ "Delete#C#menu"] [_ "Delete all\#C\#menu"] \
                                [_ "Label#C#menu"] [_ "Size & detail#C#menu"]... \
                                [_ "Set initial step#C#menu"] \
                                [_ "Set max length#C#menu"] [_ "Set max points#C#menu"] [_ "Set initial rotation#C#menu"] [_ "Show arrows#C#Menu"]]

    set MenuCommandsP(5,9) [ list  \
                                 [ list GiD_Process Mescape Results Options StreamColor ChangeMonoColour] \
                                 [ list PostStreamLinesColorOptionsMenu %W ] \
                                 [ list GiD_Process escape escape escape escape Results Options StreamDelete ] \
                                 [ list GiD_Process escape escape escape escape Results Options StreamDelete All ] \
                                 [ list GiD_Process Mescape Results Options StreamLabel ] \
                                 [ list PostStreamLineOptions ] \
                                 [ list GiD_Process Mescape Results Options StreamIniStep] \
                                 [ list GiD_Process Mescape Results Options StreamLength] \
                                 [ list GiD_Process Mescape Results Options StreamMaxPoints] \
                                 [ list GiD_Process Mescape Results Options StLineIniRotation] \
                                 [ list GiD_Process Mescape Results Options StDrawArrow ShowArrows]]

    set MenuEntriesP(5,9,1) ""
    set MenuCommandsP(5,9,1) ""

    set lst_img [ list $::GidPriv(VerifNoImage) $::GidPriv(VerifNoImage) $::GidPriv(VerifNoImage) $::GidPriv(VerifNoImage) \
                      $::GidPriv(VerifNoImage) $::GidPriv(VerifNoImage) $::GidPriv(VerifNoImage) \
                      $::GidPriv(VerifNoImage) $::GidPriv(VerifNoImage) $::GidPriv(VerifNoImage) [ IconoStreamShowArrows]]

    $w delete 0 end
    set idx 0
    set UnderLineList {}
    foreach entrada $MenuEntriesP(5,9) comando $MenuCommandsP(5,9) img $lst_img {
        set under [FindUnderChar entrada UnderLineList]
        if { [ info exists MenuEntriesP(5,9,$idx)]} {
            set m $w.mm$idx
            if { ![ winfo exists $w.mm$idx]} {
                menu $m
            }
            $w add cascade -label $entrada -underline $under -image $img -compound left \
                -menu $m
            regsub -all {%W} $comando $m cmd
            regsub -all {%I} $cmd $idx cmd
            regsub -all {%X} $cmd [ winfo pointerx .gid] cmd
            regsub -all {%Y} $cmd [ winfo pointery .gid] cmd
            $m configure -postcommand $cmd
        } else {
            regsub -all {%W} $comando $w cmd
            regsub -all {%I} $cmd $idx cmd
            regsub -all {%X} $cmd [ winfo pointerx .gid] cmd
            regsub -all {%Y} $cmd [ winfo pointery .gid] cmd
            $w add command -label $entrada -underline $under -image $img -compound left \
                -command $cmd
        }
        incr idx
    }

}

proc IconoStreamShowArrows {} {
    global GidPriv

    set valor_info [ GiD_Info postprocess get stream_draw_arrows Arrows]
    set valor_info [lindex $valor_info 0]
    set valor [lindex $valor_info 0]
    set img $GidPriv(VerifNoImage)
    if { $valor} {
        set img $GidPriv(VerifImage)
    } else {
        set img $GidPriv(VerifNoImage)
    }
    return $img
}

proc PostContourScaleOptionsMenu { w que } {
    global GidPriv

    set opciones [ GiD_Info postprocess get cur_contour_color_config]
    set curr ""
    set names ""
    set namesLabel ""
    switch "[ string tolower $que]" {
        "scaleramp" {
            set curr [ lindex $opciones 5]
            set names {Tangent Linear ArcTang}
            set namesLabel [ list [_ "Tangent"] [_ "Linear"] [_ "ArcTangent"] ]
        }
        "scaletype" {
            set curr [ lindex $opciones 4]
            set names {RGB HSV}
            set namesLabel [ list [_ "RGB"] [_ "HSV"] ]
        }
    }

    $w delete 0 end
    set UnderLineList {}
    foreach i $names j $namesLabel {
        set img $GidPriv(VerifNoImage)
        if { $i == $curr } {
            set img $GidPriv(VerifImage)
        }
        set under [FindUnderChar j UnderLineList]
        $w add command -label $j -underline $under -image $img -compound left \
            -command [list GiD_Process Mescape Results ContOptions ColorRamp $i \
                          escape escape escape escape Utilities Redisplay escape]
    }
}

proc PostContourWhichScaleMenu { w} {
    global GidPriv

    set opciones [ GiD_Info postprocess get cur_contour_color_config]
    set curr [ lindex $opciones 1]
    # para que no aparezca un mensaje nuevo en la bd a traducir
    set bw [_ "White"]
    append bw " " [_ "Black"]
    set names [ list Rainbow {Inv. rainbow} Terrain {Black & White} { White & Black} \
                    {3d anaglyphs} {3d anaglyphs 2} {User defined}]
    set namesLabel  [list [_ "Standard"] [_ "Inverse Standard"] [_ "Terrain Map"] \
                         [_ "Black White"] $bw  [_ "3D anaglyphs"] [_ "3D anaglyphs 2"] \
                         [_ "User defined"]... ]
    set cmds_lst { \
                       { GiD_Process Mescape Results ContOptions SetMinOptions MinColor Standard \
                             Mescape Results ContOptions SetMaxOptions MaxColor Standard\
                             Mescape Results ContOptions ColorRamp Tangent \
                             Mescape Utilities Redisplay escape } \
                       { GiD_Process \
                             Mescape Results ContOptions SetMinOptions MinColor InverseStd \
                             Mescape Results ContOptions SetMaxOptions MaxColor InverseStd \
                             Mescape Results ContOptions ColorRamp Tangent\
                             Mescape Utilities Redisplay escape } \
                       { GiD_Process \
                             Mescape Results ContOptions ColorRamp TerrainMap \
                             Mescape Utilities Redisplay escape } \
                       { GiD_Process \
                             Mescape Results ContOptions SetMinOptions MinColor Black \
                             Mescape Results ContOptions SetMaxOptions MaxColor White \
                             Mescape Results ContOptions ColorRamp Tangent \
                             Mescape Utilities Redisplay escape } \
                       { GiD_Process \
                             Mescape Results ContOptions SetMinOptions MinColor White \
                             Mescape Results ContOptions SetMaxOptions MaxColor Black \
                             Mescape Results ContOptions ColorRamp Tangent \
                             Mescape Utilities Redisplay escape } \
                       { GiD_Process \
                             Mescape Results ContOptions ColorRamp 3DAnaglyphs \
                             Mescape Utilities Redisplay escape } \
                       { GiD_Process \
                             Mescape Results ContOptions ColorRamp 3DAnaglyphs2 \
                             Mescape Utilities Redisplay escape } \
                       PostContourColors  }

    $w delete 0 end
    set UnderLineList {}
    foreach i $names j $namesLabel  cmd $cmds_lst {
        set img $GidPriv(VerifNoImage)
        if { $i == $curr } {
            set img $GidPriv(VerifImage)
        }
        set under [FindUnderChar j UnderLineList]
        $w add command -label $j -underline $under -image $img -compound left \
            -command $cmd
    }

    set names "ScaleRamp ScaleType"
    set namesLabel [ list  [_ "Scale Ramp"] [_ "Scale Type"]]

    set UnderLineList {}
    foreach submenu $names label $namesLabel {
        set menuname [ join "$w . [ string tolower $submenu]" ""]
        # esto es para mantener el alineamiento
        set img $GidPriv(VerifNoImage)
        set under [FindUnderChar label UnderLineList]
        $w add cascade -label $label -underline $under -image $img -compound left \
            -menu $menuname
        if { ![winfo exists $menuname] } {
            menu $menuname -postcommand "PostContourScaleOptionsMenu $menuname $submenu"
        } else {
            $menuname configure -postcommand "PostContourScaleOptionsMenu $menuname $submenu"
        }
    }
}

proc PostContourBrightColorMenu { w} {
    global GidPriv

    set opciones [ GiD_Info postprocess get cur_contour_color_config]
    set curr [ lindex [ lindex $opciones 8] 0]
    # es del tipo {%s {No Metallic Plastic Rubber}}
    set names "No Metallic Plastic Rubber"
    set namesLabel  [list [_ "No"] [_ "Metallic"] [_ "Plastic"] [_ "Rubber"]]
    $w delete 0 end
    set UnderLineList {}
    foreach i $names j $namesLabel {
        set img $GidPriv(VerifNoImage)
        if { $i == $curr } {
            set img $GidPriv(VerifImage)
        }
        set under [FindUnderChar j UnderLineList]
        $w add command -label $j -underline $under -image $img -compound left \
            -command "GiD_Process escape escape escape escape Results ContOptions BrightColors $i"
    }
}

proc PostLegendOptionsMenu { w} {
    global GidPriv

    set opciones [ GiD_Info postprocess get legends_state]

    set namesLabel [list [_ "Show"] [_ "Opaque"] [_ "Show Title"] [_ "Draw User Limits"] [_ "Border"] \
                        [_ "Change Title"] [_ "Outside"] [_ "Automatic Comments"] ]
    set values_lst ""
    set cmds_lst ""

    # Show Legends ?
    set curr [ lindex $opciones 0]
    if { $curr == "Yes"} {
        set val 1
        set cmd "GiD_Process 'Hardcopy Options ShowLegends No"
    } else {
        set val 0
        set cmd "GiD_Process 'Hardcopy Options ShowLegends Yes"
    }
    lappend values_lst $val
    lappend cmds_lst $cmd

    # Opaque Legends ?
    set curr [ lindex $opciones 1]
    if { $curr == "Opaque"} {
        set val 1
        set cmd "GiD_Process 'Hardcopy Options OpaqueLegends No"
    } else {
        set val 0
        set cmd "GiD_Process 'Hardcopy Options OpaqueLegends Yes"
    }
    lappend values_lst $val
    lappend cmds_lst $cmd

    # Title showed?
    set curr [ lindex $opciones 2]
    if { $curr == "Title"} {
        set val 1
        set cmd "GiD_Process Mescape Results ContOptions ShowTitleLeg No escape"
    } else {
        set val 0
        set cmd "GiD_Process Mescape Results ContOptions ShowTitleLeg Yes escape"
    }
    lappend values_lst $val
    lappend cmds_lst $cmd

    # User limits drawn as boxes??
    set curr [ lindex $opciones 3]
    if { $curr == "DrawUserLimits"} {
        set val 1
        set cmd "GiD_Process Mescape Results ContOptions DrawUserLimitsLeg No escape"
    } else {
        set val 0
        set cmd "GiD_Process Mescape Results ContOptions DrawUserLimitsLeg Yes escape"
    }
    lappend values_lst $val
    lappend cmds_lst $cmd

    # draw border??
    set curr [ lindex $opciones 4]
    if { $curr == "DrawBorder"} {
        set val 1
        set cmd "GiD_Process 'Hardcopy Options DrawBorderLegends No"
    } else {
        set val 0
        set cmd "GiD_Process 'Hardcopy Options DrawBorderLegends Yes"
    }
    lappend values_lst $val
    lappend cmds_lst $cmd

    # change title
    set val 0
    set cmd "GiD_Process Mescape Results ContOptions ChangeTitleLeg"
    lappend values_lst $val
    lappend cmds_lst $cmd

    # Outside?
    set val [ ExistPostLegend]
    if { $val} {
        set cmd PostLegendInside
    } else {
        set cmd PostLegend
    }
    lappend values_lst $val
    lappend cmds_lst $cmd

    # Automatic Comments
    set opciones [ GiD_Info postprocess get comments]
    set curr [ lindex $opciones 1]
    if { $curr == "yes"} {
        set val 1
        set cmd "GiD_Process Mescape Utilities Comments Automatic No escape"
    } else {
        set val 0
        set cmd "GiD_Process Mescape Utilities Comments Automatic Yes escape"
    }
    lappend values_lst $val
    lappend cmds_lst $cmd

    $w delete 0 end
    set UnderLineList {}
    foreach j $namesLabel val $values_lst cmd $cmds_lst {
        set img $GidPriv(VerifNoImage)
        if { $val } {
            set img $GidPriv(VerifImage)
        }
        set under [FindUnderChar j UnderLineList]
        $w add command -label $j -underline $under -image $img -compound left \
            -command $cmd
    }
}

proc ViewSeveralWindows {} {
    set w .gid.viewseveralwindows

    InitWindow $w [_ "Multiple windows"] PrePostViewMWindowsWindowGeom ViewSeveralWindows "" 1
    if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0

    ttk::label $w.l -text [_ "Select the desired window configuration"] -font BigFont
    ttk::label $w.i -image [ gid_themes::GetImage mwindows.png] -relief ridge -borderwidth 1
    $w.l configure -wraplength [image width [$w.i cget -image]]

    ttk::frame $w.but -style BottomFrame.TFrame
    # -background [CCColorActivo [$w cget -background]]
    ttk::button $w.but.close -text [_ "Close"] -command "destroy $w" -underline 0 -style BottomFrame.TButton
    #SetWidgetsWidthFromText $w.but.close

    grid $w.but.close -padx 5 -pady 5

    grid $w.l -sticky new
    grid $w.i -padx 3 -sticky nsew
    grid $w.but -sticky sew
    if { $::tcl_version >= 8.5 } { grid anchor $w.but center }
    grid rowconfigure $w "1" -weight 1
    grid columnconfigure $w "0" -weight 1

    focus $w.but.close
    bind $w.i <1> [list ViewSeveralWindowsSelect $w %x %y]
    bind $w <Alt-c> [list $w.but.close invoke]
    bind $w <Escape> [list $w.but.close invoke]
}


proc ViewSeveralWindowsSelect { w x y } {
    set type ""
    if { $x > 16 && $x < 77 } {
        if { $y > 21 && $y < 77 } {
            set type 1
        } elseif { $y > 102 && $y < 157 } {
            set type 3L
        } elseif { $y > 185 && $y < 236 } {
            set type 3D
        }
    } elseif { $x > 109 && $x < 169 } {
        if { $y > 21 && $y < 77 } {
            set type 2LR
        } elseif { $y > 102 && $y < 157 } {
            set type 3U
        } elseif { $y > 185 && $y < 236 } {
            set type 4
        }
    } elseif { $x > 200 && $x < 262 } {
        if { $y > 21 && $y < 77 } {
            set type 2UD
        } elseif { $y > 102 && $y < 157 } {
            set type 3R
        } elseif { $y > 185 && $y < 236 } {
            set type EXT
        }
    }
    if { $type != "" } {
        .gid.central.s makenewwindow $type
        #after idle [list GiD_Process 'NewWin $type]
    }
}

proc CreatePointNewOld {} {
    global GidPriv
    if { ![info exists GidPriv(CreatePointNewOld)] } {
        set GidPriv(CreatePointNewOld) 1
    }
    set w .gid.createpointnewold
    InitWindow $w [_ "Create point procedure"] CreatePointNewOldWindowGeom CreatePointNewOld "" 1
    if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0
    ttk::label $w.l -text [_ "Click the image to get the existing point or create a new one"]
    ttk::frame $w.centre -style ridge.TFrame -borderwidth 2
    ttk::label $w.centre.txt_NJ -text [_ "No join"] -font BigFont
    ttk::label $w.centre.txt_NJ2 -text [_ "New point is created"]
    ttk::label $w.centre.txt_J -text [_ "Join"] -font BigFont
    ttk::label $w.centre.txt_J2 -text [_ "Existing point is selected"]
    ttk::button $w.centre.nojoin -image [ gid_themes::GetImage no_join.png] -cursor hand2 \
        -command "set GidPriv(CreatePointNewOld) 0 ; CreatePointNewOldExec $w 1"        
    ttk::button $w.centre.join -image [ gid_themes::GetImage join.png] -cursor hand2 \
        -command "set GidPriv(CreatePointNewOld) 1 ; CreatePointNewOldExec $w 1"    
    ttk::label $w.note_text -text [_ "NOTE: %s toggles between Join and No join modes." ${::acceleratorText}-a]   
    grid $w.centre.txt_NJ $w.centre.txt_J
    grid $w.centre.nojoin $w.centre.join -padx 3
    grid $w.centre.txt_NJ2 $w.centre.txt_J2
    grid $w.l -sticky new -columnspan 2 -padx 3 -pady 3
    grid $w.centre -sticky nsew -columnspan 2 -padx 3
    grid columnconfigure $w.centre "0 1" -weight 1
    grid $w.note_text -sticky sew -columnspan 2 -padx 3   
    grid columnconfigure $w "0" -weight 1
    grid rowconfigure $w "1" -weight 1
    wm protocol $w WM_DELETE_WINDOW "CreatePointNewOldExec $w 0"
    bind $w <Escape> "CreatePointNewOldExec $w 0"
    focus $w
    bind $w <Return> "set GidPriv(CreatePointNewOld) 1 ; CreatePointNewOldExec $w 1"
    update idletasks
}

proc CreatePointNewOldExec { w doit } {
    global GidPriv
    if { !$doit } {
        GiD_Process escape
    } elseif { $GidPriv(CreatePointNewOld) } {
        GiD_Process old
    } else {
        GiD_Process new
    }
    destroy $w
}


proc GeometryView { } {
    set whatuse [ GiD_Info Project ViewMode]
    if { $whatuse != "GEOMETRYUSE" } {
        GiD_Process MEscape Geometry
    }
}

proc MeshView { { showmessage 1 } } {
    set whatuse [ GiD_Info Project ViewMode]
    if { $whatuse == "GEOMETRYUSE" } {
        if { $showmessage && [lindex [ GiD_Info mesh] 0] == "0" } {
	    set ::CurrentViewMode $whatuse ;#to avoid set the check mark as Mode->Mesh	    
            WarnWin [_ "Sorry. No mesh"]
        } else {
            GiD_Process Mescape Meshing MeshView
        }
    }
}

proc ToggleGeomMesh {} {
    set infoProj [ GiD_Info Project ViewMode]
    if { $infoProj == "GEOMETRYUSE" } {
        if { [lindex [ GiD_Info mesh] 0] != "0" } {
            GiD_Process Mescape Meshing MeshView
        } else {
            #WarnWin [_ "There is no mesh. Generate it?"]
            GiD_Process Mescape Meshing Generate
        }
    } elseif { $infoProj == "MESHUSE" } {
        GiD_Process Mescape Geometry escape
    }   
}

proc TogglePrePost {} {
    if { [ GetCurrentPrePostMode] == "PRE" } {
        GiD_Process Mescape Postprocess
    } else {
        GiD_Process Mescape Preprocess
    }
}

proc TogglePostGraph {} {
    set viewmode [ GiD_Info Project ViewMode]
    if { $viewmode == "POSTUSE" } {
        GiD_Process Mescape Results Graphs OptionsGraph ShowGraphs Yes
    } elseif { $viewmode == "GRAPHUSE" } {
        GiD_Process Mescape Results Graphs OptionsGraph ShowGraphs No
    }
}

proc GGCompress {} {
    set w .wcomp

    toplevel $w
    ttk::frame $w.f -style groove.TFrame -borderwidth 2
    ttk::label $w.f.l1 -text [_ "Flags"]:
    ttk::entry $w.f.e1
    ttk::label $w.f.l2 -text [_ "File In"]:
    ttk::entry $w.f.e2
    ttk::label $w.f.l3 -text [_ "File Out"]:
    ttk::entry $w.f.e3
    grid $w.f.l1 $w.f.e1
    grid $w.f.l2 $w.f.e2
    grid $w.f.l3 $w.f.e3

    proc GGCDoIt { w} {
        set fl [ $w.f.e1 get]
        set fi [ $w.f.e2 get]
        set fo [ $w.f.e3 get]
        if { $fl != ""} {
            gidcompress $fl $fi $fo
        } else {
            gidcompress $fl $fi $fo
        }
    }
    ttk::button $w.f.b1 -text [_ "Do"] -command "GGCDoIt $w" -style BottomFrame.TButton
    ttk::button $w.f.b2 -text [_ "Close"] -command "destroy $w" -style BottomFrame.TButton
    #SetWidgetsWidthFromText $w.f.b1 $w.f.b2

    grid $w.f.b1 $w.f.b2

    grid $w.f

}

proc framelabel { w text { rel groove}} {
    ttk::frame $w -relief $rel -borderwidth 2
    set i 0
    set parent [winfo parent $w]
    if { $parent == "." } { set parent "" }
    set label $parent.__label$i
    while { [winfo exists $label] } {
        incr i
        set label $parent.__label$i
    }
    ttk::label $label -text $text
    place $label -in $w -x 10 -y -1 -anchor w -bordermode outside
    after idle raise $label
    return $w
}

proc framelabelsep {} {
    set FontHeight [ font metrics NormalFont -linespace]
    return [expr $FontHeight/2+1]
}

proc AskForNormal { w message } {
    global tkPriv tcl_platform

    toplevel $w
    wm title $w [_ "Enter normal"]

    if { $::tcl_platform(platform) == "windows" } {
        wm transient $w [winfo toplevel [winfo parent $w]]
    }

    
    ttk::frame $w.f

    ttk::label $w.f.l -text $message
    ttk::radiobutton $w.f.r1 -text [_ "Positive Z"] -variable tkPriv(afw_check) -value z
    ttk::radiobutton $w.f.r2 -text [_ "Positive Y"] -variable tkPriv(afw_check) -value y
    ttk::radiobutton $w.f.r3 -text [_ "Positive X"] -variable tkPriv(afw_check) -value x
    ttk::radiobutton $w.f.r4 -text [_ "Coords"]: -variable tkPriv(afw_check) -value coords

    ttk::entry $w.f.e1 -width 5
    ttk::entry $w.f.e2 -width 5
    ttk::entry $w.f.e3 -width 5

    $w.f.e1 insert end 0.0
    $w.f.e2 insert end 0.0
    $w.f.e3 insert end 1.0

    proc ChangeCoords { w } {
        global tkPriv
        if { $tkPriv(afw_check) == "coords" } {
            $w.f.e1 configure -state normal
            $w.f.e2 configure -state normal
            $w.f.e3 configure -state normal
        } else {
            $w.f.e1 configure -state disabled
            $w.f.e2 configure -state disabled
            $w.f.e3 configure -state disabled
        }
    }

    trace var tkPriv(afw_check) w " ChangeCoords $w ;#"

    set tkPriv(afw_check) z

    grid $w.f.l -row 1 -column 1 -columnspan 4 -sticky w -padx 2
    grid  $w.f.r1 -row 2 -column 1 -columnspan 4 -sticky w -padx 2
    grid  $w.f.r2 -row 3 -column 1 -columnspan 4 -sticky w
    grid  $w.f.r3 -row 4 -column 1 -columnspan 4 -sticky w
    grid  $w.f.r4 -row 5 -column 1
    grid $w.f.e1 -row 5 -column 2 -sticky ew
    grid $w.f.e2 -row 5 -column 3 -sticky ew
    grid $w.f.e3 -row 5 -column 4 -sticky ew
    grid columnconf $w.f 2 -weight 1
    grid columnconf $w.f 3 -weight 1
    grid columnconf $w.f 4 -weight 1

    ttk::frame $w.bf -style BottomFrame.TFrame
    
    ttk::button $w.bf.ok -text [_ "OK"] -command "set tkPriv(afw_button) ok" -underline 0 -style BottomFrame.TButton
    ttk::button $w.bf.scr -text [_ "In screen"] -command "set tkPriv(afw_button) scr" -underline 0 -style BottomFrame.TButton
    ttk::button $w.bf.cancel -text [_ "Cancel"] -command "set tkPriv(afw_button) cancel" -underline 0 -style BottomFrame.TButton

    wm protocol $w WM_DELETE_WINDOW "$w.bf.cancel invoke"
    bind $w.bf.ok <Return> "$w.bf.ok invoke"
    bind $w.f.e1 <Return> "$w.bf.ok invoke"
    bind $w.f.e2 <Return> "$w.bf.ok invoke"
    bind $w.f.e3 <Return> "$w.bf.ok invoke"
    bind $w <Escape> "$w.bf.cancel invoke"
    bind $w <Alt-o> "$w.bf.ok invoke"
    bind $w <Alt-c> "$w.bf.cancel invoke"
    bind $w <Alt-i> "$w.bf.scr invoke"

    grid $w.f  -pady 6 -sticky ewns
    grid $w.bf -pady 0 -sticky ewns
    grid columnconf $w 0 -weight 1
    grid rowconf $w 0 -weight 1
    
    grid $w.bf.ok -column 1 -row 0 -padx 5 -pady 3
    grid $w.bf.scr -column 2 -row 0 -padx 5 -pady 3 
    grid $w.bf.cancel -column 3 -row 0 -padx 5 -pady 3
    grid columnconfigure $w.bf 0 -weight 1
    grid columnconfigure $w.bf 4 -weight 1
    

    wm withdraw $w
    update idletasks

    set pare [winfo toplevel [winfo parent $w]]
    set x [expr [winfo x $pare]+[winfo width $pare ]/2- [winfo reqwidth $w]/2]
    set y [expr [winfo y $pare]+[winfo height $pare ]/2- [winfo reqheight $w]]
    if { $x < 0 } { set x 0 }
    if { $y < 0 } { set y 0 }
    WmGidGeom $w +$x+$y
    #wm geom $w +$x+$y
    update
    wm deiconify $w

    set oldFocus [focus]
    if { $::tcl_platform(os) != "Darwin"} {
        if { [winfo exists $w] } {
            tkwait visibility $w
        }
    } else {
        update
    }
    grab $w
    focus $w.bf.ok
    after 100 catch [ list "focus -force $w.bf.ok"]

    while 1 {
        tkwait variable tkPriv(afw_button)

        if { $tkPriv(afw_button) != "ok" } { break }
        set value ""
        set isdiffzero 0
        if { $tkPriv(afw_check) == "coords" } {
            set isbad 0
            for { set i 1 } { $i <= 3 } { incr i } {
                if { [catch { set val [expr double([$w.f.e$i get])] }] } {
                    WarnWin [_ "Coordinate must be a real number"]
                    tkTabToWindow $w.f.e$i
                    set isbad 1
                    break
                }
                if { $val != 0.0 } { set isdiffzero 1 }
                if { $value == "" } {
                    append value $val
                } else {
                    append value ",$val"
                }
            }
            if { $isbad } {
                focus -force $w
                tkTabToWindow $w.f.e$i
                continue
            }
            if { !$isdiffzero } {
                WarnWin [_ "Normal must be different from zero"]
                focus -force $w
                tkTabToWindow $w.f.e1
                continue
            }
        } elseif { $tkPriv(afw_check) == "z" } {
            set value "0.0,0.0,1.0"
        } elseif { $tkPriv(afw_check) == "y" } {
            set value "0.0,1.0,0.0"
        } else {
            set value "1.0,0.0,0.0"
        }
        break
    }
    set oldGrab [grab current $w]
    if {$oldGrab != ""} {
        set grabStatus [grab status $oldGrab]
    }

    if { $oldFocus == "" || [catch {focus $oldFocus}] } {
        if { [winfo exists .gid] } {
            focus [focus -lastfor .gid]
        }
    }

    destroy $w
    if {$oldGrab != ""} {
        if {$grabStatus == "global"} {
            catch { grab -global $oldGrab }
        } else {
            catch { grab $oldGrab }
        }
    }

    switch $tkPriv(afw_button) {
        ok {
            GiD_Process $value
        }
        cancel {
            GiD_Process escape
        }
    }
}

proc ExecuteFileCommand { comm PREPOST lastaction filename } {
    set what [ GetCurrentPrePostMode]
    if { $PREPOST == "PRE" && $what == "POST" } {
        if { $lastaction == "goingpre" } { return }
        GiD_Process Mescape Preprocess
        delayedop changefunc [ list LoadFileInGid $filename goingpre]
        return
    }
    if { $PREPOST == "POST" && $what == "PRE" } {
        GiD_Process Mescape Postprocess
        update idletasks
    }
    if { $comm == "STLRead" || $comm == "MeshRead" } {
        if { [lindex [GiD_Info mesh] 0] } {
            #to not ask. append to current mesh
            lappend comm AddNoShare
        }
    } elseif { $comm == "NASTRANRead" || $comm == "3DStudioRead" } {
        if { [lindex [GiD_Info mesh] 0] } {
            #to not ask. append to current mesh
            lappend comm Append
        }
    }
    GiD_Process Mescape Files {*}$comm $filename
}


#user procedures to handle some file extension when dropping files on GiD 
#prepost could be: PRE POST or PREPOST
#procname is a procedure with an argument, the name of the dropped file that match the extension
#GiD_RegisterExtensionProc <list of extensions> <prepost> <procname>
#GiD_UnRegisterExtensionProc <list of extensions> <prepost>
#e.g.
#proc MyUnvRead { file } { ... }
#GiD_RegisterExtensionProc ".unv .uff" PRE MyUnvRead


proc GiD_RegisterExtensionProc { exts prepost procname  } {
    if { [info procs $procname] != "" } {
        set argc [llength [info args $procname]]
        if { $argc>1 } {
            set arg [lindex [info args $procname] 1]
            if { [info default $procname $arg defvalue] } {
                #more than 1 argument, but the rest have default values
                set argc 1
            }                                           
        }
        if { $argc != 1 } {
            return -code error [_ "Wrong procedure prototype, must be '%s'." "proc procname <filename> body"]
        }
    }
    if { $prepost == "PRE" } {
        set where PRE
    } elseif { $prepost == "POST" } {
        set where POST
    } elseif { $prepost == "PREPOST" } {  
        set where "PRE POST"
    } else {
        return -code error [_ "Wrong arg. Must be PRE, POST or PREPOST."]
    }
    foreach i $where {
        foreach ext $exts {
            set ext [string tolower $ext]
            set ::GidPriv(RegisteredExtensionProcs,$ext,$i) $procname
        }
    }
}

proc GiD_UnRegisterExtensionProc { exts prepost } {
    if { $prepost == "PRE" } {
        set where PRE
    } elseif { $prepost == "POST" } {
        set where PRE
    } elseif { $prepost == "PREPOST" } {  
        set where "PRE POST"
    } else {
        return -code error [_ "Wrong arg. Must be PRE, POST or PREPOST."]
    }
    foreach i $where {
        foreach ext $exts {
            set ext [string tolower $ext]
            if { ![info exists ::GidPriv(RegisteredExtensionProcs,$ext,$i)] } {
                return 1
            }
            unset ::GidPriv(RegisteredExtensionProcs,$ext,$i)
        }
    }
}


# last action can be: saving; goingpre;
proc LoadFileInGid { file {lastaction ""} } {
    if { ![file exists $file] } {
        WarnWin [_ "File '%s' does not exist" $file]
        return
    }

    if {$::tcl_platform(platform) eq "windows"} {
        set file [file native [file attributes $file -longname]]
    } else {
        set file [file native $file]
    }
    if { [file isdirectory $file] && [string tolower [file extension $file]] == ".gid" } {
        if { [ GetCurrentPrePostMode] == "POST" } {
            if { $lastaction == "goingpre" } { return }
            #DelayedTCLOperations::EnterOperation not add the procedure to the pending list
            #because: GiveLastFunc()==NULL 
            #GiD_Process Mescape Preprocess
            #delayedop changefunc [ list LoadFileInGid $file goingpre]
            GiD_Process Mescape Preprocess Yes
            LoadFileInGid $file
            return
        }
        if { [ GiD_Info Project AreChanges] } {
            if { $lastaction == "saving" } { return }
            GiD_Process Mescape Files New
            delayedop changefunc [ list LoadFileInGid $file saving]
        } else {
            ExecuteFileCommand Read PRE $lastaction $file
        }
    } elseif { [ string match *.post.lst $file] || \
                   [ string match *.res $file] ||[ string match *.bin $file] || \
                   [ string match *.post.bin $file] || [ string match *.post.bin $file] || \
                   [ string match *.post.msh $file] || [ string match *.post.res $file] || \
                   [ string match *.flavia.msh $file] || [ string match *.flavia.res $file] } {
        ExecuteFileCommand Read POST $lastaction $file
    } else {
        set ext [string tolower [file extension $file]]
        switch $ext {
            ".dxf" { ExecuteFileCommand DXFRead PRE $lastaction $file}
            ".msh" { 
                if { [ GetCurrentPrePostMode] == "POST" } {
                    ExecuteFileCommand Read POST $lastaction $file
                } else {
                    ExecuteFileCommand MeshRead PRE $lastaction $file
                }
            }
            ".mesh" { ExecuteFileCommand MeshRead PRE $lastaction $file}
            ".igs" - ".iges" { ExecuteFileCommand IgesRead PRE $lastaction $file}
            ".stp" - ".step" { ExecuteFileCommand STEPRead PRE $lastaction $file}
            ".nas" - ".bdf" { ExecuteFileCommand NASTRANRead ANY $lastaction $file}
            ".bch" { ExecuteFileCommand BatchFile ANY $lastaction $file}
            ".x_t" - ".x_b" { ExecuteFileCommand ParasolidRead PRE $lastaction $file}
            ".sat" { ExecuteFileCommand AcisRead PRE $lastaction $file}
            ".vda" { ExecuteFileCommand VDARead PRE $lastaction $file}
            ".stl" { ExecuteFileCommand STLRead PRE $lastaction $file}
            ".shp" { ExecuteFileCommand ShapefileRead PRE $lastaction $file}
            ".3dm" { ExecuteFileCommand RhinoRead PRE $lastaction $file}
            ".wrl" - ".vrml" { ExecuteFileCommand VrmlRead PRE $lastaction $file}
            ".3ds" { ExecuteFileCommand 3DStudioRead ANY $lastaction $file}
            ".cgns" { ExecuteFileCommand CGNSRead PRE $lastaction $file}
            ".ply" { ExecuteFileCommand PlyRead PRE $lastaction $file}
            ".obj" { ExecuteFileCommand OBJRead PRE $lastaction $file}
            ".neu" - ".fno" { ExecuteFileCommand ReadFEMAP POST $lastaction $file}
            ".plt" { ExecuteFileCommand ReadTECPLOT POST $lastaction $file}
            ".bin" { ExecuteFileCommand Read POST $lastaction $file}
            ".vv" {  ExecuteFileCommand 'ReadView ANY $lastaction $file}
            default {
                set mode [GetCurrentPrePostMode]
                if { [info exists ::GidPriv(RegisteredExtensionProcs,$ext,$mode)] } {
                    set procname $::GidPriv(RegisteredExtensionProcs,$ext,$mode)
                    set argc [llength [info args $procname]]
                    if { $argc>1 } {
                        set arg [lindex [info args $procname] 1]
                        if { [info default $procname $arg defvalue] } {
                            #more than 1 argument, but the rest have default values
                            set argc 1
                        }                                           
                    }                    
                    if { $argc == 1 } {
                        $procname $file
                    }
                } else {
                    #deprecated LoadFileInGidUnknowExtension, better use GiD_RegisterExtensionProc
                    RaiseEvent_GenericProc ::LoadFileInGidUnknowExtension $file
                    if { [info procs LoadFileInGidUnknowExtension] != "" } {                    
                        WarnWin [_ "Unknown file type for file '%s'" $file]
                        return
                    }
                }
            }
        }
    }
}

proc LoadFileInGidPost { file {lastaction ""} } {
    if { ![file exists $file] } {
        WarnWin [_ "File '%s' does not exist" $file]
        return
    }

    if {$::tcl_platform(platform) eq "windows"} {
        set file [file native [file attributes $file -longname]]
    } else {
        set file [file native $file]
    }
    if { [file isdirectory $file] && [string tolower [file extension $file]] == ".gid" } {
        if { [ GetCurrentPrePostMode] == "POST" } {
            if { $lastaction == "goingpre" } { return }
            GiD_Process Mescape Preprocess
            delayedop changefunc [ list LoadFileInGid $file goingpre]
            return
        }
        if { [ GiD_Info Project AreChanges] } {
            if { $lastaction == "saving" } { return }
            GiD_Process Mescape Files New
            delayedop changefunc [ list LoadFileInGid $file saving]
        } else {
            ExecuteFileCommand Read PRE $lastaction $file
        }
    } elseif { [ string match *.post.lst $file] || \
                   [ string match *.msh $file] || [ string match *.res $file] || \
                   [ string match *.bin $file] || \
                   [ string match *.post.bin $file] || [ string match *.post.bin $file] || \
                   [ string match *.post.msh $file] || [ string match *.post.res $file] || \
                   [ string match *.flavia.msh $file] || [ string match *.flavia.res $file] } {
        ExecuteFileCommand Read POST $lastaction $file
    } else {
        set ext [string tolower [file extension $file]]
        switch $ext {
            ".nas" { ExecuteFileCommand NASTRANRead POST $lastaction $file}
            ".bch" { ExecuteFileCommand BatchFile POST $lastaction $file}
            ".3ds" { ExecuteFileCommand 3DStudioRead POST $lastaction $file}
            ".cgns" { ExecuteFileCommand CGNSRead PRE $lastaction $file}
            ".neu" - ".fno" { ExecuteFileCommand ReadFEMAP POST $lastaction $file}
            ".plt" { ExecuteFileCommand ReadTECPLOT POST $lastaction $file}
            ".bin" { ExecuteFileCommand Read POST $lastaction $file}
            ".vv" {  ExecuteFileCommand 'ReadView ANY $lastaction $file}
            ".res" { ExecuteFileCommand Read POST $lastaction $file}
            ".msh" { ExecuteFileCommand Read POST $lastaction $file}
            ".bon" { ExecuteFileCommand Read POST $lastaction $file}
            ".dat" { ExecuteFileCommand Read POST $lastaction $file}
            default {
                if { [info exists ::GidPriv(RegisteredExtensionProcs,$ext,POST)] } {
                    if { [llength [info args ::GidPriv(RegisteredExtensionProcs,$ext,POST)]] == 1 } {                        
                        set procname $::GidPriv(RegisteredExtensionProcs,$ext,POST)
                        set argc [llength [info args $procname]]
                        if { $argc>1 } {
                            set arg [lindex [info args $procname] 1]
                            if { [info default $procname $arg defvalue] } {
                                #more than 1 argument, but the rest have default values
                                set argc 1
                            }                                           
                        }                    
                        if { $argc == 1 } {
                            $procname $file
                        }                                                
                    }
                } else {
                    #deprecated LoadFileInGidUnknowExtension, better use GiD_RegisterExtensionProc
                    RaiseEvent_GenericProc ::LoadFileInGidUnknowExtension $file
                    if { [info procs LoadFileInGidUnknowExtension] != "" } {                    
                        WarnWin [_ "Unknown file type for file '%s'" $file]
                        return
                    }
                }
            }
        }
    }
}

proc MsgcatGetLocales {} {
    global GIDDEFAULT
    # Directorio en el que se encuentran los ficheros msgs
    set dir [file join $GIDDEFAULT resources msgs]

    # Obtenemos los nombres de fichero = locale
    #force to show also en in the list
    set locales {en}
    foreach file [glob -nocomplain -directory $dir *.msg] {
        set name [lindex [file split $file] end]
        set name [string range $name 0 end-4]
        set locales [linsert $locales end $name]
    }
    set locales [lsort -unique $locales]

    return $locales
}

proc MsgcatSetLocale {locale} {
    global GIDDEFAULT
    # Directorio en el que se encuentran los ficheros msgs
    set dir [file join $GIDDEFAULT resources msgs]

    ::msgcat::mclocale $locale
    ::msgcat::mcload $dir
    # load the problemtype's message catalog
    if {![catch {GiD_Info problemtypepath} dir]} {
        ::GIDi18nProblemType::load $dir
    }
}

proc MsgcatMcInitialize {} {

    global env

    # Obtener el fichero de configuracion local
    set config [file nativename [ GiveGidDefaultsFile]]


    # Consultar las preferencias del usuario
    set found -1
    set res [file exists $config]
    if {$res} {
        
        # Leer el fichero
        set fileid [open $config r]
        fconfigure $fileid -encoding "utf-8"
        set data [read $fileid]
        close $fileid
        
        foreach line [split $data "\n"] {
            
            set res [string match "Language*" $line]
            
            if { $res} {
                
                set found 1
                
                set language [string range $line 9 end]
            }
        }
    }

    # Consultamos las preferencias del sistema
    if { $found == -1} {
        set preferences [::msgcat::mcpreferences]
        set preferences [linsert $preferences 0 en] ;#until the message catalog is fully translated
        # Obtenemos los locales disponibles
        set locales [MsgcatGetLocales]

        # Buscamos el primer lenguaje disponible para
        # las preferencias
        set found -1
        foreach preference $preferences {
            set found [lsearch -exact $locales $preference]
            if { $found > -1 } {
                set language $preference
                break
            }
        }
        
        if { $found == -1 } {
            
            # Si no se ha podido determinar el idioma,
            # se define el ingles  por defecto
            set language en
        }
    }

    ## Establecemos el idioma   
    MsgcatSetLocale $language
}



proc SetTemplatesMenu { w } {
    global GIDDEFAULT
    set dir [file join $GIDDEFAULT templates]
    set files [glob -nocomplain -tails -directory $dir -types f *.bas]

    set newstate $files
    set thisproc $w
    if { [info exists ::MenuPrevState($thisproc)] } {
        if { $::MenuPrevState($thisproc) == $newstate && [$w index end] != "none" } {
            return
        }
    }
    set ::MenuPrevState($thisproc) $newstate


    $w delete 0 end
    set UnderLineList {}
    foreach i [winfo children $w] { destroy $i }
    set inum 0
    foreach i [lsort -dictionary $files] {
        set text [file root $i]
        set under [FindUnderChar text UnderLineList]
        $w add command -label $text -underline $under \
            -command [list  GiD_Process Mescape Files WriteForBAS [file join $dir $i]]
        incr inum
    }


    if { $inum } { $w add separator }
    set text [_ "Others"]...
    set under [FindUnderChar text UnderLineList]
    $w add command -label $text -underline $under -command {GiD_Process Mescape Files WriteForBAS}
}

namespace eval WaitStater {
    variable cursors
}

proc WaitStater::SetWatch { w } {
    SetWatchRecursive $w $w
    update
}

proc WaitStater::UnsetWatch { w } {
    variable cursors

    foreach i [array names cursors $w,*] {
        regexp {[^,]+,(.*)} $i {} win
        $win configure -cursor $cursors($i)
        unset cursors($i)
    }
    update
}

proc WaitStater::SetWatchRecursive { w win } {
    variable cursors
    catch {
        set cursors($w,$win) [$win cget -cursor]
        $win configure -cursor watch
    }
    foreach i [winfo children $win] {
        SetWatchRecursive $w $i
    }
}

# status = NONE | ACADEMIC | PROFESSIONAL | TEMPORALLYPROFESSIONAL
proc ShowGiDVersionType { { status ""}} {
    global GidPriv
    if { $status == "" } {
        set status none
        if { [info exists GidPriv(GiDVersionType)] } {
            set status $GidPriv(GiDVersionType)
        }
    }
    set GidPriv(GiDVersionType) $status
    if { ![GidUtils::IsTkDisabled] && [info procs gid_themes::GetImage]!= "" } {  
        set base_name [file rootname $GidPriv(InfoGiDBitmapName)]
        set extension [file extension $GidPriv(InfoGiDBitmapName)]
        set img ""
        if { [string match -nocase "none" $status] } {
            set img [gid_themes::GetImage $GidPriv(InfoGiDBitmapName) toolbar]            
        } elseif { [string match -nocase "academic" $status] } {
            set img [gid_themes::GetImage ${base_name}_a${extension} toolbar]          
        } elseif { [string match -nocase "professional" $status] } {
            set img [gid_themes::GetImage ${base_name}_p${extension} toolbar]           
        } elseif { [string match -nocase "temporallyprofessional" $status] } {
            set img [gid_themes::GetImage ${base_name}_t${extension} toolbar]
        } else {
            set img ""
        }        
        if { [info exists GidPriv(InfoGiDButtonName)] && $GidPriv(InfoGiDButtonName) != "" } {
            if { [winfo exists $GidPriv(InfoGiDButtonName)] && $img != "" } {
                $GidPriv(InfoGiDButtonName) configure -image $img
            }
        }
    }
    RaiseEvent_GenericProc ::AfterChangeLicenceStatus $status
}

proc GetImageGiDorProblemtype {BitmapsPath filename} {
    if { $BitmapsPath == "GiD_image_folder" && [llength [file split $filename]] == 1 } { 
        #using standard GiD image
        return [gid_themes::GetImage $filename toolbar]
    } else {
        global GidPrivImages
        if { ![info exists ::GidPrivImages(problemtype$BitmapsPath$filename)] } {
            set err_img [ catch {
                if { $BitmapsPath == "GiD_image_folder" } {
                    #filename have folder, execute get from $::GIDDEFAULT
                    set ::GidPrivImages(problemtype$BitmapsPath$filename) [image create photo \
                        -file [file join $::GIDDEFAULT $filename]]
                } else {
                    set ::GidPrivImages(problemtype$BitmapsPath$filename) [ image create photo \
                        -file [file join $BitmapsPath $filename]]
                }   
            } err_txt]
            if { $err_img } {
                WarnWinText [_ "Error getting image in GetImageGiDorProblemtype"]
                set ::GidPrivImages(problemtype$BitmapsPath$filename) [gid_themes::GetImage erase-cross.png small_icons]
            }
        }
        return $::GidPrivImages(problemtype$BitmapsPath$filename)
    }
}


proc ReloadLastModel { {previousproblemtype ""} } {
    set Reload [ GiD_Set ReloadLastModel]
    if { $Reload != 0 } {
        if { [ GiD_Set LastModelSaved] == 0 } {
            set Reload 0
        }
    }
    if {  $Reload != 0 && [string range [lindex $::argv 0] 0 1] == "-b" } {
        #not reload the last model if a batch file was specified
        set Reload 0
    }
    if { $Reload != 0 && [ GiD_Info Project ModelName] != "UNNAMED" } {
        #already read a backup file after crash or load a model from the command line
        set Reload 0
    }
    if { $Reload != 0 } {
        set names [ GiD_Info recentprojects]
        if { [llength $names] > 0 } {
            if { $previousproblemtype != "" } {
                #only load last model if his probletype is also pt
                set geoinfo [ GiD_GetInfoGeoFile [file join [lindex $names 0].gid [file tail [lindex $names 0]].geo]]
                #file join to convert \ to /
                if { [file join $previousproblemtype] != [file join [lindex $geoinfo 2]] } {
                    set Reload 0
                }
            }
            if { $Reload != 0 } {
                LoadFileInGid [lindex $names 0].gid
            }
        }
    }
}

proc SourcePlugins { dir } {
    #source only .tcl (or .tbe) file with the same name as the folder
    #
    #set files [glob -nocomplain -tails -directory $dir -types f *.tcl]
    #set filestbe [glob -nocomplain -tails -directory $dir -types f *.tbe]
    set filetail [file tail $dir]
    set files [glob -nocomplain -tails -directory $dir -types f $filetail.tcl]
    set filestbe [glob -nocomplain -tails -directory $dir -types f $filetail.tbe]
    foreach i $filestbe {
        lappend files [file rootname $i].tcl
    }
    foreach i [lsort -unique -dictionary $files] {
        source [file join $dir $i]        
    }
    set subdirs [glob -nocomplain -tails -directory $dir -types d *]
    foreach link [glob -nocomplain -tails -directory $dir -types f *.lnk] {
        if { [ GidUtils::IsLink [file join $dir $link]] == 2 } {
            lappend subdirs $link
        }
    }
    foreach i [lsort -dictionary $subdirs] {
        set ifull [file join $dir $i]
        if { [file extension $i] == ".lnk" && [ GidUtils::IsLink $ifull] == 2 } {
            set i [file root $i] ;#to remove .lnk
            set ifull [ GidUtils::ReadLink $ifull 1]
        }
        SourcePlugins $ifull
    }
}

#some procedures that are defined just when sourcing plugins must be evaluated after read its preferences
proc GiD_RegisterProcedureToInvokeAfterSourcePlugins { procedure } {
    global GidPriv
    lappend ::GidPriv(procedures_after_source_plugins) $procedure
}

proc AfterSourcePlugins { } {
    global GidPriv
    if { [info exists GidPriv(procedures_after_source_plugins)] } {
        foreach procedure $GidPriv(procedures_after_source_plugins) {
            {*}[subst $procedure]
        }
    }
}



#args are the command line arguments argv
proc GiD_BeforeMainLoop { args } {
    if { [info exists ::GID_GROUPS] } {
        InitGroups
    }   
      
    # disable UpdateTopMenus
    GiDMenu::DisableUpdateMenus
    #recursivelly source all .tcl files inside the plugins folder

    source [file join $::GIDDEFAULT scripts gid_plugin_mesh.tcl] ;#to define class GiDMeshVariables before be used by plugins

    SourcePlugins [file join $::GIDDEFAULT plugins]
    #read additional preferences of possible mesher objects defined in plugins
    RaiseEvent_GenericProc PluginMeshVariablesClass_ReadObjects [GiveGidDefaultsFile] "PREFERENCES"
    AfterSourcePlugins

    #check if used -p problemtype <pt> or -e data defaults problemtype <pt>
    #to not reload the last model if it has a different problemtype
    set previousproblemtype ""
    if { [llength $args] > 0 } {
        #check if try to load a problemtype
        set pos [lsearch $args "-p"]
        if { $pos != -1 } {
            set previousproblemtype [lindex $args [expr $pos+1]]
        }
        set pos [lsearch $args "-e"]
        if { $pos != -1 } {
            set pos2 [lsearch [string tolower [lrange $args [expr $pos+1] end]] "problemtype"]
            if { $pos2 != -1 } {
                set previousproblemtype [lindex $args [expr $pos+$pos2+2]]
            }
        }
    }

    ReloadLastModel $previousproblemtype
    
    if { [info commands configure_program_proc] ne "" } {
        uplevel #0 configure_program_proc
    }
    
    
    if { $::tcl_platform(platform) == "windows" } {
        #avoid wrong menu images with Windows animation effects
        GiD_SetMenuAnimation 0
    }
    GidUtils::SetWarnLine [_ "Ready"]

    # enable back UpdateTopMenus
    GiDMenu::EnableUpdateMenus
    GiDMenu::UpdateMenus

    if { ![info exists ::GidPriv(ShowCheckNewVersion)] || $::GidPriv(ShowCheckNewVersion) != 0 } {
        ShowCheckNewVersion
    }
}

proc GiD_AfterChangeViewMode { ViewMode } {
    if { $ViewMode == "GEOMETRYUSE" || $ViewMode == "MESHUSE" } {
        after idle {
            GidUtils::UpdateWindow COPY
            SetStateConditionGroupsAllowedTypes GD_CND_1
        }        
    } elseif { $ViewMode == "POSTUSE" } {

    } elseif { $ViewMode == "GRAPHUSE" } {

    } else {

    }
}

proc bgerror { err } {
    #avoid disabled graphics
    if { $::_DebugDefaultValues} {
        DebugText "bgerror: $err"
        DebugText $::errorInfo
    }
    if { [info commands .gid.central.s] ne "" } {
        foreach i [list windows graphinput graphics warnline] {
            .gid.central.s disable $i 0
        }
    }
    ::tk::dialog::error::bgerror $err
}

#unknown is a copy of init.tcl but including translation (maybe can be alse be enhanced)

proc __unknown args {
    global auto_noexec auto_noload env unknown_pending tcl_interactive
    global errorCode errorInfo

    # If the command word has the form "namespace inscope ns cmd"
    # then concatenate its arguments onto the end and evaluate it.

    set cmd [lindex $args 0]
    if {[regexp "^:*namespace\[ \t\n\]+inscope" $cmd] && [llength $cmd] == 4} {
        set arglist [lrange $args 1 end]
        set ret [catch {uplevel 1 ::$cmd $arglist} result]
        if {$ret == 0} {
            return $result
        } else {
            return -code $ret -errorcode $errorCode $result
        }
    }

    # Save the values of errorCode and errorInfo variables, since they
    # may get modified if caught errors occur below.  The variables will
    # be restored just before re-executing the missing command.

    # Safety check in case something unsets the variables
    # ::errorInfo or ::errorCode.  [Bug 1063707]
    if {![info exists errorCode]} {
        set errorCode ""
    }
    if {![info exists errorInfo]} {
        set errorInfo ""
    }
    set savedErrorCode $errorCode
    set savedErrorInfo $errorInfo
    set name [lindex $args 0]
    if {![info exists auto_noload]} {
        #
        # Make sure we're not trying to load the same proc twice.
        #
        if {[info exists unknown_pending($name)]} {
            return -code error [_ "self-referential recursion in 'unknown' for command '%s'" $name];
        }
        set unknown_pending($name) pending;
        set ret [catch {auto_load $name [uplevel 1 {::namespace current}]} msg]
        unset unknown_pending($name);
        if {$ret != 0} {
            append errorInfo [concat "\n    (" [_ "autoloading"] "'$name')"]
            return -code $ret -errorcode $errorCode -errorinfo $errorInfo $msg
        }
        if {![array size unknown_pending]} {
            unset unknown_pending
        }
        if {$msg} {
            set errorCode $savedErrorCode
            set errorInfo $savedErrorInfo
            set code [catch {uplevel 1 $args} msg]
            if {$code ==  1} {
                #
                # Compute stack trace contribution from the [uplevel].
                # Note the dependence on how Tcl_AddErrorInfo, etc.
                # construct the stack trace.
                #
                set cinfo $args
                set ellipsis ""
                while {[string bytelength $cinfo] > 150} {
                    set cinfo [string range $cinfo 0 end-1]
                    set ellipsis "..."
                }
                append cinfo $ellipsis [concat "\"\n    (" [_ "'uplevel' body line 1"] ")"]
                append cinfo [concat "\n    " [_ "invoked from within"]]
                append cinfo [concat "\n\"" [_ "uplevel"] " 1 \$args\""]
                #
                # Try each possible form of the stack trace
                # and trim the extra contribution from the matching case
                #
                set expect [concat "$msg\n    " [_ "while executing"] "\n\"$cinfo"]
                if {$errorInfo eq $expect} {
                    #
                    # The stack has only the eval from the expanded command
                    # Do not generate any stack trace here.
                    #
                    return -code error -errorcode $errorCode $msg
                }
                #
                # Stack trace is nested, trim off just the contribution
                # from the extra "eval" of $args due to the "catch" above.
                #
                set expect [concat "\n    " [_ "invoked from within"] "\n\"$cinfo"]
                set exlen [string length $expect]
                set eilen [string length $errorInfo]
                set i [expr {$eilen - $exlen - 1}]
                set einfo [string range $errorInfo 0 $i]
                #
                # For now verify that $errorInfo consists of what we are about
                # to return plus what we expected to trim off.
                #
                if {$errorInfo ne "$einfo$expect"} {
                    error [_ "Tcl bug: unexpected stack trace in 'unknown'"] {} \
                        [list CORE UNKNOWN BADTRACE $expect $errorInfo]
                }
                return -code error -errorcode $errorCode \
                    -errorinfo $einfo $msg
            } else {
                return -code $code $msg
            }
        }
    }

    if {([info level] == 1) && [string equal [info script] ""] \
            && [info exists tcl_interactive] && $tcl_interactive} {
        if {![info exists auto_noexec]} {
            set new [auto_execok $name]
            if {$new != ""} {
                set errorCode $savedErrorCode
                set errorInfo $savedErrorInfo
                set redir ""
                if {[string equal [info commands console] ""]} {
                    set redir ">&@stdout <@stdin"
                }
                return [uplevel 1 exec $redir $new [lrange $args 1 end]]
            }
        }
        set errorCode $savedErrorCode
        set errorInfo $savedErrorInfo
        if {[string equal $name "!!"]} {
            set newcmd [history event]
        } elseif {[regexp {^!(.+)$} $name dummy event]} {
            set newcmd [history event $event]
        } elseif {[regexp {^\^([^^]*)\^([^^]*)\^?$} $name dummy old new]} {
            set newcmd [history event -1]
            catch {regsub -all -- $old $newcmd $new newcmd}
        }
        if {[info exists newcmd]} {
            tclLog $newcmd
            history change $newcmd 0
            return [uplevel 1 $newcmd]
        }

        set ret [catch {set candidates [info commands $name*]} msg]
        if {[string equal $name "::"]} {
            set name ""
        }
        if {$ret != 0} {
            return -code $ret -errorcode $errorCode \
                [concat [_ "error in unknown while checking if '%s' is a unique command abbreviation" $name] ":\n$msg"]
        }
        # Filter out bogus matches when $name contained
        # a glob-special char [Bug 946952]
        set cmds [list]
        foreach x $candidates {
            if {[string range $x 0 [expr [string length $name]-1]] eq $name} {
                lappend cmds $x
            }
        }
        if {[llength $cmds] == 1} {
            return [uplevel 1 [lreplace $args 0 0 $cmds]]
        }
        if {[llength $cmds]} {
            if {[string equal $name ""]} {
                return -code error [concat [_ "empty command name"] " ''"]
            } else {
                return -code error \
                    [concat [_ "ambiguous command name"] " '$name': [lsort $cmds]"]
            }
        }
    }
    return -code error [concat [_ "invalid command name"] " '$name'"]
}


proc SetMenusStates { } {
    #return
    global tcl_platform

    if { $::tcl_platform(platform) == "windows" } {
        if { [ GetCurrentPrePostMode] == "PRE" } {
            SetFilesMenuState
            SetViewMenuState
            SetGeometryMenuState
            SetUtilitiesMenuState
            SetDataMenuState
            SetMeshMenuState
            SetCalculateMenuState            
        } else {
            #MENUS DE POST
        }
    } else {
        #LINUX
    }
    
}

#to source easily a tcl file located in scripts
proc SRC { filename } {
    if  { [string tolower [file extension $filename]] != ".tcl" } {
        set filename $filename.tcl
    }
    return [source [file join $::GIDDEFAULTTCL $filename]]
}

proc SetFilesMenuState { } {
    set menu_name "Files#C#menu"
    set i [ GiDMenu::_FindIndex $menu_name PRE]
    if { $i == -1 } return

    set menuname [ GetMenuName $i]

    if { [lindex [ GiD_Info mesh] 0] == 0 } {
        set color $::GidPriv(Color,DisabledForegroundMenu)
    } else {
        set color black
    }

    # set option_name [list "Postprocess#C#menu"]
    # set position [lindex [split [ GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
    # if { $position != -1 } {
    #         ChangeMenuForegroundColor $menuname $position $color
    # }
}

proc SetViewMenuState { } {
    set menu_name "View#C#menu,verb"
    set i [GiDMenu::_FindIndex $menu_name PRE]
    if { $i == -1 } return

    set menuname [GetMenuName $i]

    set ViewMode [GiD_Info Project ViewMode]

    if { $ViewMode == "GEOMETRYUSE" } {
        set npoints [GiD_Info Geometry NumPoints]
        set nlines [GiD_Info Geometry NumLines]
        set nsurfs [GiD_Info Geometry NumSurfaces]
        set nvols [GiD_Info Geometry NumVolumes]            
    } else {
        set npoints 0
        set nlines 0
        set nsurfs 0
        set nvols 0
    }

    set option_name [list "Label#C#menu"]
    set position [lindex [split [GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
    if { $position != -1 } {
        if { $ViewMode == "GEOMETRYUSE" } {
            ChangeMenuForegroundColor $menuname $position [GetColorTrueFalse $npoints]        
        } elseif { $ViewMode == "MESHUSE" } {
            set nnodes [GiD_Info Mesh NumNodes]
            ChangeMenuForegroundColor $menuname $position [GetColorTrueFalse $nnodes]        
        }
    }

    set option_name [list "Normals#C#menu"]
    set position [lindex [split [GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
    if { $position != -1 } {
        if { $ViewMode == "GEOMETRYUSE" } {
            SetViewNormalsSubMenusState $menuname $position $npoints $nlines $nsurfs $nvols
        } elseif { $ViewMode == "MESHUSE" } {           
            set nlines [GiD_Info Mesh NumElements Linear]
            set nsurfs [expr {[GiD_Info Mesh NumElements Triangle]+[GiD_Info Mesh NumElements Quadrilateral]+[GiD_Info Mesh NumElements Circle]}]           
            ChangeMenuForegroundColor $menuname $position [GetColorTrueFalse [expr $nlines+$nsurfs]]           
        }
    }

    set option_name [list "Higher entities#C#menu"]
    set position [lindex [split [GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
    if { $position != -1 } {
        if { $ViewMode == "GEOMETRYUSE" } {
            SetViewHigherEntitiesSubMenusState $menuname $position $npoints $nlines $nsurfs $nvols
        } elseif { $ViewMode == "MESHUSE" } {        
            set nnodes [GiD_Info Mesh NumNodes]
            ChangeMenuForegroundColor $menuname $position [GetColorTrueFalse $nnodes] 
        }
    }

    set option_name [list "Curvatures#C#menu"]
    set position [lindex [split [GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
    if { $position != -1 } {
        if { $ViewMode == "GEOMETRYUSE" } {
            SetCurvaturesSubMenusState $menuname $position $npoints $nlines $nsurfs $nvols        
        } elseif { $ViewMode == "MESHUSE" } {
            ChangeMenuForegroundColor $menuname $position [GetColorTrueFalse 0]             
        }
    }
}

proc SetCurvaturesSubMenusState { menuname pos npoints nlines nsurfs nvols } {

    ChangeMenuForegroundColor $menuname $pos [GetColorTrueFalse $nlines]    

    set optionstochange [list [_ "Lines#C#menu"] [_ "Surfaces#C#menu"]]

    set submenuname $menuname.$pos
    if { ![winfo exists $submenuname] } {
        return
    }
    if { [$submenuname index end] == "none" } { return }

    set colors(0) [ GetColorTrueFalse $npoints]
    set colors(1) [ GetColorTrueFalse $nlines]
    set colors(2) [ GetColorTrueFalse $nsurfs]
    set colors(3) [ GetColorTrueFalse $nvols]

    set ni [$submenuname index end]
    if { $ni == "none" } { set ni -1 }
    for {set i 0} {$i <= $ni} {incr i} {
        if { [$submenuname type $i] != {command} && [$submenuname type $i] != {cascade} } { continue }
        set option [lsearch $optionstochange [$submenuname entrycget $i -label]]
        if { $option == -1 } continue
        switch $option {
            0 {
                ChangeMenuForegroundColor $submenuname $i $colors(1)
            }
            1 {
                ChangeMenuForegroundColor $submenuname $i $colors(2)
            }
            default { }
        }
    }
}

proc SetViewNormalsSubMenusState { menuname pos npoints nlines nsurfs nvols } {
    ChangeMenuForegroundColor $menuname $pos [GetColorTrueFalse $nlines]   

    set optionstochange [list [_ "Lines#C#menu"] [_ "Surfaces#C#menu"]]

    set submenuname $menuname.$pos
    if { ![winfo exists $submenuname] } {
        return
    }
    if { [$submenuname index end] == "none" } { return }

    set colors(0) [ GetColorTrueFalse $npoints]
    set colors(1) [ GetColorTrueFalse $nlines]
    set colors(2) [ GetColorTrueFalse $nsurfs]
    set colors(3) [ GetColorTrueFalse $nvols]

    set ni [$submenuname index end]
    if { $ni == "none" } { set ni -1 }
    for {set i 0} {$i <= $ni} {incr i} {
        if { [$submenuname type $i] != {command} && [$submenuname type $i] != {cascade} } { continue }
        set option [lsearch $optionstochange [$submenuname entrycget $i -label]]
        if { $option == -1 } continue
        switch $option {
            0 {
                ChangeMenuForegroundColor $submenuname $i $colors(1)
            }
            1 {
                ChangeMenuForegroundColor $submenuname $i $colors(2)
            }
            default { }
        }
    }
}

proc SetViewHigherEntitiesSubMenusState  { menuname pos npoints nlines nsurfs nvols } {
    ChangeMenuForegroundColor $menuname $pos [GetColorTrueFalse $npoints]      

    set optionstochange [list [_ "Points"] [_ "Lines"] [_ "Surfaces"] [_ "All"] ]

    set submenuname $menuname.$pos
    if { ![winfo exists $submenuname] } {
        return
    }
    if { [$submenuname index end] == "none" } { return }

    set colors(0) [ GetColorTrueFalse $npoints]
    set colors(1) [ GetColorTrueFalse $nlines]
    set colors(2) [ GetColorTrueFalse $nsurfs]
    set colors(3) [ GetColorTrueFalse $nvols]

    set ni [$submenuname index end]
    if { $ni == "none" } { set ni -1 }
    for {set i 0} {$i <= $ni} {incr i} {
        if { [$submenuname type $i] != {command} && [$submenuname type $i] != {cascade} } { continue }
        set option [lsearch $optionstochange [$submenuname entrycget $i -label]]
        if { $option == -1 } continue
        switch $option {
            0 {
                ChangeMenuForegroundColor $submenuname $i $colors(0)
            }
            1 {
                ChangeMenuForegroundColor $submenuname $i $colors(1)
            }
            2 {
                ChangeMenuForegroundColor $submenuname $i $colors(2)
            }
            3 {
                ChangeMenuForegroundColor $submenuname $i $colors(0)
            }
            default { }
        }
    }
}

proc GetColorTrueFalse { cond } {
    if { $cond } {
        return black
    } else {
        return $::GidPriv(Color,DisabledForegroundMenu)
    }
}

proc SetGeometryMenuState { } {
    set menu_name "Geometry#C#menu"
    set i [ GiDMenu::_FindIndex $menu_name PRE]
    if { $i == -1 } return

    set menuname [ GetMenuName $i]

    set npoints [ GiD_Info Geometry NumPoints]
    set nlines [ GiD_Info Geometry NumLines]
    set nsurfs [ GiD_Info Geometry NumSurfaces]
    set nvols [ GiD_Info Geometry NumVolumes]

    set option_name [list "Create#C#menu"]
    set position [lindex [split [ GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
    if { $position != -1 } {
        SetGeometryCreateSubMenusState $menuname $position $npoints $nlines $nsurfs $nvols
    }
    
    set colors(0) [ GetColorTrueFalse $npoints]
    
    set option_name [list "View geometry#C#menu"]
    set position [lindex [split [ GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
    if { $position != -1 } {
        ChangeMenuForegroundColor $menuname $position $colors(0)
    }

    set option_name [list "Delete#C#menu"]
    set position [lindex [split [ GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
    if { $position != -1 } {
        SetDeleteGeometrySubMenusState $menuname $position $npoints $nlines $nsurfs $nvols
    }

    set option_name [list "Edit#C#menu"]
    set position [lindex [split [ GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
    if { $position != -1 } {
        SetGeometryEditSubMenusState $menuname $position $npoints $nlines $nsurfs $nvols
    }
}

proc SetGeometryCreateSubMenusState { menuname pos npoints nlines nsurfs nvols } {
    $menuname entryconfigure $pos -foreground black

    set submenuname $menuname.$pos
    if { ![winfo exists $submenuname] } {
        return
    }
    if { [$submenuname index end] == "none" } { return }

    set optionstochange [list [_ "Polyline#C#menu"] [_ "NURBS surface#C#menu"] [_ "Volume#C#menu"]\
                             [_ "Contact#C#menu"] [_ "Arc#C#menu"] [_ "Contact surface#C#menu"] [_ "Surface mesh#C#menu"]\
                             [_ "Geometry from mesh#C#menu"]]

    set colors(0) [ GetColorTrueFalse $npoints]
    set colors(1) [ GetColorTrueFalse $nlines]
    set colors(2) [ GetColorTrueFalse $nsurfs]
    set colors(3) [ GetColorTrueFalse $nvols]
    set nelems [ GiD_Info Mesh NumElements]
    set colors(4) [ GetColorTrueFalse $nelems]
    

    set ni [$submenuname index end]
    if { $ni == "none" } { set ni -1 }
    for {set i 0} {$i <= $ni} {incr i} {
        if { [$submenuname type $i] != {command} && [$submenuname type $i] != {cascade} } { continue }
        set option [lsearch $optionstochange [$submenuname entrycget $i -label]]
        if { $option == -1 } continue
        switch $option {
            0 { ChangeMenuForegroundColor $submenuname $i $colors(1) }
            1 {
                if { !$npoints } {
                    ChangeMenuForegroundColor $submenuname $i $colors(0)
                } else {
                    $submenuname entryconfigure $i -foreground black
                    set subsubmenuname "$submenuname.$i"
                    if { ![winfo exists $subsubmenuname] } {
                        continue
                    }
                    set optionstochange2 [list [_ "By contour#C#menu"] [_ "Automatic#C#menu"] [_ "Trimmed#C#menu"] [_ "Untrimmed#C#menu"] \
                                              [_ "Parallel Lines#C#menu"] [_ "By Points#C#menu"] [_ "By LinePoints#C#menu"] [_ "Search#C#menu"]]
                    set nj [$subsubmenuname index end]
                    if { $nj == "none" } { set nj -1 }
                    for {set j 0} {$j <= $nj} {incr j} {
                        if { [$subsubmenuname type $i] != {command} && [$subsubmenuname type $i] != {cascade} } { continue }
                        set option [lsearch $optionstochange2 [$subsubmenuname entrycget $j -label]]
                        if { $option == -1 } { continue }
                        if { $option == 0 || $option == 1 || $option == 4 || $option == 6 || $option == 7 } {
                            ChangeMenuForegroundColor $subsubmenuname $j $colors(1)
                        } elseif { $option == 2 || $option == 3 } {
                            ChangeMenuForegroundColor $subsubmenuname $j $colors(2)
                        } elseif { $option == 5 } {
                            ChangeMenuForegroundColor $subsubmenuname $j $colors(0)
                        }
                    }
                }
            }
            2 {
                if { !$nsurfs } {
                    ChangeMenuForegroundColor $submenuname $i $colors(2)
                } else {
                    $submenuname entryconfigure $i -foreground black
                    set subsubmenuname "$submenuname.$i"
                    if { ![winfo exists $subsubmenuname] } {
                        continue
                    }
                    set optionstochange2 [list [_ "By contour#C#menu"] [_ "Automatic 6-sided volumes#C#menu"] \
                                              [_ "Search#C#menu"] [_ "Hole#C#menu"]]
                    set nj [$subsubmenuname index end]
                    if { $nj == "none" } { set nj -1 }
                    for {set j 0} {$j <= $nj} {incr j} {
                        if { [$subsubmenuname type $i] != {command} && [$subsubmenuname type $i] != {cascade} } { continue }
                        set option [lsearch $optionstochange2 [$subsubmenuname entrycget $j -label]]
                        if { $option == -1 } { continue }
                        if { $option == 0 || $option == 1 || $option == 2 } {
                            ChangeMenuForegroundColor $subsubmenuname $j $colors(2)
                        } elseif { $option == 3 } {
                            ChangeMenuForegroundColor $subsubmenuname $j $colors(3)
                        }
                    }
                }
            }
            3 {
                if { !$nsurfs } {
                    ChangeMenuForegroundColor $submenuname $i $colors(2)
                } else {
                    $submenuname entryconfigure $i -foreground black
                    set subsubmenuname "$submenuname.$i"
                    if { ![winfo exists $subsubmenuname] } {
                        continue
                    }
                    set optionstochange2 [list [_ "Volume#C#menu"] [_ "Separated volume#C#menu"]]
                    set nj [$subsubmenuname index end]
                    if { $nj == "none" } { set nj -1 }
                    for {set j 0} {$j <= $nj} {incr j} {
                        if { [$subsubmenuname type $i] != {command} && [$subsubmenuname type $i] != {cascade} } { continue }
                        set option [lsearch $optionstochange2 [$subsubmenuname entrycget $j -label]]
                        if { $option == -1 } { continue }
                        ChangeMenuForegroundColor $subsubmenuname $j $colors(2)
                    }
                }
            }
            4 {
                $submenuname entryconfigure $i -foreground black
                set subsubmenuname "$submenuname.$i"
                if { ![winfo exists $subsubmenuname] } {
                    continue
                }
                set optionstochange2 [list [_ "Fillet curves#C#menu"] [_ "By 3 points#C#menu"] ]
                set nj [$subsubmenuname index end]
                if { $nj == "none" } { set nj -1 }
                for {set j 0} {$j <= $nj} {incr j} {
                    if { [$subsubmenuname type $i] != {command} && [$subsubmenuname type $i] != {cascade} } { continue }
                    set option [lsearch $optionstochange2 [$subsubmenuname entrycget $j -label]]
                    if { $option == -1 } { continue }
                    if { $option == 0 } {
                        ChangeMenuForegroundColor $subsubmenuname $j $colors(1)
                    }
                }
            }
            5 { ChangeMenuForegroundColor $submenuname $i $colors(1) }
            6 { ChangeMenuForegroundColor $submenuname $i $colors(4) }
            7 { ChangeMenuForegroundColor $submenuname $i $colors(4) }
            default { }
        }
    }

}

proc SetGeometryEditSubMenusState { menuname pos npoints nlines nsurfs nvols } {

    if { !$npoints } {
        ChangeMenuForegroundColor $menuname $pos $::GidPriv(Color,DisabledForegroundMenu)
        return
    }
    
    $menuname entryconfigure $pos -foreground black
    
    set optionstochange [list [_ "Move point#C#menu"] [_ "Divide#C#menu"] [_ "Join#C#menu"] [_ "Lines operations#C#menu"] \
                             [_ "Swap arc#C#menu"] [_ "Polyline#C#menu"] [_ "SurfMesh#C#menu"] \
                             [_ "Rebuild surface by boundary#C#menu"]  [_ "Edit NURBS#C#menu"] [_ "Convert to NURBS#C#menu"] [_ "Simplify NURBS#C#menu"] \
                             [_ "Hole NURBS surface#C#menu"] [_ "Hole volume#C#menu"] [_ "Collapse#C#menu"] [_ "Uncollapse#C#menu"] \
                             [_ "Intersection#C#menu"] [_ "Surface boolean op.#C#menu"] [_ "Volume boolean op.#C#menu"]]
    
    set submenuname "$menuname.$pos"
    if { [$submenuname index end] == "none" } { return }
    
    set colors(0) [ GetColorTrueFalse $npoints]
    set colors(1) [ GetColorTrueFalse $nlines]
    set colors(2) [ GetColorTrueFalse $nsurfs]
    set colors(3) [ GetColorTrueFalse $nvols]
    
    set ni [$submenuname index end]
    if { $ni == "none" } { set ni -1 }
    for {set i 0} {$i <= $ni} {incr i} {
        if { [$submenuname type $i] != {command} && [$submenuname type $i] != {cascade} } { continue }
        set option [lsearch $optionstochange [$submenuname entrycget $i -label]]
        if { $option == -1 } continue
        switch $option {
            0 { ChangeMenuForegroundColor $submenuname $i $colors(0) }           
            1 { SetDivideSubMenusState $submenuname $i $nlines $nsurfs $nvols }
            2 { ChangeMenuForegroundColor $submenuname $i $colors(2) }
            3 { ChangeMenuForegroundColor $submenuname $i $colors(1) }
            4 { ChangeMenuForegroundColor $submenuname $i $colors(1) }
            5 { ChangeMenuForegroundColor $submenuname $i $colors(1) }
            6 { ChangeMenuForegroundColor $submenuname $i $colors(2) }
            7 { ChangeMenuForegroundColor $submenuname $i $colors(2) }            
            8 { SetEditNurbSubMenusState $submenuname $i $nlines $nsurfs }
            9 { SetLineSurfaceSubMenusState $submenuname $i $nlines $nsurfs }
            10 { SetSimplifySubMenusState $submenuname $i $nlines $nsurfs }
            11 { ChangeMenuForegroundColor $submenuname $i $colors(2) }
            12 { ChangeMenuForegroundColor $submenuname $i $colors(3) }
            13 { SetCollapseGeomMenusState $submenuname $i $npoints $nlines $nsurfs $nvols}            
            14 { SetUnCollapseSubMenusState $submenuname $i $nlines $nsurfs $nvols }
            15 {
                if { !$nlines } {
                    ChangeMenuForegroundColor $submenuname $i $::GidPriv(Color,DisabledForegroundMenu)
                } else {
                    $submenuname entryconfigure $i -foreground black
                    set subsubmenuname $submenuname.$i
                    set optionstochange2 [list [_ "Lines#C#menu"] [_ "Surface-2 points#C#menu"] \
                                              [_ "Surface-lines#C#menu"] [_ "Surfaces#C#menu"]]
                    set nj [$subsubmenuname index end]
                    if { $nj == "none" } { set nj -1 }
                    for {set j 0} {$j <= $nj} {incr j} {
                        if { [$subsubmenuname type $j] != {command} && [$subsubmenuname type $j] != {cascade} } { continue }
                        set option [lsearch $optionstochange2 [$subsubmenuname entrycget $j -label]]
                        if { $option == -1 } { continue }
                        if { $option == 0 } {
                            ChangeMenuForegroundColor $subsubmenuname $j $colors(1)
                        } elseif { $option == 1 || $option == 2 || $option == 3 } {
                            ChangeMenuForegroundColor $subsubmenuname $j $colors(2)
                        }
                    }
                }
            }          
            16 { ChangeMenuForegroundColor $submenuname $i $colors(2) }
            17 { ChangeMenuForegroundColor $submenuname $i $colors(3) }           
            default { }
        }
    }
}

proc SetCollapseGeomMenusState { menuname pos npoints nlines nsurfs nvols } {
    
    if { !$npoints } {
        ChangeMenuForegroundColor $menuname $pos $::GidPriv(Color,DisabledForegroundMenu)
        return
    }

    $menuname entryconfigure $pos -foreground black

    set optionstochange [list [_ "Model"]]
    lappend optionstochange {*}[ GetGeometryLabels]

    set submenuname "$menuname.$pos"
    if { [$submenuname index end] == "none" } { return }

    set colors(0) [ GetColorTrueFalse 1]
    set colors(1) [ GetColorTrueFalse 1]
    set colors(2) [ GetColorTrueFalse $nlines]
    set colors(3) [ GetColorTrueFalse $nsurfs]
    set colors(4) [ GetColorTrueFalse $nvols]

    set ni [$submenuname index end]
    if { $ni == "none" } { set ni -1 }
    for {set i 0} {$i <= $ni} {incr i} {
        if { [$submenuname type $i] != {command} && [$submenuname type $i] != {cascade} } { continue }
        set option [lsearch $optionstochange [$submenuname entrycget $i -label]]
        if { $option == -1 } continue
        ChangeMenuForegroundColor $submenuname $i $colors($option)
    }
}

proc SetUnCollapseSubMenusState { menuname pos nlines nsurfs nvols } {

    if { !$nlines } {
        ChangeMenuForegroundColor $menuname $pos $::GidPriv(Color,DisabledForegroundMenu)
        return
    }

    $menuname entryconfigure $pos -foreground black

    set optionstochange [list [_ "Lines#C#menu"] [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]

    set submenuname $menuname.$pos
    if { [$submenuname index end] == "none" } { return }

    set colors(0) [ GetColorTrueFalse 1]
    set colors(1) [ GetColorTrueFalse $nsurfs]
    set colors(2) [ GetColorTrueFalse $nvols]
    
    set ni [$submenuname index end]
    if { $ni == "none" } { set ni -1 }
    for {set i 0} {$i <= $ni} {incr i} {
        if { [$submenuname type $i] != {command} && [$submenuname type $i] != {cascade} } { continue }
        set option [lsearch $optionstochange [$submenuname entrycget $i -label]]
        if { $option == -1 } { continue }
        ChangeMenuForegroundColor $submenuname $i $colors($option)
    }

}

proc SetDivideSubMenusState {  menuname pos nlines nsurfs nvols } {
    if { !$nlines } {
        ChangeMenuForegroundColor $menuname $pos $::GidPriv(Color,DisabledForegroundMenu)
        return
    }

    $menuname entryconfigure $pos -foreground black
    set submenuname "$menuname.$pos"
    if { [$submenuname index end] == "none" } { return }

    set optionstochange [lrange [ GetGeometryLabels] 1 end]
    lappend optionstochange {*}[list [_ "Polylines"]]
    set statecolors [lrange [ GetGeometryStateColors 1 $nlines $nsurfs $nvols] 1 end]
    lappend statecolors {*}[list [ GetColorTrueFalse $nlines]]
    
    for {set i 0} {$i <= [$submenuname index end]} {incr i} {
        if { [$submenuname type $i] != {command} && [$submenuname type $i] != {cascade} } { continue }
        set option [lsearch $optionstochange [$submenuname entrycget $i -label]]
        if { $option == -1 } continue
        ChangeMenuForegroundColor $submenuname $i [lindex $statecolors $option]
    }
}


proc SetSimplifySubMenusState { menuname pos nlines nsurfs } {
    if { !$nlines } {
        ChangeMenuForegroundColor $menuname $pos $::GidPriv(Color,DisabledForegroundMenu)
        return
    }

    $menuname entryconfigure $pos -foreground black

    set optionstochange [list [_ "Model#C#menu"] [_ "Line#C#menu"] [_ "Surface#C#menu"]]

    set submenuname "$menuname.$pos"
    if { [$submenuname index end] == "none" } { return }

    set colors(0) [ GetColorTrueFalse 1]
    set colors(1) [ GetColorTrueFalse $nlines]
    set colors(2) [ GetColorTrueFalse $nsurfs]

    set ni [$submenuname index end]
    if { $ni == "none" } { set ni -1 }
    for {set i 0} {$i <= $ni} {incr i} {
        if { [$submenuname type $i] != {command} && [$submenuname type $i] != {cascade} } { continue }
        set option [lsearch $optionstochange [$submenuname entrycget $i -label]]
        if { $option == -1 } continue
        ChangeMenuForegroundColor $submenuname $i $colors($option)
    }
}

proc SetLineSurfaceSubMenusState {  menuname pos nlines nsurfs } {
    if { !$nlines } {
        ChangeMenuForegroundColor $menuname $pos $::GidPriv(Color,DisabledForegroundMenu)
        return
    }

    $menuname entryconfigure $pos -foreground black

    set optionstochange [list [_ "Line#C#menu"] [_ "Surface#C#menu"]]

    set submenuname "$menuname.$pos"
    if { [$submenuname index end] == "none" } { return }

    set colors(0) [ GetColorTrueFalse 1]
    set colors(1) [ GetColorTrueFalse $nsurfs]

    set ni [$submenuname index end]
    if { $ni == "none" } { set ni -1 }
    for {set i 0} {$i <= $ni} {incr i} {
        if { [$submenuname type $i] != {command} && [$submenuname type $i] != {cascade} } { continue }
        set option [lsearch $optionstochange [$submenuname entrycget $i -label]]
        if { $option == -1 } continue
        ChangeMenuForegroundColor $submenuname $i $colors($option)
    }
}

proc SetEditNurbSubMenusState {  menuname pos nlines nsurfs } {
    if { !$nlines } {
        ChangeMenuForegroundColor $menuname $pos $::GidPriv(Color,DisabledForegroundMenu)
        return
    }

    $menuname entryconfigure $pos -foreground black

    set optionstochange [list [_ "Line#C#menu"]... [_ "Surface#C#menu"]...]

    set submenuname "$menuname.$pos"
    if { [$submenuname index end] == "none" } { return }

    set colors(0) [ GetColorTrueFalse 1]
    set colors(1) [ GetColorTrueFalse $nsurfs]

    set ni [$submenuname index end]
    if { $ni == "none" } { set ni -1 }
    for {set i 0} {$i <= $ni} {incr i} {
        if { [$submenuname type $i] != {command} && [$submenuname type $i] != {cascade} } { continue }
        set option [lsearch $optionstochange [$submenuname entrycget $i -label]]
        if { $option == -1 } continue
        ChangeMenuForegroundColor $submenuname $i $colors($option)
    }
}

proc SetDeleteGeometrySubMenusState {  menuname pos npoints nlines nsurfs nvols } {

    if { !$npoints } {
        ChangeMenuForegroundColor $menuname $pos $::GidPriv(Color,DisabledForegroundMenu)
        return
    }

    $menuname entryconfigure $pos -foreground black

    set optionstochange [ GetGeometryLabels]
    lappend optionstochange {*}[list [_ "All types"]]

    set submenuname "$menuname.$pos"
    if { [$submenuname index end] == "none" } { return }

    set colors(0) [ GetColorTrueFalse 1]
    set colors(1) [ GetColorTrueFalse $nlines]
    set colors(2) [ GetColorTrueFalse $nsurfs]
    set colors(3) [ GetColorTrueFalse $nvols]
    set colors(4) [ GetColorTrueFalse 1]

    set ni [$submenuname index end]
    if { $ni == "none" } { set ni -1 }
    for {set i 0} {$i <= $ni} {incr i} {
        if { [$submenuname type $i] != {command} && [$submenuname type $i] != {cascade} } { continue }
        set option [lsearch $optionstochange [$submenuname entrycget $i -label]]
        if { $option == -1 } continue
        ChangeMenuForegroundColor $submenuname $i $colors($option)
    }
}

proc SetUtilitiesMenuState { } {
    set menu_name "Utilities#C#menu"
    set i [ GiDMenu::_FindIndex $menu_name PRE]
    if { $i == -1 } return

    set menuname [ GetMenuName $i]

    set npoints [ GiD_Info Geometry NumPoints]
    set nlines [ GiD_Info Geometry NumLines]
    set nsurfs [ GiD_Info Geometry NumSurfaces]
    set nvols [ GiD_Info Geometry NumVolumes]

    set optionstochange [list [list "Copy#C#menu"] \
                             [list "Move#C#menu"] [list "List#C#menu"] [list "Renumber#C#menu"] [list "Id#C#menu"] \
                             [list "Distance#C#menu"] [list "Repair#C#menu"]]

    #     set optionstochange [list [_ "Undo#C#menu"]... [_ "Preferences#C#menu"]... [_ "Layers#C#menu"]... \
        #                                         [_ "Tools#C#menu"] [_ "Copy#C#menu"]... [_ "Move#C#menu"]... \
        #                                         --- [_ "Status#C#menu"]... [_ "List#C#menu"] [_ "Renumber#C#menu"] [_ "Id#C#menu"] \
        #                                         [_ "Signal#C#menu"] [_ "Swap normals#C#menu"] [_ "Distance#C#menu"] \
        #                                         [_ "Dimension#C#menu"] [_ "Repair model#C#menu"]]

    if { [ GiD_Info Project ViewMode] == "MESHUSE" } {
        set color black
        foreach option_name $optionstochange {
            set position [lindex [split [ GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
            if { $position != -1 } {
                ChangeMenuForegroundColor $menuname $position $color
            }
        }
        return
    }

    if { !$npoints } {
        set color $::GidPriv(Color,DisabledForegroundMenu)
        foreach option_name $optionstochange {
            set position [lindex [split [ GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
            if { $position != -1 } {
                ChangeMenuForegroundColor $menuname $position $color
            }
        }
    } else {
        set color black
        foreach option_name $optionstochange {
            set position [lindex [split [ GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
            if { $position != -1 } {
                ChangeMenuForegroundColor $menuname $position $color
            }
        }
    }

}

proc SetSwapNormalsMenuState { w npoints nlines nsurfs nvols } {

    #     set geomlist [ list "$basecommand Lines Select" "$basecommand Surfaces" ]
    #     set geomlistnames [ list [_ "Lines"] [_ "Surfaces"] ]
    #     set meshlist [ list "$basecommand Select" "$basecommand MakeGroupCoherent" "$basecommand SelByNormal"]
    #     set meshlistnames [ list [_ "Select"] [_ "Make coherent"] [_ "Select by normal"]]
    #
    #     set whatuse [ GiD_Info Project ViewMode]
    #     switch $whatuse {
    #         GEOMETRYUSE {
    #             set colors [list black black ]
    #
    #             set nlines [ GiD_Info Geometry NumLines]
    #             set nsurfs [ GiD_Info Geometry NumSurfaces]
    #             set i [lindex [split $w .] end]
    #             set parent [winfo parent $w]
    #             if { !$nlines } {
    #                 $parent entryconfigure $i -foreground $::GidPriv(Color,DisabledForegroundMenu)
    #                 lset colors 0  $::GidPriv(Color,DisabledForegroundMenu)
    #                 lset colors 1  $::GidPriv(Color,DisabledForegroundMenu)
    #             } else {
    #                 $parent entryconfigure $i -foreground black
    #                 lset colors 0  black
    #                 if { $nsurfs } {
    #                     lset colors 1  black
    #                 } else {
    #                     lset colors 1  $::GidPriv(Color,DisabledForegroundMenu)
    #                 }
    #             }
    #
    #             foreach name $geomlistnames i $geomlist col $colors {
    #                 set under [FindUnderChar name UnderLineList]
    #                 if { $name == [_ "Lines"] } {
    #                     $w add command -label $name -underline $under -command "$i" -foreground $col
    #                 } elseif { $name == [_ "Surfaces"] } {
    #                     set id_menu 1
    #                     $w add cascade -label $name -underline $under -menu $w.m$id_menu -foreground $col
    #                     if { [ winfo exists $w.m$id_menu ] } {
    #                         $w.m$id_menu delete 0 end
    #                     } else {
    #                         menu $w.m$id_menu
    #                     }
    #                     set UnderLineList2 {}
    #                     set text [_ "Select"]
    #                     set under [FindUnderChar text UnderLineList2]
    #                     $w.m$id_menu add command -label $text -underline $under -command "$i Select" -foreground $col
    #                     set text [_ "Make coherent"]
    #                     set under [FindUnderChar text UnderLineList2]
    #                     $w.m$id_menu add command -label $text -underline $under -command "$i MakeGroupCoherent" -foreground $col
    #                     set text [_ "Select by normal"]
    #                     set under [FindUnderChar text UnderLineList2]
    #                     $w.m$id_menu add command -label $text -underline $under -command "$i SelByNormal" -foreground $col
    #                 }
    #             }
    #         }
    #         MESHUSE {
    #             set i [lindex [split $w .] end]
    #             set parent [winfo parent $w]
    #             if { [lindex [ GiD_Info Mesh] 0] == 0 } {
    #                 set color $::GidPriv(Color,DisabledForegroundMenu)
    #             } else {
    #                 set color black
    #             }
    #             $parent entryconfigure $i -foreground $color
    #             foreach name $meshlistnames j $meshlist {
    #                 set under [FindUnderChar name UnderLineList]
    #                 $w add command -label $name -underline $under -command $j -foreground $color
    #             }
    #         }
    #     }
}

proc SetDataMenuState { } {

    if { [ GiD_Info Project ProblemType] != "UNKNOWN" } return

    set menu_name "Data#C#menu"
    set i [ GiDMenu::_FindIndex $menu_name PRE]
    if { $i == -1 } return

    set menuname [ GetMenuName $i]

    if { ![winfo exists $menuname] } return

    set colors(0) [ GetColorTrueFalse [expr {[ GiD_Info Project ProblemType] != "UNKNOWN"}]]

    set optionstochange [list [_ "Conditions#C#menu"] [_ "Materials#C#menu"] [_ "Interval data#C#menu"] [_ "Problem data#C#menu"]]
    set ni [$menuname index end]
    if { $ni == "none" } { set ni -1 }
    for {set i 0} {$i <= $ni} {incr i} {
        if { [$menuname type $i] == {command} } {
            if { [lsearch $optionstochange [$menuname entrycget $i -label]] != -1 } {
                ChangeMenuForegroundColor $menuname $i $colors(0)
            }
        }
    }

    if { ![ GiD_Info unitssystems] || ![ModUnitWin::Init .gid.dataunits] } {
        set optionstochange [list [_ "Data units#C#menu"]]
        set ni [$menuname index end]
        if { $ni == "none" } { set ni -1 }
        for {set i 0} {$i <= $ni} {incr i} {
            if { [$menuname type $i] == {command} } {
                if { [lsearch $optionstochange [$menuname entrycget $i -label]] != -1 } {
                    ChangeMenuForegroundColor $menuname $i $colors(0)
                }
            }
        }
    }
}

proc SetMeshMenuState { } {
    set menu_name "Mesh#C#menu"
    set i [ GiDMenu::_FindIndex $menu_name PRE]
    if { $i == -1 } return

    set menuname [ GetMenuName $i]
    
    set npoints [ GiD_Info Geometry NumPoints]
    set nlines [ GiD_Info Geometry NumLines]
    set nsurfs [ GiD_Info Geometry NumSurfaces]
    set nvols [ GiD_Info Geometry NumVolumes]
    
    if { !$npoints } {
        set color $::GidPriv(Color,DisabledForegroundMenu)
        
        set optionstochange [list [list "Unstructured#C#menu"] [list "Structured#C#menu"]\
                                 [list "SemiStructured#C#menu"] [list "Cartesian#C#menu"] \
                                 [list "Element type#C#menu"] [list "Reset mesh data#C#menu"] \
                                 [list "Mesh criteria#C#menu"] [list "Draw#C#menu"] [list "Generate mesh#C#menu"] \
                                 [list "Show errors#C#menu"] [list "Boundary layer#C#menu"]]
        
        foreach option_name $optionstochange {
            set position [lindex [split [ GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
            if { $position != -1 } {
                ChangeMenuForegroundColor $menuname $position $color
            }
        }
    } else {
        set option_name [list "Unstructured#C#menu"]
        set position [lindex [split [ GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
        if { $position != -1 } {
            SetUnstructuredSubMenusState $menuname $position $npoints $nlines $nsurfs $nvols
        }
        
        set option_name [list "Structured#C#menu"]
        set position [lindex [split [ GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
        if { $position != -1 } {
            SetStructuredSubMenusState $menuname $position $nlines $nsurfs $nvols
        }
        
        set option_name [list "SemiStructured#C#menu"]
        if { !$nvols } {
            set color $::GidPriv(Color,DisabledForegroundMenu)
        } else {
            set color black
        }
        set position [lindex [split [ GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
        if { $position != -1 } {
            ChangeMenuForegroundColor $menuname $position $color
        }

        set option_name [list "Cartesian#C#menu"]
        set position [lindex [split [ GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
        if { $position != -1 } {
            SetCartesianSubMenusState $menuname $position $npoints $nlines $nsurfs $nvols
        }
        
        set option_name [list "Boundary layer#C#menu"]
        set position [lindex [split [ GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
        if { $position != -1 } {
            SetBoundaryLayerSubMenusState $menuname $position $nsurfs $nvols
        }
        
        set option_name [list "Element type#C#menu"]
        set position [lindex [split [ GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
        if { $position != -1 } {
            SetElementTypeSubMenusState $menuname $position $nlines $nsurfs $nvols
        }
        
        set color black
        set option_name [list "Reset mesh data#C#menu"]
        set position [lindex [split [ GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
        if { $position != -1 } {
            ChangeMenuForegroundColor $menuname $position $color
        }
        
        set option_name [list "Mesh criteria#C#menu"]
        set position [lindex [split [ GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
        if { $position != -1 } {
            SetMeshCriteriaSubMenusState $menuname $position $npoints $nlines $nsurfs $nvols
        }
        
        set option_name [list "Draw#C#menu"]
        set position [lindex [split [ GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
        if { $position != -1 } {
            SetDrawSubMenusState $menuname $position $npoints $nlines $nsurfs $nvols
        }
        
        set color black
        set option_name [list "Generate mesh#C#menu"]
        set position [lindex [split [ GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
        if { $position != -1 } {
            ChangeMenuForegroundColor $menuname $position $color
        }
    }

    set optionstochange [list [list "Erase mesh#C#menu"] \
                             [list "View mesh boundary#C#menu"] [list "Create boundary mesh#C#menu"] \
                             [list "Mesh quality#C#menu"]]
    if { [lindex [ GiD_Info Mesh] 0] == 0 } {
        set color $::GidPriv(Color,DisabledForegroundMenu)
    } else {
        set color black
    }
    foreach option_name $optionstochange {
        set position [lindex [split [ GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
        if { $position != -1 } {
            ChangeMenuForegroundColor $menuname $position $color
        }
    }

    set option_name [list "Show errors#C#menu"]
    if { ![info exists ::MeshErrorsPriv] ||
         ($::MeshErrorsPriv(ErrSurf,NumErr) == 0 && $::MeshErrorsPriv(ErrVol,NumErr) == 0) } {
        set color $::GidPriv(Color,DisabledForegroundMenu)
    } else {
        set color black
    }
    set position [lindex [split [ GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
    if { $position != -1 } {
        ChangeMenuForegroundColor $menuname $position $color
    }

}

proc SetCartesianSubMenusState {  menuname pos npoints nlines nsurfs nvols } {

    if { !$npoints } {
        ChangeMenuForegroundColor $menuname $pos $::GidPriv(Color,DisabledForegroundMenu)
        return
    }

    $menuname entryconfigure $pos -foreground black

    set optionstochange [ GetGeometryLabels]

    set submenuname "$menuname.$pos"
    if { [$submenuname index end] == "none" } { return }

    set colors(0) [ GetColorTrueFalse 1]
    set colors(1) [ GetColorTrueFalse $nlines]
    set colors(2) [ GetColorTrueFalse $nsurfs]
    set colors(3) [ GetColorTrueFalse $nvols]

    set ni [$submenuname index end]
    if { $ni == "none" } { set ni -1 }
    for {set i 0} {$i <= $ni} {incr i} {
        if { [$submenuname type $i] != {command} && [$submenuname type $i] != {cascade} } { continue }
        set option [lsearch $optionstochange [$submenuname entrycget $i -label]]
        if { $option == -1 } continue
        ChangeMenuForegroundColor $submenuname $i $colors($option)
    }
}

proc SetUnstructuredSubMenusState { menuname pos npoints nlines nsurfs nvols } {

    if { !$npoints } {
        ChangeMenuForegroundColor $menuname $pos $::GidPriv(Color,DisabledForegroundMenu)
        return
    }

    $menuname entryconfigure $pos -foreground black

    set optionstochange [list [_ "Assign sizes on points#C#menu"] [_ "Assign sizes on lines#C#menu"] \
                             [_ "Assign sizes on surfaces#C#menu"] [_ "Assign sizes on volumes#C#menu"] \
                             [_ "Sizes by chordal error#C#menu"]... [_ "Correct sizes#C#menu"]... \
                             [_ "Sizes by background mesh#C#menu"]... [_ "Assign entities#C#menu"]]

    set optionstochange2 [ GetGeometryLabels]

    set submenuname "$menuname.$pos"
    if { [$submenuname index end] == "none" } { return }

    set colors(0) [ GetColorTrueFalse 1]
    set colors(1) [ GetColorTrueFalse $nlines]
    set colors(2) [ GetColorTrueFalse $nsurfs]
    set colors(3) [ GetColorTrueFalse $nvols]
    set colors(4) [ GetColorTrueFalse 1]
    set colors(5) [ GetColorTrueFalse 1]
    set colors(6) [ GetColorTrueFalse 1]

    set ni [$submenuname index end]
    if { $ni == "none" } { set ni -1 }
    for {set i 0} {$i <= $ni} {incr i} {
        if { [$submenuname type $i] != {command} && [$submenuname type $i] != {cascade} } { continue }
        set option [lsearch $optionstochange [$submenuname entrycget $i -label]]
        if { $option == -1 } { continue }
        if { $option < 7 } {
            ChangeMenuForegroundColor $submenuname $i $colors($option)
        } else {
            if { !$nlines && !$nsurfs && !$nvols } {
                ChangeMenuForegroundColor $submenuname $i $::GidPriv(Color,DisabledForegroundMenu)
            } else {
                $submenuname entryconfigure $i -foreground black
                set subsubmenuname "$submenuname.$i"
                set nj [$subsubmenuname index end]
                if { $nj == "none" } { set nj -1 }
                for {set j 0} {$j <= $nj} {incr j} {
                    if { [$subsubmenuname type $i] != {command} && [$subsubmenuname type $i] != {cascade} } { continue }
                    set option [lsearch $optionstochange2 [$subsubmenuname entrycget $j -label]]
                    if { $option == -1 } { continue }
                    ChangeMenuForegroundColor $subsubmenuname $j $colors($option)
                }
            }
        }
    }

}

proc SetBoundaryLayerSubMenusState {  menuname pos nsurfs nvols } {

    if { !$nsurfs } {
        ChangeMenuForegroundColor $menuname $pos $::GidPriv(Color,DisabledForegroundMenu)
        return
    }

    $menuname entryconfigure $pos -foreground black

    set optionstochange [list [_ "2D#C#menu"] [_ "3D#C#menu"] [_ "Reset#C#menu"]]

    set submenuname "$menuname.$pos"
    if { [$submenuname index end] == "none" } { return }
    
    set colors(0) [ GetColorTrueFalse 1]
    set colors(1) [ GetColorTrueFalse $nvols]
    set colors(2) [ GetColorTrueFalse 1]
    
    set ni [$submenuname index end]
    if { $ni == "none" } { set ni -1 }
    for {set i 0} {$i <= $ni} {incr i} {
        if { [$submenuname type $i] != {command} && [$submenuname type $i] != {cascade} } { continue }
        set option [lsearch $optionstochange [$submenuname entrycget $i -label]]
        if { $option == -1 } { continue }
        ChangeMenuForegroundColor $submenuname $i $colors($option)
    }

}

proc SetStructuredSubMenusState {  menuname pos nlines nsurfs nvols } {

    if { !$nlines } {
        ChangeMenuForegroundColor $menuname $pos $::GidPriv(Color,DisabledForegroundMenu)
        return
    }

    $menuname entryconfigure $pos -foreground black
    
    set submenuname "$menuname.$pos"
    if { [$submenuname index end] == "none" } { return }

    set optionstochange [lrange [ GetGeometryLabels] 1 end]
    set statecolors [lrange [ GetGeometryStateColors 1 $nlines $nsurfs $nvols] 1 end]
    
    set ni [$submenuname index end]
    if { $ni == "none" } { set ni -1 }
    for {set i 0} {$i <= $ni} {incr i} {
        if { [$submenuname type $i] != {command} && [$submenuname type $i] != {cascade} } { continue }
        set option [lsearch $optionstochange [$submenuname entrycget $i -label]]
        if { $option == -1 } { continue }
        ChangeMenuForegroundColor $submenuname $i [lindex $statecolors $option]
    }

}

proc SetElementTypeSubMenusState { menuname pos nlines nsurfs nvols } {

    if { !$nlines } {
        ChangeMenuForegroundColor $menuname $pos $::GidPriv(Color,DisabledForegroundMenu)
        return
    }

    $menuname entryconfigure $pos -foreground black

    set optionstochange [list [_ "Default#C#menu"] [_ "Linear#C#menu"] [_ "Triangle#C#menu"] \
                             [_ "Quadrilateral#C#menu"] [_ "Tetrahedra#C#menu"] [_ "Hexahedra#C#menu"] \
                             [_ "Prism#C#menu"] [_ "Only points#C#menu"] [_ "Sphere#C#menu"] [_ "Circle#C#menu"] ]

    set submenuname $menuname.$pos
    if { [$submenuname index end] == "none" } { return }

    set optionstochange2 [lrange [ GetGeometryLabels] 1 end]
    set statecolors [lrange [ GetGeometryStateColors 1 $nlines $nsurfs $nvols] 1 end]

    set ni [$submenuname index end]
    if { $ni == "none" } { set ni -1 }
    for {set i 0} {$i <= $ni} {incr i} {
        if { [$submenuname type $i] != {command} && [$submenuname type $i] != {cascade} } { continue }
        set option [lsearch $optionstochange [$submenuname entrycget $i -label]]
        if { $option == -1 } { continue }
        if { $option == 0} {
            #Default
            $submenuname entryconfigure $i -foreground [ GetColorTrueFalse $nsurfs]
            set subsubmenuname $submenuname.$i
            set nj [$subsubmenuname index end]
            if { $nj == "none" } { set nj -1 }
            for {set j 0} {$j <= $nj} {incr j} {
                if { [$subsubmenuname type $i] != {command} && [$subsubmenuname type $i] != {cascade} } { continue }
                set option [lsearch $optionstochange2 [$subsubmenuname entrycget $j -label]]
                if { $option == -1 } { continue }
                ChangeMenuForegroundColor $subsubmenuname $j [lindex $statecolors $option]
            }
        } elseif { $option == 1} {
            #Linear
            if { !$nsurfs } {
                ChangeMenuForegroundColor $submenuname $i [lindex $statecolors $option]
                continue
            }
            $submenuname entryconfigure $i -foreground black
            set subsubmenuname "$submenuname.$i"
            set nj [$subsubmenuname index end]
            if { $nj == "none" } { set nj -1 }
            for {set j 0} {$j <= $nj} {incr j} {
                if { [$subsubmenuname type $i] != {command} && [$subsubmenuname type $i] != {cascade} } { continue }
                set option [lsearch $optionstochange2 [$subsubmenuname entrycget $j -label]]
                if { $option == -1 } { continue }
                ChangeMenuForegroundColor $subsubmenuname $j [lindex $statecolors $option]
            }
        } elseif { $option == 2 || $option == 3 || $option == 9} {
            #surface elements
            set option [lsearch $optionstochange2 [_ "Surfaces"]]
            ChangeMenuForegroundColor $submenuname $i [lindex $statecolors $option]
        } else {
            #volume elements
            set option [lsearch $optionstochange2 [_ "Volumes"]]
            ChangeMenuForegroundColor $submenuname $i [lindex $statecolors $option]
        }
    }
}

proc SetMeshCriteriaSubMenusState { menuname pos npoints nlines nsurfs nvols } {

    if { !$npoints } {
        ChangeMenuForegroundColor $menuname $pos $::GidPriv(Color,DisabledForegroundMenu)
        return
    }

    $menuname entryconfigure $pos -foreground black

    set optionstochange [list [_ "Default#C#menu"] [_ "Mesh#C#menu,verb"] [_ "No mesh#C#menu,verb"] [_ "Default mesh#C#menu,verb" ] \
                             [_ "Skip#C#menu"] [_ "No skip#C#menu"] [_ "Automatic skip#C#menu"] [_ "Skip by...#C#menu"] [_ "Force points to#C#menu"] \
                             [_ "Duplicate#C#menu"] [_ "No Duplicate#C#menu"] ]
    set optionstochange2 [ GetGeometryLabels]
    lappend optionstochange2 {*}[list [_ "Surface mesh"]]
    if { $::GidPriv(HideVolumeLevel)==0 } {
        lappend optionstochange2 {*}[list [_ "Volume mesh"]]
    }

    set submenuname "$menuname.$pos"
    if { [$submenuname index end] == "none" } { return }

    
    set statecolors [ GetGeometryStateColors $npoints $nlines $nsurfs $nvols]
    lappend statecolors {*}[list [ GetColorTrueFalse $nsurfs]]
    if { $::GidPriv(HideVolumeLevel)==0 } {
        lappend statecolors {*}[list [ GetColorTrueFalse $nvols]]
    }

    set ni [$submenuname index end]
    if { $ni == "none" } { set ni -1 }
    for {set i 0} {$i <= $ni} {incr i} {
        if { [$submenuname type $i] != {command} && [$submenuname type $i] != {cascade} } { continue }
        set option [lsearch $optionstochange [$submenuname entrycget $i -label]]
        if { $option == -1 } { continue }
        if  { $option ==1 || $option ==2 || $option ==3 || $option ==9 || $option ==10 } {
            if { !$nlines } {
                ChangeMenuForegroundColor $submenuname $i $::GidPriv(Color,DisabledForegroundMenu)
                continue
            }
        }
        if  { $option ==7 } {#this is not cascade menu
            ChangeMenuForegroundColor $submenuname $i [ GetColorTrueFalse $nsurfs]
            continue
        }
        if  { $option ==8 } {
            if { !$nsurfs } {
                ChangeMenuForegroundColor $submenuname $i $::GidPriv(Color,DisabledForegroundMenu)
                continue
            }
        }
        $submenuname entryconfigure $i -foreground black
        set subsubmenuname "$submenuname.$i"
        set nj [$subsubmenuname index end]
        if { $nj == "none" } { set nj -1 }
        for {set j 0} {$j <= $nj} {incr j} {
            if { [$subsubmenuname type $j] != {command} && [$subsubmenuname type $j] != {cascade} } { continue }
            set option [lsearch $optionstochange2 [$subsubmenuname entrycget $j -label]]
            if { $option == -1 } { continue }
            ChangeMenuForegroundColor $subsubmenuname $j [lindex $statecolors $option]
        }
    }

}

proc SetDrawSubMenusState { menuname pos npoints nlines nsurfs nvols} {

    if { !$npoints } {
        ChangeMenuForegroundColor $menuname $pos $::GidPriv(Color,DisabledForegroundMenu)
        return
    }

    $menuname entryconfigure $pos -foreground black

    set submenuname "$menuname.$pos"
    if { [$submenuname index end] == "none" } { return }

    set optionstochange [list [_ "Sizes#C#menu"] [_ "Num of divisions#C#menu"] \
                             [_ "Element type#C#menu"] [_ "Mesh / No mesh#C#menu,verb"] \
                             [_ "Structured type#C#menu"] [_ "Skip entities (Rjump)#C#menu"] [_ "Duplicate#C#menu"] \
                             [_ "Force points to#C#menu"] [_ "Boundary layer#C#menu"]]
    
    set statecolors [ GetGeometryStateColors $npoints $nlines $nsurfs $nvols]
    
    set ni [$submenuname index end]
    if { $ni == "none" } { set ni -1 }
    for {set i 0} {$i <= $ni} {incr i} {
        if { [$submenuname type $i] != {command} && [$submenuname type $i] != {cascade} } { continue }
        set option [lsearch $optionstochange [$submenuname entrycget $i -label]]
        if { $option == -1 } { continue }
        if { $option == 0 } {
            #Sizes submenu is treated in DrawSize
            $submenuname entryconfigure $i -foreground black
            set subsubmenuname $submenuname.$i
            SetDrawSizeSubMenuState $subsubmenuname $npoints $nlines $nsurfs $nvols
        } elseif { $option == 1 } {
            #Num of divisions
        } elseif { $option == 2 } {
            #Element Type            
            $submenuname entryconfigure $i -foreground [lindex $statecolors 0]
            set subsubmenuname $submenuname.$i
            SetDrawElementTypeSubMenuState $subsubmenuname $npoints $nlines $nsurfs $nvols
        } elseif { $option == 3 } {
            #Mesh / No mesh
            ChangeMenuForegroundColor $submenuname $i [lindex $statecolors 0]
            set subsubmenuname $submenuname.$i
            SetDrawMeshNoMeshSubMenuState $subsubmenuname $npoints $nlines $nsurfs $nvols
        } elseif { $option == 4 } {
            #Structured type
            ChangeMenuForegroundColor $submenuname $i [lindex $statecolors 0]
            set subsubmenuname $submenuname.$i
            SetDrawStructuredTypeSubMenuState $subsubmenuname $npoints $nlines $nsurfs $nvols
        } elseif { $option == 5 } {
            #Skip entities (Rjump)
            ChangeMenuForegroundColor $submenuname $i [lindex $statecolors 0]
        } elseif { $option == 6 } {
            #Duplicate
            ChangeMenuForegroundColor $submenuname $i [lindex $statecolors 1]
        } elseif { $option == 7 } {
            #Force points to
            set subsubmenuname $submenuname.$i
            SetDrawForcePointsToMeshSubMenuState $subsubmenuname $npoints $nlines $nsurfs $nvols
        } elseif { $option == 8 } {
            #Boundary layer
            ChangeMenuForegroundColor $submenuname $i [lindex $statecolors 2]
            #             set subsubmenuname $submenuname.$i
            #             SetDrawBoundaryLayerMeshSubMenuState $subsubmenuname $npoints $nlines $nsurfs $nvols
        }
    }
}

proc SetDrawElementTypeSubMenuState { submenuname npoints nlines nsurfs nvols } {
    set optionstochange [lrange [ GetGeometryLabels] 1 end]
    lappend optionstochange {*}[list [_ "All types"]]    
    set statecolors [lrange [ GetGeometryStateColors $npoints $nlines $nsurfs $nvols] 1 end]
    lappend statecolors [ GetColorTrueFalse [expr {$npoints+$nlines+$nsurfs+$nvols}]]
    
    set ni [$submenuname index end]
    if { $ni == "none" } { set ni -1 }
    for {set i 0} {$i <= $ni} {incr i} {
        if { [$submenuname type $i] != {command} && [$submenuname type $i] != {cascade} } { continue }
        set option [lsearch $optionstochange [$submenuname entrycget $i -label]]
        if { $option == -1 } { continue }
        ChangeMenuForegroundColor $submenuname $i [lindex $statecolors $option]
    }
}

proc SetDrawStructuredTypeSubMenuState { submenuname npoints nlines nsurfs nvols } {
    set optionstochange [lrange [ GetGeometryLabels] 1 end]
    lappend optionstochange {*}[list [_ "All types"]]    
    set statecolors [lrange [ GetGeometryStateColors $npoints $nlines $nsurfs $nvols] 1 end]
    lappend statecolors [ GetColorTrueFalse [expr {$npoints+$nlines+$nsurfs+$nvols}]]
    
    set ni [$submenuname index end]
    if { $ni == "none" } { set ni -1 }
    for {set i 0} {$i <= $ni} {incr i} {
        if { [$submenuname type $i] != {command} && [$submenuname type $i] != {cascade} } { continue }
        set option [lsearch $optionstochange [$submenuname entrycget $i -label]]
        if { $option == -1 } { continue }
        ChangeMenuForegroundColor $submenuname $i [lindex $statecolors $option]
    }
}

proc SetDrawSizeSubMenuState { submenuname npoints nlines nsurfs nvols } {
    if { [ GiD_Info Project BackgroundFilename] != "" } {
        return
    }
    
    set optionstochange [ GetGeometryLabels]
    lappend optionstochange {*}[list [_ "All types"]]    
    set statecolors [ GetGeometryStateColors $npoints $nlines $nsurfs $nvols]
    lappend statecolors [ GetColorTrueFalse [expr {$npoints+$nlines+$nsurfs+$nvols}]]
    
    set ni [$submenuname index end]
    if { $ni == "none" } { set ni -1 }
    for {set i 0} {$i <= $ni} {incr i} {
        if { [$submenuname type $i] != {command} && [$submenuname type $i] != {cascade} } { continue }
        set option [lsearch $optionstochange [$submenuname entrycget $i -label]]
        if { $option == -1 } { continue }
        ChangeMenuForegroundColor $submenuname $i [lindex $statecolors $option]
    }
}

proc SetDrawMeshNoMeshSubMenuState { submenuname npoints nlines nsurfs nvols } {  
    set optionstochange [ GetGeometryLabels]
    lappend optionstochange {*}[list [_ "All types"]]
    set statecolors [ GetGeometryStateColors $npoints $nlines $nsurfs $nvols]
    lappend statecolors [ GetColorTrueFalse [expr {$npoints+$nlines+$nsurfs+$nvols}]]
    
    set ni [$submenuname index end]
    if { $ni == "none" } { set ni -1 }
    for {set i 0} {$i <= $ni} {incr i} {
        if { [$submenuname type $i] != {command} && [$submenuname type $i] != {cascade} } { continue }
        set option [lsearch $optionstochange [$submenuname entrycget $i -label]]
        if { $option == -1 } { continue }
        ChangeMenuForegroundColor $submenuname $i [lindex $statecolors $option]
    }
}

proc SetDrawForcePointsToMeshSubMenuState { submenuname npoints nlines nsurfs nvols } {
    set optionstochange [list [_ "Surface mesh"]]
    set statecolors [list [ GetColorTrueFalse $nsurfs]]
    if { $::GidPriv(HideVolumeLevel)==0 } {
        lappend optionstochange {*}[list [_ "Volume mesh"]]
        lappend statecolors {*}[list [ GetColorTrueFalse $nvols]]
    }    
    
    set ni [$submenuname index end]
    if { $ni == "none" } { set ni -1 }
    for {set i 0} {$i <= $ni} {incr i} {
        if { [$submenuname type $i] != {command} && [$submenuname type $i] != {cascade} } { continue }
        set option [lsearch $optionstochange [$submenuname entrycget $i -label]]
        if { $option == -1 } { continue }
        ChangeMenuForegroundColor $submenuname $i [lindex $statecolors $option]
    }
}

# proc SetDrawBoundaryLayerMeshSubMenuState { w npoints nlines nsurfs nvols } {
# }

proc SetCalculateMenuState { } {
    set menu_name "Calculate#C#menu"
    set i [ GiDMenu::_FindIndex $menu_name PRE]
    if { $i == -1 } return

    set menuname [ GetMenuName $i]

    if { ![info exists ::RunProcInfo] || $::RunProcInfo == "" } {
        set color $::GidPriv(Color,DisabledForegroundMenu)
    } else {
        set color black
    }
    set option_name [list "Cancel process#C#menu"]
    set position [lindex [split [ GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
    if { $position != -1 } {
        ChangeMenuForegroundColor $menuname $position $color
    }

    if { [PWFIndOutputFilenameCurrent] == "" } {
        set color $::GidPriv(Color,DisabledForegroundMenu)
    } else {
        set color black
    }
    set option_name [list "View process info#C#menu"]
    set position [lindex [split [ GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
    if { $position != -1 } {
        ChangeMenuForegroundColor $menuname $position $color
    }

    if { [ GiD_Info Project ProblemType] == "UNKNOWN" } {
        set color $::GidPriv(Color,DisabledForegroundMenu)
    } else {
        set color black
    }
    set option_name [list "Calculate window#C#menu"]
    set position [lindex [split [ GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
    if { $position != -1 } {
        ChangeMenuForegroundColor $menuname $position $color
    }

    if { [lindex [ GiD_Info Mesh] 0] == 0 || [lindex [ GiD_Info Mesh] 0] == 0 } {
        set color $::GidPriv(Color,DisabledForegroundMenu)
    } else {
        set color black
    }
    set option_name [list "Calculate#C#menu"]
    set position [lindex [split [ GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
    if { $position != -1 } {
        ChangeMenuForegroundColor $menuname $position $color
    }

    set option_name [list "Calculate remote#C#menu"]
    set position [lindex [split [ GiDMenu::_FindOptionIndex $i $option_name PRE] ,] end]
    if { $position != -1 } {
        ChangeMenuForegroundColor $menuname $position $color
    }
}

#changes also children's color recursivelly
proc ChangeMenuForegroundColor { menuname pos color } {

    if { [$menuname type $pos] == {separator} } {
        return
    }

    $menuname entryconfigure $pos -foreground $color
    if { [$menuname type $pos] == {cascade} } {
        set submenuname [$menuname entrycget $pos -menu]
        set ni [$submenuname index end]
        if { $ni == "none" } { set ni -1 }
        for {set i 0} {$i <= $ni} {incr i} {
            ChangeMenuForegroundColor $submenuname $i $color
        }
    }
}

proc OpenNotes { } {
    package require texteditor
    set modelname [ GiD_Info Project ModelName]
    if  { $modelname == "UNNAMED" } {
        #WarnWin [_ "A project title is needed. Save project to get it"]
        set filename ""
    } else {
        set name [file tail $modelname]
        set filename [file join $modelname.gid $name.txt]
    }
    set w .gid.texteditor
    if { $filename != "" } {
        if { [file exists $filename] } {
            TextEditor::Create $filename "" "" 1 $w utf-8
        } else {
            TextEditor::Create "" "" "" 1 $w utf-8
            set TextEditor::currentfile $filename ;#to save with this name
            wm title $w $filename
        }
    } else {
        TextEditor::Create "" "" "" 1 $w utf-8
        TextEditor::ReadFromVariable
        set TextEditor::cansavetovariable 1 ;#to temporary store in a tcl variable
    }
}

proc CloseNotes { } {
    GidUtils::CloseWindow NOTES
}

proc GetNotes { } {
    set txt ""
    if { [info exists TextEditor::vartosave] && $TextEditor::vartosave != "" } {
        set txt $TextEditor::vartosave
    } else {
        set modelname [ GiD_Info Project ModelName]
        if  { $modelname != "UNNAMED" } {
            set name [file tail $modelname]
            set filename [file join $modelname.gid $name.txt]
            if { [file exists $filename] } {
                set fp [open $filename r]
                if { $fp != "" } {
                    set txt [read $fp]
                    close $fp
                }
            }
        }
    }
    return $txt
}

proc SetNotes { txt } {
    package require texteditor
    set TextEditor::vartosave $txt
    GiD_ModifiedFileFlag set 1
}

proc AreNotesVisible { } {
    set w .gid.texteditor
    if { [winfo exists $w] } {
        return 1
    } else {
        return 0
    }
}

proc RecursiveChangeState {w {what "restore"}} {
    if { ![winfo exists $w] } return
    set class [winfo class $w]
    if { [lsearch -sorted {ComboBox} $class] != -1 } {
        #it is not necessary recurse its childs 
    } else {
        foreach i [winfo children $w] {
            RecursiveChangeState $i $what
        }    
    }
    if { [lsearch -sorted {Frame Gidscale Menu NoteBook Panedwindow Scrollbar TFrame TLabelframe TScale Toplevel Tree} $class] != -1 } {
        #Tree really has -state, but its child canvas has been changed just before, and implicilty changed Tree state also
        #then it is and error store its previous state, because was just changed
    } else {
        set fail [catch {
                if {$what eq "restore"} {
                    if { [info exists ::Gid_ChangeState($w)] } {
                        $w configure -state $::Gid_ChangeState($w)
                    }
                } else {
                    set ::Gid_ChangeState($w) [$w cget -state]
                    $w configure -state $what
                }
            } msg]
        if { $fail } {
            #WarnWinText "FAIL $w [winfo class $w] $msg"
        }
    }
}

proc FinishButton { w win text endaction disable {small 0} } {
    if { ![winfo exists $w] } {
        return
    }
    if { $small } {
        if { [winfo exists $w] && [winfo class $w] != "Toplevel" } {
            set small 0
        }
    }

    if { $small } {
        set w2 .gid.finish
        toplevel $w2
        wm transient $w2 .gid
        if { $::tcl_platform(platform) == "windows" } {
            AddAlwaysOnTopFlag $w2
        }
        wm title $w2 [wm title $w]
        scan [wm geometry $w] "%dx%d+%d+%d" width height x y
        if { ![regexp {[+]} $x] } { set x +$x}
        if { ![regexp {[+]} $y] } { set y +$y}
        wm geometry $w2 $x$y
        wm protocol $w2 WM_DELETE_WINDOW [list EndFinishButton $w $endaction $small]
        wm minsize $w2 50 25
        if { [winfo exists $w2.finf] } {
            destroy $w2.finf
        }
        ttk::frame $w2.finf -style ridge.TFrame -borderwidth 2
        ttk::button $w2.finf.f -text [_ "Finish"] \
            -command [list EndFinishButton $w $endaction $small]
        ttk::label $w2.finf.l -text $text
        grid $w2.finf.f $w2.finf.l -sticky ew -padx 2
        #grid configure $w2.finf.f -sticky w
        grid columnconf $w2.finf 1 -weight 1
        grid $w2.finf -sticky nsew -columnspan 2
        grid columnconf $w2 0 -weight 1
        grid rowconfig $w2 0 -weight 1
        wm withdraw $w
    } else {
        set w2 $w
        if { [winfo exists $w2.finf] } {
            destroy $w2.finf
        }
        ttk::frame $w2.finf
        ttk::button $w2.finf.f -text [_ "Finish"] \
            -command [list EndFinishButton $w $endaction $small]
        ttk::label $w2.finf.l -text $text
        pack $w.finf.f $w.finf.l -side left -padx 16 -pady 4
        set rely 0.8
        if { [ esMac]} {
            set rely 1.0
        }
        if { $win != ""} {
	    # when layers window is inside gid, then win == "", no finishbutton           
	    place $w2.finf -in $win -x 0 -rely $rely -anchor sw -bordermode outside
	}
        if { $disable == "disableall" } {
            RecursiveChangeState $w disabled
        }
        $w2.finf.f configure -state normal
    }
    if { ![ esMac]} {
        focus $w2.finf.f
    } else {
        focus .gid
    }

    bind $w2 <Escape> [list EndFinishButton $w $endaction $small]
    bind $w2 <Return> [list EndFinishButton $w $endaction $small]
    delayedop changefunc [list EndFinishButton $w $endaction $small]
}

proc EndFinishButton { w endaction small } {
    set found [delayedop -cancel changefunc "$w.finf.f invoke"]
    GiD_Process Mescape

    if { $small } {
        set w2 .gid.finish
        if { [winfo exists $w2] } {
            scan [wm geometry $w2] "%dx%d+%d+%d" width height x y
            if { ![regexp {[+]} $x] } { set x +$x}
            if { ![regexp {[+]} $y] } { set y +$y}
            destroy $w2
            wm geometry $w $x$y
        }
        wm deiconify $w
    } else {
        destroy $w.finf
        RecursiveChangeState $w restore
        array unset ::Gid_ChangeState
    }
    if { $endaction != "" } { eval $endaction }
}


#to centralize this name, because change between platforms, and also if menu is outside
#i index 0 ... n
proc GetMenuName { i } {
    if { $::GidPriv(MenuType) == "native" } {
        if { [winfo toplevel .gid.menu] == ".gid" } {
            set menuname .mm1.button$i
        } else {
            set menuname .gid.menu.mm1.button$i
        }
    } else {
        # use "generic" menus
        set menuname .gid.menu.button$i.m.m
    }
    return $menuname
}

proc WatchBitmaps {name index op} {
    if {$index eq "PrePostBitmapsWindowGeom"}  {
        WarnWinText $::GidPriv($index)
    }
}

#define this functions here instead Layers.tcl because can be used before source Layers.tcl
proc CreateLayerCombo { w } {
    global GidPriv

    ttk::frame $w.f -borderwidth 0 -style ForcedFrame 
    #-relief ridge
    ttk::entry $w.e -cursor arrow -style ForcedCombobox
    # -justify center -style IconButtonWithMenu
    
    bind $w.e <Enter> {
        %W state pressed 
    }
    bind $w.e <Leave> {
        %W state !pressed 
    }
        
    grid $w.f -sticky ew
    grid $w.e -in $w.f -sticky ew
    grid rowconfigure $w 0 -weight 1
    
    bind $w.e <ButtonPress-1> "[list open_layers_as_menu .gid $w.f]; break"
    bind $w.e <ButtonRelease-1> "break"
    bind $w.e <KeyPress> "break"
    bind $w.e <Key-Down> "[list open_layers_as_menu .gid $w.f]; break"

    set GidPriv(ComboLayers,entry) $w.e    
    $w.e insert end [ GiD_Info Project LayerToUse]
    return
}

proc set_layers_menu_size { tbl w {x ""} {y ""} } {
    set width 2
    foreach c [$tbl column list] {
        incr width [$tbl column neededwidth $c]
    }
    
    set nrows [$tbl item count]
    if { ![$tbl cget -showroot] } {
        incr nrows -1
    }
    if { $nrows > 25 } {
        set nrows 25
        incr width 17 ;#for vertical scrollbar, to avoid horizontal one
    }
    #-----
    #dangerous depends on ttk theme
    set headerheight 12
    #-----
    set itemheight [$tbl cget -itemheight]
    set height [expr {$headerheight+($nrows+1)*$itemheight+2}]
    
    if { $x != ""  && $y != "" } {
        wm geometry $w ${width}x${height}+${x}+$y
    } else {
        wm geometry $w ${width}x${height}
    }
}

proc open_layers_as_menu { parent open_over } {
    global GidPriv

    set w $parent.m
    if { [winfo exists $w] } {
        destroy $w
        return
    }
    set w [toplevel $parent.m -borderwidth 1 -relief raised]

    wm withdraw $w
    wm overrideredirect $w 1
    set orient "horizontal"
    if { $orient == "vertical" } {
        set x [expr {[winfo rootx $open_over]+[winfo width $open_over]}]
        set y [expr {[winfo rooty $open_over]}]
    } else {
        set x [expr {[winfo rootx $open_over]}]
        set y [expr {[winfo rooty $open_over]+[winfo height $open_over]}]
    }

    ttk::frame $w.gg
    set tbl [LayersCreateListWin $w.gg]
    set GidPriv(ComboLayers,table) $tbl

    FillTableInfoLayers $tbl
    
    set_layers_menu_size $tbl $w $x $y

    focus $tbl
    SetLayerAsSelection $tbl [ GiD_Info Project LayerToUse]

    bind $tbl <Double-Button-1> "+after idle destroy $w"

    bind $w <Destroy> [list +DestroyComboLayers %W $w]

    grid $w.gg - -sticky nsew -pady 0
    grid columnconfigure $w 0 -weight 1
    grid rowconfigure $w 0 -weight 1

    bind $w <Escape> [list destroy $w]
    bind $w <1> [list _layers_destroy_if_outside $w %X %Y]
    tkTabToWindow $w.gg

    update idletasks
    wm deiconify $w
    update
    if { ![winfo exists $w] } { return }
    grab $w.gg
}

proc DestroyComboLayers { W w } {
    if { $W == $w } {
        unset -nocomplain ::GidPriv(ComboLayers,table)
    }
}

proc _layers_destroy_if_outside { w x y } {
    if { ![winfo exists $w] } { return }
    if { $x < [winfo rootx $w] || $x > [winfo rootx $w]+[winfo width $w] || \
             $y < [winfo rooty $w] || $y > [winfo rooty $w]+[winfo height $w] } {
        open_layers_as_menu [winfo parent $w] [winfo parent $w]
    }
}

proc PostGraphCoordinates { w } {
    set MenuEntriesP(5,10,0) [list [_ "Cartesian#C#menu"] [_ "Polar#C#menu"]]
    set MenuCommandsP(5,10,0) [list \
                                   [ list GiD_Process Mescape Results Graphs OptionsGraph CoordType Cartesian ] \
                                   [ list GiD_Process Mescape Results Graphs OptionsGraph CoordType Polar]]

    set lst_img [ list [ IconoCoordCart] [ IconoCoordPolar]]

    #set lst_img [ list  $::GidPriv(VerifNoImage) $::GidPriv(VerifNoImage)]

    $w delete 0 end
    set idx 0
    set UnderLineList {}
    foreach entrada $MenuEntriesP(5,10,0) comando $MenuCommandsP(5,10,0) img $lst_img {
        set under [FindUnderChar entrada UnderLineList]
        if { [ info exists MenuEntriesP(5,10,0,$idx)]} {
            set m $w.mm$idx
            if { ![ winfo exists $w.mm$idx]} {
                menu $m
            }
            $w add cascade -label $entrada -underline $under -image $img -compound left \
                -menu $m
            regsub -all {%W} $comando $m cmd
            regsub -all {%I} $cmd $idx cmd
            regsub -all {%X} $cmd [ winfo pointerx .gid] cmd
            regsub -all {%Y} $cmd [ winfo pointery .gid] cmd
            $m configure -postcommand $cmd
        } else {
            regsub -all {%W} $comando $w cmd
            regsub -all {%I} $cmd $idx cmd
            regsub -all {%X} $cmd [ winfo pointerx .gid] cmd
            regsub -all {%Y} $cmd [ winfo pointery .gid] cmd
            $w add command -label $entrada -underline $under -image $img -compound left \
                -command $cmd
        }
        incr idx
    }

}

proc PostGraphModelView { w } {
    set MenuEntriesP(5,10,0) [list [_ "Show#C#menu"] [_ "Size#C#menu"]]
    set MenuCommandsP(5,10,0) [list \
                                   [ list GiD_Process Mescape Results Graphs OptionsGraph ShowModelView Show ] \
                                   [ list GiD_Process Mescape Results Graphs OptionsGraph ShowModelView ModelViewSize ]]

    set lst_img [ list [ IconoModelView] $::GidPriv(VerifNoImage)]

    $w delete 0 end
    set idx 0
    set UnderLineList {}
    foreach entrada $MenuEntriesP(5,10,0) comando $MenuCommandsP(5,10,0) img $lst_img {
        set under [FindUnderChar entrada UnderLineList]
        if { [ info exists MenuEntriesP(5,10,0,$idx)]} {
            set m $w.mm$idx
            if { ![ winfo exists $w.mm$idx]} {
                menu $m
            }
            $w add cascade -label $entrada -underline $under -image $img -compound left \
                -menu $m
            regsub -all {%W} $comando $m cmd
            regsub -all {%I} $cmd $idx cmd
            regsub -all {%X} $cmd [ winfo pointerx .gid] cmd
            regsub -all {%Y} $cmd [ winfo pointery .gid] cmd
            $m configure -postcommand $cmd
        } else {
            regsub -all {%W} $comando $w cmd
            regsub -all {%I} $cmd $idx cmd
            regsub -all {%X} $cmd [ winfo pointerx .gid] cmd
            regsub -all {%Y} $cmd [ winfo pointery .gid] cmd
            $w add command -label $entrada -underline $under -image $img -compound left \
                -command $cmd
        }
        incr idx
    }

}

proc PostGraphXAxis { w } {
    set MenuEntriesP(5,10,15) [list [_ "Reset#C#menu"] [_ "Set min value#C#menu"] [_ "Set max value#C#menu"] [_ "Set divisions#C#menu"] [_ "Set label#C#menu"] [_ "Set Logarithmic Scale#C#menu"]]
    set MenuCommandsP(5,10,15) [list \
                                    [ list GiD_Process Mescape Results Graphs OptionsGraph X_Axis Reset ] \
                                    [ list GiD_Process Mescape Results Graphs OptionsGraph X_Axis SetMin] \
                                    [ list GiD_Process Mescape Results Graphs OptionsGraph X_Axis SetMax] \
                                    [ list GiD_Process Mescape Results Graphs OptionsGraph X_Axis SetDivisions] \
                                    [ list GiD_Process Mescape Results Graphs OptionsGraph X_Axis SetLabel] \
                                    [ list GiD_Process Mescape Results Graphs OptionsGraph X_Axis SetLog]]


    set lst_img [ list $::GidPriv(VerifNoImage) $::GidPriv(VerifNoImage) \
                      $::GidPriv(VerifNoImage) $::GidPriv(VerifNoImage) \
                      $::GidPriv(VerifNoImage) \
                      [ IconoScaleResultLogarithmicGraphX]]

    $w delete 0 end
    set idx 0
    set UnderLineList {}
    foreach entrada $MenuEntriesP(5,10,15) comando $MenuCommandsP(5,10,15) img $lst_img {
        set under [FindUnderChar entrada UnderLineList]
        if { [ info exists MenuEntriesP(5,10,15,$idx)]} {
            set m $w.mm$idx
            if { ![ winfo exists $w.mm$idx]} {
                menu $m
            }
            $w add cascade -label $entrada -underline $under -image $img -compound left \
                -menu $m
            regsub -all {%W} $comando $m cmd
            regsub -all {%I} $cmd $idx cmd
            regsub -all {%X} $cmd [ winfo pointerx .gid] cmd
            regsub -all {%Y} $cmd [ winfo pointery .gid] cmd
            $m configure -postcommand $cmd
        } else {
            regsub -all {%W} $comando $w cmd
            regsub -all {%I} $cmd $idx cmd
            regsub -all {%X} $cmd [ winfo pointerx .gid] cmd
            regsub -all {%Y} $cmd [ winfo pointery .gid] cmd
            $w add command -label $entrada -underline $under -image $img -compound left \
                -command $cmd
        }
        incr idx
    }


}

proc PostGraphYAxis { w } {
    set MenuEntriesP(5,10,16) [list [_ "Reset#C#menu"] [_ "Set min value#C#menu"] [_ "Set max value#C#menu"] [_ "Set divisions#C#menu"] [_ "Set label#C#menu"] [_ "Set Logarithmic Scale#C#menu"]]
    set MenuCommandsP(5,10,16) [list \
                                    [ list GiD_Process Mescape Results Graphs OptionsGraph Y_Axis Reset ] \
                                    [ list GiD_Process Mescape Results Graphs OptionsGraph Y_Axis SetMin] \
                                    [ list GiD_Process Mescape Results Graphs OptionsGraph Y_Axis SetMax] \
                                    [ list GiD_Process Mescape Results Graphs OptionsGraph Y_Axis SetDivisions] \
                                    [ list GiD_Process Mescape Results Graphs OptionsGraph Y_Axis SetLabel] \
                                    [ list GiD_Process Mescape Results Graphs OptionsGraph Y_Axis SetLog]]

    set lst_img [ list $::GidPriv(VerifNoImage) $::GidPriv(VerifNoImage) \
                      $::GidPriv(VerifNoImage) $::GidPriv(VerifNoImage) \
                      $::GidPriv(VerifNoImage) \
                      [ IconoScaleResultLogarithmicGraphY]]

    $w delete 0 end
    set idx 0
    set UnderLineList {}
    foreach entrada $MenuEntriesP(5,10,16) comando $MenuCommandsP(5,10,16) img $lst_img {
        set under [FindUnderChar entrada UnderLineList]
        if { [ info exists MenuEntriesP(5,10,16,$idx)]} {
            set m $w.mm$idx
            if { ![ winfo exists $w.mm$idx]} {
                menu $m
            }
            $w add cascade -label $entrada -underline $under -image $img -compound left \
                -menu $m
            regsub -all {%W} $comando $m cmd
            regsub -all {%I} $cmd $idx cmd
            regsub -all {%X} $cmd [ winfo pointerx .gid] cmd
            regsub -all {%Y} $cmd [ winfo pointery .gid] cmd
            $m configure -postcommand $cmd
        } else {
            regsub -all {%W} $comando $w cmd
            regsub -all {%I} $cmd $idx cmd
            regsub -all {%X} $cmd [ winfo pointerx .gid] cmd
            regsub -all {%Y} $cmd [ winfo pointery .gid] cmd
            $w add command -label $entrada -underline $under -image $img -compound left \
                -command $cmd
        }
        incr idx
    }
}

proc UpdatePostProcessInformation { } {
    # set err 1
    # set err [ 
    #              catch { 
    #                  if { [ esMac]} {
    #                      doUpdateMenusMac
    #                  }
    #              }
    #             ]

    if { [ GidUtils::IsTkDisabled]} {
        return
    }

    FillPDInfo
    FillPRInfo
    FillPGInfo
    PostAnimateInitVariables
    MeshGroupTBLFill
    
    #reset graph window if it's open
    set w .gid.graphs
    if { [winfo exists $w] } {
      destroy $w
      after idle [list PostGraphs::Create $w ]
    }

    # update
    # update idletasks
    # if { $err} {
    #         # como hay un after XXX por ahi para cambiar menus y ventanas de pre a post, 
    #         # toca tambien hacerlo aqui
    #         after 1000 doUpdateMenusMac
    # }
    if { [ esMac]} {
        after 500 doUpdateMenusMac
    }
}


proc IconoScaleResultLogarithmicGraphX { } {
    array set opciones [ GiD_Info postprocess get scale_result_options]

    set img $::GidPriv(VerifNoImage)
    if { $opciones(UseLogScaleGraphX)} {
        set img $::GidPriv(VerifImage)
    }
    return $img
}

proc IconoScaleResultLogarithmicGraphY { } {
    array set opciones [ GiD_Info postprocess get scale_result_options]

    set img $::GidPriv(VerifNoImage)
    if { $opciones(UseLogScaleGraphY)} {
        set img $::GidPriv(VerifImage)
    }
    return $img
}

proc IconoCoordCart { } {
    set opciones [ GiD_Info postprocess get graphs_option CoordType]     
    set img $::GidPriv(VerifNoImage)
    if { $opciones eq "Cartesian"} {
        set img $::GidPriv(VerifImage)
    }
    return $img
}

proc IconoCoordPolar { } {
    set opciones [ GiD_Info postprocess get graphs_option CoordType]      
    set img $::GidPriv(VerifNoImage)
    if { $opciones eq "Polar"} {
        set img $::GidPriv(VerifImage)
    }
    return $img
}

proc IconoModelView { } {
    set opciones [ GiD_Info postprocess get graphs_option ShowModelView]   
    set img $::GidPriv(VerifNoImage)
    if { $opciones eq "Yes"} {
        set img $::GidPriv(VerifImage)
    }
    return $img
}

proc FilesOpenPostAllFormats { filename } { 
    if { ![file exists $filename] } {
        return
    }
    set ext [string tolower [file extension $filename]]
    if { $ext  == ".res" || $ext  == ".msh" || $ext  == ".bin" || $ext  == ".lst"} {
        set is_hdf5_gid_post 0
        if { $ext  == ".res" } {
            if { [catch { package require hdf5 1.5 } msg] } {           
                #package hdf5 not available!!
                WarnWin $msg
            } else {                
                set h hd1
                if { [catch { hdf5 $h $filename } err] } {
                    #doesn't has HDF5 format
                } else {
                    if { [GiDPost::IsGiDPost $h] } {
                        set is_hdf5_gid_post 1                    
                    }
                    $h close
                }
            }
        } 
        if { $is_hdf5_gid_post } {          
            set res [GiDPost::ReadPost $filename]
            lassign $res num_meshes num_results num_graphs
            GidUtils::SetWarnLine [concat [_ "Read %d meshes and %d results %d graphs" $num_meshes $num_results $num_graphs] " (HDF5 format)"]
        } else {
            GiD_Process Mescape Files Read [ GetPostBinaryReadOpts] $filename
        }
    } elseif { $ext == ".h5" } {        
        if { [catch { package require hdf5 1.5 } msg] } {           
            #package hdf5 not available!!
            WarnWin $msg
        } else {
            set num_results 0
            set h hd1
            if { [catch { hdf5 $h $filename } err] } {
                #doesn't has HDF5 format
            } else {           
                if { [GiDPost::IsGiDPost $h] } {
                    $h close
                    set res [GiDPost::ReadPost $filename]
                    lassign $res num_meshes num_results num_graphs
                    GidUtils::SetWarnLine [concat [_ "Read %d meshes and %d results %d graphs" $num_meshes $num_results $num_graphs] " (HDF5 format)"]
                } elseif { [info procs Amelet::IsAmelet] != "" && [Amelet::IsAmelet $h] } {
                    $h close
                    set res [Amelet::ReadPost $filename]
                    lassign $res num_meshes num_results num_graphs
                    GidUtils::SetWarnLine [concat [_ "Read %d meshes and %d results %d graphs" $num_meshes $num_results $num_graphs] " (Amelet format)"]
                } else {
                    $h close
                }           
            }
            if { $num_results > 0 } {
                #set the first analysis and step to use
                set analysis_to_use [lindex [GiD_Info postprocess get all_analysis] 0]
                set step_to_use [lindex [GiD_Info postprocess get all_steps $analysis_to_use] 0]
                GiD_Process Mescape results analysissel $analysis_to_use $step_to_use escape
            } elseif { $num_graphs > 0 } {
                GiD_Graph show
            }
        }
    }   
}

proc FilesOpenPostAllFormatsWin { } {        
    set types [list \
                   [list [_ "GiD postprocess"] ".res .msh .bin .lst"] \
                   [list [_ "All files"] "*"] \
                  ]
    set filename [Browser-ramR postfile read .gid [_ "Postprocess Read"] "" $types "" 0 \
                      [ list {Postprocess read options} CreatePostBinaryReadOpts ProcessPostBinaryReadOpts] ]
    if { $filename != "" } {
        FilesOpenPostAllFormats $filename        
    }
}

proc FilesOpenPostMultipleWin { } {    
    set types [list \
                   [list [_ "GiD postprocess"] ".res .msh .bin .lst"] \
                   [list [_ "All files"] "*"] \
                  ]    
    set filenames [Browser-ramR postfile read .gid [_ "Postprocess read several files"] "" $types "" 1 \
                       [ list {Postprocess read options} CreatePostBinaryReadOpts ProcessPostBinaryReadOpts] ]
    if { $filenames != "" } {
        FilesOpenPostMultiple $filenames         
    }
}

proc FilesOpenPostMultiple { filenames } {
    if { [llength $filenames] == 1 } {
        FilesOpenPostAllFormats [lindex $filenames 0]
    } else {
        GiD_Process Mescape Files ReadMultiple [ GetPostBinaryReadOpts] $filenames        
    }
}

proc ReadView { filename } {
    if { [file exists $filename] } {
        #update
        #update idletasks
        after idle [list GiD_Process 'ReadView $filename]
    }
}

catch {
    GidTkBackCompatibility ;#repeat again, else "tkGenerateMenuSelect" dissapear!!
}
# trace add variable ::GidPriv write WatchBitmaps

proc MeshGenerationOK { w  } {
    set cb $w.frmSize.comboSizes
    if { ![winfo exists $cb] } {
        return
    }
    set size [$cb get]
    destroy $w
    if { $::ChangeVarInfo(LoadMeshingPrefOfModel) } {
        set meshingparam MeshingParametersFrom=Model
    } else {
        set meshingparam MeshingParametersFrom=Preferences
    }
    GiD_Process $size $meshingparam
}

proc MeshGenerationClose { w } {
    GiD_Process escape
    destroy $w
}

proc MeshGenerationWindow { LastGenSize RecommendedSize } {
    
    set w .gid.meshgeneration

    if { $LastGenSize<0.0 } {
        set combovalues [format %g $RecommendedSize]
    } else {
        set combovalues [format "%g %g" $LastGenSize $RecommendedSize]
    }

    InitWindow $w [_ "Mesh generation"] MeshGenerationWindowGeom

    if { ![winfo exists $w] } return ;# windows disabled || usemorewindows == 0
    
    ttk::frame $w.frmSize
    
    ttk::label $w.frmSize.sizeText -text [_ "Enter size of elements to be generated"]     
    ttk::combobox $w.frmSize.comboSizes -values $combovalues
    
    $w.frmSize.comboSizes current 0
    
    GidHelp "$w.frmSize $w.frmSize.sizeText $w.frmSize.comboSizes" \
        [_ "Enter the general size to be assigned to the geometrical\
        \n entities which have no size assigned."]

    ttk::frame $w.frmMeshingParams
    
    set ::ChangeVarInfo(LoadMeshingPrefOfModel) [ GiD_Set LoadMeshingPrefOfModel]
    
    if { ![info exists ::ChangeVarInfo(LoadMeshingPrefOfModel)] } { set ::ChangeVarInfo(LoadMeshingPrefOfModel) 0 }
    ttk::checkbutton $w.frmMeshingParams.mParamFromModel -text [_ "Get meshing parameters from model"] \
        -variable ::ChangeVarInfo(LoadMeshingPrefOfModel)
    GidHelp "$w.frmMeshingParams.mParamFromModel" \
        [_ "Choose the meshing parameters to be used for the mesh generation:\
        \n from the model (you can see them from Utilities->status window),\
        \n or from the meshing preferences (you can see them from Utilities->Preferences->Meshing."]
    
    ttk::frame $w.frmButtons -style BottomFrame.TFrame
    ttk::button $w.frmButtons.btnOK -text [_ "OK"] \
        -command [list MeshGenerationOK $w] \
        -style BottomFrame.TButton   

    ttk::button $w.frmButtons.btnclose -text [_ "Cancel"] \
        -command [list MeshGenerationClose $w] \
        -style BottomFrame.TButton
    #-underline 0 
    
    #SetWidgetsWidthFromText $w.frmButtons.btnOK $w.frmButtons.btnclose
    
    grid $w.frmSize.sizeText -sticky ew
    grid $w.frmSize.comboSizes -sticky w
    
    grid $w.frmMeshingParams.mParamFromModel -sticky sew
    
    grid $w.frmSize -sticky nsew -padx 5
    grid $w.frmMeshingParams -sticky sew -padx 5 -pady 5
    grid columnconfigure $w.frmSize 0 -weight 1
    grid columnconfigure $w.frmMeshingParams 0 -weight 1
    
    grid rowconfigure $w 0 -weight 1
    grid columnconfigure $w 0 -weight 1
    
    grid $w.frmButtons -sticky ews
    if { $::tcl_version >= 8.5 } { grid anchor $w.frmButtons center }
    grid $w.frmButtons.btnOK $w.frmButtons.btnclose -padx 5 -pady 6
    
    $w.frmSize.comboSizes selection range 0 end
    focus $w.frmSize.comboSizes
    
    bind $w <Alt-c> [list $w.frmButtons.btnclose invoke]
    bind $w <Escape> [list $w.frmButtons.btnclose invoke]
    bind $w <Return> [list $w.frmButtons.btnOK invoke]
}

#commands to access to toolbars similar to the GiDMenu:: ones
#proc HideVolumeFromToolbars must use in the future this GiDToolbar:: procedures when available
#but are under construction...
namespace eval GiDToolbar {
}

#now asumed toolbar_name_untranslated the "Geometry & View bar", but in the future can handle more bars
proc GiDToolbar::RemoveOption {toolbar_name_untranslated option_name_untranslated prepost {translationfunc _}} {
    WarnWin "GiDToolbar::RemoveOption Under construction..."
    if {$prepost!="PRE" && $prepost!="POST" && $prepost!="PREPOST"} {
        WarnWin [_ "Wrong arg. Must be PRE, POST or PREPOST."]
        return 1
    }

    if {$prepost eq "PRE"} {
        set where [list "" "PRE"]
    } elseif {$prepost eq "POST"} {
        set where [list "P" "POST"]
    } else {
        set where [list "" "PRE" "P" "POST"]
    }
    foreach {c desc} $where {
        if { $toolbar_name_untranslate == "Geometry & View bar" } {
            upvar \#0 BitMapsNames$c BitMapsNames
            upvar \#0 BitMapsCommands$c BitMapsCommands
            upvar \#0 BitmapsHelp$c BitmapsHelp            
        } else {
            WarnWin [_ "ERROR: Toolbar %s doesn't exist in %s." $toolbar_name_untranslated $desc]
            return 1
        }
        set index [ GiDToolbar::_FindOptionIndex BitMapsNames $option_name_untranslated]
        if { $index == -1 } {
            return 1
        }
        set i [join [lrange [split $index ,] 0 end-1] ,]
        set position [lindex [split $index ,] end]
        
        #must rename index
        #GiDToolbar::del_submenus $i $position $desc
        #GiDToolbar::move_submenus $i $position $desc "up"
        set BitMapsNames($i)  [lreplace $BitMapsNames($i) $position $position ]
        set BitMapsCommands($i) [lreplace $BitMapsCommands($i) $position $position]
        set BitmapsHelp($i) [lreplace $BitmapsHelp($i) $position $position]        
    }
    return 0
}


proc GiDToolbar::_FindOptionIndex { BitMapsNames nameslist} {
    WarnWin "GiDToolbar::_FindOptionIndex Under construction..."
    upvar \#0 $BitMapsNames TranslatedEntries
    
    set index 0
    foreach suboption $nameslist {
        set found 0
        set cont 0
        if { ![info exists TranslatedEntries($index)] } {
            return -1
        }
        if { [string range $suboption 0 2] == "---" } {
            set nseparator [string range $suboption 3 end]
            set suboption "---"
            set iseparator 0
        }
        foreach item $TranslatedEntries($index) {
            if { $item == $suboption } {
                if { $suboption == "---" } {
                    if { $iseparator == $nseparator} {
                        append index ,$cont
                        set found 1
                        break
                    }
                    incr iseparator
                } else {
                    append index ,$cont
                    set found 1
                    break
                }
            }
            incr cont
        }
        if { !$found } {
            return -1
        }
    }
    return $index
}

proc SaveBottomEntryFrameContents {} {
    set bottom_entry_list .gid.comm.fwarn.list
    if { [ winfo exists $bottom_entry_list] } {
        set ::GidPriv(FullScreen,ListboxContents) [ $bottom_entry_list get 0 end]
    }
}

proc RestoreBottomEntryFrameContents {} {
    set bottom_entry_list .gid.comm.fwarn.list

    if { [ info exists ::GidPriv(FullScreen,ListboxContents)] && 
         [ winfo exists $bottom_entry_list]} {
        foreach line $::GidPriv(FullScreen,ListboxContents) {
            $bottom_entry_list insert end $line
        }
        $bottom_entry_list see end
        set ::uparrow [ $bottom_entry_list size]
    }
}

proc ShowFullScreenMenu { x y} {
    if { ( $x < 16) && ( $y < 16)} {
        GiDShowContextualMenu $x $y        
    } else {
        if { $::FullScreen(Old,MainWindowMotion) != ""} {
            regsub -all {%x} $::FullScreen(Old,MainWindowMotion) $x script
            regsub -all {%y} $scripts $y scripts
            eval $scripts
        }
    }
}

proc SwitchFullScreen { { right_button_menu_label ""}} {
    global ToolbarsPriv

    if { ![ info exists ::GidPriv(FullScreen)]} {
        set ::GidPriv(FullScreen) 0
    }
 
    if { ![info exists ToolbarsPriv(toolbars)] } {
        TOInitializeToolbars
    }
   
    update    

    # save contents of bottom entry:
    SaveBottomEntryFrameContents

    if { !$::GidPriv(FullScreen)} {
        set ::FullScreen(Old,MainWindow) [ wm state .gid]
        set ::FullScreen(Old,MainWindowGeom) [ wm geometry .gid]
        set ::FullScreen(Old,MainWindowMotion) [ bind .gid <Motion>]
        set ::FullScreen(Old,MainWindowF11) [bind .gid <F11>] ;#e.g. contain .gid.menu.button1.m.m invoke 23 ; break
        # if { $::tcl_platform(os) != Linux} {
        #     wm state .gid zoomed
        #     wm overrideredirect .gid 1
        # } else {
        # }
        foreach tb $ToolbarsPriv(toolbars) {
            set geom_name [ lindex $tb 1]
            if { [info exists ::GidPriv($geom_name)] } {
                set ::FullScreen(Old,$geom_name) $::GidPriv($geom_name)
                # WarnWinText "eval [ lindex $tb 2] NONE"
            } else {                
                set ::FullScreen(Old,$geom_name) ""
            }
            eval [ lindex $tb 2] NONE
        }
        wm attributes .gid -fullscreen 1
        # if { "$right_button_menu_label" != ""} {
        #     $right_button_menu_label configure -label [_ "Normal mode"]
        # }

        bind .gid <Motion> "ShowFullScreenMenu %x %y"

        set ::GidPriv(FullScreen) 1                
    } else {
        set new_st normal
        if { [ info exists ::FullScreen(Old,MainWindow)]} {
            set new_st $::FullScreen(Old,MainWindow)
        }
        # wm overrideredirect .gid 0 
        # wm state .gid $new_st

        foreach tb $ToolbarsPriv(toolbars) {
            set geom_name [ lindex $tb 1]
            # set ::GidPriv($geom_name) $::FullScreen(Old,$geom_name) 
            # eval [ lindex $tb 2] \
                #         [ lindex $::GidPriv($geom_name) 0]
            #if { [ info exists ::FullScreen(Old,$geom_name)] } {
            eval [ lindex $tb 2] \
                [ lindex $::FullScreen(Old,$geom_name) 0]
            #}
        }
        # if { [ info exists ::FullScreen(Old,MainWindowGeom)] } {
        #     update idletasks
        #     wm geometry .gid $::FullScreen(Old,MainWindowGeom)
        # }
        wm attributes .gid -fullscreen 0

        # if { "$right_button_menu_label" != ""} {
        #     $right_button_menu_label configure -label [_ "Full screen"]
        # }
        bind .gid <Motion> $::FullScreen(Old,MainWindowMotion)
        bind .gid <F11> SwitchFullScreen ;#to avoid error calling .gid.menu.button1.m.m that doesn't exists, invoke directly its procedure!!
        set ::GidPriv(FullScreen) 0
    }
    
    #UpdateMouseMenu ;#to remove 'Quit' in fullscreen
    
    update   

    # save contents of bottom entry:
    RestoreBottomEntryFrameContents
}

proc SwitchFastDraw { w } {
    set act_mode [ string tolower [ GiD_Set FastRotation(Mode)]]
    set next_mode "Fast"
    set next_icon "fastmode_off.png"
    if { $act_mode == "fast"} {
        set next_mode "Normal"
        set next_icon "fastmode_on.png"
    } else { # act_mode == "normal"
    }

    GiD_Set FastRotation(Mode) $next_mode
    if { $w != ""} {
        $w configure -image [ gid_themes::GetImage $next_icon toolbar]
    }
    GiD_Process 'Redraw
}

#translation of results is ambiguous, becase we don't know if the original name (with associated translation)
#has spaces or underlines, because both are converted to underlines for internal command use!! 
#if one does nothing try the other option
proc TranslateResultName { txt_in } {   
    set txt_out [TranslateResultName_OriginalWithSpaces $txt_in]
    if { $txt_in == $txt_out } {
        set txt_out [TranslateResultName_OriginalWithUnderlines $txt_in]
    }
    return $txt_out
}

#first replace underlines to recover the original and then translate
proc TranslateResultName_OriginalWithSpaces { txt_in } {   
    regsub -all {_} $txt_in { } txt_out
    return [= $txt_out]
}

#first translate and then replace underlines to be shown as spaces
proc TranslateResultName_OriginalWithUnderlines { txt_in } {      
    regsub -all {_} [= $txt_in] { } txt_out  
    return $txt_out
}

proc RaiseEvent_GenericProc { event args } {
    set result ""
    if { [info procs $event] != "" } {
        if { [catch { set result [$event {*}$args] } msg] } {
            if { ![GidUtils::IsTkDisabled] } {
                after idle [list WarnWinText $msg]
            }
        }
    } else {
        catch { set result [$event {*}$args] } msg
    }
    return $result
}

#like RaiseEvent_GenericProc but evaluate a procedure that is not considered as event
#it also could evaluate procedures hidden to info procs
proc Eval_GenericProc { procedure args } {
    set result ""
    if { [info procs $procedure] != "" } {
        if { [catch { set result [$procedure {*}$args] } msg] } {
            if { ![GidUtils::IsTkDisabled] } {
                after idle [list WarnWinText $msg]
            }
        }
    } else {
        catch { set result [$procedure {*}$args] } msg
    }
    return $result
}

#to enable/disable groups: in C must #define GID_GROUPS, then ::GID_GROUPS is set to 1
if { [info exists ::GID_GROUPS] } {
    proc InitGroups  { } {
        package require gid_groups_conds

        gid_groups_conds::init_package
        
        if { ![GidUtils::IsTkDisabled] } {
            AddGroupsToMenu
            GiDMenu::UpdateMenus
            GiD_RegisterPluginAddedMenuProc AddGroupsToMenu ;#to repeat when re-creating menus
        }
    }
        
    proc AddGroupsToMenu { } {
        set position [GiDMenu::GetOptionIndex Utilities [list "Layers"] PRE]
        if { $position == -1 } {
            set position end
        }      
        GiDMenu::InsertOption Utilities [list [_ "Groups"]...] $position PRE "gid_groups_conds::open_groups .gid window" "" "" insertafter _
        #remove from Data menu
        GidChangeDataLabel "Local axes" ""
        
        if { $position != "end" } {
            incr position
        }        
        #GiDMenu::InsertOption Utilities [list [_ "Local axes"]...] $position PRE "gid_groups_conds::local_axes_window" "" "" insertafter _
        GiDMenu::InsertOption Utilities [list [_ "Local axes"]] $position PRE [list -np- gid_groups_conds::local_axes_menu %W] "" "" insertafter _
    }
}

#this function is really now only used invoked from C for the gid logo variable...
namespace eval GidPrivVariables {
    variable names {GidPriv(LogosGiDBitmapName) GidPriv(LogosGiDBitmapName32)}   
}

proc GidPrivVariables::Get { name } {  
    global GidPriv
    variable names
    if { [lsearch $names $name] == -1 } {
        error [_ "variable '%s' not found" $name]
    } else {
        if { $name == "GidPriv(LogosGiDBitmapName)" || $name == "GidPriv(LogosGiDBitmapName32)"} {
            set value [set $name]
            if { [file pathtype $value] == "relative" } {
                set value [file join $::GIDDEFAULT resources textures $value]
            }
        } else {
            set value [set $name]
        }
    }
    return $value
}

proc GidPrivVariables::Set  { name value } {
    global GidPriv
    variable names
    if { [lsearch $names $name] == -1 } {
        error [_ "variable '%s' not found" $name]
    } else {        
        if { $name == "GidPriv(LogosGiDBitmapName)" || $name == "GidPriv(LogosGiDBitmapName32)" } {
            if { [file pathtype $value] == "relative" } {
                set full_filename [file join $::GIDDEFAULT resources textures $value]
            } else {
                set full_filename $value
            }
            if { [file exists $full_filename] } {
                set $name $value
            } else {
                error [_ "File '%s' not found" $full_filename]
            }
        } else {
            set $name $value
        }
    }
}
